/**
 * L011_0804_0301
 * MainPanel
 *
 * URLDecoder class action check (normal route)
 *
 */
import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;


/**
 * URLDecoder class action check main class
 * @extends IApplication
 */
public class L011_0804_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * URLDecoder class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
    	"1",
    };

    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("ִ");
    Label   inLabel          = new Label("ʽ");
    Label   outLabel         = new Label("");
    Label   okLabel          = new Label("");
    TextBox inBox            = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    TextBox outBox           = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    TextBox okBox            = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);

    char[] emoji = {0xE63E, 0xE63F, 0xE640, 0xE641};

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "");
            errDialog.setText(e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    void showMainPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1, "˳");

        /* adding each component on the display */
        add(menuList);
        add(inLabel);
        add(inBox);
        add(execButton);
        add(outLabel);
        add(outBox);
        add(okLabel);
        add(okBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* The conversed character sequence display of an initial menu */
        inBox.setText("%E7%BD%91%E8%AF%B7");
        okBox.setText("");
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* original character sequence display */
            showIn();
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "");
        d.setText(aText);
        d.show();
    }



    /**
      * display original character of choiced variation
      */
    public void showIn() {
        outBox.setText("");
        switch( menuList.getSelectedIndex() ) {
           
        	case 0:            
 
        	inBox.setText("%E7%BD%91%E8%AF%B7");
        	okBox.setText("");
        	break;
        
        }
    }

    /**
     * test the choiced decode
     */
    public void test() {
        showIn();
        outBox.setText("");
        switch( menuList.getSelectedIndex() ) {
            case 0:            
                /* with no break */
                outBox.setText(URLDecoder.decode(inBox.getText()));
            
        }
    }
}
