/**
 * L011_4001_0101.java
 * 
 * L011_4001_0101
 * MainPanel
 * 
 * Panel class action check( normal route)
 * 
 */

import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Panel class action check main class
 * @extends IApplication
 */
public class L011_4001_0101 extends IApplication {
    /**
     * I-appli starting method
     */
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * Panell class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"~");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "T");

    /* execution button */
    Button execButton = null;
    /* create processing selection menu */
    ListBox mainMenu = new ListBox(ListBox.CHOICE,1);
    /* processing selection menu item */
    String[] mainItem = {
        "1",
    };

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {

        try {
            showMainPanel();
        } catch(Exception e) {
            err.setText(e.toString());
        } catch(Error e) {
            err.setText(e.toString());
        }

    }

    /**
     * displaying Panel class action check main screen 
     */
    public void showMainPanel() {

        /* title displaying */
        setTitle("L011");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"}");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* main menu setting */
        mainMenu.setItems(mainItem);

        /* execution button setting */
        execButton = new Button("");

        /* add the component to the screen */
        add(mainMenu);
        add(execButton);

    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * softKeyReleased
     * terminate the application when the softkey1 is released
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* going to the screen or displaying when the execution button is pushed */
        if ( aComponent == execButton
             && aType == BUTTON_PRESSED ) {
            switch (mainMenu.getSelectedIndex()) {
            
            /* method action */
            case 0:
                Display.setCurrent(new L011_4005_02((Frame) this));
                break;
           
            }
        }
    }
}




/**
 * method action check menu screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class L011_4005_02 extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"~");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "T");
    
    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButtonL011_4005_02 = null;

    /* create processing selection menu */
    ListBox menuL011_4005_02 = new ListBox(ListBox.CHOICE,9);

    /* processing selection menu item setting */
    String[] itemL011_4005_02 = {
        "1",
    };

    /**
     * L011_4005_02 class constructor
     * @param aFrame the screen
     */
    L011_4005_02(Frame aFrame) {
        try {
            /* put the previous screen in */
            previousFrame = aFrame;
            showPanelL011_4005_02();
        } catch(Exception e) {
            info.setText(e.toString());
            info.show();
        } catch(Error e) {
            Dialog err = new Dialog(Dialog.DIALOG_ERROR,"~");
            info.setText(e.toString());
            info.show();
        }
    }

    /**
     * method action check menu screen displaying
     */
    void showPanelL011_4005_02() {

        /* title displaying */
        setTitle("L011");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"}");
        setSoftLabel(Frame.SOFT_KEY_2,"^");

        /* main menu setting */
        menuL011_4005_02.setItems(itemL011_4005_02);

        /* execution button setting */
        execButtonL011_4005_02 = new Button("");

        /* add the component to the screen */
        add(menuL011_4005_02);
        add(execButtonL011_4005_02);

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* shift to the screen concerning the menu when the execution button is pressed */
        if ( aComponent == execButtonL011_4005_02
             && aType == ComponentListener.BUTTON_PRESSED ) {
            Display.setCurrent(new testL011_4005_02(menuL011_4005_02.getSelectedIndex(), this));
        }
    }
}

/**
 * method action check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class testL011_4005_02 extends Panel implements SoftKeyListener,ComponentListener,KeyListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"~");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "T");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButton = null;

    /* SoftKeyListener test button */
    Button keyListenerPrev = new Button("^");
    Button keyListenerEnd = new Button("}");

    /* setTitle checking button */
    Button titleButton1;

    /* testing result display textbox */
    TextBox resultTextBox = new TextBox("", getWidth(), 3, TextBox.DISPLAY_ANY);

    /**
     * method action checking
     * @param aType the position of menu item
     * @param aFram previous screen
     */
    public testL011_4005_02(int aType, Frame aFrame) {

        /* put the previous screen in */
        previousFrame = aFrame;

        /* title displaying */
        setTitle("L011");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"}");
        setSoftLabel(Frame.SOFT_KEY_2,"^");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* action checking for checking items on the previous screen */
        try {
            switch (aType) {
            /* componentlistener plural setting check */
            case 0:

        // L011_4005_0302
                setBackground(Graphics.getColorOfName(Graphics.BLUE));

                titleButton1 = new Button("");

                add(titleButton1);

                setComponentListener(new ComponentListener() {
                    public void componentAction(Component aComponent, int aType, int aParam) {
                        if ( aType == ComponentListener.BUTTON_PRESSED ) {
                            if ( aComponent == titleButton1 ) {
                                setTitle("W");
                            }
                        }
                    }
                });

            }
        } catch (Exception e) {
            err.setText(e.toString());
            err.show();
            return;
        } catch (Error e) {
            err.setText(e.toString());
            err.show();
            return;
        }
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* setting of the return button and finish button(the alternative to the usual softkey action) */
        if ( aComponent == keyListenerPrev 
             && aType == ComponentListener.BUTTON_PRESSED) {
            Display.setCurrent(previousFrame);
        }
        if ( aComponent == keyListenerEnd 
             && aType == ComponentListener.BUTTON_PRESSED) {
            IApplication.getCurrentApp().terminate();
        }

    }

    public void keyPressed(Panel p, int key) {}

    /* when the key is released, the key is displayed */
    public void keyReleased(Panel p, int key) {
    }

}

/**
 * user definition layout manager
 * @implements  LayoutManager
 */
class myLayout implements LayoutManager {}

/**
 * user definition focus manager
 * @implements FocusManager
 */
class myFocus implements FocusManager {}

