/**
 * L011_1603_0301
 *
 *
 * Dialog class action check (normal route)
 */
import com.nttdocomo.ui.*;

/**
 * Dialog class action check main class
 * @extends IApplication
 */
public  class L011_1603_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Dialog class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 *
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button button    = new Button("Machen");
    String[] menuListItem = {
        "Test1",
    };

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1,"Ende");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent,int aType,int aParam){

        /* when  the exsecution button is pushed */
        if(aComponent == button){
            switch(menuList.getSelectedIndex()){
               case 0:
                   try{
                       Dialog dialog = new Dialog(Dialog.DIALOG_INFO,"");
                       dialog.show();
                   }
                   catch(Exception aException){
                   Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"");
                     errDialog.setText("Dialog nicht erstellbar");
                        errDialog.show();
                 }
           
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey){}

    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey){
        if(aSoftKey == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }
}

