/**
 * L011_5402_0101
 *
 * TextBox class behavior checking (this is added)
 * check method's behavior
 *
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * TextBox class method behavior checking main class
 * @extends IApplication
 */
public class L011_5402_0101 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class method behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    Button  execButton = new Button("Machen");

	//	creating TextBox class
    TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
    TextBox textBox2 = new TextBox("",20,1,TextBox.DISPLAY_ANY);

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1, "Ende");

        /* adding each component on the display */
	add(textBox1);
	add(textBox2);
        add(execButton);

		//	make the input of user invalid
		textBox2.setEditable(false);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * process when the action other than softkey happens
     * @param source the component on which the event occurs
     * @param type event type
     * @param param event parameter
     */
    public void componentAction(Component source, int type, int param) {
        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {
			//	storage for the inputted character
			String	inputString = "";
	//L011_5402_0101
			//	check the default input mode
			inputString = textBox1.getText();
			textBox2.setText("");
			if( inputString == "" ){
			}
			else{
				textBox2.setText(inputString);
			}
        }
    }
}
