/**
 * L212_0301_0101.java
 * 
 * L212_0301_0101
 * MenuPanel
 * 
 * Class operation check
 * 
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * UIboundary operations Canvas main class
 * @extends IApplication
 */
public class L212_0301_0101 extends IApplication {
    /**
     *Startup method of i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * UIboundary operationsCanvas Check the main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    Label            subTitle      = null;  /* sub title */
    Button           execButton    = null;  /* execute button */

    /**
     * Constructor of MainPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     *  Display a main panel
     */
    public void showMainPanel() {
        setTitle("L212");

        /* Add each component to screen */
        execButton     = new Button("Machen");
        add(execButton);

        /* Settings of softLabel */
        setSoftLabel(Frame.SOFT_KEY_1,"Ende");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * A message dialog is displayed.
     * @param  aMsg  Dialog messege
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * When soft key is pressed, it does not operate
     * @param aSoftKey  Type of softkey
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is exit
     * @param aSoftKey  Type of softkey
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Type of events
     * @param aParam      Parameter of events
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        if (aAction == ComponentListener.BUTTON_PRESSED) {
           
            Display.setCurrent(new TestCanvas(this));
        }
    }
}

/**
 * UIboundary operationsCanvas 
 Check behavior of the Screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestCanvas extends Canvas {
    Frame    previousFrame  = null;  /* Storage  the previous screen */
    Graphics g1;
    Graphics g2;

    /**
     * TestCanvas Constructer of class
     * @param  aFrame      previous screen
     */
    TestCanvas(Frame aFrame) {
        previousFrame = aFrame;

        /* setting of soft key Label */
        setSoftLabel(Canvas.SOFT_KEY_1,"");
        setSoftLabel(Canvas.SOFT_KEY_2,"A");
    }

    /**
     * Called when low-level event is notified
     * @param  aType  Event type
     * @param  aPram  Event parameter
     */
    public void processEvent(int aType,int aParam){
        if(aType == Display.KEY_RELEASED_EVENT){
            switch(aParam){
                case Display.KEY_SOFT1:
                    IApplication.getCurrentApp().terminate();
                    break;
                case Display.KEY_SOFT2:
                    Display.setCurrent(previousFrame);
                    break;
            }
        }

    }

    /**
     * Display in canvas
     * Graphics object used for drawing
     */
    public void paint(Graphics g){
        g1  = getGraphics();
        g1.drawString("Softkey2 Taste",10,40);
    }

}
