/**
 * L011_0904_0301
 * MainPanel
 * MethodConfirm
 *
 * URLEncoder class action check (normal route)
 *
 */
import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;


/**
 * URLEncoder class action check main class
 * @extends IApplication
 */
public class L011_0904_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * URLEncoder class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "Prueba1"
    };

    Frame   subFrame;
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("Ejecutar");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText(e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    void showMainPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1, "Exit");

        /* adding each component on the display */
        add(menuList);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of softkey pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex the value of softkey released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            try {
                /* set the method action check screen to frame */
                subFrame = new MethodConfirm(this, menuList.getSelectedIndex());
            } catch (Exception e) {
                throw new RuntimeException("No se encuentra Class");
            }

            /* set display current which is set up */
            Display.setCurrent(subFrame);
        }
    }
}


/**
 * method action check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MethodConfirm
    extends Panel implements SoftKeyListener, ComponentListener {

    char[] emoji = {0xE63E, 0xE63F, 0xE640, 0xE641};

    Frame   prevFrame;
    int     testType;
    TextBox targetText  = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    Button  execButton  = new Button("Ejecutar");
    Label   resultLabel = new Label("Resultdo");
    TextBox resultText  = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    Label   normalLabel = new Label("Comparar");
    TextBox normalText  = new TextBox("%C2%A1%C3%91%C3%B1%C2%BF", 20, 1, TextBox.DISPLAY_ANY);

    /**
     * method action check screen class constructer
     * @param aPrev previous display frame 
     * @param aTestType Test type
     */
    public MethodConfirm(Frame aPrev, int aTestType) {

        /* setting the parameter field variable */
        prevFrame = aPrev;
        testType  = aTestType;

        try {
            /* displaying method action check screen */
            showSubPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText(e.toString());
            errDialog.show();
        }
    }

    /**
     * display method action check screen
     */
    void showSubPanel() {

        /* setting of the display item */
        setSoftLabel(Frame.SOFT_KEY_1, "Exit");
        setSoftLabel(Frame.SOFT_KEY_2, "Back");

        switch (testType) {

        case 0:
            targetText.setText("");
           normalText.setText("%C2%A1%C3%91%C3%B1%C2%BF");
           break;

       
        }

        /* A width setup of an Encode result label (prepare for button arrangement which result in non-started  new line) */
        resultLabel.setSize(this.getWidth(), resultLabel.getHeight());

        /* adding each component on the display */
        add(targetText);
        add(execButton);
        add(resultLabel);
        add(resultText);
        add(normalLabel);
        add(normalText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of softkey pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * define the action when softkey is released
     * @param anIndex the value of softkey released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* when softkey2 is released, go to the previous screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(prevFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            /* Result of constant definition checking reflects textbox of result */
            try {
            if (testType == 2) {
                    resultText.setText(URLEncoder.encode(null));
              }
                	else {
                   resultText.setText(URLEncoder.encode(targetText.getText()));
             }
          } catch 
            	(NullPointerException npe) {
               Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
                errorDialog.setText(npe.getMessage());
                errorDialog.show();
           }
        }
    }
}
