/**
 * L011_1203_0301
 * 
 * 
 *
 * Button class action check(normal route)
 *
 */
import com.nttdocomo.ui.*;

/**
 * Button class action check main class
 * @extends IApplication
 */
public class L011_1203_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    Button  button = new Button("Ejecutar");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    String[] menuListItem = {
    	"Prueba1",
    };

    /**
     * Constructor of MainPanel class
     */
    MainPanel(){
        /* setting of the display item */
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1, "Exit");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aComponent == button) {
            switch(menuList.getSelectedIndex()){
               
                case 0:
                   
                   Display.setCurrent(new NextPanel1((Frame) this));
                  break;
                
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * button creation check class1
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel;

    /**
     * constructer of NextPanel1 class
     * @param aFrame the object of MainPanel
     */
    NextPanel1(Frame aFrame){

    	
    	
    	
        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1,"Back");

       testButton1 = new Button("");

       testButton2 = new Button("");

        /* adding each component on the display */
        add(testButton1);
        add(testButton2);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

