/**
 * L011_3101_0101.java
 * 
 * L011_3101_0101
 * MainPanel
 * LitBox class action check (normal route)
 * 
*/

import com.nttdocomo.ui.*;
/**
 * LitBox class action check main class
 * @extends IApplication
 */
public class L011_3101_0101 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"Error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "Info.");

    /**
     * LitBox class action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener{

        /* execution button */
        Button execButton = null;
        /* create processing selection menu */
        ListBox mainMenu = new ListBox(ListBox.CHOICE,1);
        /* processing selection menu item */
        String[] mainItem = {
            "Prueba1",
        };

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText(e.toString());
            } catch(Error e) {
                err.setText(e.toString());
            }

        }

        /**
         * display LitBox class action check main screen
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("L011");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("Ejecutar");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * softKeyReleased
         * terminate the application when the softkey1 is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* going to the screen or displaying when the execution button is pushed */
            if (aComponent == execButton && aType == BUTTON_PRESSED) {

                switch (mainMenu.getSelectedIndex()) {
                /* access level checking */
                case 0:
            
                    Display.setCurrent(new L011_3005_02((Frame) this));
                    break;
          
                }
            }
        }
    }


    /**
     * L011_3005_02
     * constructor action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class L011_3005_02 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonL011_3005_02 = null;

        /* create processing selection menu */
        ListBox menuL011_3005_02 = new ListBox(ListBox.CHOICE,3);

        /* processing selection menu item setting */
        String[] itemL011_3005_02 = {
           "Item1",
        };

        /**
         * L011_3005_02 class constructor
         * @param aFrame the screen
         */
        L011_3005_02(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelL011_3005_02();
            } catch(Exception e) {
                info.setText(e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"Error");
                info.setText(e.toString());
                info.show();
            }
        }

        /**
         * display constructor action check manu screen
         */
        void showPanelL011_3005_02() {

            /* title displaying */
            setTitle("L011");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");
            setSoftLabel(Frame.SOFT_KEY_2,"Back");

            /* main menu setting */
            menuL011_3005_02.setItems(itemL011_3005_02);

            /* execution button setting */
            execButtonL011_3005_02 = new Button("Ejecutar");

            /* add the component to the screen */
            add(menuL011_3005_02);
            add(execButtonL011_3005_02);

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* shift to the screen concerning the menu when the execution button is pressed */
            if ( aComponent == execButtonL011_3005_02
                && aType == BUTTON_PRESSED ) {
                    Display.setCurrent(new L011_3005_0201(menuL011_3005_02.getSelectedIndex(), this));
            }
        }
    }


    /**
     * method action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class L011_3005_0201 extends Panel implements SoftKeyListener,ComponentListener {


        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* create message dialog(error/guide) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"Error");

        /* execution button */
        Button execButton = new Button("Ejecutar");


      
     
        /**
         * method action checking screen
         * @param  aType processing selection menu index
         * @param  aFrame the screen before shifting
         */
        public L011_3005_0201(int aType, Frame aFrame) {

          

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("L011");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");
            setSoftLabel(Frame.SOFT_KEY_2,"Back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* check method's behavior */
            switch (aType) {
                /* action check1 */
                case 0:
              

                /* checking the variation */
                ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,3);
                testListBox.append("");
              
                add(testListBox);
            }
        }
    
        public void softKeyPressed(int aSoftKey) {}

    
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

 
        public void componentAction(Component aComponent, int aType, int aPram) {

        }
    }
}
