/**
 * L011_4503_0201
 * MainPanel
 *
 * Ticker class constructor checking (normal route)
 *
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Ticker class constructor checking main class
 * @extends IApplication
 */
public class L011_4503_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Ticker class access level checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
           "Prueba1"
    };
    String[][]  subItems = {
       
        {
         "Item1"
        }
    };

    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("Ejecutar");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1, "Exit");

        /* adding each component on the display */
        add(menuList);
        add(menuList2);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            /* behavior checking sub screen display */
            Display.setCurrent(new SubPanel(this, menuList.getSelectedIndex(),
                                            menuList2.getSelectedIndex()));
        }
    }
}


/**
 * Ticker class constructor behavior checking sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class SubPanel extends Panel implements SoftKeyListener{
    Frame   previous;
    Ticker  ticker;
    int     type;
    int     index;
    char[]  emoji = {0xE63E, 0xE63F, 0xE640, 0xE641};
    char[]  emoji2= {0xE63E, 0xE63F};

   /**
     * SubPanel class constructor
     * @param   anIndex index of the testing item
     */
    public SubPanel(Frame aPrevious, int anType, int anIndex) {
        previous = aPrevious;
        type = anType;
        index = anIndex;

        /* setting of the display item */
        setSoftLabel(Frame.SOFT_KEY_2, "Back");

        /* setting the listener */
        setSoftKeyListener(this);

        /* test: creating each Ticker */
            /* check the variation */
            test2();
    }

    /**
     * check the variation
     */
    public void test2() {
        /* execute each testing */
        switch( index ) {
            case 0:
              
                // L011_4504_0302
                ticker = new Ticker("");
               break;
           
        }
        if( index >= 0 && index <= 1 ) {
            add(ticker);
        }
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * return to the main screen when the softkey2 is released
     */
    public void softKeyReleased(int anIndex) {
        /* return to the main screen when the softkey2 is released */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previous);
        }
    }
}
