/**
 * L211_0401_0101.java
 * 
 * L211_0401_0101
 * MenuPanel
 * TestPanel
 * 
 * Class operational test(Canvas)
 * 
 */

import com.nttdocomo.ui.*;

/**
 * Main class for class's operational (Canvas) test
 * @extends IApplication
 */
public class L211_0401_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Screen for checking class's operational(Canvas) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;
    ListBox menu2 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
      
        "Test1",
       
    };

    String[][] menu2Item = {
       
        /* Menu for behavior of screen-display, */
        {
            "Item1"
        },
        
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("L211");

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 3);
        menu2 = new ListBox(ListBox.CHOICE, 11);
        execButton = new Button("Excuter");
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        add(menu1);
        add(menu2);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"Quit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* Set an item (menu2) when menu list (menu1) is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
            }
        }
        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();

                /* Transit to Panel for checking behavior */
                Display.setCurrent(new TestPanel(menu1Index, menu2Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}


/**
 * Screen for checking class's operational (Canvas) test,
 * @extends Canvas
 */
class TestPanel extends Canvas {
    Frame previousFrame;         /* Store the previous screen */
    int Index1;
    int Index2;                 /* Index of the menu of previous screen */
    int flag = 0;
    int state;
    Graphics g1;
    Graphics g2;

    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    public TestPanel(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        Index1 = menu1Index;
        Index2 = menu2Index;

            setSoftLabel(Canvas.SOFT_KEY_1,"");
    }

    public void processEvent(int type,int param){
        /* Key event, */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* Process of when Return key is pressed, */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previousFrame);
                    break;
            }
        }
    }

    /**
     * Implement of paint() method,
     */
    public void paint(Graphics g){

        switch ( Index1 ) {
        	//L211_0402_0402
            /* Operations of screen display */
            case 0:
                switch ( Index2 ) {
                    case 0:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        if (flag == 0) {
                            g.drawString("Appuyer SoftKey1",20,40);
                            g.drawString("",30,60);
                        } else if (flag == 1) {
                            g.drawString("Echou",20,40);
                        } else if (flag == 2) {
                            g.drawString("OK",20,40);
                        }
                        break;

              
                }
                break;
            default:
                break;
        }
    }
}
