/**
 *L011_5402_0102
 *Main Panel
 *
 * TextBox class access level checking (normal route)
 *
 *$ID:$
 */
 
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * TextBox class access level checking main class
 *@IApplication
 */
public class L011_5402_0102 extends IApplication{
	public void start(){
		Display.setCurrent(new MainPanel());
	}
}

/**
 * TextBox class access level checking main screen
 *@extends Panel
 *@implements SoftKeyListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
	String[] menuListItem = {
		"Test1",
		"Test2",
	};
	
	ListBox menuList = new ListBox(ListBox.CHOICE);
	TextBox resultText = new TextBox("",20,3,TextBox.DISPLAY_ANY);
	Button Button1 = new Button("Esegui");
	
	/*
	* Constructor of MainPanel class
	*/
	public MainPanel(){
		try{
			/* Show MainPanel */
			showMainPanel();
		}catch(Exception e){
			Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Errore");
		}
	}
	
	/**
	* Show Screen
	*/
	void showMainPanel(){
	
		/* setting of the display item */
		menuList.setItems(menuListItem);
		setTitle("L011");
		setSoftLabel(Frame.SOFT_KEY_1,"Esci");
		
		/* adding each component on the display */
		add(menuList);
		add(Button1);
		add(resultText);
		
		/* setting the listener */
		setSoftKeyListener(this);
		setComponentListener(this);
		
	}
	
	/**
	* do nothing when a softkey is pushed
	*/
	public void softKeyPressed(int anIndex){}
	
	/*
	*define the action when softkey is released
	*/
	public void softKeyReleased(int anIndex){
		/* terminate the application when softkey1 is released */
		if(anIndex == Frame.SOFT_KEY_1){
			IApplication.getCurrentApp().terminate();
		}
	}
	
	/**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
	*/
	public void componentAction(Component aComponent,int aType,int aParam){
		/*processing when the list choice is changed*/
		if(aComponent == menuList && aType == ComponentListener.SELECTION_CHANGED){
			resultText.setText("");
		}
		
		/*processing when the excecute button is pushed*/
		if(aComponent == Button1 && aType == ComponentListener.BUTTON_PRESSED){
			/*Result of constant definition checking reflects textbox of result*/
			resultText.setText(result(menuList.getSelectedIndex()));
		}
	}
	
	String result(int anIndex){
		String resultStr = "";
		
		/**get the event on a component
		*@param anIndex the index number which selected in listbox
		*@return
		*/
		switch(anIndex){
			
			//L011_5402_0102
			case 0:
				try{
					resultText.setInputMode(TextBox.TRADITIONAL_HANZI);
					resultStr = "OK";
				} catch (Exception e) {
					resultStr = e.toString();
				}
				break;
			
			//L011_5402_0103
			case 1:
				try{
					resultText.setInputMode(TextBox.SIMPLIFIED_HANZI);
					resultStr = "OK";
				} catch (Exception e) {
					resultStr = e.toString();
				}
				break;
			
			default:
				break;
		}
		
		return resultStr;
	}
}
