/*
 * L021_0101_0101
 * 
 * ADF test 
 * Confirmation of download operations
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * ADF test
 * 
 * @extends IApplication
 */
public class L021_0101_0101 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Main screen of download operation confirmation
     * @extends Panel
     * @implements SoftKeyListener
     */
    class MainPanel extends Panel implements SoftKeyListener
    {

        Label aLabel;
        Label bLabel;

        /**
         * Constructors of the MainPanel class
         */
        MainPanel(){

            /* Settings of display items */
            aLabel = new Label("OK");

            /* Add each component to screen */
            add(aLabel);

            /* Listener setting */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "Esci");

        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex/ index of soft key
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * When soft key is released, operate nothing
         * @param anIndex/ index of soft key
         */
        public void softKeyReleased(int anIndex) {}

    }
}
