/**
 * L211_3501_0105
 * MainPanel
 *
 * Check behavior of the class(Class operations)
 *
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;

/**
 * Main class for checking behavior of the URLEncoder class and the class
 * @extends IApplication
 */

public class L211_3501_0105 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the URLEncoder class and the class
 * @extends Panel
 * @implements SoftKeyListener
 */
class MainPanel extends Panel implements SoftKeyListener {

    private Label label2 = new Label("Formato");
    private Label label3 = new Label("Risult");
    private TextBox textBox1 = new TextBox("àèìò", 20, 1, TextBox.DISPLAY_ANY);
    private TextBox textBox2 = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    private TextBox textBox3 = new TextBox("%C3%A0%C3%A8%C3%AC%C3%B2", 20, 1, TextBox.DISPLAY_ANY);


   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Errore");
            errDialog.setText(e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    void showMainPanel() {

        /* Settings of display items */
        setTitle("L211");
        add(label2);
        add(textBox1);
        add(label3);
        add(textBox2);
        add(textBox3);
        

        setSoftLabel(Frame.SOFT_KEY_1, "Esci");
        setSoftLabel(Frame.SOFT_KEY_2, "Test");

        /* Listener setting */
        setSoftKeyListener(this);
    }


    /**
     * When soft key is pressed, do not carry out any operations.
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate the application when soft key1 is released.
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key1 is released, end the application */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            textBox2.setText(URLEncoder.encode(textBox1.getText()));
        }
    }
}
