/**
 * L341_0201_0101
 * MainPanel
 *
 * communication (resource):check the behavior when it is opened (resource name operation) 
 *
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;
import javax.microedition.io.*;
import java.io.*;
import javax.microedition.*;
import java.util.*;


/**
 * main class
 * @extends IApplication
 */
public class L341_0201_0101 extends IApplication {

    /**
     * startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * communication (resource)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    Button executeButton = new Button("Esegui");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    InputStream lastIS;
    InputStream lastDIS;

    String[] menuListItem = {
        "Test1",
        "Test2",
    };

    /**
     * constructor of MainPanel class
     */
    public MainPanel() {
        /* configuration of display items */
        menuList.setItems(menuListItem);
        setTitle("L341");
        setSoftLabel(SOFT_KEY_1, "Esci");

        /* add each component to the screen */
        add(menuList);
        add(executeButton);

        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * operate nothing when soft key is pushed down
     * @param index of anIndex key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * end the application when soft key 1 is released
     * @param index of anIndex key
     */
    public void softKeyReleased(int anIndex) {

        /* end the application when soft key 1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * receive events occurred in components
     * @param aComponent the component that has been generated an event
     * @param aType event type
     * @param aParam event parameter
     * 
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if (aComponent == executeButton) {
            test();
        }

    }

    /*
     * dialog display method
     * @param   aText displayed character strings 
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Risult");
        d.setText(aText);
        d.show();
    }


    /**
     * method to execute the test
     */
    public void test() {
        int idx = menuList.getSelectedIndex();
        InputConnection   ic1 = null;
        InputStream       is1 = null;
        InputStreamReader isr = null;
        char[]            cbuf= new char[3];
        byte[]            bbuf1= new byte[27];
        int               len = 0;

        /* execute each of the tests */
        switch( idx ) {

		case 0:
                try{
                   is1 = Connector.openInputStream("resource:///UTF-8");
                   isr = new InputStreamReader(is1,"UTF8");
                   isr.read(cbuf,0,3);
                }
                catch(Exception e){
                    showDialog("NG:"+ e.toString());
                }
                if(cbuf[0] == '' && cbuf[1] == '' && cbuf[2] == ''){
                    showDialog("OK");
                }else{
                    showDialog("NG:" + cbuf[0] + cbuf[1] + cbuf[2] );
                }
                break;
	
                case 1:
                try{
                   is1 = Connector.openInputStream("resource:///windows-1252");
                   isr = new InputStreamReader(is1,"Cp1252");
                   isr.read(cbuf,0,3);
                }
                catch(Exception e){
                    showDialog("NG:"+ e.toString());
                }
                if(cbuf[0] == '' && cbuf[1] == '' && cbuf[2] == ''){
                    showDialog("OK");
                }else{
                    showDialog("NG:" + cbuf[0] + cbuf[1] + cbuf[2] );
                }
                break;
        }
    }
}

