/**
 * J011_0202_0201
 * MainPanel
 * StaticValueConfirm
 * ConstractorConfirm
 *
 * ConnectionException class action check (normal route)
 *
 * $Id: J011_0202_0201.java,v 1.1 2001/12/02 04:36:10 hoshi Exp $
 */
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;


/**
 * class ConnectionException main class for confirming of operation
 * @extends IApplication
 */
public class J011_0202_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * class ConnectionException main display for confirming of operation
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "0 check definition of the constant ",
        "1 check behavior of the constructor"
    };

    Frame   subFrame;
    Label   classLabel       = new Label("ConnectionException");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    void showMainPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /*
         * Constant member definition check
         * The following is confirming Constant member can't be set the value
         * Confirm the failure in building and delete to the end of the method
         */
/*
        // J011_0202_0101
        ConnectionException.HTTP_ERROR          = 1;
        // J011_0202_0102
        ConnectionException.ILLEGAL_STATE       = 1;
        // J011_0202_0103
        ConnectionException.IMODE_LOCKED        = 1;
        // J011_0202_0104
        ConnectionException.NO_RESOURCE         = 1;
        // J011_0202_0105
        ConnectionException.NO_USE              = 1;
        // J011_0202_0106
//2002/07/25 DoJa1.5      ConnectionException.OBEX_ERROR          = 1;
        // J011_0202_0107
        ConnectionException.OUT_OF_SERVICE      = 1;
        // J011_0202_0108
        ConnectionException.RESOURCE_BUSY       = 1;
        // J011_0202_0109
        ConnectionException.SCRATCHPAD_OVERSIZE = 1;
        // J011_0202_0110
        ConnectionException.SELF_MODE           = 1;
        // J011_0202_0111
        ConnectionException.SSL_ERROR           = 1;
        // J011_0202_0112
        ConnectionException.STATUS_FIRST        = 1;
        // J011_0202_0113
        ConnectionException.STATUS_LAST         = 1;
        // J011_0202_0114
        ConnectionException.SYSTEM_ABORT        = 1;
        // J011_0202_0115
        ConnectionException.TIMEOUT             = 1;
        // J011_0202_0116
        ConnectionException.UNDEFINED           = 1;
        // J011_0202_0117
        ConnectionException.USER_ABORT          = 1;
*/
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of softkey pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex the value of softkey released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            try {
                switch (menuList.getSelectedIndex()) {
                case 0:
                    /* set the display for confirming defined constant on the frame */
                    subFrame = new StaticValueConfirm(this);
                    break;
                case 1:
                    /* put Constructor operation check screen class into Frame */
                    subFrame = new ConstractorConfirm(this);
                    break;
                default:
                    break;
                }
            } catch (Exception e) {
                throw new RuntimeException("The class cannot be found.");
            }

            /* set display current which is set up */
            Display.setCurrent(subFrame);
        }
    }
}


/**
 * Class of display for confirming defined constant 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class StaticValueConfirm
    extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        " 0 HTTP_ERROR",
        " 1 ILLEGAL_ST",
        " 2 IMODE_LOCK",
        " 3 NO_RESOURC",
        " 4 NO_USE",
//2002/07/25 DoJa1.5      " 5 OBEX_ERROR",
        " 6 OUT_OF_SER",
        " 7 RESOURCE_B",
        " 8 SCRATCHPAD",
        " 9 SELF_MODE",
        "10 SSL_ERROR",
        "11 STATUS_FIR",
        "12 STATUS_LAS",
        "13 SYSTEM_ABO",
        "14 TIMEOUT",
        "15 UNDEFINED",
        "16 USER_ABORT"
    };

    String[] exceptionItem = {
        "HTTP_ERROR",
        "ILLEGAL_STATE",
        "IMODE_LOCKED",
        "NO_RESOURCE",
        "NO_USE",
//2002/07/25 DoJa1.5      "OBEX_ERROR",
        "OUT_OF_SERVICE",
        "RESOURCE_BUSY",
        "SCRATCHPAD_OVERSIZE",
        "SELF_MODE",
        "SSL_ERROR",
        "STATUS_FIRST",
        "STATUS_LAST",
        "SYSTEM_ABORT",
        "TIMEOUT",
        "UNDEFINED",
        "USER_ABORT"
    };

    Frame   prevFrame;
    Label   titleLabel = new Label("check definition of the constant ");
    ListBox menuList   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    TextBox resultText = new TextBox("", 20, 2, TextBox.DISPLAY_ANY);

    /**
     * Constructor of the constant definition confirming class
     * @param aPrev previous display frame 
     */
    public StaticValueConfirm(Frame aPrev) {

        /* setting the parameter field variable */
        prevFrame = aPrev;

        try {
            /* display of the main panel */
            showSubPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * show the constant definition confirming display
     */
    void showSubPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* adding each component on the display */
        add(titleLabel);
        add(menuList);
        add(execButton);
        add(resultText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of softkey pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * define the action when softkey is released
     * @param anIndex the value of softkey released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* when softkey2 is released, go to the previous screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(prevFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the list selection is changed */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            resultText.setText("");
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            /* Result of constant definition checking reflects textbox of result */
            resultText.setText(checkStaticValue(menuList.getSelectedIndex()));
        }
    }

    /**
     * checking the constant definition
     * @param anIndex The index number which is selected in listbox
     * @return Check result character sequence
     */
    String checkStaticValue(int anIndex) {

        String resultStr;

        /* checking whether Exception which is selected is as a default  */
        switch (anIndex) {
        case 0:
            // J011_0202_0201
            resultStr = isOK(ConnectionException.HTTP_ERROR == 10);
            break;
        case 1:
            // J011_0202_0202
            resultStr = isOK(ConnectionException.ILLEGAL_STATE == 1);
            break;
        case 2:
            // J011_0202_0203
            resultStr = isOK(ConnectionException.IMODE_LOCKED == 6);
            break;
        case 3:
            // J011_0202_0204
            resultStr = isOK(ConnectionException.NO_RESOURCE == 2);
            break;
        case 4:
            // J011_0202_0205
            resultStr = isOK(ConnectionException.NO_USE == 4);
            break;
//2002/07/25 DoJa1.5      case 5:
//2002/07/25 DoJa1.5          // J011_0202_0206
//2002/07/25 DoJa1.5          resultStr = isOK(ConnectionException.OBEX_ERROR == 12);
//2002/07/25 DoJa1.5          break;
        case 5:
//2002/07/25 DoJa1.5      case 6:
            // J011_0202_0207
            resultStr = isOK(ConnectionException.OUT_OF_SERVICE == 5);
            break;
//2002/07/25 DoJa1.5        case 7:
        case 6:
            // J011_0202_0208
            resultStr = isOK(ConnectionException.RESOURCE_BUSY == 3);
            break;
//2002/07/25 DoJa1.5        case 8:
        case 7:
            // J011_0202_0209
            resultStr = isOK(ConnectionException.SCRATCHPAD_OVERSIZE == 11);
            break;
//2002/07/25 DoJa1.5        case 9:
        case 8:
            // J011_0202_0210
            resultStr = isOK(ConnectionException.SELF_MODE == 13);
            break;
//2002/07/25 DoJa1.5        case 10:
        case 9:
            // J011_0202_0211
            resultStr = isOK(ConnectionException.SSL_ERROR == 14);
            break;
//2002/07/25 DoJa1.5        case 11:
        case 10:
            // J011_0202_0212
            resultStr = isOK(ConnectionException.STATUS_FIRST == 0);
            break;
//2002/07/25 DoJa1.5        case 12:
        case 11:
            // J011_0202_0213
            resultStr = isOK(ConnectionException.STATUS_LAST == 32);
            break;
//2002/07/25 DoJa1.5        case 13:
        case 12:
            // J011_0202_0214
            resultStr = isOK(ConnectionException.SYSTEM_ABORT == 9);
            break;
//2002/07/25 DoJa1.5        case 14:
        case 13:
            // J011_0202_0215
            resultStr = isOK(ConnectionException.TIMEOUT == 7);
            break;
//2002/07/25 DoJa1.5        case 15:
        case 14:
            // J011_0202_0216
            resultStr = isOK(ConnectionException.UNDEFINED == 0);
            break;
//2002/07/25 DoJa1.5        case 16:
        case 15:
            // J011_0202_0217
            resultStr = isOK(ConnectionException.USER_ABORT == 8);
            break;
        default:
            resultStr = "ERROR\nMissing Operation";
            break;
        }

        /* When a judgment result is NG, an actual value is set as NG addition information */
        if (resultStr.equals("NG")) {
            resultStr += "\n" + exceptionItem[anIndex];
        }

        return resultStr;
    }

    /**
     * The justification of a constant definition is judged and the character sequence OK/NG is returned.
     * @param aResult Constant definition judging
     * @return Judging result ("OK" or "NG)
     */
    String isOK(boolean aResult) {
        return (aResult ? "OK" : "NG");
    }
}


/**
 * Constructor operation check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class ConstractorConfirm
    extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "0 given value",
        "1 rated value 1",
        "2 rated value 2"
    };

    Frame   prevFrame;
    Label   titleLabel = new Label("check behavior of the constructor");
    ListBox menuList   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    TextBox resultText = new TextBox("", 20, 2, TextBox.DISPLAY_ANY);

    /**
     * the constructor of the constructor operation check screen class
     * @param aPrev previous display frame 
     * @param aConstractorType Constructor type
     */
    public ConstractorConfirm(Frame aPrev) {

        /* setting the parameter field variable */
        prevFrame = aPrev;

        try {
            /* Display of the constructor operation check screen */
            showSubPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display the constructor operation check screen
     */
    void showSubPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* adding each component on the display */
        add(titleLabel);
        add(menuList);
        add(execButton);
        add(resultText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of softkey pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * define the action when softkey1 is released
     * @param anIndex the value of softkey released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* when softkey2 is released, go to the previous screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(prevFrame);
        }
    }

    /**
     * get the event on a component
     * aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When the execution button is pushed, constructor type decide processing. */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            switch (menuList.getSelectedIndex()) {

            case 0:
                /* case of given value constructor */
                try {
                    // J011_0203_0101
                    throw new ConnectionException(
//2002/08/02 DoJa1.5                        ConnectionException.OBEX_ERROR, "OK");
                        ConnectionException.HTTP_ERROR, "OK");
                } catch (ConnectionException ce) {
                    // J011_0205_0101
                    resultText.setText(ce.getMessage() + "\n" + ce.getStatus());
                }
                break;

            case 1:
                /* In the case of a regular value constructor ( with an argument) */
                try {
                    // J011_0203_0201
                    throw new ConnectionException(
                        ConnectionException.SELF_MODE);
                } catch (ConnectionException ce) {
                    resultText.setText("OK\n" + ce.getStatus());
                }
                break;
            case 2:
                /* In the case of a regular value constructor ( without an argument) */
                try {
                    // J011_0203_0202
                    throw new ConnectionException();
                } catch (ConnectionException ce) {
                    resultText.setText(ce.getMessage() + "\n" + ce.getStatus());
                }
                break;
            default:
                /* otherwise */
                resultText.setText("NG\nMissing Operation");
                break;
            }
        }
    }
}
