/**
 * J011_0301_0301
 * 
 * HttpConnection field access action check
 *
 * $Id: J011_0301_0301.java,v 1.1 2001/11/30 02:42:43 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * HttpConnection field access action check main class
 * @extends IApplication
 */

public class J011_0301_0301 extends IApplication {
    /**
     * functional outline :Starting method of i-appli 
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * HttpConnection field access action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menulist[]={
            "0.GET",
//            "1.HEAD",
            "2.HTTP_ACCEPTED",
            "3.HTTP_BAD_GATEWAY",
            "4.HTTP_BAD_METHOD",
            "5.HTTP_BAD_REQUEST",
            "6.HTTP_CLIENT_TIMEOUT",
            "7.HTTP_CONFLICT",
            "8.HTTP_CREATED",
            "9.HTTP_ENTITY_TOO_LARGE",
            "10.HTTP_EXPECT_FAILED",
            "11.HTTP_FORBIDDEN",
            "12.HTTP_GATEWAY_TIMEOUT",
            "13.HTTP_GONE",
            "14.HTTP_LENGTH_REQUIRED",
            "15.HTTP_MOVED_PERM",
            "16.HTTP_MOVED_TEMP",
            "17.HTTP_MULT_CHOICE",
            "18.HTTP_NO_CONTENT",
            "19.HTTP_NOT_ACCEPTABLE",
            "20.HTTP_NOT_AUTHORITATIVE",
            "21.HTTP_NOT_FOUND",
//2002/08/20 DoJa1.5            "22.HTTP_INTERNAL_ERROR",
            "22.HTTP_NOT_IMPLEMENTED",
            "23.HTTP_NOT_MODIFIED",
            "24.HTTP_OK",
            "25.HTTP_PARTIAL",
            "26.HTTP_PAYMENT_REQUIRED",
            "27.HTTP_PRECON_FAILED",
            "28.HTTP_PROXY_AUTH",
            "29.HTTP_REQ_TOO_LONG",
            "30.HTTP_RESET",
            "31.HTTP_SEE_OTHER",
//2002/08/20 DoJa1.5            "32.HTTP_SERVER_ERROR",
            "32.HTTP_INTERNAL_ERROR",
            "33.HTTP_TEMP_REDIRECT",
            "34.HTTP_UNAUTHORIZED",
            "35.HTTP_UNAVAILABLE",
            "36.HTTP_UNSUPPORTED_RANGE",
            "37.HTTP_UNSUPPORTED_TYPE",
            "38.HTTP_USE_PROXY",
            "39.HTTP_VERSION",
            "40.POST"
        };
        Label title;
        ListBox menu;
        Button  exe;
        TextBox out;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class normal route");
            title=new Label("HttpConnection field");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menulist);
            add(menu);
            exe=new Button("execute");
            add(exe);
            out = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
            add(out);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {;
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when the menu is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
                /* clear the  */
                out.setText("");
            }

            /* when  the exsecution button is pushed */
            if( aComponent == exe && aType == ComponentListener.BUTTON_PRESSED ) {
                /* test the menu which is choiced */
                test(menu.getSelectedIndex());
            }
        }

        /**
         * test the field which is choiced
         * @param anIndex Index of the menu which is choiced
         */
        public void test(int anIndex) {
            int     value;
            String  str;
            out.setText("");
            switch( anIndex ) {
                // J011_0301_0301
                /* J011_0302_0201 */
                case 0:
                    str = HttpConnection.GET;
                    if( str.compareTo("GET") == 0 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + str);
                    break;
                // J011_0301_0302
                // J011_0302_0202
//                case 1:
//                    str = HttpConnection.HEAD;
//                    if( str.compareTo("HEAD") == 0 )
//                        out.setText("OK");
//                    else
//                        out.setText("NG: " + str);
//                    break;
                // J011_0301_0303
                // J011_0302_0203
                case 1:
                    value = HttpConnection.HTTP_ACCEPTED;
                    if( value == 202 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0304
                // J011_0302_0204
                case 2:
                    value = HttpConnection.HTTP_BAD_GATEWAY;
                    if( value == 502 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0305
                // J011_0302_0205
                case 3:
                    value = HttpConnection.HTTP_BAD_METHOD;
                    if( value == 405 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0306
                // J011_0302_0206
                case 4:
                    value = HttpConnection.HTTP_BAD_REQUEST;
                    if( value == 400 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0307
                // J011_0302_0207
                case 5:
                    value = HttpConnection.HTTP_CLIENT_TIMEOUT;
                    if( value == 408 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0308
                // J011_0302_0208
                case 6:
                    value = HttpConnection.HTTP_CONFLICT;
                    if( value == 409 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0309
                // J011_0302_0209
                case 7:
                    value = HttpConnection.HTTP_CREATED;
                    if( value == 201 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0310
                // J011_0302_0210
                case 8:
                    value = HttpConnection.HTTP_ENTITY_TOO_LARGE;
                    if( value == 413 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0311
                // J011_0302_0211
                case 9:
                    value = HttpConnection.HTTP_EXPECT_FAILED;
                    if( value == 417 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0312
                // J011_0302_0212
                case 10:
                    value = HttpConnection.HTTP_FORBIDDEN;
                    if( value == 403 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0313
                // J011_0302_0213
                case 11:
                    value = HttpConnection.HTTP_GATEWAY_TIMEOUT;
                    if( value == 504 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0314
                // J011_0302_0214
                case 12:
                    value = HttpConnection.HTTP_GONE;
                    if( value == 410 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0315
                // J011_0302_0215
                case 13:
                    value = HttpConnection.HTTP_LENGTH_REQUIRED;
                    if( value == 411 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0316
                // J011_0302_0216
                case 14:
                    value = HttpConnection.HTTP_MOVED_PERM;
                    if( value == 301 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0317
                // J011_0302_0217
                case 15:
                    value = HttpConnection.HTTP_MOVED_TEMP;
                    if( value == 302 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0318
                // J011_0302_0218
                case 16:
                    value = HttpConnection.HTTP_MULT_CHOICE;
                    if( value == 300 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0319
                // J011_0302_0219
                case 17:
                    value = HttpConnection.HTTP_NO_CONTENT;
                    if( value == 204 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0320
                // J011_0302_0220
                case 18:
                    value = HttpConnection.HTTP_NOT_ACCEPTABLE;
                    if( value == 406 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0321
                // J011_0302_0221
                case 19:
                    value = HttpConnection.HTTP_NOT_AUTHORITATIVE;
                    if( value == 203 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0322
                // J011_0302_0222
                case 20:
                    value = HttpConnection.HTTP_NOT_FOUND;
                    if( value == 404 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0323
                // J011_0302_0223
                case 21:
//2002/08/20 DoJa1.5                    value = HttpConnection.HTTP_INTERNAL_ERROR;
                    value = HttpConnection.HTTP_NOT_IMPLEMENTED;
                    if( value == 501 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0324
                // J011_0302_0224
                case 22:
                    value = HttpConnection.HTTP_NOT_MODIFIED;
                    if( value == 304 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0325
                // J011_0302_0225
                case 23:
                    value = HttpConnection.HTTP_OK;
                    if( value == 200 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0326
                // J011_0302_0226
                case 24:
                    value = HttpConnection.HTTP_PARTIAL;
                    if( value == 206 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0327
                // J011_0302_0227
                case 25:
                    value = HttpConnection.HTTP_PAYMENT_REQUIRED;
                    if( value == 402 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0328
                // J011_0302_0228
                case 26:
                    value = HttpConnection.HTTP_PRECON_FAILED;
                    if( value == 412 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0329
                // J011_0302_0229
                case 27:
                    value = HttpConnection.HTTP_PROXY_AUTH;
                    if( value == 407 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0330
                // J011_0302_0230
                case 28:
                    value = HttpConnection.HTTP_REQ_TOO_LONG;
                    if( value == 414 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0331
                // J011_0302_0231
                case 29:
                    value = HttpConnection.HTTP_RESET;
                    if( value == 205 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0332
                // J011_0302_0232
                case 30:
                    value = HttpConnection.HTTP_SEE_OTHER;
                    if( value == 303 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0333
                // J011_0302_0233
                case 31:
//2002/08/20 DoJa1.5                    value = HttpConnection.HTTP_SERVER_ERROR;
					value = HttpConnection.HTTP_INTERNAL_ERROR;
                    if( value == 500 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0334
                // J011_0302_0234
                case 32:
                    value = HttpConnection.HTTP_TEMP_REDIRECT;
                    if( value == 307 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0335
                // J011_0302_0235
                case 33:
                    value = HttpConnection.HTTP_UNAUTHORIZED;
                    if( value == 401 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0336
                // J011_0302_0236
                case 34:
                    value = HttpConnection.HTTP_UNAVAILABLE;
                    if( value == 503 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0337
                // J011_0302_0237
                case 35:
                    value = HttpConnection.HTTP_UNSUPPORTED_RANGE;
                    if( value == 416 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0338
                // J011_0302_0238
                case 36:
                    value = HttpConnection.HTTP_UNSUPPORTED_TYPE;
                    if( value == 415 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0339
                // J011_0302_0239
                case 37:
                    value = HttpConnection.HTTP_USE_PROXY;
                    if( value == 305 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0340
                // J011_0302_0240
                case 38:
                    value = HttpConnection.HTTP_VERSION;
                    if( value == 505 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + value);
                    break;
                // J011_0301_0341
                // J011_0302_0241
                case 39:
                    str = HttpConnection.POST;
                    if( str.compareTo("POST") == 0 )
                        out.setText("OK");
                    else
                        out.setText("NG: " + str);
                    break;
                default:
                    break;
            }
        }
    }
}
