/**
 * J011_0305_0201
 *
 * HttpConnection regular value method action check
 *
 * $Id: J011_0305_0201.java,v 1.1 2001/11/30 02:48:36 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * HttpConnection regular value method action check main class
 * @extends IApplication
 */
public class J011_0305_0201 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * HttpConnection regular value method action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menulist[]={
            "0.GET",
            "1.POST",
            "3.Content-Type",
            "4.If-Modified-Since"
        };
        Label title;
        ListBox menu;
        Button exe;
        TextBox out;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class normal route");
            title=new Label("HttpConnection rated value method's behavior");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menulist);
            add(menu);
            exe = new Button("execute");
            add(exe);
            out = new TextBox("", 20, 5, TextBox.DISPLAY_ANY);
            add(out);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when the menu is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
                /* clear the  */
                out.setText("");
            }

            /* when  the exsecution button is pushed */
            if (aComponent == exe && aType == ComponentListener.BUTTON_PRESSED) {
                /* test the menu which is choiced */
                test(menu.getSelectedIndex());
            }
        }

        /**
         * test the method action of HttpConnection
         * @param anIndex Index of the menu which is choiced
         */
        public void test(int anIndex) {
            HttpConnection  con=null;
            InputStream     is=null;
            OutputStream    os=null;
            String          filename="J011_0305_0201.jam";

            out.setText("");
            switch( anIndex ) {
                // J011_0305_0201
                case 0:         /* GET */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.connect();
                        is = con.openInputStream();
                        if ( is != null ) {
                            int c=is.read();
                            is.close();
                        }
                        con.close();
                        out.setText("OK");
                    } catch (Exception e ) {
                        out.setText("NG:"+ e.toString());
                    }
                    break;
                // J011_0305_0202
                case 1:         /* POST */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            "../cgi-bin/post.cgi",
                                            Connector.WRITE, true);
                        con.setRequestMethod(HttpConnection.POST);
                        os = con.openOutputStream();
                        if ( os != null ) {
                            os.write(64);
                            os.close();
                        }
                        con.connect();
                        con.close();
                        out.setText("OK");
                    } catch (Exception e ) {
                        out.setText("NG:"+ e.toString());
                    }
                    break;
                // J011_0305_0204
                case 2:         /* Content-Type */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+ filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setRequestProperty("Content-Type","text/plain");
                        con.connect();
                        con.close();
                        out.setText("OK");
                    } catch (Exception e ) {
                        out.setText("NG:"+ e.toString());
                    }
                    break;
                // J011_0305_0205
                case 3:         /* If-Modified-Since */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+ filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setRequestProperty("If-Modified-Since",
                                "Thu, 04 Oct 2001 13:41:16");
                        con.connect();
                        con.close();
                        out.setText("OK");
                    } catch (Exception e ) {
                        out.setText("NG:"+ e.toString());
                    }
                    break;
                default:
                    break;
            }
        }
    }
}
