/**
 * J011_0306_0101
 *
 * HttpConnection regular value exception action check
 *
 * $Id: J011_0306_0101.java,v 1.2 2002/02/14 06:22:12 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * HttpConnection regular value exception action check main class
 * @extends IApplication
 */
public class J011_0306_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * HttpConnection regular value exception action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menuList[]={
            "0.close",
            "1.connect",
            "2.getResponseCode",
            "3.getResponseMessage",
            "4.openInputStream",
            "5.openOutputStream",
            "6.setRequestMethod",
            "7.setRequestProperty"
        };

        Label title;
        ListBox menu;
        Button exe;

        int  outFlag = 0;
        IOException ioExcp = null;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class normal route");
            title=new Label("HttpConnection's behavior for thrown exceptions");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menuList);
            add(menu);
            exe = new Button("execute");
            add(exe);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when menu1 is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
            }

            /* when  the exsecution button is pushed */
            if (aComponent == exe && aType == ComponentListener.BUTTON_PRESSED) {
                /* test the menu which is choiced */
                test(menu.getSelectedIndex());
            }
        }

        /**
         * dialog display method
         * @param   aText chalacter sequence which is displaied
         */
        public void showDialog(String aText) {
            Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
            d.setText(aText);
            d.show();
        }

        /**
         * test the method action of HttpConnection
         * @param anIndex Index of the menu which is choiced
         */
        public void test(int anIndex) {
            HttpConnection  con=null;
            InputStream     is=null;
            OutputStream    os=null;
            String          filename="J011_0306_0101.jam";

            switch( anIndex ) {
                // J011_0306_0101
                case 0:         /* close() */
                  //  CloseThread closeT = new CloseThread(con);
            		CloseThread closeT;
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                    	
                    	closeT = new CloseThread(con);
                        closeT.start();
                        con.setRequestMethod(HttpConnection.GET);
                        con.connect();
                        is = con.openInputStream();
                        int c = is.read();
                    } catch (Exception e ) {
                        showDialog("NG1:"+e.toString());
                        break;
                    }
                    /* wait till closeThread end */
                    while( closeT.isAlive() ) {
                        try {
                            Thread.sleep(1000);
                        } catch( Exception e ) {}
                    }
                    /* result judging of CloseThread */
                    switch( outFlag ) {
                    case 0:
                        /* with no break */
                    case 2:
                        showDialog("NG: no Exception");
                        break;
                    case 1:
                        showDialog("NG: InterruptedException");
                        break;
                    case 3:
                        if( ioExcp == null ) {
                            showDialog("IOException");
                        } else {
                            showDialog("IOException:" + ioExcp.getMessage());
                        }
                        break;
                    case 4:
                        showDialog("NG: Exception");
                        break;
                    }
                    break;
                // J011_0306_0102
                case 1:         /* connect() */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                    } catch (Exception e ) {
                        showDialog("NG1:"+ e.toString());
                        break;
                    }
                    try {
                        con.connect();
                        showDialog("NG: no Exception");
                    } catch( IOException io ) {
                        showDialog("IOException:" + io.getMessage());
                    } catch( Exception e2 ) {
                        showDialog("NG3:"+e2.toString());
                    }
                    try {
                        con.close();
                    } catch (Exception e3 ) {
                    }
                    break;
                // J011_0306_0103
                case 2:         /* getResponseCode() */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.connect();
                        Thread.sleep(5000);
                    } catch (Exception e ) {
                        showDialog("NG1:"+ e.toString());
                        break;
                    }
                    try {
                        int res= con.getResponseCode();
                        showDialog("NG: no Exception");
                    } catch( IOException io ) {
                        showDialog("IOException" + io.getMessage());
                    } catch (Exception e2 ) {
                        showDialog("NG3:"+ e2.toString());
                    }
                    try {
                        con.close();
                    } catch (Exception e3 ) {
                    }
                    break;
                // J011_0306_0104
                case 3:         /* getResponseMessage() */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.connect();
                        Thread.sleep(5000);
                    } catch (Exception e ) {
                        showDialog("NG1:"+ e.toString());
                        break;
                    }
                    try {
                        String msg= con.getResponseMessage();
                        showDialog("NG: no Exception");
                    } catch( IOException io ) {
                        showDialog("IOException" + io.getMessage());
                    } catch (Exception e2 ) {
                        showDialog("NG3:"+ e2.toString());
                    }
                    try {
                        con.close();
                    } catch (Exception e3 ) {
                    }
                    break;
                case 4:         /* openInputStream() */
                    // J011_0306_0105
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+ filename,
                                                Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.connect();
                        Thread.sleep(5000);
                    } catch (Exception e) {
                        showDialog("NG1:"+ e.toString());
                        break;
                    }
                    InputStream[] isArray = new InputStream[999];
                    int i;
                    for( i=0; i<999; i++ ) {
                        try {
                            isArray[i] = con.openInputStream();
                            int c = isArray[i].read();
                        } catch( IOException io ) {
                            showDialog("IOException" + io.getMessage());
                            break;
                        } catch( Exception e2 ) {
                            showDialog("NG3:"+ e2.toString());
                            break;
                        }
                    }
                    if( i == 999 ) {
                        showDialog("NG: no Exception");
                    }
                    try {
                        con.close();
                    } catch( Exception e3 ) {
                    }
                    break;
                case 5:         /* openOutputStream() */
                    // J011_0306_0106
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+ filename,
                                                Connector.WRITE, true);
                        con.setRequestMethod(HttpConnection.POST);
                        Thread.sleep(5000);
                    } catch (Exception e) {
                        showDialog("NG1:"+ e.toString());
                        break;
                    }
                    OutputStream[] osArray = new OutputStream[999];
                    for( i=0; i<999; i++ ) {
                        try {
                            osArray[i] = con.openOutputStream();
                            osArray[i].write(10);
                        } catch( IOException io ) {
                            showDialog("IOException" + io.getMessage());
                            break;
                        } catch( Exception e2 ) {
                            showDialog("NG3:"+ e2.toString());
                            break;
                        }
                    }
                    if( i == 999 ) {
                        showDialog("NG: no Exception");
                    }
                    break;
                case 6:         /* setRequestMethod() */
                    // J011_0306_0107
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL(),
                                        Connector.READ, true);
                        Thread.sleep(5000);
                    } catch (Exception e) {
                        showDialog("NG1:"+ e.toString());
                        break;
                    }
                    try {
                        con.setRequestMethod(HttpConnection.GET);
                        showDialog("NG: no Exception");
                    } catch( IOException io ) {
                        showDialog("IOException" + io.getMessage());
                    } catch( Exception e2 ) {
                        showDialog("NG3:"+ e2.toString());
                    }
                    break;
                case 7:         /* setRequestProperty() */
                    // J011_0306_0107
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL(),
                                        Connector.READ, true);
                        Thread.sleep(5000);
                    } catch (Exception e) {
                        showDialog("NG1:"+ e.toString());
                        break;
                    }
                    try {
                        con.setRequestProperty("Content-Type","unknown-format");
                        showDialog("NG: no Exception");
                    } catch( IOException io ) {
                        showDialog("IOException" + io.getMessage());
                    } catch( Exception e2 ) {
                        showDialog("NG3:"+ e2.toString());
                    }
                    break;
                default:
                    break;
            }
        }

        /**
         * a thread for close
         * @extends Thread
         */
        class CloseThread extends Thread {
            HttpConnection con;

            /**
             * CloseThread constructor
             * @param   connect     HttpConnection object
             */
            public CloseThread( HttpConnection connect ) {
                con = connect;
            }

            /**
             * run method
             */
            public void run() {
                outFlag = 0;
                try {
                    Thread.sleep(5000);
                } catch( InterruptedException ie ) {
                    outFlag = 1;
                    return;
                }

                try {
                    con.close();
                    outFlag = 2;
                } catch( IOException io ) {
                    outFlag = 3;
                    ioExcp = io;
                } catch( Exception e2 ) {
                    outFlag = 4;
                }
            }
        }
    }
}
