/**
 * J011_0306_0202
 *
 * HttpConnection logic exception generating operation check 2
 *
 * $Id: J011_0306_0202.java,v 1.1 2001/11/30 02:51:01 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * HttpConnection logic exception generating operation check 2 main class
 * @extends IApplication
 */
public class J011_0306_0202 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * HttpConnection logic exception generating operation check 2 main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menuList[]={
            "no UseNetwork"
        };

        Label title;
        ListBox menu;
        Button exe;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class normal route");
            title=new Label("HttpConnection logical exception 2");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menuList);
            add(menu);
            exe = new Button("execute");
            add(exe);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when menu1 is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
            }

            /* when  the exsecution button is pushed */
            if (aComponent == exe && aType == ComponentListener.BUTTON_PRESSED) {
                /* test the menu which is choiced */
                test(menu.getSelectedIndex());
            }
        }

        /**
         * dialog display method
         * @param   aText chalacter sequence which is displaied
         */
        public void showDialog(String aText) {
            Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
            d.setText(aText);
            d.show();
        }

        /**
         * test the method action of HttpConnection
         * @param anIndex Index of the menu which is choiced
         */
        public void test(int anIndex) {
            HttpConnection  con=null;
            String          filename="J011_0306_0202.jam";

            switch( anIndex ) {
                // J011_0306_0207
                case 0:         /* ADF without UseNetwork key */
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        showDialog("NG: no Exception");
                    } catch (SecurityException e ) {
                        showDialog("SecurityException:"+e.getMessage());
                    } catch( Exception e1 ) {
                        showDialog("NG:" + e1.toString());
                    }
                    break;
                default:
                    break;
            }
        }
    }
}
