/**
 * J011_0306_0205
 *
 * HttpConnection logic exception generating operation check
 *
 * $Id: J011_0306_0205.java,v 1.1 2001/11/30 02:50:18 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * HttpConnection Logic exception generating operation check main class
 * @extends IApplication
 */
public class J011_0306_0205 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * HttpConnection Logic exception generating operation check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
       

        Label title;
        Button exe;
    
    	TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
       


        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class normal route");
            title=new Label("HttpConnection's behavior for thrown exceptions");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            add(textBox1);
            exe = new Button("execute");
            add(exe);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
         
            /* when  the exsecution button is pushed */
            if (aComponent == exe && aType == BUTTON_PRESSED) {
              
            test();
            }
        }

        /**
         * dialog display method
         * @param   aText chalacter sequence which is displaied
         */
        public void showDialog(String aText) {
            Dialog  d = new Dialog(Dialog.BUTTON_OK, "Notification");
            d.setText(aText);
            d.show();
        }

        /**
         * Testing HttpConnection logic exception generating operation 
         * @param anIndex Index of the menu which is choiced
         */
        public void test() {
            HttpConnection  con=null;
            InputStream     is=null;
            OutputStream    os=null;
        	String	Str = new String("");
            Str = textBox1.getText();
        	Dialog d;

                         /* docomo prohibition */
                    // J011_0306_0205
                    // J011_0306_0205
                    try {
                        con=(HttpConnection) Connector.open(Str
                                            ,
                                            Connector.READ, true);
                        showDialog("NG: no Exception");
                    } catch ( IllegalArgumentException e ) {
                        showDialog("IllegalArgumentException:"+e.getMessage());
                    } catch( Exception e1 ) {
                        showDialog("NG:" + e1.toString());
                    }
        }
    }
}