/**
 * J011_0703_0101
 * 
 * UnsupportedOperationException constructer action check
 *
 * $Id: J011_0703_0101.java,v 1.1 2001/11/30 02:51:48 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.lang.*;

/**
 * UnsupportedOperationException constructer action check main class
 * @extends IApplication
 */

public class J011_0703_0101 extends IApplication {
    /**
     * functional outline :Starting method of i-appli 
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * UnsupportedOperationException constructer action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menulist[]={
            "0 given value",
            "1 rated value"
        };
        Label title;
        ListBox menu;
        Button  exe;
        TextBox out;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class normal route");
            title=new Label("UnsupportedOperationException constructor");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menulist);
            add(menu);
            exe=new Button("execute");
            add(exe);
            out = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
            add(out);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when the menu is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
                /* clear the  */
                out.setText("");
            }

            /* when  the exsecution button is pushed */
            if( aComponent == exe && aType == ComponentListener.BUTTON_PRESSED ) {
                /* test the menu which is choiced */
                test(menu.getSelectedIndex());
            }
        }

        /**
         * test the field which is choiced
         * @param anIndex Index of the menu which is choiced
         */
        public void test(int anIndex) {
            UnsupportedOperationException uoe = null;
            out.setText("");
            switch( anIndex ) {
                // J011_0703_0101
                case 0:             /* arbitrary value with parameter */
                    String msg = new String("myException");
                    uoe = new UnsupportedOperationException(msg);
                    if( uoe.getMessage().compareTo(msg) == 0 ) {
                        out.setText("OK");
                    }else {
                        out.setText("NG:" + uoe.getMessage());
                    }
                    break;
                // J011_0703_0201
                case 1:             /* regular value without parameter */
                    uoe = new UnsupportedOperationException();
                    if( uoe.getMessage() == null ) {
                        out.setText("OK");
                    }else {
                        out.setText("NG:" + uoe.getMessage());
                    }
                    break;
                default:
                    break;
            }
        }
    }
}
