/**
 * J011_0804_0301
 * MainPanel
 *
 * URLDecoder class action check (normal route)
 *
 * $Id: J011_0804_0301.java,v 1.1 2001/11/30 02:52:24 lan Exp $
 */
import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;


/**
 * URLDecoder class action check main class
 * @extends IApplication
 */
public class J011_0804_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * URLDecoder class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "0 English one byte characters",
//2002/07/26 DoJa1.5        "1 Half-size kana",
//2002/07/26 DoJa1.5        "2 full-size character",
        "3 special character",
        "4 exception-Null",
        "5.exception-Illegal"
    };

    Label   classLabel       = new Label("URLDecoder");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    Label   inLabel          = new Label("encoding setting:");
    Label   outLabel         = new Label("decoding result:");
    Label   okLabel          = new Label("normal behavior:");
    TextBox inBox            = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    TextBox outBox           = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    TextBox okBox            = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);

    char[] emoji = {0xE63E, 0xE63F, 0xE640, 0xE641};

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    void showMainPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(inLabel);
        add(inBox);
        add(execButton);
        add(outLabel);
        add(outBox);
        add(okLabel);
        add(okBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* The conversed character sequence display of an initial menu */
        inBox.setText("ABC123");
        okBox.setText("ABC123");
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* original character sequence display */
            showIn();
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }



    /**
      * display original character of choiced variation
      */
    public void showIn() {
        outBox.setText("");
        switch( menuList.getSelectedIndex() ) {
            // J011_0804_0301
            case 0:             /* Half-size English number */
                inBox.setText("ABC123");
                okBox.setText("ABC123");
                break;
            // J011_0804_0302
//2002/07/26 DoJa1.5            case 1:             /*  */
//2002/07/26 DoJa1.5                inBox.setText("%B1%B2%B3%B4%B5");
//2002/07/26 DoJa1.5                okBox.setText("");
//2002/07/26 DoJa1.5                break;
            // J011_0804_0303
//2002/07/26 DoJa1.5            case 2:             /*  */
//2002/07/26 DoJa1.5                inBox.setText("%82%A0%82%A2%82%A4%82%A6%82%A8");
//2002/07/26 DoJa1.5                okBox.setText("");
//2002/07/26 DoJa1.5                break;
            // J011_0804_0304
//2002/07/26 DoJa1.5            case 3:             /*  */
            case 1:             /* special character */
                inBox.setText("%EE%98%BE%EE%98%BF%EE%99%80%EE%99%81");
//2002/08/26 Doja1.5                inBox.setText("%F8%9F%F8%A0%F8%A1%F8%A2");
                okBox.setText(String.valueOf(emoji));
                break;
            // J011_0806_0101
//2002/07/26 DoJa1.5            case 4:             /* null */
            case 2:             /* null */
                inBox.setText("");
                okBox.setText("NullPointerException");
                break;
            // J011_0806_0102
//2002/07/26 DoJa1.5            case 5:             /*  */
            case 3:             /* character sequence which is not www-form-urlencode format */
                inBox.setText("GR[h");
                okBox.setText("IllegalArgumentException");
                break;
            default:
                inBox.setText("");
                okBox.setText("");
                break;
        }
    }

    /**
     * test the choiced decode
     */
    public void test() {
        showIn();
        outBox.setText("");
        switch( menuList.getSelectedIndex() ) {
            // J011_0804_0101
            // J011_0804_0301
            case 0:             /* Half-size English number */
            // J011_0804_0302
                /* with no break */
//2002/07/26 DoJa1.5            case 1:             /*  */
            // J011_0804_0303
                /* with no break */
//2002/07/26 DoJa1.5            case 2:             /*  */
            // J011_0804_0304
                /* with no break */
//2002/07/26 DoJa1.5            case 3:             /*  */
            case 1:             /* special character */
                outBox.setText(URLDecoder.decode(inBox.getText()));
                break;
            // J011_0806_0101
//2002/07/26 DoJa1.5            case 4:             /* null */
            case 2:             /* null */
                try {
                    URLDecoder.decode(null);
                    showDialog("NG: no Exception");
                } catch ( NullPointerException ne ) {
                    showDialog("NullPointerException:"+ne.getMessage());
                } catch ( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            // J011_0806_0102
//2002/07/26 DoJa1.5            case 5:             /*  */
            case 3:             /* character sequence which is not www-form-urlencode format */
                try {
                    String str = URLDecoder.decode(inBox.getText());
                    outBox.setText(str);
                    showDialog("NG: no Exception");
                } catch ( IllegalArgumentException ie ) {
                    showDialog("IllegalArgumentException:"+ie.getMessage());
                } catch ( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            default:
                break;
        }
    }
}
