/**
 * J011_0904_0301
 * MainPanel
 * MethodConfirm
 *
 * URLEncoder class action check (normal route)
 *
 * $Id: J011_0904_0301.java,v 1.1 2001/12/02 04:37:37 hoshi Exp $
 */
import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;


/**
 * URLEncoder class action check main class
 * @extends IApplication
 */
public class J011_0904_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * URLEncoder class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "0 English one byte characters",
//2002/08/02 DoJa1.5        "1 ",
//2002/08/02 DoJa1.5        "2 ",
        "3 special character",
        "4 check the behavior for thrown exception"
    };

    Frame   subFrame;
    Label   classLabel       = new Label("URLEncoder");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    void showMainPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of softkey pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex the value of softkey released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            try {
                /* set the method action check screen to frame */
                subFrame = new MethodConfirm(this, menuList.getSelectedIndex());
            } catch (Exception e) {
                throw new RuntimeException("The class cannot be found.");
            }

            /* set display current which is set up */
            Display.setCurrent(subFrame);
        }
    }
}


/**
 * method action check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MethodConfirm
    extends Panel implements SoftKeyListener, ComponentListener {

    char[] emoji = {0xE63E, 0xE63F, 0xE640, 0xE641};

    Frame   prevFrame;
    int     testType;
    Label   titleLabel  = new Label("check method's behavior");
    TextBox targetText  = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    Button  execButton  = new Button("execute");
    Label   resultLabel = new Label("encoding result");
    TextBox resultText  = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    Label   normalLabel = new Label("normal behavior");
    TextBox normalText  = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);

    /**
     * method action check screen class constructer
     * @param aPrev previous display frame 
     * @param aTestType Test type
     */
    public MethodConfirm(Frame aPrev, int aTestType) {

        /* setting the parameter field variable */
        prevFrame = aPrev;
        testType  = aTestType;

        try {
            /* displaying method action check screen */
            showSubPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display method action check screen
     */
    void showSubPanel() {

        /* setting of the display item */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        switch (testType) {

        /* Half-size English number */
        case 0:
            // J011_0904_0301
            targetText.setText("ABC123");
            normalText.setText("ABC123");
            break;

        /* half-size kana */
//2002/08/02 DoJa1.5        case 1:
            // J011_0904_0302
//2002/08/02 DoJa1.5            targetText.setText("");
//2002/08/02 DoJa1.5            normalText.setText("%B1%B2%B3%B4%B5");
//2002/08/02 DoJa1.5            break;

        /* full-size character */
//2002/08/02 DoJa1.5        case 2:
            // J011_0904_0303
//2002/08/02 DoJa1.5            targetText.setText("");
//2002/08/02 DoJa1.5            normalText.setText("%82%A0%82%A2%82%A4%82%A6%82%A8");
//2002/08/02 DoJa1.5            break;

        /* special character */
//2002/08/02 DoJa1.5        case 3:
        case 1:
            // J011_0904_0304
            targetText.setText(String.valueOf(emoji));
            normalText.setText("%EE%98%BE%EE%98%BF%EE%99%80%EE%99%81");
//2002/08/26 Dpja1.5            normalText.setText("%F8%9F%F8%A0%F8%A1%F8%A2");
            break;

        /* exception(null) */
//2002/08/02 DoJa1.5        case 4:
        case 2:
            // J011_0904_0601
            targetText.setText("null");
            normalText.setText("NullPointerException:null");
            break;

        default:
            break;
        }

        /* A width setup of an Encode result label (prepare for button arrangement which result in non-started  new line) */
        resultLabel.setSize(this.getWidth(), resultLabel.getHeight());

        /* adding each component on the display */
        add(titleLabel);
        add(targetText);
        add(execButton);
        add(resultLabel);
        add(resultText);
        add(normalLabel);
        add(normalText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of softkey pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * define the action when softkey is released
     * @param anIndex the value of softkey released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* when softkey2 is released, go to the previous screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(prevFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            /* Result of constant definition checking reflects textbox of result */
            try {
//2002/08/02 DoJa1.5                if (testType == 4) {
                if (testType == 2) {
                    // J011_0904_0101
                    // J011_0906_0101
                    resultText.setText(URLEncoder.encode(null));
                } else {
                    resultText.setText(URLEncoder.encode(targetText.getText()));
                }
            } catch (NullPointerException npe) {
                Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR, "An exception is detected.");
                errorDialog.setText("NullPointerException:" + npe.getMessage());
                errorDialog.show();
            }
        }
    }
}
