/** 
 * J011_1104_0101
 * MainPanel
 * 
 * AudioPresenter class action check (normal route)
 * 
 * $ID:$
 */

import com.nttdocomo.io.* ;
import com.nttdocomo.ui.* ;

/** 
 * AudioPresenter class action check main class
 * @extends IApplication
 */
public class J011_1104_0101 extends IApplication{
    
    /** 
     * starting method for I-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/** 
 * AudioPresenter class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 * @implements MediaListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener,MediaListener{
    String[] menuListItem = {
        "0 test 1",
        "1 test 2",
        "2 test 3",
        "3 test 4",
        "4 test 5",
        "5 test 6",
//2002/08/30 DoJa1.5        "6 test 7",
        "7 test 8",
        "8 test 9",
//2002/07/25 DoJa1.5        "",
//2002/07/25 DoJa1.5        "",
//2002/07/25 DoJa1.5        "",
//2002/07/25 DoJa1.5        "",
//2002/07/25 DoJa1.5        "",
//2002/07/25 DoJa1.5        "",
        "15 test 16",
        "16 test 17",
        "17 test 18",
        "18 test 19",
        "19 test 20",
        "20 test 21",
        "21 test 22"
    };
    
    Frame subFrame ;
    Label classLabel = new Label("AudioPresenter");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultBox =new TextBox("",20,2,TextBox.DISPLAY_ANY);
    Button execButton = new Button("execute");
    Button playButton = new Button("replay");
    Button pauseButton = new Button("pause");
    Button restartButton = new Button("restart");
    Button stopButton = new Button("stop");
    AudioPresenter ap = null;
    
    /** 
     * constructer of the MainPanel
     */
    public MainPanel(){
        try{
            /* display the MainPanel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
            errDialog.setText("Error:" +e.toString());
            errDialog.show();
        }
    }
    
    /** 
     * display the main panel
     */
    void showMainPanel(){
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
    
    /* adding each component on the display */
    add(classLabel);
    add(menuList);
    add(execButton);
    add(stopButton);
    add(playButton);
    add(pauseButton);
    add(restartButton);
    add(resultBox);
    
    /* setting the listener */
    setSoftKeyListener(this);
    setComponentListener(this);
    }
    
    /** 
     *do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex){}
    
    /** 
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex){
        /* terminate the application when softkey1 is released */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /** 
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Event type
     * @param aParam  parameter of the event
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        int index = menuList.getSelectedIndex();
        /* processing when the execution button is pushed */
        if(aComponent == execButton && aType == ComponentListener.BUTTON_PRESSED){
            test();
        }
        
//2002/07/25 DoJa1.5      /*  */
//2002/07/25 DoJa1.5      if(aComponent == playButton && aType == ComponentListener.BUTTON_PRESSED){
//2002/07/25 DoJa1.5          int time2 = 90000;
//2002/07/25 DoJa1.5          ap.play(time2);
//2002/07/25 DoJa1.5          resultBox.setText("OK");
//2002/07/25 DoJa1.5      }
        
//2002/07/25 DoJa1.5      /*  */
//2002/07/25 DoJa1.5      if(aComponent == pauseButton && aType == ComponentListener.BUTTON_PRESSED){
//2002/07/25 DoJa1.5          if(index == 17){
//2002/07/25 DoJa1.5              ap.pause();
//2002/07/25 DoJa1.5          }else if(index == 18){
//2002/07/25 DoJa1.5              resultBox.setText("");
//2002/07/25 DoJa1.5          }else{
//2002/07/25 DoJa1.5              ap.pause();
//2002/07/25 DoJa1.5          }
//2002/07/25 DoJa1.5      }
        
//2002/07/25 DoJa1.5     /*  */
//2002/07/25 DoJa1.5      if(aComponent == restartButton && aType == ComponentListener.BUTTON_PRESSED){
//2002/07/25 DoJa1.5          if(index == 17){
//2002/07/25 DoJa1.5              ap.restart();
//2002/07/25 DoJa1.5          }else if(index == 21){
//2002/07/25 DoJa1.5              resultBox.setText("");
//2002/07/25 DoJa1.5          }else{
//2002/07/25 DoJa1.5              ap.restart();
//2002/07/25 DoJa1.5              resultBox.setText("");
//2002/07/25 DoJa1.5          }
//2002/07/25 DoJa1.5      }
        
        /* processing when the music is stopped */
        if(aComponent == stopButton && aType == ComponentListener.BUTTON_PRESSED){
            if(index == 14){
                ap.stop();
                ap.setMediaListener(this);
            }else{
                ap.stop();
                resultBox.setText("OK");
            }
        }

    }
        
    /** 
     * create the test method
     * each method when the excecution button is pushed
     */
    public void test(){
        /* takes the figure when choosing from the list box. */
        int index = menuList.getSelectedIndex();
        switch (index) {
            //J011_1104_0101
            case 0:
                try{
                    ap = null;
                    ap = AudioPresenter.getAudioPresenter();
                    if (ap != null){
                        resultBox.setText("OK");
                    }else{
                        resultBox.setText("NG");
                    }
                }catch(UIException e){
                    resultBox.setText("NG");
                }
                break;
            
            //J011_1105_0101
            case 1:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    resultBox.setText("OK");
                }catch(Exception e){
                    resultBox.setText("NG:" + e.toString());
                }
                break;
            
            //J011_1105_0102
            case 2:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaData md = MediaManager.getData("resource:///MFi-norm.mld");
                    md.use();
                    ap.setData(md);
                    resultBox.setText("NG");
                }catch(Exception e){
                    resultBox.setText("OK:" +e.toString());
                }
                break;
        
            //J011_1105_0103
            case 3:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    MediaSound s = (MediaSound)ap.getMediaResource();
                    if (ms == s){
                        resultBox.setText("OK");
                    }else{
                        resultBox.setText("NG:");
                    }
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
        
            //J011_1105_0104
            case 4:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.play();
                    resultBox.setText("OK");
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
        
            //J011_1105_0105
            case 5:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.play();
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
            
            //J011_1105_0106
//2002/08/30 DoJa1.5            case 6:
//2002/08/30 DoJa1.5                try{
//2002/08/30 DoJa1.5                    ap = AudioPresenter.getAudioPresenter();
//2002/08/30 DoJa1.5                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
//2002/08/30 DoJa1.5                    ms.use();
//2002/08/30 DoJa1.5                    ap.setSound(ms);
//2002/08/30 DoJa1.5                    ap.setAttribute(AudioPresenter.AUDIO_PLAYING,1);
//2002/08/30 DoJa1.5                    resultBox.setText("OK");
//2002/08/30 DoJa1.5                }catch(Exception e){
//2002/08/30 DoJa1.5                    resultBox.setText("NG:" +e.toString());
//2002/08/30 DoJa1.5                }
//2002/08/30 DoJa1.5                break;
        
            //J011_1105_0107
//2002/08/30 DoJa1.5            case 7:
            case 6:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.setMediaListener(this);
                    resultBox.setText("OK");
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
        
            //J011_1105_0108
//2002/08/30 DoJa1.5            case 8:
            case 7:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.setMediaListener(this);
                    ap.setMediaListener(null);
                    resultBox.setText("OK");
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
            
//2002/07/25 DoJa1.5          //J011_1105_0109
//2002/07/25 DoJa1.5          case 9:
//2002/07/25 DoJa1.5              try{
//2002/07/25 DoJa1.5                  ap = AudioPresenter.getAudioPresenter();
//2002/07/25 DoJa1.5                  MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
//2002/07/25 DoJa1.5                  ms.use();
//2002/07/25 DoJa1.5                  ap.setSound(ms);
//2002/07/25 DoJa1.5                  ap.setSyncEvent(AudioPresenter.AUDIO_SYNC,4);
//2002/07/25 DoJa1.5                  resultBox.setText("OK");
//2002/07/25 DoJa1.5              }catch(Exception e){
//2002/07/25 DoJa1.5                  resultBox.setText("NG:" +e.toString());
//2002/07/25 DoJa1.5              }
//2002/07/25 DoJa1.5              break;
                
//2002/07/25 DoJa1.5          //J011_1105_0110
//2002/07/25 DoJa1.5          case 10:
//2002/07/25 DoJa1.5              try{
//2002/07/25 DoJa1.5                  ap = AudioPresenter.getAudioPresenter();
//2002/07/25 DoJa1.5                  MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
//2002/07/25 DoJa1.5                  ms.use();
//2002/07/25 DoJa1.5                  ap.setSound(ms);
//2002/07/25 DoJa1.5                  ap.play();
//2002/07/25 DoJa1.5                  int msint = ap.getCurrentTime();
//2002/07/25 DoJa1.5                  resultBox.setText("OK:" +msint+"ms");
//2002/07/25 DoJa1.5              }catch(Exception e){
//2002/07/25 DoJa1.5                  resultBox.setText("NG:" +e.toString());
//2002/07/25 DoJa1.5              }
//2002/07/25 DoJa1.5              break;
            
//2002/07/25 DoJa1.5          //J011_1105_0111
//2002/07/25 DoJa1.5          case 11:
//2002/07/25 DoJa1.5              try{
//2002/07/25 DoJa1.5                  ap = AudioPresenter.getAudioPresenter();
//2002/07/25 DoJa1.5                  MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
//2002/07/25 DoJa1.5                  ms.use();
//2002/07/25 DoJa1.5                  ap.setSound(ms);
//2002/07/25 DoJa1.5                  int atime = 10000;
//2002/07/25 DoJa1.5                  ap.play(atime);
//2002/07/25 DoJa1.5                  resultBox.setText("OK");
//2002/07/25 DoJa1.5              }catch(Exception e){
//2002/07/25 DoJa1.5                  resultBox.setText("NG:" +e.toString());
//2002/07/25 DoJa1.5              }
//2002/07/25 DoJa1.5              break;
            
//2002/07/25 DoJa1.5          //J011_1105_0112
//2002/07/25 DoJa1.5          case 12:
//2002/07/25 DoJa1.5              try{
//2002/07/25 DoJa1.5                  ap = AudioPresenter.getAudioPresenter();
//2002/07/25 DoJa1.5                  MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
//2002/07/25 DoJa1.5                  ms.use();
//2002/07/25 DoJa1.5                  ap.setSound(ms);
//2002/07/25 DoJa1.5                  ap.play(10000);
//2002/07/25 DoJa1.5                  ap.setMediaListener(this);
//2002/07/25 DoJa1.5              }catch(Exception anException){
//2002/07/25 DoJa1.5                  resultBox.setText("NG : " +anException.toString());
//2002/07/25 DoJa1.5              }
//2002/07/25 DoJa1.5              break;
                
//2002/07/25 DoJa1.5          //J011_1105_0113
//2002/07/25 DoJa1.5          case 13:
//2002/07/25 DoJa1.5              try{
//2002/07/25 DoJa1.5                  ap = AudioPresenter.getAudioPresenter();
//2002/07/25 DoJa1.5                  MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
//2002/07/25 DoJa1.5                  ms.use();
//2002/07/25 DoJa1.5                  ap.setSound(ms);
//2002/07/25 DoJa1.5                  int atime = 90000;
//2002/07/25 DoJa1.5                  ap.play(atime);
//2002/07/25 DoJa1.5                  resultBox.setText("OK");
//2002/07/25 DoJa1.5              }catch(Exception e){
//2002/07/25 DoJa1.5                  resultBox.setText("NG:" +e.toString());
//2002/07/25 DoJa1.5              }
//2002/07/25 DoJa1.5              break;
                
//2002/07/25 DoJa1.5          //J011_1105_0114
//2002/07/25 DoJa1.5          case 14:
//2002/07/25 DoJa1.5              try{
//2002/07/25 DoJa1.5                  ap = AudioPresenter.getAudioPresenter();
//2002/07/25 DoJa1.5                  MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
//2002/07/25 DoJa1.5                  ms.use();
//2002/07/25 DoJa1.5                  ap.play(80000);
//2002/07/25 DoJa1.5                  ap.setMediaListener(this);
//2002/07/25 DoJa1.5              }catch(Exception anException){
//2002/07/25 DoJa1.5                  resultBox.setText("NG : " +anException.toString());
//2002/07/25 DoJa1.5              }
//2002/07/25 DoJa1.5              break;
                
            //J011_1105_0115
//2002/07/25 DoJa1.5            case 15:
	    case 8:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.play();
                    resultBox.setText("OK");
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
                
            //J011_1105_0116
//2002/07/25 DoJa1.5            case 16:
            case 9:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.play();
                    resultBox.setText("OK");
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
                
            //J011_1105_0117
//2002/07/25 DoJa1.5            case 17:
            case 10:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.play();
                    ap.setMediaListener(this);
                }catch(Exception anException){
                    resultBox.setText("NG : "+anException.toString());
                }
                break;
                
            //J011_1105_0118
//2002/07/25 DoJa1.5            case 18:
            case 11:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.stop();
                }catch(Exception anException){
                    resultBox.setText("NG : " +anException.toString());
                }
                break;
                
            //J011_1105_0119
//2002/07/25 DoJa1.5            case 19:
            case 12:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.play();
                }catch(Exception anException){
                    resultBox.setText("NG : " +anException.toString());
                }
                break;
                
            //J011_1105_0120
//2002/07/25 DoJa1.5            case 20:
            case 13:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.play();
                    ap.setMediaListener(this);
                }catch(Exception anException){
                    resultBox.setText("NG : " +anException.toString());
                }
                break;
                
            //J011_1105_0121
//2002/07/25 DoJa1.5            case 21:
            case 14:
                try{
                    ap = AudioPresenter.getAudioPresenter();
                    MediaSound ms = MediaManager.getSound("resource:///MFi-norm.mld");
                    ms.use();
                    ap.setSound(ms);
                    ap.stop();
                }catch(Exception e){
                    resultBox.setText("NG:" +e.toString());
                }
                break;
                
            default:
                break;
        }
    }
    
    /** 
     * processing  for adding the event
     */
    public void mediaAction(MediaPresenter source,int aType,int aParam){
        if( aType == AudioPresenter.AUDIO_PLAYING ) {
            resultBox.setText("OK : AUDIO_PLAYING");
        }else if(aType == AudioPresenter.AUDIO_COMPLETE){
            resultBox.setText("OK : AUDIO_COMPLETE");
//2002/08/01 DoJa1.5        }else if(aType == AudioPresenter.AUDIO_PAUSED){
//2002/08/01 DoJa1.5            resultBox.setText("OK : AUDIO_PAUSED");
//2002/08/01 DoJa1.5        }else if(aType == AudioPresenter.AUDIO_RESTARTED){
//2002/08/01 DoJa1.5            resultBox.setText("OK : AUDIO_RESTARTED");
        }else{
            
        }
    }
}