/**
 * J011_1203_0301
 * 
 * 
 *
 * Button class action check(normal route)
 *
 * $Id: J011_1203_0301.java,v 1.1 2001/11/30 01:30:33 ohkoshi Exp $
 */
import com.nttdocomo.ui.*;

/**
 * Button class action check main class
 * @extends IApplication
 */
public class J011_1203_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    Button  button = new Button("display");
    Label   classLabel = new Label("Button");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    String[] menuListItem = {
        "alphabetic characters",
//2002/07/30 Doja1.5        "",
//2002/07/30 Doja1.5        "",
        "pictographic characters",
        "mixed characters"
    };

    /**
     * Constructor of MainPanel class
     */
    MainPanel(){
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aComponent == button) {
            switch(menuList.getSelectedIndex()){
                /* create NextPanel1 class */
                case 0:
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                /* create NextPanel2 class */
//2002/07/30 Doja1.5                case 1:
//2002/07/30 Doja1.5                    Display.setCurrent(new NextPanel2((Frame) this));
//2002/07/30 Doja1.5                    break;
                /* create NextPanel3 class */
//2002/07/30 Doja1.5                case 2:
//2002/07/30 Doja1.5                    Display.setCurrent(new NextPanel3((Frame) this));
//2002/07/30 Doja1.5                    break;
                /* create NextPanel4 class */
                case 1:
//2002/07/30 Doja1.5                case 3:
                    Display.setCurrent(new NextPanel4((Frame) this));
                    break;
                /* create NextPanel5 class */
                case 2:
//2002/07/30 Doja1.5                case 4:
                    Display.setCurrent(new NextPanel5((Frame) this));
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * button creation check class1
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel;

    /**
     * constructer of NextPanel1 class
     * @param aFrame the object of MainPanel
     */
    NextPanel1(Frame aFrame){

        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("alphabetic character button");
        testButton1 = new Button();
//J011_1203_0301
        testButton2 = new Button(" abcde ");

        /* adding each component on the display */
        add(buttonLabel);
        add(testButton1);
        add(testButton2);

//J011_1205_0301
        testButton1.setLabel(" abcde ");

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * button creation check class2
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel2 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel;

    /**
     * the constructor of NextPanel2 class
     * @param aFrame the object of MainPanel
     */
    NextPanel2(Frame aFrame){

        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("Japanese two bytes character button");
        testButton1 = new Button();
//J011_1203_0302
        testButton2 = new Button("button");

        /* adding each component on the display */
        add(buttonLabel);
        add(testButton1);
        add(testButton2);

//J011_1205_0302
        testButton1.setLabel("button");

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * button creation check class3
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel3 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel;

    /**
     * the constructor of NextPanel3 class
     * @param aFrame the object of MainPanel
     */
    NextPanel3(Frame aFrame){

        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("one byte character button");
        testButton1 = new Button();
//J011_1203_0303
        testButton2 = new Button("button");
        /* adding each component on the display */
        add(buttonLabel);
        add(testButton1);
        add(testButton2);

//J011_1205_0303
        testButton1.setLabel("button");

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * button creation check class4
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel4 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel;
// 2002/07/30 Doja1.5
//    byte[] emj = { (byte)0xF8,(byte)0x9F,(byte)0xF8,(byte)0xA0,(byte)0xF8,(byte)0xA1,(byte)0xF8,(byte)0xA2,(byte)0xF8,(byte)0xA3};
    char[] emj = { 0xE63E, 0xE63F, 0xE640, 0xE641, 0xE642 };

    /**
     * the constructor of NextPanel4 class
     * @param aFrame the object of MainPanel
     */
    NextPanel4(Frame aFrame){

        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("pictographic character button");
        String emoji = new String(emj);
        testButton1 = new Button();
//J011_1203_0304
        testButton2 = new Button(emoji);


        /* adding each component on the display */
        add(buttonLabel);
        add(testButton1);
        add(testButton2);

//J011_1205_0304
        testButton1.setLabel(emoji);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * button creation check class5
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel5 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel;
// 2002/07/30 Doja1.5
//    byte[] emj ={ (byte)0xF8,(byte)0x9F,(byte)0xF8,(byte)0xA0,(byte)0xF8,(byte)0xA1,(byte)0xF8,(byte)0xA2,(byte)0xF8,(byte)0xA3};
    char[] emj = { 0xE63E, 0xE63F, 0xE640, 0xE641, 0xE642 };

    /**
     * the constructor of NextPanel5 class
     * @param aFrame the object of MainPanel
     */
    NextPanel5(Frame aFrame){

        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("mixed character button");
        String emoji=new String(emj);
        testButton1 = new Button();
//J011_1203_0305
        testButton2 = new Button(emoji+"abcButton ");
// 2002/07/30 Doja1.5        testButton2 = new Button(emoji+" ");

        /* adding each component on the display */
        add(buttonLabel);
        add(testButton1);
        add(testButton2);

//J011_1205_0305
        testButton1.setLabel(emoji+"abcButton ");
// 2002/07/30 Doja1.5        testButton1.setLabel(emoji+" ");

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}
