/**
 * J011_1205_0101
 * 
 * 
 *
 * Button class action check(normal route)
 *
 * $Id: J011_1205_0101.java,v 1.1 2001/11/30 01:30:33 ohkoshi Exp $
 */
import com.nttdocomo.ui.*;

/**
 * Button class action check main class
 * @extends IApplication
 */
public class J011_1205_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    Button  button = new Button("display");
    Label   classLabel = new Label("Button");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    String[] menuListItem = {
        "test 1",
        "test 2",
        "test 3",
        "test 4"
    };

    /**
     * Constructor of MainPanel class
     */
    MainPanel(){
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aComponent == button) {
            switch(menuList.getSelectedIndex()){
                /* create NextPanel1 class */
                case 0:
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                /* create NextPanel2 class */
                case 1:
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                /* create NextPanel3 class */
                case 2:
                    Display.setCurrent(new NextPanel3((Frame) this));
                    break;
                /* create NextPanel4 class */
                case 3:
                    Display.setCurrent(new NextPanel4((Frame) this));
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * button creation check class1
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2,testButton3;
    Label buttonLabel;

    /**
     * constructer of NextPanel1 class
     * @param aFrame the object of MainPanel
     */
    NextPanel1(Frame aFrame){

        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("focus on the button 2");
        testButton1 = new Button("button 1");
        testButton2 = new Button("button 2");
        testButton3 = new Button("button 3");

        /* adding each component on the display */
        add(buttonLabel);
        add(testButton1);
        add(testButton2);
//J011_1205_0101
        testButton2.requestFocus();             
        add(testButton3);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * button creation check class2
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel2 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2,testButton3;
    Label buttonLabel;

    /**
     * the constructor of NextPanel2 class
     * @param aFrame the object of MainPanel
     */
    NextPanel2(Frame aFrame){

        previousFrame = aFrame;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("focus on the button 1");
        testButton1 = new Button("button 1");
        testButton2 = new Button("button 2");
        testButton3 = new Button("button 3");

        /* adding each component on the display */
        add(buttonLabel);
        add(testButton1);
//J011_1205_0102
        testButton2.requestFocus();
        add(testButton2);
        add(testButton3);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * button creation check class3
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel3 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel;

    /**
     * the constructor of NextPanel3 class
     * @param aFrame the object of MainPanel
     */
    NextPanel3(Frame aFrame){

        previousFrame = aFrame;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel = new Label("the same button");
        testButton1 = new Button();
        testButton2 = new Button("label");

        /* adding each component on the display */
        add(testButton1);
//J011_1205_0103
        testButton1.setLabel("label");
        add(testButton2);
        add(buttonLabel);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * button creation check class4
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel4 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Button testButton1,testButton2;
    Label buttonLabel1,buttonLabel2,label;

    /**
     * the constructor of NextPanel4 class
     * @param aFrame the object of MainPanel
     */
    NextPanel4(Frame aFrame){

        previousFrame = aFrame;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        buttonLabel1 = new Label("null character button 1");
        buttonLabel2 = new Label("null character button 2");
        label = new Label("Button 1 and button 2 is the same.");
        testButton1 = new Button();
        testButton2 = new Button("label");

        /* adding each component on the display */
        add(buttonLabel1);
        add(testButton1);
        add(buttonLabel2);
        add(testButton2);
//J011_1205_0104
        testButton2.setLabel(null);
        add(label);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}
