/**
 * J011_1205_0201
 * 
 * 
 *
 * Button class action check(normal route)
 *
 * $Id: J011_1205_0201.java,v 1.1 2001/11/30 01:30:33 ohkoshi Exp $
 */

import com.nttdocomo.ui.*;
/**
 * Button class action check main class
 * @extends IApplication
 */
public class J011_1205_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    Button  button1,button2,button3,testButton1,testButton2;
    Label   buttonLabel1,buttonLabel2;


    /**
     * Constructor of MainPanel class
     */
    MainPanel(){
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        button1 = new Button("button 1");
        button2 = new Button("button 2");
        button3 = new Button("button 3");
        testButton1 = new Button("operational");
        testButton2 = new Button("no-operation");

        /* adding each component on the display */
        add(button1);
        add(button2);
        add(button3);
        add(testButton1);
        add(testButton2);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        /* user can use the button when the operable-button is pushed*/
        if (aComponent == testButton1) {
//J011_1205_0201
            button1.setEnabled(true);
            button2.setEnabled(true);
            button3.setEnabled(true);
        }
        /* user cannot use the button when the unoperable-button is pushed*/
        else if(aComponent == testButton2){
//J011_1205_0202
            button1.setEnabled(false);
            button2.setEnabled(false);
            button3.setEnabled(false);
        }
        /* do nothing when button1,button2,button3 is pushed*/
        else{}
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

