/**
 * J011_1207_0101
 *
 *
 *
 * Button class action check(normal route)
 *
 * $Id: J011_1207_0101.java,v 1.1 2001/11/30 01:30:34 ohkoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Button class action check main class
 * @extends IApplication
 */

public class J011_1207_0101 extends IApplication {
    
    /**
    * starting method for I-appli
    */

    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */

class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "01 No addition exists, location settable",
            "02 Some additions exist, updating permitted",
            "03 No addition exists, updating not permitted",
            "04 Some additions exist, updating not permitted"
    };
    private Button button = new Button("execute");

    /**
    * Constructor of MainPanel class
    */
    public MainPanel() {

        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
    * display the main panel
    */
    public void showMainPanel() {

        /* setting of the display item */
        setTitle("API class normal route");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    /* create NextPanel2 */
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                case 2:
                    /* create NextPanel3 */
                    NextPanel3 np3 = new NextPanel3((Frame) this);
                    Display.setCurrent(np3);
                    np3.setPanel();
                    break;
                case 3:
                    /* create NextPanel4 */
                    Display.setCurrent(new NextPanel4((Frame) this));
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Button check class1
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener {

    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("", 16, 1, TextBox.DISPLAY_ANY);
    

    /**
     * constructer of NextPanel1 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel1 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setLayoutManager(null);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        
        /* Button position setting */
//J011_1207_0101
        button1.setLocation(15,10);
        add(button1);
        textBox.setLocation(5,60);

        /* the position information display */
//J011_1207_0122,J011_1207_0123
        textBox.setText("X="+button1.getX()+", Y="+button1.getY());
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);

    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Button check class2
 * @extends Panel
 * @implements SoftKeyListener,ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1;
    private Button button = new Button("execute");
    private TextBox textBox = new TextBox("", 16, 1, TextBox.DISPLAY_ANY);

    /**
     * the constructor of NextPanel2 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel2 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setLayoutManager(null);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
        button.setLocation(5,60);
        add(button);
        textBox.setLocation(5,75);
        textBox.setText("X="+button1.getX()+", Y="+button1.getY());
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
            /* setting the Button position */
//J011_1207_0102
            button1.setLocation(5,10);
            /* Button position display */
            textBox.setText("X="+button1.getX()+", Y="+button1.getY());
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Button check class3
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel3 extends Panel implements SoftKeyListener {
    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("", 16, 1, TextBox.DISPLAY_ANY);

    /**
     * the constructor of NextPanel3 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel3 ( Frame aPrev ) {
        previousFrame = aPrev;
    }

    /**
    * the display item setting of NextPanel3
    */
    public void setPanel () {
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
    
        /* Button position setting */
//J011_1207_0103
        button1.setLocation(50,30);
        add(button1);

        /* Button position display */
        textBox.setText("X="+button1.getX()+", Y="+button1.getY());
        add(textBox);


        /* setting the listener */
        setSoftKeyListener(this);

    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Button check class4
 * @extends Panel
 * @implements SoftKeyListener,ComponentListener
 */
class NextPanel4 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1;
    private Button button = new Button("execute");
    private TextBox textBox = new TextBox("press the execution button!", 16, 1, TextBox.DISPLAY_ANY);

    /**
     * the constructor of NextPanel4 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel4 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
        add(button);
        add(textBox);


        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {

            /* Button position setting */
//J011_1207_0104
            button1.setLocation(5,10);
            /* Button position display */
            textBox.setText("X="+button1.getX()+", Y="+button1.getY());
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

