/**
 * J011_1207_0105
 *
 *
 *
 * Button class action check(normal route)
 *
 * $Id: J011_1207_0105.java,v 1.1 2001/11/30 01:30:34 ohkoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Button class action check main class
 * @extends IApplication
 */

public class J011_1207_0105 extends IApplication {
    
    /**
    * starting method for I-appli
    */

    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */

class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "01 No addition exists, set size of the component",
            "02 Some additions exist, updating permitted",
            "03 illegal value"
    };
    private Button button = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        /* setting of the display item */
        setTitle("API class normal route");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* create NextPanel */
        if( aComponent == button ){
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* create NextPanel1 class */
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    /* create NextPanel2 class */
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
               case 2:
                    /* create NextPanel3 class */
                    Display.setCurrent(new NextPanel3((Frame) this));
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * NextPanel1 class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener {
    
    private Frame previousFrame = null;
    private Button button1,button2;
    private TextBox textBox = new TextBox("", 16, 1, TextBox.DISPLAY_ANY);

    /**
     * constructer of NextPanel1 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel1 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setLayoutManager(null);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        button2 = new Button("button");

//J011_1207_0105
        button1.setSize(60,30);
        add(button1);
        add(button2);
        button2.setLocation(61,0);
        textBox.setLocation(5,60);
//J011_1207_0124
//J011_1207_0125
        textBox.setText("width ="+button1.getWidth()+",height ="+button1.getHeight());
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);

    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel2 class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel2 extends Panel implements SoftKeyListener,ComponentListener {
    
    private Frame previousFrame = null;
    private Button button1;
    private String picture = "";
    private TextBox textBox = new TextBox("", 16, 1, TextBox.DISPLAY_ANY);
    private Button button = new Button("execute");

    /**
     * the constructor of NextPanel2 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel2 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setLayoutManager(null);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        button1.setSize(60,30);
        add(button1);
        button1.setLocation(0,0);
        button.setLocation(5,50);
        add(button);
        textBox.setLocation(5,65);
        textBox.setText("width ="+button1.getWidth()+",height ="+button1.getHeight());
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
//J011_1207_0106
            button1.setSize(70,40);
            textBox.setText("width ="+button1.getWidth()+",height ="+button1.getHeight());
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel3 class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel3 extends Panel implements SoftKeyListener,ComponentListener {
    
    private Frame previousFrame = null;
    private Button button1;
    private Button button = new Button("execute");
    private Component component;
    private TextBox textBox = new TextBox("press the execution button!", 20, 4, TextBox.DISPLAY_ANY);
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "0 illegal width",
            "1 illegal height",
            "2 illegal width and height"
    };

    /**
     * the constructor of NextPanel3 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel3 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        menuList.setItems(menuListItem);
        add(menuList);
        add(button);

        button1 = new Button("button");
        add(button1);
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == menuList ) {
            textBox.setText("press the execution button!");
        }

        if ( aComponent == button ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    try{
                        /* An exception is detected. */
                        aComponent.setSize(-1,20);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1207_0107
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
                case 1:
                    try{
                        /* An exception is detected. */
                        aComponent.setSize(50,-1);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1207_0108
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
                case 2:
                    try{
                        /* An exception is detected. */
                        aComponent.setSize(-1,-1);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1207_0109
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}
