/**
 * J011_1207_0113
 *
 *
 *
 * Button class action check(normal route)
 *
 * $Id: J011_1207_0113.java,v 1.1 2001/11/30 01:30:34 ohkoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Button class action check main class
 * @extends IApplication
 */

public class J011_1207_0113 extends IApplication {
    
    /**
    * starting method for I-appli
    */

    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */

class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "test 1",
            "test 2",
            "test 3"
    };
    private Button button = new Button("execute");

    /**
    * Constructor of MainPanel class
    */
    public MainPanel() {

        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
    * display the main panel
    */
    public void showMainPanel() {

        /* setting of the display item */
        setTitle("API class normal route");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* create NextPanel */
        if( aComponent == button ){
            switch(menuList.getSelectedIndex()){
                case 0:
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                case 2:
                    Display.setCurrent(new NextPanel3((Frame) this));
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * NextPanel1 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel1 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("", 16, 3, TextBox.DISPLAY_ANY);
    private Button button = new Button("execute");
    private int count=0;

    /**
     * constructer of NextPanel1 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel1 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
//J011_1207_0113
        button1.setForeground(ColorBox.colors[count]);
        add(button1);
        add(button);
        textBox.setText("The foreground color of the button is displayed" + ColorBox.names[count] + "as a default.");
        count++;
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
            button1.setForeground(ColorBox.colors[count]);
            textBox.setText("The foreground color of the button is" + ColorBox.names[count] + "as a default.");
            count++;
            if ( count > 15 ) {
                count = 0;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel2 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("", 16, 3, TextBox.DISPLAY_ANY);
    private Button button = new Button("execute");
    private int count=5;

    /**
     * the constructor of NextPanel2 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel2 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
//J011_1207_0114
        button1.setForeground(ColorBox.colors[count]);
        add(button);
        textBox.setText("The foreground color of the button is displayed" + ColorBox.names[count] + "as a default.");
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
            button1.setForeground(ColorBox.colors[count]);
            textBox.setText("The foreground color of the button is" + ColorBox.names[count] + "as a default.");
            count++;
            if ( count > 15 ) {
                count = 0;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel3 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel3 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("press the execution button!", 16, 3, TextBox.DISPLAY_ANY);
    private Button button = new Button("execute");
    private int count=0;

    /**
     * the constructor of NextPanel3 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel3 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
        add(button);
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
            try {
                /* An exception is detected. */
                button1.setForeground(-1);
            /* exception processing */
            }catch (IllegalArgumentException e) { 
//J011_1207_0115
                textBox.setText("IllegalArgumentException:"+e.getMessage());
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Button class action check and color setting
 */
class ColorBox {
    static int[] colors = {
        Graphics.getColorOfName(Graphics.BLACK),
        Graphics.getColorOfName(Graphics.BLUE),
        Graphics.getColorOfName(Graphics.LIME),
        Graphics.getColorOfName(Graphics.AQUA),
        Graphics.getColorOfName(Graphics.RED),
        Graphics.getColorOfName(Graphics.FUCHSIA),
        Graphics.getColorOfName(Graphics.YELLOW),
        Graphics.getColorOfName(Graphics.WHITE),
        Graphics.getColorOfName(Graphics.GRAY),
        Graphics.getColorOfName(Graphics.NAVY),
        Graphics.getColorOfName(Graphics.GREEN),
        Graphics.getColorOfName(Graphics.TEAL),
        Graphics.getColorOfName(Graphics.MAROON),
        Graphics.getColorOfName(Graphics.PURPLE),
        Graphics.getColorOfName(Graphics.OLIVE),
        Graphics.getColorOfName(Graphics.SILVER),
    };
    static String[] names = {
    "BLACK",
    "BLUE",
    "LIME",
    "AQUA",
    "RED",
    "FUCHSIA",
    "YELLOW",
    "WHITE",
    "GRAY",
    "NAVY",
    "GREEN",
    "TEAL",
    "MAROON",
    "PURPLE",
    "OLIVE",
    "SILVER",
    };
}

