/**
 * J011_1207_0116
 *
 *
 *
 * Button class action check(normal route)
 *
 * $Id: J011_1207_0116.java,v 1.1 2001/11/30 01:30:35 ohkoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Button class action check main class
 * @extends IApplication
 */

public class J011_1207_0116 extends IApplication {
    
    /**
    * starting method for I-appli
    */

    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */

class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "01 no additions, visible",
            "02 no additions, not visible",
            "03 additions exist, make it visible",
            "04 additions exist, make it invisible",
            "05 when the component is invisible, move the cursor",
            "06 when the component is regenerated, move the cursor"
    };
    private Button button = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {

        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        /* setting of the display item */
        setTitle("API class normal route");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* create NextPanel */
        if( aComponent == button ){
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    /* create NextPanel2 */
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                case 2:
                    /* create NextPanel3 */
                    Display.setCurrent(new NextPanel3((Frame) this));
                    break;
                case 3:
                    /* create NextPanel4 */
                    Display.setCurrent(new NextPanel4((Frame) this));
                    break;
                case 4:
                    /* create NextPanel5 */
                    Display.setCurrent(new NextPanel5((Frame) this));
                    break;
                case 5:
                    /* create NextPanel6 */
                    Display.setCurrent(new NextPanel6((Frame) this));
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * NextPanel1 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel1 extends Panel implements SoftKeyListener {
    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("", 16, 3, TextBox.DISPLAY_ANY);
    private boolean flag = true;

    /**
     * constructer of NextPanel1 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel1 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
//J011_1207_0116
        button1.setVisible(flag);
        add(button1);
        textBox.setText("The button is displayed.");
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel2 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener {
    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("", 16, 3, TextBox.DISPLAY_ANY);
    private boolean flag = false;

    /**
     * the constructor of NextPanel2 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel2 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
//J011_1207_0117
        button1.setVisible(flag);
        add(button1);
        textBox.setText("The button is not displayed.");
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel3 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel3 extends Panel implements SoftKeyListener,ComponentListener {
    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("Press the button.", 16, 3, TextBox.DISPLAY_ANY);
    private boolean flag = true;

    /**
     * the constructor of NextPanel3 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel3 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button1 ) {
//J011_1207_0118
            button1.setVisible(flag);
            textBox.setText("The button is displayed.");
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel4 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel4 extends Panel implements SoftKeyListener,ComponentListener {
    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("press the execution button!", 16, 3, TextBox.DISPLAY_ANY);
    private boolean flag = false;
    private Button button = new Button("execute");

    /**
     * the constructor of NextPanel4 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel4 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
        add(button);
        button.requestFocus();
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
//J011_1207_0119
            button1.setVisible(flag);
            textBox.setText("The button is not displayed.");
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel5 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel5 extends Panel implements SoftKeyListener,ComponentListener {
    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("Press the button.", 16, 4, TextBox.DISPLAY_ANY);
    private boolean flag = false;
    private String picture = "";

    /**
     * the constructor of NextPanel5 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel5 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button1 ) {
//J011_1207_0120
            button1.setVisible(flag);
            textBox.setText("The button is not displayed, and a blank that is the size of the button exists.");
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * NextPanel6 class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel6 extends Panel implements SoftKeyListener,ComponentListener {
    private Frame previousFrame = null;
    private Button button1;
    private TextBox textBox = new TextBox("Press the button.", 16, 4, TextBox.DISPLAY_ANY);
    private boolean flag;
    private Dialog dialog = new Dialog(Dialog.DIALOG_INFO, "visible state");

    /**
     * the constructor of NextPanel6 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel6 ( Frame aPrev ) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        button1 = new Button("button");
        add(button1);
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button1 ) {
            flag = false;
            button1.setVisible(flag);
            dialog.setText("The button is not displayed, and a blank that is the size of the button exists.");
            dialog.show();
            textBox.setText("The button is displayed again.");
            try {
                Thread.sleep(3000);
                flag = true;
//J011_1207_0121
                button1.setVisible(flag);
                textBox.setText("The button is displayed.");
            } catch(Exception e){
                Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
                errDialog.setText("Error:" + e.toString());
                errDialog.show();
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int index) {}

    /**
     * terminate the application when the softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int index) {
        if (index == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (index == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}
