/**
 * J011_1303_0101
 *
 * MainPanel
 * MainCanvas
 *
 * Canvas class action check (normal route)
 *
 * $ID:$
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Canvas class action check main class
 * @extends IApplication
 */
public class J011_1303_0101 extends IApplication{
    public void start(){
        /**
         *starting method for I-appli
         */
        Display.setCurrent(new MainPanel());
    }
}

/**
 * MainPanel class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener*
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    String[] menuListItem = {
        "0 test 1",
        "1 test 2",
        "2 test 3",
        "3 test 4",
        "4 test 5",
        "5 test 6"
    };
    
    Label classLabel = new Label("Canvas");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button Button1 = new Button("execute");
    Graphics g ;
    
    /**
     * Constructor of MainPanel class
     */
    public MainPanel(){
        try{
            /* display of the main panel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
        }
    }
    
    /**
     * display main screen
     */
    void showMainPanel(){
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        
        /* add on each component */
        add(classLabel);
        add(menuList);
        add(Button1);
        
        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex){}
    
    /**
     * define the action when softkey is released
     */
    public void softKeyReleased(int anIndex){
        IApplication.getCurrentApp().terminate();
    }
    
    public void componentAction(Component aComponent,int aType,int aParam){
        /* processing when the list choice is changed */
        if(aComponent == menuList && aType == ComponentListener.SELECTION_CHANGED){
            
        }
        
        /* processing when the execution button is pushed */
        if(aComponent == Button1 && aType == ComponentListener.BUTTON_PRESSED){
            Display.setCurrent(new MainCanvas(this, menuList.getSelectedIndex()));
        }
    }
}

/*
 * screen of MainCanvas class
 * @extends Canvas
 */
class MainCanvas extends Canvas{
    Frame previous;
    int flag;
    boolean boolean1 = false;
    Graphics g1;
    String s = "press the execution button";
    String st = "press the number button";

    /**
     * create the constructor
     */
    public MainCanvas(Frame prevFrame,int aFlag){
        previous = prevFrame;
        flag = aFlag;
        setSoftLabel(Canvas.SOFT_KEY_1,"back");
        setSoftLabel(Canvas.SOFT_KEY_2,"execute");
    }
    
    //J011_1303_0105
    public void processEvent(int type,int param){
        /* key event */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* processing when the return key is pushed */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previous);
                    break;
        
                /* processing when the excecution key is pushed */
                case Display.KEY_SOFT2:
                    if (flag == 3) {
                        repaint();
                    } else if (flag == 4) {
//2002/08/16 DoJa1.5                        repaint(35, 0,100, 50);
						// 2003/04/01 ->
                        //repaint(35, 0,170, 50);
						repaint(20, 0,130, 50);
						// 2003/04/01 <-
                    } else if(flag == 5){}
                    break;
            }
        } else if (type == Display.KEY_PRESSED_EVENT) {
            //J011_1303_0106
            if (Display.KEY_0 <= param && param <= Display.KEY_9 && flag == 5) {
                int state = getKeypadState();
                st = "";
                for (int i=0; i<10; i++) {
                    if ((state & 1) == 1) {
                        st += String.valueOf(i);
                    }
                        state = state >> 1;
                }
                repaint();
            }
        }
    }

    /**
     * implementation of paint() method
     */
    public void paint(Graphics g){
        switch(flag){
            //J011_1303_0101
            case 0:
                g.drawString("Canvas",10,20);
                break;
            
            //J011_1305_0101
            case 1:
                g1 = getGraphics();
                g1.drawString("     If displayed, OK",10,20);
                break;

            //J011_1305_0102
            case 2:
                g.drawString("     If displayed, OK",10,20);
                break;
            
            //J011_1305_0103
            case 3:
                g.clearRect(0, 0, getWidth(), getHeight());
                g.drawString(s, 10, 20);
                s = "     If displayed, OK";
                break;
            
            //J011_1305_0104
            case 4:
                g.clearRect(0, 0, getWidth(), getHeight());
                g.drawString(s, 10,20);
                s = "     If displayed, OK";
                break;
            
            //J011_1305_0106
            case 5:
                g.clearRect(0, 0, getWidth(), getHeight());
                g.drawString(st, 10,20);
                break;
            
            default:
                break;
        }
    }
}