/**
 * J011_1401_0301
 *
 *
 *
 * Component class action check(normal  route)
 *
 * $Id: J011_1401_0301.java,v 1.1 2001/12/02 08:05:00 yaeda Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Component class action check main class
 * @extends IApplication
 */
public class J011_1401_0301 extends IApplication {
    
    /**
     * starting method for I-appli
     */
    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Component class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "1 test 1",
            "2 test 2",
            "3 test 3",
            "4 test 4",
            "5 test 5",
    };
    private Button button1;

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        /* setting of the display item */
        setTitle("API class normal route");
        menuList.setItems(menuListItem);
        add(menuList);

        button1 = new Button("execute");
        add(button1);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button1 ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    /* create NextPanel2 */
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                case 2:
                    /* create NextPanel3 */
                    Display.setCurrent(new NextPanel3((Frame) this));
                    break;
                case 3:
                    /* create NextPanel4 */
                    Display.setCurrent(new NextPanel4((Frame) this));
                    break;
                case 4:
                    /* create NextPanel5 */
                    Display.setCurrent(new NextPanel5((Frame) this));
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel1 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1,button2,button3;
    private TextBox textBox = new TextBox("", 16, 3, TextBox.DISPLAY_ANY);
    private Component component;
    private boolean flag = true;
    
    /**
     * the constructor of NextPanel1
     * @param aPrev the object of MainPanel
     */
    public NextPanel1(Frame aPrev) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        button1 = new Button("button 1");
        add(button1);
        component = button1;
        button2 = new Button("visible");
        add(button2);
        button3 = new Button("not visible");
        add(button3);
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }
    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button2 ) {
            flag = true;
//J011_1405_0202
            component.setVisible(flag);
            textBox.setText("The button is visible.");
        }

        if ( aComponent == button3 ) {
            flag = false;
//J011_1403_0101,J011_1405_0201
            component.setVisible(flag);
            textBox.setText("The button is not visible.");
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate when softkey1,2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Component class action check sub screen2
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1,button2;
    private Component component;
    private int count = 0;
    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);

    /**
     * the constructor of NextPanel2
     * @param aPrev the object of MainPanel
     */
    public NextPanel2(Frame aPrev) {
        previousFrame = aPrev;
    
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        button1 = new Button("The button for confirmation");
        add(button1);
        component = button1;
        button2 = new Button("change the background color");
        add(button2);
        add(textBox);


        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button2 ) {
//J011_1405_0203
            component.setBackground(ColorBox.colors[count]);
            textBox.setText("The background color of the button is" + ColorBox.names[count] + "as a default.");
            count++;
            if ( count > 15 ) {
                count = 0;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate when softkey1,2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel3 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1,button2;
    private Component component;
    private int count = 0;
    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);


    /**
     * the constructor of NextPanel3
     * @param aPrev the object of MainPanel
     */
    public NextPanel3(Frame aPrev) {
        previousFrame = aPrev;
    
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        button1 = new Button("The button for confirmation");
        add(button1);
        component = button1;
        button2 = new Button("change the foreground color");
        add(button2);
        add(textBox);


        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button2 ) {
//J011_1405_0204
            component.setForeground(ColorBox.colors[count]);
            textBox.setText("The characters and the frame of the button is displayed" + ColorBox.names[count] + "as a default.");
            count++;
            if ( count > 15 ) {
                count = 0;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate when softkey1,2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel4 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1;
    private Component component;
    private int count = 0;
    private TextBox textBox = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    private Label label;
	// 2003/03/26 ->
	private TextBox textBox2 = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
	// 2003/03/26 <-

    /**
     * the constructor of NextPanel4 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel4(Frame aPrev) {
        previousFrame = aPrev;
    
        /* setting of the display item */
        setLayoutManager(null);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        button1 = new Button("check the coordinate");
        add(button1);
        textBox.setLocation(0,15);
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
        buttonInfomation();

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button1 ) {
//J011_1405_0103
//J011_1405_0104
            textBox.setText("X="+component.getX()+". Y="+component.getY());
        }
    }

    /**
     * setting of the coordinates  of the component
     */
    public void buttonInfomation(){
		// 2003/03/26 ->
        //label = new Label("coordinate of the Label(X=5,Y=50)");
        //add(label);
        //component = label;
		textBox2.setText("coordinate of the Label(X=5,Y=50)");
		textBox2.setEnabled(false);
		add(textBox2);
		component = textBox2;
		// 2003/03/26 <-
//J011_1405_0101
        component.setLocation(5,50);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate when softkey1,2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel5 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button1,button2,button3;
    private Component component;
    private int count = 1;
    private TextBox textBox = new TextBox("", 16, 1, TextBox.DISPLAY_ANY);
    private Label label;


    /**
     * the constructor of NextPanel5 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel5(Frame aPrev) {
        previousFrame = aPrev;
    
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        button1 = new Button("The button for confirmation");
        add(button1);
        component = button1;
        add(textBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button1 ) {
//J011_1405_0102
            component.setSize(90,40);
//J011_1405_0105,J011_1405_0106
            textBox.setText("width =" + component.getWidth() + "height=" + component.getHeight());
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate when softkey1,2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Component class action check and color setting class
 */
class ColorBox {
    static int[] colors = {
        Graphics.getColorOfName(Graphics.BLACK),
        Graphics.getColorOfName(Graphics.BLUE),
        Graphics.getColorOfName(Graphics.LIME),
        Graphics.getColorOfName(Graphics.AQUA),
        Graphics.getColorOfName(Graphics.RED),
        Graphics.getColorOfName(Graphics.FUCHSIA),
        Graphics.getColorOfName(Graphics.YELLOW),
        Graphics.getColorOfName(Graphics.WHITE),
        Graphics.getColorOfName(Graphics.GRAY),
        Graphics.getColorOfName(Graphics.NAVY),
        Graphics.getColorOfName(Graphics.GREEN),
        Graphics.getColorOfName(Graphics.TEAL),
        Graphics.getColorOfName(Graphics.MAROON),
        Graphics.getColorOfName(Graphics.PURPLE),
        Graphics.getColorOfName(Graphics.OLIVE),
        Graphics.getColorOfName(Graphics.SILVER),
    };
    static String[] names = {
    " BLACK ",
    " BLUE ",
    " LIME ",
    " AQUA ",
    " RED ",
    " FUCHSIA ",
    " YELLOW ",
    " WHITE ",
    " GRAY ",
    " NAVY ",
    " GREEN ",
    " TEAL ",
    " MAROON ",
    " PURPLE ",
    " OLIVE ",
    " SILVER ",
    };
}