/**
 * J011_1406_0101
 *
 *
 *
 * Component class action check(normal  route)
 *
 * $Id: J011_1406_0101.java,v 1.1 2001/12/02 08:04:56 yaeda Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Component class action check main class
 * @extends IApplication
 */

public class J011_1406_0101 extends IApplication {
        
    /**
     * starting method for I-appli
     */
    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Component class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */

class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        
    private Button button1;
    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "0 setSize",
            "1 setBackground",
            "2 setForeground"
    };

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();

        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        /* setting of the display item */
        setTitle("API class normal route");
        menuList.setItems(menuListItem);
        add(menuList);
        button1 = new Button("execute");
        add(button1);

        add(textBox);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* clearing menu list */
        if ( aComponent == menuList ) {
            textBox.setText("");
        }

        /* input an illegal value to the background color of the component */
        if ( aComponent == button1 ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    try{
                        /* An exception is detected. */
                        aComponent.setBackground(-1);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1406_0104
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
                case 2:
                    try{
                        /* An exception is detected. */
                        aComponent.setForeground(-1);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1406_0105
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel1 extends Panel implements SoftKeyListener,ComponentListener {
    private Frame previousFrame = null;
    private Button button1 = new Button("execute");
    private Component component;
    private TextBox textBox = new TextBox("", 20, 4, TextBox.DISPLAY_ANY);
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] menuListItem = {
            "0 illegal width",
            "1 illegal height",
            "2 illegal width and height"
    };

    /**
     * constructer of NextPanel1 class
     * @param aPrev the object of MainPanel
     */
    public NextPanel1(Frame aPrev) {
        previousFrame = aPrev;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button1);
        add(textBox);
        

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* clearing menu list */
        if ( aComponent == menuList ) {
            textBox.setText("");
        }

        /* input an illegal value to the width of the component */
        if ( aComponent == button1 ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    try{
                        /* An exception is detected. */
                        aComponent.setSize(-1,20);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1406_0101
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
                case 1:
                    try{
                        /* An exception is detected. */
                        aComponent.setSize(50,-1);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1406_0102
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
                case 2:
                    try{
                        /* An exception is detected. */
                        aComponent.setSize(-1,-1);
                    /* exception processing */
                    } catch (IllegalArgumentException e) {
//J011_1406_0103
                        textBox.setText("IllegalArgumentException:"+e.getMessage());
                    }
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate when softkey1,2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}