/**
 * J011_1602_0201
 *
 *
 * Dialog class action check (normal route)
 * $Id: J011_1602_0201.java,v 1.1 2001/11/30 01:30:35 ohkoshi Exp $
 */
import com.nttdocomo.ui.*;

/**
 * Dialog class action check main class
 * @extends IApplication
 */
public  class J011_1602_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Dialog class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    Label classLabel = new Label("Dialog");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button button    = new Button("execute");
    String[] menuListItem = {
        "0 check definition of the constant ",
        "1 check behavior of the constructor"
    };

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /*
         * Constant member definition check
         * The following is confirming Constant member can't be set the value
         * Confirm the failure in building and delete to the end of the method
         */
/*
        Dialog.DIALOG_INFO             = 1;
        Dialog.DIALOG_WARNING          = 1;
        Dialog.DIALOG_ERROR            = 1;
        Dialog.DIALOG_YESNO            = 1;
        Dialog.DIALOG_YESNOCANCEL       = 1;
        Dialog.BUTTON_OK                = 1;
        Dialog.BUTTON_CANCEL            = 1;
        Dialog.BUTTON_YES               = 1;
        Dialog.BUTTON_NO                = 1;
*/

    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent,int aType,int aParam){

        /* when  the exsecution button is pushed */
        if(aComponent == button){
            switch(menuList.getSelectedIndex()){
                case 0:
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey){}

    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey){
        if(aSoftKey == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Class of display for confirming defined constant 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel1 extends Panel implements SoftKeyListener,ComponentListener{

    Frame previousFrame = null;
    Button button = new Button("execute");
    Label titleLabel = new Label("check definition of the constant ");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultText = new TextBox("",20,2,TextBox.DISPLAY_ANY);

    String[] menuListItem = {
        "0 DIALOG_INFO",
        "1 DIALOG_WARNING",
        "2 DIALOG_ERROR",
        "3 DIALOG_YESNO",
        "4 DIALOG_YESNOCANCEL",
        "5 BUTTON_OK",
        "6 BUTTON_CANCEL",
        "7 BUTTON_YES",
        "8 BUTTON_NO"
    };

    String[] exceptionItem = {
        "DIALOG_INFO",
        "DIALOG_WARNING",
        "DIALOG_ERROR",
        "DIALOG_YESNO",
        "DIALOG_YESNOCANCEL",
        "BUTTON_OK",
        "BUTTON_CANCEL",
        "BUTTON_YES",
        "BUTTON_NO"
    };

    /**
     * constructer of NextPanel1 class
     * @param aFrame the object of MainPanel
     */
    public NextPanel1(Frame aFrame) {

        /* setting the parameter field variable */
        previousFrame = aFrame;

        setSoftLabel(Frame.SOFT_KEY_1,"back");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(titleLabel);
        add(menuList);
        add(button);
        add(resultText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {

        /* return to the previous screen when softkey1 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == button) {
            resultText.setText(checkStaticValue(menuList.getSelectedIndex()));
        }
        /* clearing result in the textbox when the menu list is chosen*/
        else if(aComponent == menuList) {
            resultText.setText("");
        }
    }

    /**
     * get the event on a component
     * @param anIndex The index number which is selected in listbox
     * @return 
     */
    String checkStaticValue(int anIndex) {

        String resultStr = "";

        /* checking whether Exception which is selected is as a default  */
        switch (anIndex) {
//J011_1602_0101
        case 0:
            resultStr = isOK(Dialog.DIALOG_INFO == 0);
            break;
//J011_1602_0102
        case 1:
            resultStr = isOK(Dialog.DIALOG_WARNING == 1);
            break;
//J011_1602_0103
        case 2:
            resultStr = isOK(Dialog.DIALOG_ERROR == 2);
            break;
//J011_1602_0104
        case 3:
            resultStr = isOK(Dialog.DIALOG_YESNO == 3);
            break;
//J011_1602_0105
        case 4:
            resultStr = isOK(Dialog.DIALOG_YESNOCANCEL == 4);
            break;
//J011_1602_0106
        case 5:
            resultStr = isOK(Dialog.BUTTON_OK == 0x0001);
            break;
//J011_1602_0107
        case 6:
            resultStr = isOK(Dialog.BUTTON_CANCEL == 0x0002);
            break;
//J011_1602_0108
        case 7:
            resultStr = isOK(Dialog.BUTTON_YES == 0x0004);
            break;
//J011_1602_0109
        case 8:
            resultStr = isOK(Dialog.BUTTON_NO == 0x0008);
            break;
        }

        /* When a judgment result is NG, an actual value is set as NG addition information */
        if (resultStr.equals("NG")) {
            resultStr += "\n" + exceptionItem[anIndex];
        }
        return resultStr;
    }
    /**
     * The justification of a constant definition is judged and the character sequence OK/NG is returned.
     * @param aResult Constant definition judging
     * @return Judging result ("OK" or "NG)
     */
    String isOK(boolean aResult) {
        return (aResult ? "OK" : "NG");
    }
}

/**
 * Constructor operation check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener, ComponentListener {
    Frame previousFrame = null;
    Button button = new Button("execute");
    Label titleLabel = new Label("check behavior of the constructor");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    String[] menuListItem = {
        "0 DIALOG_INFO",
        "1 DIALOG_WARNING",
        "2 DIALOG_ERROR",
        "3 DIALOG_YESNO",
        "4 DIALOG_YESNOCANCEL",
        "5 title null"
    };

    String[] title = {
        "DIALOG_INFO",
        "DIALOG_WARNING",
        "DIALOG_ERROR",
        "DIALOG_YESNO",
        "DIALOG_YESNOCANCEL",
        null
    };
    
    /**
     * the constructor of NextPanel2 class
     * @param aFrame the object of MainPanel
     */
    public NextPanel2(Frame aFrame) {

        /* setting the parameter field variable */
        previousFrame = aFrame;
        
        setSoftLabel(Frame.SOFT_KEY_1,"back");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(titleLabel);
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {

        /* go to the previous screen when softkey1 is released*/
        if (aSoftKey == Frame.SOFT_KEY_1) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When the execution button is pushed, constructor type decide processing. */
        if (aComponent == button){
                int i = menuList.getSelectedIndex();
                try{
//J011_1603_0102
                    if(i == 5){
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,null);
                        dialog.setText(getMasage(i));
                        dialog.show();
//J011_1603_0101
                    }else {
                        Dialog dialog = new Dialog(i,title[i]);
                        dialog.setText(getMasage(i));
                        dialog.show();
                    }
                }
                catch(Exception aException){
                    Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                    errDialog.setText("The dialog cannot be created.");
                    errDialog.show();
                }
        }
    }

    /**
     * get  message to display in the textbox
     * aComponent The component on which a event occurred
     * @param aType menu list type
     */
    public String getMasage(int aType){
        String masage = "";

        switch (aType) {
            case 0:
                masage = "\"OK\" button is displayed on the dialog.";
                break;
            case 1:
                masage = "\"OK\" button is displayed on the dialog.";
                break;
            case 2:
                masage = "\"OK\" button is displayed on the dialog.";
                break;
            case 3:
                masage = "\"YES/NO\" buttons are displayed on the dialog.";
                break;
            case 4:
                masage = "\"YES/NO/Cancel\" buttons are displayed on the dialog.";
                break;
            case 5:
                masage = "If the dialog is with no title, OK.";
                break;
            default:
                break;
        }
        return masage;
    }
}
