/**
 * J011_1603_0301
 *
 *
 * Dialog class action check (normal route)
 * $Id: J011_1603_0301.java,v 1.1 2001/11/30 01:30:35 ohkoshi Exp $
 */
import com.nttdocomo.ui.*;

/**
 * Dialog class action check main class
 * @extends IApplication
 */
public  class J011_1603_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Dialog class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 *
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    Label classLabel = new Label("Dialog");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button button    = new Button("execute");
    String[] menuListItem = {
        "0 variation of the constructors",
        "1 check the background color",
        "2 check the behavior for thrown exception"
    };

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent,int aType,int aParam){

        /* when  the exsecution button is pushed */
        if(aComponent == button){
            switch(menuList.getSelectedIndex()){
                case 0:
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                case 2:
                    Display.setCurrent(new NextPanel3((Frame) this));
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey){}

    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey){
        if(aSoftKey == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * constructor variation check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel1 extends Panel implements SoftKeyListener,ComponentListener{

    Frame previousFrame = null;
    Button button = new Button("execute");
    Label titleLabel = new Label("check the variation");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultText = new TextBox("If the title of the dialog is alphabetic characters, OK.",20,4,TextBox.DISPLAY_ANY);
// 2002/07/30 Doja1.5
//    byte[] emj1 ={ (byte)0xF8,(byte)0x9F,(byte)0xF8,(byte)0xA0,(byte)0xF8,(byte)0xA1,(byte)0xF8,(byte)0xA2,(byte)0xF8,(byte)0xA3};
//    byte[] emj2 ={ (byte)0xF8,(byte)0x9F,(byte)0xF8,(byte)0xA0,(byte)0xF8,(byte)0xA1};
    char[] emj1 = { 0xE63E, 0xE63F, 0xE640, 0xE641, 0xE642 };
    char[] emj2 = { 0xE63E, 0xE63F, 0xE640 };

    String emoji1 = new String(emj1);
    String emoji2 = new String(emj2);
    String[] menuListItem = {
        "0 alphabetic characters",
//2002/07/30 Doja1.5        "1 ",
//2002/07/30 Doja1.5        "2 ",
        "3 pictographic characters",
        "4 mixed characters"
    };

    /**
     * constructer of NextPanel1 class
     * @param aFrame the object of MainPanel
     */
    public NextPanel1(Frame aFrame) {

        /* setting the parameter field variable */
        previousFrame = aFrame;

        setSoftLabel(Frame.SOFT_KEY_1,"back");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(menuList);
        add(button);
        add(resultText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {

        /* return to the previous screen when softkey1 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the listbox is chosen */
        if(aComponent == menuList){
            switch(menuList.getSelectedIndex()){
                case 0:
                    resultText.setText("If the title of the dialog is alphabetic characters, OK.");
                    break;
//2002/07/30 Doja1.5                case 1:
//2002/07/30 Doja1.5                    resultText.setText("");
//2002/07/30 Doja1.5                    break;
//2002/07/30 Doja1.5                case 2:
//2002/07/30 Doja1.5                    resultText.setText("");
//2002/07/30 Doja1.5                    break;
                case 1:
//2002/07/30 Doja1.5                case 3:
                    resultText.setText("If the title of the dialog is pictographic characters, OK.");
                    break;
                case 2:
//2002/07/30 Doja1.5                case 4:
                    resultText.setText("If the title of the dialog is mixed characters, OK.");
                    break;
                default:
                    break;
            }
        }
        else if(aComponent == button) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    try{
//J011_1603_0301
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,"abcde");
//J011_1605_0301
                        dialog.setText("If the title of the dialog is \"abcde\", OK.");
//J011_1605_0203
                        dialog.setSoftLabel(Dialog.SOFT_KEY_1,"abcde");
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
//2002/07/30 Doja1.5                case 1:
//2002/07/30 Doja1.5                    try{
//J011_1603_0302
//2002/07/30 Doja1.5                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,"");
//J011_1605_0302
//2002/07/30 Doja1.5                        dialog.setText("");
//2002/07/30 Doja1.5                        dialog.show();
//2002/07/30 Doja1.5                    }
//2002/07/30 Doja1.5                    catch(Exception aException){
//2002/07/30 Doja1.5                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"");
//2002/07/30 Doja1.5                        errDialog.setText("");
//2002/07/30 Doja1.5                        errDialog.show();
//2002/07/30 Doja1.5                    }
//2002/07/30 Doja1.5                    break;
//2002/07/30 Doja1.5                case 2:
//2002/07/30 Doja1.5                    try{
//J011_1603_0303
//2002/07/30 Doja1.5                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,"");
//J011_1605_0303
//2002/07/30 Doja1.5                        dialog.setText("");
//2002/07/30 Doja1.5                        dialog.show();
//2002/07/30 Doja1.5                    }
//2002/07/30 Doja1.5                    catch(Exception aException){
//2002/07/30 Doja1.5                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"");
//2002/07/30 Doja1.5                        errDialog.setText("");
//2002/07/30 Doja1.5                        errDialog.show();
//2002/07/30 Doja1.5                    }
//2002/07/30 Doja1.5                    break;
                case 1:
//2002/07/30 Doja1.5                case 3:
                    try{
//J011_1603_0304
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,emoji1);
//J011_1605_0304
                        dialog.setText("If the title is \""+emoji1+"\", OK.");
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 2:
//2002/07/30 Doja1.5                case 4:
                    try{
//J011_1603_0305
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,"abcDialog"+emoji2);
//2002/07/30 Doja1.5                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,""+emoji2);
//J011_1605_0305
                        dialog.setText("the title is \"abcDialog"+emoji2+"\", OK.");
//2002/07/30 Doja1.5                        dialog.setText(""+emoji2+"");
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                default:
                    break;
            }
        }
    }
}

/**
 * background color check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener,ComponentListener{

    Frame previousFrame = null;
    Button button = new Button("execute");
    Label titleLabel = new Label("check the background color");
    ListBox menuList = new ListBox(ListBox.CHOICE);

    String[] menuListItem = {
        "AQUA",
        "BLACK",
        "BLUE",
        "FUCHSIA",
        "GRAY",
        "GREEN",
        "LIME",
        "MAROON",
        "NAVY",
        "OLIVE",
        "PURPLE",
        "RED",
        "SILVER",
        "TEAL",
        "WHITE",
        "YELLOW"
    };

    /**
     * the constructor of NextPanel2 class
     * @param aFrame the object of MainPanel
     */
    public NextPanel2(Frame aFrame) {

        /* setting the parameter field variable */
        previousFrame = aFrame;

        setSoftLabel(Frame.SOFT_KEY_1,"back");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(menuList);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {

        /* return to the previous screen when softkey1 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

//J011_1605_0201
        /* when the execution button is chosen */
        if(aComponent == button) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[0]);
                        dialog.setText("If the background color is AQUA, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.AQUA));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 1:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[1]);
                        dialog.setText("If the background color is BLACK, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 2:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[2]);
                        dialog.setText("If the background color is BLUE, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.BLUE));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 3:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[3]);
                        dialog.setText("If the background color is FUCHSIA, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.FUCHSIA));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 4:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[4]);
                        dialog.setText("If the background color is GRAY, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.GRAY));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 5:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[5]);
                        dialog.setText("If the background color is GREEN, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.GREEN));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 6:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[6]);
                        dialog.setText("If the background color is LIME, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.LIME));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 7:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[7]);
                        dialog.setText("If the background color is MAROON, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.MAROON));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 8:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[8]);
                        dialog.setText("If the background color is NAVY, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.NAVY));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 9:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[9]);
                        dialog.setText("If the background color is OLIVE, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.OLIVE));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 10:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[10]);
                        dialog.setText("If the background color is PURPLE, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.PURPLE));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 11:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[11]);
                        dialog.setText("If the background color is RED, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.RED));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 12:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[12]);
                        dialog.setText("If the background color is SILVER, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.SILVER));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 13:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[13]);
                        dialog.setText("If the background color is TEAL, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.TEAL));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 14:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[14]);
                        dialog.setText("If the background color is WHITE, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.WHITE));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                case 15:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,menuListItem[15]);
                        dialog.setText("If the background color is YELLOW, OK.");
                        dialog.setBackground(Graphics.getColorOfName(Graphics.YELLOW));
                        dialog.show();
                    }
                    catch(Exception aException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("The dialog cannot be created.");
                        errDialog.show();
                    }
                    break;
                default:
                    break;
            }
        }
    }
}

/**
 * exception check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel3 extends Panel implements SoftKeyListener,ComponentListener,Runnable{

    Frame previousFrame = null;
    Button button = new Button("execute");
    Label titleLabel = new Label("check behavior for the thrown exception");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultText = new TextBox("If \"OK:IllegalArgumentException\" dialog is displayed, OK.",20,5,TextBox.DISPLAY_ANY);
    String status;

    String[] menuListItem = {
        "test 1",
        "test 2",
        "test 3"
    };

    /**
     * the constructor of NextPanel3 class
     * @param aFrame the object of MainPanel
     */
    public NextPanel3(Frame aFrame) {

        /* setting the parameter field variable */
        previousFrame = aFrame;

        setSoftLabel(Frame.SOFT_KEY_1,"back");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(menuList);
        add(button);
        add(resultText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {

        /* return to the previous screen when softkey1 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the listbox is chosen */
        if(aComponent == menuList){
            switch(menuList.getSelectedIndex()){
                case 0:
                    resultText.setText("If \"OK:IllegalArgumentException\" dialog is displayed, OK.");
                    break;
                case 1:
                    resultText.setText("If \"OK:IllegalArgumentException\" dialog is displayed, OK.");
                    break;
                case 2:
                    resultText.setText("About 3 seconds after displaying the first dialog, press \"OK\" button. If the second dialog is displayed, OK.");
                    break;
                default:
                    break;
            }
        }
        else if(aComponent == button) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    try{
//J011_1606_0101
                        Dialog dialog = new Dialog(5,"NG");
                        dialog.setText("NG:no-Exception");
                        dialog.show();
                    }
                    catch(IllegalArgumentException anIllegalArgumentException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("OK:IllegalArgumentException:"+anIllegalArgumentException.getMessage());
                        errDialog.show();
                    } catch( Exception anException ) {
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("NG:" + anException.toString());
                        errDialog.show();
                    }
                    break;
                case 1:
                    try{
                        Dialog dialog = new Dialog(Dialog.DIALOG_INFO,"dialog");
//J011_1606_0102
                        dialog.setBackground(-1);
                        dialog.setText("NG:no-Exception");
                        dialog.show();
                    }
                    catch(IllegalArgumentException anIllegalArgumentException){
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("OK:IllegalArgumentException"+anIllegalArgumentException.getMessage());
                        errDialog.show();
                    } catch( Exception anException ) {
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("NG:" + anException.toString());
                        errDialog.show();
                    }
                    break;
                case 2:
                    try{
                        Thread t = new Thread(this);
                        t.start();
                        try{
                            Thread.sleep(1000);
                        }catch (InterruptedException e) {
                        }
                        Dialog dialog2 = new Dialog(Dialog.DIALOG_INFO,"error");
                        dialog2.setText("NG:no-Exception2");
                        dialog2.show();
//J011_1606_0103
                    }catch(UIException anUIException){
                        while(true){
                            if(Display.getCurrent() == this){
                                break;
                            }
                        }
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        if(anUIException.getStatus() == UIException.BUSY_RESOURCE){
                            status = "OK";
                        }else{
                            status = "NG";
                        }
                        errDialog.setText("OK:UIException:"+anUIException.getMessage()+":status="+status);
                        errDialog.show();

                    }catch(Exception anException) {
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errDialog.setText("NG:" + anException.toString());
                        errDialog.show();
                    }
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * Thread processing (display the first dialog of the dialog double-displaying error check)
     */
    public void run(){
        Dialog dialog1 = new Dialog(Dialog.DIALOG_INFO,"error");
        dialog1.setText("Wait 3 seconds, then press \"OK\" button. -> Error dialog will be displayed.");
        dialog1.show();
    }
}
