/**
 * J011_1702_0201
 *
 *
 * Display class action check (normal route)
 * $Id: J011_1702_0201.java,v 1.1 2001/11/30 01:30:35 ohkoshi Exp $
 */
import com.nttdocomo.ui.*;

/**
 * Display class action check main class
 * @extends IApplication
 */
public  class J011_1702_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Display class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    Button button = new Button("execute");
    Label titleLabel = new Label("check definition of the constant ");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultText = new TextBox("",20,2,TextBox.DISPLAY_ANY);

    String[] menuListItem = {
        "0 KEY_PRESSED_EVENT",
        "1 KEY_RELEASED_EVENT",
        "2 RESUME_VM_EVENT",
        "3 RESET_VM_EVENT",
        "4 UPDATA_VM_EVENT",
        "5 TIMER_EXPIRED_EVEVT",
        "6 MEDIA_EVENT",
        "7 KEY_0",
        "8 KEY_1",
        "9 KEY_2",
        "10 KEY_3",
        "11 KEY_4",
        "12 KEY_5",
        "13 KEY_6",
        "14 KEY_7",
        "15 KEY_8",
        "16 KEY_9",
        "17 KEY_ASTERISK",
        "18 KEY_POUND",
        "19 KEY_LEFT",
        "20 KEY_UP",
        "21 KEY_RIGHT",
        "22 KEY_DOWN",
        "23 KEY_SELECT",
        "24 KEY_SOFT1",
        "25 KEY_SOFT2",
//2002/07/25 DoJa1.5        "26 KEY_IAPP",
//2002/07/25 DoJa1.5        "27 KEY_UPPER_LEFT",
//2002/07/25 DoJa1.5        "28 KEY_UPPER_RIGHT",
//2002/07/25 DoJa1.5        "29 KEY_LOWER_RIGHT",
//2002/07/25 DoJa1.5        "30 KEY_LOWER_LEFT",
//2002/07/25 DoJa1.5        "31 KEY_PAGE_UP",
//2002/07/25 DoJa1.5        "32 KEY_PAGE_DOWN"
    };

    String[] exceptionItem = {
        "KEY_PRESSED_EVENT",
        "KEY_RELEASED_EVENT",
        "RESUME_VM_EVENT",
        "RESET_VM_EVENT",
        "UPDATA_VM_EVENT",
        "TIMER_EXPIRED_EVEVT",
        "MEDIA_EVENT",
        "KEY_0",
        "KEY_1",
        "KEY_2",
        "KEY_3",
        "KEY_4",
        "KEY_5",
        "KEY_6",
        "KEY_7",
        "KEY_8",
        "KEY_9",
        "KEY_ASTERISK",
        "KEY_POUND",
        "KEY_LEFT",
        "KEY_UP",
        "KEY_RIGHT",
        "KEY_DOWN",
        "KEY_SELECT",
        "KEY_SOFT1",
        "KEY_SOFT2",
//2002/07/25 DoJa1.5        "KEY_IAPP",
//2002/07/25 DoJa1.5        "KEY_UPPER_LEFT",
//2002/07/25 DoJa1.5        "KEY_UPPER_RIGHT",
//2002/07/25 DoJa1.5        "KEY_LOWER_RIGHT",
//2002/07/25 DoJa1.5        "KEY_LOWER_LEFT",
//2002/07/25 DoJa1.5        "KEY_PAGE_UP",
//2002/07/25 DoJa1.5        "KEY_PAGE_DOWN"
    };

    /**
     * Constructor of the constant definition confirming class
     */
    public MainPanel() {

        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(menuList);
        add(button);
        add(resultText);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {

        /* terminate the application when the softkey1 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == button) {
            resultText.setText(checkStaticValue(menuList.getSelectedIndex()));
        }
        /* clearing result in the textbox when the menu list is chosen*/
        else if(aComponent == menuList) {
            resultText.setText("");
        }
    }

    /**
     * get the event on a component
     * @param anIndex The index number which is selected in listbox
     * @return 
     */
    String checkStaticValue(int anIndex) {

        String resultStr = "";

        /* checking whether Exception which is selected is as a default  */
        switch (anIndex) {
//J011_1702_0101
            case 0:
                resultStr = isOK(Display.KEY_PRESSED_EVENT == 0);
                break;
//J011_1702_0102
            case 1:
                resultStr = isOK(Display.KEY_RELEASED_EVENT == 1);
                break;
//J011_1702_0103
            case 2:
                resultStr = isOK(Display.RESUME_VM_EVENT == 4);
                break;
//J011_1702_0104
            case 3:
                resultStr = isOK(Display.RESET_VM_EVENT == 5);
                break;
//J011_1702_0105
            case 4:
                resultStr = isOK(Display.UPDATE_VM_EVENT == 6);
                break;
//J011_1702_0106
            case 5:
                resultStr = isOK(Display.TIMER_EXPIRED_EVENT == 7);
                break;
//J011_1702_0107
            case 6:
                resultStr = isOK(Display.MEDIA_EVENT == 8);
                break;
//J011_1702_010
            case 7:
                resultStr = isOK(Display.KEY_0 == 0x00);
                break;
//J011_1702_011
            case 8:
                resultStr = isOK(Display.KEY_1 == 0x01);
                break;
//J011_1702_012
            case 9:
                resultStr = isOK(Display.KEY_2 == 0x02);
                break;
//J011_1702_013
            case 10:
                resultStr = isOK(Display.KEY_3 == 0x03);
                break;
//J011_1702_014
            case 11:
                resultStr = isOK(Display.KEY_4 == 0x04);
                break;
//J011_1702_015
            case 12:
                resultStr = isOK(Display.KEY_5 == 0x05);
                break;
//J011_1702_016
            case 13:
                resultStr = isOK(Display.KEY_6 == 0x06);
                break;
//J011_1702_017
            case 14:
                resultStr = isOK(Display.KEY_7 == 0x07);
                break;
//J011_1702_018
            case 15:
                resultStr = isOK(Display.KEY_8 == 0x08);
                break;
//J011_1702_019
            case 16:
                resultStr = isOK(Display.KEY_9 == 0x09);
                break;
//J011_1702_020
            case 17:
                resultStr = isOK(Display.KEY_ASTERISK == 0x0a);
                break;
//J011_1702_021
            case 18:
                resultStr = isOK(Display.KEY_POUND == 0x0b);
                break;
//J011_1702_022
            case 19:
                resultStr = isOK(Display.KEY_LEFT == 0x10);
                break;
//J011_1702_023
            case 20:
                resultStr = isOK(Display.KEY_UP == 0x11);
                break;
//J011_1702_024
            case 21:
                resultStr = isOK(Display.KEY_RIGHT == 0x12);
                break;
//J011_1702_025
            case 22:
                resultStr = isOK(Display.KEY_DOWN == 0x13);
                break;
//J011_1702_026
            case 23:
                resultStr = isOK(Display.KEY_SELECT == 0x14);
                break;
//J011_1702_027
            case 24:
                resultStr = isOK(Display.KEY_SOFT1 == 0x15);
                break;
//J011_1702_028
            case 25:
                resultStr = isOK(Display.KEY_SOFT2 == 0x16);
                break;
//2002/07/25 DoJa1.5 //J011_1702_029
//2002/07/25 DoJa1.5            case 26:
//2002/07/25 DoJa1.5                resultStr = isOK(Display.KEY_IAPP == 0x18);
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5 //J011_1702_032
//2002/07/25 DoJa1.5            case 27:
//2002/07/25 DoJa1.5                resultStr = isOK(Display.KEY_UPPER_LEFT == 0x20);
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5 //J011_1702_033
//2002/07/25 DoJa1.5            case 28:
//2002/07/25 DoJa1.5                resultStr = isOK(Display.KEY_UPPER_RIGHT == 0x21);
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5 //J011_1702_034
//2002/07/25 DoJa1.5            case 29:
//2002/07/25 DoJa1.5                resultStr = isOK(Display.KEY_LOWER_RIGHT == 0x22);
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5 //J011_1702_035
//2002/07/25 DoJa1.5            case 30:
//2002/07/25 DoJa1.5                resultStr = isOK(Display.KEY_LOWER_LEFT == 0x23);
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5 //J011_1702_036
//2002/07/25 DoJa1.5            case 31:
//2002/07/25 DoJa1.5                resultStr = isOK(Display.KEY_PAGE_UP == 0x24);
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5 //J011_1702_037
//2002/07/25 DoJa1.5            case 32:
//2002/07/25 DoJa1.5                resultStr = isOK(Display.KEY_PAGE_DOWN == 0x25);
//2002/07/25 DoJa1.5                break;
            default:
                break;
        }

        /* When a judgment result is NG, an actual value is set as NG addition information */
        if (resultStr.equals("NG")) {
            resultStr += "\n" + exceptionItem[anIndex];
        }
        return resultStr;
    }
    /**
     * The justification of a constant definition is judged and the character sequence OK/NG is returned.
     * @param aResult Constant definition judging
     * @return Judging result ("OK" or "NG)
     */
    String isOK(boolean aResult) {
        return (aResult ? "OK" : "NG");
    }
}

