/**
 * J011_1704_0101
 * 
 * 
 *
 * Display class action check (normal route)
 *
 * $Id: J011_1704_0101.java,v 1.1 2001/11/30 01:30:36 ohkoshi Exp $
 */
import com.nttdocomo.ui.*;

/**
 * Display class action check main class
 * @extends IApplication
 */
public class J011_1704_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Display class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    Button  button = new Button(" execute");
    Label   classLabel = new Label("Display");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    Frame nullFrame = null;
    TextBox textBox = new TextBox("",20,3,TextBox.DISPLAY_ANY);
    Dialog testDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
    String[] menuListItem = {
        "screen size",
        "screen color",
        "nullFrame",
        "DialogFrame"
    };

    /**
     * Constructor of MainPanel class
     */
    MainPanel(){
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        menuList.setItems(menuListItem);

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(button);
        add(textBox);
        textBox.setVisible(false);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aComponent == button) {
            switch(menuList.getSelectedIndex()){
                /* create NextPanel1 class */
                case 0:
//J011_1704_0103
//J011_1704_0104
                    Display.setCurrent(new NextPanel1(Display.getCurrent()));
                    break;
                /* create NextPanel2 class */
                case 1:
//J011_1704_0103
//J011_1704_0104
                    Display.setCurrent(new NextPanel2(Display.getCurrent()));
                    break;
                /* when nullFrame is set */
                case 2:
//J011_1706_0101
                    try{
                        Display.setCurrent(nullFrame);
                        Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errorDialog.show();
                    }catch(NullPointerException aNullPointerException){
                        Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errorDialog.setText("NullPointerException");
                        errorDialog.show();
                    }
                    break;
                /* when Dialog is set */
                case 3:
                    try{
//J011_1706_0102
                        Display.setCurrent(testDialog);
                        Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errorDialog.show();
                    }catch(IllegalArgumentException aIllegalArgumentException){
                        Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errorDialog.setText("IllegalArgumentException : "+aIllegalArgumentException.getMessage());
                        errorDialog.show();
                    }catch(Exception anException){
                        Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
                        errorDialog.show();
                    }
                    break;
                default:
                    break;
            }
        }else if(aComponent == menuList){
            switch(menuList.getSelectedIndex()){
                case 0:
                    textBox.setVisible(false);
                    break;
                case 1:
                    textBox.setVisible(false);
                    break;
                case 2:
                    textBox.setText("If NullPointerException error dialog is displayed, OK.");
                    textBox.setVisible(true);
                    break;
                case 3:
                    textBox.setText("if IllegalArgumentException error dialog is displayed, OK.");
                    textBox.setVisible(true);
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Display checking class1
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Display testDisplayt1,testDisplay2;
    Label textLabel,heightLabel,widthLabel;
    String height,width;

    /**
     * constructer of NextPanel1 class
     * @param aFrame the object of MainPanel
     */
    NextPanel1(Frame aFrame){
        /*  */
        previousFrame = aFrame;
        
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

        /* get the size of screen,and convert to String type */
//J011_1704_0101
        width  = String.valueOf(Display.getWidth());
//J011_1704_0102
        height = String.valueOf(Display.getHeight());

        textLabel   = new Label(" screen size");
        widthLabel  = new Label(" width="+width);
        heightLabel = new Label(" height="+height);

        /* adding each component on the display */
        add(textLabel);
        add(heightLabel);
        add(widthLabel);

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}

/**
 * Display checking class2
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel2 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    Display testDisplay;
    Label label1,label2;

    /**
     * the constructor of NextPanel2 class
     * @param aFrame the object of MainPanel
     */
    NextPanel2(Frame aFrame){

        previousFrame = aFrame;

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"back");

//J011_1704_0104
//J011_1704_0105
//J011_1704_0106
//J011_1704_0107
        isColors(Display.isColor(),Display.numColors());

        /* setting the listener */
        setSoftKeyListener(this);
    }

    /**
     * display the result of screen color display support and of the number of the screen color 
     * @param result of the screen color display support
     * @param number of the color which can be used on value screen
     */
    void isColors(boolean flag,int value){
        Label valueLabel;

        if(flag == true){
            label1 = new Label("color picture terminal");
            valueLabel = new Label("number of colors="+value);

            add(label1);
            add(valueLabel);
        }
//2002/08/21 DoJa1.5        else if(flag == false){
//2002/08/21 DoJa1.5            label1 = new Label("black and white terminal");
//2002/08/21 DoJa1.5            label1.setSize(100,20);
//2002/08/21 DoJa1.5            valueLabel = new Label("number of colors="+value);

//2002/08/21 DoJa1.5            add(label1);
//2002/08/21 DoJa1.5            add(valueLabel);
//2002/08/21 DoJa1.5        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * return to MainPanel screen when the softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }
}