/**
 * J011_1904_0101
 *
 * Font class action check (normal route)
 * method action check /exception action check
 *
 * $Id: J011_1904_0101.java,v 1.3 2002/05/23 10:15:23 torikatu Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.lang.*;


/**
 * Font class action check main class
 * @extends IApplication
 */
public class J011_1904_0101 extends IApplication {

	/**
	 * starting i-Appli start()
	 */
	public void start() {
		Display.setCurrent(new MainPanel());
	}
}


/**
 * Font class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

	String[] menu1 = {
		"01 given value class method",
		"02 rated value class method",
		"03 given value of the method",
		"04 check the behavior for thrown legal exceptions",
		"05 check the behavior for thrown logical exceptions"
	};

	String[] menu2_01 = {
		"01-1 getFont",
		"01-2 getFont",
		"02 getDefaultFont",
		"03 stringWidth",
		"04 getBBoxWidth",
		"05 getBBoxHeight"
	};

	String[] menu2_02 = {
		"01 getFont"
	};

	String[] menu2_03 = {
		"01 getAscent",
		"02 getDescent",
		"03 getHeight",
		"04 getLineBreak"
	};

	String[] menu2_04 = {
		"01 stringWidth",
		"02 getBBoxWidth",
		"03 getBBoxHeight",
		"04 getLinBreak"
	};

	String[] menu2_05 = {
		"01 getFont",
		"02 getLineBreak1",
		"03 getLineBreak2",
		"04 getLineBreak3",
		"05 getLineBreak4"
	};

	Frame   nextFrame;
	Label   title	  = new Label("check the Font method");
	ListBox menu_Li	= new ListBox(ListBox.CHOICE);
	ListBox menu_Li2   = new ListBox(ListBox.CHOICE);
	Button  execButton = new Button("execute");
	int	 firstType;
	int	 secondType;
	String  testStr	= new String("test for checking the behavior of Font class");
	Font	f;

	/**
	 * MainPanel constructor(initializing)
	 */
	public MainPanel() {
		try {
			/* display of the main panel */
			showMainPanel();
		} catch (Exception e) {
			/* processing when the exception occurs */
			Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
			errDialog.setText("main panel:" + e.toString());
			errDialog.show();
		}
	}

	/**
	 * display the main panel
	 */
	void showMainPanel() {

		/* setting of the display item */
		menu_Li.setItems(menu1);
		menu_Li2.setItems(menu2_01);
		setTitle("API class normal route");
		setSoftLabel(Frame.SOFT_KEY_1, "exit");

		/* adding each component on the display */
		add(title);
		add(menu_Li);
		add(menu_Li2);
		add(execButton);

		/* register the softkey listener */
		setSoftKeyListener(this);
		/* register the component listener */
		setComponentListener(this);
	}

	/**
	 * do nothing when a softkey is pushed
	 * @param anIndex the value of the pushed softkey 
	 */
	public void softKeyPressed(int anIndex) {}

	/**
	 * terminate the application when SOFT_KEY_1 is released
	 * @param anIndex the value of the released softkey 
	 */
	public void softKeyReleased(int anIndex) {

		/* terminate the application when SOFT_KEY_1 is released */
		if (anIndex == Frame.SOFT_KEY_1) {
			IApplication.getCurrentApp().terminate();
		}
	}

	/**
	 * process when the action other than softkey happens
	 * @param source the component on which the event occurs
	 * @param type event type
	 * @param param event parameter
	 */
	public void componentAction(Component source, int type, int param) {
		/* when item in the menu1 is selected */
		if (source == menu_Li && type == ComponentListener.SELECTION_CHANGED) {

			/* get the chosen item */
			firstType = menu_Li.getSelectedIndex();

			/* set the selection list in menu 1 */
			switch (firstType) {
				case 0:
					menu_Li2.setItems(menu2_01);
					break;
				case 1:
					menu_Li2.setItems(menu2_02);
					break;
				case 2:
					menu_Li2.setItems(menu2_03);
					break;
				case 3:
					menu_Li2.setItems(menu2_04);
					break;
				case 4:
					menu_Li2.setItems(menu2_05);
					break;
				default:
					break;
			}
		}

		/* when the fix-key is pushed on the condition the execution button is focused */
		if (source == execButton 
			&& type == ComponentListener.BUTTON_PRESSED) {

			/* get the chosen item */
			secondType = menu_Li2.getSelectedIndex();

			switch (firstType) {
				case 0:
					/* to case 2 without breaking */
				case 1:
					/* to case 2 without breaking */
				case 2:
					/* method check is executed on the next screen */
					nextFrame = new NextPanel(this, firstType, secondType);
					/* display screen which have been set */
					Display.setCurrent(nextFrame);
					break;
				case 3:
					/* behavior for thrown exception checking */
					myException1();
					break;
				case 4:
					/* to the logic exception check */
					myException2();
					break;
				default:
					break;
			}
		}
	}


	/**
	 * hehavior for thrown exception checking
	 */
	public void myException1() {
		String msg;
		String stat;

		switch (secondType) {
//J011_1906_0101
			case 0:
				/* stringWidth exception processing */
				try {
					/* set null */
					f.stringWidth(null);
				} catch (NullPointerException e) {
					showDialog("NullPointerException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

//J011_1906_0102
			case 1:
				/* getBBoxWidth exception processing */
				try {
					/* set null */
					f.getBBoxWidth(null);
				} catch (NullPointerException e) {
					showDialog("NullPointerException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

//J011_1906_0103
			case 2:
				/* getBBoxHeight exception processing */
				try {
					/* set null */
					f.getBBoxHeight(null);
				} catch (NullPointerException e) {
					showDialog("NullPointerException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

//J011_1906_0104
			case 3:
				/* getLineBreak exception processing */
				try {
					/* set null */
					f.getLineBreak(null, 10, 10, 50);
				} catch (NullPointerException e) {
					showDialog("NullPointerException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

			default:
				break;
		}

	}

	/**
	 * logic exception action check method
	 */
	public void myException2() {

		switch (secondType) {

//J011_1906_0201
			case 0:
				/* getFont exception processing */
				try {
					/* font value is impossible */
					f.getFont(-1);
				} catch (IllegalArgumentException e) {
					showDialog("IllegalArgumentException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

//J011_1906_0202
			case 1:
				/* getLineBreak exception processing1 */
				try {
					f = Font.getFont(Font.TYPE_DEFAULT);
					/* put a negative value in the offset */
					f.getLineBreak(testStr, -1, testStr.length(), 50);
				} catch (StringIndexOutOfBoundsException e) {
					showDialog("StringIndexOutOfBoundsException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

//J011_1906_0203
			case 2:
				/* getLineBreak exception processsing2 */
				try {
					f = Font.getFont(Font.TYPE_DEFAULT);
					/* put a negative value in the length of the character sequence */
					f.getLineBreak(testStr, 0, -1, 50);
				} catch (StringIndexOutOfBoundsException e) {
					showDialog("StringIndexOutOfBoundsException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

//J011_1906_0204
			case 3:
				/* getLineBreak exception processing3 */
				try {
					f = Font.getFont(Font.TYPE_DEFAULT);
					/* put the value which is bigger than an actual character sequence's in the length */
					f.getLineBreak(testStr, 0, testStr.length()+1, 50);
				} catch (StringIndexOutOfBoundsException e) {
					showDialog("StringIndexOutOfBoundsException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

//J011_1906_0205
			case 4:
				/* getLineBreak exception processing4 */
				try {
					f = Font.getFont(Font.TYPE_DEFAULT);
					/* put a negative value in the width of a character */
					f.getLineBreak(testStr, 0, testStr.length(), -1);
				} catch (IllegalArgumentException e) {
					showDialog("IllegalArgumentException:"+e.getMessage());
				/* in case of the exception which is not to be thrown  */
				} catch (Exception e) {
					showDialog(e.toString());
				}
				break;

			default:
				break;
		}
	}

	/**
	 * setting of the dialog box which is going to be displayed
	 * @param str the message on the dialog
	 */
	public void showDialog(String str) {
		/* create the dialog box */
		Dialog	d = new Dialog(Dialog.BUTTON_OK, "result");
		/* put the character sequence */
		d.setText(str);
		/* display of the dialog box */
		d.show();
	}
}

/**
 * Font class method action check
 * @extends Panel
 * @implements SoftKeyListener
 */

class NextPanel extends Canvas{

	String[] all_kind = {
		"default font",
		"header font",
		"system font",
		"monospace font",
		"proportional font",
		"plain style",
		"bold style",
		"italic style",
		"bold italic style",
		"small size",
		"medium size",
		"large size"
	};

	int[] all_contents = {
		0x00000000,
		0x00000001,
		0x71000000,
		0x72000000,
		0x73000000,
		0x70100000,
		0x70110000,
		0x70120000,
		0x70130000,
		0x70000100,
		0x70000200,
		0x70000300 
	};

	Frame	  frame;
	Font	   font;
	int		firstType;
	int		secondType;
	String	 resultstr   = new String();
	String	 resultstr2  = new String();
	String	 text1;
	String	 text2;
	String	 resultText;
	String	 resultText2;
	String	 str;
	String	 index_str;
	int		str_num;
	int		str_num2;
	int		flg = 0;
	int		ascent;
	int		ascent2;
	int		descent;
	int		descent2;
	int		height;
	int		height2;
	int		width_len;
	int		index;

	/**
	 * NextPanel constructor(inithializing)
	 * @param f  pass the screen on
	 * @param type the selected value in the listbox1
	 * @param type2 the selected value in the listbox2
	 */
	public NextPanel(Frame f, int type, int type2) {

		/* setting of the parameter */
		frame = f;
		firstType = type;
		secondType = type2;
		init();
	}

	/**
	 * setting each initialization
	 */
	public void init() {
		setSoftLabel(Frame.SOFT_KEY_2, "back");

		Font font = Font.getFont(Font.TYPE_DEFAULT);
	}

	/**
	 * method which display the result
	 */
	public void paint(Graphics grp){
		int roop = 0;
		int x = 0;
		int y = 0;
		int backup_indx = 0;
		int startlen = 0;
		int endlen = 0;
		int len = 0;
		width_len = getWidth();

		/* method which divide the processes */
		if (firstType == 0) {

			/* processing when executing the optional value class method action check */
			switch (secondType) {

//J011_1904_0101
				/* action check of getFont */
				case 0:
					for (int i=0; i <= 6; i++) {
						grp.lock();
						/* specify size on the font */
						font = Font.getFont(all_contents[i]);
						grp.setFont(font);
						/* output the character with 15 pixel space */
						grp.drawString(all_kind[i], 10, (i+1)*15);
					}

					/* display the checking */
					resultstr = "verify that each font/style/size is displayed";
					font = Font.getFont(Font.TYPE_DEFAULT);
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					roop = 0;
					x = 0;
					y = 120;
					backup_indx = 0;
					startlen = 0;
					endlen = 0;
					len = resultstr.length();
					/* the character string which have been set  is converted to the array */
					char data1[] = new char[len];
					int index_back1[] = new int[len];
					resultstr.getChars(0, len, data1, 0);
					while (len > 0) {
						/* get the position of the line feed of the character string which is displayed */
						index = font.getLineBreak(resultstr, startlen, len, width_len);
						index_back1[roop] = index;
						/* set the position of the line feed the length of the line */
						endlen = index;
						/* display with the max value of the line length */
						grp.drawChars(data1, x, y, startlen, endlen-startlen);
						/* the number of the characters which have not been outputted yet */
						len -= (endlen - startlen);
						/* set the length of the next line which begins to be written  */
						startlen = endlen;
						/* setting of the Y coordinates for next line */
						y += font.getHeight();
						roop++;
					}
					grp.unlock(true);
					break;

				/* action check of getFont */
				case 1:
					for (int i=7; i <= 11; i++) {
						grp.lock();
						/* specify size on the font */
						font = Font.getFont(all_contents[i]);
						grp.setFont(font);
						/* output the character with 15 pixel space */
						grp.drawString(all_kind[i], 10, (i-6)*15);
					}

					/* display the checking */
					resultstr = "verify that each font/style/size is displayed";
					font = Font.getFont(Font.TYPE_DEFAULT);
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					roop = 0;
					x = 0;
					y = 90;
					backup_indx = 0;
					startlen = 0;
					endlen = 0;
					len = resultstr.length();
					/* the character string which have been set  is converted to the array */
					char data2[] = new char[len];
					int index_back2[] = new int[len];
					resultstr.getChars(0, len, data2, 0);
					while (len > 0) {
						/* get the position of the line feed of the character string which is displayed */
						index = font.getLineBreak(resultstr, startlen, len, width_len);
						index_back2[roop] = index;
						/* set the position of the line feed the length of the line */
						endlen = index;
						/* display with the max value of the line length */
						grp.drawChars(data2, x, y, startlen, endlen-startlen);
						/* the number of the characters which have not been outputted yet */
						len -= (endlen - startlen);
						/* set the length of the next line which begins to be written  */
						startlen = endlen;
						/* setting of the Y coordinates for next line */
						y += font.getHeight();
						roop++;
					}

					grp.unlock(true);
					break;
//J011_1904_0102
				/* action check of getDefaultFont */
				case 2:
					this.setBackground(0xffff00);
					str = new String("default font");

					/* create the first on the default condition */
					grp.lock();
					grp.setColor(Graphics.getColorOfRGB(0x00, 0x88, 0x00));
					/* set the font default */
					font = Font.getFont(Font.TYPE_DEFAULT);
					grp.drawString(str, 0, 20);
					/* set the font the prescribed default font */
					font = Font.getFont(Font.FACE_SYSTEM|Font.SIZE_MEDIUM|Font.STYLE_PLAIN);
					grp.setFont(font);
					grp.setColor(Graphics.getColorOfRGB(0xff, 0x00, 0x00));
					/* overwrite on the same coordinates */
					grp.drawString(str, 0, 20);

					/* display the checking */
					resultstr = "if the string is flush with the another, OK";
					grp.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
					font = Font.getFont(Font.TYPE_DEFAULT);
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					roop = 0;
					x = 0;
					y = 35;
					backup_indx = 0;
					startlen = 0;
					endlen = 0;
					len = resultstr.length();
					/* the character string which have been set  is converted to the array */
					char data3[] = new char[len];
					int index_back3[] = new int[len];
					resultstr.getChars(0, len, data3, 0);
					while (len > 0) {
						/* get the position of the line feed of the character string which is displayed */
						index = font.getLineBreak(resultstr, startlen, len, width_len);
						index_back3[roop] = index;
						/* set the position of the line feed the length of the line */
						endlen = index;
						/* display with the max value of the line length */
						grp.drawChars(data3, x, y, startlen, endlen-startlen);
						/* the number of the characters which have not been outputted yet */
						len -= (endlen - startlen);
						/* set the length of the next line which begins to be written  */
						startlen = endlen;
						/* setting of the Y coordinates for next line */
						y += font.getHeight();
						roop++;
					}
					grp.unlock(true);
					break;

//J011_1904_0103
				/* action check of stringWidth */
				case 3:
					/* set the background color so that it is easy to see the result */
					str = new String("get width of the character");

					/* compare the same character sequences at the different size.   setting the first */
					grp.lock();
					font = Font.getFont(Font.SIZE_LARGE);
					grp.setFont(font);
					grp.drawString(str, 0, 15);
					str_num = font.stringWidth(str);
					grp.unlock(true);

					/* setting the second */
					grp.lock();
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					grp.drawString(str, 0, 30);
					str_num2 = font.stringWidth(str);
					grp.unlock(true);

					grp.lock();
					/* setting the text */
					font = Font.getFont(Font.SIZE_MEDIUM);
					grp.setFont(font);
					text1 = "SIZE_LARGE width="+str_num;
					grp.drawString(text1, 0, 45);
					text2 = "SIZE_SMALL width="+str_num2;
					grp.drawString(text2, 0, 65);

					/* display the checking */
					resultstr = "verify that the obtained width is the same as the displayed number";
					font = Font.getFont(Font.TYPE_DEFAULT);
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					roop = 0;
					x = 0;
					y = 80;
					backup_indx = 0;
					startlen = 0;
					endlen = 0;
					len = resultstr.length();
					/* the character string which have been set  is converted to the array */
					char data4[] = new char[len];
					int index_back4[] = new int[len];
					resultstr.getChars(0, len, data4, 0);
					while (len > 0) {
						/* get the position of the line feed of the character string which is displayed */
						index = font.getLineBreak(resultstr, startlen, len, width_len);
						index_back4[roop] = index;
						/* set the position of the line feed the length of the line */
						endlen = index;
						/* display with the max value of the line length */
						grp.drawChars(data4, x, y, startlen, endlen-startlen);
						/* the number of the characters which have not been outputted yet */
						len -= (endlen - startlen);
						/* set the length of the next line which begins to be written  */
						startlen = endlen;
						/* setting of the Y coordinates for next line */
						y += font.getHeight();
						roop++;
					}
					grp.unlock(true);
					break;

//J011_1904_0104
				/* action check of getBBoxWidth */
				case 4:
					/* set the background color so that it is easy to see the result */
					this.setBackground(0xffff00);
					str = new String("get width of the BBOX");

					/* compare the same character sequences at the different size.   setting the first */
					grp.lock();
					font = Font.getFont(Font.SIZE_LARGE);
					grp.setFont(font);
					grp.drawString(str, 0, 15);
					str_num = font.getBBoxWidth(str);
					grp.unlock(true);

					/* setting the second */
					grp.lock();
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					grp.drawString(str, 0, 30);
					str_num2 = font.getBBoxWidth(str);
					grp.unlock(true);
					
					/* setting the second */
					grp.lock();
					font = Font.getFont(Font.SIZE_MEDIUM);
					grp.setFont(font);
					text1 = "SIZE_LARGE ="+str_num;
					grp.drawString(text1, 0, 45);
					text2 = "SIZE_SMALL ="+str_num2;
					grp.drawString(text2, 0, 65);
					/* display the checking */
					resultstr = "verify that the obtained width is the width of the bounding box";
					font = Font.getFont(Font.TYPE_DEFAULT);
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					roop = 0;
					x = 0;
					y = 85;
					backup_indx = 0;
					startlen = 0;
					endlen = 0;
					len = resultstr.length();
					/* the character string which have been set  is converted to the array */
					char data5[] = new char[len];
					int index_back5[] = new int[len];
					resultstr.getChars(0, len, data5, 0);
					while (len > 0) {
						/* get the position of the line feed of the character string which is displayed */
						index = font.getLineBreak(resultstr, startlen, len, width_len);
						index_back5[roop] = index;
						/* set the position of the line feed the length of the line */
						endlen = index;
						/* display with the max value of the line length */
						grp.drawChars(data5, x, y, startlen, endlen-startlen);
						/* the number of the characters which have not been outputted yet */
						len -= (endlen - startlen);
						/* set the length of the next line which begins to be written  */
						startlen = endlen;
						/* setting of the Y coordinates for next line */
						y += font.getHeight();
						roop++;
					}
					grp.unlock(true);
					break;

//J011_1904_0105
				/* action check of getBBoxHeight */
				case 5:
					/* set the background color so that it is easy to see the result */
					this.setBackground(0xffff00);
					str = new String("get height of the BBOX");

					/* compare the same character sequences at the different size.   setting the first */
					grp.lock();
					font = Font.getFont(Font.SIZE_LARGE);
					grp.setFont(font);
					grp.drawString(str, 0, 15);
					str_num = font.getBBoxHeight(str);
					grp.unlock(true);

					/* setting the second */
					grp.lock();
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					grp.drawString(str, 0, 30);
					str_num2 = font.getBBoxHeight(str);
					grp.unlock(true);
					
					/* setting the text */
					grp.lock();
					font = Font.getFont(Font.SIZE_MEDIUM);
					grp.setFont(font);
					text1 = "SIZE_LARGE ="+str_num;
					grp.drawString(text1, 0, 45);
					text2 = "SIZE_SMALL ="+str_num2;
					grp.drawString(text2, 0, 65);
					/* display the checking */
					resultstr = "verify that the obtained height is the height of the bounding box";
					font = Font.getFont(Font.TYPE_DEFAULT);
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					roop = 0;
					x = 0;
					y = 85;
					backup_indx = 0;
					startlen = 0;
					endlen = 0;
					len = resultstr.length();
					/* the character string which have been set  is converted to the array */
					char data6[] = new char[len];
					int index_back6[] = new int[len];
					resultstr.getChars(0, len, data6, 0);
					while (len > 0) {
						/* get the position of the line feed of the character string which is displayed */
						index = font.getLineBreak(resultstr, startlen, len, width_len);
						index_back6[roop] = index;
						/* set the position of the line feed the length of the line */
						endlen = index;
						/* display with the max value of the line length */
						grp.drawChars(data6, x, y, startlen, endlen-startlen);
						/* the number of the characters which have not been outputted yet */
						len -= (endlen - startlen);
						/* set the length of the next line which begins to be written  */
						startlen = endlen;
						/* setting of the Y coordinates for next line */
						y += font.getHeight();
						roop++;
					}
					grp.unlock(true);
					break;

				default:
					break;
			}

		/* processing in case of the prescribed value class method behavior checking */
		} else if (firstType == 1) {

//J011_1904_0201
			/* action check of getFont */
			this.setBackground(0xffff00);
			str = new String("default font");

			/* create the first on the default condition */
			grp.lock();
			grp.setColor(Graphics.getColorOfRGB(0x00, 0x88, 0x00));
			grp.drawString(str, 0, 15);
			/* set the font default */
			font = Font.getFont(Font.TYPE_DEFAULT);
			grp.setFont(font);
			grp.setColor(Graphics.getColorOfRGB(0xff, 0x00, 0x00));
			/* overwrite on the same coordinates */
			grp.drawString(str, 0, 15);
			grp.unlock(true);

			/* display the checking */
			grp.lock();
			resultstr = "if the string is flush with the another one string can be seen, OK. * two strings displaced a little are shown below";
			grp.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
			font = Font.getFont(Font.TYPE_DEFAULT);
			font = Font.getFont(Font.SIZE_SMALL);
			grp.setFont(font);
			roop = 0;
			x = 0;
			y = 30;
			backup_indx = 0;
			startlen = 0;
			endlen = 0;
			len = resultstr.length();
			/* the character string which have been set  is converted to the array */
			char data7[] = new char[len];
			int index_back7[] = new int[len];
			resultstr.getChars(0, len, data7, 0);
			while (len > 0) {
				/* get the position of the line feed of the character string which is displayed */
				index = font.getLineBreak(resultstr, startlen, len, width_len);
				index_back7[roop] = index;
				/* set the position of the line feed the length of the line */
				endlen = index;
				/* display with the max value of the line length */
				grp.drawChars(data7, x, y, startlen, endlen-startlen);
				/* the number of the characters which have not been outputted yet */
				len -= (endlen - startlen);
				/* set the length of the next line which begins to be written  */
				startlen = endlen;
				/* setting of the Y coordinates for next line */
				y += font.getHeight();
				roop++;
			}
			grp.unlock(true);

			/* creating the second for comparison */
			grp.lock();
			font = Font.getFont(Font.TYPE_DEFAULT);
			grp.setFont(font);
			grp.setColor(Graphics.getColorOfRGB(0x00, 0x88, 0x00));
			grp.drawString(str, 0, 90);
			/* set the font default */
			font = Font.getFont(Font.TYPE_DEFAULT);
			grp.setFont(font);
			grp.setColor(Graphics.getColorOfRGB(0xff, 0x00, 0x00));
			/* shift the coordinates slightly and overwrite */
			grp.drawString(str, 3, 93);
			grp.unlock(true);

		/* processing in the case of the optional value method action check */
		} else if (firstType == 2) {
			switch (secondType) {

//J011_1905_0101
				/* action check of getAscent */
				case 0:
					/* to case 2 without breaking */
//J011_1905_0102
				/* action check of getDesent */
				case 1:
					/* to case 2 without breaking */
//J011_1905_0103
				/* action check of getHeight */
				case 2:

					/* set the background color so that it is easy to see the result */
					str = new String("Display");

					/* compare at the different size.   setting the first */

					grp.lock();
					font = Font.getFont(Font.SIZE_LARGE);
					grp.setFont(font);
					grp.drawString(str, 0, 15);
					ascent = font.getAscent();
					descent = font.getDescent();
					height = font.getHeight();
					grp.unlock(true);

					/* set the text about checking */

					grp.lock();
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					resultstr = "in case of SIZE_LARGE";
					grp.drawString(resultstr, 0, 25);
					resultText = "ascent="+ascent+"   descent="+descent;
					grp.drawString(resultText, 0, 35);
					resultText = "height="+height+"(ascent+descent)";
					grp.drawString(resultText, 0, 45);
					grp.unlock(true);

					/* setting the second */
					grp.lock();
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					grp.drawString(str, 0, 65);
					ascent2 = font.getAscent();
					descent2 = font.getDescent();
					height2 = font.getHeight();
					grp.unlock(true);

					/* adding the image label */

					/* set the text about checking */
					grp.lock();
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					resultstr = "in case of SIZE_SMALL";
					grp.drawString(resultstr, 0, 75);
					resultText = "ascent="+ascent2+"   descent="+descent2;
					grp.drawString(resultText, 0, 85);
					resultText = "height="+height2+"(ascent+descent)";
					grp.drawString(resultText, 0, 95);
					grp.unlock(true);

					break;

//J011_1905_0104
				/* action check of getLineBreak */
				case 3:
					/* set the background color so that it is easy to see the result */
					this.setBackground(0xffff00);
					str = new String("Please check number of the last linefeed characters. Now displaying 31 characters in one bytes characters.");
					//str = new String("Please check number of the last linefeed characters.");

					/* create the image which doesn't process a line feed */
					grp.lock();
					font = Font.getFont(Font.TYPE_DEFAULT);
					grp.setFont(font);
					//grp.drawString(str, 0, 15);
					grp.unlock(true);

					/* create the image which do process a line feed */
					grp.lock();
					font = Font.getFont(Font.TYPE_DEFAULT);
					grp.setFont(font);
					/* setting the coordinates which start to be written */
					int i = 0;
					x = 0;
					//y = 30;
					y =12;
					backup_indx = 0;
					startlen = 0;
					endlen = 0;
					len = str.length();
					/* the character string which have been set  is converted to the array */
					char data[] = new char[len];
					int index_back[] = new int[len];
					str.getChars(0, len, data, 0);
					while (len > 0) {
						/* get the position of the line feed of the character string which is displayed */
						index = font.getLineBreak(str, startlen, len, width_len);
						index_back[i] = index;
						/* set the position of the line feed the length of the line */
						endlen = index;
						/* display with the max value of the line length */
						grp.drawChars(data, x, y, startlen, endlen-startlen);
						/* the number of the characters which have not been outputted yet */
						len -= (endlen - startlen);
						/* set the length of the next line which begins to be written  */
						startlen = endlen;
						/* setting of the Y coordinates for next line */
						y += font.getHeight();
						i++;
					}
					grp.unlock(true);

					//index_str = new String("number of the linefeed characters:");
					index_str = new String("LF:");
					for (int n=0; n <= i-2; n++) {
						if (n != 0) {
							index_str += ",";
						}
						index_str += index_back[n];
					}
					grp.lock();
					font = Font.getFont(Font.SIZE_MEDIUM);
					grp.setFont(font);
					grp.drawString(index_str, 0, 80);
					grp.unlock(true);

					/* set the text about checking */
					/*grp.lock();
					font = Font.getFont(Font.SIZE_SMALL);
					grp.setFont(font);
					resultstr = "verfy that the first string is nonbreaking,";
					grp.drawString(resultstr, 0, 95);
					resultstr = "and the second is linefeeded.";
					grp.drawString(resultstr, 0, 105);
					grp.unlock(true);*/
					break;

				default:
					break;
			}
		}
	}

    /**
     * processing when the key event occurs
     * @param type event type
     * @param param event parameter
     */
    public void processEvent(int type, int param){
            if (param == Display.KEY_SOFT2) {
                Display.setCurrent(frame);
            }
    }

}
