/**
 * J011_2001_0301
 *
 * Frame class action check(normal route)
 * access level action check
 *
 * $Id: J011_2001_0301.java,v 1.1 2001/12/01 13:27:29 horikoshi Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Frame class action check main class
 * @extends IApplication
 */
public class J011_2001_0301 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Frame class action check main class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menu1 = {
        "01 public operation",
        "02 definition of the constant members",
        "03 detail definition of the constant",
        "04 check the given value method",
        "05 check the rated value method",
        "06 check the behavior for thrown exceptions"
    };

    String[] menu2_01 = {
        "01 getWidth",
        "02 getHeight",
        "03 setBackground",
        "04 setSoftLabel"
    };

    String[] menu2_02 = {
        "01 SOFT_KEY_1",
        "02 SOFT_KEY_2"
    };

    String[] menu2_03 = {
        "01 SOFT_KEY_1",
        "02 SOFT_KEY_2"
    };

    String[] menu2_04 = {
        "01 getWidth",
        "02 getHeigth"
    };

    String[] menu2_05 = {
        "01 setBackground",
        "02 setSoftLabel",
        "03 setSoftLabel(null)"
    };

    String[] menu2_06 = {
        "01 setBackground",
        "02 setSoftLabel"
    };

    Label   title      = new Label("Frame operation test");
    ListBox menu_Li    = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    int     firstType;
    int     secondType;

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(title);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * process when the action other than softkey happens
     * @param source the component on which the event occurs
     * @param type event type
     * @param param event parameter
     */
    public void componentAction(Component source, int type, int param) {
        /* when item in the menu1 is selected */
        if (source == menu_Li && type == ComponentListener.SELECTION_CHANGED) {

            /* get the chosen item */
            firstType = menu_Li.getSelectedIndex();

            /* set the selection list in menu 1 */
            switch (firstType) {
                case 0:
                    menu_Li2.setItems(menu2_01);
                    break;
                case 1:
                    menu_Li2.setItems(menu2_02);
                    break;
                case 2:
                    menu_Li2.setItems(menu2_03);
                    break;
                case 3:
                    menu_Li2.setItems(menu2_04);
                    break;
                case 4:
                    menu_Li2.setItems(menu2_05);
                    break;
                case 5:
                    menu_Li2.setItems(menu2_06);
                    break;
                default:
                    break;
            }
        }

        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {

            /* get the chosen item */
            secondType = menu_Li2.getSelectedIndex();

            switch (firstType) {
                case 0:
                    /* to public level action check */
                    test1();
                    break;
                case 1:
                    /* to the constant member definition check */
                    test2();
                    break;
                case 2:
                    /* to the constant definition content check */
                    test3();
                    break;
                case 3:
                    /* to anyl value method acton check  */
                    test4();
                    break;
                case 4:
                    /* to the prescribed value method behavior checking */
                    test5();
                    break;
                case 5:
                    /* to the exception action check */
                    test6();
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * execute public level action check
     */
    public void test1() {

        /* initializing to the value except the one which is not expected */
        int   retNum = -1;
        Frame frame  = (Frame)this;


        /* excecute public level check of mehod */
        switch (secondType) {
//J011_2001_0301
            case 0:
                /* in case of getWidth */
                retNum = frame.getWidth();
                if (retNum != -1) {
                    showDialog("Success!:"+retNum);
                } else {
                    showDialog("Failure...");
                }
                break;

//J011_2001_0302
            case 1:
                /* in case of getHeight */
                retNum = frame.getHeight();
                if (retNum != -1) {
                    showDialog("Success!:"+retNum);
                } else {
                    showDialog("Failure...");
                }
                break;

//J011_2001_0303
            case 2:
                /* in case of setBackground */
                frame.setBackground(Graphics.getColorOfName(Graphics.YELLOW));
                showDialog("Success!: set the background color to YELLOW");
                break;

//J011_2001_0304
            case 3:
                /* in case of setSoftLabel */
                frame.setSoftLabel(SOFT_KEY_2, "key2");
                showDialog("Success!: set the soft key2(lower right) to key2");
                break;
            default:
                break;
        }
    }

    /**
     * check the constant member definition
     */
    public void test2() {

        /* initializing to the value except the one which is not expected */
        int   retNum = -1;
        Frame frame  = (Frame)this;

        /* check the constant member definition */
        switch (secondType) {
//J011_2002_0101
            case 0:
                /* confirm that the value cannot be put in SOFT_KEY_1 */
//              SOFT_KEY_1 = -1;
                /* I have confirmed compile error */
                showDialog("The success has already confirmed.");
                break;

 //J011_2002_0102
            case 1:
                /* confirm that the value cannot be put in SOFT_KEY_2 */
//              SOFT_KEY_2 = -1;
                /* I have confirmed compile error */
                showDialog("The success has already confirmed.");
                break;
            default:
                break;
        }
    }


    /**
     * check the constant definition
     */
    public void test3() {

        /* initializing to the value except the one which is not expected */
        int   retNum = -1;
        Frame frame  = (Frame)this;

        /* check the constant definition */
        switch (secondType) {
//J011_2002_0201
            case 0:
                /* SOFT_KEY_1 the constant check */
                retNum = this.SOFT_KEY_1;
                if (retNum == 0) {
                    showDialog("Success!:"+retNum);
                } else {
                    showDialog("Failure...");    
                }
                break;

//J011_2002_0202
            case 1:
                /* SOFT_KEY_2 the constant check */
                retNum = this.SOFT_KEY_2;
                if (retNum == 1) {
                    showDialog("Success!:"+retNum);
                } else {
                    showDialog("Failure...");    
                }
                break;
            default:
                break;
        }
    }


    /**
     * checking any value method action
     */
    public void test4() {

        Frame frame  = (Frame)this;
        int   retNum = 0;

        if (secondType == 0) {

//J011_2005_0101
            /* in case of getWidth */
            retNum = frame.getWidth();
            showDialog("OK: width="+retNum+"pixels");
        } else {

//J011_2005_0102
            /* in case of getHeight */
            retNum = frame.getHeight();
            showDialog("OK: height="+retNum+"pixels");
        }
    }


    /**
     * checking prescribed value method action
     */
    public void test5() {

        Frame frame  = (Frame)this;
        int   retNum = 0;

        if (secondType == 0) {

//J011_2005_0201
            /* in case of setBackground */
            frame.setBackground(Graphics.getColorOfName(Graphics.AQUA));
            showDialog("If the background color has changed to AQUA, OK. ");
        } else if (secondType == 1) {

//J011_2005_0202
            /* in case of setSoftLabel */
            frame.setSoftLabel(SOFT_KEY_2, "change");
            showDialog("If the name of the soft key2(right) has turned to \"change\", OK.");

        } else {
//J011_2005_0203
            /* in case of setSoftLabel(null) */
            frame.setSoftLabel(SOFT_KEY_2, null);
            showDialog("If the name of the soft key2(right) has turned empty(invisible), OK.");
        }
    }


    /**
     * execute exception action check
     */
    public void test6() {

        Frame frame  = (Frame)this;
        int   retNum = 0;
        int   max255 = 0;
        int   max0   = 0;

        if (secondType == 0) {

//J011_2006_0101
            /* in case of setBackground */
            try {
                /* error in case of putting the max color value + 1 in */
                max255 = Graphics.getColorOfRGB(255,255,255);
                max0   = Graphics.getColorOfRGB(0,0,0);
                if (max255 > max0) {
                    frame.setBackground(max255 + 1);
                } else {
                    frame.setBackground(max0 + 1);
                }
            } catch (IllegalArgumentException e) {
                showDialog("IllegalArgumentException:"+e.getMessage());
            }
        } else {

//J011_2006_0102
            /* in case of setSoftLabel */
            try {
                /* error when the value except SOFT_KEY_1(0)  SOFT_KEY_2(1) is put in */
                frame.setSoftLabel(2, null);
            } catch (IllegalArgumentException e) {
                showDialog("IllegalArgumentException:"+e.getMessage());
            }
        }
    }


    /**
     * setting of the dialog box which is going to be displayed
     * @param str the message which is displayed in the dialog
     */
    public void showDialog(String str) {
        /* create the dialog box */
        Dialog    d = new Dialog(Dialog.BUTTON_OK, "result");
        /* put the character sequence */
        d.setText(str);
        /* display of the dialog box */
        d.show();
    }
}
