/**
 * J011_2101_0301
 * MainPanel
 *
 * Graphics class action check (normal route) - access level,constant test ,class method
 *
 * $Id: J011_2101_0301.java,v 1.2 2002/05/23 10:15:51 torikatu Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Graphics class action check main class
 * @extends IApplication
 */
public class J011_2101_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Graphics class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    
    String[] menuItems = {
        "1.access",
        "2.definition of the constant",
        "3.behavior of the class method",
    };
    String[][] subItems = {
        {
            "1.copy",
            "2.dispose",
            "3.lock",
            "4.unlock",
            "5.setOrigin",
            "6.getColorOfRGB",
            "7.getColorOfName",
            "8.setColor",
            "9.setFont",
            "10.clearRect",
            "11.drawLine",
            "12.drawRect",
//2002/07/25 DoJa1.5            "13.drawImage",
            "14.drawPolyline1",
//2002/07/25 DoJa1.5            "15.drawPolyline2",
            "16.fillPolygon1",
//2002/07/25 DoJa1.5            "17.fillPolygon2",
            "18.drawString",
            "19.drawChars",
            "20.drawImage2",
            "21.fillRect",
            "22.setPictoColorEnabled",
//2002/07/25 DoJa1.5            "23.clearClip",
//2002/07/25 DoJa1.5            "24.clipRect",
//2002/07/25 DoJa1.5            "25.copyArea",
//2002/07/25 DoJa1.5            "26.setClip"
        },
        {
            "1.AQUA",
            "2.BLACK",
            "3.BLUE",
            "4.FUCHSIA",
            "5.GRAY",
            "6.GREEN",
            "7.LIME",
            "8.MAROON",
            "9.NAVY",
            "10.OLIVE",
            "11.PURPLE",
            "12.RED",
            "13.SILVER",
            "14.TEAL",
            "15.WHITE",
            "16.YELLOW"
        },
        {
            "1.getColorOfRGB",
            "2.getColorOfName"
        },
    };

    Label   classLabel       = new Label("Graphics normal route 1");
    ListBox menu             = new ListBox(ListBox.CHOICE);
    ListBox menu2            = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menu.setItems(menuItems);
        menu2.setItems(subItems[0]);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menu);
        add(menu2);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menu
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menu2.setItems(subItems[menu.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            switch( menu.getSelectedIndex() ) {
                case 0:
                    /* access level test */
                    test1();
                    break;
                case 1:
                    /* constant definition check */
                    test2();
                    break;
                case 2:
                    /* class method action check */
                    test3();
                    break;
            }
        }
    }


    /**
     * access level action check
     */
    public void test1() {
        /* create canvas */
        Canvas canv = new GCanvas();
        Graphics g = canv.getGraphics();
        if( g == null ) {
            showDialog("getGraphics() return null");
            return;
        }
        int[] x = {0,10};
        int[] y = {0,10};
        int   n = 2;
        int   idx = menu2.getSelectedIndex();
        switch( idx ) {
        case 0:
            // J011_2101_0301
            Graphics gg = g.copy();
            break;
        case 1:
            // J011_2101_0302
            g.dispose();
            break;
        case 2:
            // J011_2101_0303
            g.lock();
            break;
        case 3:
            // J011_2101_0304
            g.unlock(true);
            break;
        case 4:
            // J011_2101_0305
            g.setOrigin(0,0);
            break;
        case 5:
            // J011_2101_0306
            int c = g.getColorOfRGB(1,1,1);
            break;
        case 6:
            // J011_2101_0307
            c = g.getColorOfName(1);
            break;
        case 7:
            // J011_2101_0308
            try {
                g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
            } catch( Exception e ) {}
            break;
        case 8:
            // J011_2101_0309
            g.setFont(Font.getDefaultFont());
            break;
        case 9:
            // J011_2101_0310
            g.clearRect(0,0,10,10);
            break;
        case 10:
            // J011_2101_0311
            g.drawLine(0,0,10,0);
            break;
        case 11:
            // J011_2101_0312
            g.drawRect(0,0,10,10);
            break;
//2002/07/25 DoJa1.5        case 12:
//2002/07/25 DoJa1.5            // J011_2101_0313
//2002/07/25 DoJa1.5            try {
//2002/07/25 DoJa1.5                g.drawImage(null,0,0,0,0,10,10);
//2002/07/25 DoJa1.5            } catch (Exception e) {}
//2002/07/25 DoJa1.5            break;
//2002/07/25 DoJa1.5        case 13:
        case 12:
            // J011_2101_0314
            g.drawPolyline(x,y,n);
            break;
//2002/07/25 DoJa1.5        case 14:
//2002/07/25 DoJa1.5            // J011_2101_0315
//2002/07/25 DoJa1.5            g.drawPolyline(x,y,0,n);
//2002/07/25 DoJa1.5            break;
//2002/07/25 DoJa1.5        case 15:
        case 13:
            // J011_2101_0316
            g.fillPolygon(x,y,n);
            break;
//2002/07/25 DoJa1.5        case 16:
//2002/07/25 DoJa1.5            // J011_2101_0317
//2002/07/25 DoJa1.5            g.fillPolygon(x,y,0,n);
//2002/07/25 DoJa1.5            break;
//2002/07/25 DoJa1.5        case 17:
        case 14:
            // J011_2101_0318
            g.drawString("text",20,20);
            break;
//2002/07/25 DoJa1.5        case 18:
        case 15:
            // J011_2101_0319
            String s = new String("string");
            char[] cs = s.toCharArray();
            g.drawChars(cs,20,20,0,cs.length);
            break;
        case 16:
//2002/08/26 DoJa1.5        case 19:
            // J011_2101_0320
            try {
//2002/07/25 DoJa1.5                g.drawImage(null,0,0,0,0,10,10);
//2002/08/19 Doja1.5                g.drawImage(null,0,0,0,0);
                g.drawImage(null,0,0);
            } catch (Exception e) {}
            break;
//2002/07/25 DoJa1.5        case 20:
        case 17:
            // J011_2101_0321
            g.fillRect(0,0,30,30);
            break;
//2002/07/25 DoJa1.5        case 21:
        case 18:
            // J011_2101_0322
            g.setPictoColorEnabled(true);
            break;
//2002/07/25 DoJa1.5        case 22:
//2002/07/25 DoJa1.5            // J011_2101_0323
//2002/07/25 DoJa1.5            g.clearClip();
//2002/07/25 DoJa1.5            break;
//2002/07/25 DoJa1.5        case 23:
//2002/07/25 DoJa1.5            // J011_2101_0324
//2002/07/25 DoJa1.5            g.clipRect(0,0,30,30);
//2002/07/25 DoJa1.5            break;
//2002/07/25 DoJa1.5        case 24:
//2002/07/25 DoJa1.5            // J011_2101_0325
//2002/07/25 DoJa1.5            g.copyArea(0,0,30,30,10,10);
//2002/07/25 DoJa1.5            break;
//2002/07/25 DoJa1.5        case 25:
//2002/07/25 DoJa1.5            // J011_2101_0326
//2002/07/25 DoJa1.5            g.setClip(0,0,30,30);
//2002/07/25 DoJa1.5            break;
        }
//2002/07/26 DoJa1.5        if( idx >=0 && idx <= 25 ) {
        if( idx >=0 && idx <= 18 ) {
            showDialog("OK");
        }
    }


    /**
     * check definition of the constant 
     */
    public void test2() {
        int value;
        int   idx = menu2.getSelectedIndex();
        switch( idx ) {
        case 0:
            // J011_2102_0101
            //Graphics.AQUA = 0;

            // J011_2102_0201
            value = Graphics.AQUA;
            if( value == 3 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 1:
            // J011_2102_0102
            //Graphics.BLACK = 0;

            // J011_2102_0202
            value = Graphics.BLACK;
            if( value == 0 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 2:
            // J011_2102_0103
            //Graphics.BLUE = 0;

            // J011_2102_0203
            value = Graphics.BLUE;
            if( value == 1 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 3:
            // J011_2102_0104
            //Graphics.FUCHSIA = 0;

            // J011_2102_0204
            value = Graphics.FUCHSIA;
            if( value == 5 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 4:
            // J011_2102_0105
            //Graphics.GRAY = 0;

            // J011_2102_0205
            value = Graphics.GRAY;
            if( value == 8 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 5:
            // J011_2102_0106
            //Graphics.GREEN = 0;

            // J011_2102_0206
            value = Graphics.GREEN;
            if( value == 10 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 6:
            // J011_2102_0107
            //Graphics.LIME = 0;

            // J011_2102_0207
            value = Graphics.LIME;
            if( value == 2 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 7:
            // J011_2102_0108
            //Graphics.MAROON = 0;

            // J011_2102_0208
            value = Graphics.MAROON;
            if( value == 12 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 8:
            // J011_2102_0109
            //Graphics.NAVY = 0;

            // J011_2102_0209
            value = Graphics.NAVY;
            if( value == 9 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 9:
            // J011_2102_0110
            //Graphics.OLIVE = 0;

            // J011_2102_0210
            value = Graphics.OLIVE;
            if( value == 14 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 10:
            // J011_2102_0111
            //Graphics.PURPLE = 0;

            // J011_2102_0211
            value = Graphics.PURPLE;
            if( value == 13 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 11:
            // J011_2102_0112
            //Graphics.RED = 0;

            // J011_2102_0212
            value = Graphics.RED;
            if( value == 4 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 12:
            // J011_2102_0113
            //Graphics.SILVER = 0;

            // J011_2102_0213
            value = Graphics.SILVER;
            if( value == 15 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 13:
            // J011_2102_0114
            //Graphics.TEAL = 0;

            // J011_2102_0214
            value = Graphics.TEAL;
            if( value == 11 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 14:
            // J011_2102_0115
            //Graphics.WHITE = 0;

            // J011_2102_0215
            value = Graphics.WHITE;
            if( value == 7 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        case 15:
            // J011_2102_0116
            //Graphics.YELLOW = 0;

            // J011_2102_0216
            value = Graphics.YELLOW;
            if( value == 6 ) {
                showDialog("OK");
            } else {
                showDialog("NG:value=" + value);
            }
            break;
        }
    }

    /**
     * class method action check
     */
    public void test3() {
        int   idx = menu2.getSelectedIndex();
        switch( idx ) {
        case 0:
            // J011_2104_0101
            try {
                for( int r=0; r<=255; r++ ) {
                    if( Graphics.getColorOfRGB(r,r,r) < 0 ) {
                        showDialog("NG:getColorOfRGB("+r+","+r+","+r+")");
                        return;
                    }
                }
                showDialog("OK");
            } catch( Exception e) {
                showDialog("NG:"+e.toString());
            }
            break;
        case 1:
            // J011_2104_0102
            try {
                for( int i=0; i<16; i++ ) {
                    if( Graphics.getColorOfName(i) < 0 ) {
                        showDialog("NG:getColorOfName("+i+")");
                        return;
                    }
                }
                showDialog("OK");
            } catch( Exception e) {
                showDialog("NG:"+e.toString());
            }
            break;
        }
    }
}


/**
 * Canvs implementation class for testing
 * @extends Canvas
 */
 class GCanvas extends Canvas {
    /**
     * constructor
     */
    public GCanvas() {
    }

    /**
     * the implementation of paint() method
     * @param   g Graphics object of canvas
     */
    public void paint(Graphics g) {
    }
 }
