/**
 * J011_2105_0101
 * MainPanel
 *
 * Graphics class action check (normal route) - method action
 *
 * $Id: J011_2105_0101.java,v 1.1 2001/11/30 02:53:57 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Graphics class method action check main class
 * @extends IApplication
 */
public class J011_2105_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Graphics class method action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    
    String[] menuItems = {
        "1.given value",
        "2.rated value"
    };
    String[][] subItems = {
        {
            "1.copy1",
            "2.copy2",
            "3.dispose1",
            "4.dispose2",
            "5.lock",
            "6.setOrigin",
            "7.setFont",
            "8.clearRect",
            "9.drawLine",
            "10.drawRect",
            "11.drawImage1",
// 2002/07/26 DoJa1.5            "12.drawImage2",
            "13.drawPolyline1",
// 2002/07/26 DoJa1.5            "14.drawPolyline2",
            "15.fillPolygon1",
// 2002/07/26 DoJa1.5            "16.fillPolygon2",
            "17.fillRect",
            "18.drawString",
            "19.drawChars",
            "20.setPictoColorEnabled1",
            "21.setPictoColorEnabled2",
// 2002/07/26 DoJa1.5            "22.clearClip",
// 2002/07/26 DoJa1.5            "23.setClip",
// 2002/07/26 DoJa1.5            "24.clipRect",
// 2002/07/26 DoJa1.5            "25.copyArea"
        },
        {
            "1.unlock(true)",
            "2.unlock(false)",
            "3.setColor"
        },
    };

    Label   classLabel       = new Label("behavior of the Graphics method");
    ListBox menu             = new ListBox(ListBox.CHOICE);
    ListBox menu2            = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menu.setItems(menuItems);
        menu2.setItems(subItems[0]);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menu);
        add(menu2);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
        d.setText(aText);
        d.show();
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menu
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menu2.setItems(subItems[menu.getSelectedIndex()]);
        }

        /* when  the execution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            switch( menu.getSelectedIndex() ) {
                case 0:
                    /* any-value method action */
                    Display.setCurrent(new GCanvas(this,
                                menu2.getSelectedIndex()));
                    break;
                case 1:
                    /* prescribed-value method action */
                    Display.setCurrent(new GCanvas(this,
                                menu2.getSelectedIndex()+18));
//2002/08/19 Doja1.5                                menu2.getSelectedIndex()+25));
                    break;
            }
        }
    }
}


/**
 * Canvs implementation class for testing
 * @extends Canvas
 */
class GCanvas extends Canvas {
    Frame   previous;
    int     flag;
    int     sH;     /* screen height */
    int     sW;     /* screen width */
    int     fH;     /* font height */
    int     fD;     /* font decendline */
    int     lH;     /* line height */
    int     unlockFlag = 0;

    /**
     * constructor
     */
    public GCanvas(Frame prevFrame, int aFlag) {
        previous = prevFrame;
        flag = aFlag;
        setSoftLabel(Canvas.SOFT_KEY_1, "start");
        setSoftLabel(Canvas.SOFT_KEY_2, "back");
        sH = getHeight();
        sW = getWidth();
        fH = Font.getDefaultFont().getHeight();
        fD = Font.getDefaultFont().getDescent();
        lH = fH + fD + 1;
    }

    /**
     * the implementation of paint() method
     * @param   g Graphics object of canvas
     */
    public void paint(Graphics g) {
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
        d.setText(aText);
        d.show();
    }

    /**
     * event receive method
     * @param aType event type
     * @param aParam Parameter of an event
     */
    public void processEvent(int type, int param) {
        /* key event */
        if (type == Display.KEY_RELEASED_EVENT) {
            switch (param) {
            /* when the start key is pushed */
            case Display.KEY_SOFT1:
                /* the test starting */
                test();
                break;

            /* when the return key is pushed */
            case Display.KEY_SOFT2:
                /* return to the main menu screen */
                Display.setCurrent(previous);
                break;

            /* when the select/fix Key is pushed */
            case Display.KEY_SELECT:
                /* the checking in case of unlock() */
				/* 2003/04/01 ->
                // J011_2105_0201
                // J011_2105_0202
                if( unlockFlag > 0 ) {
                    Graphics g = getGraphics();
                    if( unlockFlag == 1 ) {
                        g.unlock(true);
                    } else {
                        g.unlock(false);
                    }
                }
                break;
				// 2003/04/01 <- */
            }
        }
    }

    /**
     * the method which executes the test
     */
    public void test() {
        String filename = new String("89aT.gif");
        Graphics g = getGraphics();
        int[] xP = {-10,0,10,0,-10};
        int[] yP = {0,10,0,-10,0};
        int   nP = 5;
        int[] xp = new int[5];
        int[] yp = new int[5];
        int   i;
        MediaImage mi = null;
//20002/09/09 DoJa1.5       unlockFlag = 0;
        char[] emoji = {0xE63E, 0xE63F, 0xE640, 0xE641};

        switch( flag ) {
        case 0:
            // J011_2105_0101
            Graphics gg = g.copy();
            if( gg != null ) {
                showDialog("OK");
            } else {
                showDialog("NG:copy()=null");
            }
            break;
        case 1:
            // J011_2105_0102
            for( i=0; i<9999; i++ ) {
                gg = g.copy();
                if( gg == null ) {
                    showDialog("OK");
                    return;
                }
            }
            showDialog("couldn't execute. Executed copy() 9999 times, but no failure occurred, null character has not returned.");
            break;
        case 2:
            // J011_2105_0103
            g.dispose();
            try {
                g.copy();
                showDialog("NG1: no Exception");
            } catch( UIException uie ) {
                showDialog("OK");
            } catch( Exception e ) {
                showDialog("NG2:" + e.toString());
            }
            break;
        case 3:
            // J011_2105_0104
            g.dispose();
            try {
                g.dispose();
                showDialog("OK");
            } catch (Exception e) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 4:
            // J011_2105_0105
            g.lock();
            g.drawString("lock()",0,0);
            g.unlock(true);
            showDialog("OK");
            break;
        case 5:
            // J011_2105_0106
            g.lock();
            g.setOrigin(sW/2,sH/2);
            g.drawString(".<- the origin",0,0);
            g.unlock(true);
            break;
        case 6:
            // J011_2105_0107
            g.lock();
            Font f1 = Font.getFont(Font.SIZE_LARGE);
            g.setFont(f1);
			// 2003/04/01 ->
            //g.drawString("LARGE_FONT",0,lH);
			g.drawString("LARGE_FONT",0,lH+4);
			// 2003/04/01 <-
            Font f2 = Font.getFont(Font.STYLE_ITALIC);
            g.setFont(f2);
            g.drawString("ITALIC_FONT",0,sH/2);
            g.unlock(true);
            break;
        case 7:
            // J011_2105_0108
            g.lock();
            setBackground(Graphics.getColorOfName(Graphics.GREEN));
            g.clearRect(sW/2,sH/2,sW/2,sH/2);
            g.drawString("clearRect",0,lH);
            g.unlock(true);
            break;
        case 8:
            // J011_2105_0109
            g.lock();
            int y = 10;
            int x2 = sW-10;
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.drawLine(10,y,x2,y);
            g.drawString("(10,"+y+")-("+x2+","+y+")RED",0,y+fH+1);
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            y+=lH+10;
            g.drawLine(10,y,x2,y);
            g.drawString("(10,"+y+")-("+x2+","+y+")GREEN",0,y+fH+1);
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            y+=lH+10;
            g.drawLine(10,y,x2,y);
            g.drawString("(10,"+y+")-("+x2+","+y+")BLUE",0,y+fH+1);
            g.unlock(true);
            break;
        case 9:
            // J011_2105_0110
            g.lock();
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.drawRect(sW/2-10,sH/2-10,20,20);
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.drawRect(sW/2-20,sH/2-20,40,40);
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            g.drawRect(sW/2-30,sH/2-30,60,60);
            g.unlock(true);
            break;
        case 10:
            // J011_2105_0111
            try {
                mi = MediaManager.getImage("resource:///"+filename);
                mi.use();
            } catch (Exception e ) {
                showDialog("getImage NG:"+e.toString());
                return;
            }
            g.lock();
            g.drawImage(mi.getImage(),10,10);
            g.unlock(true);
            break;
// 2002/07/26 DoJa1.5        case 11:
// 2002/07/26 DoJa1.5            // J011_2105_0112
// 2002/07/26 DoJa1.5            try {
// 2002/07/26 DoJa1.5                mi = MediaManager.getImage("resource:///"+filename);
// 2002/07/26 DoJa1.5                mi.use();
// 2002/07/26 DoJa1.5            } catch (Exception e ) {
// 2002/07/26 DoJa1.5                showDialog("getImage NG:"+e.toString());
// 2002/07/26 DoJa1.5                return;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.lock();
// 2002/07/26 DoJa1.5            g.drawImage(mi.getImage(),10,10,10,0,40,40);
// 2002/07/26 DoJa1.5            g.unlock(true);
// 2002/07/26 DoJa1.5            break;
        case 11:
// 2002/07/26 DoJa1.5        case 12:
            // J011_2105_0113
            for( i=0; i<nP; i++ ) {
                xp[i]=xP[i]+sW/2;
                yp[i]=yP[i]+sH/2;
            }
            g.lock();
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.drawPolyline(xp,yp,nP);

            for( i=0; i<nP; i++ ) {
                xp[i]=xP[i]*2+sW/2;
                yp[i]=yP[i]*2+sH/2;
            }
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.drawPolyline(xp,yp,nP);

            for( i=0; i<nP; i++ ) {
                xp[i]=xP[i]*3+sW/2;
                yp[i]=yP[i]*3+sH/2;
            }
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            g.drawPolyline(xp,yp,nP);
            g.unlock(true);
            break;
// 2002/07/26 DoJa1.5        case 13:
// 2002/07/26 DoJa1.5            // J011_2105_0114
// 2002/07/26 DoJa1.5            for( i=0; i<nP; i++ ) {
// 2002/07/26 DoJa1.5                xp[i]=xP[i]+sW/2;
// 2002/07/26 DoJa1.5                yp[i]=yP[i]+sH/2;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.lock();
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.RED));
// 2002/07/26 DoJa1.5            g.drawPolyline(xp,yp,1,nP-1);
// 2002/07/26 DoJa1.5
// 2002/07/26 DoJa1.5            for( i=0; i<nP; i++ ) {
// 2002/07/26 DoJa1.5                xp[i]=xP[i]*2+sW/2;
// 2002/07/26 DoJa1.5                yp[i]=yP[i]*2+sH/2;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
// 2002/07/26 DoJa1.5            g.drawPolyline(xp,yp,1,nP-1);
// 2002/07/26 DoJa1.5
// 2002/07/26 DoJa1.5            for( i=0; i<nP; i++ ) {
// 2002/07/26 DoJa1.5                xp[i]=xP[i]*3+sW/2;
// 2002/07/26 DoJa1.5                yp[i]=yP[i]*3+sH/2;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
// 2002/07/26 DoJa1.5            g.drawPolyline(xp,yp,1,nP-1);
// 2002/07/26 DoJa1.5            g.unlock(true);
// 2002/07/26 DoJa1.5            break;
        case 12:
// 2002/07/26 DoJa1.5        case 14:
            // J011_2105_0115
            for( i=0; i<nP; i++ ) {
                xp[i]=xP[i]*3+sW/2;
                yp[i]=yP[i]*3+sH/2;
            }
            g.lock();
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.fillPolygon(xp,yp,nP);

            for( i=0; i<nP; i++ ) {
                xp[i]=xP[i]*2+sW/2;
                yp[i]=yP[i]*2+sH/2;
            }
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.fillPolygon(xp,yp,nP);

            for( i=0; i<nP; i++ ) {
                xp[i]=xP[i]+sW/2;
                yp[i]=yP[i]+sH/2;
            }
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            g.fillPolygon(xp,yp,nP);
            g.unlock(true);
            break;
// 2002/07/26 DoJa1.5        case 15:
// 2002/07/26 DoJa1.5            // J011_2105_0116
// 2002/07/26 DoJa1.5            int[] xxp = new int[nP+1];
// 2002/07/26 DoJa1.5            int[] yyp = new int[nP+1];
// 2002/07/26 DoJa1.5            xxp[0]=0;
// 2002/07/26 DoJa1.5            yyp[0]=0;
// 2002/07/26 DoJa1.5            for( i=0; i<nP; i++ ) {
// 2002/07/26 DoJa1.5                xxp[i+1]=xP[i]*3+sW/2;
// 2002/07/26 DoJa1.5                yyp[i+1]=yP[i]*3+sH/2;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.lock();
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.RED));
// 2002/07/26 DoJa1.5            g.fillPolygon(xxp,yyp,1,nP);
// 2002/07/26 DoJa1.5
// 2002/07/26 DoJa1.5            for( i=0; i<nP; i++ ) {
// 2002/07/26 DoJa1.5                xxp[i+1]=xP[i]*2+sW/2;
// 2002/07/26 DoJa1.5                yyp[i+1]=yP[i]*2+sH/2;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
// 2002/07/26 DoJa1.5            g.fillPolygon(xxp,yyp,1,nP);
// 2002/07/26 DoJa1.5            for( i=0; i<nP; i++ ) {
// 2002/07/26 DoJa1.5                xxp[i+1]=xP[i]+sW/2;
// 2002/07/26 DoJa1.5                yyp[i+1]=yP[i]+sH/2;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
// 2002/07/26 DoJa1.5            g.fillPolygon(xxp,yyp,1,nP);
// 2002/07/26 DoJa1.5            g.unlock(true);
// 2002/07/26 DoJa1.5            break;
        case 13:
// 2002/07/26 DoJa1.5        case 16:
            // J011_2105_0117
            g.lock();
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.fillRect(sW/2-30,sH/2-30,60,60);
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.fillRect(sW/2-20,sH/2-20,40,40);
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            g.fillRect(sW/2-10,sH/2-10,20,20);
            g.unlock(true);
            break;
        case 14:
// 2002/07/26 DoJa1.5        case 17:
            // J011_2105_0118
            g.lock();
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.drawString("RED",5,lH);
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.drawString("GREEN",15,lH*2);
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            g.drawString("BLUE",25,lH*3);
            g.unlock(true);
            break;
        case 15:
// 2002/07/26 DoJa1.5        case 18:
            // J011_2105_0119
            g.lock();
            String s = new String("abcdefghijklmn");
            char[] cs = s.toCharArray();
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.drawChars(cs,5,lH,0,4);
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.drawChars(cs,15,lH*2,4,4);
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            g.drawChars(cs,25,lH*3,8,4);
            g.unlock(true);
            break;
        case 16:
//2002/08/19 Doja1.5        case 19:
            // J011_2105_0120
            g.lock();
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.setPictoColorEnabled(true);
            g.drawChars(emoji,0,lH,0,emoji.length);
            g.unlock(true);
            break;
        case 17:
// 2002/07/26 DoJa1.5        case 20:
            // J011_2105_0121
            g.lock();
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.setPictoColorEnabled(false);
            g.drawChars(emoji,0,lH,0,emoji.length);
            g.unlock(true);
            break;
// 2002/07/26 DoJa1.5        case 21:
// 2002/07/26 DoJa1.5            // J011_2105_0122
// 2002/07/26 DoJa1.5            /*  */
// 2002/07/26 DoJa1.5        case 22:
// 2002/07/26 DoJa1.5            // J011_2105_0123
// 2002/07/26 DoJa1.5            /*  */
// 2002/07/26 DoJa1.5        case 23:
// 2002/07/26 DoJa1.5            // J011_2105_0124
// 2002/07/26 DoJa1.5            g.lock();
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
// 2002/07/26 DoJa1.5            g.setClip(0,0,sW,sH/2);
// 2002/07/26 DoJa1.5            if( flag == 21 ) {
// 2002/07/26 DoJa1.5                g.clearClip();
// 2002/07/26 DoJa1.5            } else if( flag == 23 ) {
// 2002/07/26 DoJa1.5                g.clipRect(0,0,sW/2,sH/2);
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            g.fillRect(0,0,sW,sH);
// 2002/07/26 DoJa1.5            g.unlock(true);
// 2002/07/26 DoJa1.5            break;
// 2002/07/26 DoJa1.5        case 24:
// 2002/07/26 DoJa1.5            // J011_2105_0125
// 2002/07/26 DoJa1.5            g.lock();
// 2002/07/26 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
// 2002/07/26 DoJa1.5            g.fillRect(0,0,sW/2,sH/2);
// 2002/07/26 DoJa1.5            g.copyArea(0,0,sW/2,sH/2,sW/2,sH/2);
// 2002/07/26 DoJa1.5            g.unlock(true);
// 2002/07/26 DoJa1.5            break;
        case 18:
// 2002/07/26 DoJa1.5        case 25:
            // J011_2105_0201
            g.lock();
            g.drawString("lock()-1",5,lH);
            g.lock();
            g.drawString("lock()-2",5,lH*2);
			// 2003/04/01 ->
            //unlockFlag = 1;
			g.unlock(true);
			// 2003/04/01 <-
            break;
        case 19:
// 2002/07/26 DoJa1.5        case 26:
            // J011_2105_0202
            g.lock();
			// 2003/04/01 ->
			//if(unlockFlag != 0){
	            g.drawString("lock()-1",5,lH);
	            g.lock();
	            //g.drawString("lock()-2",5,lH*2);
			//}
            unlockFlag = 2;
			g.unlock(false);
			g.drawString("lock()-2",5,lH*2);
			g.unlock(false);
			// 2003/04/01 <-
            break;
        case 20:
// 2002/07/26 DoJa1.5        case 27:
            // J011_2105_0203
            g.lock();
            setBackground(Graphics.getColorOfName(Graphics.WHITE));
            g.clearRect(0,0,sW,sH);
            g.setColor(Graphics.getColorOfName(Graphics.BLACK));
            g.drawString("BLACK",0,lH);
            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
            g.drawString("BLUE",sW/3,lH);
            g.setColor(Graphics.getColorOfName(Graphics.LIME));
            g.drawString("LIME",sW*2/3,lH);
            g.setColor(Graphics.getColorOfName(Graphics.RED));
            g.drawString("RED",0,lH*2);
            g.setColor(Graphics.getColorOfName(Graphics.FUCHSIA));
            g.drawString("FUCHSIA",sW/3,lH*2);
            g.setColor(Graphics.getColorOfName(Graphics.YELLOW));
            g.drawString("YELLOW",sW*2/3,lH*2);
            g.setColor(Graphics.getColorOfName(Graphics.BLACK));
            g.fillRect(0,lH*3-fH,sW/3,lH);
            g.setColor(Graphics.getColorOfName(Graphics.WHITE));
            g.drawString("WHITE",0,lH*3);
            g.setColor(Graphics.getColorOfName(Graphics.GRAY));
            g.drawString("GRAY",sW/2,lH*3);
            g.setColor(Graphics.getColorOfName(Graphics.NAVY));
            g.drawString("NAVY",0,lH*4);
            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
            g.drawString("GREEN",sW/2,lH*4);
            g.setColor(Graphics.getColorOfName(Graphics.TEAL));
            g.drawString("TEAL",0,lH*5);
            g.setColor(Graphics.getColorOfName(Graphics.MAROON));
            g.drawString("MAROON",sW/2,lH*5);
            g.setColor(Graphics.getColorOfName(Graphics.PURPLE));
            g.drawString("PURPLE",0,lH*6);
            g.setColor(Graphics.getColorOfName(Graphics.OLIVE));
            g.drawString("OLIVE",sW/2,lH*6);
            g.setColor(Graphics.getColorOfName(Graphics.SILVER));
            g.drawString("SILVER",0,lH*7);
            g.unlock(true);
        }
    }
}
