/**
 * J011_2106_0101
 * MainPanel
 *
 * Graphics class action check (normal route) -exception action
 *
 * $Id: J011_2106_0101.java,v 1.1 2001/11/30 02:54:55 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Graphics class exception action check main class
 * @extends IApplication
 */
public class J011_2106_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Graphics class method action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    
    String[] menuItems = {
        "1.getColorOfRGB",
        "2.getColorOfName",
        "3.setColor",
        "4.setFont",
        "5.clearRect",
        "6.drawRect",
        "7.fillRect",
        "8.drawImage1",
// 2002/07/26 DoJa1.5        "9.drawImage2",
        "10.drawPolyline1",
// 2002/07/26 DoJa1.5        "11.drawPolyline2",
        "12.fillPolygon1",
// 2002/07/26 DoJa1.5      "13.fillPolygon2",
        "14.drawString",
        "15.drawChars",
        "16.setPictoColorEnabled",
// 2002/07/26 DoJa1.5      "17.clipRect",
// 2002/07/26 DoJa1.5      "18.copyArea",
// 2002/07/26 DoJa1.5      "19.setClip",
        "20.copy",
        "21.lock",
        "22.unlock",
        "23.drawLine"
    };
    String[][] subItems = {
        {
            "1.out of 0-225"
        },
        {
            "1.incorrect argument"
        },
        {
            "1.incorrect argument",
            "2.after disposing"
        },
        {
            "1.null",
            "2.after disposing"
        },
        {
            "1.w<0",
            "2.h<0",
            "3.w,h<0",
            "4.after disposing"
        },
        {
            "1.w<0",
            "2.h<0",
            "3.w,h<0",
            "4.after disposing"
        },
        {
            "1.w<0",
            "2.h<0",
            "3.w,h<0",
            "4.after disposing"
        },
        {
            "1.null",
            "2.image after disposing",
            "3.Graphic after disposing"
        },
// 2002/07/26 DoJa1.5        {
// 2002/07/26 DoJa1.5            "1.null",
// 2002/07/26 DoJa1.5            "2.w<0",
// 2002/07/26 DoJa1.5            "3.h<0",
// 2002/07/26 DoJa1.5            "4.w,h<0",
// 2002/07/26 DoJa1.5            "",
// 2002/07/26 DoJa1.5            ""
// 2002/07/26 DoJa1.5        },
        {
            "1.xP=null",
            "2.yP=null",
            "3.xP,yP=null",
            "4.nP<0",
            "5.nP>array",
            "6.after disposing"
        },
// 2002/07/26 DoJa1.5        {
// 2002/07/26 DoJa1.5            "1.xP=null",
// 2002/07/26 DoJa1.5            "2.yP=null",
// 2002/07/26 DoJa1.5            "3.xP,yP=null",
// 2002/07/26 DoJa1.5            "4.offset<0",
// 2002/07/26 DoJa1.5            "5.count<0",
// 2002/07/26 DoJa1.5            "",
// 2002/07/26 DoJa1.5            "",
// 2002/07/26 DoJa1.5            ""
// 2002/07/26 DoJa1.5        },
        {
            "1.xP=null",
            "2.yP=null",
            "3.xP,yP=null",
            "4.nP<0",
            "5.nP>array",
            "6.after disposing"
        },
// 2002/07/26 DoJa1.5        {
// 2002/07/26 DoJa1.5            "1.xP=null",
// 2002/07/26 DoJa1.5            "2.yP=null",
// 2002/07/26 DoJa1.5            "3.xP,yP=null",
// 2002/07/26 DoJa1.5            "4.offset<0",
// 2002/07/26 DoJa1.5            "5.count<0",
// 2002/07/26 DoJa1.5            "",
// 2002/07/26 DoJa1.5            "",
// 2002/07/26 DoJa1.5            ""
// 2002/07/26 DoJa1.5        },
        {
            "1.null",
            "2.after disposing"
        },
        {
            "1.null",
            "2.off<0",
            "3.len<0",
            "4.off>array",
            "5.off+len>array",
            "6.after disposing"
        },
        {
            "1.after disposing"
        },
// 2002/07/26 DoJa1.5        {
// 2002/07/26 DoJa1.5            "1.w<0",
// 2002/07/26 DoJa1.5            "2.h<0",
// 2002/07/26 DoJa1.5            "3.w,h<0",
// 2002/07/26 DoJa1.5            ""
// 2002/07/26 DoJa1.5        },
// 2002/07/26 DoJa1.5        {
// 2002/07/26 DoJa1.5            "1.w<0",
// 2002/07/26 DoJa1.5            "2.h<0",
// 2002/07/26 DoJa1.5            "3.w,h<0",
// 2002/07/26 DoJa1.5            ""
// 2002/07/26 DoJa1.5        },
// 2002/07/26 DoJa1.5        {
// 2002/07/26 DoJa1.5            "1.w<0",
// 2002/07/26 DoJa1.5            "2.h<0",
// 2002/07/26 DoJa1.5            "3.w,h<0",
// 2002/07/26 DoJa1.5            ""
// 2002/07/26 DoJa1.5        },
        {
            "1.after disposing"
        },
        {
            "1.after disposing"
        },
        {
            "1.after disposing"
        },
        {
            "1.after disposing"
        }
    };

    Label   classLabel       = new Label("Graphics' behavior for thrown exceptions");
    ListBox menu             = new ListBox(ListBox.CHOICE);
    ListBox menu2            = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menu.setItems(menuItems);
        menu2.setItems(subItems[0]);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menu);
        add(menu2);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
        d.setText(aText);
        d.show();
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menu
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menu2.setItems(subItems[menu.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
                /* prescribed exception action canvas creation display */
                Display.setCurrent(new GCanvas(this,
                                menu.getSelectedIndex(),
                                menu2.getSelectedIndex()));
        }
    }
}


/**
 * Canvs implementation class for testing
 * @extends Canvas
 */
class GCanvas extends Canvas {
    Frame   previous;
    int     index1;
    int     index2;
    int     sH;     /* screen height */
    int     sW;     /* screen width */
    int     fH;     /* font height */
    int     fD;     /* font decendline */
    int     lH;     /* line height */
    int     unlockFlag = 0;

    /**
     * constructor
     */
    public GCanvas(Frame prevFrame, int aIdx1, int aIdx2) {
        previous = prevFrame;
        index1 = aIdx1;
        index2 = aIdx2;
        setSoftLabel(Canvas.SOFT_KEY_1, "start");
        setSoftLabel(Canvas.SOFT_KEY_2, "back");
        sH = getHeight();
        sW = getWidth();
        fH = Font.getDefaultFont().getHeight();
        fD = Font.getDefaultFont().getDescent();
        lH = fH + fD + 1;
    }

    /**
     * the implementation of paint() method
     * @param   g Graphics object of canvas
     */
    public void paint(Graphics g) {
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
        d.setText(aText);
        d.show();
    }

    /**
     * event receive method
     * @param aType event type
     * @param aParam Parameter of an event
     */
    public void processEvent(int type, int param) {
        /* key event */
        if (type == Display.KEY_RELEASED_EVENT) {
            switch (param) {
            /* when the start key is pushed */
            case Display.KEY_SOFT1:
                /* the test starting */
                test();
                break;

            /* when the return key is pushed */
            case Display.KEY_SOFT2:
                /* return to the main menu screen */
                Display.setCurrent(previous);
                break;
            }
        }
    }

    /**
     * the method which executes the test
     */
    public void test() {
        String filename = new String("89aT.gif");
        Graphics g = getGraphics();
        int[] xP = {-10,0,10,0,-10};
        int[] yP = {0,10,0,-10,0};
        int   nP = 5;
        int[] xp = new int[5];
        int[] yp = new int[5];
        int   i;
        MediaImage mi = null;
        unlockFlag = 0;

        switch( index1 ) {
        case 0:             /* getColorOfRGB() */
            // J011_2106_0101
            try {
                int c = Graphics.getColorOfRGB(256,256,256);
                showDialog("NG: no Exception");
            } catch( IllegalArgumentException iae ) {
                showDialog("IllegalArgumentException:"+iae.getMessage());
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 1:             /* getColorOfName() */
            // J011_2106_0102
            try {
                int c = Graphics.getColorOfName(9999);
                showDialog("NG: no Exception");
            } catch( IllegalArgumentException iae ) {
                showDialog("IllegalArgumentException:"+iae.getMessage());
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 2:             /* setColor() */
            switch( index2 ) {
            case 0:
                // J011_2106_0103
                try {
                    g.setColor(-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0104
                g.dispose();
                try {
                    g.setColor(Graphics.getColorOfRGB(0,0,0));
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 3:             /* setFont() */
            switch( index2 ) {
            case 0:
                // J011_2106_0105
                try {
                    g.setFont(null);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0106
                g.dispose();
                try {
                    g.setFont(Font.getDefaultFont());
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 4:             /* clearRect() */
            switch( index2 ) {
            case 0:
                // J011_2106_0107
                try {
                    g.clearRect(0,0,-10,10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0108
                try {
                    g.clearRect(0,0,10,-10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_2106_0109
                try {
                    g.clearRect(0,0,-10,-10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J011_2106_0110
                g.dispose();
                try {
                    g.clearRect(0,0,10,10);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 5:                 /* drawRect() */
            switch( index2 ) {
            case 0:
                // J011_2106_0111
                try {
                    g.drawRect(0,0,-10,10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0112
                try {
                    g.drawRect(0,0,10,-10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_2106_0113
                try {
                    g.drawRect(0,0,-10,-10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J011_2106_0114
                g.dispose();
                try {
                    g.drawRect(0,0,10,10);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 6:                 /* fillRect() */
            switch( index2 ) {
            case 0:
                // J011_2106_0115
                try {
                    g.fillRect(0,0,-10,10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0116
                try {
                    g.fillRect(0,0,10,-10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_2106_0117
                try {
                    g.fillRect(0,0,-10,-10);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J011_2106_0118
                g.dispose();
                try {
                    g.fillRect(0,0,10,10);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 7:                 /* drawImage() */
            try {
                mi = MediaManager.getImage("resource:///"+filename);
                mi.use();
            } catch (Exception e ) {
                showDialog("getImage NG:"+e.toString());
                return;
            }
            switch( index2 ) {
            case 0:
                // J011_2106_0119
                try {
                    g.drawImage(null,0,0);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0420
                mi.dispose();
                try {
                    g.drawImage(mi.getImage(),0,0);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_2106_0421
                g.dispose();
                try {
                    g.drawImage(mi.getImage(),0,0);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
// 2002/07/26 DoJa1.5       case 8:         /* drawImage() */
// 2002/07/26 DoJa1.5            try {
// 2002/07/26 DoJa1.5                mi = MediaManager.getImage("resource:///"+filename);
// 2002/07/26 DoJa1.5                mi.use();
// 2002/07/26 DoJa1.5            } catch (Exception e ) {
// 2002/07/26 DoJa1.5                showDialog("getImage NG:"+e.toString());
// 2002/07/26 DoJa1.5                return;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            switch( index2 ) {
// 2002/07/26 DoJa1.5            case 0:
// 2002/07/26 DoJa1.5                // J011_2106_0122
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawImage(null,0,0,0,0,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( NullPointerException npe ) {
// 2002/07/26 DoJa1.5                    showDialog("NullPointerException:"+npe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 1:
// 2002/07/26 DoJa1.5                // J011_2106_0123
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawImage(mi.getImage(),0,0,0,0,-10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 2:
// 2002/07/26 DoJa1.5                // J011_2106_0124
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawImage(mi.getImage(),0,0,0,0,10,-10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 3:
// 2002/07/26 DoJa1.5                // J011_2106_0125
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawImage(mi.getImage(),0,0,0,0,-10,-10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 4:
// 2002/07/26 DoJa1.5                // J011_2106_0426
// 2002/07/26 DoJa1.5                mi.dispose();
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawImage(mi.getImage(),0,0,0,0,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( UIException uie ) {
// 2002/07/26 DoJa1.5                    showUIException(uie);
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 5:
// 2002/07/26 DoJa1.5                // J011_2106_0427
// 2002/07/26 DoJa1.5                g.dispose();
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawImage(mi.getImage(),0,0,0,0,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( UIException uie ) {
// 2002/07/26 DoJa1.5                    showUIException(uie);
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            break;
        case 8:             /* drawPolyline() */
// 2002/07/26 DoJa1.5        case 9:             /* drawPolyline() */
            switch( index2 ) {
            case 0:
                // J011_2106_0128
                try {
                    g.drawPolyline(null,yP,nP);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0129
                try {
                    g.drawPolyline(xP,null,nP);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_2106_0130
                try {
                    g.drawPolyline(null,null,nP);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J011_2106_0131
                try {
                    g.drawPolyline(xP,yP,-4);
                    showDialog("NG: no Exception");
                } catch( ArrayIndexOutOfBoundsException aioe ) {
                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J011_2106_0132
                try {
                    g.drawPolyline(xP,yP,6);
                    showDialog("NG: no Exception");
                } catch( ArrayIndexOutOfBoundsException aioe ) {
                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J011_2106_0133
                g.dispose();
                try {
                    g.drawPolyline(xP,yP,4);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
// 2002/07/26 DoJa1.5        case 10:                /* drawPolyline() */
// 2002/07/26 DoJa1.5            switch( index2 ) {
// 2002/07/26 DoJa1.5            case 0:
// 2002/07/26 DoJa1.5                // J011_2106_0134
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(null,yP,0,nP);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( NullPointerException npe ) {
// 2002/07/26 DoJa1.5                    showDialog("NullPointerException:"+npe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 1:
// 2002/07/26 DoJa1.5                // J011_2106_0135
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(xP,null,0,nP);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( NullPointerException npe ) {
// 2002/07/26 DoJa1.5                    showDialog("NullPointerException:"+npe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 2:
// 2002/07/26 DoJa1.5                // J011_2106_0136
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(null,null,0,nP);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( NullPointerException npe ) {
// 2002/07/26 DoJa1.5                    showDialog("NullPointerException:"+npe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 3:
// 2002/07/26 DoJa1.5                // J011_2106_0137
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(xP,yP,-1,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 4:
// 2002/07/26 DoJa1.5                // J011_2106_0138
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(xP,yP,0,-4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 5:
// 2002/07/26 DoJa1.5                // J011_2106_0139
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(xP,yP,6,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 6:
// 2002/07/26 DoJa1.5                // J011_2106_0140
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(xP,yP,2,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 7:
// 2002/07/26 DoJa1.5                // J011_2106_0141
// 2002/07/26 DoJa1.5                g.dispose();
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.drawPolyline(xP,yP,0,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( UIException uie ) {
// 2002/07/26 DoJa1.5                    showUIException(uie);
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            break;
        case 9:                    /* fillPolygon() */
// 2002/07/26 DoJa1.5        case 11:                    /* fillPolygon() */
            switch( index2 ) {
            case 0:
                // J011_2106_0142
                try {
                    g.fillPolygon(null,yP,nP);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0143
                try {
                    g.fillPolygon(xP,null,nP);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_2106_0144
                try {
                    g.fillPolygon(null,null,nP);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J011_2106_0145
                try {
                    g.fillPolygon(xP,yP,-4);
                    showDialog("NG: no Exception");
                } catch( ArrayIndexOutOfBoundsException aioe ) {
                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J011_2106_0146
                try {
                    g.fillPolygon(xP,yP,6);
                    showDialog("NG: no Exception");
                } catch( ArrayIndexOutOfBoundsException aioe ) {
                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J011_2106_0147
                g.dispose();
                try {
                    g.fillPolygon(xP,yP,4);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
// 2002/07/26 DoJa1.5        case 12:                    /* fillPolygon() */
// 2002/07/26 DoJa1.5            switch( index2 ) {
// 2002/07/26 DoJa1.5            case 0:
// 2002/07/26 DoJa1.5                // J011_2106_0148
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.fillPolygon(null,yP,0,nP);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( NullPointerException npe ) {
// 2002/07/26 DoJa1.5                    showDialog("NullPointerException:"+npe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 1:
// 2002/07/26 DoJa1.5                // J011_2106_0149
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.fillPolygon(xP,null,0,nP);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( NullPointerException npe ) {
// 2002/07/26 DoJa1.5                    showDialog("NullPointerException:"+npe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 2:
// 2002/07/26 DoJa1.5                // J011_2106_0150
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.fillPolygon(null,null,0,nP);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( NullPointerException npe ) {
// 2002/07/26 DoJa1.5                    showDialog("NullPointerException:"+npe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 3:
// 2002/07/26 DoJa1.5                // J011_2106_0151
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.fillPolygon(xP,yP,-1,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 4:
// 2002/07/26 DoJa1.5                // J011_2106_0152
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                    g.fillPolygon(xP,yP,0,-4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 5:
// 2002/07/26 DoJa1.5                // J011_2106_0153
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.fillPolygon(xP,yP,6,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 6:
// 2002/07/26 DoJa1.5                // J011_2106_0154
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.fillPolygon(xP,yP,2,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( ArrayIndexOutOfBoundsException aioe ) {
// 2002/07/26 DoJa1.5                    showDialog("ArrayIndexOutOfBoundsException:"+aioe.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 7:
// 2002/07/26 DoJa1.5                // J011_2106_0155
// 2002/07/26 DoJa1.5                g.dispose();
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.fillPolygon(xP,yP,0,4);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( UIException uie ) {
// 2002/07/26 DoJa1.5                    showUIException(uie);
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            break;
        case 10:                    /* drawString() */
// 2002/07/26 DoJa1.5        case 13:                    /* drawString() */
            switch( index2 ) {
            case 0:
                // J011_2106_0156
                try {
                    g.drawString(null,0,0);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0157
                g.dispose();
                try {
                    g.drawString("drawString",0,10);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 11:                    /* drawChars() */
// 2002/07/26 DoJa1.5        case 14:                    /* drawChars() */
            String s = new String("Chars");
            char[] cs = s.toCharArray();
            switch( index2 ) {
            case 0:
                // J011_2106_0158
                try {
                    g.drawChars(null,0,0,0,cs.length);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("NullPointerException:"+npe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_2106_0159
                try {
                    g.drawChars(cs,0,0,-1,cs.length);
                    showDialog("NG: no Exception");
                } catch( StringIndexOutOfBoundsException aioe ) {
                    showDialog("StringIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_2106_0160
                try {
                    g.drawChars(cs,0,0,0,-1);
                    showDialog("NG: no Exception");
                } catch( StringIndexOutOfBoundsException aioe ) {
                    showDialog("StringIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J011_2106_0161
                try {
                    g.drawChars(cs,0,0,cs.length+1,1);
                    showDialog("NG: no Exception");
                } catch( StringIndexOutOfBoundsException aioe ) {
                    showDialog("StringIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J011_2106_0162
                try {
                    g.drawChars(cs,0,0,3,cs.length);
                    showDialog("NG: no Exception");
                } catch( StringIndexOutOfBoundsException aioe ) {
                    showDialog("StringIndexOutOfBoundsException:"+aioe.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J011_2106_0163
                g.dispose();
                try {
                    g.drawChars(cs,0,0,0,cs.length);
                    showDialog("NG: no Exception");
                } catch( UIException uie ) {
                    showUIException(uie);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 12:                    /* setPictoColorEnabled() */
// 2002/07/26 DoJa1.5        case 15:                    /* setPictoColorEnabled() */
            // J011_2106_0164
            g.dispose();
            try {
                g.setPictoColorEnabled(true);
                showDialog("NG: no Exception");
            } catch( UIException uie ) {
                showUIException(uie);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
// 2002/07/26 DoJa1.5        case 16:                    /* clipRect() */
// 2002/07/26 DoJa1.5            switch( index2 ) {
// 2002/07/26 DoJa1.5            case 0:
// 2002/07/26 DoJa1.5                // J011_2106_0165
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.clipRect(0,0,-1,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 1:
// 2002/07/26 DoJa1.5                // J011_2106_0166
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.clipRect(0,0,10,-1);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 2:
// 2002/07/26 DoJa1.5                // J011_2106_0167
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.clipRect(0,0,-1,-1);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 3:
// 2002/07/26 DoJa1.5                // J011_2106_0168
// 2002/07/26 DoJa1.5                g.dispose();
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.clipRect(0,0,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( UIException uie ) {
// 2002/07/26 DoJa1.5                    showUIException(uie);
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            break;
// 2002/07/26 DoJa1.5      case 17:                    /* copyArea() */
// 2002/07/26 DoJa1.5            switch( index2 ) {
// 2002/07/26 DoJa1.5            case 0:
// 2002/07/26 DoJa1.5                // J011_2106_0169
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.copyArea(0,0,-1,10,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 1:
// 2002/07/26 DoJa1.5                // J011_2106_0170
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.copyArea(0,0,10,-1,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 2:
// 2002/07/26 DoJa1.5                // J011_2106_0171
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.copyArea(0,0,-1,-1,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 3:
// 2002/07/26 DoJa1.5                // J011_2106_0172
// 2002/07/26 DoJa1.5                g.dispose();
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.copyArea(0,0,10,10,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( UIException uie ) {
// 2002/07/26 DoJa1.5                    showUIException(uie);
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            break;
// 2002/07/26 DoJa1.5      case 18:                    /* setClip() */
// 2002/07/26 DoJa1.5            switch( index2 ) {
// 2002/07/26 DoJa1.5            case 0:
// 2002/07/26 DoJa1.5                // J011_2106_0173
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.setClip(0,0,-1,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 1:
// 2002/07/26 DoJa1.5                // J011_2106_0174
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.setClip(0,0,10,-1);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 2:
// 2002/07/26 DoJa1.5                // J011_2106_0175
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.setClip(0,0,-1,-1);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( IllegalArgumentException iae ) {
// 2002/07/26 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            case 3:
// 2002/07/26 DoJa1.5                // J011_2106_0176
// 2002/07/26 DoJa1.5                g.dispose();
// 2002/07/26 DoJa1.5                try {
// 2002/07/26 DoJa1.5                  g.setClip(0,0,10,10);
// 2002/07/26 DoJa1.5                    showDialog("NG: no Exception");
// 2002/07/26 DoJa1.5                } catch( UIException uie ) {
// 2002/07/26 DoJa1.5                    showUIException(uie);
// 2002/07/26 DoJa1.5                } catch( Exception e ) {
// 2002/07/26 DoJa1.5                    showDialog("NG:" + e.toString());
// 2002/07/26 DoJa1.5                }
// 2002/07/26 DoJa1.5                break;
// 2002/07/26 DoJa1.5            }
// 2002/07/26 DoJa1.5            break;
        case 13:                    /* copy() */
// 2002/07/26 DoJa1.5        case 19:                    /* copy() */
            // J011_2106_0177
            g.dispose();
            try {
                Graphics gg = g.copy();
                showDialog("NG: no Exception");
            } catch( UIException uie ) {
                showUIException(uie);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 14:                    /* lock() */
// 2002/07/26 DoJa1.5        case 20:                    /* lock() */
            // J011_2106_0178
            g.dispose();
            try {
                g.lock();
                showDialog("NG: no Exception");
            } catch( UIException uie ) {
                showUIException(uie);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 15:                    /* unlock() */
// 2002/07/26 DoJa1.5        case 21:                    /* unlock() */
            // J011_2106_0179
            g.dispose();
            try {
                g.unlock(true);
                showDialog("NG: no Exception");
            } catch( UIException uie ) {
                showUIException(uie);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 16:                    /* drawLine() */
// 2002/07/26 DoJa1.5        case 22:                    /* drawLine() */
            // J011_2106_0180
            g.dispose();
            try {
                g.drawLine(0,0,10,10);
                showDialog("NG: no Exception");
            } catch( UIException uie ) {
                showUIException(uie);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        }
    }


    /**
     * UIException result display method
     * @param   uie     UIException
     */
    public void showUIException( UIException uie ) {
        if( uie.getStatus() == uie.ILLEGAL_STATE ) {
            showDialog("UIException(ILLEGAL_STATE):"+uie.getMessage());
        } else {
            showDialog("NG:UIException(status=" + uie.getStatus() +
                        "):" + uie.getMessage());
        }
    }
}
