/**
 * J011_2301_0301
 *
 *
 *
 * IApplication class action check(normal route)
 *
 * $Id: J011_2301_0301.java,v 1.2 2001/12/26 08:12:16 yaeda Exp $
 */

import com.nttdocomo.ui.*;

/**
 * IApplication class action check main class
 * @extends IApplication
 */

public class J011_2301_0301 extends IApplication {
    private String[] args;
    private boolean flag = false;
    public static IApplication iapp;


   /**
    * starting method for I-appli
    */

//J011_2301_0306,J011_2305_0107
    public void start () {
        flag = true;
        iapp = this;
        Display.setCurrent(new MainPanel(flag));
    }
    
    /* return the current application */
    public static IApplication getIapp() {
        return iapp;
    }
    

    /* resuming */
//J011_2301_0307,J011_23050108
    public void resume() {
        Display.setCurrent(new NextPanel2());
    }
}

/**
 * Iapplication class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    
    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private String[] url = new String[1];;
    private String[] menuListItem = {
            "01 getCurrentApp",
            "02 getArgs",
            "03 getSourceURL",
// 2002/07/26 DoJa1.5            "04 getLaunchType",
            "05 start",
            "06 resume",
            "07 terminate"
// 2002/07/26 DoJa1.5            "07 terminate",
// 2002/07/26 DoJa1.5             "08 launch"
    };
    private Button button = new Button("execute");
    private boolean flag;

    /**
     * Constructor of MainPanel class
     * @param aflag the start method judgement
     */
    public MainPanel(boolean aflag) {
        flag = aflag;

        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {
        setTitle("API class normal route");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);
        add(textBox);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* clearing menu list */
        if ( aComponent == menuList ) {
            textBox.setText("");
        }

        if( aComponent == button ){
            switch(menuList.getSelectedIndex()){
                case 0:
//J011_2301_0305,J011_2304_0101
                    if ( J011_2301_0301.getIapp() == IApplication.getCurrentApp() ) {
                        textBox.setText("getCurrentApp:OK");
                    }
                    break;
                case 1:
//J011_2301_0301,J011_2305_0101
                    String[] startParameter = IApplication.getCurrentApp().getArgs();
                    String stParameter = "";
                    if ( startParameter.length != 0 ) {
                        for (int i=0; i<startParameter.length; i++) {
                            stParameter = stParameter.concat(startParameter[i]);
                        }
                    } else {
                        stParameter = ("null");
                    }
                    textBox.setText("getArgs:" + stParameter );
                    break;
                case 2:
//J011_2301_0303,J011_2305_0105
                    textBox.setText("getSourceURL:" + IApplication.getCurrentApp().getSourceURL());
                    break;
// 2002/07/26 DoJa1.5                case 3:
// 2002/07/26 DoJa1.5 //J011_2301_0304,J011_2305_0106
// 2002/07/26 DoJa1.5                    textBox.setText("getLaunchType:" + IApplication.getCurrentApp().getLaunchType());
// 2002/07/26 DoJa1.5                    break;
                case 3:
// 2002/07/26 DoJa1.5                case 4:
                    if ( flag = true ) {
                        textBox.setText("start:OK");
                    } else {
                        textBox.setText("start:NG");
                    }
                    break;
                case 4:
// 2002/07/26 DoJa1.5                case 5:
                    textBox.setText("interrupt the operation with a phone call, check the status after putting down the phone");
                    break;
                case 5:
// 2002/07/26 DoJa1.5                case 6:
                    Dialog dialog = new Dialog(Dialog.DIALOG_INFO,"terminate"); 
                    dialog.setText("display a dialog, then close the application");
                    dialog.show();
//J011_2301_0308,J011_2305_0109
                    IApplication.getCurrentApp().terminate();
                    break;
// 2002/07/26 DoJa1.5                case 7:
// 2002/07/26 DoJa1.5                    url[0] = (IApplication.getCurrentApp().getSourceURL()+"/test.html");
// 2002/07/26 DoJa1.5 //J011_2301_0309,J011_2305_0110,J011_2305_0111,J011_2305_0112
// 2002/07/26 DoJa1.5                    IApplication.getCurrentApp().launch(IApplication.getCurrentApp().LAUNCH_BROWSER,url);
// 2002/07/26 DoJa1.5                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {
    }

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Iapplication the creation check class1
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel2 extends Panel implements SoftKeyListener {
    private TextBox textBox = new TextBox("after putting down the phone, verify that this window is shown on the display", 20, 3, TextBox.DISPLAY_ANY);
    /**
     * Constructor of MainPanel class
     */
    public NextPanel2() {
        add(textBox);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");


        /* setting the listener */
        setSoftKeyListener(this);
  
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {
    }

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

}
