/**
 * J011_2305_0102
 *
 *
 *
 * IApplication class action check(normal route)
 *
 * $Id: J011_2305_0102.java,v 1.1 2001/12/02 08:09:43 yaeda Exp $
 */

import com.nttdocomo.ui.*;

/**
 * IApplication class action check main class
 * @extends IApplication
 */
public class J011_2305_0102 extends IApplication {

   /**
    * starting method for I-appli
    */
    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Iapplication class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
    private Button button = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {

        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {
        setTitle("API class normal route");
        add(button);
        add(textBox);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if( aComponent == button ){
            String[] startParameter = IApplication.getCurrentApp().getArgs();
//J011_2305_0102
            if ( startParameter.length == 0 ) {
                textBox.setText("getArgs:OK");
            } else {
                String stParameter = "";
                for (int i=0; i<startParameter.length; i++) {
                    stParameter = stParameter.concat(startParameter[i]);
                }
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}
