/**
 * J011_2404_0101
 *
 * Image class action check(normal route)
 *
 * $Id: J011_2404_0101.java,v 1.2 2002/05/23 10:16:21 torikatu Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.lang.*;


/**
 * Image class action check main class
 * @extends IApplication
 */
public class J011_2404_0101 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Image class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menu1 = {
        "01 method's behavior",
        "02 behavior for thrown exceptions"
    };

    String[] menu2_01 = {
//2002/07/26 DoJa1.5        "01 createImage",
        "02 getWidth",
        "03 getHeight",
        "04 dispose",
//2002/07/26 DoJa1.5        "05 getGraphics"
    };

    String[] menu2_02 = {
//2002/07/26 DoJa1.5        "01 createImage(0,+)",
//2002/07/26 DoJa1.5        "02 createImage(+,0)",
//2002/07/26 DoJa1.5        "03 createImage(0,0)",
        "04 dispose",
//2002/07/26 DoJa1.5        "05 getGraphics",
//2002/07/26 DoJa1.5        "06 getGraphics->dispose",
        "07 getWidth->dispose",
        "08 getHeight->dispose"
    };

    Frame      nextFrame;
    Label      title      = new Label("test of Image behavior");
    ListBox    menu_Li    = new ListBox(ListBox.CHOICE);
    ListBox    menu_Li2   = new ListBox(ListBox.CHOICE);
    Button     execButton = new Button("execute");
    int        firstType;
    int        secondType;
    Image      img;
    Image      img2;
    ImageLabel il;
    ImageLabel il2;
    MediaImage mi;
    Graphics   grp;

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(title);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * process when the action other than softkey happens
     * @param source the component on which the event occurs
     * @param type event type
     * @param param event parameter
     */
    public void componentAction(Component source, int type, int param) {
        /* when item in the menu1 is selected */
        if (source == menu_Li && type == ComponentListener.SELECTION_CHANGED) {

            /* get the chosen item */
            firstType = menu_Li.getSelectedIndex();

            /* set the selection list in menu 1 */
            switch (firstType) {
                case 0:
                    menu_Li2.setItems(menu2_01);
                    break;
                case 1:
                    menu_Li2.setItems(menu2_02);
                    break;
                default:
                    break;
            }
        }

        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {

            /* get the chosen item */
            secondType = menu_Li2.getSelectedIndex();

            switch (firstType) {
                case 0:
                    /* to method action checking */
                    nextFrame = new NextPanel(this, firstType, secondType);
                    /* display screen which have been set */
                    Display.setCurrent(nextFrame);
                    break;
                case 1:
                    /* to the exception action check */
                    errTest();
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * execute exception action check
     */
    public void errTest() {
        String msg;
        String stat;

        switch (secondType) {
//J011_2406_0101
//2002/07/26 DoJa1.5            case 0:
                /* in case of createImage(0,+) */
//2002/07/26 DoJa1.5                try {
//2002/07/26 DoJa1.5                    img.createImage(0,30);
//2002/07/26 DoJa1.5                } catch (IllegalArgumentException e) {
//2002/07/26 DoJa1.5                    msg = new String("IAException:"+e.getMessage());
//2002/07/26 DoJa1.5                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
//2002/07/26 DoJa1.5                } catch (Exception e) {
//2002/07/26 DoJa1.5                    showDialog(e.toString());
//2002/07/26 DoJa1.5                }
//2002/07/26 DoJa1.5                break;

//J011_2406_0102
//2002/07/26 DoJa1.5            case 1:
                /* in case of createImage(+,0) */
//2002/07/26 DoJa1.5                try {
//2002/07/26 DoJa1.5                    img.createImage(30, 0);
//2002/07/26 DoJa1.5                } catch (IllegalArgumentException e) {
//2002/07/26 DoJa1.5                    msg = new String("IAException:"+e.getMessage());
//2002/07/26 DoJa1.5                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
//2002/07/26 DoJa1.5                } catch (Exception e) {
//2002/07/26 DoJa1.5                    showDialog(e.toString());
//2002/07/26 DoJa1.5                }
//2002/07/26 DoJa1.5                break;

//J011_2406_0103
//2002/07/26 DoJa1.5            case 2:
                /* in case of createImage(0,0) */
//2002/07/26 DoJa1.5                try {
//2002/07/26 DoJa1.5                    img.createImage(0, 0);
//2002/07/26 DoJa1.5                } catch (IllegalArgumentException e) {
//2002/07/26 DoJa1.5                    msg = new String("IAException:"+e.getMessage());
//2002/07/26 DoJa1.5                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
//2002/07/26 DoJa1.5                } catch (Exception e) {
//2002/07/26 DoJa1.5                    showDialog(e.toString());
//2002/07/26 DoJa1.5                }
//2002/07/26 DoJa1.5                break;

//J011_2406_0104
//2002/07/26 DoJa1.5            case 3:
			case 0:		//2002/07/26 DoJa1.5
                /* in case of dispose */
//2002/07/26 DoJa1.5                    img = Image.createImage(50, 50);
//2002/07/26 DoJa1.5				try {

				try {
					/* get the image */
					mi = MediaManager.getImage("resource:///dosei.jpeg");
					/* load the image */
					mi.use();
					/* create image by other than createImage */
					img2 = mi.getImage();

                    il = new ImageLabel(img2);
                    /* dispose img */
                    img2.dispose();
                    /* using after img disposing */
                    int retNum = img2.getWidth();
                } catch (UIException e) {
                    if (e.getStatus() == UIException.ILLEGAL_STATE) {
                        stat = new String("(OK)");
                    } else {
                        stat = new String("(NG)");
                    }
                    msg = new String("UIException:"+e.getMessage()+stat);
                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
                } catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

//J011_2406_0105
//2002/07/26 DoJa1.5            case 4:
                /* in case of getGraphics */
//2002/07/26 DoJa1.5                try {
                    /* get the image */
//2002/07/26 DoJa1.5                    mi = MediaManager.getImage("resource:///dosei.jpeg");
                    /* load the image */
//2002/07/26 DoJa1.5                    mi.use();

                    /* create image by other than createImage */
//2002/07/26 DoJa1.5                    img2 = mi.getImage();
//2002/07/26 DoJa1.5                    il2 = new ImageLabel(img2);

//2002/07/26 DoJa1.5                } catch (Exception e) {
//2002/07/26 DoJa1.5                    showDialog(" ");
//2002/07/26 DoJa1.5                }

//2002/07/26 DoJa1.5                try {
                    /* call the result to grp created by other than createImage */
//2002/07/26 DoJa1.5                    grp = img2.getGraphics();
//2002/07/26 DoJa1.5                } catch (UnsupportedOperationException e) {
//2002/07/26 DoJa1.5                    msg = new String("UnsupportedOperationException:"+e.getMessage());
//2002/07/26 DoJa1.5                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
//2002/07/26 DoJa1.5                } catch (Exception e) {
//2002/07/26 DoJa1.5                    showDialog(e.toString());
//2002/07/26 DoJa1.5                }
//2002/07/26 DoJa1.5                break;

//J011_2406_0106
//2002/07/26 DoJa1.5            case 5:
                /* in case of getGraphics ->dispose */
//2002/07/26 DoJa1.5                img = Image.createImage(100, 40);
                /* dispose image */
//2002/07/26 DoJa1.5                img.dispose();
//2002/07/26 DoJa1.5                try {
                    /* calling getGraphics after disposing */
//2002/07/26 DoJa1.5                    grp = img.getGraphics();
//2002/07/26 DoJa1.5                } catch (UIException e) {
//2002/07/26 DoJa1.5                    if (e.getStatus() == UIException.ILLEGAL_STATE) {
//2002/07/26 DoJa1.5                        stat = new String("(OK)");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        stat = new String("(NG)");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    msg = new String("UIException:"+e.getMessage()+stat);
//2002/07/26 DoJa1.5                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
//2002/07/26 DoJa1.5                } catch (Exception e) {
//2002/07/26 DoJa1.5                    showDialog(e.toString());
//2002/07/26 DoJa1.5                }
//2002/07/26 DoJa1.5                break;

//J011_2406_0107
//2002/07/26 DoJa1.5            case 6:
			case 1:		//2002/07/26 DoJa1.5
                /* in case of getWidth->dispose */
//2002/07/26 DoJa1.5                img = Image.createImage(100, 40);

				try {
					/* get the image */
					mi = MediaManager.getImage("resource:///dosei.jpeg");
					/* load the image */
					mi.use();
					/* create image by other than createImage */
					img2 = mi.getImage();

                /* dispose image */
                img2.dispose();
//2002/07/26 DoJa1.5				try{
                    /* calling getWidth after disposing */
                    int width_num = img2.getWidth();
                } catch (UIException e) {
                    if (e.getStatus() == UIException.ILLEGAL_STATE) {
                        stat = new String("(OK)");
                    } else {
                        stat = new String("(NG)");
                    }
                    msg = new String("UIException:"+e.getMessage()+stat);
                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
                } catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

//J011_2406_0108
//2002/07/26 DoJa1.5            case 7:
			case 2:		//2002/07/26 DoJa1.5
                /* in case of getHeight->dispose */
//2002/07/26 DoJa1.5                img = Image.createImage(100, 40);

				try {
					/* get the image */
					mi = MediaManager.getImage("resource:///dosei.jpeg");
					/* load the image */
					mi.use();
					/* create image by other than createImage */
					img2 = mi.getImage();

                /* dispose image */
                img2.dispose();
                    /* calling getHeight after disposing */
//2002/07/26 DoJa1.5			try{
                    int height_num = img2.getHeight();
                } catch (UIException e) {
                    if (e.getStatus() == UIException.ILLEGAL_STATE) {
                        stat = new String("(OK)");
                    } else {
                        stat = new String("(NG)");
                    }
                    msg = new String("UIException:"+e.getMessage()+stat);
                    showDialog(msg);
                /* in case of the exception which is not to be thrown  */
                } catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

            default:
                break;
        }
    }

    /**
     * setting of the dialog box which is going to be displayed
     * @param str the message on the dialog
     */
    public void showDialog(String str) {
        /* create the dialog box */
        Dialog    d = new Dialog(Dialog.BUTTON_OK, "an error is detected");
        /* put the character sequence */
        d.setText(str);
        /* display of the dialog box */
        d.show();
    }
}


/**
 * Image class method checking
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel extends Panel implements SoftKeyListener {

    Frame      frame;
    int        firstType;
    int        secondType;
    TextBox    resultText = new TextBox("", 20, 4, TextBox.DISPLAY_ANY);
    String     resultstr  = new String();
    MediaImage mi;
    Image      img;
    Image      img2;
    ImageLabel il;
    ImageLabel il2;
    Graphics   grp;

    /**
     * MainPanel constructor(initializing)
     * @param f  pass the screen on
     * @param type the selected value in the listbox1
     * @param type2 the selected value in the listbox2
     */
    public NextPanel(Frame f, int type, int type2) {

        /* setting of the parameter */
        frame = f;
        firstType = type;
        secondType = type2;
        
        /* display the result  */
        init();
        showResult();
    }

    /**
     * execute each setting
     */
    public void init() {
        /* setting of the display item */
        setTitle("result");
        setSoftLabel(Frame.SOFT_KEY_1, "back");

        /* set the background color so that it is easy to see the result */
        this.setBackground(0xffff00);

        /* register the softkey listener */
        setSoftKeyListener(this);
    }

    /**
     * method which display the result
     */
    public void showResult() {

		try {		//2002/07/26 DoJa1.5
			/* get the image */
			mi = MediaManager.getImage("resource:///dosei.jpeg");	//2002/07/26 DoJa1.5
			/* load the image */
			mi.use();		//2002/07/26 DoJa1.5
			/* create image by other than createImage */
			img2 = mi.getImage();		//2002/07/26 DoJa1.5

        /* divide processing */
        switch (secondType) {
//J011_2404_0101
//2002/07/26 DoJa1.5            case 0:
//2002/07/26 DoJa1.5                /*  */
//2002/07/26 DoJa1.5                img = Image.createImage(80, 30);
                /* the creation by image is pasted on the image label */
//2002/07/26 DoJa1.5                il = new ImageLabel(img);

                /* setting the text of checking */
//2002/07/26 DoJa1.5                resultstr = " ";
//2002/07/26 DoJa1.5                resultText.setText(resultstr);

//2002/07/26 DoJa1.5                add(resultText);
//2002/07/26 DoJa1.5                add(il);
//2002/07/26 DoJa1.5                break;

//J011_2405_0101
//2002/07/26 DoJa1.5            case 1:
			case 0:		//2002/07/26 DoJa1.5
                /* getWidth method action check */
//2002/07/26 DoJa1.5                img = Image.createImage(80, 30);
                /* the creation by image is pasted on the image label */
                il = new ImageLabel(img2);

                /* setting the text of checking */
//2002/09/02 DoJa1.5                resultstr = "get width of 30*80(If the number 80 was displayed,OK):width= ";
                resultstr = "get width of 90*90(If the number 90 was displayed,OK):width=";


                /* get the width while displaying in the text */
//2002/08/15 DoJa1.5                resultText.setText(resultstr+img2.getWidth());
                resultText.setText(resultstr+il.getWidth());

                add(resultText);
                add(il);
                break;

//J011_2405_0102
//2002/07/26 DoJa1.5            case 2:
			case 1:		//2002/07/26 DoJa1.5
                /* getHeight method action check */
//2002/07/26 DoJa1.5                img = Image.createImage(80, 30);
                /* the creation by image is pasted on the image label */
                il = new ImageLabel(img2);

                /* setting the text of checking */
//2002/09/02 DoJa1.5                resultstr = "get height of 30*80(If the number 30 was displayed,OK):height= ";
                resultstr = "get height of 90*90(If the number 90 was displayed,OK):height=";


                /* get the height while displaying in the text */
//2002/08/15 DoJa1.5                resultText.setText(resultstr+img2.getHeight());
                resultText.setText(resultstr+il.getHeight());

                add(resultText);
                add(il);
                break;

//J011_2405_0103
//2002/07/26 DoJa1.5            case 3:
			case 2:		//2002/07/26 DoJa1.5
                /* dispose method action check */
                try {
//2002/07/26 DoJa1.5                    img = Image.createImage(80, 30);
                    /* the creation by image is pasted on the image label */
                    il = new ImageLabel(img2);
                    /* dispose the image */
                    img2.dispose();
                    /* calling other mthod after disposing */
                    img2.getHeight();
                } catch (UIException e) {
                    /* set the text about checking */
                    resultstr = "revocation of the image is successful:"+e.getMessage();
                    resultText.setText(resultstr);
                }
                add(resultText);
                break;

//J011_2405_0104
//2002/07/26 DoJa1.5            case 4:
                /* getGraphics method action check */
//2002/07/26 DoJa1.5                img = Image.createImage(100, 40);
//2002/07/26 DoJa1.5                grp = img.getGraphics();
                /* draw with graphic */
//2002/07/26 DoJa1.5                grp.lock();
//2002/07/26 DoJa1.5                grp.setColor(Graphics.getColorOfRGB(0x00, 0x88, 0x00));
//2002/07/26 DoJa1.5                grp.drawLine(10, 20, 90, 20);

//2002/07/26 DoJa1.5                grp.unlock(true);
//2002/07/26 DoJa1.5                il = new ImageLabel(img);

                /* setting the text of checking */
//2002/07/26 DoJa1.5                resultstr = " ";
                /* write on the text */
//2002/07/26 DoJa1.5                resultText.setText(resultstr);

                /* adding the component */
//2002/07/26 DoJa1.5                add(il);
//2002/07/26 DoJa1.5                add(resultText);
//2002/07/26 DoJa1.5                break;

            default:
                break;
        }

		} catch (Exception e) {		//2002/07/26 DoJa1.5
			resultstr = "loading failed.";
			resultText.setText(resultstr);
		}		//2002/07/26 DoJa1.5

    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            Display.setCurrent(frame);
        }
    }
}
