/**
 * J011_2605_0101
 *
 * ImageLabel class action check (normal route)
 * method action check
 *
 * $Id: J011_2605_0101.java,v 1.1 2001/12/01 13:28:00 horikoshi Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;

/**
 * ImageLabel class action check main class
 * @extends IApplication
 */
public class J011_2605_0101 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * ImageLabel class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menu1 = {
        "01 setImage",
        "02 setLocation",
        "03 setSize",
        "04 setBackground",
        "05 setForeground",
        "06 setVisible",
        "07 getX",
        "08 getY",
        "09 getWidth",
        "10 getHeight",
        "11 check the behavior for thrown exceptions"
    };

    String[] menu2_01 = {
        "01 set the image on the label"
    };

    String[] menu2_02 = {
        "01 No addition exists, location settable",
        "02 Some additions exist, updating permitted",
        "03 No addition exists, updating not permitted",
        "04 Some additions exist, updating not permitted"
    };

    String[] menu2_03 = {
        "01 No addition exists, set size of the component",
        "02 Some additions exist, updating permitted",
        "03 width<0",
        "04 height<0",
        "05 w<0 and h<0"
    };

    String[] menu2_04 = {
        "01 no addition exists, background color is settable",
        "02 no addition exists, change acceptable",
        "03 incorrect value"
    };

    String[] menu2_05 = {
        "01 no addition exists, background color is settable",
        "02 no addition exists, change acceptable",
        "03 incorrect value"
    };

    String[] menu2_06 = {
        "01 no addition exists, true",
        "02 no addition exists, false",
        "03 additions exist, true",
        "04 additions exist, false",
    };

    String[] menu2_07 = {
        "01 get the x-coordinate"
    };

    String[] menu2_08 = {
        "01 get the y-coordinate"
    };

    String[] menu2_09 = {
        "01 get the width"
    };

    String[] menu2_10 = {
        "01 get the height"
    };

    String[] menu2_11 = {
        "01 setImage->dispose",
        "02 setImage(null)",
//2002/09/09 DoJa1.5        "03 setImage model dependence",
		"03 use->dispose",
        "04 ImageLabel(null)",
        "05 ImageLabel->dispose"
    };

    Frame   nextFrame;
    Label   title      = new Label("ImageLabel operation test");
    ListBox menu_Li    = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    int     firstType;
    int     secondType;
    int     switchFlg = 1;
    NextPanelOn np;
    MediaImage mi;
    ImageLabel imgLabel;
    ImageLabel imgLabel2;
    Image      img;
    String     stat;

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            /* processing when the exception occurs */
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "an error is detected");
            errDialog.setText(e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    void showMainPanel() {

        /* setting of the display item */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(title);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * process when the action other than softkey happens
     * @param source the component on which the event occurs
     * @param type event type
     * @param param event parameter
     */
    public void componentAction(Component source, int type, int param) {
        /* when item in the menu1 is selected */
        if (source == menu_Li && type == ComponentListener.SELECTION_CHANGED) {

            /* get the chosen item */
            firstType = menu_Li.getSelectedIndex();

            /* set the selection list in menu 1 */
            switch (firstType) {
                case 0:
                    menu_Li2.setItems(menu2_01);
                    break;
                case 1:
                    menu_Li2.setItems(menu2_02);
                    break;
                case 2:
                    menu_Li2.setItems(menu2_03);
                    break;
                case 3:
                    menu_Li2.setItems(menu2_04);
                    break;
                case 4:
                    menu_Li2.setItems(menu2_05);
                    break;
                case 5:
                    menu_Li2.setItems(menu2_06);
                    break;
                case 6:
                    menu_Li2.setItems(menu2_07);
                    break;
                case 7:
                    menu_Li2.setItems(menu2_08);
                    break;
                case 8:
                    menu_Li2.setItems(menu2_09);
                    break;
                case 9:
                    menu_Li2.setItems(menu2_10);
                    break;
                case 10:
                    menu_Li2.setItems(menu2_11);
                    break;
                default:
                    break;
            }
        }

        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {

            /* get the chosen item */
            secondType = menu_Li2.getSelectedIndex();

            try {
                /* 
                 * divide processing between LayoutManager-ON and OFF
                 * LayoutManager ON(1) =NextPanelOn
                 * LayoutManager OFF(0) =NextPanelOff
                 */
                switch (firstType) {
                    /* setImage test */
                    case 0:
                        switchFlg = 1;
                        break;
                    /* setLocation test */
                    case 1:
                        /* LayoutManager OFF in case of secondType=0,1 */
                        if (secondType == 0 || secondType == 1) {
                            switchFlg = 0;
                        /* LayoutManager On in case of secondType=2,3 */
                        } else {
                            switchFlg = 1;
                        }
                        break;
                    /* setSize test */
                    case 2:
                        switchFlg = 1;
                        break;
                    /* setBackground test */
                    case 3:
                        switchFlg = 1;
                        break;
                    /* setForeground test */
                    case 4:
                        switchFlg = 1;
                        break;
                    /* setVisible test */
                    case 5:
                        switchFlg = 1;
                        break;
                    /* getX test */
                    case 6:
                        switchFlg = 0;
                        break;
                    /* getY test */
                    case 7:
                        switchFlg = 0;
                        break;
                    /* getWidth test */
                    case 8:
                        switchFlg = 1;
                        break;
                    /* getHeight test */
                    case 9:
                        switchFlg = 1;
                        break;
                    /* exception test */
                    case 10:
                        if (secondType == 2) {
                            /* automatically trembling of setImage is here */
                            switchFlg = 1;
                        } else {
                            switchFlg = 2;
                        }
                        break;
                    default:
                        break;
                }

                /* execute the processing */
                if (switchFlg == 1) {
                    /* processing layout manager ON */
                    NextPanelOn np = new NextPanelOn(this);
                    Display.setCurrent(np);
                    np.Resultinit(firstType, secondType);
                } else if (switchFlg == 0) {
                    /* processing layout manager OFF */
                    NextPanelOff np = new NextPanelOff(this);
                    Display.setCurrent(np);
                    np.Resultinit(firstType, secondType);
                } else if (switchFlg == 2) {
                    /* execute exception action check */
                    myException();
                }

            } catch (Exception e) {
                /* in case of exception */
                throw new RuntimeException("The selected item is not exist.");
            }
        }
    }

    /**
     * exception action check method
     */
    public void myException() {

        try {
            mi = MediaManager.getImage("resource:///dosei.jpeg");
            mi.use();
        } catch (Exception e) {
            /* in case of image file loading error */
            Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,
                                    "loading the image failed.");
        }
        img = mi.getImage();
        imgLabel = new ImageLabel();

        switch (secondType) {
//J011_2606_0101
            case 0:
                /* when the image is called after disposing */
                try {
                    mi.unuse();
                    img.dispose();
                    imgLabel.setImage(img);
                } catch (UIException e) {
                    if (e.getStatus() == UIException.ILLEGAL_STATE) {
                        stat = new String("(OK)");
                    } else {
                        stat = new String("(NG)");
                    }
                    showDialog("UIException:"+e.getMessage()+stat);
                /* in case of the exception which is not to be thrown  */
                } catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

//J011_2606_0102
            case 1:
                /* when set null on image of setImage */
                try {
                    img = mi.getImage();
                    imgLabel = new ImageLabel();
                    imgLabel.setImage(null);
                } catch (NullPointerException e) {
                    showDialog("NullPointerException:"+e.getMessage());
                /* in case of the exception which is not to be thrown  */
                } catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

            case 2:
                break;

//J011_2606_0104
            case 3:
                /* when set null on image of ImageLabel */
                try {
                    imgLabel2 = new ImageLabel(null);
                } catch (NullPointerException e) {
                    showDialog("NullPointerException:"+e.getMessage());
                /* in case of the exception which is not to be thrown  */
                } catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

//J011_2606_0105
            case 4:
                /* calling ImageLabel after it has been disposed */
                try {
                    mi.unuse();
                    img.dispose();
                    imgLabel2 = new ImageLabel(img);
                } catch (UIException e) {
                    if (e.getStatus() == UIException.ILLEGAL_STATE) {
                        stat = new String("(OK)");
                    } else {
                        stat = new String("(NG)");
                    }
                    showDialog("UIException:"+e.getMessage()+stat);
                /* in case of the exception which is not to be thrown  */
                } catch (Exception e) {
                    showDialog(e.toString());
                }
                break;
            default:
                break;
            }
        }

    /**
     * setting of the dialog box which is going to be displayed
     * @param str the message on the dialog
     */
    public void showDialog(String str) {
        /* create the dialog box */
        Dialog    d = new Dialog(Dialog.BUTTON_OK, "result");
        /* put the character sequence */
        d.setText(str);
        /* display of the dialog box */
        d.show();
    }
}

/**
 * action check in case of layout manager ON
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanelOn extends Panel implements SoftKeyListener, ComponentListener {

    Frame      mainFrame;
    Frame      nextFrame;
    Label      title      = new Label("ImageLabel method result");
    TextBox    resultText = new TextBox("", 20, 4, TextBox.DISPLAY_ANY);
    TextBox    showText   = new TextBox("", 20, 1, TextBox.NUMBER);
    Button     execButton = new Button("update");
    Dialog     err        = new Dialog(Dialog.DIALOG_INFO, "an error is detected");
    String     resultstr  = new String();
    int        firstType;
    int        secondType;
    int        execFlg = 0;
    Image      img;
    ImageLabel imgLabel;
    MediaImage mi;
	// 2003/03/27 ->
	Timer timer;
	// 2003/03/27 <-

    /**
     * NextPanelOn class constructor(initializing)
     * @param frame pass the screen
     */
    public NextPanelOn(Frame frame) {

        /* setting the parameter */
        mainFrame = frame;
    }

    /**
     * execute each setting
     * @param type the selected value in the listbox1
     * @param type2 the selected value in the listbox2
     */
    public void Resultinit(int type, int type2) {

        try {
            /* display the result of action testing on the screen */
            firstType = type;
            secondType = type2;

            /* add the title only */
            add(title);

            /* display the result  */
            showResult();

        } catch (Exception e) {
            /* processing when the exception occurs */
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "an error is detected");
            errDialog.setText(e.toString());
            errDialog.show();
        }

        /* setting of softkey listener 1 */
        setSoftLabel(Frame.SOFT_KEY_1, "back");

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * display the result( update button is set when something to update exists after it is added
     */
    public void showResult() {

        try {
            /* get the image file from JAR */
            mi = MediaManager.getImage("resource:///dosei.jpeg");

            /* load the image file into the memory */
            mi.use();

//J011_2605_0101
            /* setImage: in case of label image setting */
            if (firstType == 0) {

                img = mi.getImage();
                /* create ImageLabel which is null */
                imgLabel = new ImageLabel();

                /* after that, confirming whether or not it is set by setImage */
                imgLabel.setImage(img);
                add(imgLabel);

                /* setting the text of checking */
                resultstr = "verify that the image is correctly displayed/set";
                resultText.setText(resultstr);
                add(resultText);

//J011_2607_0103
            /* setLocation: adding doesn't occur and position setting is impossible */
            } else if (firstType == 1 && secondType == 2) {

                /* when the component adding doesn't occur and position setting is impossible */
                img = mi.getImage();
                imgLabel = new ImageLabel(img);

                /* setting the image position on the left before adding */
                imgLabel.setLocation(0, 80);
                add(imgLabel);

                /* setting the text of checking */
                resultstr = "verify that the position is not set to (0,80) but set naturally -> result:";
                resultText.setText(resultstr+"("+imgLabel.getX()+","+imgLabel.getY()+")");
                add(resultText);

//J011_2607_0104
            /* setLocation : when adding occurs and updating is impossible */
            } else if (firstType == 1 && secondType == 3) {

                /* when the component adding occurs and updating setting is impossible */
                img = mi.getImage();
                imgLabel = new ImageLabel(img);
                add(imgLabel);

                /* setting the text of checking */
                resultstr = "verify that the position is not changed if the update button was pressed: -> present position:";
                resultText.setText(resultstr+"("+imgLabel.getX()+","+imgLabel.getY()+")");
                add(resultText);

                /* display the update button */
                add(execButton);

            /* in case of setSize: */
            } else if (firstType == 2) {

                switch (secondType) {
//J011_2607_0105
                case 0:
                    /* when the component adding doesn't occur and size setting is possible */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);

                    /* change the component size before adding */
                    imgLabel.setSize(10, 80);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "verify that the size can be set (original size(width=90, height=90)) -> result:";
                    resultText.setText(resultstr+"(width="+imgLabel.getWidth()+",height="+imgLabel.getHeight()+")");
                    add(resultText);
                    break;

//J011_2607_0106
                case 1:
                    /* when the component adding occurs and size updating is possible */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "verify that the size of the image is changed after the update button is pressed";
                    resultText.setText(resultstr+"(width="+imgLabel.getWidth()
                                        +",height="+imgLabel.getHeight()+")");
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

//J011_2607_0107
                case 2:
                    /* width<=0,in case of */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "when the size (width) is a negative value IllegalArgumentException is thrown -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

//J011_2607_0108
                case 3:
                    /* height<=0,in case of */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "when the size (height) is a negative value IllegalArgumentException is thrown -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

//J011_2607_0109
                case 4:
                    /* w<=0 and h<=0,in case of */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "when the size (width, height) is a negative value IllegalArgumentException is thrown -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

                default:
                    break;
                }

            /* in case of setBackground: */
            } else if (firstType == 3) {

                switch (secondType) {
//J011_2607_0110
                case 0:
                    /* when the component adding doesn't occur and setting is possible */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);

                    /* change the component size before adding */
                    imgLabel.setSize(110, 110);
                    imgLabel.setBackground(0x00ffff00);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "verify that the background color is changed to YELLOW (implementation dependent)";
                    resultText.setText(resultstr);
                    add(resultText);
                    break;

//J011_2607_0111
                case 1:
                    /* when the component adding occurs and changing is possible */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);

                    /* set the background the size which is easy to checking */
                    imgLabel.setSize(110, 110);
                    add(imgLabel);

                    /* coloring the background for ease to understand */
                    imgLabel.setBackground(0x00008000);

                    /* setting the text of checking */
                    resultstr = "verify that the background color (behind the image) is changed -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

//J011_2607_0112
                case 2:
                    /* in case of invalid value */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);

                    /* set the background the size which is easy to checking */
                    imgLabel.setSize(110, 110);

                    /* coloring the background for ease to understand */
                    imgLabel.setBackground(0x00008000);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "when an incorrect value is set to the background color, IllegalArgumentException is thrown -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

                default:
                    break;
                }

            /* in case of setForeground: */
            } else if (firstType == 4) {

                switch (secondType) {
//J011_2607_0113
                case 0:
                    /* when the adding doesn't occur and setting is possible */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);

                    /* change the previous background before adding */
                    imgLabel.setForeground(0x00ffff00);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "verify that the foreground color is set (the change is not visible, so if no error is detected, OK)";
                    resultText.setText(resultstr);
                    add(resultText);

                    break;

//J011_2607_0114
                case 1:
                    /* when the adding occurs and changing is possible */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "verify that the foreground color is changed (the change is not visible, so if no error is detected, OK)";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

//J011_2607_0115
                case 2:
                    /* in case of invalid value */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "when an incorrect value is set to the foreground color, IllegalArgumentException is thrown -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

                default:
                    break;
                }

            /* in case of setVisible: */
            } else if (firstType == 5) {

                switch (secondType) {
//J011_2607_0201
                case 0:
                    /* when the component adding doesn't occur and true */
                    img = mi.getImage();
                    imgLabel = new ImageLabel();

                    /* make that true and set the image before adding */
                    imgLabel.setVisible(true);
                    imgLabel.setImage(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "after setting the image true, verify that the image is displayed/set";
                    resultText.setText(resultstr);
                    add(resultText);
                    break;

//J011_2607_0202
                case 1:
                    /* when the component adding doesn't occur and false */
                    img = mi.getImage();
                    imgLabel = new ImageLabel();

                    /* make that false and set the image before adding */
                    imgLabel.setVisible(false);
                    imgLabel.setImage(img);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "after setting the image false, verify that the image is not displayed/set";
                    resultText.setText(resultstr);
                    add(resultText);
                    break;

//J011_2607_0203
                case 2:
                    /* when the component adding occurs and true */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);

                    /* set the component easy to see updating */
                    imgLabel.setSize(110, 110);
                    imgLabel.setBackground(0x00ffff00);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "after displaying the image, set that true, then verify that the image is updated -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

//J011_2607_0204
                case 3:
                    /* when the component adding occurs and false */
                    img = mi.getImage();
                    imgLabel = new ImageLabel(img);

                    /* set the size easy to see updating */
                    imgLabel.setSize(110, 110);
                    imgLabel.setBackground(0x00ffff00);
                    add(imgLabel);

                    /* setting the text of checking */
                    resultstr = "after displaying the image, set that false, then verify that the image is updated -> update button";
                    resultText.setText(resultstr);
                    add(resultText);

                    /* display the update button */
                    add(execButton);
                    break;

                default:
                    break;
                }

            /* in case of getWidth: -> get the width */
            } else if (firstType == 8) {

//J011_2607_0207
                img = mi.getImage();
                imgLabel = new ImageLabel(img);
                add(imgLabel);

                /* set the value of the gotten width in the textbox */
                showText.setText("width ="+String.valueOf(imgLabel.getWidth()));
                add(showText);

                /* set the text of checking (in this case, the size is 90*90) */
                resultstr = "verify that the width (=90) is displayed";
                resultText.setText(resultstr);
                add(resultText);

            /* in case of getHeight -> get the height */
            } else if (firstType == 9) {

//J011_2607_0208
                img = mi.getImage();
                imgLabel = new ImageLabel(img);
                add(imgLabel);

                /* set the value of the gotten height in the textbox */
                showText.setText("height="+String.valueOf(imgLabel.getHeight()));
                add(showText);

                /* set the text of checking (in this case, the size is 90*90) */
                resultstr = "verify that the height (=90) is displayed";
                resultText.setText(resultstr);
                add(resultText);

            /* setImage exception( in case of secondType=2) */
            } else if (firstType == 10) {

//J011_2606_0103

                img = mi.getImage();
				// 2003/03/27 ->
                //imgLabel = new ImageLabel(img);
                //add(imgLabel);

                /* setting the text of checking */
//2002/09/09 DoJa1.5                resultstr = "dispose the image while displaying. in case of an error, check the detail because it's automatic mode.
//2002/09/09 DoJa1.5                resultText.setText(resultstr);
//2002/09/09 DoJa1.5                add(resultText);

                /* display the update button */
                //add(execButton);

				imgLabel = new ImageLabel();
				imgLabel.setImage(img);
				add(imgLabel);
				timer = new Timer();
				timer.setTime(5000);
				timer.setRepeat(false);
				TimerListener tl = new TimerListener() {
					public void timerExpired(Timer t) {
						if (t == timer) {
							try {
								img.dispose();
							} catch (UIException uie) {
								err.setText("UIException:" + uie.getMessage() + "(OK)");
								err.show();
							} catch (Exception e) {
								err.setText("NG:"+e.getMessage());
								err.show();
							}
						}
					}
				};
				timer.setListener(tl);
				timer.start();
				// 2003/03/27 <-
            }

        } catch (Exception e) {
            /* in case of image file loading error */
            Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,
                                    "loading the image failed.");
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* return to the previous screen when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            Display.setCurrent(mainFrame);
        }
    }

    /**
     * update when the update button is pushed
     * @param source the component on which the event occurs
     * @param ivent event type
     * @param param event parameter
     */
    public void componentAction(Component source, int ivent, int param) {

        /* when the select button is pushed on condition that the focus is on the update button */
        if (source == execButton 
            && ivent == ComponentListener.BUTTON_PRESSED) {

//J011_2607_0104
            /* setLocation: checking whether or not the updating is possible */
            if (firstType == 1 && secondType == 3) {
                imgLabel.setLocation(0, 30);
                resultText.setText("press the update button. verify that the coordinate is not changed to (0,30). ->"+
                                    "("+imgLabel.getX()+","+imgLabel.getY()+")");

//J011_2607_0106
            /* setSize : checking whether or not the size updating is possible */
            } else if (firstType == 2 && secondType == 1) {
                imgLabel.setSize(50, 50);
                resultText.setText("press the update button. check the size ->"+"(width="+imgLabel.getWidth()
                                        +",height="+imgLabel.getHeight()+")");

//J011_2607_0107
            /* setSize:check IllegalArgumentException */
            } else if (firstType == 2 && secondType == 2) {
                try {
                    /* set a negative value to the setSize width */
                    imgLabel.setSize(-1, 70);
                } catch (IllegalArgumentException e) {
                    err.setText("IAE:"+e.getMessage());
                    err.show();
                }

//J011_2607_0108
            /* setSize:check IllegalArgumentException */
            } else if (firstType == 2 && secondType == 3) {
                try {
                    /* set a negative value to the setSize height */
                    imgLabel.setSize(10, -1);
                } catch (IllegalArgumentException e) {
                    err.setText("IAE:"+e.getMessage());
                    err.show();
                }

//J011_2607_0109
            /* setSize:check IllegalArgumentException */
            } else if (firstType == 2 && secondType == 4) {
                try {
                    /* set a negative value to the setSize width and height */
                    imgLabel.setSize(-1, -1);
                } catch (IllegalArgumentException e) {
                    err.setText("IAE:"+e.getMessage());
                    err.show();
                }

//J011_2607_0111
            /* setBackground:check that the background is updated */
            } else if (firstType == 3 && secondType == 1) {
                /* change the background color from default color */
                imgLabel.setBackground(0x00ffff00);
                resultText.setText("press the update button. if the background color is changed, OK.");

//J011_2607_0112
            /* setBackground:check IllegalArgumentException */
            } else if (firstType == 3 && secondType == 2) {
                try {
                    /* set an incorrect value (maximum color value + 1) to setBackground */
                    imgLabel.setBackground(16777216);
                } catch (IllegalArgumentException e) {
                    err.setText("IAE:"+e.getMessage());
                    err.show();
                }

//J011_2607_0114
            /* setForeground:check that the foreground is updated */
            } else if (firstType == 4 && secondType == 1) {
                /* change the foreground color */
                imgLabel.setForeground(0x00ffff00);
                resultText.setText("press the update button. the change is not visible, so if no error is detected, OK");

//J011_2607_0115
            /* setForeground:check IllegalArgumentException */
            } else if (firstType == 4 && secondType == 2) {
                try {
                    /* set an incorrect value (maximum color value + 1) to setBackground */
                    imgLabel.setForeground(16777216);
                } catch (IllegalArgumentException e) {
                    err.setText("IAE:"+e.getMessage());
                    err.show();
                }

//J011_2607_0203
            /* setVisible:check that the state is updated */
            } else if (firstType == 5 && secondType == 2) {
                /* after setting true, refresh the display */
                imgLabel.setVisible(true);
                resultText.setText("when it's difficult to determine that it was updated, if no error is detected, OK.");

//J011_2607_0204
            /* setVisible:check that the state is updated */
            } else if (firstType == 5 && secondType == 3) {
                /* after setting false, refresh the display */
                imgLabel.setVisible(false);
                imgLabel.setSize(100, 100);
                resultText.setText("if the space is left where the image was displayed, OK");

//J011_2606_0103
//2002/09/09 DoJa1.5            /* setImage exception:check UIException */
//2002/09/09 DoJa1.5            } else if (firstType == 10) {
//2002/09/09 DoJa1.5                try {
//2002/09/09 DoJa1.5                    /* stop using the image, then call the image */
//2002/09/09 DoJa1.5                    mi.unuse();
//2002/09/09 DoJa1.5                    img.dispose();
//2002/09/09 DoJa1.5                    resultText.setText("for that depends on the implementation, if no error is detected, OK");
//2002/09/09 DoJa1.5                } catch (UIException e) {
//2002/09/09 DoJa1.5                    err.setText("UIException:"+e.getMessage());
//2002/09/09 DoJa1.5                    err.show();
//2002/09/09 DoJa1.5                }
//2002/09/09 DoJa1.5            }
            /* setImage exception:check UIException */
            } else if (firstType == 10) {
                try {
                    /* stop using the image, then call the image */
					mi.unuse();
					mi.dispose();
					mi.use();
				    Dialog ngDialog = new Dialog(Dialog.DIALOG_INFO, "");
					ngDialog.setText("NG:Exception generating is not carried out.");
                    ngDialog.show();
                } catch (UIException uie) {
                    err.setText("UIException:" + uie.getMessage() + "(OK)");
                    err.show();
                } catch (Exception e) {
					err.setText("NG:"+e.getMessage());
                    err.show();
                }
            }
        }
    }
}

/**
 * check the behavior when layout manager is OFF
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanelOff extends Panel implements SoftKeyListener, ComponentListener {

    Frame      mainFrame;
    Frame      nextFrame;
    Label      title      = new Label("ImageLabel method result");
    TextBox    resultText = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
    TextBox    showText   = new TextBox("", 20, 1, TextBox.NUMBER);
    Button     execButton = new Button("update");
    String     resultstr  = new String();
    int        firstType;
    int        secondType;
    int        execFlg = 0;
    Image      img;
    ImageLabel imgLabel;
    MediaImage mi;

    /**
     * NextPanelOff class constructor (initializing)
     * @param frame pass the screen
     */
    public NextPanelOff(Frame frame) {

        /* setting the parameter */
        mainFrame = frame;
    }

    /**
     * execute each setting
     * @param type the selected value in the listbox1
     * @param type2 the selected value in the listbox2
     */
    public void Resultinit(int type, int type2) {
        try {
            /* setting the parameter */
            firstType = type;
            secondType = type2;
            /* add the title on the screen */
            add(title);
            /* display the result of action testing on the screen */
            showResult();

        } catch (Exception e) {
            /* processing when the exception occurs */
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error:window2");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }

        /* setting SOFT_KEY_1 */
        setSoftLabel(Frame.SOFT_KEY_1, "back");

        /* register the softkey listener */
        setSoftKeyListener(this);

        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * return to the previous screen when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* return to the previous screen when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            Display.setCurrent(mainFrame);
        }
    }

    /**
     * method which display the result
     */
    public void showResult() {

        try {
            /* get the image file from JAR */
            mi = MediaManager.getImage("resource:///niko.jpeg");

            /* load the image file into the memory */
            mi.use();

            /* set the layout manager null (because of confirming that the position- setting is possible) */
            this.setLayoutManager(null);

            /* setLocation: when the component adding doesn't occur and the position setting is possible */
            if (firstType == 1 && secondType == 0) {

//J011_2607_0101
                img = mi.getImage();
                imgLabel = new ImageLabel(img);

                /* setting the position before adding */
                imgLabel.setLocation(0, 15);
                /* and setting the position because the image label is null */
                resultText.setLocation(0, 55);
                add(imgLabel);

                /* setting the text of checking */
                resultstr = "verify that the coordinate is set to (0,15): coordinate ->";
                resultText.setText(resultstr+"("+imgLabel.getX()+","+imgLabel.getY()+")");
                add(resultText);

//J011_2607_0102
            /* setLocation: when the component adding occurs and the updating is possible */
            } else if (firstType == 1 && secondType == 1) {

                img = mi.getImage();
                imgLabel = new ImageLabel(img);

                /* setting the position because the image label is set null */
                imgLabel.setLocation(0, 15);
                resultText.setLocation(0, 55);
                execButton.setLocation(0,105);

                add(imgLabel);

                /* setting the text of checking */
                resultstr = "verify that the coordinate is changed after the update button was pressed";
                resultText.setText(resultstr+"("+imgLabel.getX()+","+imgLabel.getY()+")");
//2002/08/30 DoJa1.5                add(execButton);
                add(resultText);
                add(execButton);
            /* in case of getX: -> get the X coordinates */
            } else if (firstType == 6) {

//J011_2607_0205
                img = mi.getImage();
                imgLabel = new ImageLabel(img);

                /* set the x coordinates of the image label 30 and test */
                imgLabel.setLocation(30, 15);
                /* and setting the position because the image label is null */
                resultText.setLocation(0, 75);
                showText.setLocation(0, 55);

                add(imgLabel);

                /* get the x coordinates -> at the same time, set the value in the textbox */
                showText.setText("X="+String.valueOf(imgLabel.getX()));

                /* setting the text of checking */
                resultstr = "verify that the x-coordinate (X=30) is displayed";
                resultText.setText(resultstr);
                add(showText);
                add(resultText);

            /* in case of getY: -> get the Y coordinates */
            } else if (firstType == 7) {

//J011_2607_0206
                img = mi.getImage();
                imgLabel = new ImageLabel(img);

                /* set the Y coordinates of the image label 15 and test */
                imgLabel.setLocation(10, 15);
                /* and setting the position because the image label is null */
                resultText.setLocation(0, 75);
                showText.setLocation(0, 55);

                add(imgLabel);

                /* get the Y coordinates -> at the same times,set the value in the textbox*/
                showText.setText("Y="+String.valueOf(imgLabel.getY()));

                /* setting the text of checking */
                resultstr = "verify that the y-coordinate (Y=15) is displayed";
                resultText.setText(resultstr);
                add(showText);
                add(resultText);
            }

        } catch (Exception e) {
            /* in case of image file loading error */
            Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,
                                    "loading the image failed.");
        }
    }

    /**
     * update when the update button is pushed
     * @param source the component on which the event occurs
     * @param ivent event type
     * @param param event parameter
     */
    public void componentAction(Component source, int ivent, int param) {

        /* when the select button is pushed on condition that the focus is on the update button */
        if (source == execButton
            && ivent == ComponentListener.BUTTON_PRESSED) {

//J011_2607_0102
            /* setLocation: checking whether or not the re-layout is possible */
            if (firstType == 1 && secondType == 1) {
                imgLabel.setLocation(40, 15);
                resultText.setText("press the update button. present coordinate of the image is ->"
                        +"("+imgLabel.getX()+","+imgLabel.getY()+")");
            }
        }
    }
}
