/**
 * J011_2901_0101.java
 * 
 * MainPanel
 * J011_2901_0101
 * J011_2901_0301
 * J011_2902_0202
 * J011_2903
 * J011_2903_02
 * J011_2903_0201
 * J011_2903_03
 * J011_2905
 * J011_2905_02
 * J011_2905_0201
 * J011_2905_03
 * J011_2906
 * 
 * Label class action check (normal route)
 * 
 * $Id: J011_2901_0101.java,v 1.2 2001/12/02 05:14:09 waka Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Label class action check main class
 * @extends IApplication
 */
public class J011_2901_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* special character (pictograph) */
    char[]    emoji             = {0xE63E, 0xE63F, 0xE640, 0xE641};
    char[]    emoji2            = {0xE63E, 0xE63F};

    /**
     * Label class action check main screen
     * main menu
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class MainPanel  extends Panel implements SoftKeyListener,ComponentListener{

        Button execButton = null;
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
        Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

        /**
         * Constructor of MainPanel class
         */
        MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
            } catch(Error e) {
                err.setText("Error" + e.toString());
            }

        }

        int i;
        String[] mainItem = {
            "0.check the access level",
            "1.constant's behavior",
            "2.constructor's behavior",
            "3.method's behavior",
            "4.behavior for thrown exceptions",
            "5.succeeded method",
        };

        ListBox mainMenu = new ListBox(ListBox.CHOICE,4);

        /**
         * display the main panel
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("Label");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when a softkey is pushed
         * @param  aIndex iindex of softkey
         */
        public void softKeyPressed(int aIndex) {
        }

        /**
         * terminate the application when softkey1 is released
         * @param  aIndex iindex of softkey
         */
        public void softKeyReleased(int aIndex) {
            /* terminate when the softkey is released */
            if (aIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* going to the screen or displaying when the execution button is pushed */
            if ( aComponent == execButton
                && aType == BUTTON_PRESSED) {
                switch (mainMenu.getSelectedIndex()) {
                    /* access level action check */
                    case 0:
                        Display.setCurrent(new J011_2901_0301((Frame) this));
                        break;
                    /* constant test */
                    case 1:
                        Display.setCurrent(new J011_2902_0202((Frame) this));
                        break;
                    /* constructor */
                    case 2:
                        Display.setCurrent(new J011_2903((Frame) this));
                        break;
                    /* method  */
                    case 3:
                        Display.setCurrent(new J011_2905((Frame) this));
                        break;
                    /* exception action */
                    case 4:
                        Display.setCurrent(new J011_2906((Frame) this));
                        break;
                    /* inheritance method */
                    case 5:
                        Display.setCurrent(new J011_2907_0101((Frame) this));
                        break;
                }
            }
        }
    }

    /**
     * access level action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2901_0301 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButton011_2801_0301 = null;

        /* create message dialog(error/) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* selection processing  menu */
        ListBox menuJ011_2901_0301 = new ListBox(ListBox.CHOICE,12);
        String[] menuList = {
            "0.Label()",
            "1.setAlignment()",
            "2.setText()",
            "3.getHeight()",
            "4.getWidth()",
            "5.getX()",
            "6.getY()",
            "7.setBackground()",
            "8.setForeground()",
            "9.setLocation()",
            "10.setSize()",
            "11.setVisible()"
        };

        /* result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        J011_2901_0301(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_2901_0301();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * displaying access level action check screen
         */
        void showPanelJ011_2901_0301() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* menu setting */
            menuJ011_2901_0301.setItems(menuList);

            /* execution button setting */
            execButton011_2801_0301 = new Button("execute");

            /* adding the component */
            add(new Label("check the access level"));
            add(menuJ011_2901_0301);
            add(execButton011_2801_0301);
            add(resultTextBox);

            /* setting the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * testing the selected menu
         */
        public void test() {
            Label testLabel = new Label("Label");

            try {
                /* execute each testing */
                switch( menuJ011_2901_0301.getSelectedIndex() ) {
                    /* Label() */
                    case 0:
                        testLabel = new Label();
                        resultTextBox.setText("OK");
                        break;
                    /* setAlignment() */
                    case 1:
                        testLabel = new Label("CENTER",Label.CENTER);
                        resultTextBox.setText("OK");
                        break; 
                    /* setText() */
                    case 2:
                        testLabel.setText("NewText-Label");
                        resultTextBox.setText("OK");
                        break;
                    /* getHeight() */
                    case 3:
                        resultTextBox.setText("OK");
                        break;
                    /* getWidth() */
                    case 4:
                        resultTextBox.setText("OK");
                        break;
                    /* getX() */
                    case 5:
                        resultTextBox.setText("OK");
                        break;
                    /* getY() */
                    case 6:
                        resultTextBox.setText("OK");
                        break;
                    /* setBackground() */
                    case 7:
                        testLabel.setBackground(Graphics.getColorOfName(Graphics.BLUE));
                        resultTextBox.setText("OK");
                        break;
                    /* setForeground() */
                    case 8:
                        testLabel.setForeground(Graphics.getColorOfName(Graphics.RED));
                        resultTextBox.setText("OK");
                        break;
                    /* setLocation() */
                    case 9:
                        testLabel.setLocation(0,70);
                        resultTextBox.setText("OK");
                        break;
                    /* setSize() */
                    case 10:
                        testLabel.setSize(100,40);
                        resultTextBox.setText("OK");
                        break;
                    /* setVisible() */
                    case 11:
                        testLabel.setVisible(true);
                        resultTextBox.setText("OK");
                        break;
                }
            } catch (Exception e) {
                resultTextBox.setText("Exception: " + e.toString());
            } catch (Error e) {
                resultTextBox.setText("Exception: " + e.toString());
            }
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aIndex iindex of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_2901_0301
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* when  the execution button is pushed */
            if (aComponent == execButton011_2801_0301
                && aType == ComponentListener.BUTTON_PRESSED) {
                test();
            }
        }
    }

    /**
     * constant behavior test main class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2902_0202 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2902_0202 = null;

        /**
         * J011_2902_0202 class constructor
         */
        J011_2902_0202(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2902_0202();
        }

        ListBox menuJ011_2902_0202 = new ListBox(ListBox.CHOICE,2);

        /**
         * displaying constant checking screen
         */
        void showPanelJ011_2902_0202() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            add(new Label("definition of the constants"));

            Label testLabel1,testLabel2,testLabel3;
            TextBox testText1,testText2,testText3;

            String str1 = new String("");
            String str2 = new String("");
            String str3 = new String("");
            testLabel1 = new Label("CENTER");
            testLabel1.setSize(getWidth(),testLabel1.getHeight());
            add(testLabel1);

		// J011_2902_0101
		// When examining, it checks removing a comment and becoming a compile error.
		// Label.CENTER = 1;

		// J011_2902_0102
		// When examining, it checks removing a comment and becoming a compile error.
		// Label.LEFT = 0;

		// J011_2902_0103
		// When examining, it checks removing a comment and becoming a compile error.
		// Label.RIGHT = 2;


        // J011_2902_0201
            if ( Label.CENTER == 1 ) {
                str1 = "OK";
            } else {
                str1 = "NG:\nnot defined as 1";
            }
            testText1 = new TextBox(str1,getWidth(),3,TextBox.DISPLAY_ANY);
            add(testText1);

            testLabel2 = new Label("LEFT");
            testLabel2.setSize(getWidth(),testLabel2.getHeight());
            add(testLabel2);
        // J011_2902_0202
            if ( Label.LEFT == 0 ) {
                str2 = "OK";
            } else {
                str2 = "NG:\nnot defined as 0";
            }
            testText2 = new TextBox(str2,getWidth(),3,TextBox.DISPLAY_ANY);
            add(testText2);

            testLabel3 = new Label("RIGHT");
            testLabel3.setSize(getWidth(),testLabel3.getHeight());
            add(testLabel3);
        // J011_2902_0203
            if ( Label.RIGHT == 2 ){
                str3 = "OK";
            } else {
                str3 = "NG:\nnot defined as 2";
            }
            testText3 = new TextBox(str3,getWidth(),3,TextBox.DISPLAY_ANY);
            add(testText3);
            setSoftKeyListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aIndex iindex of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }

    /**
     * constructor action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2903 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2903 = null;
        String[] itemJ011_2903 = {
            "0.rated value constructor",
            "1.variation",
            "2.variation Align",
        };

        /**
         * J011_2903 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2903(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2903();
        }

        ListBox menuJ011_2903 = new ListBox(ListBox.CHOICE,2);

        /**
         * displaying constructor action check menu screen
         */
        void showPanelJ011_2903() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            add(new Label("check the constructor"));

            menuJ011_2903.setItems(itemJ011_2903);
            add(menuJ011_2903);

            execButtonJ011_2903 = new Button("execute");
            add(execButtonJ011_2903);

            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aIndex iindex of softkey
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            if ( aComponent == execButtonJ011_2903
                && aType == BUTTON_PRESSED) {
                switch (menuJ011_2903.getSelectedIndex()) {
                    /* the prescribed value constructor menu display */
                    case 0:
                        Display.setCurrent(new J011_2903_02((Frame) this));
                        break;
                    /* constructor variation display */
                    case 1:
                        Display.setCurrent(new J011_2903_03((Frame) this));
                        break;
                    /* constructor variation Align display */
                    case 2:
                        Display.setCurrent(new J011_2903_03_01((Frame) this));
                        break;
                }
            }
        }
    }

    /**
     * the prescribed value constructor behavior checking menu display class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2903_02 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2903_02 = null;
        String[] itemJ011_2903_02 = {
            "0.setting of the alignment",
            "1.setting of the text",
        };

        /**
         * J011_2903_02 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2903_02(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2903_02();
        }

        ListBox menuJ011_2903_02 = new ListBox(ListBox.CHOICE,2);

        /**
         * display the prescribed value constructor behavior checking menu screen
         * @extends Panel
         * @implements SoftKeyListener
         * @implements ComponentListener
         */
        void showPanelJ011_2903_02() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            add(new Label("check the constructor"));

            menuJ011_2903_02.setItems(itemJ011_2903_02);
            add(menuJ011_2903_02);

            execButtonJ011_2903_02 = new Button("execute");
            add(execButtonJ011_2903_02);

            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey index of softkey
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            if ( aComponent == execButtonJ011_2903_02
                && aType == BUTTON_PRESSED) {

                /* constructor action check screen displaying */
                Display.setCurrent(new J011_2903_0201(menuJ011_2903_02.getSelectedIndex(), this));

            }
        }
    }

    /**
     * the prescribed constructor behavior checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2903_0201 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* create message dialog(error/guide) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* execution button */
        Button execButton = new Button("");

        /**
         * J011_2903_0201 class constructor
         * @aType   index of processing menu
         * @aFrame  the screen before shifting
         */
        public J011_2903_0201(int aType, Frame aFrame) {

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("API class normal route");

            /* sub title setting */
            Label subTitle = new Label("");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            Label testLabel1,testLabel2,testLabel3;

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            switch (aType) {

                /* alighnment setting check */
                case 0:
                    subTitle.setText("check the setting of the alignment");
                    subTitle.setSize(getWidth(), subTitle.getHeight());

            // J011_2903_0201
                    add(new Label("center justify the string below"));
                    testLabel1 = new Label("CENTER",Label.CENTER);
                    testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel1.setSize(getWidth(),testLabel1.getHeight());
                    add(testLabel1);
            // J011_2903_0202
                    add(new Label("left justify the string below"));
                    testLabel2 = new Label("LEFT",Label.LEFT);
                    testLabel2.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel2.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel2.setSize(getWidth(),testLabel2.getHeight());
                    add(testLabel2);
            // J011_2903_0203
                    add(new Label("right justify the string below"));
                    testLabel3 = new Label("RIGHT",Label.RIGHT);
                    testLabel3.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel3.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel3.setSize(getWidth(),testLabel3.getHeight());
                    add(testLabel3);

                    break;

                /* text setting check */
                case 1:
                    subTitle.setText("check the setting of the text");
                    subTitle.setSize(getWidth(), subTitle.getHeight());

                    add(new Label("text exists below"));
            // J011_2903_0204
                    testLabel1 = new Label("text");
                    testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel1.setSize(getWidth(),testLabel1.getHeight());
                    add(testLabel1);

                    add(new Label("the character below is null"));
            // J011_2903_0205
                    testLabel2 = new Label();
                    testLabel2.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel2.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel2.setSize(getWidth(),testLabel2.getHeight());
                    add(testLabel2);

                    add(new Label("the string below is an empty string"));
            // J011_2903_0206
                    testLabel3 = new Label("");
                    testLabel3.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel3.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel3.setSize(getWidth(),testLabel3.getHeight());
                    add(testLabel3);

                    break;

            }
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }

    /**
     * the prescribed value constructor variation checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2903_03 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2903_03 = null;

        /**
         * J011_2903_03 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2903_03(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2903_03();
        }

        ListBox menuJ011_2903_03 = new ListBox(ListBox.CHOICE,2);

        /**
         * display the prescribed value constructor variation checking screen
         */
        void showPanelJ011_2903_03() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* sub title setting */
            Label subTitle = new Label("check the variation");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);
            subTitle.setSize(getWidth(),subTitle.getHeight());

            Label testLabel1,testLabel2,testLabel3,testLabel4,testLabel5;

//2002/07/30 Doaj1.5            add(new Label(""));
        // J011_2903_0301
//2002/07/30 Doaj1.5            testLabel1 = new Label("");
//2002/07/30 Doaj1.5            testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
//2002/07/30 Doaj1.5            testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
//2002/07/30 Doaj1.5            testLabel1.setSize(getWidth(),testLabel1.getHeight());
//2002/07/30 Doaj1.5            add(testLabel1);

//2002/07/30 Doaj1.5            add(new Label(""));
        // J011_2903_0302
//2002/07/30 Doaj1.5            testLabel2 = new Label("");
//2002/07/30 Doaj1.5            testLabel2.setBackground(Graphics.getColorOfName(Graphics.BLACK));
//2002/07/30 Doaj1.5            testLabel2.setForeground(Graphics.getColorOfName(Graphics.WHITE));
//2002/07/30 Doaj1.5            testLabel2.setSize(getWidth(),testLabel2.getHeight());
//2002/07/30 Doaj1.5            add(testLabel2);

            add(new Label("pictogram exists below"));
        // J011_2903_0303
            testLabel3 = new Label(String.valueOf(emoji));
            testLabel3.setSize(getWidth(),testLabel3.getHeight());
            add(testLabel3);
            add(new Label("alphabet exists below"));

        // J011_2903_0304
            testLabel4 = new Label("ABCabc");
            testLabel4.setBackground(Graphics.getColorOfName(Graphics.BLACK));
            testLabel4.setForeground(Graphics.getColorOfName(Graphics.WHITE));
            testLabel4.setSize(getWidth(),testLabel4.getHeight());
            add(testLabel4);

            add(new Label("mixed character exists below"));
        // J011_2903_0305
            testLabel5 = new Label("Ab" + String.valueOf(emoji2));
//2002/07/30 Doaj1.5            testLabel5 = new Label("Ab" + String.valueOf(emoji2));
            testLabel5.setSize(getWidth(),testLabel5.getHeight());
            add(testLabel5);

            setSoftKeyListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey index of softkey
         */
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }

    /**
     * display the prescribed value constructor variation Align checking screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2903_03_01 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2903_03_01 = null;

        /**
         * J011_2903_03_01 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2903_03_01(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2903_03_01();
        }

        ListBox menuJ011_2903_03_01 = new ListBox(ListBox.CHOICE,2);

        /**
         * display the prescribed value constructor variation Align checking screen
         */
        void showPanelJ011_2903_03_01() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* sub title setting */
            Label subTitle = new Label("check the Align variation");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);
            subTitle.setSize(getWidth(),subTitle.getHeight());

            Label testLabel1,testLabel2,testLabel3;

        // J011_2903_0306
            add(new Label("alphabet exists below"));
            testLabel1 = new Label("ABCabc", Label.CENTER);
            testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
            testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
            testLabel1.setSize(getWidth(),testLabel1.getHeight());
            add(testLabel1);

        // J011_2903_0309
            add(new Label("pictogram exists below"));
            testLabel2 = new Label(String.valueOf(emoji), Label.CENTER);
            testLabel2.setSize(getWidth(),testLabel2.getHeight());
            add(testLabel2);

        // J011_2903_0310
            add(new Label("mixed character exists below"));
            testLabel3 = new Label("Ab" + String.valueOf(emoji2), Label.CENTER);
            testLabel3.setSize(getWidth(),testLabel3.getHeight());
            add(testLabel3);

            setSoftKeyListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey index of softkey
         */
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }

    /**
     * method action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2905 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2905 = null;
        String[] itemJ011_2905 = {
            "0.rated value method",
            "1.variation",
        };

        /**
         * J011_2905 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2905(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2905();
        }

        ListBox menuJ011_2905 = new ListBox(ListBox.CHOICE,2);

        /**
         * method action check menu screen displaying
         */
        void showPanelJ011_2905() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            add(new Label("check the method"));

            menuJ011_2905.setItems(itemJ011_2905);
            add(menuJ011_2905);

            execButtonJ011_2905 = new Button("execute");
            add(execButtonJ011_2905);

            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            if ( aComponent == execButtonJ011_2905
                && aType == BUTTON_PRESSED) {
                switch (menuJ011_2905.getSelectedIndex()) {
                    /* the prescribed value method */
                    case 0:
                        Display.setCurrent(new J011_2905_02((Frame) this));
                        break;
                    /* variation */
                    case 1:
                        Display.setCurrent(new J011_2905_03((Frame) this));
                        break;
                }
            }
        }
    }

    /**
     * the prescribed value method behavior checking menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2905_02 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2905_02 = null;
        String[] itemJ011_2905_02 = {
            "0.setting of the alignment",
            "1.setting of the text",
        };

        /**
         * J011_2905_02 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2905_02(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2905_02();
        }

        ListBox menuJ011_2905_02 = new ListBox(ListBox.CHOICE,2);

        /**
         * display the prescribed value method behavior checking menu screen
         */
        void showPanelJ011_2905_02() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            add(new Label("check the rated value method"));

            menuJ011_2905_02.setItems(itemJ011_2905_02);
            add(menuJ011_2905_02);

            execButtonJ011_2905_02 = new Button("execute");
            add(execButtonJ011_2905_02);

            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey index of softkey
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            if ( aComponent == execButtonJ011_2905_02
                && aType == BUTTON_PRESSED) {
                    /* the prescribed value method behavior checking */
                Display.setCurrent(new J011_2905_0201(menuJ011_2905_02.getSelectedIndex(), this));
            }
        }
    }

    /**
     * the prescribed value method behavior checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2905_0201 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* create message dialog(error/guide) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* execution button */
        Button execButton = new Button("");

        /* label for checking set */
        Label testLabel1,testLabel2,testLabel3;

        /**
         * J011_2905_0201 class constructor
         * @param  aType index of processing selection menu
         * @param  aFrame the screen before shifting
         */
        public J011_2905_0201(int aType, Frame aFrame) {

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("API class normal route");

            /* sub title setting */
            Label subTitle = new Label("");
            add(subTitle);

            Label testLabel1,testLabel2,testLabel3;

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            switch (aType) {

                /* alighnment setting check */
                case 0:
                    subTitle.setText("check the setting of the alignment");
                    subTitle.setSize(getWidth(), subTitle.getHeight());

                    add(new Label("center justify the string below"));

            // J011_2905_0201
                    testLabel1 = new Label("CENTER");
                    testLabel1.setAlignment(Label.CENTER);
                    testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel1.setSize(getWidth(),testLabel1.getHeight());
                    add(testLabel1);

                    add(new Label("left justify the string below"));
            // J011_2905_0202
                    testLabel2 = new Label("LEFT");
                    testLabel2.setAlignment(Label.LEFT);
                    testLabel2.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel2.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel2.setSize(getWidth(),testLabel2.getHeight());
                    add(testLabel2);

                    add(new Label("right justify the string below"));
            // J011_2905_0203
                    testLabel3 = new Label("RIGHT");
                    testLabel3.setAlignment(Label.RIGHT);
                    testLabel3.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel3.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel3.setSize(getWidth(),testLabel3.getHeight());
                    add(testLabel3);

                    break;

                /* text setting check */
                case 1:
                    subTitle.setText("check the setting of the text");
                    subTitle.setSize(getWidth(), subTitle.getHeight());

                    add(new Label("the item below is a text"));

            // J011_2905_0204
                    testLabel1 = new Label("before_text");
                    testLabel1.setText("text");
                    testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel1.setSize(getWidth(),testLabel1.getHeight());
                    add(testLabel1);

                    add(new Label("the string below is an empty string"));
            // J011_2905_0205
                    testLabel2 = new Label("before_Label");
                    testLabel2.setText("");
                    testLabel2.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testLabel2.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    testLabel2.setSize(getWidth(),testLabel2.getHeight());
                    add(testLabel2);

                    break;

            }
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }

    /**
     * variation checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_2905_03 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonJ011_2905_03 = null;
        Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

        /**
         * J011_2905_03 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2905_03(Frame aFrame) {
            previousFrame = aFrame;
            showPanelJ011_2905_03();
        }

        ListBox menuJ011_2905_03 = new ListBox(ListBox.CHOICE,2);

        /**
         * variation checking screen displaying
         */
        void showPanelJ011_2905_03() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* sub title setting */
            Label subTitle = new Label("setting");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            Label testLabel1,testLabel2,testLabel3,testLabel4,testLabel5;

//2002/07/30 Doaj1.5            add(new Label(""));
//2002/07/30 Doaj1.5            testLabel1 = new Label();
        // J011_2905_0301
//2002/07/30 Doaj1.5            testLabel1.setText("");
//2002/07/30 Doaj1.5            testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
//2002/07/30 Doaj1.5            testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
//2002/07/30 Doaj1.5            testLabel1.setSize(getWidth(),testLabel1.getHeight());
//2002/07/30 Doaj1.5            add(testLabel1);

//2002/07/30 Doaj1.5            add(new Label(""));
//2002/07/30 Doaj1.5            testLabel2 = new Label();
        // J011_2905_0302
//2002/07/30 Doaj1.5            testLabel2.setText("");
//2002/07/30 Doaj1.5            testLabel2.setBackground(Graphics.getColorOfName(Graphics.BLACK));
//2002/07/30 Doaj1.5            testLabel2.setForeground(Graphics.getColorOfName(Graphics.WHITE));
//2002/07/30 Doaj1.5            testLabel2.setSize(getWidth(),testLabel2.getHeight());
//2002/07/30 Doaj1.5            add(testLabel2);

            add(new Label("alphabet exists below"));
            testLabel3 = new Label();
        // J011_2905_0303
            testLabel3.setText(String.valueOf(emoji));
            testLabel3.setSize(getWidth(),testLabel3.getHeight());
            add(testLabel3);

            add(new Label("pictogram exists below"));
            testLabel4 = new Label();
        // J011_2905_0304
            testLabel4.setText("ABCabc");
            testLabel4.setBackground(Graphics.getColorOfName(Graphics.BLACK));
            testLabel4.setForeground(Graphics.getColorOfName(Graphics.WHITE));
            testLabel4.setSize(getWidth(),testLabel4.getHeight());
            add(testLabel4);

            add(new Label("mixed character exists below"));
            testLabel5 = new Label();
        // J011_2905_0305
            testLabel5.setText("Ab" + String.valueOf(emoji2));
//2002/07/30 Doaj1.5            testLabel5.setText("Ab" + String.valueOf(emoji2));
            testLabel5.setSize(getWidth(),testLabel5.getHeight());
            add(testLabel5);

            setSoftKeyListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey type of soft menu
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey type of soft menu
         */
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {}
    }


    /**
     * exception action checking menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_2906 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        /* execution button */
        Button execButtonJ011_2906 = null;
        /* for the error message */
        Dialog info = new Dialog(Dialog.DIALOG_INFO, "info"); /* for the error message */
        /* menu item */
        String[] itemJ011_2906 = {
            "0.check the exception 1",
            "1.check the exception 2",
        };

        /* exception message OK/NG flag */
        boolean aFlag;

        /* exception processing message display setting */
        String exceptionString = new String();
        TextBox exceptinTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        ListBox menuJ011_2906 = new ListBox(ListBox.CHOICE,2);


        /**
         * J011_2906 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_2906(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_2906();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * exception action checking menu screen displaying
         */
        void showPanelJ011_2906() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            add(new Label("check behavior for the thrown exception"));

            /* create exception selection menu */
            menuJ011_2906.setItems(itemJ011_2906);
            add(menuJ011_2906);

            /* create the execution button */
            execButtonJ011_2906 = new Button("execute");
            add(execButtonJ011_2906);

            /*setting of the listener*/
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * display message dialog
         * @param  aMsg the message which display in the dialog
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            Label testLabel;

            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_2906
                && aType == SELECTION_CHANGED) {
                    exceptinTextBox.setText("");
            }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_2906
                && aType == BUTTON_PRESSED) {

                /* divide the processing by menu */
                switch (menuJ011_2906.getSelectedIndex()) {
                    /* exception test 1 */
                    case 0:
        // J011_2906_0101
                        try {
                            testLabel = new Label("text",3);
                            add(testLabel);
                        } catch(IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\" IllegalArgumentException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" 3 has set to the alignment.");
                        }
                        break;
                    /* exception test 2 */
                    case 1:
        // J011_2906_0102
                        try {
                            testLabel = new Label("text");
                            testLabel.setAlignment(3);
                            testLabel.setSize(getWidth(),testLabel.getHeight());
                        } catch(IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\" IllegalArgumentException:" + e.getMessage());
                        } catch (Exception e) {
                            info.setText(e.toString());
                            info.show();
                            if ( aFlag == false ) {
                                showMsg("\"NG\" 3 has set to the alignment.");
                            }
                        }
                        break;
                }
            }
        }
    }

}