/**
 * J011_2907_0101.java
 * 
 * J011_2907_0101
 * methodTest
 * ExceptionTest
 * 
 * action checking of the inheritance method from component class
 * 
 * $Id: J011_2907_0101.java,v 1.2 2001/12/02 05:14:09 waka Exp $
 */

import com.nttdocomo.ui.*;

/**
 * action checking main screen of the inheritance method from component class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
public class J011_2907_0101 extends Panel implements SoftKeyListener,ComponentListener {

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* execution button */
    Button execButton = null;

    /* create processing selection menu */
    ListBox componentTestMenu = new ListBox(ListBox.CHOICE,4);

    /* processing selection menu item */
    String[] menuItem = {
        "0.given value method 1",
        "1.given value method 2",
        "2.rated value method 1",
        "3.rated value method 2",
        "4.check the exception",
    };

    /**
     * J011_2907_0101 class constructor
     * @param  aFrame the screen before shifting
     */
    public J011_2907_0101(Frame aFrame) {

        try {
            previousFrame = aFrame;
            showJ011_2907_0101();
        } catch(Exception e) {
            err.setText("Exception:" + e.toString());
        } catch(Error e) {
            err.setText("Error" + e.toString());
        }

    }

    /**
     * display action checking of the inheritance method from component class
     */
    public void showJ011_2907_0101() {

        /* title displaying */
        setTitle("API class normal route");

        /* sub title displaying */
        Label subTitle = new Label("check behavior of the succeeded method");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* main menu setting */
        componentTestMenu.setItems(menuItem);

        /* execution button setting */
        execButton = new Button("execute");

        /* add the component to the screen */
        add(componentTestMenu);
        add(execButton);
        
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* shift to the screen concerning the menu when the execution button is pressed */
        if ( aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED ) {
            if ( componentTestMenu.getSelectedIndex() == 4 ) {
                Display.setCurrent(new ExceptionTest((Frame) this));
            } else {
                Display.setCurrent(new methodTest(componentTestMenu.getSelectedIndex(), this));
            }
        }
    }
}

/**
 * method action check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class methodTest extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButton = new Button("");
    Button testButton1,testButton2,testButton3,testButton4,testButton5,testButton6;

    /* Label for action checking */
    Label testLabel1,testLabel2,testLabel3,testLabel4,testLabel5,testLabel6;

    /* textbox for action checking */
    TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

    /* label for checking whether or not visible/invisible */
    Label visibleLabel = new Label("visible state");

    /**
     * method action checking screen
     * @param  aType processing selection menu index
     * @param  aFrame the screen before shifting
     */
    public methodTest(int aType, Frame aFrame) {

        /* put the previous screen in */
        previousFrame = aFrame;

        /* title displaying */
        setTitle("API class normal route");

        /* sub title setting */
        Label subTitle = new Label("");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* check method's behavior */
        try {

            switch (aType) {
                /* condition that layout manager is null */
                case 0:
                    /* set LayoutManage Null */
                    setLayoutManager(null);

                    subTitle.setText("checking the behavior of the given value method 1");

                    testButton1 = new Button("test1");
                    testButton2 = new Button("test2");
                    testButton1.setLocation(0,70);
                    testButton2.setLocation(40,70);
                    add(testButton1);
                    add(testButton2);

                    /* create the action checking Label */
                    testLabel1 = new Label("test1");
                    testLabel2 = new Label("test2");

            // J011_2907_0101
                    /* setLacation of the component which has been added to the panel */
                    add(testLabel1);
                    testLabel1.setLocation(10,20);

                    /* setLacation of the component before being added to the panel */
                    testLabel2.setLocation(30,30);
                    add(testLabel2);

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /*  */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_3007_0105
                                    /* setLacation of the component which has been added */
                                    info.setText("Location:" + testLabel1.getX() + "," + testLabel1.getY());
                                    info.show();;
                                }
                                if ( aComponent == testButton2 ) {
                        // J011_3007_0106
                                    /* setLacation of the component before being adde */
                                    info.setText("Location:" + testLabel2.getX() + "," + testLabel2.getY());
                                    info.show();;
                                }
                            }
                        }
                    });
                    break;

                /* the condition that layout manager is not Null */
                case 1:
                    subTitle.setText("checking the behavior of the given value method 2");

                    /* set the background color of panel because it is uneasy to see in condition that the focus is on the button */
                    setBackground(Graphics.getColorOfName(Graphics.AQUA));

                    /* create the action checking button */
                    testLabel1 = new Label("test1");
                    testLabel2 = new Label("test2");
                    testLabel3 = new Label("test3");
                    testLabel4 = new Label("test4");
                    testLabel5 = new Label("OK");
                    testLabel6 = new Label("NG");

            // J011_2907_0102
                    /* the position setting before being added to the component. Confirming that it is invalid */
                    testLabel1.setLocation(100,100);
                    add(testLabel1);

            // J011_2907_0102
                    /* the position setting after being added to the component. Confirming that it is invalid */
                    add(testLabel2);
                    testLabel2.setLocation(100,100);

            // J011_2907_0103
                    /* before adding the component, confirming the setting of the size,background color and the foreground color is possible*/
                    add(testLabel3);
                    testLabel3.setSize(40,30);
                    testLabel3.setBackground(Graphics.getColorOfName(Graphics.BLUE));
                    testLabel3.setForeground(Graphics.getColorOfName(Graphics.WHITE));

            // J011_2907_0104
                    /* after adding the component, confirming the setting of the size,background color and the foreground color is possible */
                    testLabel4.setSize(30,40);
                    testLabel4.setBackground(Graphics.getColorOfName(Graphics.RED));
                    testLabel4.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    add(testLabel4);

                    testButton1 = new Button("test1");
                    testButton2 = new Button("test2");
                    testButton1.setLocation(0,70);
                    testButton2.setLocation(40,70);
                    add(testButton1);
                    add(testButton2);

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /*  */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_3007_0105
                                    /* setSize of the component which has been added */
                                    info.setText("Size:" + testLabel3.getWidth() + "," + testLabel3.getHeight());
                                    info.show();;
                                }
                                if ( aComponent == testButton2 ) {
                        // J011_3007_0106
                                    /* setSize of the component before it is added */
                                    info.setText("Size:" + testLabel4.getWidth() + "," + testLabel4.getHeight());
                                    info.show();;
                                }
                            }
                        }
                    });
                    break;

                case 2:
                    subTitle.setText("checking the behavior of the rated value method 1");

                    /* creating / adding the action checking button*/
                    testButton1 = new Button("ON");
                    testButton2 = new Button("OFF1");
                    testLabel4 = new Label("OK label");
                    testLabel5 = new Label("NG label");
                    add(visibleLabel);
                    visibleLabel.setSize(getWidth(),visibleLabel.getHeight());
                    visibleLabel.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    visibleLabel.setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    add(testButton1);
                    add(testButton2);

            // J011_2907_0107
                    /* testLabel4 is displayed because it is visible(true) before adding to the component */
                    testLabel4.setVisible(true);
                    add(testLabel4);

                    /* testLabel4 is not displayed because it is visible(false) before adding to the component */
                    testLabel5.setVisible(false);
                    add(testLabel5);

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /* action check of setVisible() */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_2907_0105
                                    /* set the visibility */
                                    visibleLabel.setVisible(true);
                                    visibleLabel.setSize(getWidth(),visibleLabel.getHeight());
                                    visibleLabel.setText("visible state");
                                }
                                if ( aComponent == testButton2 ) {
                        // J011_2907_0106
                                    /* set the invisibility */
                                    visibleLabel.setVisible(false);
                                    visibleLabel.setText("invisible state");
                                }
                            }
                        }
                    });

                    break;

                /* checking whether or not it is possible to get the component position */
                case 3:

                    setLayoutManager(null);

                    subTitle.setText("checking the behavior of the rated value method 3");
                    testLabel1 = new Label("checking object");
                    testButton1 = new Button("check the coordinate");
                    add(testLabel1);
                    add(testButton1);
                    add(resultTextBox);

                    /* set the position of the component display */
                    subTitle.setLocation(0,0);
                    testLabel1.setLocation(0,15);
                    testButton1.setLocation(0,55);
                    resultTextBox.setLocation(0,75);
                    testLabel1.setSize(50,40);

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /* action checking of setVisible(). The value of the position which has been set must be returned */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_2907_0108
                                    resultTextBox.setText("X:" + testLabel1.getX() + "," + "Y:" + testLabel1.getY() +
                                    "\nwidth:"+testLabel1.getWidth()+",height:"+testLabel1.getHeight());
                                }
                            }
                        }
                    });

                    break;
            }

        } catch(Exception e) {
            err.setText("Exception : " + e.toString());
            err.show();
        } catch(Error e) {
            err.setText("Error : " + e.toString());
        }

    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {}
}

/**
 * exception action checking screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class ExceptionTest extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* menu ListBox creation */
    ListBox errorMenu = new ListBox(ListBox.CHOICE,7);

    /* execution button */
    Button execButton = null;

    /* exception message OK/NG flag */
    boolean aFlag;

    /* exception checking component */
    Label testLabel = new Label("test");

    /**
     * exception action checking screen display
     * @param aFrame the screen
     */
    ExceptionTest (Frame aFrame) {
        try {
            previousFrame = aFrame;
            showExceptionTest();
        } catch(Exception e) {
            err.setText("Exception: " + toString());
            err.show();
        } catch(Error e) {
            err.setText("Error: " + toString());
            err.show();
        }
    }

    /**
     * check behavior for the thrown exception
     */
    void showExceptionTest() {

        /* title displaying */
        setTitle("API class normal route");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* sub title displaying */
        add(new Label("check the exception"));

        /* exception menu item array */
        String[] errorListItem = {
            "0.check the exception 1",
            "1.check the exception 2",
            "2.check the exception 3",
            "3.check the exception 4",
            "4.check the exception 5",
        };

        /* creating exception menu */
        errorMenu.setItems(errorListItem);

        /* create the execution button */
        execButton = new Button("execute");

        /* adding the component */
        add(errorMenu);
        add(execButton);
    }

    /**
     * display message dialog
     * @param  aMsg the message which display in the dialog
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* initialize the textbox when the menu is selected */
        if ( aComponent == errorMenu
            && aType == SELECTION_CHANGED) {
            aFlag = false;
        }

        /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
        if ( aComponent == execButton
            && aType == BUTTON_PRESSED) {


            /* divide the processing by menu */
            switch (errorMenu.getSelectedIndex()) {
            // J011_2907_0109
                /* exception test1 set width less than 0 */
                case 0:
                    try {
                        testLabel.setSize(-1,10);
                        break;
                    } catch(IllegalArgumentException iae) {
                        aFlag = true;
                        showMsg("\"OK\" IllegalArgumentException:"+ iae.getMessage());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\" the value under 0 was set to width");
                    }
                    break;

            // J011_2907_0110
                /* exception test2 set height less than 0 */
                case 1:
                    try {
                        testLabel.setSize(10,-1);
                        break;
                    } catch(IllegalArgumentException iae) {
                        aFlag = true;
                        showMsg("\"OK\" IllegalArgumentException:"+ iae.getMessage());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\" the value under 0 was set to height");
                    }
                    break;

            // J011_2907_0111
                /* exception test3 set width and height less than 0 */
                case 2:
                    try {
                        testLabel.setSize(-1,-1);
                        break;
                    } catch(IllegalArgumentException iae) {
                        aFlag = true;
                        showMsg("\"OK\" IllegalArgumentException:"+ iae.getMessage());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\" the value under 0 was set to width and height");
                    }
                    break;

            // J011_2907_0112
                /* exception test4 set the background color the invalid value */
                case 3:
                    try {
                        testLabel.setBackground(-1);
                        break;
                    } catch(IllegalArgumentException iae) {
                        aFlag = true;
                        showMsg("\"OK\" IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\" -1 was set to background color");
                    }
                    break;

            // J011_2907_0113
                /* exception test5 set the background color the invalit value */
                case 4:
                    try {
                        testLabel.setForeground(-1);
                        break;
                    } catch(IllegalArgumentException iae) {
                        aFlag = true;
                        showMsg("\"OK\" IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\" -1 was set to foreground color");
                    }
                    break;
            }
        }
    }
}
