/**
 * J011_3101_0101.java
 * 
 * J011_3101_0101
 * MainPanel
 * J011_3002_0201
 * J011_3003_02
 * J011_3003_0201
 * J011_3005_02
 * J011_3005_0201
 * J011_3005_0201_01
 * J011_3006_0101
 * 
 * LitBox class action check (normal route)
 * 
 * $id: $
*/

import com.nttdocomo.ui.*;
/**
 * LitBox class action check main class
 * @extends IApplication
 */
public class J011_3101_0101 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * LitBox class action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener{

        /* execution button */
        Button execButton = null;
        /* create processing selection menu */
        ListBox mainMenu = new ListBox(ListBox.CHOICE,4);
        /* processing selection menu item */
        String[] mainItem = {
            "0.check the access level",
            "1.constant's behavior",
            "2.constructor's behavior",
            "3.method's behavior",
            "4.behavior for thrown exceptions",
            "5.succeeded method",
        };

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
            } catch(Error e) {
                err.setText("Error" + e.toString());
            }

        }

        /**
         * display LitBox class action check main screen
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("ListBox");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * softKeyReleased
         * terminate the application when the softkey1 is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* going to the screen or displaying when the execution button is pushed */
            if (aComponent == execButton && aType == BUTTON_PRESSED) {

                switch (mainMenu.getSelectedIndex()) {
                /* access level checking */
                case 0:
                    Display.setCurrent(new J011_3001_0301((Frame) this));
                    break;
                /* constant test */
                case 1:
                    Display.setCurrent(new J011_3002_0201((Frame) this));
                    break;
                /* constructor */
                case 2:
                    Display.setCurrent(new J011_3003_02((Frame) this));
                    break;
                /* method */
                case 3:
                    Display.setCurrent(new J011_3005_02((Frame) this));
                    break;
                /* exception action */
                case 4:
                    Display.setCurrent(new J011_3006_0101((Frame) this));
                    break;
                /* inheritance method */
                case 5:
                    Display.setCurrent(new J011_3107_0101((Frame) this));
                    break;
                }
            }
        }
    }

    /**
     * access level action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3001_0301
        extends Panel implements SoftKeyListener,ComponentListener {

        Frame previousFrame = null;
        Button execButton011_3001_0301 = null;

        /* create message dialog(error/) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* selection processing  menu */
        ListBox menuJ011_3001_0301 = new ListBox(ListBox.CHOICE,19);

        String[] menuList = {
            "0.ListBox()",
            "1.setEnabled()",
            "2.requestFocus()",
            "3.setItems()",
            "4.append()",
            "5.removeAll()",
            "6.getItemCount()",
            "7.getItem()",
            "8.deselect()",
            "9.isIndexSelected()",
            "10.getHeight()",
            "11.getWidth()",
            "12.getX()",
            "13.getY()",
            "14.setBackground()",
            "15.setForeground()",
            "16.setLocation()",
            "17.setSize()",
            "18.setVisible()",
            "19.select()",
            "20.getSelectedIndex()",
        };

        /* result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        /**
         * J011_3001_0301 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_3001_0301(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3001_0301();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * displaying access level action check screen
         */
        void showPanelJ011_3001_0301() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* menu setting */
            menuJ011_3001_0301.setItems(menuList);

            /* execution button setting */
            execButton011_3001_0301 = new Button("execute");

            /* adding the component */
            add(new Label("check the access level"));
            add(menuJ011_3001_0301);
            add(execButton011_3001_0301);
            add(resultTextBox);

            /* setting the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * testing the selected menu
         */
        public void test() {

            boolean okFlag = true;

            ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,3);
            ListBox testListBox2 = new ListBox(ListBox.SINGLE_SELECT,3);

            try {
                /* execute each testing */
                switch( menuJ011_3001_0301.getSelectedIndex() ) {
// J011_3101_0301
// J011_3101_0302
                    /* ListBox() */
                    case 0:
                        testListBox = new ListBox(ListBox.CHOICE,3);
                        testListBox2 = new ListBox(ListBox.CHOICE);
                        break;
                    /* setEnabled() */
// J011_3101_0303
                    case 1:
                        testListBox.setEnabled(true);
                        break; 
                    /* requestFocus() */
// J011_3101_0304
                    case 2:
                        testListBox.requestFocus();
                        break;
                    /* setItems() */
// J011_3101_0305
                    case 3:
                        String[] testItems = {
                            "Item1",
                            "Item2",
                            "Item3",
                        };
                        testListBox.setItems(testItems);
                        break;
                    /* append() */
// J011_3101_0306
                    case 4:
                        testListBox.append("Item1");
                        testListBox.append("Item2");
                        testListBox.append("Item3");
                        break;
                    /* removeAll() */
// J011_3101_0307
                    case 5:
                        testListBox.removeAll();
                        break;
                    /* getItemCount() */
// J011_3101_0308
                    case 6:
                        testListBox.getItemCount();
                        break;
                    /* getItem() */
// J011_3101_0309
                    case 7:
                        testListBox.append("Item1");
                        testListBox.append("Item2");
                        testListBox.append("Item3");
                        testListBox.getItem(0);
                        break;
                    /* deselect() */
// J011_3101_0311
                    case 8:
                        testListBox.append("Item1");
                        testListBox.append("Item2");
                        testListBox.append("Item3");
                        testListBox.isIndexSelected(0);
                        testListBox.deselect(0);
                        break;
                    /* isIndexSelected() */
// J011_3101_0312
                    case 9:
                        testListBox.append("Item1");
                        testListBox.append("Item2");
                        testListBox.append("Item3");
                        testListBox.isIndexSelected(0);
                        break;
                    /* getHeight() */
// J011_3101_0314
                    case 10:
                        resultTextBox.getHeight();
                        break;
                    /* getWidth() */
// J011_3101_0315
                    case 11:
                        resultTextBox.getWidth();
                        break;
                    /* getX() */
// J011_3101_0316
                    case 12:
                        resultTextBox.getX();
                        break;
                    /* getY() */
// J011_3101_0317
                    case 13:
                        resultTextBox.getY();
                        break;
                    /* setBackground() */
// J011_3101_0318
                    case 14:
                        testListBox.setBackground(
                            Graphics.getColorOfName(Graphics.BLUE));
                        break;
                    /* setForeground() */
// J011_3101_0319
                    case 15:
                        testListBox.setForeground(
                            Graphics.getColorOfName(Graphics.RED));
                        break;
                    /* setLocation() */
                    case 16:
// J011_3101_0320
                        testListBox.setLocation(0,70);
                        break;
                    /* setSize() */
                    case 17:
// J011_3101_0321
                        testListBox.setSize(100,40);
                        break;
                    /* setVisible() */
                    case 18:
// J011_3101_0322
                        testListBox.setVisible(true);
                        break;
                    /* select() */
// J011_3101_0310
                    case 19:
                        testListBox.append("Item1");
                        testListBox.append("Item2");
                        testListBox.append("Item3");
                        testListBox.select(0);
                        break;
                    /* getSelectedIndex() */
// J011_3101_0313
                    case 20:
                        testListBox.append("Item1");
                        testListBox.append("Item2");
                        testListBox.append("Item3");
                        testListBox.getSelectedIndex();
                        break;
                }
            } catch (Exception e) {
                okFlag = false;
                err.setText("Exception: " + e.toString());
                err.show();
            } catch (Error e) {
                okFlag = false;
                err.setText("Exception: " + e.toString());
                err.show();
            }
			if (okFlag == true) {
                resultTextBox.setText("OK");
			}
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * define the action when softkey is released
         * @param  aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_3001_0301
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* when  the execution button is pushed */
            if (aComponent == execButton011_3001_0301
                && aType == ComponentListener.BUTTON_PRESSED) {
                test();
            }
        }
    }

    /**
     * J011_3002_0201
     * constant definition check screen class. Display true or false of constant definition
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3002_0201 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* create processing selection menu */
        ListBox menuJ011_3002_0201 = new ListBox(ListBox.CHOICE,5);

        /* menu item */
        String[] menuItem = {
            "0.SINGLE",
            "1.RADIO",
            "2.CHECK",
            "3.NUMBERED",
            "4.MULTIPLE",
            "5.CHOICE",
        };

        /* execution button */
        Button execButtonJ011_3002_0201 = new Button("execute");;

        /* textbox for displaying the checking result */
        TextBox resultTextBox = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);

        /**
         * J011_3002_0201 class constructor
         * @param aFrame the screen
         */
        J011_3002_0201(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3002_0201();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * showPanelJ011_3002_0201
         * display constant definition check screen
         */
        void showPanelJ011_3002_0201() {

            /* title displaying */
            setTitle("API class normal route");

            menuJ011_3002_0201.setItems(menuItem);

            /* adding the component */
            add(new Label("constant definition check"));
            add(menuJ011_3002_0201);
            add(execButtonJ011_3002_0201);
            add(resultTextBox);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

        }


        /**
         * Constant member definition check
         * the following is confirmation that the value can not be put in constant member
         * confirm ierror in building and delete
         */
        // J011_3102_0101
        // J011_3102_0102
        // J011_3102_0103
        // J011_3102_0104
        // J011_3102_0105
        // J011_3102_0106
/*        ListBox.SINGLE_SELECT = 1;
        ListBox.RADIO_BUTTON = 1;
        ListBox.CHEK_BOX = 1;
        ListBox.NUMBERED_LIST = 1;
        ListBox.MULTIPLE_SELECT = 1;
        ListBox.CHOICE = 1;
*/
        /**
         * do nothing when a softkey is pushed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * define the action when softkey is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_3002_0201
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            if ( aComponent == execButtonJ011_3002_0201
            && aType == ComponentListener.BUTTON_PRESSED) {

                switch ( menuJ011_3002_0201.getSelectedIndex() ) {
                    case 0:
                    /* OK if each constant definition is valid, else NG */
                // J011_3102_0201
                    if ( ListBox.SINGLE_SELECT == 0 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG:\nnot defined as 1");
                    }
                    break;

                    case 1:
                // J011_3102_0202
                    if ( ListBox.RADIO_BUTTON == 1 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG:\nnot defined as 1");
                    }
                    break;

                    case 2:
                // J011_3102_0203
                    if ( ListBox.CHECK_BOX == 2 ){
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG:\nnot defined as 2");
                    }
                    break;

                    case 3:
                // J011_3102_0204
                    if ( ListBox.NUMBERED_LIST == 3 ){
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG:\nnot defined as 3");
                    }
                    break;

                    case 4:
                // J011_3102_0205
                    if ( ListBox.MULTIPLE_SELECT == 4 ){
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG:\nnot defined as 4");
                    }
                    break;

                    case 5:
                // J011_3102_0206
                    if ( ListBox.CHOICE == 5 ){
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG:\nnot defined as 5");
                    }
                    break;
                }
            }
        }
    }

    /**
     * J011_3003_02
     * constructor action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3003_02 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3003_02 = null;

        /* create processing selection menu */
        ListBox menuJ011_3003_02 = new ListBox(ListBox.CHOICE,3);

        /* processing selection menu item setting */
        String[] itemJ011_3003_02 = {
            "0.set 8 items",
            "1.set 0 item",
            "2.no line number definition",
        };

        /**
         * J011_3003_02 class constructor
         * @param aFrame the screen
         */
        J011_3003_02(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3003_02();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * display constructor action check manu screen
         */
        void showPanelJ011_3003_02() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* main menu setting */
            menuJ011_3003_02.setItems(itemJ011_3003_02);

            /* execution button setting */
            execButtonJ011_3003_02 = new Button("execute");

            /* add the component to the screen */
            add(menuJ011_3003_02);
            add(execButtonJ011_3003_02);

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* shift to the screen concerning the menu when the execution button is pressed */
            if ( aComponent == execButtonJ011_3003_02
                && aType == BUTTON_PRESSED ) {
                    Display.setCurrent(new J011_3003_0201(menuJ011_3003_02.getSelectedIndex(), this));
            }
        }
    }

    /**
     * constructor creation check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3003_0201 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* create message dialog(error/guide) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* execution button */
        Button execButton = new Button("");

        /**
         * constructor action check screen
         * @param  aType processing selection menu index
         * @param  aFrame the screen before shifting
         */
        public J011_3003_0201(int aType, Frame aFrame) {

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("API class normal route");

            /* sub title setting */
            Label subTitle = new Label("");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* LitBox item setting */
            String[] listBoxNameList = {
                "1.single selection",
                "2.radio button",
                "3.check box",
                "4.list of the numbers",
                "5.multiple selection",
                "6.option",
            };

            /* array for ListBox which is displayed */
            ListBox[] testListBox;
            testListBox = new ListBox[6];

            /* the variable for looping */
            int i;
            int j;

            /* check method's behavior */
            switch (aType) {
                /* 8 line definition */
                case 0:
                subTitle.setText("check that the number of listbox items is 8");
            // from J011_3103_0201to J011_3103_0206
                /* create 8 line listbox (all of 6 type) */
                for ( i = 0; i < 6; i++ ) {
                    testListBox[i] = new ListBox(i,8);
                        for ( j = 1; j < 9; j++ ) {
                            testListBox[i].append(j + "th line");
                        }
                    Label listBoxName = new Label(listBoxNameList[i]);
                    add(listBoxName);
                    add(testListBox[i]);
                }

                break;

                /* 0 line number definition */
                case 1:
                subTitle.setText("check that the number of listbox items is 0");
        // from J011_3103_0207 to J011_3103_0212
                /* create 0 line listbox (all of 6 type) */
                for ( i = 0; i < 6; i++ ) {
                    testListBox[i] = new ListBox(i,0);

                    Label listBoxName = new Label(listBoxNameList[i]);
                    add(listBoxName);
                    add(testListBox[i]);

                }
                break;

                /* without definition of line number */
                case 2:
                subTitle.setText("check when the number of the line is not defined");
        // from J011_3103_0213 to J011_3103_0218
                /* create the listbox which is not set the number of the line (all of 6 type) */
                for ( i = 0; i < 6; i++ ) {
                    testListBox[i] = new ListBox(i);

                    Label listBoxName = new Label(listBoxNameList[i]);
                    add(listBoxName);
                    add(testListBox[i]);

                }
                break;

            }
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {}
    }


    /**
     * J011_3005_02
     * constructor action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3005_02 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3005_02 = null;

        /* create processing selection menu */
        ListBox menuJ011_3005_02 = new ListBox(ListBox.CHOICE,3);

        /* processing selection menu item setting */
        String[] itemJ011_3005_02 = {
            "0.operation check 1",
            "1.check the focus",
            "2.variation test",
        };

        /**
         * J011_3005_02 class constructor
         * @param aFrame the screen
         */
        J011_3005_02(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3005_02();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * display constructor action check manu screen
         */
        void showPanelJ011_3005_02() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* main menu setting */
            menuJ011_3005_02.setItems(itemJ011_3005_02);

            /* execution button setting */
            execButtonJ011_3005_02 = new Button("execute");

            /* add the component to the screen */
            add(menuJ011_3005_02);
            add(execButtonJ011_3005_02);

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* shift to the screen concerning the menu when the execution button is pressed */
            if ( aComponent == execButtonJ011_3005_02
                && aType == BUTTON_PRESSED ) {
                    Display.setCurrent(new J011_3005_0201(menuJ011_3005_02.getSelectedIndex(), this));
            }
        }
    }


    /**
     * method action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3005_0201 extends Panel implements SoftKeyListener,ComponentListener {


        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* create message dialog(error/guide) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* execution button */
        Button execButton = new Button("execute");


        /* array for ListBox which is displayed */
        ListBox testListBox[] = new ListBox[6];

        /* create the array of action check button */
        Button selectButton[] = new Button[6];
        Button deselectButton[] = new Button[6];
        Button removeButton[] = new Button[6];
        Button visibleButton[] = new Button[6];
        Button enabledButton[] = new Button[6];
        Button indexButton[] = new Button[6];
        Button addButton[] = new Button[6];

        /* LitBox item setting */
        String[] listBoxNameList = {
            "1.single selection",
            "2.radio button",
            "3.check box",
            "4.list of the numbers",
            "5.multiple selection",
            "6.option",
        };

        /* create processing selection menu */
        ListBox menuFocus = new ListBox(ListBox.CHOICE,3);

        /* pictographic characters */
        char[]    emoji             = {0xE63E, 0xE63F, 0xE640, 0xE641};
        char[]    emoji2            = {0xE63E, 0xE63F};

        /**
         * method action checking screen
         * @param  aType processing selection menu index
         * @param  aFrame the screen before shifting
         */
        public J011_3005_0201(int aType, Frame aFrame) {

            /* special character (pictograph) */
            char[]    emoji             = {0xE63E, 0xE63F, 0xE640, 0xE641};

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("API class normal route");

            /* sub title setting */
            Label subTitle = new Label("");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* check method's behavior */
            switch (aType) {
                /* action check1 */
                case 0:
                subTitle.setText("checking of the method 1");

                /**
                 * 
                 * select by the selection button,deselect by the deselect button, removeAll by the remove button
                 * checking visible by the visible button, setEnabled by enabled button, and getSelectedIndex by state button
                 * 
                 */

                /**
                 * creating listbox for checking(all of 6 type)
                 * create 5 button for each checking
                 * 
                 */
                int i;
                for ( i = 0; i < 6 ; i++ ){
                    if ( i != 5 ){
                        testListBox[i] = new ListBox(i,2);
                    } else {
/* takashi */                        testListBox[i] = new ListBox(i,1);
                    }
                    /* adding the item */
                    testListBox[i].append("");
                    testListBox[i].append("");
                    testListBox[i].append("ABCabc");
                    testListBox[i].append(String.valueOf(emoji2));
                    testListBox[i].append("Ab" + String.valueOf(emoji2));
//2002/07/30 Doja1.5                    testListBox[i].append("Ab" + String.valueOf(emoji2));
                    testListBox[i].append("number of the items="+ (testListBox[i].getItemCount() + 1));

                    testListBox[i].setVisible(true);

                    /* create checking button */
                    selectButton[i]=new Button("select");
                    deselectButton[i]=new Button("cancel");
                    removeButton[i]=new Button("delete");
                    visibleButton[i]=new Button("visible");
                    enabledButton[i]=new Button("available");
                    indexButton[i]=new Button("status");
                    addButton[i]=new Button("add");

                    /* listbox label setting */
                    Label listLabal = new Label(listBoxNameList[i]);
                    listLabal.setSize(getWidth(), listLabal.getHeight());

                    /* adding the component */
                    add(listLabal);
                    add(testListBox[i]);
                    add(selectButton[i]);
                    add(deselectButton[i]);
                    add(removeButton[i]);
                    add(visibleButton[i]);
                    add(enabledButton[i]);
                    add(indexButton[i]);
                    add(addButton[i]);

                }

            //J011_3105_0213
                /* create ListBox for checking setItem */
                ListBox setItemList = new ListBox(0,3);

                /* define the item with array */
                String[] setItemItem1 = {
                    "setItem1",
                    "setItem2",
                    "setItem3",
                };

                /* define the item ,which is set ,with array */
                String[] setItemItem2 = {
                    "setItem4",
                    "setItem5",
                    "setItem6",
                };

                /* item setting */
                setItemList.setItems(setItemItem1);
                setItemList.setItems(setItemItem2);

                /* title label setting */
                Label setItemLabel = new Label("check the setItem");
                setItemLabel.setSize(getWidth(),setItemLabel.getHeight());

                /* adding the title and ListBox for checking setItem */
                add(setItemLabel);
                add(setItemList);

                break;

                /* checking the focus */
                case 1:
                subTitle.setText("check the focus");

                /* processing selection menu item setting */
                String[] itemFocus = {
                    "0.set",
                    "1.requests before additions will be ignored",
                    "2.in case of no-op, requests are ignored",
                };

                /* adding the focus action check menu / execution button*/
                menuFocus.setItems(itemFocus);
                add(menuFocus);
                add(execButton); 

                break;

                /* checking the variation */
                case 2:
                subTitle.setText("check the variation");

                ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,5);
                testListBox.append("");
                testListBox.append("");
                testListBox.append("ABCabc");
                testListBox.append(String.valueOf(emoji));
                testListBox.append("Ab" + String.valueOf(emoji));
//2002/07/30 Doja1.5
                testListBox.append("Ab" + String.valueOf(emoji));
                add(testListBox);
            }
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        // J011_3105_0202
        // J011_3105_0204
        // J011_3105_0208
        // J011_3105_0209
        // J011_3105_0210
            /* define the action when the item of each ListBox is selected */
            if ( ( aComponent == testListBox[0]
                || aComponent == testListBox[1]
                || aComponent == testListBox[2]
                || aComponent == testListBox[3]
                || aComponent == testListBox[4]
                || aComponent == testListBox[5] )
                && aType == ComponentListener.SELECTION_CHANGED ) {
                /**
                 * when select button / deselect button is pressed
                 * display the state in the dialog when the item is selected
                 */
                int i = 0;
                for ( i = 0; i < 6; i++ ) {
                    if ( aComponent == testListBox[i] ) break;
                }
                int aSelect = testListBox[i].getSelectedIndex();
                if ( aSelect == -1 ) {
                    info.setText(listBoxNameList[i]+"s selection is released.");
                } else {
                    info.setText(listBoxNameList[i]+"s"+(testListBox[i].getSelectedIndex()+1)+"th line is selected");
                }
                info.show();
            }

            /* defining the action when the button of each listbox is pressed */
            if ( ( aComponent == selectButton[0]
                || aComponent == selectButton[1]
                || aComponent == selectButton[2]
                || aComponent == selectButton[3]
                || aComponent == selectButton[4]
                || aComponent == selectButton[5]
                || aComponent == deselectButton[0]
                || aComponent == deselectButton[1]
                || aComponent == deselectButton[2]
                || aComponent == deselectButton[3]
                || aComponent == deselectButton[4]
                || aComponent == deselectButton[5]
                || aComponent == removeButton[0]
                || aComponent == removeButton[1]
                || aComponent == removeButton[2]
                || aComponent == removeButton[3]
                || aComponent == removeButton[4]
                || aComponent == removeButton[5]
                || aComponent == visibleButton[0]
                || aComponent == visibleButton[1]
                || aComponent == visibleButton[2]
                || aComponent == visibleButton[3]
                || aComponent == visibleButton[4]
                || aComponent == visibleButton[5]
                || aComponent == enabledButton[0]
                || aComponent == enabledButton[1]
                || aComponent == enabledButton[2]
                || aComponent == enabledButton[3]
                || aComponent == enabledButton[4]
                || aComponent == enabledButton[5]
                || aComponent == indexButton[0]
                || aComponent == indexButton[1]
                || aComponent == indexButton[2]
                || aComponent == indexButton[3]
                || aComponent == indexButton[4]
                || aComponent == indexButton[5]
                || aComponent == addButton[0]
                || aComponent == addButton[1]
                || aComponent == addButton[2]
                || aComponent == addButton[3]
                || aComponent == addButton[4]
                || aComponent == addButton[5]
                 ) && aType == ComponentListener.BUTTON_PRESSED ) {
                int i;

                for ( i = 0; i < 6; i++ ) {
        // J011_3105_0201
        // J011_3105_0209
        // J011_3105_0210
                    /* by select button, select the item of the second line */
                    if ( selectButton[i] == aComponent ) {
                        testListBox[i].select(3);
//                        if ( testListBox[i].getItem() == 1 ) {
                            info.setText("getItem:" + testListBox[i].getItem(2));
                            info.show();
 //                       }
                        return;
                    }

                    if ( aComponent == testListBox[i]
                    && aType == SELECTION_CHANGED ) {
                        info.setText("SELECTION_CHANGED");
                        info.show();
                        return;
                    }

        // J011_3105_0203
                    /* by deselect button,deselect the item of the second line */
                    if ( deselectButton[i] == aComponent ) {
						if (i != 5)	{
    	                    testListBox[i].deselect(3);
						} else {
		                    info.setText(listBoxNameList[i]+"s selection is released.");
                        	info.show();
						}
                        return;
                    }
        // J011_3005_0205
                    /* by remove button,remove all the item */
                    if ( removeButton[i] == aComponent ) {
                        testListBox[i].removeAll();
                        return;
                    }
        // J011_3105_0206
                    /* by visible button, make the list invisible */
                    if ( visibleButton[i] == aComponent ) {
                        testListBox[i].setVisible(false);
                    }
        // J011_3105_0207
                    /* by enable button, make the list operation impossible */
                    if ( enabledButton[i] == aComponent ) {
                        testListBox[i].setEnabled(false);
                    }
        // J011_3105_0208
        // J011_3105_0211
        // J011_3105_0212
                    /**
                     * by state button,return the selected item
                     * by not selected / selected, display other dialog
                     */
                    if ( indexButton[i] == aComponent ) {
                        int aSelect1 = testListBox[i].getSelectedIndex();
                        int aSelect2;
                        for ( aSelect2 = 0; aSelect2 < testListBox[i].getItemCount(); aSelect2++ ) {
                            if ( testListBox[i].isIndexSelected(aSelect2) ) break;
                        }
                        if ( aSelect1 == -1 ) {
                            info.setText(listBoxNameList[i]+"is not selected.");
                        } else {
                            info.setText(
                                        listBoxNameList[i]+"s"
                                        +(testListBox[i].getSelectedIndex()+1)
                                        +"th line is selected+isIndex:"+ ((aSelect1 == aSelect2) ? "OK" : "NG")
                                        );
                        }
                        info.show();
                    }

                    /* by add button, add the item to the list */
                    if ( addButton[i] == aComponent ) {
                        testListBox[i].append("AddItem");;
                    }


                }
            }

            /* display the focus checking screen */
            if ( aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                Display.setCurrent(new J011_3005_0201_01(menuFocus.getSelectedIndex(), this));
            }

        }
    }

    /**
     * focus action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3005_0201_01 extends Panel implements SoftKeyListener,ComponentListener {


        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* create message dialog(error/guide) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* execution button */
        Button execButton = new Button("");

        /* create ListBox for checking */
        ListBox focusListBox1 = new ListBox(ListBox.CHOICE,3);
        ListBox focusListBox2 = new ListBox(ListBox.CHOICE,3);
        ListBox focusListBox3 = new ListBox(ListBox.CHOICE,3);

        /**
         * Focus action checking screen
         * @param  aType processing selection menu index
         * @param  aFrame the screen before shifting
         */
        public J011_3005_0201_01(int aType, Frame aFrame) {

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("API class normal route");

            /* sub title setting */
            Label subTitle = new Label("");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* Focus action checking */
            switch (aType) {
                /* Focus setting check */
                case 0:
                subTitle.setText("focus set");

                /* adding the component */
                add(focusListBox1);
                add(focusListBox2);
                add(focusListBox3);
                focusListBox1.append("focus not set");
                focusListBox2.append("focus set");
                focusListBox3.append("focus not set");

        // J011_3105_0214
            /* set the focus on the arbitrary component */
            focusListBox2.requestFocus();

                break;
                /*  */
                case 1:
                subTitle.setText("check that a request before additions is ignored");

            // J011_3105_0215
                /* set the focus on the component before ibeing added the panel on */
                focusListBox2.requestFocus();

                /* adding the component */
                add(focusListBox1);
                add(focusListBox2);
                add(focusListBox3);
                focusListBox1.append("focus set");
                focusListBox2.append("focus not set");
                focusListBox3.append("focus not set");
                break;

                /* check the ignoring when the operation is impossible */
                case 2:
                subTitle.setText("check the ignoring when the operation is impossible");

                /* create ListBox for checking */
                ListBox focusListBox1 = new ListBox(ListBox.CHOICE,3);
                ListBox focusListBox2 = new ListBox(ListBox.CHOICE,3);
                ListBox focusListBox3 = new ListBox(ListBox.CHOICE,3);

                /* adding the component */
                add(focusListBox1);
                add(focusListBox2);
                add(focusListBox3);
                focusListBox1.append("focus not set");
                focusListBox2.append("focus set");
                focusListBox3.append("focus not set");

                focusListBox2.requestFocus();

        // J011_3105_0216
            /* make the operation of arbitrary component impossible and set the focus on */
            focusListBox1.setEnabled(false);
            focusListBox1.requestFocus();
                break;

            }
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {}
    }


    /**
     * exception action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3006_0101 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3006_0101 = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* exception processing message display setting */
        String exceptionString = new String();
        TextBox exceptinTextBox = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);

        /**
         * J011_3006_0101 class constructor
         * @param aFrame the screen
         */
        J011_3006_0101(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3006_0101();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /* menu ListBox creation */
        ListBox errorMenu = new ListBox(ListBox.CHOICE,13);

        /**
         * exception action checking screen display
         */
        void showPanelJ011_3006_0101() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("check the exception"));

            /* exception menu item array */
            String[] errorListItem = {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
                "4.check the exception 5",
                "5.check the exception 6",
                "6.check the exception 7",
                "7.check the exception 8",
                "8.check the exception 9",
                "9.check the exception 10",
                "10 check the exception 11",
                "11 check the exception 12",
                "12 check the exception 13",
                "13 check the exception 14",
            };

            /* creating exception menu */
            int i;
            for ( i = 0; i < errorListItem.length ; i++ ){
                /* create the list */
                errorMenu.append(errorListItem[i]);
            }

            /* create the execution button */
            execButtonJ011_3006_0101 = new Button("execute");

            /* adding the component */
            add(errorMenu);
            add(execButtonJ011_3006_0101);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * display message dialog
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            Label testLabel;

            /* initialize the textbox when the menu is selected */
            if ( aComponent == errorMenu
                && aType == SELECTION_CHANGED) {
                    exceptinTextBox.setText("");
                    aFlag = true;
            }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_3006_0101
                && aType == BUTTON_PRESSED) {


try {
                /* divide the processing by menu */
                switch (errorMenu.getSelectedIndex()) {
            // J011_3106_0101
                    /* exception test 1 set ListBox type which doesn't exist*/
                    case 0:
                        try {
                            ListBox errorListBox = new ListBox(6);
                        } catch(IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\" IllegalArgumentException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" 6 has set to type");
                        }
                        break;
            // J011_3106_0102
                    /* exception test 2 set the ine number negative*/
                    case 1:
                        try {
                            ListBox errorListBox = new ListBox(0,-1);
                        } catch(IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\" IllegalArgumentException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" a number under 0 has set to rows");
                        }
                        break;
            // J011_3106_0103
                    /* exception test 3 set the Null item */

                    case 2:
                        try {
                            // compiling error (the proper method doesn't exist,errorListBox.setItems();)
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.setItems(null);
                        } catch(NullPointerException e) {
                            aFlag = true;
                            showMsg("\"OK\" NullPointerException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" null character has set to items");
                        }
                        break;

            // J011_3106_0104
                    /* exception test 4 set the item of Null array */
                    case 3:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            String[] setItemsItem = {null};
                            errorListBox.setItems(setItemsItem);
                        } catch(NullPointerException e) {
                            aFlag = true;
                            showMsg("\"OK\" NullPointerException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" a number under 0 has set to rows");
                        }
                        break;
            // J011_3106_0105
                    /* exception test 5 add the Null item */
                    case 4:
                        try {
                            // compiling error (the proper method doesn't exist,errorListBox.append();)
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.append(null);
                        } catch(NullPointerException e) {
                            aFlag = true;
                            showMsg("\"OK\" NullPointerException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" an empty item has added.");
                        }
                        break;

            // J011_3106_0106
                    /* exception test 6 do getItem a negative value */
                    case 5:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.getItem(-1);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" GetItem has gotten a negative value");
                        }
                        break;
            // J011_3106_0107
                    /* exception test 7 do getItem more than the number of items */
                    case 6:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.append("a");
                            errorListBox.append("b");
                            errorListBox.getItem(99);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" GetItem has gotten items in excess");
                        }
                        break;
            // J011_3106_0108
                    /* exception test 8 select a negative value*/
                    case 7:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.select(-1);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" selected item is a negative value");
                        }
                        break;
            // J011_3106_0109
                    /* exception test 9 select more than the number of items */
                    case 8:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.append("a");
                            errorListBox.append("b");
                            errorListBox.select(99);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" selected excess items");
                        }
                        break;
            // J011_3106_0110
                    /* exception test 10 deselect a negative value */
                    case 9:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.deselect(-1);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" deselected a negative item");
                        }
                        break;
            // J011_3106_0111
                    /* exception test 11 deselect more than the number of items */
                    case 10:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.append("a");
                            errorListBox.append("b");
                            errorListBox.deselect(99);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:"  + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" deselected more than the number of the items");
                        }
                        break;
            // J011_3106_0112
                    /* exception test 12 deselect CHOICE*/
                    case 11:
                        try {
                            // don't error
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox = new ListBox(ListBox.CHOICE,3);
                            errorListBox.append("a");
                            errorListBox.append("b");
                            add(errorListBox);
                            errorListBox.select(0);
                            errorListBox.deselect(0);
                        } catch(UIException e) {
                            showMsg("\"OK\" UIException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"OK\" a number under 0 has set to rows");
                        }
                        break;

            // J011_3106_0113
                    /* exception test 13 do isIndexSelected a negative value */
                    case 12:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.isIndexSelected(-1);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" isIndexSelected has selected a negateve item");
                        }
                        break;

            // J011_3106_0114
                    /* exception test 14 do isIndexSelected more than the number of items */
                    case 13:
                        try {
                            ListBox errorListBox = new ListBox(0,3);
                            errorListBox.append("a");
                            errorListBox.append("b");
                            errorListBox.isIndexSelected(99);
                        } catch(ArrayIndexOutOfBoundsException e) {
                            aFlag = true;
                            showMsg("\"OK\" ArrayIndexOutOfBoundsException:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" isIndexSelected has selected items in excess");
                        }
                        break;
                    }
                } catch (Exception e) {
                showMsg(e.getMessage());
                } catch (Error e) {
                    showMsg(e.getMessage());
                }
            }
        }
    }
}