/**
 * J011_3107_0101.java
 * 
 * J011_3107_0101
 * methodTest
 * ExceptionTest
 * 
 * action checking of the inheritance method from component class
 * 
 * $id: $
 */

import com.nttdocomo.ui.*;

/**
 * action checking main screen of the inheritance method from component class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
public class J011_3107_0101 extends Panel implements SoftKeyListener,ComponentListener {

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* execution button */
    Button execButton = null;

    /* create processing selection menu */
    ListBox componentTestMenu = new ListBox(ListBox.CHOICE,4);

    /* processing selection menu item */
    String[] menuItem = {
        "0.given value method 1",
        "1.given value method 2",
        "2.rated value method 1",
        "3.rated value method 2",
        "4.check the exception",
    };

    /**
     * J011_3107_0101 class constructor
     * @param  aFrame the screen before shifting
     */
    public J011_3107_0101(Frame aFrame) {

        try {
            previousFrame = aFrame;
            showJ011_3007_0101();
        } catch(Exception e) {
            err.setText("Exception:" + e.toString());
        } catch(Error e) {
            err.setText("Error" + e.toString());
        }

    }

    /**
     * display action checking of the inheritance method from component class
     */
    public void showJ011_3007_0101() {

        /* title displaying */
        setTitle("API class normal route");

        /* sub title displaying */
        Label subTitle = new Label("check behavior of the succeeded method",Label.LEFT);
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* main menu setting */
        componentTestMenu.setItems(menuItem);

        /* execution button setting */
        execButton = new Button("execute");

        /* add the component to the screen */
        add(componentTestMenu);
        add(execButton);
        
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* shift to the screen concerning the menu when the execution button is pressed */
        if ( aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED ) {
            if ( componentTestMenu.getSelectedIndex() == 4 ) {
                Display.setCurrent(new ExceptionTest((Frame) this));
            } else {
                Display.setCurrent(new methodTest(componentTestMenu.getSelectedIndex(), this));
            }
        }
    }
}

/**
 * method action check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class methodTest extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButton = new Button("");
    Button testButton1,testButton2,testButton3;

    /* listbox for checking */
    ListBox testListBox[] = new ListBox[7];

    /* textbox for action checking */
    TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

    /* textbox for checking whether or not it's visible */
    TextBox visibleTextBox = new TextBox("checking whether it's visible or invisible",getWidth(),1,TextBox.DISPLAY_ANY);

    /**
     * method action checking screen
     * @param  aType processing selection menu index
     * @param  aFrame the screen before shifting
     */
    public methodTest(int aType, Frame aFrame) {

        /* put the previous screen in */
        previousFrame = aFrame;

        /* title displaying */
        setTitle("API class normal route");

        /* sub title setting */
        Label subTitle = new Label("",Label.LEFT);
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* create the listbox for checking */
        int i;
        for ( i = 0; i < 7; i++ ) {
            testListBox[i] = new ListBox(ListBox.CHOICE,2);
        }

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* check method's behavior */
        try {

            switch (aType) {
                /* condition that layout manager is null */
                case 0:
                    /* set LayoutManage Null */
                    setLayoutManager(null);

                    subTitle.setText("checking the behavior of the given value method 1");

                    testButton1 = new Button("test 1");
                    testButton2 = new Button("test 2");
                    testButton1.setLocation(0,70);
                    testButton2.setLocation(40,70);
                    add(testButton1);
                    add(testButton2);

            // J011_3107_0101
                    /* setLacation of the component which has been added to the panel */
                    add(testListBox[1]);
                    testListBox[1].append("test 1");
                    testListBox[1].setLocation(10,20);

                    /* setLacation of the component before being added to the panel */
                    testListBox[2].setLocation(30,50);
                    testListBox[2].append("test 2");
                    add(testListBox[2]);

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /*  */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_3107_0105
                                    /* setLacation of the component which has been added */
                                    info.setText("Location:" + testListBox[1].getX() + "," + testListBox[1].getY());
                                    info.show();;
                                }
                                if ( aComponent == testButton2 ) {
                        // J011_3107_0106
                                    /* setLacation of the component before being adde */
                                    info.setText("Location:" + testListBox[2].getX() + "," + testListBox[2].getY());
                                    info.show();;
                                }
                            }
                        }
                    });

                    break;

                /* the condition that layout manager is not Null */
                case 1:
                    subTitle.setText("checking the behavior of the given value method 2");

                    /* set the background color of panel because it is uneasy to see in condition that the focus is on the button */
                    setBackground(Graphics.getColorOfName(Graphics.AQUA));

                    /* create the action checking button */
                    testListBox[1].append("test 1");
                    testListBox[2].append("test 2");
                    testListBox[3].append("test 3");
                    testListBox[4].append("test 4");
                    testListBox[5].append("OK");
                    testListBox[6].append("NG");

            // J011_3107_0102
                    /* the position setting before being added to the component. Confirming that it is invalid */
                    testListBox[1].setLocation(100,100);
                    add(testListBox[1]);

            // J011_3107_0102
                    /* the position setting after being added to the component. Confirming that it is invalid */
                    add(testListBox[2]);
                    testListBox[2].setLocation(200,200);

            // J011_3107_0103
                    /* before adding the component, confirming the setting of the size,background color and the foreground color is possible*/
                    add(testListBox[3]);
                    testListBox[3].setSize(50,30);
                    testListBox[3].setBackground(Graphics.getColorOfName(Graphics.BLUE));
                    testListBox[3].setForeground(Graphics.getColorOfName(Graphics.YELLOW));

            // J011_3107_0104
                    /* after adding the component, confirming the setting of the size,background color and the foreground color is possible */
                    testListBox[4].setSize(60,40);
                    testListBox[4].setBackground(Graphics.getColorOfName(Graphics.RED));
                    testListBox[4].setForeground(Graphics.getColorOfName(Graphics.WHITE));
                    add(testListBox[4]);

                    testButton1 = new Button("test 1");
                    testButton2 = new Button("test 2");
                    testButton1.setLocation(0,70);
                    testButton2.setLocation(40,70);
                    add(testButton1);
                    add(testButton2);

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /*  */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_3107_0105
                                    /* setSize of the component which has been added */
                                    info.setText("Size:" + testListBox[3].getWidth() + "," + testListBox[3].getHeight());
                                    info.show();;
                                }
                                if ( aComponent == testButton2 ) {
                        // J011_3107_0106
                                    /* setSize of the component before it is added */
                                    info.setText("Size:" + testListBox[4].getWidth() + "," + testListBox[4].getHeight());
                                    info.show();;
                                }
                            }
                        }
                    });
                    break;

                case 2:
                subTitle.setText("checking the behavior of the rated value method 1");

                    /* creating / adding the action checking button*/
                    testButton1 = new Button("ON");
                    testButton2 = new Button("OFF1");
                    testButton3 = new Button("OFF2");
                    testListBox[1].append("checking whether it's visible or invisible");
                    testListBox[2].append("OK");
                    testListBox[3].append("NG");
                    add(testListBox[1]);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);

            // J011_3107_0107
                    /* testListBox4 is displayed because ,before adding the component ,visible(true) is done */
                    testListBox[2].setVisible(true);
                    add(testListBox[2]);

                    /* testListBox4 is not displayed because ,before adding the component ,visible(false) is done */
                    testListBox[3].setVisible(false);
                    add(testListBox[3]);

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /* action check of setVisible() */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_3107_0105
                                    /* set the visibility */
                                    testListBox[1].setVisible(true);
                                }
                                if ( aComponent == testButton2 ) {
                        // J011_3107_0106
                                    /* set the invisibility */
                                    testListBox[1].setVisible(false);
                                }
                                if ( aComponent == testButton3 ) {
                                    /* after getting the focus , setting invisible */
                                    testListBox[1].requestFocus();
                                    testListBox[1].setVisible(false);
                                }
                            }
                        }
                    });

                    break;

                /* checking whether or not it is possible to get the component position */
                case 3:

                    setLayoutManager(null);

                    /* setting and adding the display position of the component*/
                    subTitle.setText("checking the behavior of the rated value method 3");
                    subTitle.setLocation(0,0);

                    testListBox[1].setSize(80,20);
                    testListBox[1].append("checking object");
                    testListBox[1].setLocation(0,20);
                    add(testListBox[1]);

                    testButton1 = new Button("check the coordinate");
                    testButton1.setLocation(0,40);
                    add(testButton1);

                    resultTextBox.setLocation(0,65);
                    add(resultTextBox);

                    testButton1.requestFocus();

                    setComponentListener(new ComponentListener() {
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            /* action checking of setVisible(). The value of the position which has been set must be returned */
                            if ( aType == BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                        // J011_3107_0108
                                    resultTextBox.setText("X:" + testListBox[1].getX() + "," + "Y:" + testListBox[1].getY() +
                                    "\nwidth:"+testListBox[1].getWidth()+",height:"+testListBox[1].getHeight());
                                }
                            }
                        }
                    });

                    break;
            }

        } catch(Exception e) {
            err.setText("Exception : " + e.toString());
            err.show();
        } catch(Error e) {
            err.setText("Error : " + e.toString());
        }

    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {}
}

/**
 * exception action checking screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class ExceptionTest extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* menu ListBox creation */
    ListBox errorMenu = new ListBox(ListBox.CHOICE,7);

    /* execution button */
    Button execButton = null;

    /* exception message OK/NG flag */
    boolean aFlag;

    /* exception checking component */
    ListBox testListBox = new ListBox(ListBox.CHOICE,1);

    /**
     * exception action checking screen display
     * @param aFrame the screen
     */
    ExceptionTest (Frame aFrame) {
        try {
            previousFrame = aFrame;
            showExceptionTest();
        } catch(Exception e) {
            err.setText("Exception: " + toString());
            err.show();
        } catch(Error e) {
            err.setText("Error: " + toString());
            err.show();
        }
    }

    void showExceptionTest() {

        /* title displaying */
        setTitle("API class normal route");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* sub title displaying */
        add(new Label("check the exception"));

        /* exception menu item array */
        String[] errorListItem = {
            "0.check the exception 1",
            "1.check the exception 2",
            "2.check the exception 3",
            "3.check the exception 4",
            "4.check the exception 5",
        };

        /* creating exception menu */
        errorMenu.setItems(errorListItem);

        /* create the execution button */
        execButton = new Button("execute");

        /* adding the component */
        add(errorMenu);
        add(execButton);

        testListBox.append("Item");

    }

        /**
         * display message dialog
         * @param  aMsg the message which display in the dialog
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* initialize the textbox when the menu is selected */
        if ( aComponent == errorMenu
            && aType == SELECTION_CHANGED) {
            aFlag = false;
        }

        /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
        if ( aComponent == execButton
            && aType == BUTTON_PRESSED) {


            /* divide the processing by menu */
            switch (errorMenu.getSelectedIndex()) {
        // J011_3107_0109
                /* exception test1 set width less than 0 */
                case 0:
                try {
                    testListBox.setSize(-1,10);
                    break;
                } catch(IllegalArgumentException iae) {
                    aFlag = true;
                    showMsg("\"OK\" IllegalArgumentException:"+ iae.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" the value under 0 was set to width");
                }
                break;

        // J011_3107_0110
                /* exception test2 set height less than 0 */
                case 1:
                try {
                    testListBox.setSize(10,-1);
                    break;
                } catch(IllegalArgumentException iae) {
                    aFlag = true;
                    showMsg("\"OK\" IllegalArgumentException:"+ iae.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" the value under 0 was set to height");
                }
                break;

        // J011_3107_0111
                /* exception test3 set width and height less than 0 */
                case 2:
                try {
                    testListBox.setSize(-1,-1);
                    break;
                } catch(IllegalArgumentException iae) {
                    aFlag = true;
                    showMsg("\"OK\" IllegalArgumentException:"+ iae.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" the value under 0 was set to width and height");
                }
                break;

        // J011_3107_0112
                /* exception test4 set the background color the invalid value */
                case 3:
                try {
                    testListBox.setBackground(-1);
                    break;
                } catch(IllegalArgumentException iae) {
                    aFlag = true;
                    showMsg("\"OK\" IllegalArgumentException:" + iae.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" -1 was set to background color");
                }
                break;

        // J011_3107_0113
                /* exception test5 set the background color the invalit value */
                case 4:
                try {
                    testListBox.setForeground(-1);
                    break;
                } catch(IllegalArgumentException iae) {
                    aFlag = true;
                    showMsg("\"OK\" IllegalArgumentException:" + iae.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" -1 was set to foreground color");
                }
                break;
            }
        }
    }
}
