/**
 * J011_3301_0101.java
 * 
 * J011_3301_0101
 * MainPanel
 * J011_3305_02
 * testJ011_3705_02
 * J011_3306_01
 * 
 * MediaData class action check (normal route)
 * 
 * $Id: J011_3301_0101.java,v 1.2 2001/12/02 05:15:13 waka Exp $
*/

import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;


/**
 * MediaData class action check main class
 * @extends IApplication
 */
public class J011_3301_0101 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * MediaData class action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

        /* execution button */
        Button execButton = null;
        /* create processing selection menu */
        ListBox mainMenu = new ListBox(ListBox.CHOICE,4);
        /* processing selection menu item */
        String[] mainItem = {
            "0.check the access level",
            "1.method's behavior",
            "2.behavior for thrown exceptions",
        };

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
            } catch(Error e) {
                err.setText("Error" + e.toString());
            }

        }

        /**
         * display MediaData class action check main screen
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("MediaData");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * softKeyReleased
         * terminate the application when the softkey1 is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* going to the screen or displaying when the execution button is pushed */
            if ( aComponent == execButton
                && aType == BUTTON_PRESSED ) {
                switch (mainMenu.getSelectedIndex()) {
                /* access level checking */
                case 0:
                    Display.setCurrent(new J011_3301_0301((Frame) this));
                    break;
                /* method action */
                case 1:
                    Display.setCurrent(new J011_3305_02((Frame) this));
                    break;
                /* exception action */
                case 2:
                    Display.setCurrent(new J011_3306_0101((Frame) this));
                    break;
                }
            }
        }
    }


    /**
     * access level action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3301_0301 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButton011_3201_0301 = null;

        /* create message dialog(error/) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* selection processing  menu */
        ListBox menuJ011_3301_0301 = new ListBox(ListBox.CHOICE,19);
        String[] menuList = {
            "0.use()",
            "1.unuse()",
            "2.dispose()",
        };

        /* result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        /**
         * J011_3301_0301 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_3301_0301(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3301_0301();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * displaying access level action check screen
         */
        void showPanelJ011_3301_0301() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* menu setting */
            menuJ011_3301_0301.setItems(menuList);

            /* execution button setting */
            execButton011_3201_0301 = new Button("execute");

            /* adding the component */
            add(new Label("check the access level"));
            add(menuJ011_3301_0301);
            add(execButton011_3201_0301);
            add(resultTextBox);

            /* setting the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * testing the selected menu
         */
        public void test() {
            ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,3);

            //MediaImage testMediaImage;
			MediaData testMediaData;
            MediaResource testMediaResource;
            VisualPresenter testVisualPresenter = new VisualPresenter();

            //testMediaImage = MediaManager.getImage("resource:///J011_3301_0101.gif");
            //testMediaResource = (MediaResource)testMediaImage;
			testMediaData = MediaManager.getData("resource:///J011_3301_0101.gif");
			if( testMediaData == null ) {
				err.setText("MediaData : Null");
				err.show();
				return;
			}

            try {
                /* execute each testing */
                switch( menuJ011_3301_0301.getSelectedIndex() ) {
                    /* use() */
                    case 0:
                        //testMediaResource.use();
						testMediaData.use();
                        resultTextBox.setText("OK");
                        break;
                    /* unuse() */
                    case 1:
                        //testMediaResource.use();
						testMediaData.use();
                        //testMediaResource.unuse();
						testMediaData.unuse();
                        resultTextBox.setText("OK");
                        break; 
                    /* dispose() */
                    case 2:
                        //testMediaResource.use();
						testMediaData.use();
                        //testMediaResource.dispose();
						testMediaData.dispose();
                        testListBox.requestFocus();
                        resultTextBox.setText("OK");
                        break;
                }
            } catch (Exception e) {
                err.setText("Exception: " + e.toString());
                err.show();
            } catch (Error e) {
                err.setText("Exception: " + e.toString());
                err.show();
            }
        }

        /**
         * do nothing when a softkey is pushed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_3301_0301
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* when  the execution button is pushed */
            if (aComponent == execButton011_3201_0301
                && aType == ComponentListener.BUTTON_PRESSED) {
                test();
            }
        }
    }

    /**
     * method action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3305_02 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3305_02 = null;

        /* create processing selection menu */
        ListBox menuJ011_3305_02 = new ListBox(ListBox.CHOICE,3);

        /* processing selection menu item setting */
        String[] itemJ011_3305_02 = {
            "0.use",
            "1.unuse",
            "2.dispose",
        };

        /* action checking result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),1,TextBox.DISPLAY_ANY);

        /* media setting */
        MediaData testMediaData;

        /**
         * J011_3305_02 class constructor
         * @param aFrame the screen
         */
        J011_3305_02(Frame aFrame) {
            try {
                /* put the previous screen in */
                previousFrame = aFrame;
                showPanelJ011_3305_02();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * method action check menu screen displaying
         */
        void showPanelJ011_3305_02() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("checking method's behavior");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* main menu setting */
            menuJ011_3305_02.setItems(itemJ011_3305_02);

            /* execution button setting */
            execButtonJ011_3305_02 = new Button("execute");

            /* add the component to the screen */
            add(menuJ011_3305_02);
            add(execButtonJ011_3305_02);
            add(resultTextBox);

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_3305_02
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_3305_02
                && aType == BUTTON_PRESSED) {

                try {

                    testMediaData = MediaManager.getData(("resource:///J011_3301_0101.gif"));
                    if(testMediaData == null){
                		err.setText("MediaData : Null");
                        err.show();
                		return;
                	}
                    
                    /* divide the processing by menu */
                    switch (menuJ011_3305_02.getSelectedIndex()) {
                        /* use() checking */
                        case 0:
                    // J011_3305_0201
                            testMediaData.use();
                            resultTextBox.setText("OK");
                            break;

                        /* unuse() checking */
                        case 1:
                    // J011_3305_0202
                            testMediaData.use();
                            testMediaData.unuse();
                            resultTextBox.setText("OK");
                            break;

                        /* dispose checking */
                        case 2:
                    // J011_3305_0203
                            testMediaData.use();
                            testMediaData.dispose();
                            resultTextBox.setText("OK");
                            break;
                    }

                    } catch (ConnectionException ce) {
                        err.setText("ConnectionException=" + ce.getStatus());
                        err.show();
                        return;
                    } catch (Exception e) {
                        err.setText("Exception=" + e.toString());
                        err.show();
                        return;
                    } catch (Error e) {
                        err.setText("Error=" + e.toString());
                        err.show();
                        return;
                    }
            }
        }
    }

    /**
     * exception action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3306_0101 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3306_0101 = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* exception processing message display setting */
//        String exceptionString = new String();
//        TextBox exceptinTextBox = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);

        /* media setting */
        //MediaImage testMediaImage;
		MediaData testMediaData;
        MediaResource testMediaResource;
        VisualPresenter testVisualPresenter = new VisualPresenter();

        /**
         * J011_3306_0101 class constructor
         * @param aFrame the screen
         */
        J011_3306_0101(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3306_0101();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /* menu ListBox creation */
        ListBox errorMenu = new ListBox(ListBox.CHOICE,7);

        /**
         * exception action checking screen display
         */
        void showPanelJ011_3306_0101() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("check the exception"));

            /* exception menu item array */
            String[] errorListItem = {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
                "4.check the exception 5",
                "5.check the exception 6",
                "6.check the exception 7",
                "7.check the exception 8"
            };

            /* creating exception menu */
            int i;
            for ( i = 0; i < errorListItem.length ; i++ ){
                /* create the list */
                errorMenu.append(errorListItem[i]);
            }

            /* create the execution button */
            execButtonJ011_3306_0101 = new Button("execute");

            /* adding the component */
            add(errorMenu);
            add(execButtonJ011_3306_0101);

        }

        /**
         * display message dialog
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            Label testLabel;

            /* initialize the textbox when the menu is selected */
            if ( aComponent == errorMenu
                && aType == SELECTION_CHANGED) {
                    aFlag = true;
            }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_3306_0101
                && aType == BUTTON_PRESSED) {

				testMediaData = MediaManager.getData("resource:///J011_3301_0101_0101.gif");
				if ( testMediaData == null ) {
					showMsg("MediaData : Null");
					return;
				}
                /* divide the processing by menu */
                switch (errorMenu.getSelectedIndex()) {
                    /* exception test 1 data which can not be played */
					// J011_3306_0101
                    case 0:
                        try {
                            //testMediaImage = MediaManager.getImage("resource:///J011_3301_0101_b.gif");
                            //testMediaResource = (MediaResource)testMediaImage;
                            //testMediaResource.use();
                            //testVisualPresenter.setImage(testMediaImage);
							testMediaData = MediaManager.getData("resource:///J011_3301_0101_b.gif");
							testMediaData.use();
							testVisualPresenter.setData(testMediaData);

                            add(testVisualPresenter);
                            testVisualPresenter.play();
                        } catch(UIException ue) {
                            if (ue.getStatus() == 4){
                                aFlag = true;
                                showMsg("UNSPOORTED_FORMAT:" + ue.getMessage());
                            } else {
                                showMsg("UIException:" + ue.getMessage());
                            }
                        } catch (Exception e) {
                            showMsg(e.toString());
                        }
                        if ( aFlag == false ) {
                            //showMsg("\"NG\" getImage has gotten a non-replayable Media");
							showMsg("\"NG\" getData has gotten a non-replayable Media");
                        }
                        break;

                    /* exception test 2 resource can not be gotten */
					// J011_3306_0102
                    case 1:
                        try {
                            Vector aVector = new Vector();
                            for ( ; ; ){
                                //testMediaImage = MediaManager.getImage("resource:///J011_3301_0101.gif");
                                //testMediaResource = (MediaResource)testMediaImage;
                                //testMediaResource.use();
								testMediaData = MediaManager.getData("resource:///J011_3301_0101_0101.gif");
								aVector.addElement(testMediaData);
								testMediaData.use();
                            }
                        } catch(UIException uie) {
                            if ( uie.getStatus() == 2) {
                                aFlag = true;
                                showMsg("\"OK\" UIException(NO_RESOURCES)");
                            } else {
                                showMsg("UIException Status=" + uie.getStatus());
                            }
                        } catch(OutOfMemoryError ooe) {
                            aFlag = true;
                            showMsg("\"OK\" OutOfMemoryError");
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException" + ce.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" an object has generated without lack of resources");
                        }
                        break;

                    /* exception test 3 after doing dispose(),call other than dispose() */
					// J011_3306_0103
                    case 2:
                        try {
//                            testMediaImage = MediaManager.getImage(getSourceURL() + "../res/J011_3301_0101.gif");
                            //testMediaImage = MediaManager.getImage("resource:///J011_3301_0101.gif");
                            //testMediaResource = (MediaResource)testMediaImage;
                            //testMediaResource.use();
                            //testMediaResource.dispose();
                            //testMediaResource.use();
							testMediaData = MediaManager.getData("resource:///J011_3301_0101.gif");
							testMediaData.use();
							testMediaData.dispose();
							testMediaData.use();
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException:" + ce.getMessage());
                        } catch (UIException uie) {
                            aFlag = true;
                            showMsg("\"OK\" UIException:" + uie.getMessage());
                        } catch (Exception e) {
                            aFlag = true;
                            showMsg("Exception:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" a function other than dispose() was called after dispose()");
                        }
                        break;

                    /**
                     * exception test 4 network doesn't exist 
                     * deselect I-mode service while doing use
                     */
					// J011_3306_0201
                    case 3:
                        try {
                            //testMediaImage = MediaManager.getImage(getSourceURL() + "../res/J011_3301_0101.gif");
                            //testMediaImage = MediaManager.getImage("resource:///J011_3301_0101.gif");
                            //testMediaResource = (MediaResource)testMediaImage;
                            //testMediaResource.use();
							testMediaData = MediaManager.getData("resource:///J011_3301_0101.gif");
							testMediaData.use();
                        } catch (ConnectionException ce) {
                            if ( ce.getStatus() == 5 ) {
                                aFlag = true;
                                showMsg("\"OK\" ConnectionException(OUT_OF_SERVICE)");
                            } else {
                                showMsg("ConectionException Status=" + ce.toString());
                            }
                        } catch (Exception e) {
                            aFlag = true;
                            showMsg("Exception:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\"");
                        }
                        break;

                    /**
                     * exception test 5 OUT_OF_SERVICE 
                     */
					// J011_3306_0202
                    case 4:
                        try {
                            //testMediaImage = MediaManager.getImage(getSourceURL() + "../res/J011_3301_0101.gif");
							testMediaData = MediaManager.getData(getSourceURL() + "../res/J011_3301_0101.gif");
//                            testMediaImage = MediaManager.getImage("resource:///J011_3301_0101.gif");
                            //testMediaResource = (MediaResource)testMediaImage;
                            //testMediaResource.use();
							testMediaData.use();
                        } catch (ConnectionException ce) {
                            if ( ce.getStatus() == 5 ) {
                                aFlag = true;
                                showMsg("\"OK\" ConnectionException(OUT_OF_SERVICE)");
                            } else {
                                showMsg("ConectionException Status=" + ce.toString());
                            }
                        } catch (Exception e) {
                            aFlag = true;
                            showMsg("Exception:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\"");
                        }
                        break;

                    /* exception test 6 network timeout */
					// J011_3306_0203
                    case 5:
                        try {
                            //testMediaImage = MediaManager.getImage(getSourceURL() + "../cgi-bin/tout.cgi?time=600");
                            //testMediaResource = (MediaResource)testMediaImage;
                            //testMediaResource.use();
							testMediaData = MediaManager.getData(getSourceURL() + "../cgi-bin/tout.cgi?time=600");
							testMediaData.use();
                        } catch (ConnectionException ce) {
// 2002/09/05 DoJa1.5                            if ( ce.getStatus() == 4 ) {
                            if ( ce.getStatus() == 7 ) {
                                aFlag = true;
                                showMsg("\"OK\" ConnectionException(TIME_OUT)");
                            } else {
                                showMsg("ConectionException Status=" + ce.toString());
                            }
                        } catch (Exception e) {
                            aFlag = true;
                            showMsg("Exception:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\"");
                        }
                        break;

					/* exception test 7 ConnectionException */
					// J011_3306_0204
                    case 6:
						try{
                            //testMediaImage = MediaManager.getImage(getSourceURL() + "../cgi-bin/tout.cgi?time=600");
                            //testMediaResource = (MediaResource)testMediaImage;
                            //testMediaResource.use();
							testMediaData = MediaManager.getData(getSourceURL() + "../cgi-bin/tout.cgi?time=600");
							testMediaData.use();
						}
						catch(ConnectionException ce){
                                showMsg("\"OK\"ConnectionException");
						}
						catch(Exception e){
                                showMsg("\"NG\"" + e.toString());
						}
                        break;

					/* exception test 8 ConnectionException(UNDEFIND) Unexpected I/O exception */
					// J011_3306_0205
					case 7:
						try{
				            //testMediaImage = MediaManager.getImage(getSourceURL() + "../cgi-bin/tout.cgi?time=600");
				            //testMediaResource = (MediaResource)testMediaImage;
				            //testMediaResource.use();
							testMediaData = MediaManager.getData(getSourceURL() + "../cgi-bin/tout.cgi?time=600");
							testMediaData.use();
						}
						catch(ConnectionException ce){
							if(ce.getStatus() == ConnectionException.UNDEFINED){
								showMsg("\"OK\"ConnectionException(UNDEFINED) Unexpected I/O exception");
							}
							else{
				                showMsg("\"NG\"" + ce.toString());
							}
						}
						catch(Exception e){
				                showMsg("\"NG\"" + e.toString());
						}
						break;

                }
            }
        }
    }
}
