/**
 * J011_3401_0101.java
 * 
 * MediaImage class action check (normal route)
 * 
 * J011_3401_0101
 * MainPanel
 * J011_3405_02
 * 
 * $Id: J011_3401_0101.java,v 1.2 2001/12/02 05:15:28 waka Exp $
*/

import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * MediaImage class action check main class
 * @extends IApplication
 */
public class J011_3401_0101 extends IApplication {

    /**
     * I-appli starting method
     */
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * MediaImage class action check main screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class MainPanel extends Panel implements SoftKeyListener,ComponentListener{

        /* execution button */
        Button execButton = null;
        /* create processing selection menu */
        ListBox mainMenu = new ListBox(ListBox.CHOICE,1);
        /* processing selection menu item */
        String[] mainItem = {
            "0.check the access level",
            "1.method's behavior 1",
            "2.method's behavior 2",
            "3.behavior for thrown exceptions",
        };

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
            } catch(Error e) {
                err.setText("Error" + e.toString());
            }

        }

        /**
         * display MediaImage class action check main screen
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("MadiaImage");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* going to the screen or displaying when the execution button is pushed */
            if ( aComponent == execButton
                && aType == BUTTON_PRESSED ) {
                switch (mainMenu.getSelectedIndex()) {
                /* access level action check */
                case 0:
                    Display.setCurrent(new J011_3401_0301((Frame) this));
                    break;
                /* check method's behavior */
                case 1:
                    Display.setCurrent(new J011_3405_0201((Frame) this));
                    break;
                /* method action 2 */
                case 2:
                    Display.setCurrent(new J011_3405_0202((Frame) this));
                    break;
                /* check behavior for the thrown exception */
                case 3:
                    Display.setCurrent(new J011_3406((Frame) this));
                    break;
                }
            }
        }
    }


    /**
     * access level action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3401_0301 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButton011_3301_0301 = null;

        /* create message dialog(error/) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* selection processing  menu */
        ListBox menuJ011_3401_0301 = new ListBox(ListBox.CHOICE,19);
        String[] menuList = {
            "0.getWidth()",
            "1.getHeight()",
            "2.use()",
            "3.unuse()",
            "4.dispose()",
            "5.getImage()",
        };

        /* result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        /**
         * J011_3401_0301 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_3401_0301(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3201_0301();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * displaying access level action check screen
         */
        void showPanelJ011_3201_0301() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* menu setting */
            menuJ011_3401_0301.setItems(menuList);

            /* execution button setting */
            execButton011_3301_0301 = new Button("execute");

            /* adding the component */
            add(new Label("check the access level"));
            add(menuJ011_3401_0301);
            add(execButton011_3301_0301);
            add(resultTextBox);

            /* setting the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * testing the selected menu
         */
        public void test() {
            ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,3);

            MediaImage testMediaImage;
            MediaResource testMediaResource;

            testMediaImage = MediaManager.getImage("resource:///J011_3401_0101.gif");
            testMediaResource = (MediaResource)testMediaImage;

            try {
                testMediaImage.use();
            } catch (ConnectionException ce) {
                err.setText("ConnectionException: " + ce.toString());
                err.show();
            }

            ImageLabel testImageLabel = new ImageLabel();
            testImageLabel.setImage(testMediaImage.getImage());

            try {
                /* execute each testing */
                switch( menuJ011_3401_0301.getSelectedIndex() ) {
// J011_3401_0301
                    /* getWidth() */
                    case 0:
                        resultTextBox.setText("OK");
                        break;
// J011_3401_0302
                    /* getHeight() */
                    case 1:
                        resultTextBox.setText("OK");
                        break;
// J011_3401_0304
                    /* use() */
                    case 2:
                        testMediaResource.use();
                        resultTextBox.setText("OK");
                        break;
// J011_3401_0305
                    /* unuse() */
                    case 3:
                        testMediaResource.use();
                        testMediaResource.unuse();
                        resultTextBox.setText("OK");
                        break; 
// J011_3401_0306
                    /* dispose() */
                    case 4:
                        testMediaResource.use();
                        testMediaResource.dispose();
                        testListBox.requestFocus();
                        resultTextBox.setText("OK");
                        break;
// J011_3401_0303
                    /* getImage() */
                    case 5:
                        testMediaImage = MediaManager.getImage("resource:///J011_3401_0101.gif");
                        resultTextBox.setText("OK");
                        break;
                }
            } catch (Exception e) {
                err.setText("Exception: " + e.toString());
                err.show();
            } catch (Error e) {
                err.setText("Exception: " + e.toString());
                err.show();
            }
        }

        /**
         * do nothing when a softkey is pushed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_3401_0301
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* when  the execution button is pushed */
            if (aComponent == execButton011_3301_0301
                && aType == ComponentListener.BUTTON_PRESSED) {
                test();
            }
        }
    }


    /**
     * method action check screen 1 class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3405_0201 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3405_0201 = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* exception processing message display setting */
        String exceptionString = new String();
        TextBox exceptinTextBox = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);


        /* media image setting */
        MediaImage aMediaImage1;
        MediaImage aMediaImage2;

        ImageLabel imageLabel1 = new ImageLabel();
        ImageLabel imageLabel2 = new ImageLabel();

        Dialog err2 = new Dialog(Dialog.DIALOG_INFO, "error");

        /**
         * J011_3405_0201 class constructor
         * @param aFrame the screen
         */
        J011_3405_0201(Frame aFrame) {

            try {
                previousFrame = aFrame;
                showPanelJ011_3405_0201();
            } catch (UIException e) {
                err.setText("UIException code="+e.toString());
                err.show();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * showPanelJ011_3405_0201
         * display method action checking screen
         */
        void showPanelJ011_3405_0201() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("checking method's behavior"));

        // J011_3405_0103
        // J011_3405_0105
            /* media image
             * aMediaImage1:for the normal displaying
             * aMediaImage2:for displaying Null 
             */
            aMediaImage1 = MediaManager.getImage("resource:///J011_3401_0101.gif");

            try {
// J011_3405_0106
                aMediaImage1.use();
//                aMediaImage2.use();
//                aMediaImage2.unuse();
            } catch (UIException e) {
                err2.setText("UIException code="+e.getStatus());
                err2.show();
            } catch (ConnectionException ce) {
                err2.setText("ConnectionException code="+ce.getStatus());
                err2.show();
            }


        // J011_3405_0101
            /* image creation / setting */
            imageLabel1.setImage(aMediaImage1.getImage());

            /* title / state label */
            Label titleLabel1 = new Label("acquisition image object");
            titleLabel1.setSize(getWidth(), titleLabel1.getHeight());
            Label infoLabel1 = new Label();
            infoLabel1.setSize(getWidth(), infoLabel1.getHeight());
            execButtonJ011_3405_0201 = new Button("test");

            /* adding the component */
            add(titleLabel1);
            add(imageLabel1);
            add(infoLabel1);
            add(execButtonJ011_3405_0201);
        // J011_3405_0101
        // J011_3405_0102
            /* display the state of media image */
            infoLabel1.setText("width:"+imageLabel1.getWidth()+",height:"+imageLabel1.getHeight());

            try {
                aMediaImage1.use();
            } catch (UIException e) {
                err2.setText("UIException code="+e.getStatus());
                err2.show();
            } catch (ConnectionException ce) {
                err2.setText("ConnectionException code="+ce.getStatus());
                err2.show();
            }

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            if ( aType == BUTTON_PRESSED ) {
                try {
                    aMediaImage2 = MediaManager.getImage("resource:///J011_3401_0101_b.gif");
                    imageLabel2.setImage(aMediaImage2.getImage());
// J011_3405_0104
                } catch (NullPointerException npe) {
                    err2.setText("NullPoineterException:"+ npe.getMessage());
                    err2.show();
                }
            }
        }
    }

    /**
     * method action checking2 menu screen class 
     * (checking of use(),unuse(),and despose() which are inherited from MediaResource
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3405_0202 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3405_0202 = null;

        /* create processing selection menu */
        ListBox menuJ011_3405_0202 = new ListBox(ListBox.CHOICE,3);

        /* processing selection menu item setting */
        String[] itemJ011_3405_0202 = {
            "0.use",
            "1.unuse",
            "2.dispose",
        };

        /**
         * J011_3405_0202 class constructor
         * @param aFrame the screen
         */
        J011_3405_0202(Frame aFrame) {
            try {
                /* put the previous screen in */
                previousFrame = aFrame;
                showPanelJ011_3405_0202();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * display method action checking 2 menu screen
         */
        void showPanelJ011_3405_0202() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("checking method's behavior");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* main menu setting */
            menuJ011_3405_0202.setItems(itemJ011_3405_0202);

            /* execution button setting */
            execButtonJ011_3405_0202 = new Button("execute");

            /* add the component to the screen */
            add(menuJ011_3405_0202);
            add(execButtonJ011_3405_0202);

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* shift to the screen concerning the menu when the execution button is pressed */
            if ( aComponent == execButtonJ011_3405_0202
                && aType == ComponentListener.BUTTON_PRESSED ) {
                Display.setCurrent(new testJ011_3405_0202(menuJ011_3405_0202.getSelectedIndex(), this));
            }
        }
    }

    /**
     * method action checking 2 screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class testJ011_3405_0202 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3405_0202 = null;

        /* media setting */
        MediaImage testMediaImage;
        MediaData testMediaData;
        MediaResource testMediaResource;
        VisualPresenter testVisualPresenter = new VisualPresenter();

        /**
         * method action checking
         * @param aType the position of menu item
         * @param aFrame previous screen
         */
        public testJ011_3405_0202(int aType, Frame aFrame) {

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);

            /* sub title displaying */
            add(new Label("checking method's behavior"));

            /* label for displaying the state */
            Label infoLabel = new Label("");
            infoLabel.setSize(getWidth(), infoLabel.getHeight());
            add(infoLabel);

            /* action checking for the checking item on the previous screen (0.use,1.unuse,2.dispose) */
            try {

                testMediaImage = MediaManager.getImage("resource:///J011_3401_0101_a.gif");
                testMediaResource = (MediaResource)testMediaImage;
// J011_3405_0106
                testMediaResource.use();
                testVisualPresenter.setImage(testMediaImage);
                add(testVisualPresenter);

                switch (aType) {
                    /* use() checking reproduce and display the image */
                    case 0:
                        testVisualPresenter.play();
                        infoLabel.setText("use play an animation");
                        return;

                    /* unuse() checking image is reproduced and displayed */
                    case 1:
                        infoLabel.setText("unuse stop the animation");
                        testVisualPresenter.play();
// J011_3405_0107
                        testMediaResource.unuse();
                        return;

                    /* dispose checking image is not displayed because the media is disposed */
                    case 2:
                        infoLabel.setText("dispose the animation has not shown");
                        testVisualPresenter.play();
// J011_3405_0108
// J011_3405_0109
                        testMediaResource.dispose();
                        return;
                }

            } catch (ConnectionException ce) {
                err.setText("ConnectionException=" + ce.toString());
                err.show();
                return;
            } catch (Exception e) {
                err.setText("Exception=" + e.toString());
                err.show();
                return;
            } catch (Error e) {
                err.setText("Error=" + e.toString());
                err.show();
                return;
            }
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }


    /**
     * exception action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3406 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3406 = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* media setting */
        MediaImage testMediaImage;
        MediaResource testMediaResource;
        VisualPresenter testVisualPresenter = new VisualPresenter();

        /**
         * J011_3406 class constructor
         * @param aFrame the screen
         */
        J011_3406(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3406();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /* menu ListBox creation */
        ListBox errorMenu = new ListBox(ListBox.CHOICE,13);

        /**
         * exception action checking screen display
         */
        void showPanelJ011_3406() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("check the exception"));

            /* exception menu item array */
            String[] errorListItem = {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
                "4.check the exception 5",
            };

            /* creating exception menu */
            int i;
            for ( i = 0; i < errorListItem.length ; i++ ){
                /* create the list */
                errorMenu.append(errorListItem[i]);
            }

            /* create the execution button */
            execButtonJ011_3406 = new Button("execute");

            /* adding the component */
            add(errorMenu);
            add(execButtonJ011_3406);

        }

        /**
         * display message dialog
         * @param  aMsg the message which display in the dialog
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }
        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /* basic ListBox for error checking */
        ListBox errorListBox = new ListBox(0,3);

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* initialize the textbox when the menu is selected */
            if ( aComponent == errorMenu
                && aType == SELECTION_CHANGED) {
                aFlag = false;
            }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_3406
                && aType == BUTTON_PRESSED) {

                /* divide the processing by menu */
                switch (errorMenu.getSelectedIndex()) {
                    /* exception test 1 data which can not be played */
                // J011_3406_0101
                    case 0:
                        try {
                            testMediaImage = MediaManager.getImage("resource:///J011_3401_0101_b.gif");
                            testMediaResource = (MediaResource)testMediaImage;
                            testMediaResource.use();
                            testVisualPresenter.setImage(testMediaImage);
                            add(testVisualPresenter);
                            testVisualPresenter.play();
                        } catch(UIException ue) {
                            if (ue.getStatus() == 4){
                                aFlag = true;
//2002/10/01 DoJa1.5                                showMsg("UNSPOORTED_FORMAT:" + ue.getMessage());
                                showMsg("UNSUPPORTED_FORMAT:" + ue.getMessage());
                            } else {
                                showMsg("UIException:" + ue.getMessage());
                            }
                        } catch (Exception e) {
                            showMsg(e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" getImage has gotten a non-replayable Media");
                        }
                        break;

                    /* exception test 2 resource can not be gotten */
                // J011_3406_0102
                    case 1:
                        try {
                            Vector aVector = new Vector();
                            for ( ; ; ){
                                testMediaImage = MediaManager.getImage("resource:///J011_3401_0101.gif");
                                testMediaResource = (MediaResource)testMediaImage;
                                testMediaResource.use();
                            }
                        } catch(UIException uie) {
                            if ( uie.getStatus() == 2) {
                                aFlag = true;
                                showMsg("\"OK\" UIException(NO_RESOURCES)");
                            } else {
                                showMsg("UIException Status=" + uie.getStatus());
                            }
                        } catch(OutOfMemoryError ooe) {
                            aFlag = true;
                            showMsg("\"OK\" OutOfMemoryError");
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException" + ce.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" an object has generated without lack of resources");
                        }
                        break;

                    /* exception test 3 after doing dispose(),call other than dispose() */
                // J011_3406_0103
                    case 2:
                        try {
//                            testMediaImage = MediaManager.getImage(getSourceURL() + "img/anim5.gif");
                            testMediaImage = MediaManager.getImage("resource:///J011_3401_0101.gif");
                            testMediaResource = (MediaResource)testMediaImage;
                            testMediaResource.use();
                            testMediaResource.dispose();
                            testMediaResource.use();
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException:" + ce.getMessage());
                        } catch (UIException uie) {
                            aFlag = true;
                            showMsg("\"OK\" UIException:" + uie.getMessage());
                        } catch (Exception e) {
                            aFlag = true;
                            showMsg("Exception:" + e.getMessage());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" a function other than dispose() was called after dispose()");
                        }
                        break;

                    /**
                     * exception test 4 network doesn't exist 
                     * deselect I-mode service while doing use
                     */
                // J011_3406_0201
                    case 3:
                        try {
                            testMediaImage = MediaManager.getImage(getSourceURL() + "../res/J011_3401_0101.gif");
//                            testMediaImage = MediaManager.getImage("resource:///J011_3401_0101.gif");
                            testMediaResource = (MediaResource)testMediaImage;
                            testMediaResource.use();
                        } catch (ConnectionException ce) {
                            if ( ce.getStatus() == 5 ) {
                                aFlag = true;
                                showMsg("\"OK\" ConnectionException(OUT_OF_SERVICE)");
                            } else {
                                showMsg("ConectionException Status=" + ce.toString()+":"+ce.getStatus());
                            }
                        } catch (Exception e) {
                            aFlag = true;
                            showMsg("Exception:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\"");
                        }
                        break;

                    /**
                    exception test 5 network timeout */
                // J011_3406_0202
                    case 4:
                        try {
                            testMediaImage = MediaManager.getImage(getSourceURL()+"../cgi-bin/tout.cgi?time=600");
                            testMediaResource = (MediaResource)testMediaImage;
                            testMediaResource.use();
                        } catch (ConnectionException ce) {
                            if ( ce.getStatus() == 7 ) {
                                aFlag = true;
                                showMsg("\"OK\" ConnectionException(TIMEOUT)");
                            } else {
                                showMsg("ConectionException Status=" + ce.toString());
                            }
                        } catch (Exception e) {
                            aFlag = true;
                            showMsg("Exception:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\"");
                        }
                        break;
                }
            }
        }
    }
}
