/**
 * J011_3601_0101.java
 * 
 * MediaManager class action check( normal route)
 * 
 * J011_3601_0101
 * MainPanel
 * J011_3604_02
 * J011_3606_01
 * 
 * $Id: J011_3601_0101.java,v 1.3 2002/02/14 11:09:48 lan Exp $
*/

import java.lang.*;
import java.util.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * MediaManager class action check main class
 * @extends IApplication
 */
public class J011_3601_0101 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * MediaManager class action checking main screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class MainPanel extends Panel implements SoftKeyListener,ComponentListener{

        /* execution button */
        Button execButton = null;

        /* create processing selection menu */
        ListBox mainMenu = new ListBox(ListBox.CHOICE,3);

        /* processing selection menu item */
        String[] mainItem = {
            "0.check the access level",
            "1.class method's behavior",
            "2.behavior for thrown exceptions",
        };

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
            } catch(Error e) {
                err.setText("Error" + e.toString());
            }

        }

        /**
         * display MediaSound class action checking main screen
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("MediaManager");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* going to the screen or displaying when the execution button is pushed */
            if ( aComponent == execButton
                && aType == BUTTON_PRESSED ) {
                switch (mainMenu.getSelectedIndex()) {
                /* access level action check */
                case 0:
                    Display.setCurrent(new J011_3601_0301((Frame) this));
                    break;
                /* check method's behavior */
                case 1:
                    Display.setCurrent(new J011_3604_02((Frame) this));
                    break;
                /* check behavior for the thrown exception */
                case 2:
                    Display.setCurrent(new J011_3606_01((Frame) this));
                    break;
                }
            }
        }
    }


    /**
     * access level action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3601_0301 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButton011_3501_0301 = null;

        /* create message dialog(error/) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* selection processing  menu */
        ListBox menuJ011_3601_0301 = new ListBox(ListBox.CHOICE,19);
        String[] menuList = {
            "0.getData()",
            "1.getImage()",
            "2.getSound()",
        };

        /* result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        J011_3601_0301(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3201_0301();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * displaying access level action check screen
         */
        void showPanelJ011_3201_0301() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* menu setting */
            menuJ011_3601_0301.setItems(menuList);

            /* execution button setting */
            execButton011_3501_0301 = new Button("execute");

            /* adding the component */
            add(new Label("check the access level"));
            add(menuJ011_3601_0301);
            add(execButton011_3501_0301);
            add(resultTextBox);

            /* setting the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * testing the selected menu
         */
        public void test() {
            ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,3);

            /* media setting */
            MediaData testMediaData;
            MediaImage testMediaImage;
            MediaSound testMediaSound;

            try {
                /* execute each testing */
                switch( menuJ011_3601_0301.getSelectedIndex() ) {
                    /* getData() */
                    case 0:
                        testMediaData = MediaManager.getData("resource:///J011_36img.gif");
                        resultTextBox.setText("OK");
                        break;
                    /* getImage() */
                    case 1:
                        testMediaImage = MediaManager.getImage("resource:///J011_36img.gif");
                        resultTextBox.setText("OK");
                        break;
                    /* getSound() */
                    case 2:
                        testMediaSound = MediaManager.getSound("resource:///J011_35.mld");
                        resultTextBox.setText("OK");
                        break;
                }
            } catch (Exception e) {
                err.setText("Exception: " + e.toString());
                err.show();
            } catch (Error e) {
                err.setText("Exception: " + e.toString());
                err.show();
            }
        }

        /**
         * do nothing when a softkey is pushed
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * define the action when softkey is released
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_3601_0301
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* when  the exsecution button is pushed */
            if (aComponent == execButton011_3501_0301
                && aType == ComponentListener.BUTTON_PRESSED) {
                test();
            }
        }
    }

    /**
     * class method action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3604_02 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3604_02 = null;

        /**
         * J011_3604_02 class constructor
         * @param aFrame the screen
         */
        J011_3604_02(Frame aFrame) {

            try {
                previousFrame = aFrame;
                showPanelJ011_3604_02();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /* media setting */
        MediaData testMediaData;
        MediaImage testMediaImage;
        MediaSound testMediaSound;
        AudioPresenter testAudioPresenter;

        /* media menu item */
        String[] mediaMenuItem = {
            "0.MediaData",
            "1.MediaImage",
            "2.MediaSound",
        };

        /* create media menu */
        ListBox mediaMenu = new ListBox(ListBox.CHOICE,3);

        /* textbox for displaying the result */
        String resultString = new String();
        TextBox resultTextBox = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);

        /**
         * showPanelJ011_3604_02
         * display method action checking screen
         */
        void showPanelJ011_3604_02() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("checking method's behavior"));

            /* set the item in the media menu */
            mediaMenu.setItems(mediaMenuItem);

            /* execution button setting */
            execButtonJ011_3604_02 = new Button("execute");

            /* add media menu and execution button */
            add(mediaMenu);
            add(execButtonJ011_3604_02);
            
            /* create and initialize the result displaying textbox */
            add(resultTextBox);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* initialize the textbox when the menu is selected */
            if ( aComponent == mediaMenu
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* processing of the menu when the execution button is pressed */
            if ( aComponent == execButtonJ011_3604_02
                && aType == BUTTON_PRESSED ) {

                /**
                 * display OK when each media (MediaData,MediaSound,MediaSound) is gotten
                 * display error message when they aren't gotten
                 */
                try {
                    switch (mediaMenu.getSelectedIndex()) {
        // J011_3604_0201
                        /* MediaData */
                        case 0:
                            testMediaData = MediaManager.getData("resource:///J011_36img.gif");
                            if( testMediaData != null ){
                            	testMediaData.use();
                            	resultTextBox.setText("OK");
                            } else {
                            	resultTextBox.setText("MediaManager.getData() is not supported.");
                            }
                            break;
        // J011_3604_0202
                        /* MediaImage */
                        case 1:
                            testMediaImage = MediaManager.getImage("resource:///J011_36img.gif");
                            testMediaImage.use();
                            resultTextBox.setText("OK");
                            break;
        // J011_3604_0203
                        /* MediaSound */
/*
 * UIException Unknown media sound format
 */
                        case 2:
                            testAudioPresenter = AudioPresenter.getAudioPresenter();
                            testMediaSound = MediaManager.getSound("resource:///J011_35.mld");
                            testMediaSound.use();
                            testAudioPresenter.setSound(testMediaSound);
                            testAudioPresenter.play();
                            resultTextBox.setText("OK");
                            break;
                    }
                } catch (ConnectionException ce) {
                    info.setText("ConnectionException=" + ce.getMessage());
                    info.show();
                } catch (SecurityException se) {
                    info.setText("SecurityException");
                    info.show();
                } catch (IllegalArgumentException iae) {
                    info.setText("IllegalArgumentException");
                    info.show();
                } catch (UIException uie) {
                    info.setText("UIExceptiossn=" + uie.toString()+":"+uie.getMessage());
                    info.show();
                } catch (Exception e) {
                    info.setText("Exception=" + e.toString());
                    info.show();
                } catch (Error e) {
                    info.setText("Error=" + e.toString());
                    info.show();
                }
            }
        }
    }
    /**
     * exception action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3606_01 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3606_01 = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* media setting */
        MediaData testMediaData;
        MediaImage testMediaImage;
        MediaSound testMediaSound;
        MediaResource testMediaResource;

        /**
         * J011_3603_01 class constructor
         * @param aFrame the screen
         */
        J011_3606_01(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3606_01();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /* menu ListBox creation */
        ListBox errorMenu = new ListBox(ListBox.CHOICE,13);

        /**
         * exception action checking screen display
         */
        void showPanelJ011_3606_01() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("check the exception"));

            /* exception menu item array */
            String[] errorListItem = {
                "0.Data exception 1",
                "2.Data exception 2_2",
                "3.Data exception 2_3",
                "4.Data exception 2_4",
                "5.Data exception 2_5",
                "6.Data exception 3",
                "7.Image exception 1",
                "9.Image exception 2_2",
                "10.Image exception 2_3",
                "11.Image exception 2_4",
                "12.Image exception 2_5",
                "13.Image exception 3",
                "14.Sound exception 1",
                "16.Sound exception 2_2",
                "17.Sound exception 2_3",
                "18.Sound exception 2_4",
                "19.Sound exception 2_5",
                "20.Sound exception 3",
            };

            /* creating exception menu */
            int i;
            for ( i = 0; i < errorListItem.length ; i++ ){
                /* create the list */
                errorMenu.append(errorListItem[i]);
            }

            /* create the execution button */
            execButtonJ011_3606_01 = new Button("execute");

            /* adding the component */
            add(errorMenu);
            add(execButtonJ011_3606_01);

        }

        /**
         * display message dialog
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /* basic ListBox for error checking */
        ListBox errorListBox = new ListBox(0,3);

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            Label testLabel;
            String[] url = new String[1];
            url = getArgs();

            /* initialize the textbox when the menu is selected */
            if ( aComponent == errorMenu
                && aType == SELECTION_CHANGED) {
                aFlag = true;
            }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_3606_01
                && aType == BUTTON_PRESSED) {

            String baseUrl = getSourceURL();
            int aCounter = 0;
            String aStat1 = "getData";
            String aStat2 = "getImage";
            String aStat3 = "getSound";

                /* divide the processing by menu */
                switch (errorMenu.getSelectedIndex()) {

        // J011_3606_0101
                    /**
                     * Data exception 1
                     * put the value in location of MediaData
                     */
                    case 0:
                        try {
                            aFlag = true;
                            testMediaData = MediaManager.getData("hogehoge");
                            if( testMediaData == null ){
                            	showMsg("MediaManager.getData() is not supported.");
                            	break;
                            }
                        } catch(IllegalArgumentException e) {
                            showMsg("\"OK\" IllegalArgumentException");
                        } catch(Exception e) {
                            showMsg(e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect value has set to location");
                        }
                        break;

       

        // J011_3606_0103
                    /**
                     * Data exception 2_2
                     * when MediaData is exceeding the security limitation
                     * URL set the IP
                     */
                    case 1:
                        try {
                            testMediaData = MediaManager.getData("http://192.168.0.1");
                            if( testMediaData == null ){
                            	showMsg("MediaManager.getData() is not supported.");
                            	break;
                            }
                            testMediaResource = (MediaResource)testMediaData;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg(e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" IP address has specified");
                        }
                        break;

        // J011_3606_0104
                    /**
                     * Data exception 2_3
                     * when MediaData is exceeding the security limitation
                     * invalid server
                     */
                    case 2:
                        try {
                            testMediaData = MediaManager.getData("http://www.yahoo.co.jp/");
                            if( testMediaData == null ){
                            	showMsg("MediaManager.getData() is not supported.");
                            	break;
                            }
                            testMediaResource = (MediaResource)testMediaData;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect server is specified");
                        }
                        break;

        // J011_3606_0105
                    /**
                     * Data exception 2_4
                     * when MediaData is exceeding the security limitation
                     * invalid scheme
                     */
                    case 3:
                        try {
                            //testMediaData = MediaManager.getData(url + "DJ15/J011/J011_3601_0101/res/GIF10kover.gif");
                         	String _url="";
                            if( getSourceURL().startsWith("https") ){
                            	_url = "http" + getSourceURL().substring(5);
                            } else {
                            	_url = "https" + getSourceURL().substring(4);
                            }
                            testMediaImage = MediaManager.getImage( _url + "../res/GIF10kover.gif" );
                            if( testMediaData == null ){
                            	showMsg("MediaManager.getData() is not supported.");
                            	break;
                            }
                            testMediaResource = (MediaResource)testMediaData;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect scheme is specified");
                        }
                        break;

        // J011_3606_0106
                    /**
                     * Data exception 2_5
                     * when MediaData is exceeding the security limitation
                     * invalid port
                     */
                    case 4:
                        try {
                        	/***
                            String url1 = getSourceURL();
                            int idx1 = url1.length();
                            String url2 = url1.substring(0,idx1-1);
                            url2 = url2 + ":8080/";
                            testMediaData = MediaManager.getData(url2);
                            ***/
                            String srcUrl = getSourceURL();
                            String _url="";
                            int idx, idxp;
                            if( srcUrl.startsWith("https://") ){
                            	idx = srcUrl.indexOf("/",8);
                            	idxp = srcUrl.indexOf(":",8);
                            } else { // case of "http://"
                            	idx = srcUrl.indexOf("/",7);
                            	idxp = srcUrl.indexOf(":",7);
                            }

                            if( idxp != -1 && idxp < idx ){ // case of already having port no
                            	_url = srcUrl.substring( 0, idxp ) + ":9999" + srcUrl.substring( idx );
                            } 
                            else {
                           		_url = srcUrl.substring( 0, idx ) + ":9999" + srcUrl.substring( idx );
                           	}
                            System.out.println(_url);
                            testMediaImage = MediaManager.getImage( _url );
                            if( testMediaData == null ){
                            	showMsg("MediaManager.getData() is not supported.");
                            	break;
                            }
                            testMediaResource = (MediaResource)testMediaData;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect port is specified");
                        }
                        break;

        // J011_3606_0107
                    /**
                     * exception test 3 
                     * MediaData object can not be created because of lack of the system resource
                     */
                    case 5:
                        try {
                            for ( ; ; ) {
                                testMediaImage = MediaManager.getImage("resource:///GIF10kover.gif");
                                testMediaImage.use();
                                aCounter++;
                            }
                        } catch(UIException uie) {
                            aFlag = true;
                            showMsg("\"OK\" UIException");
                        } catch(OutOfMemoryError ooe) {
                            aFlag = true;
                            showMsg("\"OK\" OutOfMemoryError");
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.toString());
                        } catch (Exception e) {
                            showMsg("Exception=" + e.toString());
                        } catch (Error e) {
                            showMsg("Error=" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" an object has generated without lack of resources");
                        }
                        break;

        // J011_3606_0108
                    /**
                     * Image exception 1
                     * put the value in location of MediaData
                     */
                    case 6:
                        try {
                            testMediaImage = MediaManager.getImage("ABC");
                        } catch(IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\" IllegalArgumentException:");
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect value has set to location");
                        }
                        break;


        // J011_3606_0110
                    /**
                     * Image exception 2_2
                     * when MediaData is exceeding the security limitation
                     * setting IP address
                     */
                    case 7:
                        try {
                            testMediaImage = MediaManager.getImage("http://192.168.0.1/");
                            testMediaResource = (MediaResource)testMediaImage;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" IP address has specified");
                        }
                        break;

        // J011_3606_0111
                    /**
                     * Image exception 2_3
                     * when MediaData is exceeding the security limitation
                     * invalid server
                     */
                    case 8:
                        try {
                            testMediaImage = MediaManager.getImage("http://www.yahoo.co.jp/");
                            testMediaResource = (MediaResource)testMediaImage;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect server is specified");
                        }
                        break;

        // J011_3606_0112
                /**
                     * Image exception 2_4
                     * when MediaData is exceeding the security limitation
                     * invalid scheme
                     */
                    case 9:
                        try {
                            //testMediaImage = MediaManager.getImage(url + "JAM-JVM/index/J011/J011_3601_0101/res/GIF10kover.gif");
                            String _url="";
                            if( getSourceURL().startsWith("https") ){
                            	_url = "http" + getSourceURL().substring(5);
                            } else {
                            	_url = "https" + getSourceURL().substring(4);
                            }
                            testMediaImage = MediaManager.getImage( _url + "../res/GIF10kover.gif" );
                            testMediaResource = (MediaResource)testMediaImage;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect scheme is specified");
                        }
                        break;

        // J011_3606_0113
                    /**
                     * Image exception 2_5
                     * when MediaData is exceeding the security limitation
                     * invalid port
                     */
                    case 10:
                        try {
                            //testMediaImage = MediaManager.getImage("http://www.yahoo.co.jp:8080/");
                            String srcUrl = getSourceURL();
                            String _url="";
                            int idx, idxp;
                            if( srcUrl.startsWith("https://") ){
                            	idx = srcUrl.indexOf("/",8);
                            	idxp = srcUrl.indexOf(":",8);
                            } else { // case of "http://"
                            	idx = srcUrl.indexOf("/",7);
                            	idxp = srcUrl.indexOf(":",7);
                            }

                            if( idxp != -1 && idxp < idx ){ // case of already having port no
                            	_url = srcUrl.substring( 0, idxp ) + ":9999" + srcUrl.substring( idx );
                            } 
                            else {
                           		_url = srcUrl.substring( 0, idx ) + ":9999" + srcUrl.substring( idx );
                           	}

                            testMediaImage = MediaManager.getImage( _url );
                            testMediaResource = (MediaResource)testMediaImage;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect port is specified");
                        }
                        break;

        // J011_3606_0114
                    /**
                     * Image exception test 3 
                     * MediaData object can not be created because of lack of the system resource
                     */
                    case 11:
                        try {
                            for ( ; ; ) {
                                testMediaImage = MediaManager.getImage("resource:///GIF10kover.gif");
                                testMediaImage.use();
                                aCounter++;
                            }
                        } catch(UIException uie) {
                            aFlag = true;
                            showMsg("\"OK\" UIException");
                        } catch(OutOfMemoryError ooe) {
                            aFlag = true;
                            showMsg("\"OK\" OutOfMemoryError");
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.toString());
                        } catch (Exception e) {
                            showMsg("Exception=" + e.toString());
                        } catch (Error e) {
                            showMsg("Error=" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" an object has generated without lack of resources");
                        } 
                        break;

        // J011_3606_0115
                    /**
                     * Sound exception 1
                     * put invalid value in the location of MediaSound
                     */
                    case 12:
                        try {
                            testMediaSound = MediaManager.getSound("ABC");
                        } catch(IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\" IllegalArgumentException:");
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect value has set to location");
                        }
                        break;


        // J011_3606_0117
                    /**
                     * Sound exception 2_2
                     * when MediaSound is exceeding the security limitation
                     * setting IP address
                     */
                    case 13:
                        try {
                            testMediaSound = MediaManager.getSound("http://192.168.0.1/");
                            testMediaResource = (MediaResource)testMediaSound;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" IP address has specified");
                        }
                        break;

        // J011_3606_0118
                    /**
                     * Sound exception 2_3
                     * when MediaSound is exceeding the security limitation
                     * invalid server
                     */
                    case 14:
                        try {
                            testMediaSound = MediaManager.getSound("http://www.yahoo.co.jp/");
                            testMediaResource = (MediaResource)testMediaSound;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect server is specified");
                        }
                        break;

        // J011_3606_0119
                    /**
                     * Sound exception 2_4
                     * when MediaSound is exceeding the security limitation
                     * invalid scheme
                     */
                    case 15:
                        try {
                            //testMediaSound = MediaManager.getSound(url + "JAM-JVM/index/J011/J011_3601_0101/res/J011_3601_0101.mld");
                            String _url="";
                            if( getSourceURL().startsWith("https") ){
                            	_url = "http" + getSourceURL().substring(5);
                            } else {
                            	_url = "https" + getSourceURL().substring(4);
                            }
                            testMediaSound = MediaManager.getSound( _url + "../res/J011_3601_0101.mld" );
                            testMediaResource = (MediaResource)testMediaSound;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect scheme is specified");
                        }
                        break;

        // J011_3606_0120
                    /**
                     * Sound exception 2_5
                     * when MediaSound is exceeding the security limitation
                     * invalid port
                     */
                    case 16:
                        try {
                            //testMediaSound = MediaManager.getSound("http://www.yahoo.co.jp:8080/");
                            String srcUrl = getSourceURL();
                            String _url="";
                            int idx, idxp;
                            if( srcUrl.startsWith("https://") ){
                            	idx = srcUrl.indexOf("/",8);
                            	idxp = srcUrl.indexOf(":",8);
                            } else { // case of "http://"
                            	idx = srcUrl.indexOf("/",7);
                            	idxp = srcUrl.indexOf(":",7);
                            }

                            if( idxp != -1 && idxp < idx ){ // case of already having port no
                            	_url = srcUrl.substring( 0, idxp ) + ":9999" + srcUrl.substring( idx );
                            } 
                            else {
                           		_url = srcUrl.substring( 0, idx ) + ":9999" + srcUrl.substring( idx );
                           	}
                            System.out.println(_url);

                            testMediaSound = MediaManager.getSound( _url );
                            testMediaResource = (MediaResource)testMediaSound;
                            aStat1 = "use,";
                            testMediaResource.use();
                        } catch(SecurityException se) {
                            aFlag = true;
                            showMsg("\"OK\" SecurityException:" + se.getMessage());
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" incorrect port is specified");
                        }
                        break;

        // J011_3606_0121

/*
 * incompleteness
 * UIException occurs because mld can not be reproduced
 * though ,on the code , the exception is catched,
 * that is not for the expected reason
 */
                    /**
                     * Sound exception test 3 
                     * MediaData object can not be created because of lack of the system resource
                     */
                    case 17:
                        try {
                            for ( ; ; ) {
                                testMediaSound = MediaManager.getSound("resource:///J011_35.mld");
                                testMediaSound.use();
                                aCounter++;
                            }
                        } catch(UIException uie) {
                            aFlag = true;
                            showMsg("\"OK\" UIException("+uie.getMessage()+")");
//2002/08/19 Doja1.5                            showMsg(""OK" UIException");
                        } catch(OutOfMemoryError ooe) {
                            aFlag = true;
                            showMsg("\"OK\" OutOfMemoryError");
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.toString());
                        } catch (Exception e) {
                            showMsg("Exception=" + e.toString());
                        } catch (Error e) {
                            showMsg("Error=" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" an object has generated without lack of resources");
                        } 
                        break;
                }
            }
        }
    }
}
