/**
 * J011_3601_0601.java
 * 
 * MediaManager class action check( normal route)
 * 
 * J011_3601_0101
 * MainPanel
 * 
 * $Id: J011_3606_0101.java,v 1.3 2002/01/18 04:59:59 waka Exp $
*/

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import java.util.*;

/**
 * MediaManager class action check main class
 *
 *
 */
public class J011_3606_0101 extends IApplication {

    /**
     * I-appli starting method
     */
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

/**
 * MediaManager class action checking main screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    Button execButton  = null;                              /* execution button */
    ListBox mainMenu = null;                                /* main menu */
    String[] menuItem = {"0.Data","1.Image","2.Sound",};    /* items on the main menu */

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            showMainPanel();
        } catch (Exception e) {
            showMsg("Exception:" + e.toString());
        } catch(Error e) {
            showMsg("Error:" + e.toString());
        }
    }

    /**
     * display MediaSound class action checking main screen
     */
    public void showMainPanel() {
        /* title displaying */
        setTitle("API class normal route");

        /* sub title displaying */
        Label subTitle = new Label("MediaManager exception verification");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* adding the component */
        mainMenu = new ListBox(ListBox.CHOICE,3);
        execButton = new Button("execute");
        add(mainMenu);
        add(execButton);
        mainMenu.setItems(menuItem);
    }

    /**
     * test execution method
     * @param index of the menuIndex menu
     */
    public void test(int menuIndex) {
        MediaData testMediaData = null;      /* Media data */
        MediaImage testMediaImage = null;    /* image */
        MediaSound testMediaSound = null;    /* sound */
        boolean exceptionFlag = false;       /* flag for exception */

        try {
            switch (menuIndex) {
                case 0:
                    try {
                        exceptionFlag = false;
// J011_3606_0122
                        testMediaData = MediaManager.getData(getSourceURL() + "../res/anim5.gif");
						if(testMediaData == null){
                			showMsg("OK : MediaData is Null");
                			return;
                		}
						
                    } catch (SecurityException se) {
                        exceptionFlag = true;
                        showMsg("\"OK\" SecurityException:" + se.getMessage());
                        }
                    if ( exceptionFlag == false ) {
                        showMsg("\"NG\" had access to network without setting a key to ADF");
                    }
                break;
                case 1:
                    try {
                        exceptionFlag = false;
// J011_3606_0123
                        testMediaImage = MediaManager.getImage(getSourceURL() + "../res/anim5.gif");
                    } catch (SecurityException se) {
                        exceptionFlag = true;
                        showMsg("\"OK\" SecurityException:" + se.getMessage());
                    }
                    if ( exceptionFlag == false ) {
                        showMsg("\"NG\" had access to network without setting a key to ADF");
                    }
                break;
                case 2:
                    try {
                        exceptionFlag = false;
// J011_3606_0124
                        testMediaSound = MediaManager.getSound(getSourceURL() + "../res/J011_3601_0101.mld");
                    } catch (SecurityException se) {
                        exceptionFlag = true;
                        showMsg("\"OK\" SecurityException:" + se.getMessage());
                    }
                    if ( exceptionFlag == false ) {
                        showMsg("\"NG\" had access to network without setting a key to ADF");
                    }
                break;
            }
        } catch (Exception e) {
            showMsg(e.toString());
        }
    }

   /**
    * dialog display method
    * @param messages to be displayed on myMsg dialog
    */
    public void showMsg(String myMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(myMsg);
        msgDialog.show();
    }

   /**
    * do nothing when the softkey is pressed
    * @param aSoftKey softkey type
    */
    public void softKeyPressed(int softKeyValue) {}

   /**
    * terminate the application when the softkey1 is released
    * shift to the previous screen in case of softkey2
    * @param aSoftKey softkey type
    */
    public void softKeyReleased(int softKeyValue) {
        if ( softKeyValue == Frame.SOFT_KEY_1 ) {
            IApplication.getCurrentApp().terminate();
        }
    }

   /**
    * get the event on a component
    * @param aComponent The component on which a event occurred
    * @param aType Type of an event.
    * @param aParam Parameter of an event
    */
    public void componentAction(Component aComponent, int aType, int aPram) {
        if ( aType == BUTTON_PRESSED ) {
            test(mainMenu.getSelectedIndex());
        }
    }
}
}