/**
 * J011_3606_0116.java
 * 
 * MediaManager class action check( normal route)
 * 
 * J011_3606_0116
 * MainPanel
 * J011_3604_02
 * J011_3606_01
 * 
 * $Id: J011_3606_0116.java,v 1.3 2002/02/14 11:09:48 lan Exp $
*/

import java.lang.*;
import java.util.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * MediaManager class action check main class
 * @extends IApplication
 */
public class J011_3606_0116 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
    	mainPanel.showPanel();	
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
//    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
//    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

   /**
     * exception action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
   public class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButton = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* media setting */
//        MediaData testMediaData;
//        MediaImage testMediaImage;
        MediaSound testMediaSound;
        MediaResource testMediaResource;
	 	TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
//        TextBox menu;


      

        /**
         * exception action checking screen display
         */
        void showPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("check the exception"));
            add(textBox1);
          
          
            /* create the execution button */
            execButton = new Button("execute");

            /* adding the component */
        
            add(execButton);

        }

        /**
         * display message dialog
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
//            Label testLabel;
//            String[] url = new String[1];
//            url = getArgs();

            /* initialize the textbox when the menu is selected */
//            if ( aComponent == menu && aType == SELECTION_CHANGED) {
           //     aFlag = true;
//           }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButton && aType == BUTTON_PRESSED) {

        // J011_3606_0116
                    /**
                     * Sound exception 2_1
                     * when MediaSound is exceeding the security limitation
                     * set the URL which is prohibited by docom.ne.jp
                     */
                   	String	Str = new String("");
                    Str = textBox1.getText();
                        try {
                            testMediaSound = MediaManager.getSound(Str);
                            testMediaResource = (MediaResource)testMediaSound;
                           
                            testMediaResource.use();
						// 2003/04/03 ->
                        //} catch(SecurityException se) {
                          
                            //showMsg("\"OK\" SecurityException:" + se.getMessage());
						} catch (IllegalArgumentException iae) {
							aFlag = true;
							showMsg(iae.toString());
						// 2003/04/03 <-
                        } catch (ConnectionException ce) {
                            showMsg("ConnectionException=" + ce.getStatus());
                        } catch(Exception e) {
                            showMsg("Exception:" + e.toString());
                        } catch(Error e) {
                            showMsg("Error:" + e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" a URL that is prohibited by  "+Str+"  has specified");
                        }
            }
        }
   }
}