/**
 * J011_3901_0101.java
 * 
 * J011_3901_0101
 * MainPanel
 * J011_3905_02
 * testJ011_3905_02
 * J011_3906_01
 * 
 * MediaSound class action check(normal route)
 * 
 * $Id: J011_3901_0101.java,v 1.2 2001/12/02 05:17:23 waka Exp $
*/

import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * MediaSound class action checking main class
 * @extends IApplication
 */
public class J011_3901_0101 extends IApplication {
    /**
     * I-appli starting method
     */
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * MediaSound class action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

        /* execution button */
        Button execButton = null;
        /* create processing selection menu */
        ListBox mainMenu = new ListBox(ListBox.CHOICE,4);
        /* processing selection menu item */
        String[] mainItem = {
            "0.check the access level",
            "1.method's behavior",
            "2.behavior for thrown exceptions",
        };

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
            } catch(Error e) {
                err.setText("Error" + e.toString());
            }

        }

        /**
         * display MediaPresenter class action check main screen
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("MediaSound");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * softKeyReleased
         * terminate the application when the softkey1 is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* going to the screen or displaying when the execution button is pushed */
            if ( aComponent == execButton
                 && aType == BUTTON_PRESSED ) {
                switch (mainMenu.getSelectedIndex()) {
                /* access level checking */
                case 0:
                    Display.setCurrent(new J011_3901_0301((Frame) this));
                    break;
                /* method action */
                case 1:
                    Display.setCurrent(new J011_3905_02((Frame) this));
                    break;
                /* exception action */
                case 2:
                    Display.setCurrent(new J011_3906_0101((Frame) this));
                    break;
                }
            }
        }
    }

    /**
     * access level action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_3901_0301 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButton011_3801_0301 = null;

        /* create message dialog(error/) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* selection processing  menu */
        ListBox menuJ011_3901_0301 = new ListBox(ListBox.CHOICE,19);
        String[] menuList = {
            "1.use()",
            "2.unuse()",
            "3.dispose()",
        };

        /* result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        /**
         * J011_3901_0301 class constructor
         * @param  aType processing selection menu index
         * @param  aFrame the screen before shifting
         */
        J011_3901_0301(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3901_0301();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * displaying access level action check screen
         */
        void showPanelJ011_3901_0301() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* menu setting */
            menuJ011_3901_0301.setItems(menuList);

            /* execution button setting */
            execButton011_3801_0301 = new Button("execute");

            /* adding the component */
            add(new Label("check the access level"));
            add(menuJ011_3901_0301);
            add(execButton011_3801_0301);
            add(resultTextBox);

            /* setting the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * testing the selected menu
         */
        public void test() {
            ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,3);

            MediaSound testMediaSound;
            AudioPresenter testAudioPresenter = null;

            testMediaSound = MediaManager.getSound("resource:///J011_3901_0101.mld");
            testAudioPresenter.getAudioPresenter();

            try {
                /* execute each testing */
                switch( menuJ011_3901_0301.getSelectedIndex() ) {
                // J011_3901_0301
                /* use() */
                case 0:
                    testMediaSound.use();
                    resultTextBox.setText("OK");
                    break;
                // J011_3901_0302
                /* unuse() */
                case 1:
                    testMediaSound.use();
                    testMediaSound.unuse();
                    resultTextBox.setText("OK");
                    break; 
                // J011_3901_0303
                /* dispose() */
                case 2:
                    testMediaSound.use();
                    testMediaSound.dispose();
                    testListBox.requestFocus();
                    resultTextBox.setText("OK");
                    break;
                }
            } catch (Exception e) {
                err.setText("Exception: " + e.toString());
                err.show();
            } catch (Error e) {
                err.setText("Exception: " + e.toString());
                err.show();
            }
        }

        /**
         * do nothing when a softkey is pushed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * define the action when softkey is released
         * @param  aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_3901_0301
                 && aType == SELECTION_CHANGED) {
                resultTextBox.setText("");
            }

            /* when  the execution button is pushed */
            if (aComponent == execButton011_3801_0301
                && aType == ComponentListener.BUTTON_PRESSED) {
                test();
            }
        }
    }

    /**
     * method action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3905_02 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3905_02 = null;

        /* create processing selection menu */
        ListBox menuJ011_3905_02 = new ListBox(ListBox.CHOICE,3);

        /* processing selection menu item setting */
        String[] itemJ011_3905_02 = {
            "0.use",
            "1.unuse",
            "2.dispose",
        };

        /**
         * J011_3905_02 class constructor
         * @param aFrame the screen
         */
        J011_3905_02(Frame aFrame) {
            try {
                /* put the previous screen in */
                previousFrame = aFrame;
                showPanelJ011_3905_02();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * method action check menu screen displaying
         */
        void showPanelJ011_3905_02() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("checking method's behavior");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* main menu setting */
            menuJ011_3905_02.setItems(itemJ011_3905_02);

            /* execution button setting */
            execButtonJ011_3905_02 = new Button("execute");

            /* add the component to the screen */
            add(menuJ011_3905_02);
            add(execButtonJ011_3905_02);

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* shift to the screen concerning the menu when the execution button is pressed */
            if ( aComponent == execButtonJ011_3905_02
                 && aType == ComponentListener.BUTTON_PRESSED ) {
                Display.setCurrent(new testJ011_3905_02(menuJ011_3905_02.getSelectedIndex(), this));
            }
        }
    }


	AudioPresenter testAudioPresenter = AudioPresenter.getAudioPresenter();
	/* media setting */
     MediaSound testMediaSound = null;
    
    boolean first = true;
    /**
     * method action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class testJ011_3905_02 extends Panel implements SoftKeyListener,ComponentListener,MediaListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3905_02 = null;

        
        

        /* create the label for displaying media status */
        Label statusLabel = new Label();

        /**
         * method action checking
         * @param aType the position of menu item
         * @param aFram previous screen
         */
        public testJ011_3905_02(int aType, Frame aFrame) {

            /* put the previous screen in */
            previousFrame = aFrame;

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);

            /* sub title displaying */
            add(new Label("checking method's behavior"));

            /* label for displaying the state */
            Label infoLabel = new Label("");
            infoLabel.setSize(getWidth(), infoLabel.getHeight());
            add(infoLabel);

            /* create the label for displaying media status */
            Label statusLabel = new Label();

            /* action checking for the checking item on the previous screen (0.use,1.unuse,2.dispose) */
            try {
//                testMediaSound = MediaManager.getSound(getSourceURL() + "mld/asia.mld");
                
                if(first){
	                
	                testMediaSound = MediaManager.getSound("resource:///J011_3901_0101.mld");
	                testMediaSound.use();
	                testAudioPresenter.setSound(testMediaSound);
	                testAudioPresenter.play();
	                first = false;
	            }

                switch (aType) {
                /* use() checking playing the sound */
                // J011_3905_0201
                case 0:
                    infoLabel.setText("use play the sound");
                    return;

                /* unuse() checking stop the sound */
                // J011_3905_0202
                case 1:
                    infoLabel.setText("unuse stop the sound");
                    testAudioPresenter.play();
                    testMediaSound.unuse();
                    first = true;
                    return;

                /* dispose checking  the media is disposed and don't sound */
                // J011_3905_0203
                // J011_3905_0204
                case 2:
                    infoLabel.setText("dispose the sound has not played");
                    testAudioPresenter.play();
                    testMediaSound.dispose();
                    first = true;
                    return;
                }

            } catch (ConnectionException ce) {
                err.setText("ConnectionException=" + ce.getStatus());
                err.show();
                return;
            } catch (Exception e) {
                err.setText("Exception=" + e.toString());
                err.show();
                return;
            } catch (Error e) {
                err.setText("Error=" + e.toString());
                err.show();
                return;
            }
        }

        /**
         * get the notice from media presenter
         * @param aSrc media presenter which is the source of the notice
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void mediaAction(MediaPresenter aSrc, int aType, int aParam) {

            if (aSrc == testAudioPresenter) {
                if (aType == testAudioPresenter.AUDIO_PLAYING) {
                    statusLabel.setText("");
                     statusLabel.setText("play");
                } else if (aType == testAudioPresenter.AUDIO_STOPPED) {
                    statusLabel.setText("");
                     statusLabel.setText("stop");
                } else if (aType == testAudioPresenter.AUDIO_COMPLETE) {
                    statusLabel.setText("");
                    statusLabel.setText("exit");
                }
            }
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {}
    }

    /**
     * exception action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_3906_0101 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_3906_0101 = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* media setting */
        MediaSound testMediaSound;
        MediaResource testMediaResource;
        AudioPresenter testAudiolPresenter;

        /**
         * J011_3906_0101 class constructor
         * @param aFrame the screen
         */
        J011_3906_0101(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_3906_0101();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /* menu ListBox creation */
        ListBox errorMenu = new ListBox(ListBox.CHOICE,7);

        /**
         * exception action checking screen display
         */
        void showPanelJ011_3906_0101() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("check the exception"));

            AudioPresenter testAudiolPresenter;

            /* exception menu item array */
            String[] errorListItem = {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
                "4.check the exception 5",
            };

            /* creating exception menu */
            int i;
            for ( i = 0; i < errorListItem.length ; i++ ){
                /* create the list */
                errorMenu.append(errorListItem[i]);
            }

            /* create the execution button */
            execButtonJ011_3906_0101 = new Button("execute");

            /* adding the component */
            add(errorMenu);
            add(execButtonJ011_3906_0101);

            /* create and initialize the exception display textbox */
        }

        /**
         * dialog display method
         * @param  aMsg character string which is displayed
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            Label testLabel;

            /* initialize the textbox when the menu is selected */
            if ( aComponent == errorMenu
                 && aType == SELECTION_CHANGED) {
                aFlag = true;
            }


            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_3906_0101
                 && aType == BUTTON_PRESSED) {

                /* media setting */
                AudioPresenter testAudioPresenter = null;
				testAudioPresenter = AudioPresenter.getAudioPresenter();

                /* divide the processing by menu */
                switch (errorMenu.getSelectedIndex()) {
                /* exception test 1 data which can not be played */
                // J011_3906_0101
                case 0:
                    try {
//                            testMediaSound = MediaManager.getSound(getSourceURL() + "mld/asia.mld");
                        testMediaSound = MediaManager.getSound("resource:///J011_3901_0101.gif");
                        testMediaSound.use();
                        testAudioPresenter.setSound(testMediaSound);
                        testAudioPresenter.play();
                    } catch(UIException ue) {
                        aFlag = true;
                        showMsg("\"OK\" UIException:" + ue.getMessage());
                    } catch (Exception e) {
                        showMsg(e.toString());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\" specified data cannot be played");
                    }
                    break;

                /* exception test 2 resource can not be gotten */
                // J011_3906_0102
                case 1:
                    try {
                        Vector aVector = new Vector();
                        for ( ; ; ){
//                            testMediaSound = MediaManager.getSound(getSourceURL() + "mld/asia.mld");
                            testMediaSound = MediaManager.getSound("resource:///J011_3901_0101.mld");
							// 2003/03/28 ->
							aVector.addElement(testMediaSound);
							// 2003/03/28 <-
                            testMediaSound.use();
                        }
                    } catch(UIException uie) {
                        aFlag = true;
						// 2003/03/28 ->
                        //showMsg("\"OK\" UIException:" + uie.getMessage());
						if (uie.getStatus() == 2) {
							showMsg("\"OK\" UIException:NO_RESOURCES");
						} else {
							showMsg("UIException:" + uie.getMessage());
						}
						// 2003/03/28 <-
                    } catch(OutOfMemoryError ooe) {
                        aFlag = true;
                        showMsg("\"OK\" OutOfMemoryError");
                    } catch (ConnectionException ce) {
                        showMsg(ce.getMessage());
					// 2003/03/28 ->
					} catch(Throwable th) {
						aFlag = true;
						showMsg("\"NG\"" + th.toString());
					// 2003/03/28 <-
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\" an object has created without resource shortage");
                    }
                    break;

                /**
                 * exception test 3  
                 * don't dispose() after dispose()
                 */
                // J011_3906_0103
                case 2:
                    try {
//                            testMediaSound = MediaManager.getSound(getSourceURL() + "mld/asia.mld");
                        testMediaSound = MediaManager.getSound("resource:///J011_3901_0101.mld");
                        testMediaSound.use();
                        testMediaResource = (MediaResource)testMediaSound;
                        testMediaResource.dispose();
                        testMediaResource.use();
                    } catch (ConnectionException ce) {
                        aFlag = true;
//2002/10/01 DoJa1.5                        showMsg("\"OK\"ConnectionException:" + ce.getMessage());
                        showMsg("\"NG\"ConnectionException:" + ce.getMessage());
//2002/10/01 DoJa1.5                    } catch (Exception e) {
                    } catch (UIException uie) {
                        aFlag = true;
//2002/10/01 DoJa1.5                        showMsg(e.toString());
                        showMsg("\"OK\"UIException:"+uie.getMessage());
                    } catch (Exception e) {
                        showMsg("\"NG\""+e.toString());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\"");
                    }
                    break;

                /**
                 * exception test 4 network doesn't exist 
                 * deselect I-mode service while doing use
                 */
                // J011_3906_0201
                case 3:
                    try {
                        testMediaSound = MediaManager.getSound(getSourceURL() + "../res/J011_3901_0101.mld");
//                            testMediaSound = MediaManager.getSound("resource:///J011_3901_0101.mld");
                        testMediaSound.use();
                    } catch (ConnectionException ce) {
                        if ( ce.getStatus() == 5 ) {
                            aFlag = true;
                            showMsg("\"OK\" ConnectionException(OUT_OF_SERVICE");
                        } else {
                            showMsg("ConectionException Status=" + ce.toString());
                        }
                    } catch (Exception e) {
                        aFlag = true;
                        showMsg(e.toString());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\"");
                    }
                    break;

                /* exception test 5 network timeout */
                // J011_3906_0202
                case 4:
                   try {
                        testMediaSound = MediaManager.getSound(getSourceURL()+" ../cgi-bin/tout.cgi?time=600");
                        testMediaSound.use();
                    } catch (ConnectionException ce) {
                        if ( ce.getStatus() == 4 ) {
                            aFlag = true;
                            showMsg("\"OK\" ConnectionException(OUT_OF_SERVICE");
                        } else {
                            showMsg("ConectionException Status=" + ce.toString());
                        }
                    } catch(Exception e) {
                        aFlag = true;
                        showMsg(e.toString());
                    }
                    if ( aFlag == false ) {
                        showMsg("\"NG\"");
                    }
                    break;
                }
            }
        }
    }
}
