/**
 * J011_4001_0101.java
 * 
 * J011_4001_0101
 * MainPanel
 * J011_4005_02
 * J011_4006_01
 * 
 * Panel class action check( normal route)
 * 
 * $Id: J011_4001_0101.java,v 1.2 2001/12/02 05:17:33 waka Exp $
 */

import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Panel class action check main class
 * @extends IApplication
 */
public class J011_4001_0101 extends IApplication {
    /**
     * I-appli starting method
     */
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * Panell class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* execution button */
    Button execButton = null;
    /* create processing selection menu */
    ListBox mainMenu = new ListBox(ListBox.CHOICE,4);
    /* processing selection menu item */
    String[] mainItem = {
        "0.check the access level",
        "1.constant's behavior",
        "2.constructor's behavior",
        "3.method's behavior",
        "4.behavior for thrown exceptions",
    };

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {

        try {
            showMainPanel();
        } catch(Exception e) {
            err.setText("Exception:" + e.toString());
        } catch(Error e) {
            err.setText("Error" + e.toString());
        }

    }

    /**
     * displaying Panel class action check main screen 
     */
    public void showMainPanel() {

        /* title displaying */
        setTitle("API class normal route");

        /* sub title displaying */
        Label subTitle = new Label("Panel");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* main menu setting */
        mainMenu.setItems(mainItem);

        /* execution button setting */
        execButton = new Button("execute");

        /* add the component to the screen */
        add(mainMenu);
        add(execButton);

    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * softKeyReleased
     * terminate the application when the softkey1 is released
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* going to the screen or displaying when the execution button is pushed */
        if ( aComponent == execButton
             && aType == BUTTON_PRESSED ) {
            switch (mainMenu.getSelectedIndex()) {
            /* access level checking */
            case 0:
                Display.setCurrent(new J011_4001_0301((Frame) this));
                break;
            /* constant test */
            case 1:
                Display.setCurrent(new J011_4002_0201((Frame) this));
                break;
            /* constructor action */
            case 2:
                Display.setCurrent(new J011_4003_02((Frame) this));
                break;
            /* method action */
            case 3:
                Display.setCurrent(new J011_4005_02((Frame) this));
                break;
            /* exception action */
            case 4:
                Display.setCurrent(new J011_4006_0101((Frame) this));
                break;
            }
        }
    }
}

/**
 * access level action check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class J011_4001_0301 extends Panel implements SoftKeyListener,ComponentListener {
    Frame previousFrame = null;
    Button execButton011_3901_0301 = null;

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* selection processing  menu */
    ListBox menuJ011_4001_0301 = new ListBox(ListBox.CHOICE,19);
    String[] menuList = {
        "0.Panel()",
        "1.setBackground()",
        "2.setTitle()",
        "3.add()",
        "4.setComponentListener()",
        "5.setSoftKeyListener()",
        "6.setKeyListener()",
        "7.setFocusManager()",
        "8.getFocusManager()",
        "9.setLayoutManager()",
    };

    /* result display textbox */
    TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

    /**
     * J011_4001_0301 class constructor
     * @param  aFrame the screen before shifting
     */
    J011_4001_0301(Frame aFrame) {
        try {
            previousFrame = aFrame;
            showPanelJ011_4001_0301();
        } catch(Exception e) {
            err.setText("Exception:" + e.toString());
            err.show();
        } catch(Error e) {
            Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
            err.setText("Error:" + e.toString());
            err.show();
        }
    }

    /**
     * displaying access level action check screen
     */
    void showPanelJ011_4001_0301() {
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* menu setting */
        menuJ011_4001_0301.setItems(menuList);

        /* execution button setting */
        execButton011_3901_0301 = new Button("execute");

        /* adding the component */
        add(new Label("check the access level"));
        add(menuJ011_4001_0301);
        add(execButton011_3901_0301);
        add(resultTextBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * testing the selected menu
     */
    public void test() {
        ListBox testListBox = new ListBox(ListBox.SINGLE_SELECT,3);

        MediaImage testMediaImage;
        MediaResource testMediaResource;

        testMediaImage = MediaManager.getImage("resource:///J011_4001_0101.gif");
        testMediaResource = (MediaResource)testMediaImage;

        Panel testPanel = new Panel();


        try {
            /* execute each testing */
            switch( menuJ011_4001_0301.getSelectedIndex() ) {
            /* Panel() */
        // J011_4001_0301
            case 0:
                Panel testPanel1 = new Panel();
                resultTextBox.setText("OK");
                break;
            /* setBackground() */
        // J011_4001_0302
            case 1:
                testPanel.setBackground(Graphics.getColorOfName(Graphics.BLUE));
                resultTextBox.setText("OK");
                break; 
            /* setTitle() */
        // J011_4001_0303
            case 2:
                testPanel.setTitle("testPanel");
                resultTextBox.setText("OK");
                break;
            /* add() */
        // J011_4001_0304
            case 3:
                Button testButton = new Button("test");
                testPanel.add(testButton);
                resultTextBox.setText("OK");
                break;
            /* setComponentListener() */
        // J011_4001_0305
            case 4:
                testPanel.setComponentListener(null);
                resultTextBox.setText("OK");
                break;
            /* setSoftKeyListener() */
        // J011_4001_0306
            case 5:
                testPanel.setSoftKeyListener(null);
                resultTextBox.setText("OK");
                break;
            /* setKeyListener() */
        // J011_4001_0307
            case 6:
                testPanel.setKeyListener(null);
                resultTextBox.setText("OK");
                break;
            /* setFocusManager() */
        // J011_4001_0308
            case 7:
                try {
                    testPanel.setFocusManager(null);
                } catch(NullPointerException npe) {
                    resultTextBox.setText("\"OK\" NullPointerException:" + npe.getMessage());
                }
                break;
            /* getFocusManager() */
        // J011_4001_0309
            case 8:
                testPanel.getFocusManager();
                resultTextBox.setText("OK");
                break;
            /* setLayoutManager() */
        // J011_4001_0310
            case 9:
                testPanel.setLayoutManager(null);
                resultTextBox.setText("OK");
                break;
            }
        } catch (Exception e) {
            err.setText("Exception: " + e.toString());
            err.show();
        } catch (Error e) {
            err.setText("Exception: " + e.toString());
            err.show();
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey is released
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
    /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        /* initialize the textbox when the menu is selected */
        if ( aComponent == menuJ011_4001_0301
             && aType == SELECTION_CHANGED) {
            resultTextBox.setText("");
        }

        /* when  the execution button is pushed */
        if ( aComponent == execButton011_3901_0301
             && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }
}

/**
 * J011_4002_0201
 * constant definition check screen class. Display true or false of constant definition
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class J011_4002_0201 extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButtonJ011_4002_0201 = null;

    /**
     * J011_4002_0201 class constructor
     * @param aFrame the screen
     */
    J011_4002_0201(Frame aFrame) {
        try {
            previousFrame = aFrame;
            showPanelJ011_4002_0201();
        } catch(Exception e) {
            info.setText("Exception:" + e.toString());
            info.show();
        } catch(Error e) {
            Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
            info.setText("Error:" + e.toString());
            info.show();
        }
    }

    /**
     * showPanelJ011_4002_0201
     * display constant definition check screen
     */
    void showPanelJ011_4002_0201() {

        /* title displaying */
        setTitle("API class normal route");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);

        /* sub title displaying */
        add(new Label("constant definition check"));

        /* textbox which contains the title of each constant and testing result */
        Label testLabel1,testLabel2;

        /* initializing the character string for checking */
        String str1 = new String("");
        String str2 = new String("");

        /* OK if each constant definition is valid, else NG */
        testLabel1 = new Label("SOFT_KEY_1");
        testLabel1.setSize(getWidth(),testLabel1.getHeight());
//J011_4002_0201
        if ( Panel.SOFT_KEY_1 == 0 ) {
            str1 = "OK";
        } else {
            str1 = "NG:\nnot defined as 1";
        }
        TextBox testText1 = new TextBox(str1,getWidth(),3,TextBox.DISPLAY_ANY);

        testLabel2 = new Label("SOFT_KEY_2");
        testLabel2.setSize(getWidth(),testLabel2.getHeight());
//J011_4002_0202
        if ( Panel.SOFT_KEY_2 == 1 ) {
            str2 = "OK";
        } else {
            str2 = "NG:\nnot defined as 1";
        }
        TextBox testText2 = new TextBox(str2,getWidth(),3,TextBox.DISPLAY_ANY);

        /* display the title and the result */
        add(testLabel1);
        add(testText1);
        add(testLabel2);
        add(testText2);

    }

//J011_4002_0101
//J011_4005_0102
    /**
     * Constant member definition check
     * the following is confirmation that the value can not be put in constant member
     * confirm ierror in building and delete
     */
/*
    Panel.SOFT_KEY_1 = 99;
    Panel.SOFT_KEY_2 = 99;
*/
    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * define the action when softkey is released
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {}
}

/**
 * Constructor operation check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class J011_4003_02 extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButton = null;

    /**
     * constructor action check
     * @param aType the position of menu item
     * @param aFram previous screen
     */
    public J011_4003_02(Frame aFrame) {

        /* put the previous screen in */
        previousFrame = aFrame;

        /* title displaying */
        setTitle("API class normal route");

        /* sub title displaying */
        Label subTitle = new Label("check behavior of the constructor");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

    // J011_4001_0310
        /* create Panel */
        Panel testPanel = new Panel();

        /* create the components to testPanel */
        Button testButton = new Button("test");
        TextBox testTextBox = new TextBox("test",getWidth(),1,TextBox.DISPLAY_ANY);

        /* adding the component */
        testPanel.add(testButton);
        testPanel.add(testTextBox);

        TextBox resultTextBox = new TextBox("OK",getWidth(),1,TextBox.DISPLAY_ANY);
        add(resultTextBox);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);

    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {}
}


/**
 * method action check menu screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class J011_4005_02 extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");
    
    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButtonJ011_4005_02 = null;

    /* create processing selection menu */
    ListBox menuJ011_4005_02 = new ListBox(ListBox.CHOICE,9);

    /* processing selection menu item setting */
    String[] itemJ011_4005_02 = {
        "0.multiple components",
        "1.null component",
        "2.multiple soft keys",
        "3.null soft key",
        "4.multiple keys",
        "5.null key",
        "6.focus",
        "7.layout",
        "8.title",
        
    };

    /**
     * J011_4005_02 class constructor
     * @param aFrame the screen
     */
    J011_4005_02(Frame aFrame) {
        try {
            /* put the previous screen in */
            previousFrame = aFrame;
            showPanelJ011_4005_02();
        } catch(Exception e) {
            info.setText("Exception:" + e.toString());
            info.show();
        } catch(Error e) {
            Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
            info.setText("Error:" + e.toString());
            info.show();
        }
    }

    /**
     * method action check menu screen displaying
     */
    void showPanelJ011_4005_02() {

        /* title displaying */
        setTitle("API class normal route");

        /* sub title displaying */
        Label subTitle = new Label("checking method's behavior");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* main menu setting */
        menuJ011_4005_02.setItems(itemJ011_4005_02);

        /* execution button setting */
        execButtonJ011_4005_02 = new Button("execute");

        /* add the component to the screen */
        add(menuJ011_4005_02);
        add(execButtonJ011_4005_02);

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* shift to the screen concerning the menu when the execution button is pressed */
        if ( aComponent == execButtonJ011_4005_02
             && aType == ComponentListener.BUTTON_PRESSED ) {
            Display.setCurrent(new testJ011_4005_02(menuJ011_4005_02.getSelectedIndex(), this));
        }
    }
}

/**
 * method action check screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class testJ011_4005_02 extends Panel implements SoftKeyListener,ComponentListener,KeyListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* sub title */
    Label subTitle = new Label("");

    /* execution button */
    Button execButton = null;

    /* ComponentListener test button */
    Button componentTest1 = new Button("test 1");
    Button componentTest2 = new Button("test 2");

    /* SoftKeyListener test button */
    Button keyListenerPrev = new Button("back");
    Button keyListenerEnd = new Button("exit");

    /* setTitle checking button */
    Button titleButton1,titleButton2,titleButton3,titleButton4,titleButton5,titleButton6;

    char[]    emoji             = {0xE63E, 0xE63F, 0xE640, 0xE641};

    /* testing result display textbox */
    TextBox resultTextBox = new TextBox("", getWidth(), 3, TextBox.DISPLAY_ANY);

    /**
     * method action checking
     * @param aType the position of menu item
     * @param aFram previous screen
     */
    public testJ011_4005_02(int aType, Frame aFrame) {

        /* put the previous screen in */
        previousFrame = aFrame;

        /* title displaying */
        setTitle("API class normal route");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* label for displaying the state */
        Label infoLabel = new Label("");
        infoLabel.setSize(getWidth(), infoLabel.getHeight());

        add(infoLabel);

        /* action checking for checking items on the previous screen */
        try {
            switch (aType) {
            /* componentlistener plural setting check */
            case 0:
                /* title display check */
        // J011_4005_0202
                setTitle("title test OK");
                subTitle.setText("check multiple components");
                subTitle.setSize(getWidth(), subTitle.getHeight());

                /* adding the component */
                add(subTitle);
                add(componentTest1);
                add(componentTest2);
                add(resultTextBox);

        // J011_4005_0205
        // J011_4005_0206
                /* testing of listener plural setting */
                /* the first setting */
                setComponentListener(new ComponentListener() {
                    public void componentAction(Component aComponent, int aType, int aParam) {
                        if ( aComponent == componentTest1 
                            && aType == ComponentListener.BUTTON_PRESSED) {
                            resultTextBox.setText("test1 result:\nif this is displayed, NG");
                        }
                    }
                });
                /* the second setting */
                setComponentListener(new ComponentListener() {
                    public void componentAction(Component aComponent, int aType, int aParam) {
                        if ( aComponent == componentTest2 
                            && aType == ComponentListener.BUTTON_PRESSED) {
                            resultTextBox.setText("test2 result:\nif this is displayed, OK");
                        }
                    }
                });
                break;

            /* component listener Null setting check */
            case 1:
                /* display title / subtitle */
        // J011_4005_0203
                setTitle(null);
                subTitle.setText("check that the component is null");
                subTitle.setSize(getWidth(), subTitle.getHeight());

                /* adding the component */
                add(subTitle);
                add(componentTest1);
                add(resultTextBox);

        // J011_4005_0207
                /* testing of listener Null setting */
                setComponentListener(new ComponentListener() {
                    public void componentAction(Component aComponent, int aType, int aParam) {
                        if ( aComponent == componentTest1 
                            && aType == ComponentListener.BUTTON_PRESSED) {
                            resultTextBox.setText("test1 result:\nif this is displayed, NG");
                        }
                    }
                });
                setComponentListener(null);
                break;

            /* SoftKeyListener plural setting check */
            case 2:
                /* display title / subtitle */
                setTitle("API class normal route");
                subTitle.setText("check that the key listener is null");
                subTitle.setSize(getWidth(), subTitle.getHeight());

                /* adding the component */
                add(subTitle);
                add(resultTextBox);
                add(keyListenerPrev);
                add(keyListenerEnd);

                setSoftLabel(Frame.SOFT_KEY_1, "test 1");
                setSoftLabel(Frame.SOFT_KEY_2, "test 2");

                /* because the focus is on the texttbox when initially displaying
                 * focus on the button for easy operationally
                 */
                keyListenerPrev.requestFocus();

        // J011_4005_0208
        // J011_4005_0209
                /* testing of listener plural setting */
                /* the first setting */
                setSoftKeyListener(new SoftKeyListener() {
                    public void softKeyPressed(int aSoftKey) {
                    }
                    public void softKeyReleased(int aSoftKey) {
                        if ( aSoftKey == Frame.SOFT_KEY_2 ) {
                            resultTextBox.setText("test1 result:\nif this is displayed, NG");
                        }
                    }
                });
                /* the second setting */
                setSoftKeyListener(new SoftKeyListener() {
                    public void softKeyPressed(int aSoftKey) {
                    }
                    public void softKeyReleased(int aSoftKey) {
                        if ( aSoftKey == Frame.SOFT_KEY_2 ) {
                            resultTextBox.setText("test2 result:\nif this is displayed, OK");
                        }
                    }
                });
                break;

            /* softkeylistener Null setting check */
            case 3:
                /* display title / subtitle */
                setTitle("API class normal route");
                subTitle.setText("check that the soft key listener is null");
                subTitle.setSize(getWidth(), subTitle.getHeight());

                /* adding the component */
                add(subTitle);
                add(resultTextBox);
                add(keyListenerPrev);
                add(keyListenerEnd);

                setSoftLabel(Frame.SOFT_KEY_1, "test 1");
                setSoftLabel(Frame.SOFT_KEY_2, "");

                /* because the focus is on the texttbox when initially displaying
                 * focus on the button for easy operationally
                 */
                keyListenerPrev.requestFocus();

        // J011_4005_0210
                /* testing of listener Null setting */
                setSoftKeyListener(new SoftKeyListener() {
                    public void softKeyPressed(int aSoftKey) { }
                    public void softKeyReleased(int aSoftKey) {
                        if ( aSoftKey == Frame.SOFT_KEY_1 ) {
                            resultTextBox.setText("test1 result:\nif this is displayed, NG");
                        }
                    }
                });
                setSoftKeyListener(null);
                break;

            /* key listener plural setting */
            case 4:
                /* display title / subtitle */
                setTitle("API class normal route");
                subTitle.setText("check that the number of the keys is plural");
                subTitle.setSize(getWidth(), subTitle.getHeight());

                /* adding the component */
                add(subTitle);
                add(resultTextBox);

        // J011_4005_0211
        // J011_4005_0212
                /* the first setting */
                setKeyListener(new KeyListener() {
                    public void keyPressed(Panel aPanel, int aKey) {
                    }
                    public void keyReleased(Panel aPanel, int aKey) {
                        if ( aKey == Display.KEY_1 ) {
                            resultTextBox.setText("1 result of pressing the button:\nif this is displayed, NG");
                        }
                    }
                });
                /* the second setting */
                setKeyListener(new KeyListener() {
                    public void keyPressed(Panel aPanel, int aKey) {
                    }
                    public void keyReleased(Panel aPanel, int aKey) {
                        if ( aKey == Display.KEY_2 ) {
                            resultTextBox.setText("2 result of pressing the button:\nif this is displayed, OK");
                        }
                    }
                });
                break;

            /* key listener Null setting */
        // J011_4005_0213
            case 5:
                /* display title / subtitle */
                setTitle("API class normal route");
                subTitle.setText("check that the key is null");
                subTitle.setSize(getWidth(), subTitle.getHeight());

                /* adding the component */
                add(subTitle);
                add(resultTextBox);

        // J011_4005_0206
                setKeyListener(new KeyListener() {
                    public void keyPressed(Panel aPanel, int aKey) {
                    }
                    public void keyReleased(Panel aPanel, int aKey) {
                        if ( aKey == Display.KEY_1 ) {
                            resultTextBox.setText("1 result of pressing the button:\nif this is displayed, NG");
                        }
                    }
                });
                setKeyListener(null);
                break;

            /* focus on the button for easy operationally */
        // J011_4005_0214
        // J011_4005_0215
            case 6:
                /* display title / subtitle */
                setTitle("API class normal route");
                subTitle.setText("check the focus");
                subTitle.setSize(getWidth(), subTitle.getHeight());

                /* adding the component */
                add(subTitle);
                add(resultTextBox);
                execButton = new Button("execute");
                add(execButton);


                /* because the focus is on the texttbox when initially displaying
                 * focus on the button for easy operationally
                 */
                execButton.requestFocus();

        // J011_4005_0207
                /* display the return of focus management object */
                setComponentListener(new ComponentListener() {
                    public void componentAction(Component aComponent, int aType, int aParam) {
                        if ( aComponent == execButton 
                            && aType == ComponentListener.BUTTON_PRESSED) {
                            resultTextBox.setText(getFocusManager().toString());
                        }
                    }
                });
                break;

            /* setLayout(null) object is displayed in the upper left*/
            case 7:
                /* display title / subtitle */
                setTitle("API class normal route");
                subTitle.setText("check the layout");
                subTitle.setSize(getWidth(), subTitle.getHeight());

        // J011_4005_0216
        // J011_4005_0217
                /* set Null on the layout manager */
                setLayoutManager(null);

                /* display check label setting */
                Label centerLabel = new Label("CENTER",Label.CENTER);
                Label rightLabel = new Label("RIGHT",Label.RIGHT);
                Label leftLabel = new Label("LEFT",Label.LEFT);

                /* adding the component */
                add(subTitle);
                add(centerLabel);
                add(rightLabel);
                add(leftLabel);

                /* setting of the size of label */
                centerLabel.setSize(getWidth(), centerLabel.getHeight());
                rightLabel.setSize(getWidth(), rightLabel.getHeight());
                leftLabel.setSize(getWidth(), leftLabel.getHeight());

                break;

            case 8:
        // J011_4005_0201
                setBackground(Graphics.getColorOfName(Graphics.BLUE));

                titleButton1 = new Button("TitleSet1");
//2002/07/30 Doja1.5                titleButton2 = new Button("TitleSet2");
//2002/07/30 Doja1.5                titleButton3 = new Button("TitleSet3");
                titleButton4 = new Button("TitleSet4");
                titleButton5 = new Button("TitleSet5");

        // J011_4005_0204
                add(titleButton1);
//2002/07/30 Doja1.5                add(titleButton2);
//2002/07/30 Doja1.5                add(titleButton3);
                add(titleButton4);
                add(titleButton5);

    // J011_4005_0301
    // J011_4005_0302
    // J011_4005_0303
    // J011_4005_0304
    // J011_4005_0305
                setComponentListener(new ComponentListener() {
                    public void componentAction(Component aComponent, int aType, int aParam) {
                        if ( aType == ComponentListener.BUTTON_PRESSED ) {
                            if ( aComponent == titleButton1 ) {
                                setTitle("ABCabc");
//2002/07/30 Doja1.5                            } else if ( aComponent == titleButton2 ) {
//2002/07/30 Doja1.5                                setTitle("");
//2002/07/30 Doja1.5                            } else if ( aComponent == titleButton3 ) {
//2002/07/30 Doja1.5                                setTitle("");
                            } else if ( aComponent == titleButton4 ) {
                                setTitle(String.valueOf(emoji));
                            } else if ( aComponent == titleButton5 ) {
                                setTitle("Ab" + String.valueOf(emoji));
//2002/07/30 Doja1.5                                setTitle("Ab" + String.valueOf(emoji));
                            }
                        }
                    }
                });

            }
        } catch (Exception e) {
            err.setText("Exception=" + e.toString());
            err.show();
            return;
        } catch (Error e) {
            err.setText("Error=" + e.toString());
            err.show();
            return;
        }
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* setting of the return button and finish button(the alternative to the usual softkey action) */
        if ( aComponent == keyListenerPrev 
             && aType == ComponentListener.BUTTON_PRESSED) {
            Display.setCurrent(previousFrame);
        }
        if ( aComponent == keyListenerEnd 
             && aType == ComponentListener.BUTTON_PRESSED) {
            IApplication.getCurrentApp().terminate();
        }

    }

    public void keyPressed(Panel p, int key) {}

    /* when the key is released, the key is displayed */
    public void keyReleased(Panel p, int key) {
    }

}

/**
 * user definition layout manager
 * @implements  LayoutManager
 */
class myLayout implements LayoutManager {}

/**
 * user definition focus manager
 * @implements FocusManager
 */
class myFocus implements FocusManager {}

/**
 * exception action checking screen class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class J011_4006_0101 extends Panel implements SoftKeyListener,ComponentListener {

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* the variable for returning to the previous screen */
    Frame previousFrame = null;

    /* execution button */
    Button execButtonJ011_4006_0101 = null;

    /* exception message OK/NG flag */
    boolean aFlag;

    /* media setting */
    MediaImage testMediaImage;
    MediaResource testMediaResource;
    VisualPresenter testVisualPresenter = new VisualPresenter();

    /**
     * J011_4006_0101 class constructor
     * @param aFrame the screen
     */
    J011_4006_0101(Frame aFrame) {
        try {
            previousFrame = aFrame;
            showPanelJ011_4006_0101();
        } catch(Exception e) {
            info.setText("Exception:" + e.toString());
            info.show();
        } catch(Error e) {
            Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
            info.setText("Error:" + e.toString());
            info.show();
        }
    }

    /* menu ListBox creation */
    ListBox errorMenu = new ListBox(ListBox.CHOICE,7);

    /**
     * exception action checking screen display
     */
    void showPanelJ011_4006_0101() {

        /* title displaying */
        setTitle("API class normal route");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* sub title displaying */
        add(new Label("check the exception"));

        /* exception menu item array */
        String[] errorListItem = {
            "0.check the exception 1",
            "1.check the exception 2",
            "2.check the exception 3",
            "3.check the exception 4",
            "4.check the exception 5",
            "5.check the exception 6",
            "6.check the exception 7",
        };

        /* creating exception menu */
        errorMenu.setItems(errorListItem);

        /* create the execution button */
        execButtonJ011_4006_0101 = new Button("execute");

        /* adding the component */
        add(errorMenu);
        add(execButtonJ011_4006_0101);

    }

    /**
     * dialog display method
     * @param  aMsg character string which is displayed
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {
    }

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        Label testLabel;

        /* initialize the textbox when the menu is selected */
        if ( aComponent == errorMenu
             && aType == SELECTION_CHANGED) {
            aFlag = true;
        }

        /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
        if ( aComponent == execButtonJ011_4006_0101
             && aType == BUTTON_PRESSED) {


            /* divide the processing by menu */
            switch (errorMenu.getSelectedIndex()) {
            /* exception test1 select the value which is unable to be set to background */
        // J011_4006_0101
            case 0:
                try {
                    setBackground(2147483647);
                } catch (IllegalArgumentException iae) {
                    aFlag = true;
                    showMsg("\"OK\" IllegalArgumentException:" + iae.getMessage());
                } catch (Exception e) {
                    aFlag = true;
                    showMsg(e.toString());
                } catch (Error e) {
                    aFlag = true;
                    showMsg(e.toString());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" \"2147483643\" was specified to the background color");
                }
                break;

        // J011_4006_0102
            /* exception test2 Add the component which is beyond support */
            case 1:
                try {
                    Button addTestButton[] = new Button[1000000001];
                    int i;
                    for ( i = 0; i < 1000000000; i++ ) {
                        addTestButton[i] = new Button("AddTest");
                        add(addTestButton[i]);
                    }
                } catch(UIException uie) {
                    aFlag = true;
                    showMsg("\"OK\" UIException:" + uie.getMessage());
                } catch(OutOfMemoryError ooe) {
                    aFlag = true;
                    showMsg("\"OK\" OutOfMemoryError");
                } catch(Exception e) {
                    showMsg(e.toString());
                } catch(Error e) {
                    showMsg(e.toString());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" the number of added components excess the supported number");
                }
                break;

            /* exception test3 Null is added */
            // J011_4006_0103
            case 2:
                try {
                    add(null);
                } catch(NullPointerException e) {
                    aFlag = true;
                    showMsg("\"OK\" NullPonterException:" + e.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" a null was added");
                }
                break;

            /* exception test4 Add the component which is Added on other Panel */
            // J011_4006_0104
            case 3:
                try {
                    Panel testPanel = new Panel();
                    Button testButton = new Button("");
                    testPanel.add(testButton);
                    add(testButton);
                } catch(UIException uie) {
                    aFlag = true;
                    showMsg("\"OK\" UIException:" + uie.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" added component is the one which has added to another panel");
                }
                break;

        // J011_4006_0105
            /* exception test5* setting user-defined FocusManager */
            case 4:
                try {
                    aFlag = true;
                    this.setFocusManager(new myFocus());
                } catch (IllegalArgumentException iae) {
                    showMsg("\"OK\" IllegalArgumentException:" + iae.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" user-defined FocusManager was set");
                }
                break;

        // J011_4006_0106
            /* exception test6 set Null on setFocusManager */
            case 5:
                try {
                    setFocusManager(null);
                } catch(NullPointerException e) {
                    aFlag = true;
                    showMsg("\"OK\" NullPonterException:" + e.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" a null was set to setFocusManager");
                }
                break;

        // J011_4006_0107
            /* exception test7 setting user-defined LayoutManager */
            case 6:
                try {
                    aFlag = true;
                    this.setLayoutManager(new myLayout());
                } catch (IllegalArgumentException iae) {
                    showMsg("\"OK\" IllegalArgumentException:" + iae.getMessage());
                }
                if ( aFlag == false ) {
                    showMsg("\"NG\" user-defined LayoutManager was set");
                }
                break;
            }
        }
    }
}
