/**
 * J011_4101_0101.java
 * 
 * J011_4101_0101
 * MainPanel
 * J011_4105_02
 * J011_4106_01
 * 
 * PhoneSystem class action check(normal route)
 * 
 * $Id: J011_4101_0101.java,v 1.2 2001/12/02 05:17:38 waka Exp $
*/

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import java.util.*;

/**
 * PhoneSystem class action check main class
 * @extends IApplication
 */
public class J011_4101_0101 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

    /* create message dialog(error/guide) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * PhoneSystem class action check main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

        /* execution button */
        Button execButton = null;

        /* create processing selection menu */
        ListBox mainMenu = new ListBox(ListBox.CHOICE,4);
        /* processing selection menu item */
        String[] mainItem = {
            "0.check the access level",
            "1.constant's behavior",
            "2.the method's behavior",
            "3.behavior for thrown exceptions",
        };

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
            } catch(Error e) {
                err.setText("Error" + e.toString());
            }

        }

        /**
         * displaying Panel class action check main screen 
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("PhoneSystem");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aPram) {

            /* going to the screen or displaying when the execution button is pushed */
            if ( aComponent == execButton
                && aType == BUTTON_PRESSED ) {
                switch (mainMenu.getSelectedIndex()) {
                /* access level checking */
                case 0:
                    Display.setCurrent(new J011_4101_0301((Frame) this));
                    break;
                /* constant test */
                case 1:
                    Display.setCurrent(new J011_4102_0201((Frame) this));
                    break;
                /* method action */
                case 2:
                    Display.setCurrent(new J011_4105_02((Frame) this));
                    break;
                /* exception action */
                case 3:
                    Display.setCurrent(new J011_4106_0101((Frame) this));
                    break;
                }
            }
        }
    }
    /**
     * access level action check screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class J011_4101_0301 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButton011_3901_0301 = null;

        /* create message dialog(error/) */
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");

        /* selection processing  menu */
        ListBox menuJ011_4101_0301 = new ListBox(ListBox.CHOICE,19);
        String[] menuList = {
            "0.setAttribute()",
//2002/07/26 DoJa1.5            "1.getAttribute()",
//2002/07/26 DoJa1.5            "2.isAvailable()",
            "3.playSound()"
        };

        /* result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),2,TextBox.DISPLAY_ANY);

        /**
         * J011_4101_0301 class constructor
         * @param  aFrame the screen before shifting
         */
        J011_4101_0301(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_4101_0301();
            } catch(Exception e) {
                err.setText("Exception:" + e.toString());
                err.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                err.setText("Error:" + e.toString());
                err.show();
            }
        }

        /**
         * displaying access level action check screen
         */
        void showPanelJ011_4101_0301() {
            setTitle("API class normal route");
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* menu setting */
            menuJ011_4101_0301.setItems(menuList);

            /* execution button setting */
            execButton011_3901_0301 = new Button("execute");

            /* adding the component */
            add(new Label("check the access level"));
            add(menuJ011_4101_0301);
            add(execButton011_3901_0301);
            add(resultTextBox);

            /* setting the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * testing the selected menu
         */
        public void test() {

            try {
                /* execute each testing */
                switch( menuJ011_4101_0301.getSelectedIndex() ) {
                    /* setAttribute() */
            // J011_4101_0301
                    case 0:
                        try {
                            PhoneSystem.setAttribute(0,0);
                        } catch( Exception e ) {
                        }
                        resultTextBox.setText("OK");
                        break;
//2002/07/26 DoJa1.5                    /* getAttribute() */
//2002/07/26 DoJa1.5            // J011_4101_0302
//2002/07/26 DoJa1.5                    case 1:
//2002/07/26 DoJa1.5                        PhoneSystem.getAttribute(0);
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                        break; 
//2002/07/26 DoJa1.5                    /* isAvailable() */
//2002/07/26 DoJa1.5            // J011_4101_0303
//2002/07/26 DoJa1.5                    case 2:
//2002/07/26 DoJa1.5                        PhoneSystem.isAvailable(0);
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                        break;
                    /* playSound() */
            // J011_4101_0304
//2002/07/26 DoJa1.5                    case 3:
                    case 1:
                        try {
                            PhoneSystem.playSound(0);
                        } catch( Exception e ) {
                        }
                        resultTextBox.setText("OK");
                        break;
                }
            } catch (Exception e) {
                err.setText("Exception: " + e.toString());
                err.show();
            } catch (Error e) {
                err.setText("Exception: " + e.toString());
                err.show();
            }
        }

        /**
         * do nothing when a softkey is pushed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * define the action when softkey is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* initialize the textbox when the menu is selected */
            if ( aComponent == menuJ011_4101_0301
                && aType == SELECTION_CHANGED) {
                    resultTextBox.setText("");
            }

            /* when  the execution button is pushed */
            if (aComponent == execButton011_3901_0301
                && aType == ComponentListener.BUTTON_PRESSED) {
                test();
            }
        }
    }


    /**
     * J011_4102_0201
     * constant definition check screen class. Display true or false of constant definition
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_4102_0201 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_4102_0201 = null;

        /* constant definition check menu */
        ListBox valueList = new ListBox(ListBox.CHOICE,24);
        String[] listItem = {
            "0.ATTR_BACKLIGHT_OFF",
            "1.ATTR_BACKLIGHT_ON",
//2002/07/26 DoJa1.5            "2.ATTR_FOLDING_CLOSE",
//2002/07/26 DoJa1.5            "3.ATTR_FOLDING_OPEN",
//2002/07/26 DoJa1.5            "4.ATTR_MAIL_AT_CENTER",
//2002/07/26 DoJa1.5            "5.ATTR_MAIL_NONE",
//2002/07/26 DoJa1.5            "6.ATTR_MAIL_RECEIVED",
//2002/07/26 DoJa1.5            "7.ATTR_MESSAGE_AT_CENTER",
//2002/07/26 DoJa1.5            "8.ATTR_MESSAGE_NONE",
//2002/07/26 DoJa1.5            "9.ATTR_MESSAGE_RECEIVED",
            "10.ATTR_VIBRATOR_OFF",
            "11.ATTR_VIBRATOR_ON",
            "12.DEV_BACKLIGHT",
//2002/07/26 DoJa1.5            "13.DEV_FOLDING",
//2002/07/26 DoJa1.5            "14.DEV_MAILBOX",
//2002/07/26 DoJa1.5            "15.DEV_MESSAGEBOX",
            "16.DEV_VIBRATOR",
//2002/07/26 DoJa1.5            "17.MAX_VENDOR_ATTR",
//2002/07/26 DoJa1.5            "18.MIN_VENDOR_ATTR",
            "19.SOUND_ALARM",
            "20.SOUND_CONFIRM",
            "21.SOUND_ERROR",
            "22.SOUND_INFO",
            "23.SOUND_WARNING"
//2002/07/26 DoJa1.5            "24.MIN_OPTION_ATTR",
//2002/07/26 DoJa1.5            "25.MAX_OPTION_ATTR",
        };

        /* checking button */
        Button execButton = new Button("execute");

        /* checking result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);

        /**
         * J011_4102_0201 class constructor
         * @param aFrame the screen
         */
        J011_4102_0201(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_4102_0201();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        /**
         * showPanelJ011_4102_0201
         * display constant definition check screen
         */
        void showPanelJ011_4102_0201() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            Label subTitle = new Label("constant definition check");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* adding the component*/
            add(valueList);
            add(execButton);
            add(resultTextBox);

            valueList.setItems(listItem);

        }

    //J011_4102_0101
        /**
         * Constant member definition check
         * the following is confirmation that the value can not be put in constant member
         * confirm ierror in building and delete
         */
/*
        PhoneSystem.ATTR_BACKLIGHT_OFF = 99;
        PhoneSystem.ATTR_BACKLIGHT_ON = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_FOLDING_CLOSE = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_FOLDING_OPEN = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_MAIL_AT_CENTER = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_MAIL_NONE = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_MAIL_RECEIVED = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_MESSAGE_AT_CENTER = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_MESSAGE_NONE = 99;
//2002/07/26 DoJa1.5        PhoneSystem.ATTR_MESSAGE_RECEIVED = 99;
        PhoneSystem.ATTR_VIBRATOR_OFF = 99;
        PhoneSystem.ATTR_VIBRATOR_ON = 99;
        PhoneSystem.DEV_BACKLIGHT = 99;
//2002/07/26 DoJa1.5        PhoneSystem.DEV_FOLDING = 99;
//2002/07/26 DoJa1.5        PhoneSystem.DEV_MAILBOX = 99;
//2002/07/26 DoJa1.5        PhoneSystem.DEV_MESSAGEBOX = 99;
        PhoneSystem.DEV_VIBRATOR = 99;
//2002/07/26 DoJa1.5        PhoneSystem.MAX_VENDOR_ATTR = 99;
//2002/07/26 DoJa1.5        PhoneSystem.MIN_VENDOR_ATTR = 99;
        PhoneSystem.SOUND_ALARM = 99;
        PhoneSystem.SOUND_CONFIRM = 99;
        PhoneSystem.SOUND_ERROR = 99;
        PhoneSystem.SOUND_INFO = 99;
        PhoneSystem.SOUND_WARNING = 99;
//2002/07/26 DoJa1.5        PhoneSystem.MIN_OPTION_ATTR = 99;
//2002/07/26 DoJa1.5        PhoneSystem.MAX_OPTION_ATTR = 99;
*/

        /**
         * do nothing when a softkey is pushed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * define the action when softkey is released
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* initialize the textbox when the menu is selected */
            if ( aComponent == valueList 
            && aType == SELECTION_CHANGED ) {
                resultTextBox.setText("");
            }

            /* when the execution button is pushed, if the constant definition is valid ,display OKin other case, display NG */
            if ( aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

                switch ( valueList.getSelectedIndex() ) {
            // j011_4002_0201
                case 0:
                    if ( PhoneSystem.ATTR_BACKLIGHT_OFF == 0 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 0 is defined");
                    }
                    break;
                
            // j011_4002_0202
                case 1:
                    if ( PhoneSystem.ATTR_BACKLIGHT_ON == 1 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 1 is defined");
                    }
                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0203
//2002/07/26 DoJa1.5                case 2:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_FOLDING_CLOSE == 0 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0204
//2002/07/26 DoJa1.5                case 3:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_FOLDING_OPEN == 1 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0205
//2002/07/26 DoJa1.5                case 4:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_MAIL_AT_CENTER == 2 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0206
//2002/07/26 DoJa1.5                case 5:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_MAIL_NONE == 0 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0207
//2002/07/26 DoJa1.5                case 6:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_MAIL_RECEIVED == 1 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0208
//2002/07/26 DoJa1.5                case 7:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_MESSAGE_AT_CENTER == 2 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0209
//2002/07/26 DoJa1.5                case 8:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_MESSAGE_NONE == 0 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0210
//2002/07/26 DoJa1.5                case 9:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.ATTR_MESSAGE_RECEIVED == 1 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
            // j011_4002_0211
//2002/07/26 DoJa1.5                case 10:
                case 2:
                    if ( PhoneSystem.ATTR_VIBRATOR_OFF == 0 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 0 is defined");
                    }
                    break;
                
            // j011_4002_0212
//2002/07/26 DoJa1.5                case 11:
                case 3:
                    if ( PhoneSystem.ATTR_VIBRATOR_ON == 1 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 1 is defined");
                    }
                    break;
                
            // j011_4002_0213
//2002/07/26 DoJa1.5                case 12:
                 case 4:
                    if ( PhoneSystem.DEV_BACKLIGHT == 0 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 0 is defined");
                    }
                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0214
//2002/07/26 DoJa1.5                case 13:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.DEV_FOLDING == 2 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0215
//2002/07/26 DoJa1.5                case 14:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.DEV_MAILBOX == 3 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0216
//2002/07/26 DoJa1.5                case 15:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.DEV_MESSAGEBOX == 4 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
            // j011_4002_0217
//2002/07/26 DoJa1.5                case 16:
                case 5:
                    if ( PhoneSystem.DEV_VIBRATOR == 1 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 1 is defined");
                    }
                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0218
//2002/07/26 DoJa1.5                case 17:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.MAX_VENDOR_ATTR == 127 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
//2002/07/26 DoJa1.5            // j011_4002_0219
//2002/07/26 DoJa1.5                case 18:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.MIN_VENDOR_ATTR == 64 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;
                
            // j011_4002_0220
//2002/07/26 DoJa1.5                case 19:
                case 6:
                    if ( PhoneSystem.SOUND_ALARM == 3 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 3 is defined");
                    }
                    break;
                
            // j011_4002_0221
//2002/07/26 DoJa1.5                case 20:
                case 7:
                    if ( PhoneSystem.SOUND_CONFIRM == 4 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 4 is defined");
                    }
                    break;
                
            // j011_4002_0222
//2002/07/26 DoJa1.5                case 21:
                case 8:
                    if ( PhoneSystem.SOUND_ERROR == 2 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 2 is defined");
                    }
                    break;
                
            // j011_4002_0223
//2002/07/26 DoJa1.5                case 22:
                case 9:
                    if ( PhoneSystem.SOUND_INFO == 0 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 0 is defined");
                    }
                    break;
                
            // j011_4002_0224
//2002/07/26 DoJa1.5                case 23:
                case 10:
                    if ( PhoneSystem.SOUND_WARNING == 1 ) {
                        resultTextBox.setText("OK");
                    } else {
                        resultTextBox.setText("NG\na number other than 1 is defined");
                    }
                    break;

//2002/07/26 DoJa1.5            // j011_4002_0225
//2002/07/26 DoJa1.5                case 24:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.MIN_OPTION_ATTR == 128 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;

//2002/07/26 DoJa1.5            // j011_4002_0226
//2002/07/26 DoJa1.5                case 25:
//2002/07/26 DoJa1.5                    if ( PhoneSystem.MAX_OPTION_ATTR == 255 ) {
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                    } else {
//2002/07/26 DoJa1.5                        resultTextBox.setText("");
//2002/07/26 DoJa1.5                    }
//2002/07/26 DoJa1.5                    break;

                }
            }
        }
    }

    /**
     * method action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_4105_02 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButton = null;

        /* create processing selection menu */
        ListBox methodMenu = new ListBox(ListBox.CHOICE,9);
        String[] menuItem = {
            "0.setAttribute()",
//2002/07/26 DoJa1.5            "1.getAttribute()",
//2002/07/26 DoJa1.5            "2.isAvailable()",
            "3.playSound()",
			"4.setAttribute()"
        };

        /* checking result display textbox */
        TextBox resultTextBox = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);

        /**
         * J011_4105_02 class constructor
         * @param aFrame the screen
         */
        J011_4105_02(Frame aFrame) {
            try {
                /* put the previous screen in */
                previousFrame = aFrame;
                showPanelJ011_3905_02();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }

        void showPanelJ011_3905_02() {

            /* title displaying */
            setTitle("API class normal route");

            /* sub title displaying */
            Label subTitle = new Label("checking method's behavior");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* main menu setting */
            methodMenu.setItems(menuItem);

            /* execution button setting */
            execButton = new Button("execute");

            /* add the component to the screen */
            add(methodMenu);
            add(execButton);
            add(resultTextBox);

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                Display.setCurrent(previousFrame);
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* initialize the textbox when the menu is selected */
            if ( aComponent == methodMenu 
            && aType == SELECTION_CHANGED ) {
                resultTextBox.setText("");
            }

            /* setting of the return button and finish button(the alternative to the usual softkey action) */
            if ( aComponent == execButton 
                && aType == ComponentListener.BUTTON_PRESSED) {

                try {
                    switch ( methodMenu.getSelectedIndex() ) {
            // j011_4005_0201
                    /* the backlight of liquid crystal lights up.
  */
                    case 0:
                        PhoneSystem.setAttribute(0,1);
                        resultTextBox.setText("if the LC panel's backlight turns on, OK");
                        break;

//2002/07/26 DoJa1.5            // j011_4005_0202
//2002/07/26 DoJa1.5                    case 1:
//2002/07/26 DoJa1.5                        int a;
//2002/07/26 DoJa1.5                        PhoneSystem.getAttribute(0);
//2002/07/26 DoJa1.5                        resultTextBox.setText("OK");
//2002/07/26 DoJa1.5                        break;

            // j011_4005_0203
//2002/07/26 DoJa1.5                    case 2:
//2002/07/26 DoJa1.5                        PhoneSystem.setAttribute(0,1);
//2002/07/26 DoJa1.5                        if ( PhoneSystem.isAvailable(0) == true ) {
//2002/07/26 DoJa1.5                            resultTextBox.setText("OK TRUE");
//2002/07/26 DoJa1.5                        } else if ( PhoneSystem.isAvailable(0) == false ) {
//2002/07/26 DoJa1.5                            resultTextBox.setText("OK FALSE");
//2002/07/26 DoJa1.5                        }
//2002/07/26 DoJa1.5                        break;

            // j011_4005_0204
//2002/07/26 DoJa1.5                    case 3:

					/* The sound specified by type can be sounded. */
					/* What can be specified is as follows. */
                    /* SOUND_INFO(0)  */
					/* SOUND_WARNING(1)*/
                    /* SOUND_ERROR(2)*/
					/* SOUND_ALARM(3)  */
                    /* SOUND_CONFIRM(4)  */
                    case 1:
                        PhoneSystem.playSound(PhoneSystem.SOUND_INFO);
                        break;

                    /* When the kind of resource not existing is specified */
					/* Existing is as follows. */
					/* DEV_BACKLIGHT(0)			*/
					/* DEV_VIBRATOR(1)			*/
					case 2:
                        PhoneSystem.setAttribute(2,1);
                        resultTextBox.setText("OK");
                        break;
                    }

                } catch(Exception e) {
                    err.setText("Exception: " + e.toString());
                    err.show();
                } catch(Error e) {
                    err.setText("Error: " + e.toString());
                    err.show();
                }
            }
        }
    }


    /**
     * exception action checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class J011_4106_0101 extends Panel implements SoftKeyListener,ComponentListener {

        /* the variable for returning to the previous screen */
        Frame previousFrame = null;

        /* execution button */
        Button execButtonJ011_4106_0101 = null;

        /* exception message OK/NG flag */
        boolean aFlag;

        /* media setting */
        MediaImage testMediaImage;
        MediaResource testMediaResource;
        VisualPresenter testVisualPresenter = new VisualPresenter();

        /**
         * J011_4106_0101 class constructor
         * @param aFrame the screen
         */
        J011_4106_0101(Frame aFrame) {
            try {
                previousFrame = aFrame;
                showPanelJ011_4106_0101();
            } catch(Exception e) {
                info.setText("Exception:" + e.toString());
                info.show();
            } catch(Error e) {
                Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
                info.setText("Error:" + e.toString());
                info.show();
            }
        }


        /**
         * message dialog displaying method
         * @param  aMsg dialog display message
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /* menu ListBox creation */
        ListBox errorMenu = new ListBox(ListBox.CHOICE,7);

        /**
         * exception action checking screen display
         */
        void showPanelJ011_4106_0101() {

            /* title displaying */
            setTitle("API class normal route");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* sub title displaying */
            add(new Label("check the exception"));

            /* exception menu item array */
            String[] errorListItem = {
                "0.check the exception 1",
                "1.check the exception 2"
//2002/07/26 DoJa1.5                "",
            };

            /* creating exception menu */
            errorMenu.setItems(errorListItem);

            /* create the execution button */
            execButtonJ011_4106_0101 = new Button("execute");

            /* adding the component */
            add(errorMenu);
            add(execButtonJ011_4106_0101);

        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                    Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            Label testLabel;

            /* initialize the textbox when the menu is selected */
            if ( aComponent == errorMenu
                && aType == SELECTION_CHANGED) {
                aFlag = false;
            }

            /* display OK when exception occurs on condition the exception button is presseddisplay NG when it doesn't occur */
            if ( aComponent == execButtonJ011_4106_0101
                && aType == BUTTON_PRESSED) {


                /* divide the processing by menu */
                switch (errorMenu.getSelectedIndex()) {
                    /* exception test1 setAttribute */
            // J011_4106_0101
                    case 0:
                        try {
                            PhoneSystem.setAttribute(0,2);
                        } catch (IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\"IAE:" + e.getMessage());
                        } catch(Exception e) {
                            showMsg(e.toString());
                        } catch(Error e) {
                            showMsg(e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" value3 was set to attr0");
                        }
                        break;

                    /* exception test2 put the invalid value in the parameter of playSound */
            // J011_4106_0102
                    case 1:
                        try {
                            PhoneSystem.playSound(999);
                        } catch (IllegalArgumentException e) {
                            aFlag = true;
                            showMsg("\"OK\"IAE:" + e.getMessage());
                        } catch(Exception e) {
                            showMsg(e.toString());
                        } catch(Error e) {
                            showMsg(e.toString());
                        }
                        if ( aFlag == false ) {
                            showMsg("\"NG\" playSound(999) was specified");
                        }
                        break;

//2002/07/26 DoJa1.5                    /*  */
//2002/07/26 DoJa1.5            // J011_4106_0103
//2002/07/26 DoJa1.5                    case 2:
//2002/07/26 DoJa1.5                        try {
//2002/07/26 DoJa1.5                            PhoneSystem.getAttribute(PhoneSystem.DEV_MESSAGEBOX);
//2002/07/26 DoJa1.5                        } catch (SecurityException se) {
//2002/07/26 DoJa1.5                            aFlag = true;
//2002/07/26 DoJa1.5                            showMsg(""OK" SE:" + se.getMessage());
//2002/07/26 DoJa1.5                        } catch(Exception e) {
//2002/07/26 DoJa1.5                            showMsg(e.toString());
//2002/07/26 DoJa1.5                        } catch(Error e) {
//2002/07/26 DoJa1.5                            showMsg(e.toString());
//2002/07/26 DoJa1.5                        }
//2002/07/26 DoJa1.5                        if ( aFlag == false ) {
//2002/07/26 DoJa1.5                            showMsg("");
//2002/07/26 DoJa1.5                        }
//2002/07/26 DoJa1.5                        break;
                }
            }
        }
    }

}