/**
 * J011_4301_0301
 * MainPanel
 *
 * SoftKeyListener class action check (normal route)
 *
 * $Id: J011_4301_0301.java,v 1.1 2001/11/30 04:16:20 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * SoftKeyListener class action check main class
 * @extends IApplication
 */
public class J011_4301_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * SoftKeyListener class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    Label   classLabel       = new Label("SoftKeyListener's behavior");
    Button  pressButton      = new Button("setKeyPressed");
    Button  releaseButton    = new Button("setKeyReleased");
    TextBox outBox           = new TextBox("",20,2,TextBox.DISPLAY_ANY);
    Button  exitButton       = new Button("exit");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "Key1");
        setSoftLabel(Frame.SOFT_KEY_2, "Key2");

        /* adding each component on the display */
        add(classLabel);
        add(pressButton);
        add(releaseButton);
        add(outBox);
        add(exitButton);


        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * called when the softkey is pushed
     */
    public void softKeyPressed(int anIndex) {
        // J011_4305_0201
        // J011_4305_0202
        if (anIndex == Frame.SOFT_KEY_1) {
            outBox.setText("SOFT_KEY_1 Pressed");
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            outBox.setText("SOFT_KEY_2 Pressed");
        }
        if (anIndex == 9999 ) {
            outBox.setText("softKeyPressed() is called");
        }
    }

    /**
     * when the softkey1 is released
     */
    public void softKeyReleased(int anIndex) {
        // J011_4305_0203
        // J011_4305_0204
        if (anIndex == Frame.SOFT_KEY_1) {
            outBox.setText("SOFT_KEY_1 Released");
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            outBox.setText("SOFT_KEY_2 Released");
        }
        if (anIndex == 9999 ) {
            outBox.setText("softKeyReleased() is called");
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        /* when pressButton is pushed */
        if (aComponent == pressButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            // J011_4301_0301
            /* call softkeyPressed() */
            softKeyPressed(9999);
        }

        /* when releaseButton is pushed */
        if (aComponent == releaseButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            // J011_4301_0302
            /* call softKeyReleased() */
            softKeyReleased(9999);
        }

        /* when the terminate button is pushed */
        if (aComponent == exitButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            /* exit */
            IApplication.getCurrentApp().terminate();
        }

    }
}


