/**
 * J011_4402_0201
 * MainPanel
 *
 * TextBox class constant definition checking (normal route)
 *
 * $Id: J011_4402_0201.java,v 1.1 2001/11/30 04:19:06 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class constant definition checking main class
 * @extends IApplication
 */
public class J011_4402_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class constant definition checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.NUMBER",
        "2.ALPHA",
        "3.KANA",
        "4.DISPLAY_ANY",
        "5.DISPLAY_PASSWORD"
    };

    Label   classLabel       = new Label("check the detail definition of the TextBox rated value");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    TextBox outBox           = new TextBox("",20,1,TextBox.DISPLAY_ANY);

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(execButton);
        add(outBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* clear the output box */
            outBox.setText("");
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * testing the selected menu
     */
    public void test() {
        /* execute each testing */
        int value;
        switch( menuList.getSelectedIndex() ) {
            case 0:
                // J011_4402_0101
                //TextBox.NUMBER = 0;

                // J011_4402_0201
                value=TextBox.NUMBER;
                if( value == 0 ) {
                    outBox.setText("OK");
                } else {
                    outBox.setText("NG:"+value);
                }
                break;
            case 1:
                // J011_4402_0102
                //TextBox.ALPHA = 0;

                // J011_4402_0202
                value=TextBox.ALPHA;
                if( value == 1 ) {
                    outBox.setText("OK");
                } else {
                    outBox.setText("NG:"+value);
                }
                break;
            case 2:
                // J011_4402_0103
                //TextBox.KANA = 0;

                // J011_4402_0203
                value=TextBox.KANA;
                if( value == 2 ) {
                    outBox.setText("OK");
                } else {
                    outBox.setText("NG:"+value);
                }
                break;
            case 3:
                // J011_4402_0104
                //TextBox.DISPLAY_ANY = 0;

                // J011_4402_0204
                value=TextBox.DISPLAY_ANY;
                if( value == 0 ) {
                    outBox.setText("OK");
                } else {
                    outBox.setText("NG:"+value);
                }
                break;
            case 4:
                // J011_4402_0105
                //TextBox.DISPLAY_PASSWORD = 0;

                // J011_4402_0205
                value=TextBox.DISPLAY_PASSWORD;
                if( value == 1 ) {
                    outBox.setText("OK");
                } else {
                    outBox.setText("NG:"+value);
                }
                break;
        }
    }
}
