/**
 * J011_4403_0201
 * MainPanel
 *
 * TextBox class constructor behavior checking (normal route)
 *
 * $Id: J011_4403_0201.java,v 1.1 2001/11/30 04:20:24 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class constructor behavior checking main class
 * @extends IApplication
 */
public class J011_4403_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class constructor behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.constructor's behavior",
        "2.variation"
    };
    String[] subItem1 = {
        "1.setting digit number and number of the lines",
        "2.null",
        "3.DISPLAY_ANY",
        "4.DISPLAY_PASSWORD"
    };
    String[] subItem2 = {
        "1.alphabetic characters",
//2002/07/30 Doja1.5        "2.",
//2002/07/30 Doja1.5        "3.",
        "4.pictographic characters",
        "5.all kinds of characters mixed"
    };

    Label   classLabel       = new Label("TextBox constructor's behavior check");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItem1);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            if( menuList.getSelectedIndex() == 0 ) {
                menuList2.setItems(subItem1);
            } else {
                menuList2.setItems(subItem2);
            }
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            /* behavior checking sub screen display */
            Display.setCurrent(new SubPanel(this, menuList.getSelectedIndex(),
                                            menuList2.getSelectedIndex()));
        }
    }
}


/**
 * TextBox class constructor behavior checking sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class SubPanel extends Panel implements SoftKeyListener{
    Frame   previous;
    TextBox testBox;
    Label   cmpLabel;
    int     type;
    int     index;
    char[]  emoji = {0xE63E, 0xE63F, 0xE640, 0xE641};
    char[]  emoji2= {0xE63E, 0xE63F};

   /**
     * SubPanel class constructor
     * @param   anIndex index of the testing item
     */
    public SubPanel(Frame aPrevious, int anType, int anIndex) {
        previous = aPrevious;
        type = anType;
        index = anIndex;

        /* setting of the display item */
        setTitle("TextBox constructor test");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* setting the listener */
        setSoftKeyListener(this);

        /* test: creating each TextBox */
        if( type == 0 ) {
            /* check behavior of the constructor */
            test1();
        } else {
            /* check the variation */
            test2();
        }
    }


    /**
     * check the constructor behavior 
     */
    public void test1() {
        /* execute each testing */
        switch( index ) {
            case 0:
                // J011_4403_0201
                testBox = new TextBox("1234567890",10,1,TextBox.DISPLAY_ANY);
                break;
            case 1:
                // J011_4403_0202
                testBox = new TextBox(null,10,1,TextBox.DISPLAY_ANY);
                break;
            case 2:
                // J011_4403_0203
                testBox = new TextBox("DISPLAY_ANY",16,1,TextBox.DISPLAY_ANY);
                break;
            case 3:
                // J011_4403_0204
                testBox = new TextBox("DISPLAY_PASSWORD",16,1,TextBox.DISPLAY_PASSWORD);
                break;
        }
        if( index >= 0 && index <= 3 ) {
            add(testBox);
        }
    }

    /**
     * check the variation
     */
    public void test2() {
        /* execute each testing */
        switch( index ) {
            case 0:
                // J011_4404_0301
                testBox = new TextBox("abcdeABCDE",16,1,TextBox.DISPLAY_ANY);
                cmpLabel = new Label("abcdeABCDE");
                break;
//2002/07/30 Doja1.5            case 1:
                // J011_4404_0302
//2002/07/30 Doja1.5                testBox = new TextBox("",16,1,TextBox.DISPLAY_ANY);
//2002/07/30 Doja1.5                cmpLabel = new Label("");
//2002/07/30 Doja1.5                break;
//2002/07/30 Doja1.5            case 2:
                // J011_4404_0303
//2002/07/30 Doja1.5                testBox = new TextBox("",16,1,TextBox.DISPLAY_ANY);
//2002/07/30 Doja1.5                cmpLabel = new Label("");
//2002/07/30 Doja1.5                break;
            case 1:
//2002/07/30 Doja1.5            case 3:
                // j011_4404_0304
                testBox = new TextBox(String.valueOf(emoji),16,1,TextBox.DISPLAY_ANY);
                cmpLabel = new Label(String.valueOf(emoji));
                break;
            case 2:
//2002/07/30 Doja1.5            case 4:
                // j011_4404_0305
                testBox = new TextBox("aA"+String.valueOf(emoji2),20,2,
//2002/07/30 Doja1.5                testBox = new TextBox("aA"+String.valueOf(emoji2),20,2,
                                        TextBox.DISPLAY_ANY);
                cmpLabel = new Label("aA"+String.valueOf(emoji2));
//2002/07/30 Doja1.5                cmpLabel = new Label("aA"+String.valueOf(emoji2));
                break;
        }
        if( index >= 0 && index <= 4 ) {
            add(testBox);
            Label lb = new Label("comparing label:");
            add(lb);
            cmpLabel.setSize(getWidth(),20);
            add(cmpLabel);
        }
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * return to the main screen when the softkey2 is released
     */
    public void softKeyReleased(int anIndex) {
        /* return to the main screen when the softkey2 is released */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previous);
        }
    }
}
