/**
 * J011_4405_0201
 * MainPanel
 *
 * TextBox class prescribed value method behavior checking (normal route)
 *
 * $Id: J011_4405_0201.java,v 1.1 2001/11/30 04:21:17 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class prescribed value method behavior checking main class
 * @extends IApplication
 */
public class J011_4405_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class prescribed value method behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.setEnabled",
        "2.requestFocus",
        "3.setText",
        "4.getText",
        "5.setInputMode",
        "6.setEditable"
    };
    String[][] subItems = {
        {
            "1.true",
            "2.false"
        },
        {
            "1.focus set",
            "2.ignore"
        },
        {
            "1.string",
            "2.null",
            "3.password",
            "4.TEXT_CHANGED"
        },
        {
            "1.return a string"
        },
        {
            "1.NUMBER",
            "2.ALPHA",
            "3.KANA"
        },
        {
            "1.true",
            "2.false"
        }
    };

    Label   classLabel       = new Label("TextBox rated value method's behavior");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    TextBox testBox          = new TextBox("TextBox",12,1,TextBox.DISPLAY_ANY);

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(testBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the execution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }

        /* character string change method of textbox */
        if (aComponent == testBox
            && aType == ComponentListener.TEXT_CHANGED) {
            // J011_4405_0208
            String str = testBox.getText();
            if( str.compareTo("TEXT_CHANGED") == 0 ) {
                showDialog("TEXT_CHANGED event invoked");
            }
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * testing the selected menu
     */
    public void test() {

		//2003/03/12 ->
		try {
		//2003/03/12 <-

        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                switch( menuList2.getSelectedIndex() ) {
                    case 0:
                        // J011_4405_0201
                        testBox.setEnabled(true);
                        break;
                    case 1:
                        // J011_4405_0202
                        testBox.setEnabled(false);
                        break;
                }
                break;
            case 1:
                switch( menuList2.getSelectedIndex() ) {
                    case 0:
                        // J011_4405_0203
                        testBox.requestFocus();
                        break;
                    case 1:
                        // J011_4405_0204
                        TextBox testBox2 = new TextBox("TextBox2",16,1,TextBox.DISPLAY_ANY);
                        testBox2.requestFocus();
                        add(testBox2);
                        break;
                }
                break;
            case 2:
                switch( menuList2.getSelectedIndex() ) {
                    case 0:
                        // J011_4405_0205
                        testBox.setText("NewText");
                        break;
                    case 1:
                        // J011_4405_0206
                        testBox.setText(null);
                        break;
                    case 2:
                        // J011_4405_0207
                        TextBox testBox3 = new TextBox("",16,1,
                                                TextBox.DISPLAY_PASSWORD);
                        add(testBox3);
                        testBox3.setText("password");
                        break;
                    case 3:
                        // J011_4405_0208
                        testBox.setText("TEXT_CHANGED");
                        break;
                }
                break;
            case 3:
                // J011_4405_0209
				// 2003/03/20 ->
                //testBox.setText("TextBox");
				// 2003/03/20 <-
                showDialog("getText():" + testBox.getText());
                break;
            case 4:
                switch( menuList2.getSelectedIndex() ) {
                    case 0:
                        // J011_4405_0210
                        testBox.setInputMode(TextBox.NUMBER);
                        break;
                    case 1:
                        // J011_4405_0211
                        testBox.setInputMode(TextBox.ALPHA);
                        break;
                    case 2:
                        // J011_4405_0212
                        testBox.setInputMode(TextBox.KANA);
                        break;
                }
                break;
            case 5:
                switch( menuList2.getSelectedIndex() ) {
                    case 0:
                        // J011_4405_0213
                        testBox.setEditable(true);
                        break;
                    case 1:
                        // J011_4405_0214
                        testBox.setEditable(false);
                        break;
                }
                break;
        }

		// 2003/03/12 ->
		} catch(Throwable e) {
			Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
			errDialog.setText("Error:" +e.toString());
			errDialog.show();
		}
		// 2003/03/12 <-

    }
}
