/**
 * J011_4405_0301
 * MainPanel
 *
 * TextBox class variation checking (normal route)
 *
 * $Id: J011_4405_0301.java,v 1.1 2001/11/30 04:23:17 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class variation checking main class
 * @extends IApplication
 */
public class J011_4405_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class variation checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.alphabetic characters",
//2002/07/30 Doja1.5        "2.",
//2002/07/30 Doja1.5        "3.",
        "4.pictographic characters",
        "5.all kinds of characters mixed"
    };

    Label   classLabel      = new Label("TextBox.setText variation");
    ListBox menuList        = new ListBox(ListBox.CHOICE);
    Button  execButton      = new Button("execute");
    TextBox testBox         = new TextBox("",16,1,TextBox.DISPLAY_ANY);
    char[]  emoji           = {0xE63E, 0xE63F, 0xE640, 0xE641};
    char[]  emoji2          = {0xE63E, 0xE63F};

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(testBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            testBox.setText("");
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }

    /**
     * checking setText variation
     */
    public void test() {
        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                // J011_4405_0301
                testBox.setText("abcdeABCDE");
                break;
//2002/07/30 Doja1.5            case 1:
                // J011_4405_0302
//2002/07/30 Doja1.5                testBox.setText("");
//2002/07/30 Doja1.5                break;
//2002/07/30 Doja1.5            case 2:
                // J011_4405_0303
//2002/07/30 Doja1.5                testBox.setText("");
//2002/07/30 Doja1.5                break;
            case 1:
//2002/07/30 Doja1.5            case 3:
                // j011_4405_0304
                testBox.setText(String.valueOf(emoji));
                break;
            case 2:
//2002/07/30 Doja1.5            case 4:
                // j011_4405_0305
                testBox.setText("aA"+String.valueOf(emoji2));
//2002/07/30 Doja1.5                testBox.setText(""+String.valueOf(emoji2));
                break;
        }
    }
}
