/**
 * J011_4406_0101
 * MainPanel
 *
 * TextBox class prescribed exception behavior checking (normal route)
 *
 * $Id: J011_4406_0101.java,v 1.1 2001/11/30 04:24:08 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class prescribed exception behavior checking main class
 * @extends IApplication
 */
public class J011_4406_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class prescribed exception behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.TextBox",
        "2.setInputMode",
        "3.setSize"
    };
    String[][] subItems = {
        {
//2002/08/26 Doja1.5            "1.col=0",
//2002/08/26 Doja1.5            "2.row=0",
            "3.col<0",
            "4.row<0",
            "5.out of the mode's range"
        },
        {
            "1.out of the mode's range"
        },
        {
            "1.width<0",
            "2.height<0",
            "3.both<0",
        }
    };

    Label   classLabel       = new Label("TextBox's behavior for thrown exceptions");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    TextBox testBox          = new TextBox("TextBox",16,1,TextBox.DISPLAY_ANY);

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(testBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * testing the selected menu
     */
    public void test() {
        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                switch( menuList2.getSelectedIndex() ) {
//2002/08/26 Doja1.5                    case 0:
                        // J011_4406_0101
//2002/08/26 Doja1.5                        try {
//2002/08/26 Doja1.5                            TextBox t = new TextBox("",0,1,TextBox.DISPLAY_ANY);
//2002/08/26 Doja1.5                            showDialog("NG:no exception");
//2002/08/26 Doja1.5                        } catch( IllegalArgumentException iae ) {
//2002/08/26 Doja1.5                            showDialog("IllegalArgumentException:"+iae.getMessage());
//2002/08/26 Doja1.5                        } catch( Exception e ) {
//2002/08/26 Doja1.5                            showDialog("NG:" + e.toString());
//2002/08/26 Doja1.5                        }
//2002/08/26 Doja1.5                        break;
//2002/08/26 Doja1.5                    case 1:
                        // J011_4406_0102
//2002/08/26 Doja1.5                        try {
//2002/08/26 Doja1.5                            TextBox t = new TextBox("",16,0,TextBox.DISPLAY_ANY);
//2002/08/26 Doja1.5                            showDialog("NG:no exception");
//2002/08/26 Doja1.5                        } catch( IllegalArgumentException iae ) {
//2002/08/26 Doja1.5                            showDialog("IllegalArgumentException:"+iae.getMessage());
//2002/08/26 Doja1.5                        } catch( Exception e ) {
//2002/08/26 Doja1.5                            showDialog("NG:" + e.toString());
//2002/08/26 Doja1.5                        }
//2002/08/26 Doja1.5                        break;
                    case 0:
//2002/08/26 Doja1.5                    case 2:
                        // J011_4406_0103
                        try {
                            TextBox t = new TextBox("",-1,1,TextBox.DISPLAY_ANY);
                            showDialog("NG:no exception");
                        } catch( IllegalArgumentException iae ) {
                            showDialog("IllegalArgumentException:"+iae.getMessage());
                        } catch( Exception e ) {
                            showDialog("NG:" + e.toString());
                        }
                        break;
                    case 1:
//2002/08/26 Doja1.5                    case 3:
                        // J011_4406_0104
                        try {
                            TextBox t = new TextBox("",16,-1,TextBox.DISPLAY_ANY);
                            showDialog("NG:no exception");
                        } catch( IllegalArgumentException iae ) {
                            showDialog("IllegalArgumentException:"+iae.getMessage());
                        } catch( Exception e ) {
                            showDialog("NG:" + e.toString());
                        }
                        break;
                    case 2:
//2002/08/26 Doja1.5                    case 4:
                        // J011_4406_0105
                        try {
                            TextBox t = new TextBox("",16,1,9999);
                            showDialog("NG:no exception");
                        } catch( IllegalArgumentException iae ) {
                            showDialog("IllegalArgumentException:"+iae.getMessage());
                        } catch( Exception e ) {
                            showDialog("NG:" + e.toString());
                        }
                        break;
                }
                break;
            case 1:
                // J011_4406_0106
                try {
                    testBox.setInputMode(9999);
                    showDialog("NG:no exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                switch( menuList2.getSelectedIndex() ) {
                    case 0:
                        // J011_4406_0107
                        try {
                            testBox.setSize(-1,20);
                            showDialog("NG:no exception");
                        } catch( IllegalArgumentException iae ) {
                            showDialog("IllegalArgumentException:"+iae.getMessage());
                        } catch( Exception e ) {
                            showDialog("NG:" + e.toString());
                        }
                        break;
                    case 1:
                        // J011_4406_0108
                        try {
                            testBox.setSize(80,-1);
                            showDialog("NG:no exception");
                        } catch( IllegalArgumentException iae ) {
                            showDialog("IllegalArgumentException:"+iae.getMessage());
                        } catch( Exception e ) {
                            showDialog("NG:" + e.toString());
                        }
                        break;
                    case 2:
                        // J011_4406_0109
                        try {
                            testBox.setSize(-1,-1);
                            showDialog("NG:no exception");
                        } catch( IllegalArgumentException iae ) {
                            showDialog("IllegalArgumentException:"+iae.getMessage());
                        } catch( Exception e ) {
                            showDialog("NG:" + e.toString());
                        }
                        break;
                }
                break;
        }
    }
}
