/**
 * J011_4501_0301
 * MainPanel
 *
 * Ticker class access level checking (normal route)
 *
 * $Id: J011_4501_0301.java,v 1.1 2001/11/30 04:28:43 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Ticker class access level checking main class
 * @extends IApplication
 */
public class J011_4501_0301 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Ticker class access level checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.Ticker()",
        "2.Ticker(String)",
        "3.setText()",
        "4.getHeight()",
        "5.getWidth()",
        "6.getX()",
        "7.getY()",
        "8.setBackground()",
        "9.setForeground()",
        "10.setLocation()",
        "11.setSize()",
        "12.setVisible()"
    };

    Label   classLabel       = new Label("Ticker access level");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    Ticker  ticker           = new Ticker("Ticker");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(execButton);
        add(ticker);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * testing the selected menu
     */
    public void test() {
        Ticker  t;

        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                // J011_4501_0301
                t = new Ticker();
                showDialog("OK");
                break;
            case 1:
                // J011_4501_0302
                t = new Ticker("test Ticker");
                showDialog("OK");
                break;
            case 2:
                // J011_4501_0303
                ticker.setText("NewText-Ticker");
                showDialog("OK");
                break;
            case 3:
                // J011_4501_0304
                showDialog("getHeight():" + ticker.getHeight());
                break;
            case 4:
                // J011_4501_0305
                showDialog("getWidth():" + ticker.getWidth());
                break;
            case 5:
                // J011_4501_0306
                showDialog("getX():" + ticker.getX());
                break;
            case 6:
                // J011_4501_0307
                showDialog("getY():" + ticker.getY());
                break;
            case 7:
                // J011_4501_0308
                ticker.setBackground(Graphics.getColorOfName(Graphics.BLUE));
                showDialog("OK");
                break;
            case 8:
                // J011_4501_0309
                ticker.setForeground(Graphics.getColorOfName(Graphics.RED));
                showDialog("OK");
                break;
            case 9:
                // J011_4501_0310
                ticker.setLocation(0,70);
                showDialog("OK");
                break;
            case 10:
                // J011_4501_0311
                ticker.setSize(100,40);
                showDialog("OK");
                break;
            case 11:
                // J011_4501_0312
                ticker.setVisible(true);
                showDialog("OK");
                break;
        }
    }
}
