/**
 * J011_4505_0201
 * MainPanel
 *
 * Ticker class method behavior checking (normal route)
 *
 * $Id: J011_4505_0201.java,v 1.1 2001/11/30 04:29:48 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Ticker class method behavior checking main class
 * @extends IApplication
 */
public class J011_4505_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Ticker class method behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1 rated value",
        "2.variation"
    };
    String[][] subItems = {
        {
            "1.setText(String)",
            "2.setText(null)"
        },
        {
            "1.alphabetic characters",
//2002/07/30 Doja1.5            "",
//2002/07/30 Doja1.5            "3.",
            "4.pictographic characters",
            "5.all kinds of characters mixed"
        }
    };

    Label   classLabel       = new Label("Ticker method's behavior");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    Ticker  ticker           = new Ticker("Ticker");
    char[]  emoji            = {0xE63E, 0xE63F, 0xE640, 0xE641};
    char[]  emoji2           = {0xE63E, 0xE63F};

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(ticker);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            if( menuList.getSelectedIndex() == 0 ) {
                /* prescribed value method behavior checking */
                test1();
            } else {
                /* check the variation */
                test2();
            }
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * check the prescribed value method behavior
     */
    public void test1() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J011_4505_0201
                ticker.setText("NewText");
                break;
            case 1:
                // J011_4505_0202
                ticker.setText(null);
                break;
        }
    }

    /**
     * check the variation
     */
    public void test2() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J011_4505_0301
                ticker.setText("abcdeABCDE");
                break;
//2002/07/30 Doja1.5            case 1:
                // J011_4505_0302
//2002/07/30 Doja1.5                ticker.setText("");
//2002/07/30 Doja1.5                break;
//2002/07/30 Doja1.5            case 2:
                // J011_4505_0303
//2002/07/30 Doja1.5                ticker.setText("");
//2002/07/30 Doja1.5                break;
            case 1:
//2002/07/30 Doja1.5            case 3:
                // j011_4505_0304
                ticker.setText(String.valueOf(emoji));
                break;
            case 2:
//2002/07/30 Doja1.5            case 4:
                // j011_4505_0305
                ticker.setText("aA"+String.valueOf(emoji2));
//2002/07/30 Doja1.5                ticker.setText(""+String.valueOf(emoji2));
                break;
        }
    }
}
