/**
 * J011_4506_0101
 * MainPanel
 *
 * Ticker class prescribed exception behavior checking (normal route)
 *
 * $Id: J011_4506_0101.java,v 1.1 2001/11/30 04:30:28 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Ticker class prescribed exception behavior checking main class
 * @extends IApplication
 */
public class J011_4506_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Ticker class prescribed exception behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.width<0",
        "2.height<0",
        "3.both<0"
    };

    Label   classLabel       = new Label("Ticker.setSize behavior for thrown exceptions");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    Ticker  ticker           = new Ticker("Ticker");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(ticker);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * testing the selected menu
     */
    public void test() {
        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                // J011_4506_0101
                try {
                    ticker.setSize(-1,20);
                    showDialog("NG:no exception");
                } catch( IllegalArgumentException iae ) {
//2002/08/21 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
                    showDialog("OK:IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_4506_0102
                try {
                    ticker.setSize(80,-1);
                    showDialog("NG:no exception");
                } catch( IllegalArgumentException iae ) {
//2002/08/21 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
                    showDialog("OK:IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J011_4506_0103
                try {
                    ticker.setSize(-1,-1);
                    showDialog("NG:no exception");
                } catch( IllegalArgumentException iae ) {
//2002/08/21 DoJa1.5                    showDialog("IllegalArgumentException:"+iae.getMessage());
                    showDialog("OK:IllegalArgumentException:"+iae.getMessage());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }
}
