/**
 * J011_4602_0201
 * MainPanel
 *
 * UIException class constant checking (normal route)
 *
 * $Id: J011_4602_0201.java,v 1.1 2001/11/30 04:32:09 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * UIException class constant checking main class
 * @extends IApplication
 */
public class J011_4602_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * UIException class constant checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.UNDEFINED",
        "2.ILLEGAL_STATE",
        "3.NO_RESOURCES",
        "4.BUSY_RESOURCE",
        "5.UNSUPPORTED_FORMAT",
        "6.STATUS_FIRST",
        "7.STATUS_LAST"
    };

    Label   classLabel       = new Label("UIException constant's definition");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            /* check definition of the constant  */
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * check definition of the constant 
     */
    public void test() {
        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                // J011_4602_0101
                //UIException.UNDEFINED = 0;

                // J011_4602_0201
                if( UIException.UNDEFINED == 0 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + UIException.UNDEFINED);
                }
                break;
            case 1:
                // J011_4602_0102
                //UIException.ILLEGAL_STATE = 0;

                // J011_4602_0202
                if( UIException.ILLEGAL_STATE == 1 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + UIException.ILLEGAL_STATE);
                }
                break;
            case 2:
                // J011_4602_0103
                //UIException.NO_RESOURCES = 0;

                // J011_4602_0203
                if( UIException.NO_RESOURCES == 2 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + UIException.NO_RESOURCES);
                }
                break;
            case 3:
                // J011_4602_0104
                //UIException.BUSY_RESOURCE = 0;

                // J011_4602_0204
                if( UIException.BUSY_RESOURCE == 3 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + UIException.BUSY_RESOURCE);
                }
                break;
            case 4:
                // J011_4602_0105
                //UIException.UNSUPPORTED_FORMAT = 0;

                // J011_4602_0205
                if( UIException.UNSUPPORTED_FORMAT == 4 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + UIException.UNSUPPORTED_FORMAT);
                }
                break;
            case 5:
                // J011_4602_0206
                if( MyUIException.getSTATUS_FIRST() == 0 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + MyUIException.getSTATUS_FIRST());
                }
                break;
            case 6:
                // J011_4602_0207
                if( MyUIException.getSTATUS_LAST() == 63 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + MyUIException.getSTATUS_LAST());
                }
                break;
        }
    }
}

/**
 * sub class of UIException
 * @extends UIException
 */
class MyUIException extends UIException {
    /**
     * constructor
     */
    public MyUIException() {
    }

    /**
     * get STATUS_FIRST
     */
    public static int getSTATUS_FIRST() {
        // J011_4602_0106
        //STATUS_FIRST = 0;

        return STATUS_FIRST;
    }

    /**
     * get STATUS_LAST
     */
    public static int getSTATUS_LAST() {
        // J011_4602_0107
        //STATUS_LAST = 0;

        return STATUS_LAST;
    }
}
