/**
 * J011_4701_0201
 * MainPanel
 *
 * VisualPresenter class access level checking (normal route)
 *
 * $Id: J011_4701_0201.java,v 1.1 2001/11/30 04:33:50 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * VisualPresenter class access level checking main class
 * @extends IApplication
 */
public class J011_4701_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * VisualPresenter class access level checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
//2002/07/26 DoJa1.5        "1.protected",
        "2.public"
    };
//2002/07/26 DoJa1.5    String[][] subItems = {
//2002/07/26 DoJa1.5        {
//2002/07/26 DoJa1.5            "1.MAX_VENDOR_ATTR",
//2002/07/26 DoJa1.5            "2.MAX_VENDOR_VISUAL_EVENT",
//2002/07/26 DoJa1.5            "3.MIN_VENDOR_ATTR",
//2002/07/26 DoJa1.5            "4.MIN_VENDOR_VISUAL_EVENT"
//2002/07/26 DoJa1.5        },
		String[] subItems = 
        {
            "1.VisualPresenter()",
            "2.setImage()",
            "3.setData()",
            "4.getMediaResource()",
            "5.play()",
            "6.stop()",
            "7.setAttribute()",
            "8.setMediaListener()",
            "9.getHeight()",
            "10.getWidth()",
            "11.getX()",
            "12.getY()",
            "13.setBackground()",
            "14.setForeground()",
            "15.setLocation()",
            "16.setSize()",
            "17.setVisible()"
//2002/07/26 DoJa1.5        }
    };
    String  filename         = new String("animmax.gif");

    Label   classLabel       = new Label("VisualPresenter access level");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    VisualPresenter vp       = new VisualPresenter();

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
//2002/07/26 DoJa1.5        menuList2.setItems(subItems[0]);
        menuList2.setItems(subItems);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(vp);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

//2002/07/26 DoJa1.6        /*  */
//2002/07/26 DoJa1.5        if (aComponent == menuList
//2002/07/26 DoJa1.5            && aType == ComponentListener.SELECTION_CHANGED) {
//2002/07/26 DoJa1.6            /*  */
//2002/07/26 DoJa1.5            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
//2002/07/26 DoJa1.5        }

        /* when  the execution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
//2002/07/26 DoJa1.5            if( menuList.getSelectedIndex() == 0 ) {
//2002/07/26 DoJa1.6                /* protected */
//2002/07/26 DoJa1.5                test1();
//2002/07/26 DoJa1.5            } else {
                /* checking public level behavior  */
                test2();
//2002/07/26 DoJa1.5            }
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

//2002/07/26 DoJa1.5    /**
//2002/07/26 DoJa1.6     * protected
//2002/07/26 DoJa1.5     */
//2002/07/26 DoJa1.5    public void test1() {
//2002/07/26 DoJa1.5        int value;

//2002/07/26 DoJa1.6        /*  */
//2002/07/26 DoJa1.5        switch( menuList2.getSelectedIndex() ) {
//2002/07/26 DoJa1.5            case 0:
//2002/07/26 DoJa1.5                // J011_4701_0201
//2002/07/26 DoJa1.5                value = MyVisualPresenter.getMAX_VENDOR_ATTR();
//2002/07/26 DoJa1.5                showDialog("OK: value=" + value);
//2002/07/26 DoJa1.5                break;
//2002/07/26 DoJa1.5            case 1:
//2002/07/26 DoJa1.5                // J011_4701_0202
//2002/07/26 DoJa1.5                value = MyVisualPresenter.getMAX_VENDOR_VISUAL_EVENT();
//2002/07/26 DoJa1.5                showDialog("OK: value=" + value);
//2002/07/26 DoJa1.5                break;
//2002/07/26 DoJa1.5            case 2:
//2002/07/26 DoJa1.5                // J011_4701_0203
//2002/07/26 DoJa1.5                value = MyVisualPresenter.getMIN_VENDOR_ATTR();
//2002/07/26 DoJa1.5                showDialog("OK: value=" + value);
//2002/07/26 DoJa1.5                break;
//2002/07/26 DoJa1.5            case 3:
//2002/07/26 DoJa1.5                // J011_4701_0204
//2002/07/26 DoJa1.5                value = MyVisualPresenter.getMIN_VENDOR_VISUAL_EVENT();
//2002/07/26 DoJa1.5                showDialog("OK: value=" + value);
//2002/07/26 DoJa1.5                break;
//2002/07/26 DoJa1.5        }
//2002/07/26 DoJa1.5    }

    /**
     * checking public level behavior 
     */
    public void test2() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J011_4701_0301
                try {
                    VisualPresenter vp3 = new VisualPresenter();
                    Ticker t1 = new Ticker("TOP");
                    Ticker t2 = new Ticker("LEFT");
                    Ticker t3 = new Ticker("RIGHT");
                    Ticker t4 = new Ticker("BOTTOM");
                    Font f = Font.getDefaultFont();
                    t1.setSize(getWidth(),t1.getHeight());
                    t2.setSize(f.getBBoxWidth("LEFT"),t2.getHeight()*2/3);
                    t3.setSize(f.getBBoxWidth("RIGHT"),t3.getHeight()*2/3);
                    t4.setSize(getWidth(),t4.getHeight());
                    add(t1);
                    add(t2);
                    add(vp3);
                    add(t3);
                    add(t4);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J011_4701_0302
                try {
                    vp.setImage(null);
                } catch( Exception e ) {
                }
                showDialog("OK");
                break;
            case 2:
                // J011_4701_0303
                try {
                    vp.setData(null);
                } catch( Exception e ) {
                }
                showDialog("OK");
                break;
            case 3:
                // J011_4701_0304
                MediaResource mr = vp.getMediaResource();
                showDialog("OK");
                break;
            case 4:
                // J011_4701_0305
                try {
                    vp.play();
                } catch( Exception e ) {
                }
                showDialog("OK");
                break;
            case 5:
                // J011_4701_0306
                try {
                    vp.stop();
                } catch( Exception e ) {
                }
                showDialog("OK");
                break;
            case 6:
                // J011_4701_0307
                try {
                    vp.setAttribute(0,0);
                } catch( Exception e ) {
                }
                showDialog("OK");
                break;
            case 7:
                // J011_4701_0308
                try {
                    vp.setMediaListener(null);
                } catch( Exception e ) {
                }
                showDialog("OK");
                break;
            case 8:
                // J011_4701_0309
                int h = vp.getHeight();
                showDialog("OK");
                break;
            case 9:
                // J011_4701_0310
                int w = vp.getWidth();
                showDialog("OK");
                break;
            case 10:
                // J011_4701_0311
                int x = vp.getX();
                showDialog("OK");
                break;
            case 11:
                // J011_4701_0312
                int y = vp.getY();
                showDialog("OK");
                break;
            case 12:
                // J011_4701_0313
                vp.setBackground(7);
                showDialog("OK");
                break;
            case 13:
                // J011_4701_0314
                vp.setForeground(0);
                showDialog("OK");
                break;
            case 14:
                // J011_4701_0315
                vp.setLocation(10,70);
                showDialog("OK");
                break;
            case 15:
                // J011_4701_0316
                vp.setSize(40,40);
                showDialog("OK");
                break;
            case 16:
                // J011_4701_0317
                vp.setVisible(true);
                showDialog("OK");
                break;
        }
    }
}

/**
 * sub class of VisualPresenter
 * @extends VisualPresenter
 */
//2002/08/01 DoJa1.5class MyVisualPresenter extends VisualPresenter {
    /**
     * constructor
     */
//2002/08/01 DoJa1.5    public MyVisualPresenter() {
//2002/08/01 DoJa1.5    }

    /**
     * get MAX_VENDOR_ATTR
     */
//2002/08/01 DoJa1.5    public static int getMAX_VENDOR_ATTR() {
//2002/08/01 DoJa1.5        return MAX_VENDOR_ATTR;
//2002/08/01 DoJa1.5    }

    /**
     * get MAX_VENDOR_VISUAL_EVENT
     */
//2002/08/01 DoJa1.5    public static int getMAX_VENDOR_VISUAL_EVENT() {
//2002/08/01 DoJa1.5        return MAX_VENDOR_VISUAL_EVENT;
//2002/08/01 DoJa1.5    }

    /**
     * get MIN_VENDOR_ATTR
     */
//2002/08/01 DoJa1.5    public static int getMIN_VENDOR_ATTR() {
//2002/08/01 DoJa1.5        return MIN_VENDOR_ATTR;
//2002/08/01 DoJa1.5    }

    /**
     * get MIN_VENDOR_VISUAL_EVENT
     */
//2002/08/01 DoJa1.5    public static int getMIN_VENDOR_VISUAL_EVENT() {
//2002/08/01 DoJa1.5        return MIN_VENDOR_VISUAL_EVENT;
//2002/08/01 DoJa1.5    }
//2002/08/01 DoJa1.5}
