/**
 * J011_4702_0201
 * MainPanel
 *
 * VisualPresenter class constant checking (normal route)
 *
 * $Id: J011_4702_0201.java,v 1.1 2001/11/30 04:34:35 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * VisualPresenter class constant checking main class
 * @extends IApplication
 */
public class J011_4702_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * VisualPresenter class constant checking main class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.IMAGE_XPOS",
        "2.IMAGE_YPOS",
//2002/07/25 DoJa1.5        "3.MIN_VENDOR_ATTR",
//2002/07/25 DoJa1.5        "4.MAX_VENDOR_ATTR",
        "5.VISUAL_PLAYING",
        "6.VISUAL_STOPPED",
        "7.VISUAL_COMPLETE"
//2002/07/25 DoJa1.5        "8.MIN_VENDOR_VISUAL_EVENT",
//2002/07/25 DoJa1.5        "9.MAX_VENDOR_VISUAL_EVENT",
    };

    Label   classLabel       = new Label("VisualPresenter constant's definition");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            /* check definition of the constant  */
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * check definition of the constant 
     */
    public void test() {
        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                // J011_4702_0101
                //VisualPresenter.IMAGE_XPOS = 0;

                // J011_4702_0201
                if( VisualPresenter.IMAGE_XPOS == 1 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + VisualPresenter.IMAGE_XPOS);
                }
                break;
            case 1:
                // J011_4702_0102
                //VisualPresenter.IMAGE_YPOS = 0;

                // J011_4702_0202
                if( VisualPresenter.IMAGE_YPOS == 2 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + VisualPresenter.IMAGE_YPOS);
                }
                break;
//2002/07/25 DoJa1.5            case 2:
//2002/07/25 DoJa1.5                // J011_4702_0203
//2002/07/25 DoJa1.5                if( MyVisualPresenter.getMIN_VENDOR_ATTR() == 64 ) {
//2002/07/25 DoJa1.5                    showDialog("OK");
//2002/07/25 DoJa1.5                } else {
//2002/07/25 DoJa1.5                    showDialog("NG: " + MyVisualPresenter.getMIN_VENDOR_ATTR());
//2002/07/25 DoJa1.5                }
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5            case 3:
//2002/07/25 DoJa1.5                // j011_4702_0204
//2002/07/25 DoJa1.5                if( MyVisualPresenter.getMAX_VENDOR_ATTR() == 127 ) {
//2002/07/25 DoJa1.5                    showDialog("OK");
//2002/07/25 DoJa1.5                } else {
//2002/07/25 DoJa1.5                    showDialog("NG: " + MyVisualPresenter.getMAX_VENDOR_ATTR());
//2002/07/25 DoJa1.5                }
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5            case 4:
            case 2:
                // J011_4702_0105
                //VisualPresenter.VISUAL_PLAYING = 0;

                // J011_4702_0205
                if( VisualPresenter.VISUAL_PLAYING == 1 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + VisualPresenter.VISUAL_PLAYING);
                }
                break;
//2002/07/25 DoJa1.5            case 5:
            case 3:
                // J011_4702_0106
                //VisualPresenter.VISUAL_STOPPED = 0;

                // J011_4702_0206
                if( VisualPresenter.VISUAL_STOPPED == 2 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + VisualPresenter.VISUAL_STOPPED);
                }
                break;
//2002/07/25 DoJa1.5            case 6:
            case 4:
                // J011_4702_0107
                //VisualPresenter.VISUAL_COMPLETE = 0;

                // J011_4702_0207
                if( VisualPresenter.VISUAL_COMPLETE == 3 ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + VisualPresenter.VISUAL_COMPLETE);
                }
                break;
//2002/07/25 DoJa1.5            case 7:
//2002/07/25 DoJa1.5                // J011_4702_00208
//2002/07/25 DoJa1.5                if( MyVisualPresenter.getMIN_VENDOR_VISUAL_EVENT() == 64 ) {
//2002/07/25 DoJa1.5                    showDialog("OK");
//2002/07/25 DoJa1.5                } else {
//2002/07/25 DoJa1.5                    showDialog("NG: " + MyVisualPresenter.getMIN_VENDOR_VISUAL_EVENT());
//2002/07/25 DoJa1.5                }
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5            case 8:
//2002/07/25 DoJa1.5                // j011_4702_0209
//2002/07/25 DoJa1.5                if( MyVisualPresenter.getMAX_VENDOR_VISUAL_EVENT() == 127 ) {
//2002/07/25 DoJa1.5                    showDialog("OK");
//2002/07/25 DoJa1.5                } else {
//2002/07/25 DoJa1.5                    showDialog("NG: " + MyVisualPresenter.getMAX_VENDOR_VISUAL_EVENT());
//2002/07/25 DoJa1.5                }
//2002/07/25 DoJa1.5                break;
//2002/07/25 DoJa1.5        }
    }
}

//2002/07/25 DoJa1.5/**
//2002/07/25 DoJa1.6 * VisualPresenter
//2002/07/25 DoJa1.5 * @extends VisualPresenter
//2002/07/25 DoJa1.5 */
//2002/07/25 DoJa1.5class MyVisualPresenter extends VisualPresenter {
//2002/07/25 DoJa1.5    /**
//2002/07/25 DoJa1.6     * 
//2002/07/25 DoJa1.5     */
//2002/07/25 DoJa1.5    public MyVisualPresenter() {
//2002/07/25 DoJa1.5    }

//2002/07/25 DoJa1.5    /**
//2002/07/25 DoJa1.6     * MAX_VENDOR_ATTR
//2002/07/25 DoJa1.5     */
//2002/07/25 DoJa1.5    public static int getMAX_VENDOR_ATTR() {
//2002/07/25 DoJa1.5        // J011_4702_0104
//2002/07/25 DoJa1.5        //MAX_VENDOR_ATTR = 0;

//2002/07/25 DoJa1.5        return MAX_VENDOR_ATTR;
//2002/07/25 DoJa1.5    }

//2002/07/25 DoJa1.5    /**
//2002/07/25 DoJa1.6     * MAX_VENDOR_VISUAL_EVENT
//2002/07/25 DoJa1.5     */
//2002/07/25 DoJa1.5    public static int getMAX_VENDOR_VISUAL_EVENT() {
//2002/07/25 DoJa1.5        // J011_4702_0109
//2002/07/25 DoJa1.5        //MAX_VENDOR_VISUAL_EVENT = 0;

//2002/07/25 DoJa1.5        return MAX_VENDOR_VISUAL_EVENT;
//2002/07/25 DoJa1.5    }

//2002/07/25 DoJa1.5    /**
//2002/07/25 DoJa1.6     * MIN_VENDOR_ATTR
//2002/07/25 DoJa1.5     */
//2002/07/25 DoJa1.5    public static int getMIN_VENDOR_ATTR() {
//2002/07/25 DoJa1.5        // J011_4702_0103
//2002/07/25 DoJa1.5        //MIN_VENDOR_ATTR = 0;

//2002/07/25 DoJa1.5        return MIN_VENDOR_ATTR;
//2002/07/25 DoJa1.5    }

//2002/07/25 DoJa1.5    /**
//2002/07/25 DoJa1.6     * MIN_VENDOR_VISUAL_EVENT
//2002/07/25 DoJa1.5     */
//2002/07/25 DoJa1.5    public static int getMIN_VENDOR_VISUAL_EVENT() {
//2002/07/25 DoJa1.5        // J011_4702_0108
//2002/07/25 DoJa1.5        //MIN_VENDOR_VISUAL_EVENT = 0;

//2002/07/25 DoJa1.5        return MIN_VENDOR_VISUAL_EVENT;
//2002/07/25 DoJa1.5/    }
}
