//2002/07/25 DoJa1.5
/**
 *J011_5401_0101
 *Main Panel
 *
 *TextBox class constant member checking
 *
 *$ID:$
 */
 
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 *TextBox class behavior checking main class
 *@IApplication
 */
public class J011_5401_0101 extends IApplication{
	public void start(){
		Display.setCurrent(new MainPanel());
	}
}

/**
 *TextBox class constant member checking main screen
 *@extends Panel
 *@implements SoftKeyListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
	String[] menuListItem = {
		"0 TRADITIONAL_HANZI",
		"1 SIMPLEFIED_HANZI"
	};
	
	String[] exceptionItem = {
		"TRADITIONAL_HANZI",
		"SIMPLIFIED_HANZI"
	};
	
	Label classLabel = new Label("TextBox");
	ListBox menuList = new ListBox(ListBox.CHOICE);
	TextBox resultText = new TextBox("",20,3,TextBox.DISPLAY_ANY);
	Button Button1 = new Button("execute");
	
	/*
	*Constructor of MainPanel class
	*/
	public MainPanel(){
		try{
			/*display of the main panel*/
			showMainPanel();
		}catch(Exception e){
			Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
		}
	}
	
	/**
	*display constant definition check screen
	*/
	void showMainPanel(){
	
		/*setting of the display item*/
		menuList.setItems(menuListItem);
		setTitle("API class normal route");
		setSoftLabel(Frame.SOFT_KEY_1,"exit");
		
		/*add on each component*/
		add(classLabel);
		add(menuList);
		add(Button1);
		add(resultText);
		
		/*setting the listener*/
		setSoftKeyListener(this);
		setComponentListener(this);
		
		/*Constant member definition check
		 *following is confirming that constant member can't be set up the value
		 *check the failure in building and delete to the end of the method
		 */
		 
		 /**
		 TextBox.TRADITIONAL_HANZI = 0;		//	J011_5401_0101
		 TextBox.SIMPLIFIED_HANZI = 0;		//	J011_5401_0102
		 */
	}
	
	/**
	*do nothing when a softkey is pushed
	*/
	public void softKeyPressed(int anIndex){}
	
	/*
	*define the action when softkey is released
	*/
	public void softKeyReleased(int anIndex){
		/*terminate the application when softkey1 is released*/
		if(anIndex == Frame.SOFT_KEY_1){
			IApplication.getCurrentApp().terminate();
		}
	}
	
	/**
	*get the event on a component
	*@param aComponent The component on which a event occurred
	*@param aType Type of an event.
	*@param aParam Parameter of an event
	*/
	public void componentAction(Component aComponent,int aType,int aParam){
		/*processing when the list choice is changed*/
		if(aComponent == menuList && aType == ComponentListener.SELECTION_CHANGED){
			resultText.setText("");
		}
		
		/*processing when the excecute button is pushed*/
		if(aComponent == Button1 && aType == ComponentListener.BUTTON_PRESSED){
			/*Result of constant definition checking reflects textbox of result*/
			resultText.setText(result(menuList.getSelectedIndex()));
		}
	}
	
	String result(int anIndex){
		String resultStr;
		
		/**get the event on a component
		*@param anIndex the index number which selected in listbox
		*@return
		*/
		switch(anIndex){
			/*checking whether Exception which is selected is as a default */
			
			//J011_5402_0101
			case 0:
				resultStr = isOK(TextBox.TRADITIONAL_HANZI == 3);
				break;
			
			//J011_5402_0102
			case 1:
				resultStr = isOK(TextBox.SIMPLIFIED_HANZI == 4);
				break;
			
			default:
				resultStr = "ERROR\nMissing Operation";
				break;
		}
		
		/*When a judgment result is NG, an actual value is set as NG addition information*/
		if (resultStr.equals("NG")){
			resultStr += "\n"+exceptionItem[anIndex];
		}
		return resultStr;
	}
	
	/**
	*The justification of a constant definition is judged and the character sequence OK/NG is returned.
	*@param aResult Constant definition judging
	*@implements ComponentListener
	*/
	String isOK(boolean aResult){
		return(aResult ? "OK":"NG");
	}
}
//2002/07/25 DoJa1.5
