//2002/07/25 DoJa1.5
/**
 * J011_5402_0101
 *
 * TextBox class behavior checking (this is added)
 * check method's behavior
 *
 * $Id: J011_5402_0101.java,v 1.1 2001/12/01 13:27:29 horikoshi Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * TextBox class method behavior checking main class
 * @extends IApplication
 */
public class J011_5402_0101 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class method behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    Label   title      = new Label("TextBox's behavior test");
    Button  execButton = new Button("execute");

	//	creating TextBox class
    TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
    TextBox textBox2 = new TextBox("",20,1,TextBox.DISPLAY_ANY);

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
        setTitle("API class normal route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(title);
		add(textBox1);
		add(textBox2);
        add(execButton);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * process when the action other than softkey happens
     * @param source the component on which the event occurs
     * @param type event type
     * @param param event parameter
     */
    public void componentAction(Component source, int type, int param) {
        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {
			//	storage for the inputted character
			String	inputString = "";
	//J011_5402_0101
			//	check the default input mode
			inputString = textBox1.getText();
			textBox2.setText("");
			if( inputString == "" ){
			}
			else{
				textBox2.setText(inputString);
			}
        }
    }
}
//2002/07/25 DoJa1.5
