/**
 * J012_0301_0101
 *
 * HttpConnection boundary test
 *
 * $Id: J012_0301_0101.java,v 1.2 2002/01/17 07:47:19 lan Exp $
 */

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * HttpConnection boundary test main class
 * @extends IApplication
 */
public class J012_0301_0101 extends IApplication
{
    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * HttpConnection boundary test main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String[] menulist = {
            "1.the argument's maximum value",
            "2.the argument's value is 0",
            "3.the argument's value is -1",
            "4.null argument"
        };
        String[][] subItems = {
            {
/*                "1.URL255",
                "2.URL256",  */
                "3.setIfModifiedSince",
                "4.setRequestMethod",
                "5.setRequestProperty"
            },
            {
                "1.setIfModifiedSince",
                "2.setRequestMethod",
                "3.setRequestProperty1",
                "4.setRequestProperty2"
            },
            {
                "1.setIfModifiedSince"
            },
            {
                "1.setRequestMethod",
                "2.setRequestProperty1",
                "3.setRequestProperty2"
            }
        };

        Label title;
        ListBox menu;
        ListBox menu2;
        Button exe;

        HttpConnection  con = null;
        InputStream     is = null;
        OutputStream    os = null;
        String          filename = "J012_0301_0101.jam";
        String          olddate = "olddate";
        String          newdate = "newdate";

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class boundary route");
            title=new Label("HttpConnection boundary test");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu2=new ListBox(ListBox.CHOICE);
            menu.setItems(menulist);
            menu2.setItems(subItems[0]);
            add(menu);
            add(menu2);
            exe = new Button("execute");
            add(exe);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * dialog display method
         * @param   aText chalacter sequence which is displaied
         */
        public void showDialog(String aText) {
            Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
            d.setText(aText);
            d.show();
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when the menu is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
                /* sub menu setting */
                menu2.setItems(subItems[menu.getSelectedIndex()]);
            }

            /* when  the exsecution button is pushed */
            if (aComponent == exe && aType == ComponentListener.BUTTON_PRESSED) {
                /* test the menu which is choiced */
                switch( menu.getSelectedIndex() ) {
                    case 0:
                        /* behavior checking in case of the maximum parameter out of the prescribed */
                        test1();
                        break;
                    case 1:
                        /* checking behavior in case of the parameter  0 */
                        test2();
                        break;
                    case 2:
                        /* checking behavior in case of the parameter  -1 */
                        test3();
                        break;
                    case 3:
                        /* checking behavior in case of the parameter  null */
                        test4();
                        break;
                }
            }
        }

        /**
         * HttpConnection boundary test / behavior checking in case of the maximum parameter out of the prescribed
         */
        public void test1() {
            switch( menu2.getSelectedIndex() ) {
                // J012_0301_0101
                case 0:
                /*    try {
                        String url1 = getSourceURL();
                        int len = url1.length();
                        len = 255 - len;
                        for(int i=0; i<len; i++){
                                url1 += 1;
                        }
                        if( url1.length() != 255 ) {
                            showDialog("NG: URL-length=" + url1.length());
                            return;
                        }

                        con=(HttpConnection) Connector.open(url1,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        String url = con.getURL();
                        if( url.length() != 255 ) {
                            showDialog("NG:URL-length="+url.length());
                            return;
                        }
                        showDialog("OK");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0301_0201
                case 1:
                    try {
                        String url2 = getSourceURL();
                        int len = url2.length();
                        len = 256 - len;
                        for(int i=0; i<len; i++){
                                url2 += 2;
                        }
                        if( url2.length() != 256 ) {
                            showDialog("NG: URL-length=" + url2.length());
                            return;
                        }

                        con=(HttpConnection) Connector.open(url2,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        String url = con.getURL();
                        if( url.length() != 256 ) {
                            showDialog("NG:URL-length="+url.length());
                            return;
                        }
                        showDialog("OK");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0301_0301
                case 2:*/
                    try {
//           String url = getSourceURL();
//              url += "./newhead.asis";
//                          con=(HttpConnection) Connector.open(url,
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            newdate,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setIfModifiedSince(Long.MAX_VALUE);
                        con.connect();
                        int status = con.getResponseCode();
                        String modified = con.getHeaderField("Last-Modified");
                        con.close();
                        showDialog("OK" + status + ":Last-Modified:" + modified);
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0301_0302
                case 1:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        String maxString = new String("GETA");
                        for( int i=0; i<102; i++ ) {
                            maxString += "1234567890";
                        }
                        con.setRequestMethod(maxString);
                        showDialog("NG:no Exception");
                    } catch (IllegalArgumentException iae) {
                        showDialog("OK:IllegalArgumentException");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0301_0303
                case 2:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        String maxString = new String("HEADNAME");
                     // for( int i=0; i<102; i++ ) {
                        for( int i=0; i<12; i++ ) {
                            maxString += "1234567890";
                        }
//                        if( maxString.length() != 1024 ) {
                        if( maxString.length() != 128 ) {
                            showDialog("NG:length="+maxString.length());
                        }
                        con.setRequestProperty(maxString,maxString);
                        con.connect();
                        con.close();
                        showDialog("OK");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
            }
        }


        /**
         * HttpConnection boundary test / Checking behavior in case of the parameter 0
         */
        public void test2() {
            switch( menu2.getSelectedIndex() ) {
                // J012_0302_0301
                case 0:
                    try {
           String url = getSourceURL();
              url += "./oldhead.asis";
                        con=(HttpConnection) Connector.open(url,
//                        con=(HttpConnection) Connector.open(getSourceURL()+
//                                            olddate,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setIfModifiedSince(0);
                        con.connect();
                        int status = con.getResponseCode();
                        String modified = con.getHeaderField("Last-Modified");
                        con.close();
                        showDialog("OK" + status + ":Last-Modified:" + modified);
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0302_0302
                case 1:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod("");
                        showDialog("NG:no Exception");
                    } catch (IllegalArgumentException npe) {
                        showDialog("OK:IllegalArgumentException");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0302_0303
                case 2:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setRequestProperty("","ABCD");
                        con.connect();
                        con.close();
                        showDialog("OK");
                    } catch (NullPointerException npe) {
                        showDialog("NG:NullPointerException");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0302_0304
                case 3:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setRequestProperty("Content-Type","");
                        con.connect();
                        con.close();
                        showDialog("OK");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
            }
        }


        /**
         * HttpConnection boundary test / Checking behavior in case of the parameter -1
         */
        public void test3() {
            switch( menu2.getSelectedIndex() ) {
                // J012_0303_0101
                case 0:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setIfModifiedSince(-1);
                        con.connect();
                        con.close();
                        showDialog("OK");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
            }
        }

        /**
         * HttpConnection boundary test / Checking behavior in case of the parameter null
         */
        public void test4() {
            switch( menu2.getSelectedIndex() ) {
                // J012_0304_0101
                case 0:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(null);
                        showDialog("NG:no Exception");
                    } catch (NullPointerException npe) {
                        showDialog("OK:NullPointerException");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0304_0102
                case 1:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setRequestProperty(null,"ABCD");
                        con.connect();
                        con.close();
                        showDialog("OK");
                    } catch (NullPointerException npe) {
                        showDialog("OK:NullPointerException");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
                // J012_0304_0103
                case 2:
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                                            filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setRequestProperty("Content-Type",null);
                        con.connect();
                        con.close();
                        showDialog("OK");
                    } catch (Exception e ) {
                        showDialog("NG:"+ e.toString());
                    }
                    break;
            }
        }
    }
}
