/**
 * J012_0701_0301
 * 
 * UnsupportedOperationException boundary test
 *
 * $Id: J012_0701_0301.java,v 1.1 2001/11/30 04:42:46 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.lang.*;

/**
 * UnsupportedOperationException boundary test main class
 * @extends IApplication
 */

public class J012_0701_0301 extends IApplication {
    /**
     * functional outline :Starting method of i-appli 
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }


    /**
     * UnsupportedOperationException boundary test main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menulist[]={
            "1.the argument's maximum value",
            "2.the argument's value is 0",
            "3.null argument"
        };
        Label title;
        ListBox menu;
        Button  exe;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class boundary route");
            title=new Label("UnsupportedOperationException boundary test");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menulist);
            add(menu);
            exe=new Button("execute");
            add(exe);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when the menu is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
            }

            /* when  the exsecution button is pushed */
            if( aComponent == exe && aType == ComponentListener.BUTTON_PRESSED ) {
                /* test the menu which is choiced */
                test();
            }
        }

        /**
         * execute the selected testing
         */
        public void test() {
            UnsupportedOperationException uoe = null;
            switch( menu.getSelectedIndex() ) {
                // J012_0701_0301
                case 0:             /* 1024byte character sequence */
                    String maxMsg = new String("1234");
                    for( int i=0; i<102; i++ ) {
                        maxMsg += "1234567890";
                    }
                    uoe = new UnsupportedOperationException(maxMsg);
                    if( uoe.getMessage().compareTo(maxMsg) == 0 ) {
                        showDialog("OK");
                    } else {
                        showDialog("NG:" + uoe.getMessage());
                    }
                    break;
                // J011_0702_0301
                case 1:             /* 0 parameter */
                    uoe = new UnsupportedOperationException("");
                    if( uoe.getMessage().compareTo("") == 0 ) {
                        showDialog("OK");
                    } else {
                        showDialog("NG:" + uoe.getMessage());
                    }
                    break;
                // J011_0704_0101
                case 2:             /* null parameter */
                    uoe = new UnsupportedOperationException(null);
                    if( uoe.getMessage() == null ) {
                        showDialog("OK");
                    } else {
                        showDialog("NG:" + uoe.getMessage());
                    }
                    break;
                default:
                    break;
            }
        }
    }
}
