/**
 * J011_1201_0101
 * 
 * 
 *
 * Button class behavior checking (boundary test)
 *
 * $Id: J011_1201_0101.java,v 1.2 2002/12/04 12:08:09 lan Exp $
 */
import com.nttdocomo.ui.*;


/**
 * Button class action check main class
 * @extends IApplication
 */
public class J012_1201_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Button class behavior checking MainPanel
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
 
	Button  button = new Button(" execute");
    Label   classLabel = new Label("Button");
    TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
    ListBox menuList2 = new ListBox(ListBox.CHOICE);
   
        MainPanel(){
        /* setting of the display item */
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        menuList2.setItems(subItems);

        /* adding each component on the display */
        add(classLabel);
        add(textBox1);
        add(menuList2);
        add(button);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }
    String[] subItems = {
        "1.Button",
        "2.setLabel"
    };


    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if( aComponent == textBox1 ) {
            /* sub menu setting */
          	menuList2.setItems(subItems);
        }

        if (aComponent == button) {
            /* create NextPanel1 class */
            Display.setCurrent(new NextPanel1((Frame)this, 
                                textBox1.getText(),
                                menuList2.getSelectedIndex()));
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * terminate the application when softkey1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Button boundary checking class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener{
    Frame previousFrame = null;
    int idx1 = 0;
 

    /**
     * constructer of NextPanel1 class
     * @param aFrame the object of MainPanel
     * @param anIndex1 selected index of menu1
     * @param anIndex2 selected index of menu2
     */
    NextPanel1(Frame aFrame,String text, int anIndex2){
        /* parameter storaging */
        previousFrame = aFrame;
   

        /* setting of the display item */
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting the listener */
        setSoftKeyListener(this);

        /* excecute testing */
        test(text);
    }

    /*
     * dialog display method
     * @param   aText displayed character sequence
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
        d.setText(aText);
        d.show();
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int aSoftKey) {}
    
    /**
     * when softkey2 is released, return to the MainPanel screen
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if(previousFrame != null){
                Display.setCurrent(previousFrame);
            }
        }
    }

    /**
     * Button boundary checking method
     */
    public void test(String text) {
        Button b;

        switch( idx1 ) {
       
        case 0:
            b = new Button(text);
            add(b);
            break;
        case 1:
             b = new Button();
            add(b);
            b.setLabel(text);
            break;
        }
    }
}
