/**
 * J012_1301_0301
 *
 * MainPanel
 * MainCanvas
 *
 * Canvas class action check (normal route)
 *
 * $Id: J012_1301_0301.java,v 1.1 2001/12/01 12:51:01 misato Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Canvas class action check main class
 * @extends IApplication
 */
public class J012_1301_0301 extends IApplication{
    public void start(){
        /* starting method for I-appli */
        Display.setCurrent(new MainPanel());
    }
}

/**
 * MainPanel class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener*
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    String[] menuListItem = {
        "0 test 1",
        "1 test 2",
        "2 test 3",
        "3 test 4",
        "4 test 5",
        "5 test 6",
        "6 test 7",
        "7 test 8",
        "8 test 9"
    };
    
    Label classLabel = new Label("Canvas");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button Button1 = new Button("execute");
    Graphics g ;
    
    /**
     * Constructor of MainPanel class
     */
    public MainPanel(){
        try{
            /* display of the main panel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
        }
    }
    
    /**
     * show the constant definition confirming display
     */
    void showMainPanel(){
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class boundary test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        
        /* add on each component */
        add(classLabel);
        add(menuList);
        add(Button1);
        
        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex){}
    
    /**
     * define the action when softkey is released
     */
    public void softKeyReleased(int anIndex){
        IApplication.getCurrentApp().terminate();
    }
    
    public void componentAction(Component aComponent,int aType,int aParam){
        /* processing when the list choice is changed */
        if(aComponent == menuList && aType == ComponentListener.SELECTION_CHANGED){
            
        }
        
        /* processing when the execution button is pushed */
        if(aComponent == Button1 && aType == ComponentListener.BUTTON_PRESSED){
            Display.setCurrent(new MainCanvas(this, menuList.getSelectedIndex()));
        }
    }
}

/**
 * screen of MainCanvas class
 * @extends Canvas
 */
class MainCanvas extends Canvas{
    Frame previous;
    int anint;
    boolean flag = false;
    Graphics g1;

    /**
     * create the constructor
     */
    public MainCanvas(Frame prevFrame,int aFlag){
        previous = prevFrame;
        anint = aFlag;
        setSoftLabel(Canvas.SOFT_KEY_1,"back");
        setSoftLabel(Canvas.SOFT_KEY_2,"execute");
    }
    
    public void processEvent(int type,int param){
        /* key event */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* processing when the return key is pushed */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previous);
                    break;
        
                /* processing when the excecution key is pushed */
                case Display.KEY_SOFT2:
                    if (anint == 0) {
                        flag = true;
                        repaint(0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF);
                    }else if (anint ==1){
                        flag = true;
                        repaint(0x7FFFFFFF,0,0,0);
                    }else if (anint == 2){
                        flag = true;
                        repaint(0,0x7FFFFFFF,0,0);
                    }else if(anint == 3){
                        flag = true;
                        repaint(0,0,0x7FFFFFFF,20);
                    }else if(anint == 4){
                        flag = true;
                        repaint(10,20,0x7FFFFFFF,20);
                    }else if(anint == 5){
                        flag = true;
                        repaint(-10,40,0x7FFFFFFF,20);
                    }else if(anint == 6){
                        flag =true;
                        repaint(0,0,20,0x7FFFFFFF);
                    }else if(anint == 7){
                        flag = true;
                        repaint(20,20,20,0x7FFFFFFF);
                    }else if(anint == 8){
                        flag = true;
                        repaint(40,-20,20,0x7FFFFFFF);
                    }
            }
        }
    }

    /**
     * implementation of paint() method
     */
    public void paint(Graphics g){
        switch(anint){
            //J012_1301_0101
            case 0:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
            
            //J012_1301_0102
            case 1:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
                
            //J012_1301_0103
            case 2:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
                
            //J012_1301_0104
            case 3:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
            
            //J012_1301_0105
            case 4:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
            
            //J012_1301_0106
            case 5:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
            
            //J012_1301_0107
            case 6:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
                
            //J012_1301_0108
            case 7:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
            
            //J012_1301_0109
            case 8:
                if(flag == false){
                    g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                    g.fillRect(0,0,getWidth(),getHeight());
                }else if(flag == true){
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                    g.fillRect(0,0,getWidth(),getHeight());
                }
                break;
                
            default:
                break;
        }
    }
}