/**
 * J012_1402_0103
 *
 *
 *
 * Component classs behavior checking (boundary test)
 *
 * $Id: J012_1402_0103.java,v 1.1 2001/11/30 02:25:34 yaeda Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Component class action check main class
 * @extends IApplication
 */
public class J012_1402_0103 extends IApplication {
    
    /**
     * starting method for I-appli
     */
    public void start () {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Component class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private Frame previousFrame = null;
    private Button button1;
    private String[] menuListItem = {
            "01 minimum width",
            "02 minimum height",
            "03 minimum width and height"
    };
    int min1 = 0;
    int max1 = Display.getWidth();
    int max2 = Display.getHeight();;


    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        /* setting of the display item */
        setTitle("API class boundary route");
        menuList.setItems(menuListItem);
        
        add(menuList);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        button1 = new Button("execute");
        add(button1);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button1 ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this, min1 ,max2));
                    break;
                case 1:
                    /* create NextPanel2 */
                    Display.setCurrent(new NextPanel2((Frame) this, min1, max1));
                    break;
                case 2:
                    /* create NextPanel3 */
                    Display.setCurrent(new NextPanel3((Frame) this, min1, max1, max2));
                    break;
            }
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {
    }

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel1 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button[] =new Button[6];
    private int min1,max1,max2;
    
    /**
     * NextPanel1 constructor
     * @param aPrev the object of MainPanel
     * @param amin screen minimum(0)
     * @param amax2 screen height
     */
    public NextPanel1(Frame aPrev, int amin, int amax2) {
        previousFrame = aPrev;
        min1 = amin;
        max2 = amax2;

        /* setting of the display item */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        for( int i=0; i < 6; i++ ) {
            button[i] = new Button("b"+(i));
            add(button[i]);
            button[i].setSize(20,max2);
//2002/08/22 Doja1.5            button[i].setSize(15,max2);
        }

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        
        if ( aComponent == button[0] ) {
            Dialog dialog = new Dialog(Dialog.BUTTON_OK, "setSize");
//J012_1402_0103
            button[3].setSize(min1,20);
            dialog.setText("width ="+button[3].getWidth()+",height ="+button[3].getHeight());
            dialog.show();
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button[] =new Button[6];
    private int min1,max1;
    
    /**
     * NextPanel2 constructor
     * @param aPrev the object of MainPanel
     * @param amin screen minimum(0)
     * @param amax1 screen width
     */
    public NextPanel2(Frame aPrev, int amin, int amax1) {
        previousFrame = aPrev;
        min1 = amin;
        max1 = amax1;

        /* setting of the display item */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        for( int i=0; i < 6; i++ ) {
            button[i] = new Button("button"+(i));
            add(button[i]);
            button[i].setSize(max1,20);
        }

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        
        if ( aComponent == button[0] ) {
            Dialog dialog = new Dialog(Dialog.BUTTON_OK, "setSize");
//J012_1402_0104
            button[3].setSize(20,min1);
            dialog.setText("width ="+button[3].getWidth()+",height ="+button[3].getHeight());
            dialog.show();
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Component class action check sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel3 extends Panel implements SoftKeyListener,ComponentListener {

    private Frame previousFrame = null;
    private Button button[] =new Button[12];
    private int min1,max1,max2;
    
    /**
     * NextPanel2 constructor
     * @param aPrev the object of MainPanel
     * @param amin screen minimum(0)
     * @param amax1 screen width
     * @param amax2 screen height
     */
    public NextPanel3(Frame aPrev, int amin, int amax1, int amax2) {
        previousFrame = aPrev;
        min1 = amin;
        max1 = amax1;
        max2 = amax2;

        /* setting of the display item */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");
        for( int i=0; i < 6; i++ ) {
            button[i] = new Button("b"+(i));
            add(button[i]);
            button[i].setSize(20,max2);
//2002/08/22 Doja1.5            button[i].setSize(15,max2);
        }
        for( int i=6; i < 12; i++ ) {
            button[i] = new Button("button"+(i));
            add(button[i]);
            button[i].setSize(max1,15);
        }

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
        
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        
        if ( aComponent == button[0] ) {
//J012_1402_0105
            Dialog dialog = new Dialog(Dialog.BUTTON_OK, "setSize");
            button[3].setSize(min1,min1);
            button[9].setSize(min1,min1);
            dialog.setText("button3's width="+button[3].getWidth()+",height ="+button[3].getHeight()+":button9's width="+button[9].getWidth()+",height ="+button[9].getHeight());
            dialog.show();
        }
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * terminate the application when the softkey2 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

