/**
 * J012_1601_0101
 *
 * Dialog class behavior checking (boundary test)
 *
 * $Id: J012_1601_0101.java,v 1.2 2001/12/01 12:09:31 lan Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Dialog class behavior checking main class
 * @extends IApplication
 */
public class J012_1601_0101 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Dialog class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

   TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);

    /* maximum within the prescribed */
    String[] menu2_01 = {
        "01 Dialog",
        
        "03 setSoftLabel",
        "04 setText"
    };

  

    Label   title      = new Label("test of Dialog's behavior");
   // ListBox menu_Li    = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    int     firstType;
    int     secondType;
    Graphics g;
    Dialog d;

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
      //  menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(title);
        add(textBox1);
        add(menu_Li2);
        add(execButton);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component source, int type, int param) {
   

        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {

              
                   test1();
                   
        }
    }

    /**
     * the maximum of the parameter within the prescribed behavior checking
     */
    public void test1() {
      //  int max = 0;
      //  int min = 0;
        Dialog d;
    	String	Str = new String("");
        Str = textBox1.getText();
        secondType = menu_Li2.getSelectedIndex();
//J012_1601_0101
        if (secondType == 0) {
            d = new Dialog(Dialog.BUTTON_OK,Str);
         
            d.show();

//J012_1601_0104
        } else  if(secondType == 1) {
            d = new Dialog(Dialog.BUTTON_OK, "setSoftLabel");
            d.setText("check that the soft key1 is changed(nothing is handled actually)");
            d.setSoftLabel(Frame.SOFT_KEY_1, Str);
            d.show();
//J012_1601_0106
        } else if (secondType == 2) {
            d = new Dialog(Dialog.BUTTON_OK, "setText");
            d.setText(Str);
            d.show();
        }
    }
}



 