/**
 * J012_1601_0103
 *
 * Dialog class behavior checking (boundary test)
 *
 * $Id: J012_1601_0103.java,v 1.2 2001/12/01 12:09:31 lan Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Dialog class behavior checking main class
 * @extends IApplication
 */
public class J012_1601_0103 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Dialog class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menu1 = {
        "01 when the value is prescribed maximum",
        "02 when the value is prescribed maximum + 1",
        "03 when the value is non-prescribed maximum",
        "04 when the value is prescribed minimum",
        "05 when the value is prescribed minimum - 1",
        "06 when the value is null"
    };

    /* maximum within the prescribed */
    String[] menu2_01 = {
       
        "02 setBackground",
      
    };

    /* maximum + 1 within the prescribed */
    String[] menu2_02 = {
       
        "02 Dialog2",
        "03 setBackground",
      
        "05 setSoftLabel2",
        
    };

    /* maximum out of the prescribed */
    String[] menu2_03 = {
      
        "02 Dialog2",
        "03 setBackground",
       
        "05 setSoftLabel2",
        
    };

    /* minimum within the prescribed */
    String[] menu2_04 = {
        "01 Dialog",
        "02 setBackground",
        "03 setSoftLabel",
        "04 setText"
    };

    /* the minimum -1 whithin the prescribed */
    String[] menu2_05 = {
        "01 Dialog",
        "02 setBackground"
    };

    /* in case of null */
    String[] menu2_06 = {
        "01 Dialog",
        "02 setSoftLabel",
        "03 setText"
    };

    Label   title      = new Label("test of Dialog's behavior");
    ListBox menu_Li    = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    int     firstType;
    int     secondType;
    Graphics g;
    Dialog d;

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(title);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param aSoftKey Index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param aSoftKey Index of the key
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component source, int type, int param) {
        /* when item in the menu1 is selected */
        if (source == menu_Li && type == ComponentListener.SELECTION_CHANGED) {

            /* get the chosen item */
            firstType = menu_Li.getSelectedIndex();

            /* set the selection list in menu 1 */
            switch (firstType) {
                case 0:
                    menu_Li2.setItems(menu2_01);
                    break;
                case 1:
                    menu_Li2.setItems(menu2_02);
                    break;
                case 2:
                    menu_Li2.setItems(menu2_03);
                    break;
                case 3:
                    menu_Li2.setItems(menu2_04);
                    break;
                case 4:
                    menu_Li2.setItems(menu2_05);
                    break;
                case 5:
                    menu_Li2.setItems(menu2_06);
                    break;
                default:
                    break;
            }
        }

        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {

            /* get the chosen item */
            secondType = menu_Li2.getSelectedIndex();

            switch (firstType) {
                case 0:
                    test1();
                    break;
                case 1:
                    test2();
                    break;
                case 2:
                    test3();
                    break;
                case 3:
                    test4();
                    break;
                case 4:
                    /* the minimum of the parameter -1 within the prescribed */
                    test5();
                    break;
                case 5:
                    /* in case of null */
                    test6();
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * the maximum of the parameter within the prescribed behavior checking
     */
    public void test1() {
        int max = 0;
        int min = 0;
        Dialog d;


//J012_1601_0103
         if (secondType == 0) {
            d = new Dialog(Dialog.BUTTON_OK, "setBackground");
            d.setText("maximum value:check that value is displayed black or white");
            if  (g.getColorOfRGB(255,255,255) > g.getColorOfRGB(0,0,0)) {
                max = g.getColorOfRGB(255,255,255);
                min = g.getColorOfRGB(0,0,0);
            }else {
                min = g.getColorOfRGB(255,255,255);
                max = g.getColorOfRGB(0,0,0);
            }
            d.setBackground(max);
            d.show();

    }
    }


    /**
     * the maximum of the parameter +1 within the prescribed behavior checking
     */
    public void test2() {
        int min = 0;
        int max = 0;
        Dialog d;


//J012_1601_0202
        if (secondType == 0) {
            try {
                d = new Dialog(5, "Dialog");
                d.show();
            } catch (IllegalArgumentException e) {
                showDialog("an exception has been thrown:IllegalArgumentException");
            } catch (Exception e) {
                String str = "an exception has been thrown:";
                showDialog(str+e.toString());
            }
//J012_1601_0203
        } else if (secondType == 1) {
            d = new Dialog(Dialog.BUTTON_OK, "setBackground");
            if (g.getColorOfRGB(255,255,255) > g.getColorOfRGB(0,0,0)) {
                max = g.getColorOfRGB(255,255,255);
                min = g.getColorOfRGB(0,0,0);
            }else {
                min = g.getColorOfRGB(255,255,255);
                max = g.getColorOfRGB(0,0,0);
            }
            try {
                d.setBackground(max+1);
                d.show();
            } catch (IllegalArgumentException e) {
                showDialog("an exception has been thrown:IllegalArgumentException");
            } catch (Exception e) {
                showDialog(e.toString());
            }

//J012_1601_0205
        } else if (secondType == 2) {
            d = new Dialog(Dialog.BUTTON_OK, "setSoftLabel2");
            try {
                d.setSoftLabel(2, "1234");
                d.setText("incorrect soft key type (nothing is handled actually)");
                d.show();
            } catch (Exception e) {
                showDialog(e.toString());
            }
//J012_1601_0206
        } else if (secondType == 3) {
            d = new Dialog(Dialog.BUTTON_OK, "setText");
            d.setText("1234567890123456789012345678901234567890123456789");
            d.show();
        }
    }

    /**
     * the maximum of the parameter out of the prescribed behavior checking
     */
    public void test3() {
        int int_max = 0x7FFFFFFF;
        String str_max = "";

        for (int i=0; i<1024; i++) {
            str_max += "a";
        }


     if (secondType == 0) {
            try {
                d = new Dialog(int_max, "Dialog");
                d.show();
            } catch (IllegalArgumentException e) {
                showDialog("an exception has been thrown:IllegalArgumentException");
            } catch (Exception e) {
                showDialog(e.toString());
            }
//J012_1601_0303
        } else if (secondType == 1) {
            d = new Dialog(Dialog.BUTTON_OK, "setBackground");
            try {
                d.setBackground(int_max);
                d.show();
            } catch (IllegalArgumentException e) {
                showDialog("an exception has been thrown:IllegalArgumentException");
            } catch (Exception e) {
                showDialog(e.toString());
            }

//J012_1601_0305
        } else if (secondType == 2) {
            d = new Dialog(Dialog.BUTTON_OK, "setSoftLabel2");
            try {
                d.setSoftLabel(int_max, "1234");
                d.setText("incorrect soft key type (nothing is handled actually)");
                d.show();
            } catch (Exception e) {
                showDialog(e.toString());
            }

        }
    }

    /**
     * the minimum of the parameter within the prescribed behavior checking
     */
    public void test4() {
        int min = 0;
        int max = 0;
        String str_min = "";

//J012_1602_0101
        if (secondType == 0) {
            d = new Dialog(Dialog.BUTTON_OK, str_min);
            d.setText("set 0 byte to the title -> check the empty string");
            d.show();
//J012_1602_0103
        } else if (secondType == 1) {
            d = new Dialog(Dialog.BUTTON_OK, "setBackground");
            d.setText("maximum value:check that value is displayed black or white");
            if (g.getColorOfRGB(255,255,255) > g.getColorOfRGB(0,0,0)) {
                max = g.getColorOfRGB(255,255,255);
                min = g.getColorOfRGB(0,0,0);
            }else {
                min = g.getColorOfRGB(255,255,255);
                max = g.getColorOfRGB(0,0,0);
            }
            d.setBackground(min);
            d.show();
//J012_1602_0104
        } else if (secondType == 2) {
            d = new Dialog(Dialog.BUTTON_OK, "setSoftLabel");
            d.setText("check that the soft key1 is changed(nothing is handled actually)");
            d.setSoftLabel(Frame.SOFT_KEY_1, str_min);
            d.show();
//J012_1602_0105
        } else if (secondType == 3) {
            d = new Dialog(Dialog.BUTTON_OK, "setText");
            d.setText(str_min);
            d.show();
        }
    }

    /**
     * the minimum of the parameter -1 within the prescribed behavior checking
     */
    public void test5() {
        int min = 0;
        int max = 0;

//J012_1602_0201
        if (secondType == 0) {
            try {
                d = new Dialog(-1, "Dialog");
                d.show();
            } catch (IllegalArgumentException e) {
                showDialog("an exception has been thrown:IllegalArgumentException");
            } catch (Exception e) {
                showDialog(e.toString());
            }
//J012_1602_0202
        } else if (secondType == 1) {
            d = new Dialog(Dialog.BUTTON_OK, "setBackground");
            try {
                d.setBackground(-1);
                d.show();
            } catch (IllegalArgumentException e) {
                showDialog("an exception has been thrown:IllegalArgumentException");
            } catch (Exception e) {
                showDialog(e.toString());
            }
        }
    }

    /**
     * behavior checking in case of null
     */
    public void test6() {
        String str_null = null;

//J012_1602_0401
        if (secondType == 0) {
            try {
                d = new Dialog(Dialog.BUTTON_OK, str_null);
                d.setText("set a null to the title -> check the empty string");
                d.show();
            } catch (Exception e) {
                showDialog(e.toString());
            }
//J012_1602_0403
        } else if (secondType == 1) {
            try {
                d = new Dialog(Dialog.BUTTON_OK, "setSoftLabel");
                d.setText("check that the soft key1 is changed(nothing is handled actually)");
                d.setSoftLabel(Frame.SOFT_KEY_1, str_null);
                d.show();
            } catch (Exception e) {
                showDialog(e.toString());
            }
//J012_1602_0404
        } else if (secondType == 2) {
            try {
                d = new Dialog(Dialog.BUTTON_OK, "setText");
                d.setText(str_null);
                d.show();
            } catch (Exception e) {
                showDialog(e.toString());
            }
        }
    }

    /**
     * setting of the dialog box which is going to be displayed
     */
    public void showDialog(String str) {
        /* create the dialog box */
        Dialog    d = new Dialog(Dialog.BUTTON_OK, "result");
        /* put the character sequence */
        d.setText(str);
        /* display of the dialog box */
        d.show();
    }
}
