/**
 * J012_2101_0101
 * MainPanel
 *
 * Graphics class behavior checking(boundary test) -method behavior
 *
 * $Id: J012_2101_0101.java,v 1.1 2001/11/30 04:44:17 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Graphics class method action check main class
 * @extends IApplication
 */
public class J012_2101_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Graphics class method action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    
    String[] menuItems = {
        "1.prescribed maximum value",
        "2.prescribed maximum value + 1",
        "3.non-prescribed maximum value",
        "4.prescribed minimum value",
        "5.minimum within the prescribed -1",
        "6.minimum within the prescribed",
        "7.parameter -1",
        "8.parameter null"
    };
    String[][] subItems = {
        /* 1.prescribed maximum value */
        {
            "1.getColorOfRGB(r=255)",
            "2.getColorOfRGB(g=255)",
            "3.getColorOfRGB(b=255)",
            "4.getColorOfName(15)",
            "5.setColor()",
            "6.fillPolygon(16)"
//2002/08/22 DoJa1.5            "6.fillPolygon(16)",
//2002/08/22 DoJa1.5            "7.fillPolygon2(16)"
        },
        /* 2.prescribed maximum value + 1 */
        {
            "1.getColorOfRGB(r=256)",
            "2.getColorOfRGB(g=256)",
            "3.getColorOfRGB(b=256)",
            "4.getColorOfName(16)",
            "5.setColor()",
            "6.fillPolygon(17)"
//2002/08/22 DoJa1.5            "6.fillPolygon(17)",
//2002/08/22 DoJa1.5            "7.fillPolygon2(17)"
        },
        /* 3.non-prescribed maximum value */
        {
            "1.setOrigin(x=MaxInt)",
            "2.setOrigin(y=MaxInt)",
            "3.getColorOfRGB(r=MaxInt)",
            "4.getColorOfRGB(g=MaxInt)",
            "5.getColorOfRGB(b=MaxInt)",
            "6.getColorOfName(MaxInt)",
            "7.setColor(MaxInt)",
            "8.clearRect(x=MaxInt)",
            "9.clearRect(y=MaxInt)",
            "10.clearRect(w=MaxInt)",
            "11.clearRect(h=MaxInt)",
            "12.drawLine(x1=y1=MaxInt)",
            "13.drawLine(x2=y2=MaxInt)",
            "14.drawRect(x=MaxInt)",
            "15.drawRect(y=MaxInt)",
            "16.drawRect(w=MaxInt)",
            "17.drawRect(h=MaxInt)",
            "18.fillRect(x=MaxInt)",
            "19.fillRect(y=MaxInt)",
            "20.fillRect(w=MaxInt)",
            "21.fillRect(h=MaxInt)",
            "22.drawImage(x=MaxInt)",
            "23.drawImage(y=MaxInt)",
//2002/08/22 DoJa1.5            "24.drawImage2(dx=dy=MaxInt)",
//2002/08/22 DoJa1.5            "25.drawImage2(sx=sy=MaxInt)",
//2002/08/22 DoJa1.5            "26.drawImage2(w=h=MaxInt)",
//2002/08/22 DoJa1.5            "27.drawImage2(all=MaxInt)",
            "28.drawPolyline(x=y=MaxInt)",
            "29.drawPolyline(n=MaxInt)",
//2002/08/22 DoJa1.5            "30.drawPolyline2(x=y=MaxInt)",
//2002/08/22 DoJa1.5            "31.drawPolyline2(offset=MaxInt)",
//2002/08/22 DoJa1.5            "32.drawPolyline2(count=MaxInt)",
//2002/08/22 DoJa1.5            "33.drawPolyline2(offset=count=MaxInt)",
            "34.fillPolygon(x=y=MaxInt)",
            "35.fillPolygon(n=MaxInt)",
//2002/08/22 DoJa1.5            "36.fillPolygon2(x=y=MaxInt)",
//2002/08/22 DoJa1.5            "37.fillPolygon2(offset=MaxInt)",
//2002/08/22 DoJa1.5            "38.fillPolygon2(count=MaxInt)",
//2002/08/22 DoJa1.5            "39.fillPolygon2(offset=count=MaxInt)",
            "40.drawString(str=1024byte)",
            "41.drawString(x=MaxInt)",
            "42.drawString(y=MaxInt)",
            "43.drawChars(str=1024byte)",
            "44.drawChars(x=MaxInt)",
            "45.drawChars(y=MaxInt)",
            "46.drawChars(len=MaxInt)",
            "47.drawChars(offset=MaxInt)",
            "48.drawChars(len=offset=MaxInt)"
//2002/08/22 DoJa1.5            "48.drawChars(len=offset=MaxInt)",
//2002/08/22 DoJa1.5            "49.setClip(x=MaxInt)",
//2002/08/22 DoJa1.5            "50.setClip(y=MaxInt)",
//2002/08/22 DoJa1.5            "51.setClip(w=h=MaxInt)",
//2002/08/22 DoJa1.5            "52.clipRect(x=MaxInt)",
//2002/08/22 DoJa1.5            "53.clipRect(y=MaxInt)",
//2002/08/22 DoJa1.5            "54.clipRect(w=h=MaxInt)",
//2002/08/22 DoJa1.5            "55.copyArea(x=MaxInt)",
//2002/08/22 DoJa1.5            "56.copyArea(y=MaxInt)",
//2002/08/22 DoJa1.5            "57.copyArea(w=h=MaxInt)",
//2002/08/22 DoJa1.5            "58.copyArea(dx=dy=MaxInt)"

        },
        /* 4.prescribed minimum value */
        {
            "1.setOrigin(x=y=0)",
            "2.getColorOfRGB(r=0)",
            "3.getColorOfRGB(g=0)",
            "4.getColorOfRGB(b=0)",
            "5.getColorOfRGB(0,0,0)",
            "6.getColorOfName(0)",
            "7.setColor(min)",
            "8.clearRect(w=0)",
            "9.clearRect(h=0)",
            "10.drawRect(w=0)",
            "11.drawRect(h=0)",
            "12.fillRect(w=0)",
            "13.fillRect(h=0)",
//2002/08/22 DoJa1.5            "14.drawImage(w=0)",
//2002/08/22 DoJa1.5            "15.drawImage(h=0)",
            "16.drawPolyline(n=0)",
//2002/08/22 DoJa1.5            "17.drawPolyline2(offset=0)",
//2002/08/22 DoJa1.5            "18.drawPolyline2(count=0)",
//2002/08/22 DoJa1.5            "19.drawPolyline2(offset=count=0)",
            "20.fillPolygon(n=3)"
//2002/08/22 DoJa1.5            "20.fillPolygon(n=3)",
//2002/08/22 DoJa1.5            "21.fillPolygon2(offset=0)",
//2002/08/22 DoJa1.5            "22.fillPolygon2(count=3)",
//2002/08/22 DoJa1.5            "23.setClip(w=0)",
//2002/08/22 DoJa1.5            "24.setClip(h=0)",
//2002/08/22 DoJa1.5            "25.clipRect(w=0)",
//2002/08/22 DoJa1.5            "26.clipRect(h=0)",
//2002/08/22 DoJa1.5            "27.copyArea(w=0)",
//2002/08/22 DoJa1.5            "28.copyArea(h=0)"
        },
        /* 5.minimum within the prescribed -1 */
        {
            "1.setOrigin(-1,-1)",
            "2.getColorOfRGB(r=-1)",
            "3.getColorOfRGB(g=-1)",
            "4.getColorOfRGB(b=-1)",
            "5.getColorOfName(-1)",
            "6.setColor(min-1)",
            "7.clearRect(w=-1)",
            "8.clearRect(h=-1)",
            "9.drawRect(w=-1)",
            "10.drawRect(h=-1)",
            "11.fillRect(w=-1)",
            "12.fillRect(h=-1)",
//2002/08/22 DoJa1.5            "13.drawImage(w=-1)",
//2002/08/22 DoJa1.5            "14.drawImage(h=-1)",
            "15.drawPolyline(n=-1)",
//2002/08/22 DoJa1.5            "16.drawPolyline2(offset=-1)",
//2002/08/22 DoJa1.5            "17.drawPolyline2(count=-1)",
            "18.fillPolygon(n=3-1)",
//2002/08/22 DoJa1.5            "18.fillPolygon(n=3-1)",
//2002/08/22 DoJa1.5            "19.fillPolygon2(offset=-1)",
//2002/08/22 DoJa1.5            "20.fillPolygon2(count=3-2)",
//2002/08/22 DoJa1.5            "21.setClip(w=-1)",
//2002/08/22 DoJa1.5            "22.setClip(h=-1)",
//2002/08/22 DoJa1.5            "23.clipRect(w=-1)",
//2002/08/22 DoJa1.5            "24.clipRect(h=-1)",
//2002/08/22 DoJa1.5            "25.copyArea(w=-1)",
//2002/08/22 DoJa1.5            "26.copyArea(h=-1)"
//2002/08/28 DoJa1.5
        },
        /* 6.minimum within the prescribed */
        {
            "1.clearRect(x=0)",
            "2.clearRect(y=0)",
            "3.drawLine(x1=y1=0)",
            "4.drawLine(x2=y2=0)",
            "5.drawLine(0,0,0,0)",
            "6.drawRect(x=0)",
            "7.drawRect(y=0)",
            "8.fillRect(x=0)",
            "9.fillRect(y=0)",
            "10.drawImage(x=0)",
            "11.drawImage(y=0)",
//2002/08/22 DoJa1.5            "12.drawImage2(dx=dy=0)",
//2002/08/22 DoJa1.5            "13.drawImage2(sx=sy=0)",
//2002/08/22 DoJa1.5            "14.drawImage2(all=0)",
            "15.drawPolyline(x=y=0)",
//2002/08/22 DoJa1.5            "16.drawPolyline2(x=y=0)",
            "17.fillPolygon(x=y=0)",
            "18.fillPolygon(n=0)",
//2002/08/22 DoJa1.5            "19.fillPolygon2(x=y=0)",
//2002/08/22 DoJa1.5            "20.fillPolygon2(offset=0)",
//2002/08/22 DoJa1.5            "21.fillPolygon2(offset=count=0)",
            "22.drawString(str=0byte)",
            "23.drawString(x=0)",
            "24.drawString(y=0)",
            "25.drawChars(str=0byte)",
            "26.drawChars(x=0)",
            "27.drawChars(y=0)",
            "28.drawChars(len=0)",
            "29.drawChars(off=0)"
//2002/08/22 DoJa1.5            "29.drawChars(off=0)",
//2002/08/22 DoJa1.5            "30.setClip(x=0)",
//2002/08/22 DoJa1.5            "31.setClip(y=0)",
//2002/08/22 DoJa1.5            "32.clipRect(x=0)",
//2002/08/22 DoJa1.5            "33.clipRect(y=0)",
//2002/08/22 DoJa1.5            "34.copyArea(x=0)",
//2002/08/22 DoJa1.5            "35.copyArea(y=0)",
//2002/08/22 DoJa1.5            "36.copyArea(dx=0)",
//2002/08/22 DoJa1.5            "37.copyArea(dy=0)"
        },
        /* 7.parameter -1 */
        {
            "1.clearRect(x=-1)",
            "2.clearRect(y=-1)",
            "3.drawLine(x1=y1=-1)",
            "4.drawLine(x2=y2=-1)",
            "5.drawLine(all=-1)",
            "6.drawRect(x=-1)",
            "7.drawRect(y=-1)",
            "8.fillRect(x=-1)",
            "9.fillRect(y=-1)",
            "10.drawImage(x=-1)",
            "11.drawImage(y=-1)",
//2002/08/22 DoJa1.5            "12.drawImage2(dx=dy=-1)",
//2002/08/22 DoJa1.5            "13.drawImage2(sx=sy=-1)",
//2002/08/22 DoJa1.5            "14.drawImage2(all=-1)",
//2002/08/22 DoJa1.5            "15.fillPolygon2(count=-1)",
//2002/08/22 DoJa1.5            "16.fillPolygon2(offset=count=-1)",
            "17.drawString(x=-1)",
            "18.drawString(y=-1)",
            "19.drawChars(x=-1)",
            "20.drawChars(y=-1)",
            "21.drawChars(len=-1)",
            "22.drawChars(off=-1)",
//2002/08/22 DoJa1.5            "22.drawChars(off=-1)",
//2002/08/22 DoJa1.5            "23.setClip(x=-1)",
//2002/08/22 DoJa1.5            "24.setClip(y=-1)",
//2002/08/22 DoJa1.5            "25.clipRect(x=-1)",
//2002/08/22 DoJa1.5            "26.clipRect(y=-1)",
//2002/08/22 DoJa1.5            "27.copyArea(x=-1)",
//2002/08/22 DoJa1.5            "28.copyArea(y=-1)",
//2002/08/22 DoJa1.5            "29.copyArea(dx=-1)",
//2002/08/22 DoJa1.5            "30.copyArea(dy=-1)"
            "31.fillPolygon(nP=-1)",
        },
        /* 8.parameter null */
        {
            "1.setFont(null)",
            "2.drawImage(image=null)",
//2002/08/22 DoJa1.5            "3.drawImage2(image=null)",
            "4.drawPolyline(x=null)",
            "5.drawPolyline(y=null)",
//2002/08/22 DoJa1.5            "6.drawPolyline2(x=null)",
//2002/08/22 DoJa1.5            "7.drawPolyline2(y=null)",
            "8.fillPolygon(x=null)",
            "9.fillPolygon(y=null)",
//2002/08/22 DoJa1.5            "10.fillPolygon2(x=null)",
//2002/08/22 DoJa1.5            "11.fillPolygon2(y=null)",
            "12.drawString(str=null)",
            "13.drawChars(str=null)"
        }
    };

    Label   classLabel       = new Label("Graphics boundary test");
    ListBox menu             = new ListBox(ListBox.CHOICE);
    ListBox menu2            = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menu.setItems(menuItems);
        menu2.setItems(subItems[0]);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menu);
        add(menu2);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
        d.setText(aText);
        d.show();
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menu
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menu2.setItems(subItems[menu.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            Display.setCurrent(new GCanvas(this,menu.getSelectedIndex(),
                                menu2.getSelectedIndex()));
        }
    }
}


/**
 * Canvs implementation class for testing
 * @extends Canvas
 */
class GCanvas extends Canvas {
    Frame   previous;
    int     idx1;
    int     idx2;
    int     sH;     /* screen height */
    int     sW;     /* screen width */
    int     fH;     /* font height */
    int     fD;     /* font decendline */
    int     lH;     /* line height */
    String filename = new String("89aT.gif");
    Graphics g;
    int     maxInt  = 0x7FFFFFFF;
    MediaImage  mi;

    /**
     * constructor
     */
    public GCanvas(Frame prevFrame, int anIndex1, int anIndex2 ) {
        previous = prevFrame;
        idx1 = anIndex1;
        idx2 = anIndex2;
        setSoftLabel(Canvas.SOFT_KEY_1, "test");
        setSoftLabel(Canvas.SOFT_KEY_2, "back");
        sH = getHeight();
        sW = getWidth();
        fH = Font.getDefaultFont().getHeight();
        fD = Font.getDefaultFont().getDescent();
        lH = fH + fD + 1;
        g = getGraphics();
        if( (idx1 == 2 && idx2 >= 21 && idx2 <= 26 ) ||
            (idx1 == 3 && idx2 >= 13 && idx2 <= 14 ) ||
            (idx1 == 4 && idx2 >= 12 && idx2 <= 13 ) ||
            (idx1 == 5 && idx2 >= 9  && idx2 <= 13 ) ||
            (idx1 == 6 && idx2 >= 9  && idx2 <= 13 ) ) {
            try {
                mi = MediaManager.getImage("resource:///" + filename);
                mi.use();
            } catch( Exception e ) {
                showDialog("ImageLoad error:" + e.toString());
            }
        }
    }

    /**
     * the implementation of paint() method
     */
    public void paint(Graphics g) {
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
        d.setText(aText);
        d.show();
    }

    /**
     * event receive method
     * @param aType event type
     * @param aParam Parameter of an event
     */
    public void processEvent(int type, int param) {
        /* key event */
        if (type == Display.KEY_RELEASED_EVENT) {
            /* when the return key is pushed */
            if( param == Display.KEY_SOFT2 ) {
                /* return to the main menu screen */
                Display.setCurrent(previous);
            }

            /* when the testing key is pressed */
            if( param == Display.KEY_SOFT1 ) {
                /* screen clear */
                g.lock();
                g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                g.fillRect(0,0,sW,sH);
                g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                g.unlock(true);
                setBackground(Graphics.getColorOfName(Graphics.WHITE));

                /* the test starting */
                switch( idx1 ) {
                case 0:
                    /* maximum within the prescribed */
                    test1();
                    break;
                case 1:
                    /* maximum + 1 within the prescribed */
                    test2();
                    break;
                case 2:
                    /* maximum parameter within the prescribed */
                    test3();
                    break;
                case 3:
                    /* minimum within the prescribed */
                    test4();
                    break;
                case 4:
                    /* the minimum -1 whithin the prescribed */
                    test5();
                    break;
                case 5:
                    /* minimum parameter out of the prescribed */
                    test6();
                    break;
                case 6:
                    /* behavior in case of the parameter -1 */
                    test7();
                    break;
                case 7:
                    /* behavior in case of the parameter null */
                    test8();
                    break;
                }
            }
        }
    }


    /**
     * maximum within the prescribed
     */
    public void test1() {
        int c = 0;

        switch( idx2 ) {
        case 0:
            // J012_2101_0101
            /* with no break */
        case 1:
            // J012_2101_0102
            /* with no break */
        case 2:
            // J012_2101_0103
            /* with no break */
        case 3:
            // J012_2101_0105
            if( idx2 == 0 ) {
                c = Graphics.getColorOfRGB(255,0,0);
            } else if( idx2 == 1 ) {
                c = Graphics.getColorOfRGB(0,255,0);
            } else if( idx2 == 2 ) {
                c = Graphics.getColorOfRGB(0,0,255);
            } else {
                c = Graphics.getColorOfName(15);
            }
            g.lock();
            g.setColor(c);
            g.fillRect(sW/2-20,sH/2-20,40,40);
            g.unlock(true);
            break;
        case 4:
            // J012_2101_0106
            int c1 = Graphics.getColorOfRGB(0,0,0);
            int c2 = Graphics.getColorOfRGB(255,255,255);
            if( c1 < c2 ) {
                int c3 = c1;
                c1 = c2;
                c2 = c3;
                showDialog("maximum value is shown in white");
            } else {
                showDialog("maximum value is shown in black");
            }
            g.lock();
            g.setColor(c2);
            g.fillRect(0,0,sW,sH);
            g.setColor(c1);
            g.fillRect(sW/2-20,sH/2-20,40,40);
            g.unlock(true);
            break;
        case 5:
            // J012_2101_0107
            /* with no break */
//2002/08/22 DoJa1.5        case 6:
            // J012_2101_0108
            int[] xP = new int[17];
            int[] yP = new int[17];
            int r = 40;
            int unit = 1024;
            for( int i=0; i<16; i++ ) {
                long ang = FMath.PI2 * i / 16;
                xP[i] = r * ((int) FMath.sin(ang)) / ((int) FMath.FP);
                yP[i] = r * ((int) FMath.cos(ang)) / ((int) FMath.FP);
            }
            xP[16] = xP[0];
            yP[16] = yP[0];
            for( int i=0; i<17; i++ ) {
                xP[i] += sW/2;
                yP[i] += sH/2;
            }
            g.lock();
            g.drawString("hexadecagon",0,lH);
//2002/08/22 DoJa1.5            if( idx2 == 5 ) {
                g.fillPolygon(xP,yP,16);
//2002/08/22 DoJa1.5            } else {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,1,16);
//2002/08/22 DoJa1.5            }
            g.unlock(true);
            break;
        }
    }

    /**
     * maximum + 1 within the prescribed
     */
    public void test2() {
        int c;
        if( idx2 <= 4 ) {
            try {
                switch( idx2 ) {
                case 0:
                    // J012_2101_0201
                    c = Graphics.getColorOfRGB(256,0,0);
                    break;
                case 1:
                    // J012_2101_0202
                    c = Graphics.getColorOfRGB(0,256,0);
                    break;
                case 2:
                    // J012_2101_0203
                    c = Graphics.getColorOfRGB(0,0,256);
                    break;
                case 3:
                    // J012_2101_0205
                    c = Graphics.getColorOfName(16);
                    break;
                case 4:
                    // J012_2101_0206
                    int c1 = Graphics.getColorOfRGB(0,0,0);
                    int c2 = Graphics.getColorOfRGB(255,255,255);
                    if( c1 < c2 ) {
                        c1 = c2;
                    }
                    g.setColor(c1+1);
                    break;
                }
                showDialog("NG: no Exception");
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            return;
        }

        int[] xP = new int[17];
        int[] yP = new int[17];
        int r = 40;
        int unit = 1024;
        for( int i=0; i<17; i++ ) {
            long ang = FMath.PI2 * i / 17;
            xP[i] = r * ((int) FMath.sin(ang)) / ((int) FMath.FP);
            yP[i] = r * ((int) FMath.cos(ang)) / ((int) FMath.FP);
        }
        for( int i=0; i<17; i++ ) {
            xP[i] += sW/2;
            yP[i] += sH/2;
        }
        g.lock();
        g.drawString("heptadecagon",0,lH);
        try {
//2002/08/22 DoJa1.5            if( idx2 == 5 ) {
                // J012_2101_0207
                g.fillPolygon(xP,yP,17);
//2002/08/22 DoJa1.5            } else {
                // J012_2101_0208
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,0,17);
//2002/08/22 DoJa1.5            }
        } catch( IllegalArgumentException iae ) {
            showDialog("IllegalArgumentException");
        } catch( Exception e ) {
            showDialog("NG:" + e.toString());
        }
        g.unlock(true);
    }

    /**
     * behavior in case of the maximum parameter out of the prescribed
     */
    public void test3() {
        String msg;
        char[] chrs;
        int[] xP = new int[5];
        int[] yP = new int[5];
        int r = 40;
        xP[0] = r;
        yP[0] = 0;
        xP[1] = 0;
        yP[1] = -r;
        xP[2] = -r;
        yP[2] = 0;
        for( int i=0; i<3; i++ ) {
            xP[i] += sW/2;
            yP[i] += sH/2;
        }
        xP[3] = maxInt;
        yP[3] = maxInt;
        xP[4] = xP[0];
        yP[4] = yP[0];

        g.lock();
        switch( idx2 ) {
        case 0:
            // J012_2101_0301
            try {
                g.setOrigin(maxInt,0);
                g.fillRect(sW/4,sH/4,sW/2,sH/2);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 1:
            // J012_2101_0302
            try {
                g.setOrigin(0,maxInt);
                g.fillRect(sW/4,sH/4,sW/2,sH/2);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 2:
            // J012_2101_0304
            /* with no break */
        case 3:
            // J012_2101_0305
            /* with no break */
        case 4:
            // J012_2101_0306
            /* with no break */
        case 5:
            // J012_2101_0308
            /* with no break */
        case 6:
            // J012_2101_0309
            try {
                switch( idx2 ) {
                case 2:
                    // J012_2101_0304
                    g.getColorOfRGB(maxInt,0,0);
                    break;
                case 3:
                    // J012_2101_0305
                    g.getColorOfRGB(0,maxInt,0);
                    break;
                case 4:
                    // J012_2101_0306
                    g.getColorOfRGB(0,0,maxInt);
                    break;
                case 5:
                    // J012_2101_0308
                    g.getColorOfName(maxInt);
                    break;
                case 6:
                    // J012_2101_0309
                    g.setColor(maxInt);
                    break;
                }
                showDialog("NG: no Exception");
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 7:
            // J012_2101_0310
            /* with no break */
        case 8:
            // J012_2101_0311
            /* with no break */
        case 9:
            // J012_2101_0313
            /* with no break */
        case 10:
            // J012_2101_0314
            g.fillRect(0,0,sW,sH);
            switch( idx2 ) {
            case 7:
                // J012_2101_0310
                g.clearRect(maxInt,0,sW,sH);
                break;
            case 8:
                // J012_2101_0311
                g.clearRect(0,maxInt,sW,sH);
                break;
            case 9:
                // J012_2101_0313
                g.clearRect(0,0,maxInt,sH/2);
                break;
            case 10:
                // J012_2101_0314
                g.clearRect(0,0,sW/2,maxInt);
                break;
            }
            break;
        case 11:
            // J012_2101_0319
            g.drawLine(maxInt,maxInt,0,0);
            break;
        case 12:
            // J012_2101_0322
            g.drawLine(0,0,maxInt,maxInt);
            break;
        case 13:
            // J012_2101_0323
            g.drawRect(maxInt,0,sW,sH);
            break;
        case 14:
            // J012_2101_0324
            g.drawRect(0,maxInt,sW,sH);
            break;
        case 15:
            // J012_2101_0326
            g.drawRect(0,1,maxInt,sH/2);
            break;
        case 16:
            // J012_2101_0327
            g.drawRect(1,0,sW/2,maxInt);
            break;
        case 17:
            // J012_2101_0330
            g.fillRect(maxInt,0,sW,sH);
            break;
        case 18:
            // J012_2101_0331
            g.fillRect(0,maxInt,sW,sH);
            break;
        case 19:
            // J012_2101_0333
            g.fillRect(0,0,maxInt,sH/2);
            break;
        case 20:
            // J012_2101_0334
            g.fillRect(0,0,sW/2,maxInt);
            break;
        case 21:
            // J012_2101_0337
            g.drawImage(mi.getImage(),maxInt,0);
            break;
        case 22:
            // J012_2101_0338
            g.drawImage(mi.getImage(),0,maxInt);
            break;
//2002/08/22 DoJa1.5        case 23:
            // J012_2101_0342
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),maxInt,maxInt,0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 24:
            // J012_2101_0345
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),0,0,maxInt,maxInt,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 25:
            // J012_2101_0348
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawImage(mi.getImage(),0,0,0,0,maxInt,maxInt);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 26:
            // J012_2101_0349
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawImage(mi.getImage(),maxInt,maxInt,maxInt,maxInt,maxInt,maxInt);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 23:
//2002/08/22 DoJa1.5        case 27:
            // J012_2101_0352
            g.drawPolyline(xP,yP,4);
            break;
        case 24:
//2002/08/22 DoJa1.5        case 28:
            // J012_2101_0353
            try {
                g.drawPolyline(xP,yP,maxInt);
                showDialog("NG: no Exception");
            } catch( ArrayIndexOutOfBoundsException ae ) {
                showDialog("OK:ArrayIndexOutOfBoundsException");
            } catch( Exception e) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 29:
            // J012_2101_0356
//2002/08/22 DoJa1.5            g.drawPolyline(xP,yP,0,4);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 30:
            // J012_2101_0357
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(xP,yP,maxInt,4);
//2002/08/22 DoJa1.5                showDialog("NG: no Exception");
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException ae ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch( Exception e) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 31:
            // J012_2101_0358
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(xP,yP,0,maxInt);
//2002/08/22 DoJa1.5                showDialog("NG: no Exception");
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException ae ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch( Exception e) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 32:
            // J012_2101_0359
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(xP,yP,maxInt,maxInt);
//2002/08/22 DoJa1.5                showDialog("NG: no Exception");
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException ae ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch( Exception e) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 25:
//2002/08/22 DoJa1.5        case 33:
            // J012_2101_0362
            g.fillPolygon(xP,yP,5);
            break;
        case 26:
//2002/08/22 DoJa1.5        case 34:
            // J012_2101_0363
            try {
                g.fillPolygon(xP,yP,maxInt);
                showDialog("NG: no Exception");
            } catch( ArrayIndexOutOfBoundsException ae ) {
                showDialog("OK:ArrayIndexOutOfBoundsException");
            } catch( Exception e) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 35:
            // J012_2101_0366
//2002/08/22 DoJa1.5            g.fillPolygon(xP,yP,0,5);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 36:
            // J012_2101_0367
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,maxInt,0);
//2002/08/22 DoJa1.5                showDialog("NG: no Exception");
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException ae ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch( Exception e) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 37:
            // J012_2101_0368
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,0,maxInt);
//2002/08/22 DoJa1.5                showDialog("NG: no Exception");
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException ae ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch( Exception e) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 38:
            // J012_2101_0369
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,maxInt,maxInt);
//2002/08/22 DoJa1.5                showDialog("NG: no Exception");
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException ae ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch( Exception e) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 27:
//2002/08/22 DoJa1.5        case 39:
            // J012_2101_0370
            /* with no break */
        case 30:
//2002/08/22 DoJa1.5        case 42:
            // J012_2101_0374
            String str1024 = new String("1024byte******");
            for( int i=0; i<101; i++ ) {
                str1024 += "**********";
            }
            if( str1024.length() != 1024 ) {
                showDialog("NG:str.length=" + str1024.length());
                break;
            }
            if( idx2 == 27 ) {
//2002/08/22 DoJa1.5            if( idx2 == 39 ) {
                g.drawString(str1024,0,lH);
            } else {
                g.drawChars(str1024.toCharArray(),0,lH,0,1024);
            }
            break;
        case 28:
//2002/08/22 DoJa1.5        case 40:
            // J012_2101_0371
            g.drawString("if visible, NG",maxInt,lH);
            break;
        case 29:
//2002/08/22 DoJa1.5        case 41:
            // J012_2101_0372
            g.drawString("if visible, NG",0,maxInt);
            break;
        case 31:
//2002/08/22 DoJa1.5        case 43:
            // J012_2101_0375
            msg = new String("if visible, NG");
            chrs = msg.toCharArray();
            g.drawChars(chrs,maxInt,lH,0,chrs.length);
            break;
        case 32:
//2002/08/22 DoJa1.5        case 44:
            // J012_2101_0376
            msg = new String("if visible, NG");
            chrs = msg.toCharArray();
            g.drawChars(chrs,0,maxInt,0,chrs.length);
            break;
        case 33:
//2002/08/22 DoJa1.5        case 45:
            // J012_2101_0378
            /* with no break */
        case 34:
//2002/08/22 DoJa1.5        case 46:
            // J012_2101_0379
            /* with no break */
        case 35:
//2002/08/22 DoJa1.5        case 47:
            // J012_2101_0380
            msg = new String("if visible, NG");
            chrs = msg.toCharArray();
            try {
                if( idx2 == 33 ) {
//2002/08/22 DoJa1.5                if( idx2 == 45 ) {
//2002/09/02 DoJa1.5                    g.drawChars(chrs,0,lH,0,maxInt);
                    g.drawChars(chrs,0,lH,0,chrs.length+1);
                } else if( idx2 == 34 ) {
//2002/08/22 DoJa1.5                } else if( idx2 == 46 ) {
//2002/09/02 DoJa1.5                    g.drawChars(chrs,0,lH,maxInt,chrs.length);
                    g.drawChars(chrs,0,lH,chrs.length+1,0);
                } else {
//2002/09/02 DoJa1.5                    g.drawChars(chrs,0,lH,maxInt,maxInt);
                    g.drawChars(chrs,0,lH,chrs.length,chrs.length);
                }
                showDialog("NG: no Exception");
            } catch( StringIndexOutOfBoundsException iae ) {
                showDialog("OK:StringIndexOutOfBoundsException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 48:
            // J012_2101_0381
//2002/08/22 DoJa1.5            g.setClip(maxInt,0,sW/2,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 49:
            // J012_2101_0382
//2002/08/22 DoJa1.5            g.setClip(0,maxInt,sW/2,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 50:
            // J012_2101_0386
//2002/08/22 DoJa1.5            g.setClip(0,0,maxInt,maxInt);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 51:
            // J012_2101_0387
//2002/08/22 DoJa1.5            g.clipRect(maxInt,0,sW/2,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 52:
            // J012_2101_0388
//2002/08/22 DoJa1.5            g.clipRect(0,maxInt,sW/2,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 53:
            // J012_2101_0392
//2002/08/22 DoJa1.5            g.clipRect(0,0,maxInt,maxInt);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 54:
            // J012_2101_0393
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
//2002/08/22 DoJa1.5            g.fillRect(0,sH/2,sW,sH/2);
//2002/08/22 DoJa1.5            g.copyArea(maxInt,0,sW/2,sH/2,sW/2,sH/2);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 55:
            // J012_2101_0394
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
//2002/08/22 DoJa1.5            g.fillRect(0,sH/2,sW,sH/2);
//2002/08/22 DoJa1.5            g.copyArea(0,maxInt,sW/2,sH/2,sW/2,sH/2);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 56:
            // J012_2101_0398
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
//2002/08/22 DoJa1.5            g.fillRect(0,sH/2,sW,sH/2);
//2002/08/22 DoJa1.5            g.copyArea(sW,sH,maxInt,maxInt,sW/2,sH/2);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 57:
            // J012_2101_03101
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH/2);
//2002/08/22 DoJa1.5            g.setColor(Graphics.getColorOfName(Graphics.BLUE));
//2002/08/22 DoJa1.5            g.fillRect(0,sH/2,sW,sH/2);
//2002/08/22 DoJa1.5            g.copyArea(0,0,sW/2,sH/2,maxInt,maxInt);
//2002/08/22 DoJa1.5            break;
        }
        g.unlock(true);
    }


    /**
     * minimum within the prescribed
     */
    public void test4() {
        int[] xP = new int[5];
        int[] yP = new int[5];
        int r = 40;
        xP[0] = r;
        yP[0] = 0;
        xP[1] = 0;
        yP[1] = -r;
        xP[2] = -r;
        yP[2] = 0;
        xP[3] = 0;
        yP[3] = r;
        for( int i=0; i<4; i++ ) {
            xP[i] += sW/2;
            yP[i] += sH/2;
        }
        xP[4] = xP[0];
        yP[4] = yP[0];

        g.lock();
        switch( idx2 ) {
        case 0:
            // J012_2102_0103
            g.setOrigin(0,0);
            g.drawLine(0,0,20,20);
            g.drawLine(0,0,4,8);
            g.drawLine(0,0,8,4);
            g.drawString("origin",20,20+lH);
            break;
        case 1:
            /* with no break */
        case 2:
            /* with no break */
        case 3:
            /* with no break */
        case 4:
            /* with no break */
            int c =0;
            switch( idx2 ) {
            case 1:
                // J012_2102_0104
                c = g.getColorOfRGB(0,255,255);
                break;
            case 2:
                // J012_2102_0105
                c = g.getColorOfRGB(255,0,255);
                break;
            case 3:
                // J012_2102_0106
                c = g.getColorOfRGB(255,255,0);
                break;
            case 4:
                // J012_2102_0107
                c = g.getColorOfRGB(0,0,0);
                break;
            }
            g.setColor(c);
            g.fillRect(sW/4,sH/4,sW/2,sH/2);
            break;
        case 5:
            // J012_2102_0108
            c = g.getColorOfName(0);
            g.setColor(c);
            g.fillRect(sW/4,sH/4,sW/2,sH/2);
            break;
        case 6:
            // J012_2102_0109
            int c1 = g.getColorOfRGB(0,0,0);
            int c2 = g.getColorOfRGB(255,255,255);
            if( c1 < c2 ) {
                showDialog("minimum value is shown in black");
                g.setColor(c2);
                g.fillRect(0,0,sW,sH);
                g.setColor(c1);
                g.fillRect(sW/4,sH/4,sW/2,sH/2);
            } else {
                showDialog("minimum value is shown in white");
                g.setColor(c1);
                g.fillRect(0,0,sW,sH);
                g.setColor(c2);
                g.fillRect(sW/4,sH/4,sW/2,sH/2);
            }
            break;
        case 7:
            // J012_2102_0110
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(0,0,sW,sH);
            g.clearRect(0,0,0,sH);
            break;
        case 8:
            // J012_2102_0111
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(0,0,sW,sH);
            g.clearRect(0,0,sW,0);
            break;
        case 9:
            // J012_2102_0113
            g.drawRect(1,1,0,sH/2);
            break;
        case 10:
            // J012_2102_0114
            g.drawRect(1,1,sW/2,0);
            break;
        case 11:
            // J012_2102_0116
            g.fillRect(1,1,0,sH/2);
            break;
        case 12:
            // J012_2102_0117
            g.fillRect(1,1,sW/2,0);
            break;
//2002/08/22 DoJa1.5        case 13:
            // J012_2102_0119
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),0,0,0,0,0,mi.getHeight());
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 14:
            // J012_2102_0120
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),0,0,0,0,mi.getWidth(),0);
//2002/08/22 DoJa1.5            break;
        case 13:
//2002/08/22 DoJa1.5        case 15:
            // J012_2102_0122
            try {
                g.drawPolyline(xP,yP,0);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 16:
            // J012_2102_0123
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(xP,yP,0,5);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 17:
            // J012_2102_0124
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(xP,yP,1,0);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 18:
            // J012_2102_0125
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(xP,yP,0,0);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 14:
//2002/08/22 DoJa1.5        case 19:
            // J012_2102_0126
            try {
                g.fillPolygon(xP,yP,3);
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 20:
            // J012_2102_0127
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,0,5);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 21:
            // J012_2102_0128
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,0,3);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 22:
            // J012_2102_0129
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.setClip(0,0,0,sH);
//2002/08/22 DoJa1.5                g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 23:
            // J012_2102_0130
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.setClip(0,0,sW,0);
//2002/08/22 DoJa1.5                g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 24:
            // J012_2102_0132
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.clipRect(0,0,0,sH);
//2002/08/22 DoJa1.5                g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 25:
            // J012_2102_0133
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.clipRect(0,0,sW,0);
//2002/08/22 DoJa1.5                g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 26:
            // J012_2102_0135
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5                g.fillRect(0,0,sW/2,sH/2);
//2002/08/22 DoJa1.5                g.copyArea(0,0,0,sH/2,sW/2,sH/2);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 27:
            // J012_2102_0136
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5                g.fillRect(0,0,sW/2,sH/2);
//2002/08/22 DoJa1.5                g.copyArea(0,0,sW/2,0,sW/2,sH/2);
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        }
        g.unlock(true);
    }

    /**
     * the minimum -1 whithin the prescribed
     */
    public void test5() {
        int[] xP = new int[5];
        int[] yP = new int[5];
        int r = 40;
        xP[0] = r;
        yP[0] = 0;
        xP[1] = 0;
        yP[1] = -r;
        xP[2] = -r;
        yP[2] = 0;
        xP[3] = 0;
        yP[3] = r;
        for( int i=0; i<4; i++ ) {
            xP[i] += sW/2;
            yP[i] += sH/2;
        }
        xP[4] = xP[0];
        yP[4] = yP[0];

        g.lock();
        switch( idx2 ) {
        case 0:
            // J012_2102_0203
            g.setOrigin(-4,-4);
            g.drawLine(0,0,20,20);
            g.drawLine(0,0,4,8);
            g.drawLine(0,0,8,4);
            g.drawString("origin",20,20+lH);
            break;
        case 1:
            /* with no break */
        case 2:
            /* with no break */
        case 3:
            /* with no break */
            try {
                switch( idx2 ) {
                case 1:
                    // J012_2102_0204
                    g.getColorOfRGB(-1,0,0);
                    break;
                case 2:
                    // J012_2102_0205
                    g.getColorOfRGB(0,-1,0);
                    break;
                case 3:
                    // J012_2102_0206
                    g.getColorOfRGB(0,0,-1);
                    break;
                }
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 4:
            // J012_2102_0208
            try {
                int c = g.getColorOfName(-1);
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 5:
            // J012_2102_0209
            int c1 = g.getColorOfRGB(0,0,0);
            int c2 = g.getColorOfRGB(255,255,255);
            try {
                if( c1 > c2 ) {
                    c1 = c2;
                }
                g.setColor(c1-1);
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 6:
            /* with no break */
        case 7:
            try {
                switch( idx2 ) {
                case 6:
                    // J012_2102_0210
                    g.clearRect(0,0,-1,sH);
                    break;
                case 7:
                    // J012_2102_0211
                    g.clearRect(0,0,sW,-1);
                    break;
                }
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 8:
            /* with no break */
        case 9:
            try {
                switch( idx2 ) {
                case 8:
                    // J012_2102_0213
                    g.drawRect(0,0,-1,sH);
                    break;
                case 9:
                    // J012_2102_0214
                    g.drawRect(0,0,sW,-1);
                    break;
                }
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 10:
            /* with no break */
        case 11:
            try {
                switch( idx2 ) {
                case 10:
                    // J012_2102_0216
                    g.fillRect(0,0,-1,sH);
                    break;
                case 11:
                    // J012_2102_0217
                    g.fillRect(0,0,sW,-1);
                    break;
                }
            } catch( IllegalArgumentException iae ) {
                showDialog("OK:IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 12:
            /* with no break */
//2002/08/22 DoJa1.5        case 13:
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                switch( idx2 ) {
//2002/08/22 DoJa1.5                case 12:
                    // J012_2102_0219
//2002/08/22 DoJa1.5                    g.drawImage(mi.getImage(),0,0,0,0,-1,sH);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                case 13:
                    // J012_2102_0220
//2002/08/22 DoJa1.5                    g.drawImage(mi.getImage(),0,0,0,0,sW,-1);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                }
//2002/08/22 DoJa1.5            } catch( IllegalArgumentException iae ) {
//2002/08/22 DoJa1.5                showDialog("OK:IllegalArgumentException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 12:
//2002/08/22 DoJa1.5        case 14:
            /* with no break */
//2002/08/22 DoJa1.5        case 15:
            /* with no break */
//2002/08/22 DoJa1.5        case 16:
            try {
//2002/08/22 DoJa1.5                switch( idx2 ) {
//2002/08/22 DoJa1.5                case 14:
                    // J012_2102_0222
                    g.drawPolyline(xP,yP,-1);
                    break;
//2002/08/22 DoJa1.5                case 15:
                    // J012_2102_0223
//2002/08/22 DoJa1.5                    g.drawPolyline(xP,yP,-1,4);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                case 16:
                    // J012_2102_0224
//2002/08/22 DoJa1.5                    g.drawPolyline(xP,yP,0,-1);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                }
            } catch( ArrayIndexOutOfBoundsException iae ) {
                showDialog("OK:ArrayIndexOutOfBoundsException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 13:
//2002/08/22 DoJa1.5        case 17:
            // J012_2102_0226
            g.fillPolygon(xP,yP,2);
            break;
//2002/08/22 DoJa1.5        case 18:
            // J012_2102_0227
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,yP,-1,4);
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException iae ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 19:
            // J012_2102_0228
//2002/08/22 DoJa1.5            g.fillPolygon(xP,yP,0,2);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 20:
            /* with no break */
//2002/08/22 DoJa1.5        case 21:
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                switch( idx2 ) {
//2002/08/22 DoJa1.5                case 20:
                    // J012_2102_0229
//2002/08/22 DoJa1.5                    g.setClip(0,0,-1,sH);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                case 21:
                    // J012_2102_0230
//2002/08/22 DoJa1.5                    g.setClip(0,0,sW,-1);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                }
//2002/08/22 DoJa1.5            } catch( IllegalArgumentException iae ) {
//2002/08/22 DoJa1.5                showDialog("OK:IllegalArgumentException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 22:
            /* with no break */
//2002/08/22 DoJa1.5        case 23:
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                switch( idx2 ) {
//2002/08/22 DoJa1.5                case 22:
                    // J012_2102_0232
//2002/08/22 DoJa1.5                    g.clipRect(0,0,-1,sH);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                case 23:
                    // J012_2102_0233
//2002/08/22 DoJa1.5                    g.clipRect(0,0,sW,-1);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                }
//2002/08/22 DoJa1.5            } catch( IllegalArgumentException iae ) {
//2002/08/22 DoJa1.5                showDialog("OK:IllegalArgumentException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 24:
            /* with no break */
//2002/08/22 DoJa1.5        case 25:
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                switch( idx2 ) {
//2002/08/22 DoJa1.5                case 24:
                    // J012_2102_0235
//2002/08/22 DoJa1.5                    g.copyArea(0,0,-1,sH,0,0);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                case 25:
                    // J012_2102_0236
//2002/08/22 DoJa1.5                    g.copyArea(0,0,sW,-1,0,0);
//2002/08/22 DoJa1.5                    break;
//2002/08/22 DoJa1.5                }
//2002/08/22 DoJa1.5            } catch( IllegalArgumentException iae ) {
//2002/08/22 DoJa1.5                showDialog("OK:IllegalArgumentException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        }
        g.unlock(true);
    }

    /**
     * the minimum out of the prescribed
     */
    public void test6() {
        int[] xP = new int[5];
        int[] yP = new int[5];
        xP[0] = 0;
        yP[0] = 0;
        xP[1] = sW/4;
        yP[1] = sH*3/4;
        xP[2] = sW;
        yP[2] = sH;
        xP[3] = sW*3/4;
        yP[3] = sH/4;
        xP[4] = xP[0];
        yP[4] = yP[0];

        g.lock();
        switch( idx2 ) {
        case 0:
            // J012_2102_0310
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(0,0,sW,sH);
            g.clearRect(0,sH/2,sW,sH);
            break;
        case 1:
            // J012_2102_0311
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(0,0,sW,sH);
            g.clearRect(sW/2,0,sW,sH);
            break;
        case 2:
            // J012_2102_0319
            g.drawLine(0,0,sW,sH);
            break;
        case 3:
            // J012_2102_0322
            g.drawLine(sW,sH,0,0);
            break;
        case 4:
            // J012_2102_0323
            g.drawLine(0,0,0,0);
            break;
        case 5:
            // J012_2102_0324
            g.drawRect(0,sH/2,sW/2-1,sH/2-1);
            break;
        case 6:
            // J012_2102_0325
            g.drawRect(sW/2,0,sW/2-1,sH/2-1);
            break;
        case 7:
            // J012_2102_0331
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(0,sH/2,sW/2,sH/2);
            break;
        case 8:
            // J012_2102_0332
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(sW/2,0,sW/2,sH/2);
            break;
        case 9:
            // J012_2102_0338
            g.drawImage(mi.getImage(),0,sH/2);
            break;
        case 10:
            // J012_2102_0339
            g.drawImage(mi.getImage(),sW/2,0);
            break;
//2002/08/22 DoJa1.5        case 11:
//2002/08/22 DoJa1.5            // J012_2102_0343
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),0,0,0,0,mi.getWidth(),mi.getHeight());
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 12:
            // J012_2102_0347
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),sW/2,sH/2,0,0,mi.getWidth(),mi.getHeight());
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 13:
            // J012_2102_0350
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),0,0,0,0,0,0);
//2002/08/22 DoJa1.5            break;
        case 11:
//2002/08/22 DoJa1.5        case 14:
            // J012_2102_0353
            g.drawPolyline(xP,yP,5);
            break;
//2002/08/22 DoJa1.5        case 15:
            // J012_2102_0357
//2002/08/22 DoJa1.5            g.drawPolyline(xP,yP,0,5);
//2002/08/22 DoJa1.5            break;
        case 12:
//2002/08/22 DoJa1.5        case 16:
            // J012_2102_0363
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillPolygon(xP,yP,5);
            break;
        case 13:
//2002/08/22 DoJa1.5        case 17:
            // J012_2102_0364
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillPolygon(xP,yP,0);
            break;
//2002/08/22 DoJa1.5        case 18:
            // J012_2102_0367
            /* with no break */
//2002/08/22 DoJa1.5        case 19:
            // J012_2102_0368
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillPolygon(xP,yP,0,5);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 20:
            // J012_2102_0370
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillPolygon(xP,yP,0,0);
//2002/08/22 DoJa1.5            break;
        case 14:
//2002/08/22 DoJa1.5        case 21:
            // J012_2102_0371
            g.drawString("",sW/2,sH/2);
            break;
        case 15:
//2002/08/22 DoJa1.5        case 22:
            // J012_2102_0372
            g.drawString("String",0,sH/2);
            break;
        case 16:
//2002/08/22 DoJa1.5        case 23:
            // J012_2102_0373
            g.drawString("String",sW/2,0);
            break;
        case 17:
//2002/08/22 DoJa1.5        case 24:
            // J012_2102_0375
            String msg = new String("");
            char[] chrs = msg.toCharArray();
            g.drawChars(chrs,sW/2,sH/2,0,chrs.length);
            break;
        case 18:
//2002/08/22 DoJa1.5        case 25:
            // J012_2102_0376
            /* with no break */
        case 19:
//2002/08/22 DoJa1.5        case 26:
            // J012_2102_0377
            /* with no break */
        case 20:
//2002/08/22 DoJa1.5        case 27:
            // J012_2102_0379
            /* with no break */
        case 21:
//2002/08/22 DoJa1.5        case 28:
            // J012_2102_0380
            msg = new String("drawChars");
            chrs = msg.toCharArray();
            if( idx2 == 18 ) {
//2002/08/22 DoJa1.5            if( idx2 == 25 ) {
                g.drawChars(chrs,0,sH/2,0,chrs.length);
            } else if( idx2 == 19 ) {
//2002/08/22 DoJa1.5            } else if( idx2 == 26 ) {
                g.drawChars(chrs,sW/2,0,0,chrs.length);
            } else if( idx2 == 20 ) {
//2002/08/22 DoJa1.5            } else if( idx2 == 27 ) {
                g.drawChars(chrs,sW/2,sH/2,0,0);
            } else if( idx2 == 21 ) {
//2002/08/22 DoJa1.5            } else if( idx2 == 28 ) {
                g.drawChars(chrs,0,sH/2,0,chrs.length);
            }
            break;
//2002/08/22 DoJa1.5        case 29:
            // J012_2102_0382
            /* with no break */
//2002/08/22 DoJa1.5        case 30:
            // J012_2102_0383
            /* with no break */
//2002/08/22 DoJa1.5        case 31:
            // J012_2102_0388
            /* with no break */
//2002/08/22 DoJa1.5        case 32:
            // J012_2102_0389
//2002/08/22 DoJa1.5            switch( idx2 ) {
//2002/08/22 DoJa1.5            case 29:
//2002/08/22 DoJa1.5                g.setClip(0,sH/2,sW/2,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 30:
//2002/08/22 DoJa1.5                g.setClip(sW/2,0,sW/2,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 31:
//2002/08/22 DoJa1.5                g.clipRect(0,sH/2,sW/2,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 32:
//2002/08/22 DoJa1.5                g.clipRect(sW/2,0,sW/2,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 33:
            // J012_2102_0394
            /* with no break */
//2002/08/22 DoJa1.5        case 34:
            // J012_2102_0395
            /* with no break */
//2002/08/22 DoJa1.5        case 35:
            // J012_2102_03100
            /* with no break */
//2002/08/22 DoJa1.5        case 36:
            // J012_2102_03101
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW/2,sH/2);
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.BLUE));
//2002/08/22 DoJa1.5            g.fillRect(sW/2,0,sW/2,sH/2);
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.WHITE));
//2002/08/22 DoJa1.5            g.fillRect(0,sH/2,sW,sH/2);
//2002/08/22 DoJa1.5            switch( idx2 ) {
//2002/08/22 DoJa1.5            case 33:
//2002/08/22 DoJa1.5                g.copyArea(0,0,sW/2,sH/2,sW/2,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 34:
//2002/08/22 DoJa1.5                g.copyArea(sW/2,0,sW/2,sH/2,-sW/2,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 35:
//2002/08/22 DoJa1.5                g.copyArea(0,0,sW/2,sH/2,0,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 36:
//2002/08/22 DoJa1.5                g.copyArea(0,0,sW/2,sH/2,sW/2,0);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        }
        g.unlock(true);
    }

    /**
     * parameter -1
     */
    public void test7() {
        int[] xP = new int[5];
        int[] yP = new int[5];
        xP[0] = 0;
        yP[0] = 0;
        xP[1] = sW/4;
        yP[1] = sH*3/4;
        xP[2] = sW;
        yP[2] = sH;
        xP[3] = sW*3/4;
        yP[3] = sH/4;
        xP[4] = xP[0];
        yP[4] = yP[0];
        String  str = new String("String");
        char[]  chr;

        g.lock();
        switch( idx2 ) {
        case 0:
            // J012_2103_0110
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(0,0,sW,sH);
            g.clearRect(-10,sH/2,sW,sH/2);
            break;
        case 1:
            // J012_2103_0111
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(0,0,sW,sH);
            g.clearRect(sW/2,-10,sW/2,sH);
            break;
        case 2:
            // J012_2103_0119
            g.drawLine(-30,-10,sW,sH);
            break;
        case 3:
            // J012_2103_0122
            g.drawLine(sW,sH,-30,-10);
            break;
        case 4:
            // J012_2103_0123
            g.drawLine(-1,-1,-1,-1);
            break;
        case 5:
            // J012_2103_0124
            g.drawRect(-10,sH/4,sW,sH/2);
            break;
        case 6:
            // J012_2103_0125
            g.drawRect(sW/4,-10,sW/2,sH);
            break;
        case 7:
            // J012_2103_0131
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(-10,sH/4,sW,sH/2);
            break;
        case 8:
            // J012_2103_0132
            g.setColor(g.getColorOfName(g.GREEN));
            g.fillRect(sW/4,-10,sW/2,sH);
            break;
        case 9:
            // J012_2103_0138
            g.drawImage(mi.getImage(),-30,0);
            break;
        case 10:
            // J012_2103_0139
            g.drawImage(mi.getImage(),0,-30);
            break;
//2002/08/22 DoJa1.5        case 11:
            // J012_2103_0143
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),-30,-30,0,0,mi.getWidth(),mi.getHeight());
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 12:
            // J012_2103_0146
//2002/08/22 DoJa1.5            g.drawImage(mi.getImage(),10,10,-30,-30,mi.getWidth(),mi.getHeight());
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 13:
            // J012_2103_0150
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawImage(mi.getImage(),-1,-1,-1,-1,-1,-1);
//2002/08/22 DoJa1.5            } catch( IllegalArgumentException iae ) {
//2002/08/22 DoJa1.5                showDialog("OK:IllegalArgumentException");
//2002/08/22 DoJa1.5            } catch ( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 14:
            // J012_2103_0157
            /* with no break */
//2002/08/22 DoJa1.5        case 15:
            // J012_2103_0158
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                if( idx2 == 14 ) {
//2002/08/22 DoJa1.5                    g.fillPolygon(xP,yP,0,-1);
//2002/08/22 DoJa1.5                } else {
//2002/08/22 DoJa1.5                    g.fillPolygon(xP,yP,-1,-1);
//2002/08/22 DoJa1.5                }
//2002/08/22 DoJa1.5            } catch( ArrayIndexOutOfBoundsException aobe ) {
//2002/08/22 DoJa1.5                showDialog("OK:ArrayIndexOutOfBoundsException");
//2002/08/22 DoJa1.5            } catch ( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 11:
//2002/08/22 DoJa1.5        case 16:
            // J012_2103_0159
            g.drawString(str,-10,sH/2);
            break;
        case 12:
//2002/08/22 DoJa1.5        case 17:
            // J012_2103_0160
            g.drawString(str,10,-5);
            break;
        case 13:
//2002/08/22 DoJa1.5        case 18:
            // J012_2103_0162
            str = new String("drawChars");
            chr = str.toCharArray();
            g.drawChars(chr,-10,sH/2,0,chr.length);
            break;
        case 14:
//2002/08/22 DoJa1.5        case 19:
            // J012_2103_0163
            str = new String("drawChars");
            chr = str.toCharArray();
            g.drawChars(chr,10,-5,0,chr.length);
            break;
        case 15:
//2002/08/22 DoJa1.5        case 20:
            // J012_2103_0165
            /* with no break */
        case 16:
//2002/08/22 DoJa1.5        case 21:
            // J012_2103_0166
            chr = str.toCharArray();
            try {
                if( idx2 == 15 ) {
//2002/08/22 DoJa1.5                if( idx2 == 20 ) {
                    g.drawChars(chr,10,sH/2,0,-1);
                } else {
                    g.drawChars(chr,10,sH/2,-1,chr.length);
                }
            } catch( StringIndexOutOfBoundsException aobe ) {
                showDialog("OK:StringIndexOutOfBoundsException");
            } catch ( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 22:
            // J012_2103_0168
//2002/08/22 DoJa1.5            g.setClip(-10,0,sW,sH);
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 23:
            // J012_2103_0169
//2002/08/22 DoJa1.5            g.setClip(0,-10,sW,sH);
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 24:
            // J012_2103_0174
//2002/08/22 DoJa1.5            g.clipRect(-10,0,sW,sH);
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 25:
            // J012_2103_0175
//2002/08/22 DoJa1.5            g.clipRect(0,-10,sW,sH);
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW,sH);
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 26:
            // J012_2103_0180
            /* with no break */
//2002/08/22 DoJa1.5        case 27:
            // J012_2103_0181
            /* with no break */
//2002/08/22 DoJa1.5        case 28:
            // J012_2103_0186
            /* with no break */
//2002/08/22 DoJa1.5        case 29:
            // J012_2103_0187
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.GREEN));
//2002/08/22 DoJa1.5            g.fillRect(0,0,sW/2,sH/2);
//2002/08/22 DoJa1.5            g.setColor(g.getColorOfName(g.BLUE));
//2002/08/22 DoJa1.5            g.fillRect(sW/2,0,sW/2,sH/2);
//2002/08/22 DoJa1.5            switch( idx2 ) {
//2002/08/22 DoJa1.5            case 26:
//2002/08/22 DoJa1.5                g.copyArea(-10,0,sW/2,sH/2,10,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 27:
//2002/08/22 DoJa1.5                g.copyArea(sW/2,-10,sW/2,sH/2,0,sH/2+10);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 28:
//2002/08/22 DoJa1.5                g.copyArea(0,0,sW/2,sH/2,-10,sH/2);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            case 29:
//2002/08/22 DoJa1.5                g.copyArea(0,sH/2,sW/2,sH/2,0,-10);
//2002/08/22 DoJa1.5                break;
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/28 DoJa1.5
            // J012_2103_0155
        case 17:
            try {
                g.fillPolygon(xP,yP,-1);
            } catch( ArrayIndexOutOfBoundsException aobe ) {
                showDialog("OK:ArrayIndexOutOfBoundsException");
            } catch ( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        }
        g.unlock(true);
    }

    /**
     * parameter null
     */
    public void test8() {
        int[] xP = new int[5];
        int[] yP = new int[5];
        xP[0] = 0;
        yP[0] = 0;
        xP[1] = sW/4;
        yP[1] = sH*3/4;
        xP[2] = sW;
        yP[2] = sH;
        xP[3] = sW*3/4;
        yP[3] = sH/4;
        xP[4] = xP[0];
        yP[4] = yP[0];

        g.lock();
        switch( idx2 ) {
        case 0:
            // J012_2104_0101
            try {
                g.setFont(null);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 1:
            // J012_2104_0102
            try {
                g.drawImage(null,0,0);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 2:
            // J012_2104_0103
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawImage(null,0,0,0,0,10,10);
//2002/08/22 DoJa1.5            } catch( NullPointerException npe ) {
//2002/08/22 DoJa1.5                showDialog("OK:NullPointerException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 2:
//2002/08/22 DoJa1.5        case 3:
            // J012_2104_0104
            try {
                g.drawPolyline(null,yP,5);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 3:
//2002/08/22 DoJa1.5        case 4:
            // J012_2104_0105
            try {
                g.drawPolyline(xP,null,5);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 5:
            // J012_2104_0107
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(null,yP,0,5);
//2002/08/22 DoJa1.5            } catch( NullPointerException npe ) {
//2002/08/22 DoJa1.5                showDialog("OK:NullPointerException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 6:
            // J012_2104_0108
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.drawPolyline(xP,null,0,5);
//2002/08/22 DoJa1.5            } catch( NullPointerException npe ) {
//2002/08/22 DoJa1.5                showDialog("OK:NullPointerException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 4:
//2002/08/22 DoJa1.5        case 7:
            // J012_2104_0110
            try {
                g.fillPolygon(null,yP,5);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 5:
//2002/08/22 DoJa1.5        case 8:
            // J012_2104_0111
            try {
                g.fillPolygon(xP,null,5);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
//2002/08/22 DoJa1.5        case 9:
            // J012_2104_0113
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(null,yP,0,5);
//2002/08/22 DoJa1.5            } catch( NullPointerException npe ) {
//2002/08/22 DoJa1.5                showDialog("OK:NullPointerException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
//2002/08/22 DoJa1.5        case 10:
            // J012_2104_0114
//2002/08/22 DoJa1.5            try {
//2002/08/22 DoJa1.5                g.fillPolygon(xP,null,0,5);
//2002/08/22 DoJa1.5            } catch( NullPointerException npe ) {
//2002/08/22 DoJa1.5                showDialog("OK:NullPointerException");
//2002/08/22 DoJa1.5            } catch( Exception e ) {
//2002/08/22 DoJa1.5                showDialog("NG:" + e.toString());
//2002/08/22 DoJa1.5            }
//2002/08/22 DoJa1.5            break;
        case 6:
//2002/08/22 DoJa1.5        case 11:
            // J012_2104_0116
            try {
                g.drawString(null,0,0);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        case 7:
//2002/08/22 DoJa1.5        case 12:
            // J012_2104_0117
            try {
                g.drawChars(null,0,0,0,0);
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
            break;
        }
        g.unlock(true);
    }

}
