/**
 * J012_2601_0101
 * MainPanel
 *
 * ImageLabel class boundary test
 *
 * $Id: J012_2601_0101.java,v 1.2 2001/12/01 04:54:58 lan Exp $
 */

import com.nttdocomo.lang.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * ImageLabel class boundary test main class
 * @extends IApplication
 */
public class J012_2601_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * ImageLabel class boundary test main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.the argument's maximum value",
        "2.parameter maximum +1",
        "3.non-prescribed maximum value",
        "4.parameter minimum",
        "5.parameter minimum -1",
        "6.minimum within the prescribed",
        "7.parameter -1",
        "8.parameter null"
    };
    String[][] subItems = {
        /* 1.the argument's maximum value */
        {
            "1.setBackground(max)",
            "2.setForeground(max)",
            "3.setLocation(x=max)",
            "4.setLocation(y=max)",
            "5.setLocation(max,max)",
            "6.setSize(w=max)",
            "7.setSize(h=max)",
            "8.setSize(max,max)"
        },
        /* 2.parameter maximum +1 */
        {
            "1.setBackground(max+1)",
            "2.setForeground(max+1)",
            "3.setLocation(x=max+1)",
            "4.setLocation(y=max+1)",
            "5.setLocation(max+1,max+1)",
            "6.setSize(w=max+1)",
            "7.setSize(h=max+1)",
            "8.setSize(max+1,max+1)"
        },
        /* 3.non-prescribed maximum value */
        {
            "1.setBackground(MaxInt)",
            "2.setForeground(MaxInt)",
            "3.setLocation(x=MaxInt)",
            "4.setLocation(y=MaxInt)",
            "5.setLocation(MaxInt,MaxInt)",
            "6.setSize(w=MaxInt)",
            "7.setSize(h=MaxInt)",
            "8.setSize(MaxInt,MaxInt)"
        },
        /* 4.parameter minimum */
        {
            "1.setBackground(min)",
            "2.setForeground(min)",
            "3.setSize(w=min)",
            "4.setSize(h=min)",
            "5.setSize(min,min)"
        },
        /* 5.parameter minimum -1 */
        {
            "1.setBackground(min-1)",
            "2.setForeground(min-1)",
            "3.setSize(w=-1)",
            "4.setSize(h=-1)",
            "5.setSize(-1,-1)"
        },
        /* 6.minimum within the prescribed */
        {
            "1.setLocation(x=0)",
            "2.setLocation(y=0)",
            "3.setLocation(0,0)",
        },
        /* 7.parameter -1 */
        {
            "1.setLocation(x=-1)",
            "2.setLocation(y=-1)",
            "3.setLocation(-1,-1)"
        },
        /* 8.parameter null */
        {
            "1.ImageLabel(null)",
            "2.setImage(null)"
        }
    };

    Label   classLabel       = new Label("ImageLabel boundary test");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    ImageLabel imageL            = new ImageLabel();
    MediaImage  mi           = null;
    String  filename         = new String("89aT-8.gif");
    int     maxInt           = 0x7FFFFFFF;
    int     sH;
    int     sW;
    boolean sizeFlag         = false;
    ImageLabel testObj       = new ImageLabel();
    Ticker left              = new Ticker("LEFT");
    Ticker right             = new Ticker("RIGHT");
    Ticker top               = new Ticker("TOP");
    Ticker bottom            = new Ticker("BOTTOM");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* get the size of the screen */
        sH = getHeight();
        sW = getWidth();

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(sW,execButton.getHeight());
        add(execButton);
        add(imageL);

        /* display initial animation */
        try {
            mi = MediaManager.getImage("resource:///"+filename);
            mi.use();
            imageL.setImage(mi.getImage());
            imageL.setSize(mi.getWidth()+10,mi.getHeight()+10);
            int c = Graphics.getColorOfName(Graphics.BLUE);
            imageL.setBackground(c);
        } catch (Exception e) {
            mi = null;
            showDialog("ImageLabel unable to continue:"+e.toString());
        }

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }


    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            switch( menuList.getSelectedIndex() ) {
                case 0:
                    /* behavior in case of the maximum parameter */
                    test1();
                    break;
                case 1:
                    /* parameter maximum +1 */
                    test2();
                    break;
                case 2:
                    /* maximum parameter within the prescribed */
                    test3();
                    break;
                case 3:
                    /* parameter minimum */
                    test4();
                    break;
                case 4:
                    /* parameter minimum -1 */
                    test5();
                    break;
                case 5:
                    /* minimum parameter out of the prescribed */
                    test6();
                    break;
                case 6:
                    /* behavior in case of the parameter -1 */
                    test7();
                    break;
                case 7:
                    /* behavior in case of the parameter null */
                    test8();
                    break;
            }
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * behavior in case of the maximum parameter
     */
    public void test1() {
        int idx = menuList2.getSelectedIndex();

        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_2601_0101
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        imageL.setBackground(c1);
                        imageL.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        imageL.setBackground(c2);
                        imageL.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_2601_0102
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        imageL.setBackground(c2);
                        imageL.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        imageL.setBackground(c1);
                        imageL.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_2601_0103
                setLayoutManager(null);
                try {
                    imageL.setLocation(sW,imageL.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_2601_0104
                setLayoutManager(null);
                try {
                    imageL.setLocation(imageL.getX(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_2601_0105
                setLayoutManager(null);
                try {
                    imageL.setLocation(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_2601_0106
                try {
                    imageL.setSize(sW,imageL.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_2601_0107
                try {
                    imageL.setSize(imageL.getWidth(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_2601_0108
                try {
                    imageL.setSize(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter +1
     */
    public void test2() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_2601_0201
                /* with no break */
            case 1:
                // J012_2601_0202
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 < c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 0 ) {
                        imageL.setBackground(c1+1);
                    } else {
                        imageL.setForeground(c1+1);
                    }
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_2601_0203
                setLayoutManager(null);
                try {
                    imageL.setLocation(sW+1,imageL.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_2601_0204
                setLayoutManager(null);
                try {
                    imageL.setLocation(imageL.getX(),sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_2601_0205
                setLayoutManager(null);
                try {
                    imageL.setLocation(sW+1,sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_2601_0206
                try {
                    imageL.setSize(sW+10,imageL.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_2601_0207
                try {
                    imageL.setSize(imageL.getWidth(),sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_2601_0208
                try {
                    imageL.setSize(sW+10,sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter out of the prescribed
     */
    public void test3() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_2601_0301
                /* with no break */
            case 1:
                // J012_2601_0302
                try {
                    if( idx == 0 ) {
                        imageL.setBackground(maxInt);
                    } else {
                        imageL.setForeground(maxInt);
                    }
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_2601_0303
                setLayoutManager(null);
                try {
                    imageL.setLocation(maxInt,imageL.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_2601_0304
                setLayoutManager(null);
                try {
                    imageL.setLocation(imageL.getX(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_2601_0305
                setLayoutManager(null);
                try {
                    imageL.setLocation(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_2601_0306
                try {
                    imageL.setSize(maxInt,imageL.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_2601_0307
                try {
                    imageL.setSize(imageL.getWidth(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_2601_0308
                try {
                    imageL.setSize(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter
     */
    public void test4() {
        int idx = menuList2.getSelectedIndex();

        if( sizeFlag == false && idx >= 2 && idx <= 4 ) {
            imageL.setSize(imageL.getWidth(),0);
            top.setSize(sW,top.getHeight());
            bottom.setSize(sW,bottom.getHeight());
            left.setSize(sW/3,left.getHeight());
            right.setSize(sW/3,right.getHeight());
            testObj.setSize(sW/4,testObj.getHeight());
            add(top);
            add(left);
            add(testObj);
            add(right);
            add(bottom);
            sizeFlag = true;
            if( mi != null ) {
                testObj.setImage(mi.getImage());
            }
            showDialog("Please press the \"execute\" button again");
            return;
        }

        if( sizeFlag == true && idx >= 2 && idx <= 4 ) {
            left.setSize(left.getWidth(),3);
            right.setSize(right.getWidth(),3);
        }

        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_2602_0101
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        imageL.setBackground(c1);
                        imageL.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        imageL.setBackground(c2);
                        imageL.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_2602_0102
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        imageL.setBackground(c2);
                        imageL.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        imageL.setBackground(c1);
                        imageL.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_2602_0103
                try {
                    testObj.setSize(0,testObj.getHeight());
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_2602_0104
                try {
                    testObj.setSize(testObj.getWidth(),0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_2602_0105
                try {
                    testObj.setSize(0,0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter -1
     */
    public void test5() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_2602_0201
                /* with no break */
            case 1:
                // J012_2602_0202
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 > c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 0 ) {
                        imageL.setBackground(c1-1);
                    } else {
                        imageL.setForeground(c1-1);
                    }
                    showDialog("NG: no Excepption");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_2602_0203
                try {
                    imageL.setSize(-1,imageL.getHeight());
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_2602_0204
                try {
                    imageL.setSize(imageL.getWidth(),-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_2602_0205
                try {
                    imageL.setSize(-1,-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum out of the prescribed
     */
    public void test6() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_2602_0303
                setLayoutManager(null);
                try {
                    imageL.setLocation(0,imageL.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_2602_0304
                setLayoutManager(null);
                try {
                    imageL.setLocation(imageL.getX(),0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_2602_0305
                setLayoutManager(null);
                try {
                    imageL.setLocation(0,0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter -1
     */
    public void test7() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_2603_0103
                setLayoutManager(null);
                try {
                    imageL.setLocation(-20,imageL.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_2603_0104
                setLayoutManager(null);
                try {
                    imageL.setLocation(imageL.getX(),-20);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_2603_0105
                setLayoutManager(null);
                try {
                    imageL.setLocation(-20,-20);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter null
     */
    public void test8() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_2604_0101
                try {
                    ImageLabel il = new ImageLabel(null);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("OK:NullPointerException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_2604_0102
                try {
                    imageL.setImage(null);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("OK:NullPointerException");
                } catch( UnsupportedOperationException uoe ) {
                    showDialog("UnsupportedOperationException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }
}
