/**
 * J012_2901_0101.java
 * 
 * J012_2901_0101
 * MenuPanel
 * TestPanel
 * 
 * Label class behavior checking (boundary test)
 * 
 * $Id: J012_2901_0101.java,v 1.2 2001/12/02 05:18:02 waka Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Label class action check main class
 * @extends IApplication
 */
public class J012_2901_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * TextBox class boundary test menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

               /* selection processing  menu */
    Button execButton = null;                /* execution button */
    int maxColor;                            /* the maximum value of terminal color */
    protected int maxInt = 0x7FFFFFFF;       /* the maximum of int */

    /* processing selection menu item() */
   TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);

   
    /**
     * MenuPanel class constructor
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * menu screen display
     */
    public void showMainPanel() {
        /* menu/sub title display */
        setTitle("API class boundary route");
        Label subTitle = new Label("Label");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* create/add the component */
    
        execButton = new Button("execute");
   
        add(textBox1);
      
        add(execButton);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * behavior checking method. Display message n case of exception checking, otherwise, go to the checking Panel
     * @param  menu1Index index of menu1
     * @param  menu2Index index of menu2
     * @param  menu3Index index of menu3
     */
 
    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * the method which get the maximum color value of cell phone
     */
    void getColorMax() {
        int color0;
        int color255;

        color0 = Graphics.getColorOfRGB(0,0,0);
        color255 = Graphics.getColorOfRGB(255,255,255);

/* debug
        System.out.println(color0);
        System.out.println(color255);
*/

        if ( color0 >= color255 ) {
            maxColor = color0;
        } else {
            maxColor = color255;
        }
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
        public void componentAction(Component aComponent, int aType, int aParam) {

      
        /* when the execution button is pressed, store the 3 kinds of menu indexes to the variable and call the behavior checking method*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
                    
            try {
	        Display.setCurrent(new TestPanel(textBox1.getText(), this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Label class boundary checking screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel extends Panel implements SoftKeyListener, ComponentListener {

    protected int maxInt = 0x7FFFFFFF;  /* the maximum of int */
    Frame previousFrame = null;         /* store the previous screen */
    int menu1Index = 0;
    int menu2Index = 0;
    int menu3Index = 0;                 /* index of the previous screen menu */
    Label subTitle = null;              /* sub title */
    String maxString = null;            /* store the longest character sequence */
    Label[] testLabel = new Label[6];   /* label for checking */
                   /* testing button */
    int maxColor;                       /* the maximum value of terminal color */
    String str;

    /**
     * TestPanel class constructor
     * @param  menu1Index index of menu1
     * @param  menu2Index index of menu2
     * @param  menu3Index index of menu3
     */

    TestPanel(String text, Frame aFrame) {
	        previousFrame = aFrame;
		str = text;
    		showTestPanel();
		test(str);
    	}

    /**
     * behavior checking panel
     */
    void showTestPanel() {
        /* menu/sub title display */
        setTitle("API class boundary route");
        subTitle = new Label("");
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    	
    	 
    }

    /**
     * action checking method
     * @param  menu1Index index of menu1 on the menu screen
     * @param  menu2Index index of menu2 on the menu screen
     * @param  menu3Index index of menu3 on the menu screen
     */
    void test(String str) {


// J012_2901_0101
    
                        subTitle.setText("check the behavior when the value is prescribed maximum 1");

    	subTitle.setSize(getWidth(), subTitle.getHeight());

                        testLabel[0] = new Label(strMax(16), 2);
                        add(testLabel[0]);

                        testLabel[1] = new Label();
                        testLabel[1].setText(strMax(16));
                        add(testLabel[1]);
                        testLabel[1].setAlignment(2);

                        getColorMax();
                        testLabel[2] = new Label("setBackground");
                        testLabel[2].setSize(getWidth(), testLabel[2].getHeight());
                        testLabel[2].setBackground(maxColor);
                        testLabel[2].setForeground(0);
                        testLabel[3] = new Label("setForeground");
                        testLabel[3].setSize(getWidth(), testLabel[3].getHeight());
                        testLabel[3].setForeground(maxColor);
                        testLabel[3].setBackground(0);
             	
                	   testLabel[0].setText(str);
                       testLabel[1].setText(str);
                        add(testLabel[2]);
                        add(testLabel[3]);

                        settingLabel(2);
    
    }
                   
        
    /**
     * create longest String
     * @param  maxStringValue string length which is created
     */
    String strMax(int maxStringValue) {
        int i;
        int j = 0;
        maxString = "";
        for ( i = 0; i < maxStringValue; i++ ) {
            if ( j == 10 ) {
                j = 0;
            }
            maxString = maxString + j;
            j++;
        }
        maxString = maxString;
        return maxString;
    }

    /**
     * the method which get the maximum color value of cell phone
     */
    void getColorMax() {
        int color0;
        int color255;

        color0 = Graphics.getColorOfRGB(0,0,0);
        color255 = Graphics.getColorOfRGB(255,255,255);

/* debug
        System.out.println(color0);
        System.out.println(color255);
*/

        if ( color0 >= color255 ) {
            maxColor = color0;
        } else {
            maxColor = color255;
        }
    }

    /**
     * setting the label color,and the size
     * @param aCount the number of looping
     */
    void settingLabel(int aCount) {
        int i;
        for ( i = 0; i < aCount; i++ ) {
            testLabel[i].setBackground(Graphics.getColorOfName(Graphics.BLACK));
            testLabel[i].setForeground(Graphics.getColorOfName(Graphics.WHITE));
            testLabel[i].setSize(getWidth(),testLabel[i].getHeight());
        }
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {}

}
