/**
 * J012_2901_0107.java
 * 
 * J012_2901_0107
 * MenuPanel
 * TestPanel
 * 
 * Label class behavior checking (boundary test)
 * 
 * $Id: J012_2901_0107.java,v 1.2 2001/12/02 05:18:02 waka Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Label class action check main class
 * @extends IApplication
 */
public class J012_2901_0107 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * TextBox class boundary test menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;
    ListBox menu2 = null;
    ListBox menu3 = null;                    /* selection processing  menu */
    Button execButton = null;                /* execution button */
    int maxColor;                            /* the maximum value of terminal color */
    protected int maxInt = 0x7FFFFFFF;       /* the maximum of int */

    /* processing selection menu item(menu1,menu2,menu3) */
    String[] menu1Item = {
        "0.the argument is prescribed maximum value",
        "1.the argument is prescribed maximum value + 1",
        "2.the argument is non-prescribed maximum value",
        "3.the argument is prescribed minimum value",
        "4.the argument is prescribed minimum value - 1",
        "5.the argument is non-prescribed minimum value",
        "6.the argument is -1",
        "7.the argument is null",
    };

    String[][] menu2Item = {
        /* menu of the maximum parameter within the prescribed */
        {
          
            "1.operation check 2",
            "2.operation check 3",
        },
        /* menu of the maximum parameter +1 within the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
            "2.operation check 3",
            "3.operation check 4",
        },
        /* menu of the maximum parameter out of the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
            "2.operation check 3",
        },
        /* menu of the minimum parameter within the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
        },
        /* menu of the minimum parameter -1 within the prescribed */
        {
            "0.operation check 1",
        },
        /* menu of the minimum parameter out of the prescribed */
        {
            "0.operation check 1",
        },
        /* menu of the parameter -1 */
        {
            "0.operation check 1",
        },
        /* menu of the parameter Null */
        {
            "0.operation check 1",
        },
    };

    String[][][] menu3Item = {
        /* maximum within the prescribed*/
        {
            /* the maximum within the prescribed behavior checking1 */
            {
                "unused",
            },
            /* the maximum within the prescribed behavior checking2 */
            {
                "unused",
            },
            /* the maximum within the prescribed behavior checking3 */
            {
                "unused",
            },
        },
        /* maximum + 1 within the prescribed */
        {
            /* the maximum +1 within the prescribed behavior checking1 */
            {
                "unused",
            },
            /* the maximum +1 within the prescribed behavior checking2 */
            {
                "unused",
            },
            /* the maximum +1 within the prescribed behavior checking3 */
            {
                "unused",
            },
            /* the maximum +1 within the prescribed behavior checking4 */
            {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
            },
        },
        /* maximum out of the prescribed*/
        {
            /* maximum out of the prescribed behavior checking1 */
            {
                "0.check the exception 1",
                "1.check the exception 2",
            },
            /* maximum out of the prescribed behavior checking2 */
            {
                "unused",
            },
            /* maximum out of the prescribed behavior checking3 */
            {
                "unused",
            },
        },
        /* minimum within the prescribed*/
        {
            /* minimum within the prescribed behavior checking1 */
            {
                "unused",
            },
            /* minimum within the prescribed behavior checking2 */
            {
                "unused",
            },
        },
        /* the minimum -1 whithin the prescribed*/
        {
            /* minimum -1 within the prescribed behavior checking1 */
            {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
                "4.check the exception 5",
                "5.check the exception 6",
                "6.check the exception 7",
            },
        },
        /* the minimum out of the prescribed*/
        {
            /* minimum out of the prescribed behavior checking 1 */
            {
                "unused",
            },
        /* minimum out of the prescribed behavior checking 2 */
            {
                "unused",
            },
            /* minimum out of the prescribed behavior checking 3 */
            {
                "unused",
            },
        },
        /* parameter -1*/
        {
            /* parameter -1 behavior checking1 */
            {
                "unused",
            },
            /* parameter -1 behavior checking2 */
            {
                "unused",
            },
            /* parameter -1 behavior checking3 */
            {
                "unused",
            },
        },
        /* parameter Null*/
        {
            /* parameter Null behavior checking1 */
            {
                "unused",
            },
            /* parameter Null behavior checking2 */
            {
                "unused",
            },
            /* parameter Null behavior checking3 */
            {
                "unused",
            },
        },
    };

    /**
     * MenuPanel class constructor
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * menu screen display
     */
    public void showMainPanel() {
        /* menu/sub title display */
        setTitle("API class boundary route");
        Label subTitle = new Label("Label");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* create/add the component */
        menu1 = new ListBox(ListBox.CHOICE, 8);
        menu2 = new ListBox(ListBox.CHOICE, 4);
        menu3 = new ListBox(ListBox.CHOICE, 8);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        menu3.setItems(menu3Item[0][0]);
        add(menu1);
        add(menu2);
        add(menu3);
        add(execButton);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * behavior checking method. Display message n case of exception checking, otherwise, go to the checking Panel
     * @param  menu1Index index of menu1
     * @param  menu2Index index of menu2
     * @param  menu3Index index of menu3
     */
    void test(int menu1Index, int menu2Index, int menu3Index) {

        boolean okFlag = false;
        Label testLabel = null;

/* debug
        System.out.println("menu1:" + menu1Index);
        System.out.println("menu2:" + menu2Index);
        System.out.println("menu3:" + menu3Index);
*/

        /* display dialog in case of exception checking,otherwise,go to the checking screen */
        /* maximum parameter +1 within the prescribed exception checking */
        if ( menu1Index == 1 
             && menu2Index == 3) {
            switch ( menu3Index ) {
// J012_2902_0102
                case 0:
                    okFlag = false;
                    try {
                        testLabel = new Label("", 3);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\"3 is set to alignment");
                    }
                    break;
// J012_2902_0103
                case 1:
                    okFlag = false;
                    try {
                        testLabel = new Label("");
                        testLabel.setAlignment(3);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\"3 is set to alignment");
                    }
                    break;
// J012_2901_0205
                case 2:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setBackground(maxColor + 1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" the value set to the background color excesses supported maximum value.");
                    }
                    break;
// J012_2902_0106
                case 3:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setForeground(maxColor + 1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" the value set to the foreground color excesses supported maximum value.");
                    }
                    break;
            }
            return;
        }
        /* maximum parameter out of the prescribed exception checking */
        if ( menu1Index == 2 
        && menu2Index == 0) {
            switch ( menu3Index ) {
// J012_2901_0301
                case 0:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setBackground(maxInt);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" the value set to the background color is maximum Int value.");
                    }
                    break;
// J012_2901_0302
                case 1:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setForeground(maxColor + 1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" the value set to the foreground color is maximum Int value.");
                    }
                    break;
            }
            return;
        }

        /* parameter -1 within the prescribed exception checking */
        if ( menu1Index == 4 ) {
            switch ( menu3Index ) {
// J012_2902_0201
                case 0:
                    okFlag = false;
                    try {
                        testLabel = new Label("", -1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" -1 is set to alignment");
                    }
                    break;
// J012_2902_0202
                case 1:
                    okFlag = false;
                    try {
                        testLabel = new Label("");
                        testLabel.setAlignment(-1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" -1 is set to alignment");
                    }
                    break;
// J012_2902_0203
                case 2:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setBackground(-1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" -1 is set to the background color.");
                    }
                    break;
// J012_2902_0204
                case 3:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setForeground(-1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" -1 is set to the foreground color.");
                    }
                    break;
// J012_2902_0205
                case 4:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setSize(-1,10);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" -1 is set to the component size X.");
                    }
                    break;
// J012_2902_0206
                case 5:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setSize(10,-1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" -1 is set to the component size Y.");
                    }
                    break;
// J012_2902_0207
                case 6:
                    okFlag = false;
                    try {
                        getColorMax();
                        testLabel = new Label();
                        testLabel.setSize(-1,-1);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IllegalArgumentException:" + iae.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" -1 is set to the component size X, Y.");
                    }
                    break;
            }
            return;
        }

        /* shift to the behavior checking Panel */
        Display.setCurrent(new TestPanel(menu1Index, menu2Index, menu3Index, this));
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * the method which get the maximum color value of cell phone
     */
    void getColorMax() {
        int color0;
        int color255;

        color0 = Graphics.getColorOfRGB(0,0,0);
        color255 = Graphics.getColorOfRGB(255,255,255);

/* debug
        System.out.println(color0);
        System.out.println(color255);
*/

        if ( color0 >= color255 ) {
            maxColor = color0;
        } else {
            maxColor = color255;
        }
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
        public void componentAction(Component aComponent, int aType, int aParam) {

        /* setting the item (menu2 or menu3),when the menulist(menu1 or menu2)is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
                menu3.setItems(menu3Item[menu1.getSelectedIndex()][0]);
            }
            if ( aComponent == menu2 ) {
                menu3.setItems(menu3Item[menu1.getSelectedIndex()][menu2.getSelectedIndex()]);
            }
        }
        /* when the execution button is pressed, store the 3 kinds of menu indexes to the variable and call the behavior checking method*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {

                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();
                int menu3Index = menu3.getSelectedIndex();

                test(menu1Index, menu2Index, menu3Index);

            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Label class boundary checking screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel extends Panel implements SoftKeyListener, ComponentListener {

    protected int maxInt = 0x7FFFFFFF;  /* the maximum of int */
    Frame previousFrame = null;         /* store the previous screen */
    int menu1Index = 0;
    int menu2Index = 0;
    int menu3Index = 0;                 /* index of the previous screen menu */
    Label subTitle = null;              /* sub title */
    String maxString = null;            /* store the longest character sequence */
    Label[] testLabel = new Label[6];   /* label for checking */
    Button testButton1,testButton2,
           testButton3,testButton4,
           testButton5;                 /* testing button */
    int maxColor;                       /* the maximum value of terminal color */

    /**
     * TestPanel class constructor
     * @param  menu1Index index of menu1
     * @param  menu2Index index of menu2
     * @param  menu3Index index of menu3
     */
    TestPanel(int menu1Index, int menu2Index, int menu3Index, Frame aFrame) {
        previousFrame = aFrame;
        menu1Index = menu1Index;
        menu2Index = menu2Index;
        menu3Index = menu3Index;

        try {
            showTestPanel();
            test(menu1Index, menu2Index, menu3Index);
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }

    }

    /**
     * behavior checking panel
     */
    void showTestPanel() {
        /* menu/sub title display */
        setTitle("API class boundary route");
        subTitle = new Label("");
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * action checking method
     * @param  menu1Index index of menu1 on the menu screen
     * @param  menu2Index index of menu2 on the menu screen
     * @param  menu3Index index of menu3 on the menu screen
     */
    void test(int menu1Index, int menu2Index, int menu3Index) {

/* debug
        System.out.println("menu1Index:"+ menu1Index);
        System.out.println("menu2Index:"+ menu2Index);
        System.out.println("menu3Index:"+ menu3Index);
*/

        switch ( menu1Index ) {
            /* maximum within the prescribed */
            case 0:
                switch ( menu2Index ) {
                    case 0:
// J012_2901_0107
// J012_2901_0102
// J012_2901_0103
// J012_2901_0104
// J012_2901_0105
// J012_2901_0106
                     
                 
                        setLayoutManager(null);
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check the behavior when the value is prescribed maximum 2");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("x=max");
                        testButton2 = new Button("y=max");
                        testButton3 = new Button("x,y=max");
                        testButton4 = new Button("initial coordinate");
                        testButton5 = new Button("check the coordinate");

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        settingLabel(1);

// J012_2901_0107 - 
// J012_2901_0109

                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                            /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setLocation(getWidth(),15);
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setLocation(0,getHeight());
//                                        showMsg("height" + getHeight() + "\n width" + getWidth());
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setLocation(getWidth(),getHeight());
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setLocation(0, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("x:" + testLabel[0].getX() + "\ny:" + testLabel[0].getY());
                                    }
                                }
                            }
                        });
                        break;
                    case 1:
                        setLayoutManager(null);

                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("the maximum within the prescribed behavior checking3");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("width");
                        testButton2 = new Button("height");
                        testButton3 = new Button("wid,hei");
                        testButton4 = new Button("initial size");
                        testButton5 = new Button("checking the size");

                        testLabel[0].setSize(50, 15);

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        testLabel[0].setBackground(Graphics.getColorOfName(Graphics.BLACK));
                        testLabel[0].setForeground(Graphics.getColorOfName(Graphics.WHITE));


// J012_2901_0111 -
// J012_2901_0112
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setSize(getWidth(), 15);
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setSize(50, getHeight());
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setSize(getWidth(), getHeight());
                                    	testButton5.setLocation(0,180);
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setSize(50, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("width:" + testLabel[0].getWidth() + "  height:" + testLabel[0].getHeight());
                                    }
                                }
                            
                            }
                        });
                        break;
                }
                break;
            /* maximum + 1 within the prescribed */
            case 1:
                switch ( menu2Index ) {
                    case 0:
                        subTitle.setText("the maximum +1 within the prescribed behavior checking1");
                        subTitle.setSize(getWidth(), subTitle.getHeight());


// J012_2902_0101
                        testLabel[0] = new Label(strMax(17));
                        add(testLabel[0]);

                        testLabel[1] = new Label();
                        testLabel[1].setText(strMax(17));
                        add(testLabel[1]);

                        settingLabel(2);
                        break;
                    case 1:
                        setLayoutManager(null);
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check2 that the argument's value is maximum + 1");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("x=max");
                        testButton2 = new Button("y=max");
                        testButton3 = new Button("x,y=max");
                        testButton4 = new Button("initial coordinate");
                        testButton5 = new Button("check the coordinate");

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(50,55);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        settingLabel(1);

// J012_2902_0107
// J012_2902_0108
// J012_2902_0109
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setLocation(getWidth() + 1,15);
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setLocation(0,getHeight() + 1);
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setLocation(getWidth() + 1, getHeight() + 1);
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setLocation(0, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("x:" + testLabel[0].getX() + "\ny:" + testLabel[0].getY());
                                    }
                                }
                            }
                        });
                        break;
                    case 2:
                        setLayoutManager(null);

                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check3 that the value is prescribed maximum + 1");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("width");
                        testButton2 = new Button("height");
                        testButton3 = new Button("wid,hei");
                        testButton4 = new Button("initial size");
                        testButton5 = new Button("checking the size");

                        settingLabel(1);

                        testLabel[0].setSize(50, 15);

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

// J012_2902_0110
// J012_2902_0111
// J012_2902_0112
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setSize(getWidth() + 1, 15);
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setSize(50, getHeight() + 1);
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setSize(getWidth() + 1, getHeight() + 1);
                                    	testButton5.setLocation(0,180);
                                  
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setSize(50, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("width:" + testLabel[0].getWidth() + "  height:" + testLabel[0].getHeight());
                                    }
                                }
                            
                            }
                        });
                        break;
                }
                break;
            /* maximum out of the prescribed */
            case 2:
                switch ( menu2Index ) {
                    case 1:
                        setLayoutManager(null);
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check that the value is non-prescribed maximum 1");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("x=max");
                        testButton2 = new Button("y=max");
                        testButton3 = new Button("x,y=max");
                        testButton4 = new Button("initial coordinate");
                        testButton5 = new Button("check the coordinate");

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        settingLabel(1);

// J012_2901_0303
// J012_2901_0304
// J012_2901_0305
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setLocation(maxInt, 15);
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setLocation(0, maxInt);
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setLocation(maxInt, maxInt);
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setLocation(0, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("x:" + testLabel[0].getX() + "\ny:" + testLabel[0].getY());
                                    }
                                }
                            }
                        });
                        break;

                    case 2:
                        setLayoutManager(null);

                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check that the value is non-prescribed maximum 2");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("width");
                        testButton2 = new Button("height");
                        testButton3 = new Button("wid,hei");
                        testButton4 = new Button("initial size");
                        testButton5 = new Button("checking the size");

                        testLabel[0].setSize(50, 15);

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        testLabel[0].setBackground(Graphics.getColorOfName(Graphics.BLACK));
                        testLabel[0].setForeground(Graphics.getColorOfName(Graphics.WHITE));

// J012_2901_0306
// J012_2901_0307
// J012_2901_0308
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setSize(maxInt, testLabel[0].getHeight());
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setSize(10, maxInt);
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setSize(maxInt, maxInt);
                                    	testButton5.setLocation(0,180);
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setSize(50, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("width:" + testLabel[0].getWidth() + "  height:" + testLabel[0].getHeight());
                                    }
                                }
                            
                            }
                        });
                        break;
                }
                break;

            /* minimum within the prescribed */
            case 3:
                switch ( menu2Index ) {
                    case 0:
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("minimum within the prescribed behavior checking1");

                        testLabel[0] = new Label("");
                        testLabel[1] = new Label("test label 2", 0);
                        testLabel[2] = new Label("test label 3", 2);
                        testLabel[3] = new Label("test label 4");
                        testLabel[4] = new Label("background");
                        testLabel[5] = new Label("foreground");

                        testLabel[2].setAlignment(0);
                        testLabel[3].setText("");
// J012_2902_0101
// J012_2902_0102
// J012_2902_0103
// J012_2902_0104
// J012_2902_0105
// J012_2902_0106
                        testLabel[4].setBackground(0);
                        testLabel[5].setForeground(0);

                        add(testLabel[0]);
                        add(testLabel[1]);
                        add(testLabel[2]);
                        add(testLabel[3]);
                        add(testLabel[4]);
                        add(testLabel[5]);

                        settingLabel(4);

                        testLabel[4].setSize(getWidth(), testLabel[4].getHeight());
                        testLabel[5].setSize(getWidth(), testLabel[5].getHeight());
                        break;
                    case 1:
                        setLayoutManager(null);

                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("minimum within the prescribed behavior checking2");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("x=min");
                        testButton2 = new Button("y=min");
                        testButton3 = new Button("x,y=min");
                        testButton4 = new Button("initial size");
                        testButton5 = new Button("checking the size");

                        testLabel[0].setSize(50, 15);

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        testLabel[0].setBackground(Graphics.getColorOfName(Graphics.BLACK));
                        testLabel[0].setForeground(Graphics.getColorOfName(Graphics.WHITE));
// J012_2902_0107 -
// J012_2902_0109
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setSize(0, testLabel[0].getHeight());
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setSize(10, 0);
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setSize(0, 0);
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setSize(50, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("x:" + testLabel[0].getWidth() + "  y:" + testLabel[0].getHeight());
                                    }
                                }
                            
                            }
                        });
                        break;
                }
                break;
            /* the minimum -1 whithin the prescribed */
            case 4:
                break;
            /* the minimum out of the prescribed */
            case 5:
                switch ( menu2Index ) {
                    case 0:
                        setLayoutManager(null);

                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check the behavior when the value is non-prescribed minimum");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("x=0");
                        testButton2 = new Button("y=0");
                        testButton3 = new Button("x,y=0");
                        testButton4 = new Button("initial size");
                        testButton5 = new Button("checking the size");

                        testLabel[0].setSize(50, 15);

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        testLabel[0].setBackground(Graphics.getColorOfName(Graphics.BLACK));
                        testLabel[0].setForeground(Graphics.getColorOfName(Graphics.WHITE));
// J012_2902_0307 -
// J012_2902_0309
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setSize(0, testLabel[0].getHeight());
										// 2003/03/12 ->
										testLabel[0].setLocation(0, testLabel[0].getHeight());
										// 2003/03/12 <-
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setSize(10, 0);
										// 2003/03/12 ->
										testLabel[0].setLocation(10, 0);
										// 2003/03/12 <-
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setSize(0, 0);
										// 2003/03/12 ->
										testLabel[0].setLocation(0, 0);
										// 2003/03/12 <-
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setSize(50, 15);
                                    } else if ( aComponent == testButton5 ) {
										// 2003/03/12 ->
                                        //showMsg("x:" + testLabel[0].getWidth() + "  y:" + testLabel[0].getHeight());
										showMsg("x:" + testLabel[0].getX() + "  y:" + testLabel[0].getY());
										// 2003/03/12 <-
                                    }
                                }
                            
                            }
                        });
                        break;
                }
                break;
            /* -1 */
            case 6:
                switch ( menu2Index ) {
                    case 0:
                        setLayoutManager(null);

                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check the behavior when the argument value is -1");
                        subTitle.setLocation(0,0);

                        testLabel[0] = new Label("test label");
                        testButton1 = new Button("x=-1");
                        testButton2 = new Button("y=-1");
                        testButton3 = new Button("x,y=-1");
                        testButton4 = new Button("initial coordinate");
                        testButton5 = new Button("check the coordinate");

                        testLabel[0].setLocation(0,15);
                        testButton1.setLocation(0,40);
                        testButton2.setLocation(35,40);
                        testButton3.setLocation(70,40);
                        testButton4.setLocation(0,55);
                        testButton5.setLocation(0,70);

                        add(testLabel[0]);
                        add(testButton1);
                        add(testButton2);
                        add(testButton3);
                        add(testButton4);
                        add(testButton5);

                        settingLabel(1);
// J012_2903_0107 -
// J012_2903_0109
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        testLabel[0].setLocation(-1, 15);
                                    } else if ( aComponent == testButton2 ) {
                                        testLabel[0].setLocation(0, -1);
                                    } else if ( aComponent == testButton3 ) {
                                        testLabel[0].setLocation(-1, -1);
                                    } else if ( aComponent == testButton4 ) {
                                        testLabel[0].setLocation(0, 15);
                                    } else if ( aComponent == testButton5 ) {
                                        showMsg("x:" + testLabel[0].getX() + "\ny:" + testLabel[0].getY());
                                    }
                                }
                            }
                        });
                        break;
                }
                break;
            /* Null */
            case 7:
                switch ( menu2Index ) {
                    case 0:
//                        setLayoutManager(null);

                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        subTitle.setText("check the behabior when the argument is null");
                        subTitle.setLocation(0,0);
                        subTitle.setSize(getWidth(), subTitle.getHeight());
// J012_2904_0101
// J012_2904_0102
// J012_2904_0103
                        testLabel[0] = new Label();
                        testButton1 = new Button("test");
                        testLabel[0].setBackground(Graphics.getColorOfName(Graphics.BLACK));
                        testLabel[0].setForeground(Graphics.getColorOfName(Graphics.WHITE));
                        add(testLabel[0]);
                        add(testButton1);
                        /* 
                         * setting of the component listener
                         */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        showMsg("width:" + testLabel[0].getWidth() + "\nheight:" + testLabel[0].getHeight());
                                    }
                                }
                            }
                        });

                        break;
                }
                break;
        }

    }

    /**
     * create longest String
     * @param  maxStringValue string length which is created
     */
    String strMax(int maxStringValue) {
        int i;
        int j = 0;
        maxString = "";
        for ( i = 0; i < maxStringValue; i++ ) {
            if ( j == 10 ) {
                j = 0;
            }
            maxString = maxString + j;
            j++;
        }
        maxString = maxString;
        return maxString;
    }

    /**
     * the method which get the maximum color value of cell phone
     */
    void getColorMax() {
        int color0;
        int color255;

        color0 = Graphics.getColorOfRGB(0,0,0);
        color255 = Graphics.getColorOfRGB(255,255,255);

/* debug
        System.out.println(color0);
        System.out.println(color255);
*/

        if ( color0 >= color255 ) {
            maxColor = color0;
        } else {
            maxColor = color255;
        }
    }

    /**
     * setting the label color,and the size
     * @param aCount the number of looping
     */
    void settingLabel(int aCount) {
        int i;
        for ( i = 0; i < aCount; i++ ) {
            testLabel[i].setBackground(Graphics.getColorOfName(Graphics.BLACK));
            testLabel[i].setForeground(Graphics.getColorOfName(Graphics.WHITE));
            testLabel[i].setSize(getWidth(),testLabel[i].getHeight());
        }
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {}

}
