/**
 * J012_3101_0101.java
 * 
 * J012_2901_0101
 * MenuPanel
 * TestPanel
 * 
 * ListBox class behavior checking(boundary test)
 * 
 * $Id: J012_3101_0101.java,v 1.2 2001/12/02 05:18:10 waka Exp $
 */

import com.nttdocomo.ui.*;

/**
 * ListBox class behavior checking main class
 * @extends IApplication
 */
public class J012_3101_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * ListBox class boundary test menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    protected int maxInt = 0x7FFFFFFF;       /* the maximum of int */
    ListBox menu1 = null;
    ListBox menu2 = null;
    ListBox menu3 = null;                    /* selection processing  menu */
    ListBox testList = null;                 /* listbox for behavior checking */
    Button execButton = null;                /* execution button */
    int maxColor;                            /* the maximum value of terminal color */

    /* processing selection menu item(menu1,menu2,menu3) */
    String[] menu1Item = {
        "0.the argument is prescribed maximum value",
        "1.the argument is prescribed maximum value + 1",
        "2.the argument is non-prescribed maximum value",
        "3.the argument is prescribed minimum value",
        "4.the argument is prescribed minimum value - 1",
        "5.the argument is non-prescribed minimum value",
        "6.the argument is -1",
        "7.the argument is null",
    };

    String[][] menu2Item = {
        /* menu of the maximum parameter within the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
            "2.operation check 3",
        },
        /* menu of the maximum parameter +1 within the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
            "2.operation check 3",
            "3.operation check 4",
        },
        /* menu of the maximum parameter out of the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
            "2.operation check 3",
        },
        /* menu of the minimum parameter within the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
            "2.operation check 3",
        },
        /* menu of the minimum parameter -1 within the prescribed */
        {
            "0.operation check 1",
        },
        /* menu of the minimum parameter out of the prescribed */
        {
            "0.operation check 1",
            "1.operation check 2",
        },
        /* menu of the parameter -1 */
        {
            "0.operation check 1",
        },
        /* menu of the parameter Null */
        {
            "0.operation check 1",
            "1.operation check 2",
        },
    };
    String[][][] menu3Item = {
        /* maximum within the prescribed*/
        {
            /* the maximum within the prescribed behavior checking1 */
            {
                "unused",
            },
            /* the maximum within the prescribed behavior checking2 */
            {
                "unused",
            },
            /* the maximum within the prescribed behavior checking3 */
            {
                "unused",
            },
        },
        /* maximum + 1 within the prescribed */
        {
            /* the maximum +1 within the prescribed behavior checking1 */
            {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
                "4.check the exception 5",
                "5.check the exception 6",
            },
            /* the maximum +1 within the prescribed behavior checking2 */
            {
                "unused",
            },
            /* the maximum +1 within the prescribed behavior checking3 */
            {
                "unused",
            },
            /* the maximum +1 within the prescribed behavior checking4 */
            {
                "unused",
            },
        },
        /* maximum out of the prescribed*/
        {
            /* maximum out of the prescribed behavior checking1 */
            {
                "0.check the exception 1",
                "1.check the exception 2",
            },
            /* maximum out of the prescribed behavior checking2 */
            {
                "unused",
            },
            /* maximum out of the prescribed behavior checking3 */
            {
                "unused",
            },
        },
        /* minimum within the prescribed*/
        {
            /* minimum within the prescribed behavior checking1 */
            {
                "unused",
            },
            /* minimum within the prescribed behavior checking2 */
            {
                "unused",
            },
            /* minimum within the prescribed behavior checking3 */
            {
                "unused",
            },
        },
        /* the minimum -1 whithin the prescribed*/
        {
            /* minimum -1 within the prescribed behavior checking1 */
            {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
                "3.check the exception 4",
                "4.check the exception 5",
                "5.check the exception 6",
                "6.check the exception 7",
                "7.check the exception 8",
                "8.check the exception 9",
                "9.check the exception 10",
            },
        },
        /* the minimum out of the prescribed*/
        {
            /* minimum out of the prescribed behavior checking 1 */
            {
                "unused",
            },
			/* minimum out of the prescribed behavior checking 2 */
            {
                "unused",
            },
        },
        /* parameter -1*/
        {
            /* parameter -1 behavior checking1 */
            {
                "unused",
            },
        },
        /* parameter Null*/
        {
            /* parameter Null behavior checking1 */
            {
                "0.check the exception 1",
                "1.check the exception 2",
                "2.check the exception 3",
            },
            /* parameter Null behavior checking2 */
            {
                "unused",
            },
        },
    };

    /**
     * MenuPanel class constructor
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {
        /* menu/sub title display */
        setTitle("API class boundary route");
        Label subTitle = new Label("ListBox");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* create/add the component */
        menu1 = new ListBox(ListBox.CHOICE, 8);
        menu2 = new ListBox(ListBox.CHOICE, 4);
        menu3 = new ListBox(ListBox.CHOICE, 8);
        execButton = new Button("execute");
        testList = new ListBox(ListBox.CHOICE, 1);
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        menu3.setItems(menu3Item[0][0]);
        add(menu1);
        add(menu2);
        add(menu3);
        add(execButton);
        testList.append("unused (for checking)");

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

     /**
     * action checking method
     * @param  menu1Index index of menu1
     * @param  menu2Index index of menu2
     * @param  menu3Index index of menu3
     */
    void test(int menu1Index, int menu2Index, int menu3Index) {

        boolean okFlag = false;
        Label testLabel = null;

        /* display dialog in case of exception checking,otherwise,go to the checking screen */
        /* maximum parameter +1 within the prescribed exception checking */
        if ( menu1Index == 1 
             && menu2Index == 0) {
            switch ( menu3Index ) {
// J012_3101_0203
            case 0:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.getItem(99);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" trying to get more items than getItem function can get..");
                }
                break;
// J012_3101_0204
            case 1:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.select(99);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" trying to select more items than select function can select..");
                }
                break;
// J012_3101_0205
            case 2:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.SINGLE_SELECT, 1);
                    testList.deselect(99);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" trying to deselect more items than deselect function can deselect..");
                }
                break;
// J012_3101_0206
            case 3:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.isIndexSelected(99);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" trying to select more items than isIndexSelected function can select..");
                }
                break;
// J012_3101_0208
            case 4:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    getColorMax();
                    testList.setBackground(maxColor + 1);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException:" + iae.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" the value set to the background color excesses supported maximum value.");
                }
                break;
// J012_3101_0209
            case 5:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    getColorMax();
                    testList.setForeground(maxColor + 1);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException:" + iae.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" the value set to the foreground color excesses supported maximum value.");
                }
                break;
            }
            return;
        }
        /* maximum parameter out of the prescribed exception checking */
        if ( menu1Index == 2 
             && menu2Index == 0) {
            switch ( menu3Index ) {
// J012_3101_0301
            case 0:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    getColorMax();
                    testList.setBackground(maxInt);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException:" + iae.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" the value set to the background color is maximum Int value.");
                }
                break;
// J012_3101_0302
            case 1:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    getColorMax();
                    testList.setForeground(maxInt);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException:" + iae.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" the value set to the foreground color is maximum Int value.");
                }
                break;
            }
            return;
        }
        /* minimum parameter -1 within the prescribed exception checking */
        if ( menu1Index == 4 
             && menu2Index == 0) {
            switch ( menu3Index ) {
// J012_3102_0201
            case 0:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, -1);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException:" + iae.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" -1 is set to the number of the line");
                }
                break;
// J012_3102_0202
            case 1:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.getItem(-1);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" getItem has gotten -1st item..");
                }
                break;
// J012_3102_0203
            case 2:
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.select(-1);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" selected -1st item..");
                }
                break;
// J012_3102_0204
            case 3:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.SINGLE_SELECT, 1);
                    testList.deselect(-1);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" deselected -1st item..");
                }
                break;
// J012_3102_0205
            case 4:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.isIndexSelected(-1);
                } catch (ArrayIndexOutOfBoundsException aioobe) {
                    okFlag = true;
                    showMsg("ArrayIndexOutOfBoundsException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" isIndexSelected -1st item");
                }
                break;
// J012_3102_0206
            case 5:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.setBackground(-1);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException:" + iae.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" -1 is set to the background color.");
                }
                break;
// J012_3102_0207
            case 6:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.setForeground(-1);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException:" + iae.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" -1 is set to the foreground color.");
                }
                break;
// J012_3102_0208
            case 7:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.setSize(-1,10);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" -1 is set to the component's width");
                }
                break;
// J012_3102_0209
            case 8:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.setSize(10, -1);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" -1 is set to the component's height");
                }
                break;
// J012_3102_0210
            case 9:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.setSize(-1, -1);
                } catch (IllegalArgumentException iae) {
                    okFlag = true;
                    showMsg("IllegalArgumentException");
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" -1 is set to the component's width and height");
                }
                break;
            }
            return;
        }
        /* parameter Null exception checking */
        if ( menu1Index == 7 
             && menu2Index == 0) {
            switch ( menu3Index ) {
// J012_3104_0101
            case 0:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.setItems(null);
                } catch (NullPointerException npe) {
                    okFlag = true;
                    showMsg("\"OK\" NullPonterException:" + npe.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" null value is set to setItems");
                }
                break;
// J012_3104_0102
            case 1:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    String[] testItem = {null};
                    testList.setItems(testItem);
                } catch (NullPointerException npe) {
                    okFlag = true;
                    showMsg("\"OK\" NullPonterException:" + npe.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" null value is set to setItems");
                }
                break;
// J012_3104_0104
            case 2:
                okFlag = false;
                try {
                    testList = new ListBox(ListBox.CHOICE, 1);
                    testList.append(null);
                } catch (NullPointerException npe) {
                    okFlag = true;
                    showMsg("\"OK\" NullPonterException:" + npe.getMessage());
                }
                if ( okFlag == false ) {
                    showMsg("\"NG\" null value is appended");
                }
                break;
            }
            return;
        }

        /* shift to the behavior checking Panel */
        Display.setCurrent(new TestPanel(menu1Index, menu2Index, menu3Index, this));

    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * the method which get the maximum color value of cell phone
     */
    void getColorMax() {
        int color0;
        int color255;

        color0 = Graphics.getColorOfRGB(0,0,0);
        color255 = Graphics.getColorOfRGB(255,255,255);

        if ( color0 >= color255 ) {
            maxColor = color0;
        } else {
            maxColor = color255;
        }
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
        public void componentAction(Component aComponent, int aType, int aParam) {

        /* setting the item (menu2 or menu3),when the menulist(menu1 or menu2)is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
                menu3.setItems(menu3Item[menu1.getSelectedIndex()][0]);
            }
            if ( aComponent == menu2 ) {
                menu3.setItems(menu3Item[menu1.getSelectedIndex()][menu2.getSelectedIndex()]);
            }
        }
        /* when the execution button is pressed, store the 3 kinds of menu indexes to the variable and call the behavior checking method*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {

                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();
                int menu3Index = menu3.getSelectedIndex();

                test(menu1Index, menu2Index, menu3Index);

            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }

}
/**
 * TextBox class boundary behavior checking screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel extends Panel implements SoftKeyListener, ComponentListener {

    protected int maxInt = 0x7FFFFFFF;  /* the maximum of int */
    Frame previousFrame = null;         /* store the previous screen */
    int menu1Index = 0;
    int menu2Index = 0;
    int menu3Index = 0;                 /* index of the previous screen menu */
    Label subTitle = null;              /* sub title */
    String maxString = null;            /* store the longest character sequence */
    int maxColor;                       /* the maximum value of terminal color */
    ListBox testListBox1,testListBox2,
            testListBox3,testListBox4,
            testListBox5,testListBox6;  /* listbox for checking */
    Button testButton1,testButton2,
           testButton3,testButton4,
           testButton5;                 /* testing button */

    /**
     * TestPanel class constructor
     * @param  menu1Index index of menu1
     * @param  menu2Index index of menu2
     * @param  menu3Index index of menu3
     */
    TestPanel(int menu1Index, int menu2Index, int menu3Index, Frame aFrame) {
        previousFrame = aFrame;
        menu1Index = menu1Index;
        menu2Index = menu2Index;
        menu3Index = menu3Index;

        try {
            showTestPanel();
            test(menu1Index, menu2Index, menu3Index);
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }

    }

    /**
     * behavior checking screen
     */
    void showTestPanel() {
        /* menu/sub title display */
        setTitle("API class boundary route");
        subTitle = new Label("");
        add(subTitle);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * action checking method
     * @param  menu1Index index of menu1 on the menu screen
     * @param  menu2Index index of menu2 on the menu screen
     * @param  menu3Index index of menu3 on the menu screen
     */
    void test(int menu1Index, int menu2Index, int menu3Index) {

        try {
            switch ( menu1Index ) {
            /* maximum within the prescribed */
            case 0:
                switch ( menu2Index ) {
                case 0:
                    subTitle.setText("check the behavior when the value is prescribed maximum 1");
// J012_3101_0101
                    String[] testListItem = { strMax(14) };

                    testListBox1 = new ListBox(ListBox.SINGLE_SELECT, 4);
                    testButton1 = new Button("sel");
                    testButton2 = new Button("getI");
                    testButton3 = new Button("iISel");
                    testButton4 = new Button("desel");

                    testListBox1.setItems(testListItem);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);

// J012_3101_0102
                    testListBox1.append(strMax(14));
                    testListBox1.append("Item3");
                    testListBox1.append("Item4");

                    testButton1.requestFocus();

                    getColorMax();
                    testListBox2 = new ListBox(ListBox.CHOICE, 1);
                    testListBox3 = new ListBox(ListBox.CHOICE, 1);
// J012_3101_0107
// J012_3101_0108
                    testListBox2.setBackground(maxColor);
                    testListBox2.setForeground(0);
                    testListBox3.setBackground(0);
                    testListBox3.setForeground(maxColor);
                    add(testListBox2);
                    add(testListBox3);
                    testListBox2.append("Background Max");
                    testListBox3.append("Foreground Max");

                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
// J012_3101_0103
                                    testListBox1.select(3);
                                } else if ( aComponent == testButton2 ) {
// J012_3101_0104
                                    showMsg("getItem: " + testListBox1.getItem(3));
                                } else if ( aComponent == testButton3 ) {
// J012_3101_0105
                                    showMsg("isIndexSelected: " + testListBox1.isIndexSelected(3));
                                } else if ( aComponent == testButton4 ) {
// J012_3101_0106
                                    testListBox1.deselect(3);
                                }
                            }
                        }
                    });
                    break;

                case 1:
                    setLayoutManager(null);
                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check the behavior when the value is prescribed maximum 2");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Location");

                    testButton1 = new Button("x=max");
                    testButton2 = new Button("y=max");
                    testButton3 = new Button("x,y=max");
                    testButton4 = new Button("initial coordinate");
                    testButton5 = new Button("check the coordinate");

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

// J012_3101_0109 -
// J012_3101_0111
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setLocation(getWidth(),15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setLocation(0,getHeight());
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setLocation(getWidth(),getHeight());                                        
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setLocation(0, 15);
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("X:" + testListBox1.getX() + "\nY:" + testListBox1.getY());
                                }
                            }
                        }
                    });
                    break;

                case 2:
                    setLayoutManager(null);

                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check the behavior when the value is prescribed maximum 3");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Size");

                    testButton1 = new Button("width");
                    testButton2 = new Button("height");
                    testButton3 = new Button("wid,hei");
                    testButton4 = new Button("initial size");
                    testButton5 = new Button("checking the size");
                	
					// check Size
                    testListBox1.setSize(50, 17);

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

                    testListBox1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testListBox1.setForeground(Graphics.getColorOfName(Graphics.WHITE));

// J012_3101_0112 -
// J012_3101_0114
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setSize(getWidth(), 15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setSize(50, getHeight());
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setSize(getWidth(), getHeight());
                                    testButton5.setLocation(0,180);
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setSize(50, 17);//initial size
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("width:" + testListBox1.getWidth() + "  height:" + testListBox1.getHeight());
                                }
                            }
                        
                        }
                    });
                    break;
                }
                break;

            /* maximum + 1 within the prescribed */
            case 1:
                switch ( menu2Index ) {
                case 1:
                    subTitle.setText("check2 that the value is prescribed maximum + 1");
                    subTitle.setLocation(0,0);
// J012_3101_0201
// J012_3101_0202
                    String[] testListItem100 = { strMax(100) };
                    testListBox1 = new ListBox(ListBox.SINGLE_SELECT, 2);
                    add(testListBox1);
                    testListBox1.setItems(testListItem100);
                    testListBox1.append(strMax(100));
                    break;

                case 2:
                    setLayoutManager(null);
                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check3 that the value is prescribed maximum + 1");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Location");

                    testButton1 = new Button("x=max");
                    testButton2 = new Button("y=max");
                    testButton3 = new Button("x,y=max");
                    testButton4 = new Button("initial coordinate");
                    testButton5 = new Button("check the coordinate");

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

// J012_3101_0210
// J012_3101_0211
// J012_3101_0212
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setLocation(getWidth() + 1,15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setLocation(0,getHeight() + 1);
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setLocation(getWidth() + 1, getHeight() + 1);
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setLocation(0, 15);
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("X:" + testListBox1.getX() + "\nY:" + testListBox1.getY());
                                }
                            }
                        }
                    });
                    break;

                case 3:
                    setLayoutManager(null);

                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check3 that the value is prescribed maximum + 1");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Size");

                    testButton1 = new Button("width");
                    testButton2 = new Button("height");
                    testButton3 = new Button("wid,hei");
                    testButton4 = new Button("initial size");
                    testButton5 = new Button("checking the size");

                    testListBox1.setSize(50, 17);

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

                    testListBox1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testListBox1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
// J012_3101_0213
// J012_3101_0214
// J012_3101_0215
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setSize(getWidth() + 1, 15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setSize(50, getHeight() + 1);
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setSize(getWidth() + 1, getHeight() + 1);
                                	testButton5.setLocation(0,180);
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setSize(50, 17);
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("width:" + testListBox1.getWidth() + "  height:" + testListBox1.getHeight());
                                }
                            }
                        
                        }
                    });
                    break;
                }
                break;

            /* maximum out of the prescribed */
            case 2:
                switch ( menu2Index ) {
                case 1:
                    setLayoutManager(null);
                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check that the value is non-prescribed maximum 2");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Location");

                    testButton1 = new Button("x=max");
                    testButton2 = new Button("y=max");
                    testButton3 = new Button("x,y=max");
                    testButton4 = new Button("initial coordinate");
                    testButton5 = new Button("check the coordinate");

                    testListBox1.setLocation(0,17);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);
// J012_3101_0303
// J012_3101_0304
// J012_3101_0305
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setLocation(maxInt,15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setLocation(0,maxInt);
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setLocation(maxInt,maxInt);
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setLocation(0, 15);
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("X:" + testListBox1.getX() + "\nY:" + testListBox1.getY());
                                }
                            }
                        }
                    });
                    break;

                case 2:
                    setLayoutManager(null);

                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check2 that the value is non-prescribed maximum");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Size");

                    testButton1 = new Button("width");
                    testButton2 = new Button("height");
                    testButton3 = new Button("wid,hei");
                    testButton4 = new Button("initial size");
                    testButton5 = new Button("checking the size");

                    testListBox1.setSize(50, 17);

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

                    testListBox1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testListBox1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
// J012_3101_0306
// J012_3101_0307
// J012_3101_0308
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setSize(maxInt, 15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setSize(50, maxInt);
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setSize(maxInt, maxInt);
                                	testButton5.setLocation(0,180);
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setSize(50, 17);
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("width:" + testListBox1.getWidth() + "  height:" + testListBox1.getHeight());
                                }
                            }
                        
                        }
                    });
                    break;
                }
                break;

            /* minimum within the prescribed */
            case 3:
                switch ( menu2Index ) {
                case 0:
                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check1 that the value is prescribed minimum");

// J012_3102_0101
                    testListBox1 = new ListBox(ListBox.CHOICE, 0);
                    add(testListBox1);
                    testListBox1.setBackground(Graphics.getColorOfName(Graphics.BLACK));

                    testListBox2 = new ListBox(ListBox.CHOICE, 1);
                    testListBox3 = new ListBox(ListBox.CHOICE, 1);
                    testListBox2.append("background");
                    testListBox3.append("foreground");
// J012_3102_0107
// J012_3102_0108
                    testListBox2.setBackground(0);
                    testListBox3.setForeground(0);
                    add(testListBox2);
                    add(testListBox3);
                    break;

                case 1:
                    String[] testListItem = { "Item1", "Item2", "Item3" };

                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check2 thatht the value is prescribed minimum");

                    testListBox1 = new ListBox(ListBox.SINGLE_SELECT, 3);

                    testButton1 = new Button("sel");
                    testButton2 = new Button("getI");
                    testButton3 = new Button("iISel");
                    testButton4 = new Button("desel");

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);

                    testListBox1.setItems(testListItem);

                    testButton1.requestFocus();

// J012_3102_0103 -
// J012_3102_0106
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.select(0);
                                } else if ( aComponent == testButton2 ) {
                                    showMsg("getItem: " + testListBox1.getItem(0));
                                } else if ( aComponent == testButton3 ) {
                                    showMsg("isIndexSelected: " + testListBox1.isIndexSelected(0));
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.deselect(0);
                                }
                            }
                        }
                    });
                    break;

                case 2:
                    setLayoutManager(null);

                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check3 that the value is prescribed minimum");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
//                    testListBox2.append("Size checking");

                    testButton1 = new Button("width");
                    testButton2 = new Button("height");
                    testButton3 = new Button("wid,hei");
                    testButton4 = new Button("initial size");
                    testButton5 = new Button("checking the size");

                    testListBox1.setSize(70, 20);

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

                    testListBox1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    testListBox1.setForeground(Graphics.getColorOfName(Graphics.WHITE));

// J012_3102_0110 -
// J012_3102_0111
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setSize(0, 15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setSize(50, 0);
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setSize(0, 0);
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setSize(70, 20);
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("width:" + testListBox1.getWidth() + "  height:" + testListBox1.getHeight());
                                }
                            }
                        
                        }
                    });
                    break;
                }
                break;

            /* the minimum out of the prescribed */
            case 5:
                switch ( menu2Index ) {
                case 0:
                    String[] testListItem = { "" };

                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check1 that the value is non-prescribed minimum");

// J012_3102_0201
// J012_3102_0202
// J012_3102_0203
                    testListBox1 = new ListBox(ListBox.SINGLE_SELECT, 0);
                    testListBox2 = new ListBox(ListBox.SINGLE_SELECT, 1);
                    testListBox3 = new ListBox(ListBox.SINGLE_SELECT, 1);

                    add(testListBox1);
                    add(testListBox2);
                    add(testListBox3);

                    testListBox2.append("");

                    testListBox3.setItems(testListItem);
                    break;

				case 1:
// J012_3102_0311
// J012_3102_0312
// J012_3102_0313
                    setLayoutManager(null);
                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check2 that the value is non-prescribed minimum");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Location");

                    testButton1 = new Button("x=0");
                    testButton2 = new Button("y=0");
                    testButton3 = new Button("x,y=0");
                    testButton4 = new Button("initial coordinate");
                    testButton5 = new Button("check the coordinate");

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
						int flag = 0;
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setLocation(0,15);
									flag = 1;
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setLocation(0, 0);
									flag = 2;
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setLocation(0, 0);
									flag = 0;
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setLocation(0,15);
									flag = 0;
                                } else if ( aComponent == testButton5 ) {
									if(flag == 1){
										showMsg("X:" + testListBox1.getX());
									}else if (flag == 2){
										showMsg("Y:" + testListBox1.getY());
									}else if (flag == 0){
                                    	showMsg("X:" + testListBox1.getX() + "\nY:" + testListBox1.getY());
									}
                                }
                            }
                        }
                    });
                    break;

                }
                break;

            /* -1 */
            case 6:
                switch ( menu2Index ) {
                case 0:
                    setLayoutManager(null);
                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check the behavior when the argument value is -1");
                    subTitle.setLocation(0,0);

                    testListBox1 = new ListBox(ListBox.CHOICE, 1);
                    testListBox1.append("check Location");

                    testButton1 = new Button("x=-1");
                    testButton2 = new Button("y=-1");
                    testButton3 = new Button("x,y=-1");
                    testButton4 = new Button("initial coordinate");
                    testButton5 = new Button("check the coordinate");

                    testListBox1.setLocation(0,15);
                    testButton1.setLocation(0,40);
                    testButton2.setLocation(35,40);
                    testButton3.setLocation(70,40);
                    testButton4.setLocation(0,55);
                    testButton5.setLocation(0,70);

                    add(testListBox1);
                    add(testButton1);
                    add(testButton2);
                    add(testButton3);
                    add(testButton4);
                    add(testButton5);

// J012_3103_0108
// J012_3103_0109
// J012_3103_0110
                    /* 
                     * setting of the component listener
                     */
                    setComponentListener(new ComponentListener() {
                       /**
                        * get the event on a component
                        * @param aComponent The component on which a event occurred
                        * @param aType Type of an event.
                        * @param aParam Parameter of an event
                        */
                        public void componentAction(Component aComponent, int aType, int aParam) {
                            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                if ( aComponent == testButton1 ) {
                                    testListBox1.setLocation(-1,15);
                                } else if ( aComponent == testButton2 ) {
                                    testListBox1.setLocation(0,-1);
                                } else if ( aComponent == testButton3 ) {
                                    testListBox1.setLocation(-1, -1);
                                } else if ( aComponent == testButton4 ) {
                                    testListBox1.setLocation(0, 15);
                                } else if ( aComponent == testButton5 ) {
                                    showMsg("X:" + testListBox1.getX() + "\nY:" + testListBox1.getY());
                                }
                            }
                        }
                    });
                    break;
                }
                break;

            case 7:
                switch ( menu2Index ) {
                case 1:
                    subTitle.setSize(getWidth(), subTitle.getHeight());
                    subTitle.setText("check that the argument is a null value");

                    testButton1 = new Button("test");

                    testListBox1 = new ListBox(ListBox.CHOICE, 0);
                    testListBox1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
                    add(testListBox1);
                    add(testButton1);

// J012_3104_0103
                    /* 
                     * setting of the component listener
                     */
                        setComponentListener(new ComponentListener() {
                           /**
                            * get the event on a component
                            * @param aComponent The component on which a event occurred
                            * @param aType Type of an event.
                            * @param aParam Parameter of an event
                            */
                            public void componentAction(Component aComponent, int aType, int aParam) {
                                if ( aType == ComponentListener.BUTTON_PRESSED ) {
                                    if ( aComponent == testButton1 ) {
                                        showMsg("width:" + testListBox1.getWidth() + " height:" + testListBox1.getHeight());
                                    }
                                }
                            }
                        });
                        break;
                }
                break;
            }

        } catch (Exception e) {
            showMsg(e.toString());
        } catch (Error e) {
            showMsg(e.toString());
        }

    }

    /**
     * create longest String
     * @param  maxStringValue string length which is created
     */
    String strMax(int maxStringValue) {
        int i;
        int j = 0;
        maxString = "";
        for ( i = 0; i < maxStringValue; i++ ) {
            if ( j == 10 ) {
                j = 0;
            }
            maxString = maxString + j;
            j++;
        }
        maxString = maxString;
        return maxString;
    }

    /**
     * the method which get the maximum color value of cell phone
     */
    void getColorMax() {
        int color0;
        int color255;

        color0 = Graphics.getColorOfRGB(0,0,0);
        color255 = Graphics.getColorOfRGB(255,255,255);

        if ( color0 >= color255 ) {
            maxColor = color0;
        } else {
            maxColor = color255;
        }
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {}
}

