/**
 * J012_3601_0101.java
 * 
 * J012_3601_0101
 * MenuPanel
 * TestPanel
 * 
 * MediaManager class behavior checking (boundary test)
 * 
 * $Id: J012_3601_0101.java,v 1.3 2002/01/18 05:13:19 waka Exp $
 */

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * MediaManager class behavior checking main class
 * @extends IApplication
 */
public class J012_3601_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }

    /**
     * MediaManager class boundary test menu screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

        ListBox menu1 = null;
        ListBox menu2 = null;
        ListBox menu3 = null;                    /* selection processing  menu */
        ListBox testList = null;                 /* listbox for behavior checking */
        Button execButton = null;                /* execution button */
        /* URL of 225 characters */
        String          url255 = 
            "longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/123456789012";
        String          url256 = 
            "longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/longurlpath1234567890/1234567890123";

        String testUrl255 = null;
        String testUrl256 = null;

        TextBox resultBox;
        /* processing selection menu item(menu1,menu2,menu3) */
        String[] menu1Item = {
            "0.the argument is prescribed maximum value",
            "1.the argument is prescribed maximum value + 1",
            "2.the argument is non-prescribed minimum"
        };

        String[][] menu2Item = {
            /* maximum within the prescribed */
            {
                "0.getData()",
                "1.getImage()",
                "2.getSound()"
            },
            /* maximum + 1 within the prescribed */
            {
                "0.getData()",
                "1.getImage()",
                "2.getSound()"
            },
            /* the minimum out of the prescribed */
            {
                "0.getData()",
                "1.getImage()",
                "2.getSound()"
            }
        };

        String[][][] menu3Item = {
            /* maximum within the prescribed*/
            {
                {
                    "0.operation check 1",
                    "1.operation check 2"
                },
                {
                    "0.operation check 1",
                    "1.operation check 2"
                },
                {
                    "0.operation check 1",
                    "1.operation check 2"
                }
            },
            /* maximum + 1 within the prescribed */
            {
                {
                    "0.operation check 1",
                    "1.operation check 2",
                },
                {
                    "0.operation check 1",
                    "1.operation check 2",
                },
                {
                    "0.operation check 1",
                    "1.operation check 2",
                }
            },

            /* the minimum out of the prescribed */
            {
                {
                    "unused",
                },
                {
                    "unused",
                },
                {
                    "unused",
                }
            }
        };

        /**
         * MenuPanel class constructor
         */
        MenuPanel() {
            try {
                showMainPanel();
            } catch(Exception e) {
                showMsg("Exception:" + e.toString());
            } catch(Error e) {
                showMsg("Error:" + e.toString());
            }
        }

        public void showMainPanel() {
            /* menu/sub title display */
            setTitle("API class boundary route");
            Label subTitle = new Label("MediaManager");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            add(subTitle);

            /* create/add the component */
            menu1 = new ListBox(ListBox.CHOICE, 8);
            menu2 = new ListBox(ListBox.CHOICE, 4);
            menu3 = new ListBox(ListBox.CHOICE, 8);
            execButton = new Button("execute");
            resultBox = new TextBox("", getWidth(), 1, TextBox.DISPLAY_ANY); 
            menu1.setItems(menu1Item);
            menu2.setItems(menu2Item[0]);
            menu3.setItems(menu3Item[0][0]);
            add(menu1);
            add(menu2);
            add(menu3);
            add(execButton);
            add(resultBox);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        MediaData testMediaData;
        MediaImage testMediaImage;
        MediaSound testMediaSound;
        MediaResource testMediaResource;    /* media concerning */
        void test(int menu1Index, int menu2Index, int menu3Index) {

            boolean okFlag = false;    /* flag for exception */
            String aURL = getSourceURL() + "../res/" ;    /*  */

            testUrl255 = getSourceURL() + url255;
            testUrl256 = getSourceURL() + url256;

            /* maximum parameter set the URL 255byte */
            if ( menu1Index == 0  && menu3Index == 0 ) {
                resultBox.setText("");
                switch (menu2Index) {
// J012_3601_0101
                case 0:
                    okFlag = true;
                    try {
                        if( testUrl255.length() != 255 ) {
                            showMsg("NG:URL-length="+testUrl255.length());
                            return;
                        }
                        testMediaData = MediaManager.getData(getSourceURL() + url255);
                    } catch (Exception e) {
                        okFlag = false;
                        showMsg(e.toString());
                    } catch (Error e) {
                        okFlag = false;
                        showMsg(e.toString());
                    }
                    if ( okFlag == true ) {
                        resultBox.setText("OK");
                    }
                    break;
// J012_3601_0102
                case 1:
                    okFlag = true;
                    try {
                        if( testUrl255.length() != 255 ) {
                            showMsg("NG:URL-length="+testUrl255.length());
                            return;
                        }
                        testMediaImage = MediaManager.getImage(getSourceURL() + url255);
                    } catch (Exception e) {
                        okFlag = false;
                        showMsg(e.toString());
                    } catch (Error e) {
                        okFlag = false;
                        showMsg(e.toString());
                    }
                    if ( okFlag == true ) {
                        resultBox.setText("OK");
                    }
                    break;
// J012_3601_0103
                case 2:
                    okFlag = true;
                    try {
                        if( testUrl255.length() != 255 ) {
                            showMsg("NG:URL-length="+testUrl255.length());
                            return;
                        }
                        testMediaSound = MediaManager.getSound(getSourceURL() + url255);
                    } catch (Exception e) {
                        okFlag = false;
                        showMsg(e.toString());
                    } catch (Error e) {
                        okFlag = false;
                        showMsg(e.toString());
                    }
                    if ( okFlag == true ) {
                        resultBox.setText("OK");
                    }
                    break;
                }
                return;
            }

            /* minimum parameter getData 10k data set checking */
            if ( menu1Index == 0 
              && menu2Index == 0 
              && menu3Index == 1) {
// J012_3601_0104
                okFlag = false;
                try {
                    testMediaData = MediaManager.getData("resource:///aniGIF-10k.gif");
                    testMediaResource = (MediaResource)testMediaData;
                    testMediaResource.use();
                } catch (ConnectionException ce) {
                    okFlag = true;
                    showMsg(ce.getMessage());
                } catch (Exception e) {
                    showMsg(e.getMessage());
                } catch (Error e) {
                    showMsg(e.getMessage());
                }
                if ( okFlag == false ) {
                    resultBox.setText("OK");
                }
                return;
            }

            /* display dialog in case of exception checking,otherwise,go to the checking screen */
            /* maximum parameter +1 within the prescribed data more than URL225 */
            if ( menu1Index == 1  && menu3Index == 0) {
                switch ( menu2Index ) {
// J012_3601_0201
                case 0:
/*
testUrl255 = getSourceURL() + url255;
testUrl256 = getSourceURL() + url256;
System.out.println("URL255:" + testUrl255);
System.out.println("URL256:" + testUrl256);
System.out.println("Url255_length:" + testUrl255.length());
System.out.println("Url256_length:" + testUrl256.length());
*/
                    okFlag = false;
                    try {
                        testMediaData = MediaManager.getData(getSourceURL() + url256);
                        if( testUrl256.length() != 256 ) {
                            showMsg("NG:URL-length="+testUrl256.length());
                            return;
                        }

                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IAE:" + iae.getMessage());
                    } catch (Exception e) {
                        showMsg(e.getMessage());
                    } catch (Error e) {
                        showMsg(e.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" size of the URL set is over 255");
                    }
                    break;
// J012_3601_0202
                case 1:
                    okFlag = false;
                    try {
                        if( testUrl256.length() != 256 ) {
                            showMsg("NG:URL-length="+testUrl256.length());
                            return;
                        }
                        testMediaImage = MediaManager.getImage(getSourceURL() + url256);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IAE:" + iae.getMessage());
                    } catch (Exception e) {
                        showMsg(e.getMessage());
                    } catch (Error e) {
                        showMsg(e.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" size of the URL set is over 255");
                    }
                    break;
// J012_3601_0203
                case 2:
                    okFlag = false;
                    try {
                        if( testUrl256.length() != 256 ) {
                            showMsg("NG:URL-length="+testUrl256.length());
                            return;
                        }
                        testMediaSound = MediaManager.getSound(getSourceURL() + url256);
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("IAE:" + iae.getMessage());
                    } catch (Exception e) {
                        showMsg(e.getMessage());
                    } catch (Error e) {
                        showMsg(e.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" size of the URL set is over 255");
                    }
                    break;
                }
                return;
            }

            /* maximum parameter +1 within the prescribed .data more than 10k */
            if ( menu1Index == 1  && menu3Index == 1) {
                switch ( menu2Index ) {
// J012_3601_0105
                case 0:
                    try {
                        testMediaData = MediaManager.getData("resource:///aniGIF-10kover.gif");
                        testMediaData.use();
                    } catch (ConnectionException ce) {
                        okFlag = true;
                        showMsg("CE:" + ce.getMessage());
                    } catch (OutOfMemoryError ooe) {
                        okFlag = true;
                        showMsg("OutOfMemoryError");
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" size of the Media set is over 10 Kbytes");
                    }
                    break;
// J012_3601_0106
                case 1:
                    try {
                        testMediaImage = MediaManager.getImage("resource:///aniGIF-10kover.gif");
                        testMediaImage.use();
                    } catch (ConnectionException ce) {
                        okFlag = true;
                        showMsg("CE:" + ce.getMessage());
                    } catch (OutOfMemoryError ooe) {
                        okFlag = true;
                        showMsg("OutOfMemoryError");
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" size of the Media set is over 10 Kbytes");
                    }
                    break;
                case 2:
                    try {
                        testMediaSound = MediaManager.getSound("resource:///MFi20k.mld");
                        testMediaSound.use();
                    } catch (ConnectionException ce) {
                        okFlag = true;
                        showMsg("CE:" + ce.getMessage());
                    } catch (OutOfMemoryError ooe) {
                        okFlag = true;
                        showMsg("OutOfMemoryError");
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" size of the Media set is over 10 Kbytes");
                    }
                    break;
                }
                return;
            }

            /* minimum parameter out of the prescribed 0 byte URL */
            if ( menu1Index == 2 ) {
                switch ( menu2Index ) {
                case 0:
                    okFlag = false;
                    try {
                        testMediaData = MediaManager.getData("");
						// 2003/03/28 ->
						if ( testMediaData == null ) {
							okFlag = true;
							showMsg("OK:Minimum spec is null");
						}
						// 2003/03/28 <-
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("OK:IllegalArgumentException");
                    } catch (Exception e) {
                        showMsg(e.getMessage());
                    } catch (Error e) {
                        showMsg(e.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" 0 byte URL is set");
                    }
                    break;
                case 1:
                    okFlag = false;
                    try {
                        testMediaImage = MediaManager.getImage("");
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("OK:IllegalArgumentException");
                    } catch (Exception e) {
                        showMsg(e.getMessage());
                    } catch (Error e) {
                        showMsg(e.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" 0 byte URL is set");
                    }
                    break;
                case 2:
                    okFlag = false;
                    try {
                        testMediaImage = MediaManager.getImage("");
                    } catch (IllegalArgumentException iae) {
                        okFlag = true;
                        showMsg("OK:IllegalArgumentException");
                    } catch (Exception e) {
                        showMsg(e.getMessage());
                    } catch (Error e) {
                        showMsg(e.getMessage());
                    }
                    if ( okFlag == false ) {
                        showMsg("\"NG\" 0 byte URL is set");
                    }
                    break;
                }
                return;
            }

            /* shift to the behavior checking Panel */
            Display.setCurrent(new TestPanel(menu1Index, menu2Index, menu3Index, this));
        }

        /**
         * display message dialog
         * @param  aMsg dialog message
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }


        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* setting the item (menu2 or menu3),when the menulist(menu1 or menu2)is selected */
            if ( aType == ComponentListener.SELECTION_CHANGED ) {
                resultBox.setText("");
                if ( aComponent == menu1 ) {
                    menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
                    menu3.setItems(menu3Item[menu1.getSelectedIndex()][0]);
                }
                if ( aComponent == menu2 ) {
                    menu3.setItems(menu3Item[menu1.getSelectedIndex()][menu2.getSelectedIndex()]);
                }
            }
            /* when the execution button is pressed, store the 3 kinds of menu indexes to the variable and call the behavior checking method*/
            if ( aType == ComponentListener.BUTTON_PRESSED ) {
                try {

                    int menu1Index = menu1.getSelectedIndex();
                    int menu2Index = menu2.getSelectedIndex();
                    int menu3Index = menu3.getSelectedIndex();

                    test(menu1Index, menu2Index, menu3Index);

                } catch(Exception e) {
                    showMsg(e.toString());
                } catch (Error e) {
                    showMsg(e.toString());
                }
            }
        }
    }

    /**
     * MediaManager class boundary behavior checking screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class TestPanel extends Panel implements SoftKeyListener, ComponentListener {

        Frame previousFrame = null;         /* store the previous screen */
        int menu1Index = 0;
        int menu2Index = 0;
        int menu3Index = 0;                 /* index of the previous screen menu */
        Label subTitle = null;              /* sub title */
        String maxString = null;            /* store the longest character sequence */
        Button testButton1,testButton2,
               testButton3;                 /* testing button */

        /**
         * TestPanel class constructor
         * @param  menu1Index index of menu1
         * @param  menu2Index index of menu2
         * @param  menu3Index index of menu3
         */
        TestPanel(int menu1Index, int menu2Index, int menu3Index, Frame aFrame) {
            previousFrame = aFrame;
            menu1Index = menu1Index;
            menu2Index = menu2Index;
            menu3Index = menu3Index;

            try {
                showTestPanel();
                test(menu1Index, menu2Index, menu3Index);
            } catch(Exception e) {
                showMsg(e.getMessage());
            } catch(Error e) {
                showMsg(e.getMessage());
            }

        }

        void showTestPanel() {
            /* menu/sub title display */
            setTitle("API class boundary route");
            subTitle = new Label("");
            add(subTitle);

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * action checking method
         * @param  menu1Index index of menu1 on the menu screen
         * @param  menu2Index index of menu2 on the menu screen
         * @param  menu3Index index of menu3 on the menu screen
         */
        void test(int menu1Index, int menu2Index, int menu3Index) {

            MediaData testMediaData;
            MediaImage testMediaImage;
            MediaSound testMediaSound;
            VisualPresenter testVisualPresenter = new VisualPresenter();
            AudioPresenter testAudioPresenter = null;
            MediaResource testMediaResource ;

            /* maximum within the prescribed 10k data set (setImage,setSound) */
            try {
                if ( menu1Index == 0  && menu3Index == 1) {
                    switch ( menu2Index ) {
                    case 1:
                        subTitle.setText("10k Image set");
                        testMediaImage = MediaManager.getImage("resource:///aniGIF-10k.gif");
                        testMediaResource = (MediaResource)testMediaImage;
                        testMediaResource.use();
                        testVisualPresenter.setImage(testMediaImage);
                        add(testVisualPresenter);
                        testVisualPresenter.play();
                        break;
                    case 2:
                        subTitle.setText("10k Sound set");
                        testMediaSound = MediaManager.getSound("resource:///asia.mld");
                        testAudioPresenter=AudioPresenter.getAudioPresenter();
                        testMediaSound.use();
                        testAudioPresenter.setSound(testMediaSound);
                        testAudioPresenter.play();
                        break;
                    }
                }
            } catch ( ConnectionException ce) {
                showMsg(ce.getMessage());
            } catch (Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }

        /**
         * display message dialog
         * @param  aMsg dialog message
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * do nothing when the softkey is pressed
         * @param aSoftKey softkey type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * terminate the application when the softkey1 is released
         * shift to the previous screen in case of softkey2
         * @param aSoftKey softkey type
         */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                Display.setCurrent(previousFrame);
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aAction, int aParam) {}
    }
}