/**
 * J012_4101_0101.java
 * 
 * J012_4101_0101
 * MenuPanel
 * 
 * PhoneSystem class behavior checking(boundary test)
 * 
 * $Id: J012_4101_0101.java,v 1.2 2001/12/02 05:18:34 waka Exp $
 */

import com.nttdocomo.ui.*;

/**
 * PhoneSystem class behavior checking main class
 * @extends IApplication
 */
public class J012_4101_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * PhoneSystem class boundary testing menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    protected int maxInt = 0x7FFFFFFF;       /* the maximum of int */
    ListBox menu1 = null;
    ListBox menu2 = null;                    /* selection processing  menu */
    Button execButton = null;                /* execution button */
    TextBox resultBox;                       /* result display textbox */
    /* processing selection menu item(menu1,menu2,menu3) */
    String[] menu1Item = {
        "0.the argument is prescribed maximum value",
        "1.the argument is prescribed maximum value + 1",
        "2.the argument is non-prescribed maximum value",
        "3.the argument is prescribed minimum value",
        "4.the argument is prescribed minimum value - 1",
    };

    String[][] menu2Item = {
        /* menu of the maximum parameter within the prescribed */
        {
            "0.setAttribute",
        },
        /* menu of the maximum parameter +1 within the prescribed */
        {
            "0.setAttribute",
        },
        /* menu of the maximum parameter out of the prescribed */
        {
            "0.setAttribute1",
        },
        /* menu of the minimum parameter within the prescribed */
        {
            "0.setAttribute",
        },
        /* menu of the minimum parameter -1 within the prescribed */
        {
            "0.setAttribute",
        }
    };

    /**
     * MenuPanel class constructor
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * menu screen display
     */
    public void showMainPanel() {
        /* menu/sub title display */
        setTitle("API class boundary route");
        Label subTitle = new Label("PnomeSystem");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* create/add the component */
        menu1 = new ListBox(ListBox.CHOICE, 8);
        menu2 = new ListBox(ListBox.CHOICE, 4);
        execButton = new Button("execute");
        resultBox = new TextBox("", getWidth(), 3, TextBox.DISPLAY_ANY);
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        add(menu1);
        add(menu2);
        add(execButton);
        add(resultBox);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * behavior checking method. Display message n case of exception checking, otherwise, go to the checking Panel
     * @param  menu1Index index of menu1
     * @param  menu2Index index of menu2
     */
    void test(int menu1Index, int menu2Index) {

        boolean okFlag = false;
        Label testLabel = null;

        switch ( menu1Index ) {
        /* maximum parameter within the prescribed */
        case 0:
            switch ( menu2Index ) {
            case 0:
                try {
// J012_4101_0101
                    okFlag = true;
                    PhoneSystem.setAttribute(4, 0);
                } catch ( Exception e ) {
                    okFlag = false;
                    showMsg(e.toString());
                } catch ( Error e ) {
                    okFlag = false;
                    showMsg(e.toString());
                }
                if ( okFlag == true ) {
                    resultBox.setText("OK");
                }
                break;
            }
            break;
        /* maximum parameter +1 within the prescribed */
        case 1:
            switch ( menu2Index ) {
            case 0:
                try {
                    okFlag = true;
// J012_4101_0201
                    PhoneSystem.setAttribute(5, 0);
                } catch ( Exception e ) {
                    okFlag = false;
                    showMsg(e.toString());
                } catch ( Error e ) {
                    okFlag = false;
                    showMsg(e.toString());
                }
                if ( okFlag == true ) {
                    resultBox.setText("OK");
                }
                break;
            }
            break;
        /* maximum parameter within the prescribed */
        case 2:
            switch ( menu2Index ) {
            case 0:
                try {
// J012_4101_0301
                    PhoneSystem.setAttribute(0, maxInt);
                } catch ( IllegalArgumentException iae ) {
                    showMsg("\"OK\"IAE:" + iae.getMessage());
                } catch ( Exception e ) {
                    showMsg(e.toString());
                } catch ( Error e ) {
                    showMsg(e.toString());
                }
                break;
            }
            break;
        /* minimum parameter within the prescribed */
        case 3:
            switch ( menu2Index ) {
            case 0:
                try {
                    okFlag = true;
// J012_4102_0101
                    PhoneSystem.setAttribute(0, 0);
                } catch ( Exception e ) {
                    okFlag = false;
                    showMsg(e.toString());
                } catch ( Error e ) {
                    okFlag = false;
                    showMsg(e.toString());
                }
                if ( okFlag == true ) {
                    resultBox.setText("OK");
                }
                break;
            }
            break;
        /* the minimum of the parameter -1 within the prescribed */
        case 4:
            switch ( menu2Index ) {
            case 0:
                try {
// J012_4102_0201
                    PhoneSystem.setAttribute(0, -1);
                } catch ( IllegalArgumentException iae ) {
                    showMsg("\"OK\"IAE:" + iae.getMessage());
                } catch ( Exception e ) {
                    showMsg(e.toString());
                } catch ( Error e ) {
                    showMsg(e.toString());
                }
                break;
            }
            break;
        }
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {
    }

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when menu list(menu1) is selected , set the item(menu2) */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            resultBox.setText("");

            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
            }
        }
        /* when the execution button is pressed, store the 3 kinds of menu indexes to the variable and call the behavior checking method*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {

                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();

                test(menu1Index, menu2Index);

            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}
