/**
 * J012_4201_0101
 * MainPanel
 *
 * ShorTimer class boundary test
 *
 * $Id: J012_4201_0101.java,v 1.1 2001/11/30 04:46:51 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * ShorTimer class boundary test main class
 * @extends IApplication
 */
public class J012_4201_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * ShorTimer class boundary test main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.the argument's maximum value",
        "2.the argument is its minimum value",
        "3.the sign is reversed",
        "4.null argument"
    };
    String[][] subItems = {
        {
            "1.excess number",
            "2.time=MaxInt",
            "3.id=MaxInt"
        },
        {
            "1.time=0",
            "2.id=0"
        },
        {
            "1.time = negative value",
            "2.id=-1"
        },
        {
            "1.canvas=null"
        }
    };

    Label   classLabel       = new Label("ShortTimer boundary test");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * testing the selected menu
     */
    public void test() {
        /* create timer canvas */
        STimerCanvas sc = new STimerCanvas(this, menuList.getSelectedIndex(),
                                           menuList2.getSelectedIndex());
        /* display timer canvas */
        Display.setCurrent(sc);
    }
}


/**
 * ShorTimer class action check canvas
 * @extends Canvas
 */
class STimerCanvas extends Canvas {

    int fH, fD;
    int sH, sW;
    ShortTimer st = null;
    int count = 0;
    Frame   previous;
    int     idx1 = 0;
    int     idx2 = 0;
    boolean start = false;
    int maxInt = 0x7FFFFFFF;

   /**
     * STimerCanvas class constructor
     * @param prevFrame  mainPanel
     * @param anIdx1 menu of testing type
     * @param anIdx2 sub menu of testing type
     */
    public STimerCanvas(Frame prevFrame, int anIdx1, int anIdx2) {
        previous = prevFrame;
        idx1 = anIdx1;
        idx2 = anIdx2;
        setSoftLabel(Canvas.SOFT_KEY_1, "start");
        setSoftLabel(Canvas.SOFT_KEY_2, "back");
        fH = Font.getDefaultFont().getHeight();
        fD = Font.getDefaultFont().getDescent();
        sH = getHeight();
        sW = getWidth();
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

   /**
     * canvas drawing method
     * @param g Graphics object of canvas
     */
    public void paint(Graphics g) {
        g.lock();
        g.clearRect(0, 0, getWidth(), getHeight());
        g.unlock(true);
        drawText("timer test", 0, 0);
        drawText("timer", 0, 1);
    }

   /**
     * drawing method
     * @param text the character string which is displayed
     * @param x x coordinates of the position which is displayed
     * @param the number of lines from the position where it is drawn
     */
    public synchronized void drawText(String text, int x, int line) {
        Graphics g = getGraphics();
        Font f = Font.getDefaultFont();
        int len = text.length();
        int y = (line+1) * fH;
        int endindex = 0;
        int startindex = 0;
        g.lock();
        while (len > 0) {
        endindex = f.getLineBreak(text, startindex, len, sW-x);
        g.clearRect(x, y-fH, sW, fH);
        g.drawString(text.substring(startindex, endindex), x, y-fD);
        y += fH;
        len -= (endindex-startindex);
        startindex = endindex;
        }
        g.unlock(true);
    }

    /**
     * event receive method
     * @param aType event type
     * @param aParam Parameter of an event
     */
    public void processEvent(int type, int param) {
        /* timer event */
        if (type == Display.TIMER_EXPIRED_EVENT) {
            count++;
            drawText(String.valueOf(count), 50, 1);
        }

        /* key event */
        if (type == Display.KEY_RELEASED_EVENT) {
            switch (param) {
            /* when the start key is pushed */
            case Display.KEY_SOFT1:
                /* start testing */
                test();
                break;

            /* when the return key is pushed */
            case Display.KEY_SOFT2:
                /* destroy short timer */
                if( st != null ) {
                    st.dispose();
                }
                /* return to the main menu screen */
                Display.setCurrent(previous);
                break;
            }
        }
    }

    /**
     * boundary test execution method
     */
    public void test() {
        if( st != null ) {
            st.dispose();
        }

        switch( idx1 ) {
        case 0:         /* maximum parameter */
            switch( idx2 ) {
            case 0:
                // J012_4201_0201
                for( int i=0; i<99999; i++ ) {
                    try {
                        ShortTimer t = ShortTimer.getShortTimer(this,i,
                                        5000,true);
                        t.start();
                    } catch( UIException uie ) {
                        if( uie.getStatus() == UIException.NO_RESOURCES ) {
                            showDialog("OK:UIException.NO_RESOURCES at "+(i+1));
                        } else {
                            showDialog("NG:UIException."+uie.getStatus()+" at "+(i+1));
                        }
                        return;
                    } catch( Exception e) {
                        showDialog("NG:" + e.toString());
                        return;
                    }
                }
                showDialog("Why? no Exception after 99999");
                break;
            case 1:
                // J012_4201_0301
                try {
                    st = ShortTimer.getShortTimer(this,0,maxInt,true);
                    st.start();
                    showDialog("OK");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4201_0302
                try {
                    st = ShortTimer.getShortTimer(this,maxInt,1000,true);
                    st.start();
                    showDialog("OK");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 1:             /* parameter minimum */
            switch( idx2 ) {
            case 0:
                // J012_4202_0301
                try {
                    st = ShortTimer.getShortTimer(this,0,0,true);
                    st.start();
                } catch( Exception e) {
                    showDialog("NG:" + e.toString());
                    return;
                }
                drawText("resolution="+st.getResolution()+"ms", 0, 2);
                break;
            case 1:
                // J012_4202_0302
                try {
                    st = ShortTimer.getShortTimer(this,0,1000,true);
                    st.start();
                    showDialog("OK");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            }
            break;
        case 2:             /* signe reverse */
            switch( idx2 ) {
            case 0:
                // J012_4203_0101
                try {
                    ShortTimer t4 = ShortTimer.getShortTimer(this,1,-1000,true);
                    showDialog("NG:no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e) {
                    showDialog("NG:" + e.toString());
                    return;
                }
                break;
            case 1:
                // J012_4203_0102
                try {
                    st = ShortTimer.getShortTimer(this,-1,1000,true);
                    st.start();
                    showDialog("OK");
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e) {
                    showDialog("NG:" + e.toString());
                    return;
                }
                break;
            }
            break;
        case 3:             /* parameter null */
            // J012_4204_0101
            try {
                ShortTimer t3 = ShortTimer.getShortTimer(null,3,1000,true);
                showDialog("NG:no Exception");
            } catch( NullPointerException npe ) {
                showDialog("OK:NullPointerException");
            } catch( Exception e) {
                showDialog("NG:" + e.toString());
                return;
            }
            break;
        }
    }
}
