/**
 * J012_4401_0101
 * MainPanel
 *
 * TextBox class boundary test
 *
 * $Id: J012_4401_0101.java,v 1.2 2002/02/13 02:20:15 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class boundary test main class
 * @extends IApplication
 */
public class J012_4401_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class boundary test main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

   TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
    String[] subItems = {
            "1.TextBox",
            "2.setText",
    };

    Label   classLabel       = new Label("TextBox boundary test");
   // ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    TextBox testBox          = new TextBox("TextBox",8,1,TextBox.DISPLAY_ANY);
    int     maxInt           = 0x7FFFFFFF;
    int     sH;
    int     sW;
    boolean sizeFlag         = false;
    TextBox testObj          = new TextBox("T",1,1,TextBox.DISPLAY_ANY);
    TextBox left             = new TextBox("LEFT",4,1,TextBox.DISPLAY_ANY);
    TextBox right            = new TextBox("RIGHT",5,1,TextBox.DISPLAY_ANY);
    TextBox top              = new TextBox("    TOP",20,1,TextBox.DISPLAY_ANY);
    TextBox bottom           = new TextBox("   BOTTOM",20,1,TextBox.DISPLAY_ANY);

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
     //   menuList.setItems(menuListItem);
        menuList2.setItems(subItems);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
       add(textBox1);
        add(menuList2);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(testBox);

        /* get the size of the screen */
        /* 2002.02.13 update(Panel.getHeight()->Display.getHeight()) */
        sH = Display.getHeight();
        sW = Display.getWidth();

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
//        if (aComponent == menuList2
//            && aType == ComponentListener.SELECTION_CHANGED) {
//            /* sub menu setting */
//            menuList2.setItems(subItems[menuList2.getSelectedIndex()]);
//        }

        /* when  the execution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            	test1();
            }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * behavior in case of the maximum parameter
     */
    public void test1() {
        int idx = menuList2.getSelectedIndex();
        String	Str = new String("");
        Str = textBox1.getText();

                try {
                    if( idx == 0 ) {
//                   		String	inputString = "";
                        TextBox t = new TextBox(Str,16,4,TextBox.DISPLAY_ANY);
                        add(t);
                    } else {
                        testBox.setText(Str);
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
    }
}