/**
 * J012_4401_0103
 * MainPanel
 *
 * TextBox class boundary test
 *
 * $Id: J012_4401_0103.java,v 1.2 2002/02/13 02:20:15 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class boundary test main class
 * @extends IApplication
 */
public class J012_4401_0103 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class boundary test main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.the argument's maximum value",
        "2.parameter maximum +1",
        "3.non-prescribed maximum value",
        "4.parameter minimum",
        "5.parameter minimum -1",
        "6.minimum within the prescribed",
        "7.parameter -1",
        "8.parameter null"
    };
    String[][] subItems = {
        {
         
            "3.setBackground(max)",
            "4.setForeground(max)",
            "5.setLocation(x=max)",
            "6.setLocation(y=max)",
            "7.setLocation(max,max)",
            "8.setSize(w=max)",
            "9.setSize(h=max)",
            "10.setSize(max,max)"
        },
        {
       
            "3.setBackground(max+1)",
            "4.setForeground(max+1)",
            "5.setLocation(x=max+1)",
            "6.setLocation(y=max+1)",
            "7.setLocation(max+1,max+1)",
            "8.setSize(w=max+1)",
            "9.setSize(h=max+1)",
            "10.setSize(max+1,max+1)"
        },
        {
            "1.TextBox(col=MaxInt)",
            "2.TextBox(row=MaxInt)",
            "3.TextBox(MaxInt,MaxInt)",
            "4.TextBox(mode=MaxInt)",
            "5.setBackground(MaxInt)",
            "6.setForeground(MaxInt)",
            "7.setLocation(x=MaxInt)",
            "8.setLocation(y=MaxInt)",
            "9.setLocation(MaxInt,MaxInt)",
            "10.setSize(w=MaxInt)",
            "11.setSize(h=MaxInt)",
            "12.setSize(MaxInt,MaxInt)"
        },
        {
            "1.TextBox(col=0)",
            "2.TextBox(row=0)",
            "3.setBackground(min)",
            "4.setForeground(min)",
            "5.setSize(w=0)",
            "6.setSize(h=0)",
            "7.setSize(0,0)"
        },
        {
            "1.setBackground(min-1)",
            "2.setForeground(min-1)",
            "3.setSize(w=-1)",
            "4.setSize(h=-1)",
            "5.setSize(-1,-1)"
        },
        {
            "1.TextBox(0byte)",
            "2.setText(0byte)",
            "3.setLocation(x=0)",
            "4.setLocation(y=0)",
            "5.setLocation(0,0)"
        },
        {
            "1.TextBox(col=-1)",
            "2.TextBox(row=-1)",
            "3.TextBox(mode=-1)",
            "4.setLocation(x=-1)",
            "5.setLocation(y=-1)",
            "6.setLocation(-1,-1)"
        },
        {
            "1.TextBox(null)",
            "2.setText(null)",
        }
    };

    Label   classLabel       = new Label("TextBox boundary test");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    TextBox testBox          = new TextBox("TextBox",8,1,TextBox.DISPLAY_ANY);
    int     maxInt           = 0x7FFFFFFF;
    int     sH;
    int     sW;
    boolean sizeFlag         = false;
    TextBox testObj          = new TextBox("T",1,1,TextBox.DISPLAY_ANY);
    TextBox left             = new TextBox("LEFT",4,1,TextBox.DISPLAY_ANY);
    TextBox right            = new TextBox("RIGHT",5,1,TextBox.DISPLAY_ANY);
    TextBox top              = new TextBox("    TOP",20,1,TextBox.DISPLAY_ANY);
    TextBox bottom           = new TextBox("   BOTTOM",20,1,TextBox.DISPLAY_ANY);

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(testBox);

        /* get the size of the screen */
        /* 2002.02.13 update(Panel.getHeight()->Display.getHeight()) */
        sH = Display.getHeight();
        sW = Display.getWidth();

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the execution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            switch( menuList.getSelectedIndex() ) {
                case 0:
                    /* behavior in case of the maximum parameter */
                    test1();
                    break;
                case 1:
                    /* parameter maximum +1 */
                    test2();
                    break;
                case 2:
                    /* maximum parameter within the prescribed */
                    test3();
                    break;
                case 3:
                    /* parameter minimum */
                    test4();
                    break;
                case 4:
                    /* parameter minimum -1 */
                    test5();
                    break;
                case 5:
                    /* minimum parameter out of the prescribed */
                    test6();
                    break;
                case 6:
                    /* behavior in case of the parameter -1 */
                    test7();
                    break;
                case 7:
                    /* behavior in case of the parameter null */
                    test8();
                    break;
            }
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * behavior in case of the maximum parameter
     */
    public void test1() {
        int idx = menuList2.getSelectedIndex();

        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4401_0103
                /* with no break */
           
           // case 1:
                // J012_4401_0103
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        testBox.setBackground(c1);
                        testBox.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        testBox.setBackground(c2);
                        testBox.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4401_0104
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        testBox.setBackground(c2);
                        testBox.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        testBox.setBackground(c1);
                        testBox.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4401_0105
                setLayoutManager(null);
                try {
                    testBox.setLocation(sW,testBox.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4401_0106
                setLayoutManager(null);
                try {
                    testBox.setLocation(testBox.getX(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4401_0107
                setLayoutManager(null);
                try {
                    testBox.setLocation(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4401_0108
                try {
                    testBox.setSize(sW,testBox.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4401_0109
                try {
                    testBox.setSize(testBox.getWidth(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4401_0110
                try {
                    testBox.setSize(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter +1
     */
    public void test2() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
          //  case 0:
                // J012_4401_0201
                /* with no break */
         /*   case 1:
                // J012_4401_0202
                String str256 = new String("");
                for( int i=0; i<25; i++ ) {
                    str256 += "256byte   ";
                }
                str256 += "   END";
                if( str256.length() != 256 ) {
                    showDialog("NG:strlen="+ str256.length());
                    return;
                }
                try {
                    if( idx == 0 ) {
                        TextBox t = new TextBox(str256,16,4,TextBox.DISPLAY_ANY);
                        add(t);
                    } else {
                        testBox.setText(str256);
                    }
                } catch( OutOfMemoryError ome ) {
                    showDialog("OutOfMemoryError");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;*/
            case 0:
                // J012_4401_0203
                /* with no break */
            case 1:
                // J012_4401_0204
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 < c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 2 ) {
                        testBox.setBackground(c1+1);
                    } else {
                        testBox.setForeground(c1+1);
                    }
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4401_0205
                setLayoutManager(null);
                try {
                    testBox.setLocation(sW+1,testBox.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4401_0206
                setLayoutManager(null);
                try {
                    testBox.setLocation(testBox.getX(),sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4401_0207
                setLayoutManager(null);
                try {
                    testBox.setLocation(sW+1,sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4401_0208
                try {
                    testBox.setSize(sW+10,testBox.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4401_0209
                try {
                    testBox.setSize(testBox.getWidth(),sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4401_0210
                try {
                    testBox.setSize(sW+10,sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter out of the prescribed
     */
    public void test3() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4401_0301
                try {
                    TextBox t = new TextBox("col=MaxInt",maxInt,1,TextBox.DISPLAY_ANY);
                    add(t);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4401_0302
                try {
                    TextBox t = new TextBox("row=MaxInt",12,maxInt,TextBox.DISPLAY_ANY);
                    add(t);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4401_0303
                try {
                    TextBox t = new TextBox("col=row=MaxInt",maxInt,maxInt,TextBox.DISPLAY_ANY);
                    add(t);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4401_0304
                try {
                    TextBox t = new TextBox("mode=MaxInt",16,1,maxInt);
                    add(t);
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4401_0305
                /* with no break */
            case 5:
                // J012_4401_0306
                try {
                    if( idx == 4 ) {
                        testBox.setBackground(maxInt);
                    } else {
                        testBox.setForeground(maxInt);
                    }
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4401_0307
                setLayoutManager(null);
                try {
                    testBox.setLocation(maxInt,testBox.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4401_0308
                setLayoutManager(null);
                try {
                    testBox.setLocation(testBox.getX(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 8:
                // J012_4401_0309
                setLayoutManager(null);
                try {
                    testBox.setLocation(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 9:
                // J012_4401_0310
                try {
                    testBox.setSize(maxInt,testBox.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 10:
                // J012_4401_0311
                try {
                    testBox.setSize(testBox.getWidth(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 11:
                // J012_4401_0312
                try {
                    testBox.setSize(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter
     */
    public void test4() {
        int idx = menuList2.getSelectedIndex();

        if( sizeFlag == false && idx >= 4 && idx <= 6 ) {
            testBox.setSize(testBox.getWidth(),0);
            add(top);
            add(left);
            add(testObj);
            add(right);
            add(bottom);
            sizeFlag = true;
            showDialog("Please press the \"execute\" button again");
            return;
        }
        if( sizeFlag == true && idx >= 4 && idx <= 6 ) {
            left.setSize(left.getWidth(),3);
            right.setSize(right.getWidth(),3);
        }

        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4402_0101
                try {
                    TextBox t = new TextBox("col=0",0,1,TextBox.DISPLAY_ANY);
                    add(t);
//2002/09/27 Doja1.5                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4402_0102
                try {
                    TextBox t = new TextBox("row=0",16,0,TextBox.DISPLAY_ANY);
                    add(t);
//2002/09/27doja1.5                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4402_0103
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        testBox.setBackground(c1);
                        testBox.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        testBox.setBackground(c2);
                        testBox.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4402_0104
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        testBox.setBackground(c2);
                        testBox.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        testBox.setBackground(c1);
                        testBox.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4402_0105
                try {
                    testObj.setSize(0,testObj.getHeight());
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4402_0106
                try {
                    testObj.setSize(testObj.getWidth(),0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4402_0107
                try {
                    testObj.setSize(0,0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter -1
     */
    public void test5() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4402_0201
                /* with no break */
            case 1:
                // J012_4402_0202
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 > c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 0 ) {
                        testBox.setBackground(c1-1);
                    } else {
                        testBox.setForeground(c1-1);
                    }
                    showDialog("NG: no Excepption");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4402_0203
                try {
                    testBox.setSize(-1,testBox.getHeight());
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4402_0204
                try {
                    testBox.setSize(testBox.getWidth(),-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4402_0205
                try {
                    testBox.setSize(-1,-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum out of the prescribed
     */
    public void test6() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4402_0301
                try {
                    TextBox t = new TextBox("",16,1,TextBox.DISPLAY_ANY);
                    add(t);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4402_0302
                try {
                    testBox.setText("");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4402_0303
                setLayoutManager(null);
                try {
                    testBox.setLocation(0,testBox.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4402_0304
                setLayoutManager(null);
                try {
                    testBox.setLocation(testBox.getX(),0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4402_0305
                setLayoutManager(null);
                try {
                    testBox.setLocation(0,0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter -1
     */
    public void test7() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_4403_0101
                try {
                    TextBox t = new TextBox("columns=-1",-1,1,TextBox.DISPLAY_ANY);
                    showDialog("NG: Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4403_0102
                try {
                    TextBox t = new TextBox("rows=-1",12,-1,TextBox.DISPLAY_ANY);
                    showDialog("NG: Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4403_0103
                try {
                    TextBox t = new TextBox("mode=-1",12,1,-1);
                    showDialog("NG: Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4403_0104
                setLayoutManager(null);
                try {
                    testBox.setLocation(-10,testBox.getY());
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4403_0105
                setLayoutManager(null);
                try {
                    testBox.setLocation(testBox.getX(),-5);
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4403_0106
                setLayoutManager(null);
                try {
                    testBox.setLocation(-10,-5);
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter null
     */
    public void test8() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_4404_0101
                try {
                    TextBox t = new TextBox(null,16,1,TextBox.DISPLAY_ANY);
                    add(t);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4404_0102
                try {
                    testBox.setText(null);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }
}
