/**
 * J012_4501_0103
 * MainPanel
 *
 * Ticker class boundary test
 *
 * $Id: J012_4501_0103.java,v 1.1 2001/11/30 04:48:00 lan Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Ticker class boundary test main class
 * @extends IApplication
 */
public class J012_4501_0103 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Ticker class boundary test main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.the argument's maximum value",
        "2.parameter maximum +1",
        "3.non-prescribed maximum value",
        "4.parameter minimum",
        "5.parameter minimum -1",
        "6.minimum within the prescribed",
        "7.parameter -1",
        "8.parameter null"
    };
    String[][] subItems = {
        {
           
            "3.setBackground(max)",
            "4.setForeground(max)",
            "5.setLocation(x=max)",
            "6.setLocation(y=max)",
            "7.setLocation(max,max)",
            "8.setSize(w=max)",
            "9.setSize(h=max)",
            "10.setSize(max,max)"
        },
        {
           
            "3.setBackground(max+1)",
            "4.setForeground(max+1)",
            "5.setLocation(x=max+1)",
            "6.setLocation(y=max+1)",
            "7.setLocation(max+1,max+1)",
            "8.setSize(w=max+1)",
            "9.setSize(h=max+1)",
            "10.setSize(max+1,max+1)"
        },
        {
            "1.setBackground(MaxInt)",
            "2.setForeground(MaxInt)",
            "3.setLocation(x=MaxInt)",
            "4.setLocation(y=MaxInt)",
            "5.setLocation(MaxInt,MaxInt)",
            "6.setSize(w=MaxInt)",
            "7.setSize(h=MaxInt)",
            "8.setSize(MaxInt,MaxInt)"
        },
        {
            "1.setBackground(min)",
            "2.setForeground(min)",
            "3.setSize(w=0)",
            "4.setSize(h=0)",
            "5.setSize(0,0)"
        },
        {
            "1.setBackground(min-1)",
            "2.setForeground(min-1)",
            "3.setSize(w=-1)",
            "4.setSize(h=-1)",
            "5.setSize(-1,-1)"
        },
        {
            "1.Ticker(0byte)",
            "2.setText(0byte)",
            "3.setLocation(x=0)",
            "4.setLocation(y=0)",
            "5.setLocation(0,0)"
        },
        {
            "1.setLocation(x=-1)",
            "2.setLocation(y=-1)",
            "3.setLocation(-1,-1)"
        },
        {
            "1.Ticker(null)",
            "2.setText(null)",
        }
    };

    Label   classLabel       = new Label("Ticker boundary test");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    Ticker  ticker           = new Ticker("Ticker");
    int     maxInt           = 0x7FFFFFFF;
    int     sH;
    int     sW;
    boolean sizeFlag         = false;
    Ticker testObj           = new Ticker("T");
    Ticker left              = new Ticker("LEFT");
    Ticker right             = new Ticker("RIGHT");
    Ticker top               = new Ticker("TOP");
    Ticker bottom            = new Ticker("BOTTOM");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* get the size of the screen */
        sH = getHeight();
        sW = getWidth();

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(sW,execButton.getHeight());
        add(execButton);
        ticker.setSize(sW/2,ticker.getHeight());
        add(ticker);


        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            switch( menuList.getSelectedIndex() ) {
                case 0:
                    /* behavior in case of the maximum parameter */
                    test1();
                    break;
                case 1:
                    /* parameter maximum +1 */
                    test2();
                    break;
                case 2:
                    /* maximum parameter within the prescribed */
                    test3();
                    break;
                case 3:
                    /* parameter minimum */
                    test4();
                    break;
                case 4:
                    /* parameter minimum -1 */
                    test5();
                    break;
                case 5:
                    /* minimum parameter out of the prescribed */
                    test6();
                    break;
                case 6:
                    /* behavior in case of the parameter -1 */
                    test7();
                    break;
                case 7:
                    /* behavior in case of the parameter null */
                    test8();
                    break;
            }
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * behavior in case of the maximum parameter
     */
    public void test1() {
        int idx = menuList2.getSelectedIndex();

        /* execute each testing */
        switch( idx ) {
         
            case 0:
               
                // J012_4501_0103
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        ticker.setBackground(c1);
                        ticker.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        ticker.setBackground(c2);
                        ticker.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4501_0104
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        ticker.setBackground(c2);
                        ticker.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        ticker.setBackground(c1);
                        ticker.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4501_0105
                setLayoutManager(null);
                try {
                    ticker.setLocation(sW,ticker.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4501_0106
                setLayoutManager(null);
                try {
                    ticker.setLocation(ticker.getX(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4501_0107
                setLayoutManager(null);
                try {
                    ticker.setLocation(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4501_0108
                try {
                    ticker.setSize(sW,ticker.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4501_0109
                try {
                    ticker.setSize(ticker.getWidth(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4501_0110
                try {
                    ticker.setSize(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter +1
     */
    public void test2() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
          
            case 0:
        
                // J012_4501_0203
                /* with no break */
           	 case 1:
                // J012_4501_0204
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 < c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 2 ) {
                        ticker.setBackground(c1+1);
                    } else {
                        ticker.setForeground(c1+1);
                    }
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        	
            case 2:
                // J012_4501_0205
                setLayoutManager(null);
                try {
                    ticker.setLocation(sW+1,ticker.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4501_0206
                setLayoutManager(null);
                try {
                    ticker.setLocation(ticker.getX(),sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4501_0207
                setLayoutManager(null);
                try {
                    ticker.setLocation(sW+1,sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4501_0208
                try {
                    ticker.setSize(sW+10,ticker.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4501_0209
                try {
                    ticker.setSize(ticker.getWidth(),sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4501_0210
                try {
                    ticker.setSize(sW+10,sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter out of the prescribed
     */
    public void test3() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4501_0301
                /* with no break */
            case 1:
                // J012_4501_0302
                try {
                    if( idx == 0 ) {
                        ticker.setBackground(maxInt);
                    } else {
                        ticker.setForeground(maxInt);
                    }
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4501_0303
                setLayoutManager(null);
                try {
                    ticker.setLocation(maxInt,ticker.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4501_0304
                setLayoutManager(null);
                try {
                    ticker.setLocation(ticker.getX(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4501_0305
                setLayoutManager(null);
                try {
                    ticker.setLocation(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4501_0306
                try {
                    ticker.setSize(maxInt,ticker.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4501_0307
                try {
                    ticker.setSize(ticker.getWidth(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4501_0308
                try {
                    ticker.setSize(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter
     */
    public void test4() {
        int idx = menuList2.getSelectedIndex();

        if( sizeFlag == false && idx >= 2 && idx <= 4 ) {
            ticker.setSize(ticker.getWidth(),0);
            top.setSize(sW,top.getHeight());
            bottom.setSize(sW,bottom.getHeight());
            left.setSize(sW/3,left.getHeight());
            right.setSize(sW/3,right.getHeight());
            testObj.setSize(sW/4,testObj.getHeight());
            add(top);
            add(left);
            add(testObj);
            add(right);
            add(bottom);
            sizeFlag = true;
            showDialog("Please press the \"execute\" button again");
            return;
        }

        if( sizeFlag == true && idx >= 2 && idx <= 4 ) {
            left.setSize(left.getWidth(),3);
            right.setSize(right.getWidth(),3);
        }

        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4502_0101
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        ticker.setBackground(c1);
                        ticker.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        ticker.setBackground(c2);
                        ticker.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4502_0102
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        ticker.setBackground(c2);
                        ticker.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        ticker.setBackground(c1);
                        ticker.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4502_0103
                try {
                    testObj.setSize(0,testObj.getHeight());
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4502_0104
                try {
                    testObj.setSize(testObj.getWidth(),0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4502_0105
                try {
                    testObj.setSize(0,0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter -1
     */
    public void test5() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4502_0201
                /* with no break */
            case 1:
                // J012_4502_0202
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 > c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 0 ) {
                        ticker.setBackground(c1-1);
                    } else {
                        ticker.setForeground(c1-1);
                    }
                    showDialog("NG: no Excepption");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4502_0203
                try {
                    ticker.setSize(-1,ticker.getHeight());
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4502_0204
                try {
                    ticker.setSize(ticker.getWidth(),-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4502_0205
                try {
                    ticker.setSize(-1,-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum out of the prescribed
     */
    public void test6() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4502_0301
                try {
                    Ticker t = new Ticker("");
                    add(t);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4502_0302
                try {
                    ticker.setText("");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4502_0305
                setLayoutManager(null);
                try {
                    ticker.setLocation(0,ticker.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4502_0306
                setLayoutManager(null);
                try {
                    ticker.setLocation(ticker.getX(),0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4502_0307
                setLayoutManager(null);
                try {
                    ticker.setLocation(0,0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter -1
     */
    public void test7() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_4503_0103
                setLayoutManager(null);
                try {
                    ticker.setLocation(-10,ticker.getY());
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4503_0104
                setLayoutManager(null);
                try {
                    ticker.setLocation(ticker.getX(),-5);
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4503_0105
                setLayoutManager(null);
                try {
                    ticker.setLocation(-10,-5);
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter null
     */
    public void test8() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_4504_0101
                try {
                    Ticker t = new Ticker(null);
                    add(t);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4504_0102
                try {
                    ticker.setText(null);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }
}
