/**
 * J012_4701_0101
 * MainPanel
 *
 * VisualPresenter class boundary test
 *
 * $Id: J012_4701_0101.java,v 1.1 2001/11/30 04:50:10 lan Exp $
 */

import com.nttdocomo.lang.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * VisualPresenter class boundary test main class
 * @extends IApplication
 */
public class J012_4701_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * VisualPresenter class boundary test main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.the argument's maximum value",
        "2.parameter maximum +1",
        "3.non-prescribed maximum value",
        "4.parameter minimum",
        "5.parameter minimum -1",
        "6.minimum within the prescribed",
        "7.parameter -1",
        "8.parameter null"
    };
    String[][] subItems = {
        {
            "1.setAttribute(X=max)",
            "2.setAttribute(Y=max)",
            "3.setBackground(max)",
            "4.setForeground(max)",
            "5.setLocatin(x=max)",
            "6.setLocatin(y=max)",
            "7.setLocatin(max,max)",
            "8.setSize(w=max)",
            "9.setSize(h=max)",
            "10.setSize(max,max)"
        },
        {
            "1.setAttribute(X=max+1)",
            "2.setAttribute(Y=max+1)",
            "3.setBackground(max+1)",
            "4.setForeground(max+1)",
            "5.setLocatin(x=max+1)",
            "6.setLocatin(y=max+1)",
            "7.setLocatin(max+1,max+1)",
            "8.setSize(w=max+1)",
            "9.setSize(h=max+1)",
            "10.setSize(max+1,max+1)"
        },
        {
            "1.setAttribute(X=MaxInt)",
            "2.setAttribute(Y=MaxInt)",
            "3.setBackground(MaxInt)",
            "4.setForeground(MaxInt)",
            "5.setLocatin(x=MaxInt)",
            "6.setLocatin(y=MaxInt)",
            "7.setLocatin(MaxInt,MaxInt)",
            "8.setSize(w=MaxInt)",
            "9.setSize(h=MaxInt)",
            "10.setSize(MaxInt,MaxInt)"
        },
        {
            "1.setAttribute(X=0)",
            "2.setAttribute(Y=0)",
            "3.setBackground(min)",
            "4.setForeground(min)",
            "5.setSize(w=0)",
            "6.setSize(h=0)",
            "7.setSize(0,0)"
        },
        {
            "1.setBackground(min-1)",
            "2.setForeground(min-1)",
            "3.setSize(w=-1)",
            "4.setSize(h=-1)",
            "5.setSize(-1,-1)"
        },
        {
            "1.setLocation(x=0)",
            "2.setLocaiton(y=0)",
            "3.setLocaiton(0,0)"
        },
        {
            "1.setAttribute(X=-1)",
            "2.setAttribute(Y=-1)",
            "3.setLocation(x=-1)",
            "4.setLocaiton(y=-1)",
            "5.setLocaiton(-1,-1)"
        },
        {
            "1.setImage(null)",
            "2.setData(null)",
        }
    };

    Label   classLabel       = new Label("VisualPresenter boudary test");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");
    VisualPresenter vp       = new VisualPresenter();
    MediaImage  mi           = null;
    String  filename         = new String("89aT-8.gif");
    int     maxInt           = 0x7FFFFFFF;
    int     sH;
    int     sW;
    boolean sizeFlag         = false;
    boolean attrFlag         = false;
    VisualPresenter testObj  = new VisualPresenter();
    Ticker left              = new Ticker("LEFT");
    Ticker right             = new Ticker("RIGHT");
    Ticker top               = new Ticker("TOP");
    Ticker bottom            = new Ticker("BOTTOM");

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("API class boundary route");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* get the size of the screen */
        sH = getHeight();
        sW = getWidth();

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(menuList2);
        execButton.setSize(sW,execButton.getHeight());
        add(execButton);
        add(vp);

        /* display initial animation */
        try {
            mi = MediaManager.getImage("resource:///"+filename);
            mi.use();
            vp.setImage(mi);
            vp.setSize(mi.getWidth()+10,mi.getHeight()+10);
            int c = Graphics.getColorOfName(Graphics.BLUE);
            vp.setBackground(c);
            vp.play();
        } catch (Exception e) {
            mi = null;
            showDialog("VisualPresenter cannot be continued:"+e.toString());
        }

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }


    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            switch( menuList.getSelectedIndex() ) {
                case 0:
                    /* behavior in case of the maximum parameter */
                    test1();
                    break;
                case 1:
                    /* parameter maximum +1 */
                    test2();
                    break;
                case 2:
                    /* maximum parameter within the prescribed */
                    test3();
                    break;
                case 3:
                    /* parameter minimum */
                    test4();
                    break;
                case 4:
                    /* parameter minimum -1 */
                    test5();
                    break;
                case 5:
                    /* minimum parameter out of the prescribed */
                    test6();
                    break;
                case 6:
                    /* behavior in case of the parameter -1 */
                    test7();
                    break;
                case 7:
                    /* behavior in case of the parameter null */
                    test8();
                    break;
            }
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * behavior in case of the maximum parameter
     */
    public void test1() {
        int idx = menuList2.getSelectedIndex();

        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4701_0101
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_XPOS,mi.getWidth());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
            case 1:
                // J012_4701_0102
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_YPOS,mi.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4701_0103
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        vp.setBackground(c1);
                        vp.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        vp.setBackground(c2);
                        vp.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4701_0104
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 > c2 ) {
                        vp.setBackground(c2);
                        vp.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        vp.setBackground(c1);
                        vp.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4701_0105
                setLayoutManager(null);
                try {
                    vp.setLocation(sW,vp.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4701_0106
                setLayoutManager(null);
                try {
                    vp.setLocation(vp.getX(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4701_0107
                setLayoutManager(null);
                try {
                    vp.setLocation(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4701_0108
                try {
                    vp.setSize(sW,vp.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 8:
                // J012_4701_0109
                try {
                    vp.setSize(vp.getWidth(),sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 9:
                // J012_4701_0110
                try {
                    vp.setSize(sW,sH);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter +1
     */
    public void test2() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4701_0201
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_XPOS,mi.getWidth()+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4701_0202
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_YPOS,mi.getHeight()+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4701_0203
                /* with no break */
            case 3:
                // J012_4701_0204
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 < c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 2 ) {
                        vp.setBackground(c1+1);
                    } else {
                        vp.setForeground(c1+1);
                    }
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4701_0205
                setLayoutManager(null);
                try {
                    vp.setLocation(sW+1,vp.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4701_0206
                setLayoutManager(null);
                try {
                    vp.setLocation(vp.getX(),sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4701_0207
                setLayoutManager(null);
                try {
                    vp.setLocation(sW+1,sH+1);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4701_0208
                try {
                    vp.setSize(sW+10,vp.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 8:
                // J012_4701_0209
                try {
                    vp.setSize(vp.getWidth(),sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 9:
                // J012_4701_0210
                try {
                    vp.setSize(sW+10,sH+10);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the maximum parameter out of the prescribed
     */
    public void test3() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4701_0301
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_XPOS,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4701_0302
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_YPOS,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4701_0303
                /* with no break */
            case 3:
                // J012_4701_0304
                try {
                    if( idx == 2 ) {
                        vp.setBackground(maxInt);
                    } else {
                        vp.setForeground(maxInt);
                    }
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4701_0305
                setLayoutManager(null);
                try {
                    vp.setLocation(maxInt,vp.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4701_0306
                setLayoutManager(null);
                try {
                    vp.setLocation(vp.getX(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4701_0307
                setLayoutManager(null);
                try {
                    vp.setLocation(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 7:
                // J012_4701_0308
                try {
                    vp.setSize(maxInt,vp.getHeight());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 8:
                // J012_4701_0309
                try {
                    vp.setSize(vp.getWidth(),maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 9:
                // J012_4701_0310
                try {
                    vp.setSize(maxInt,maxInt);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter
     */
    public void test4() {
        int idx = menuList2.getSelectedIndex();

        if( attrFlag == false && idx >=0 && idx <=1 ) {
            vp.setAttribute(VisualPresenter.IMAGE_XPOS,20);
            vp.setAttribute(VisualPresenter.IMAGE_YPOS,20);
            attrFlag = true;
            showDialog("Please press the \"execute\" button again");
            return;
        }

        if( sizeFlag == false && idx >= 4 && idx <= 6 ) {
            vp.setSize(vp.getWidth(),0);
            top.setSize(sW,top.getHeight());
            bottom.setSize(sW,bottom.getHeight());
            left.setSize(sW/3,left.getHeight());
            right.setSize(sW/3,right.getHeight());
            testObj.setSize(sW/4,testObj.getHeight());
            add(top);
            add(left);
            add(testObj);
            add(right);
            add(bottom);
            sizeFlag = true;
            if( mi != null ) {
                testObj.setImage(mi);
                testObj.play();
            }
            showDialog("Please press the \"execute\" button again");
            return;
        }

        if( sizeFlag == true && idx >= 4 && idx <= 6 ) {
            left.setSize(left.getWidth(),3);
            right.setSize(right.getWidth(),3);
        }

        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4702_0101
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_XPOS,0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4702_0102
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_YPOS,0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4702_0103
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        vp.setBackground(c1);
                        vp.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    } else {
                        vp.setBackground(c2);
                        vp.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4702_0104
                c1 = Graphics.getColorOfRGB(0,0,0);
                c2 = Graphics.getColorOfRGB(255,255,255);
                try {
                    if( c1 < c2 ) {
                        vp.setBackground(c2);
                        vp.setForeground(c1);
                        showDialog("background color is white, foreground color is black");
                    } else {
                        vp.setBackground(c1);
                        vp.setForeground(c2);
                        showDialog("background color is black, foreground color is white");
                    }
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4702_0105
                try {
                    testObj.setSize(0,testObj.getHeight());
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 5:
                // J012_4702_0106
                try {
                    testObj.setSize(testObj.getWidth(),0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 6:
                // J012_4702_0107
                try {
                    testObj.setSize(0,0);
                } catch( IllegalArgumentException iae ) {
                    showDialog("NG:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum parameter -1
     */
    public void test5() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4702_0201
                /* with no break */
            case 1:
                // J012_4702_0202
                int c1 = Graphics.getColorOfRGB(0,0,0);
                int c2 = Graphics.getColorOfRGB(255,255,255);
                if( c1 > c2 ) {
                    c1 = c2;
                }
                try {
                    if( idx == 0 ) {
                        vp.setBackground(c1-1);
                    } else {
                        vp.setForeground(c1-1);
                    }
                    showDialog("NG: no Excepption");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4702_0203
                try {
                    vp.setSize(-1,vp.getHeight());
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4702_0204
                try {
                    vp.setSize(vp.getWidth(),-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4702_0205
                try {
                    vp.setSize(-1,-1);
                    showDialog("NG: no Exception");
                } catch( IllegalArgumentException iae ) {
                    showDialog("OK:IllegalArgumentException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the minimum out of the prescribed
     */
    public void test6() {
        int idx = menuList2.getSelectedIndex();
        /* execute each testing */
        switch( idx ) {
            case 0:
                // J012_4702_0303
                setLayoutManager(null);
                try {
                    vp.setLocation(0,vp.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4702_0304
                setLayoutManager(null);
                try {
                    vp.setLocation(vp.getX(),0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4702_0305
                setLayoutManager(null);
                try {
                    vp.setLocation(0,0);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter -1
     */
    public void test7() {
        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_4703_0101
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_XPOS,-20);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4703_0102
                try {
                    vp.setAttribute(VisualPresenter.IMAGE_YPOS,-20);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 2:
                // J012_4703_0105
                setLayoutManager(null);
                try {
                    vp.setLocation(-20,vp.getY());
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 3:
                // J012_4703_0106
                setLayoutManager(null);
                try {
                    vp.setLocation(vp.getX(),-20);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 4:
                // J012_4703_0107
                setLayoutManager(null);
                try {
                    vp.setLocation(-20,-20);
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }


    /**
     * behavior in case of the parameter null
     */
    public void test8() {
        try {
            vp.stop();
        } catch( Exception e ) {}

        /* execute each testing */
        switch( menuList2.getSelectedIndex() ) {
            case 0:
                // J012_4704_0101
                try {
                    vp.setImage(null);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("OK:NullPointerException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
            case 1:
                // J012_4704_0102
                try {
                    vp.setData(null);
                    showDialog("NG: no Exception");
                } catch( NullPointerException npe ) {
                    showDialog("OK:NullPointerException");
                } catch( UnsupportedOperationException uoe ) {
                    showDialog("UnsupportedOperationException");
                } catch( Exception e ) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }
}
