/**
 * J013_0201_0101
 *
 * ConnectionException repeating behavior checking
 *
 * $Id: J013_0201_0101.java,v 1.1 2002/01/07 01:45:22 hoshi Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * ConnectionException repeating behavior checking main class
 * @extends IApplication
 */
public class J013_0201_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * ConnectionException repeating behavior checking main screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menuList[]={
            "getStatus()"
        };

        int status;
        Label title;
        ListBox menu;
        Button exe;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class normal route");
            title=new Label("HttpConnection logical exception 2");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menuList);
            add(menu);
            exe = new Button("execute");
            add(exe);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);

        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {}

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType,
            int aParam) {
            /* when menu1 is choiced */
            if( aComponent == menu && aType == 
                ComponentListener.SELECTION_CHANGED ) {
            }

            /* when  the exsecution button is pushed */
            if (aComponent == exe && aType == 
                ComponentListener.BUTTON_PRESSED) {
                /* test the menu which is choiced */
                test(menu.getSelectedIndex());
            }
        }

        /**
         * dialog display method
         * @param   aText chalacter sequence which is displaied
         */
        public void showDialog(String aText) {
            Dialog  d = new Dialog(Dialog.BUTTON_OK, "notification");
            d.setText(aText);
            d.show();
        }

        /**
         * test the method action of HttpConnection
         * @param anIndex Index of the menu which is choiced
         */
        public void test(int anIndex) {
            HttpConnection  con=null;
            ConnectionException conEx = new ConnectionException();
            String          filename="J013_0201_0101.jam";

            switch( anIndex ) {
                case 0:         
                    try {
                        con=(HttpConnection) Connector.open(getSourceURL()+
                            filename,Connector.READ, true);
                        showDialog("NG: no Exception");
                    } catch (SecurityException e ) {
                    } catch( Exception e1 ) {
                    }
                    break;
                default:
                    break;
            }
            
            /* getStatus() */
            // J013_0201_0101
            for (int i = 0; i < 100; i++) {
                status = conEx.getStatus();
            }
            showDialog("OK : " + status);
        }
    }
}
