/**
 * J013_0901_0101
 * MainPanel
 *
 * URLDecoder repeat testing
 *
 * $Id: J013_0901_0101.java,v 1.1 2002/01/07 07:29:39 lan Exp $
 */
import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;


/**
 * URLDecoder repeat testing main class
 * @extends IApplication
 */
public class J013_0901_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * URLDecoder repeat testing main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.encode"
    };

    Label   classLabel       = new Label("URLEncoder");
    ListBox menuList         = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("execute");


    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* display of the main panel */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * display the main panel
     */
    void showMainPanel() {

        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class repeatability test");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        add(execButton);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }


    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }


    /**
     * test the choiced encode
     */
    public void test() {
        int MaxLoop = 100;
        int i;

        switch( menuList.getSelectedIndex() ) {
            case 0:
                // J013_0901_0101
                String orgStr = new String("abc");
                String deStr = URLDecoder.decode(orgStr);
                for( i=0; i<MaxLoop; i++ ) {
                    String enStr1 = URLEncoder.encode(orgStr);
                    if( enStr1.compareTo(deStr) != 0 ) {
                        showDialog("NG" + i + ":different encode outcome");
                        break;
                    }
                }
                if( i == MaxLoop ) {
                    showDialog("OK");
                }
        }
    }
}
