/**
 * J013_1501_0101
 * 
 * MainPanel
 * 
 * ComponentListener class behavior checking (repeatability)
 * 
 * $Id: J013_1501_0101.java,v 1.1 2002/01/07 08:26:50 misato Exp $
 */
 
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * ComponentListener class action check main class
 * @extends IApplication
 */
public class J013_1501_0101 extends IApplication{
    /**
     * starting method for I-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * ComponentListener class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    Frame subFrame;
    Label classLabel = new Label("ComponentListener");
    Button execButton = new Button("execute");
    TextBox resultBox = new TextBox("",20,3,TextBox.DISPLAY_ANY);
    int count = 0;
    
    /**
     * constructer of the MainPanel
     */
    public MainPanel(){
        try{
            /* display the MainPanel */
            showMainPanel();
        }catch(Exception anException){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
            errDialog.setText("Error:"+anException.toString());
            errDialog.show();
        }
    }
    
    /**
     * display the main panel
     */
    void showMainPanel(){
        /* setting of the display item */
        setTitle("API repeatability test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        
        /* add on each component */
        add(classLabel);
        add(execButton);
        add(resultBox);
        
        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /**
     * do nothing when the softkey is pushed
     */
    public void softKeyPressed(int anIndex){}
    
    /**
     * terminate the application when the softkey is released
     */
    public void softKeyReleased(int anIndex){
        /* processing when the softkey1 is released */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }
    
    /**
     * get the event on a component
     * @param aComponent the component on which an event occurred
     * @param aType event type
     * @param aParam event parameter
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        /* processing when the execution button is pushed */
        if(aComponent == execButton && aType == ComponentListener.BUTTON_PRESSED){
            //J013_1501_0101
            count++;
            if(count<100){
                resultBox.setText("the button is pressed for the"+count+"th time");
            }else if(count == 100){
                resultBox.setText("OK : "+count+"th time");
            }
        }
    }
}