/**
 * J013_1601_0101
 * MainPanel
 *
 * Dialog class repeatability test
 *
 * $Id: J013_1601_0101.java,v 1.1 2001/12/29 02:01:05 ohkoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Button class repeatability test main class
 * @extends IApplication
 */
public class J013_1601_0101 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Dialog class repeatability test main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "1.setBackground",
        "2.setText",
        "3.setSoftLabel",
        "4.getWidth",
        "5.getHeight"
    };

    Label        classLabel       = new Label("Dialog");
    ListBox      menuList         = new ListBox(ListBox.CHOICE);
    Button       execButton       = new Button("execute");
    int          sH;
    int          sW;

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class repeatability test");
        setSoftLabel(SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(classLabel);
        add(menuList);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);

        /* get the size of the screen */
        sH = getHeight();
        sW = getWidth();

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex index of the key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     * @param anIndex index of the key
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when  the exsecution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            /* execute testing */
            test();
        }
    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * repeat testing method
     */
    public void test() {
        int idx = menuList.getSelectedIndex();
        int Loop = 100;
        int i;
        int n=0;
        Dialog testDialog = new Dialog(Dialog.DIALOG_INFO,"Dialog");

        /* execute each testing */
        switch( idx ) {
// J013_1601_0101
            case 0:
                for( i=0; i<Loop; i++ ) {
                    testDialog.setBackground(Graphics.getColorOfName(Graphics.YELLOW));
                }
                if( i == Loop ){
                    testDialog.setText("if the yellow dialog is displayed, OK");
                    testDialog.show();
                }
                break;
// J013_1601_0102
            case 1:
                for( i=0; i<Loop; i++ ) {
                    testDialog.setText(i+"times repetition OK");
                }
                if( i == Loop ){
                    testDialog.setText("100 times repetition OK");
                    testDialog.show();
                }
                break;
// J013_1601_0103
            case 2:
                for( i=0; i<Loop; i++ ) {
                    testDialog.setSoftLabel(Dialog.SOFT_KEY_1,"soft key");
                }
                if( i == Loop ){
                    testDialog.setText("if the soft key label is not changed, OK");
                    testDialog.show();
                }
                break;
// J013_1601_0104
            case 3:
                int w0 = testDialog.getWidth();
                for( i=0; i<Loop; i++ ) {
                    int w = testDialog.getWidth();
                    if( w != w0 ) {
                        showDialog("NG:getWidth=" + w + " w0=" + w0);
                        break;
                    }
                }
                if( i == Loop ) {
                    showDialog("OK");
                }
                break;
// J013_1601_0105
            case 4:
                int h0 = testDialog.getHeight();
                for( i=0; i<Loop; i++ ) {
                    int h = testDialog.getHeight();
                    if( h != h0 ) {
                        showDialog("NG:getHeight=" + h + " h0=" + h0);
                        break;
                    }
                }
                if( i == Loop ) {
                    showDialog("OK");
                }
                break;
        }
    }
}



