/**
 * J013_2401_0101
 *
 * Image class behavior checking(repeat)
 *
 * $Id: J013_2401_0101.java,v 1.1 2001/12/29 02:00:52 horikoshi Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.lang.*;
import java.util.*;

/**
 * Image class repeating checking main class
 * @extends IApplication
 */
public class J013_2401_0101 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Image class repeating checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menu1 = {
//2002/07/26 DoJa1.5        "01 createImage",
        "02 getWidth",
        "03 getHeight",
//2002/07/26 DoJa1.5        "04 dispose",
        "04 dispose"
//2002/07/26 DoJa1.5        "05 getGraphics"
    };

    Frame      nextFrame;
    Label      title      = new Label("Image loop test");
    ListBox    menu_Li    = new ListBox(ListBox.CHOICE);
    Button     execButton = new Button("execute");
    Graphics   grp;
    Image      img[] = new Image[100];
    Image      img2;
    int        firstType;

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
        menu_Li.setItems(menu1);
        setTitle("API class loop test");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        add(title);
        add(menu_Li);
        add(execButton);
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * process when the action other than softkey happens
     * @param source the component on which the event occurs
     * @param type event type
     * @param param event parameter
     */
    public void componentAction(Component source, int type, int param) {

        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {

            /* get the chosen item */
            firstType = menu_Li.getSelectedIndex();
            /* display the result  */
            showResult();
        }
    }

    /**
     * method which display the result
     */
    public void showResult() {

        int    cont=0;
        int    num =0;
        int    num2=0;

	MediaImage mi;		//2002/07/26 DoJa1.5
	try {				//2002/07/26 DoJa1.5
		mi = MediaManager.getImage("resource:///dosei.jpeg");	//2002/07/26 DoJa1.5
			/* get the image file from JAR */
		mi.use();		//2002/07/26 DoJa1.5
			/* load the image file into the memory */
		img2 = mi.getImage();		//2002/07/26 DoJa1.5

//J013_2401_0101
        /* createImage repeating  */
//2002/07/26 DoJa1.5        if (firstType == 0) {
//2002/07/26 DoJa1.5            try {
//2002/07/26 DoJa1.5                for (cont=0; cont<100; cont++){
//2002/07/26 DoJa1.5                    img[cont] = Image.createImage(10,10);
//2002/07/26 DoJa1.5                }
//2002/07/26 DoJa1.5            } catch (Exception e) {
//2002/07/26 DoJa1.5                showDialog(e.toString()+":"+cont+"loop");
//2002/07/26 DoJa1.5            }

//J013_2401_0201
        /* getWidth repeating */
//2002/07/26 DoJa1.5        } else if (firstType == 1) {
 if (firstType == 0) {	//2002/07/26 DoJa1.5
//            img2 = Image.createImage(50,50);
            num = img2.getWidth();
            num2 = num;
            try {
                for (cont=0; cont<100 && num2==num; cont++) {
                    num = img2.getWidth();
                }
            } catch (Exception e) {
                showDialog(e.toString()+":"+cont+"loop");
            }

//J013_2401_0301
        /* repeating getHeight */
//2002/07/26 DoJa1.5        } else if (firstType == 2) {
} else if (firstType == 1) {	//2002/07/26 DoJa1.5
//2002/07/26 DoJa1.5            img2 = Image.createImage(60,60);
            num = img2.getHeight();
            num2 = num;
            try {
                for (cont=0; cont<100 && num2==num; cont++) {
                    num = img2.getHeight();
                }
            } catch (Exception e) {
                showDialog(e.toString()+":"+cont+"loop");
            }

//J013_2401_0401
        /* dispose repeating */
//2002/07/26 DoJa1.5        } else if (firstType == 3) {
        } else if (firstType == 2) {	//2002/07/26 DoJa1.5
//2002/07/26 DoJa1.5            img2 = Image.createImage(60,60);
            img2.dispose();
            try {
                for (cont=0; cont<100; cont++) {
                    img2.dispose();
                }
            } catch (Exception e) {
                showDialog(e.toString()+":"+cont+"loop");
            }
        }
        //J013_2401_0501
        /* getGraphics repeating */
//2002/07/26 DoJa1.5        } else if (firstType == 4) {
//2002/07/26 DoJa1.5            img2 = Image.createImage(1,1);
//2002/07/26 DoJa1.5            try {
//2002/07/26 DoJa1.5                for(cont=0; cont<100; cont++){
//2002/07/26 DoJa1.5                    grp = img2.getGraphics();
//2002/07/26 DoJa1.5                }
//2002/07/26 DoJa1.5            } catch (Exception e) {
//2002/07/26 DoJa1.5                showDialog(e.toString()+":"+cont+"loop");
//2002/07/26 DoJa1.5            }
	} catch (Exception e) {		//2002/07/26 DoJa1.5
		Dialog errorDialog = new Dialog(Dialog.DIALOG_ERROR,"loading the image failed.");	//2002/07/26 DoJa1.5
	}	//2002/07/26 DoJa1.5

        if (cont == 100) {
            showDialog(cont+" loop OK!");
        } else {
            showDialog(cont+" loop NG!");
        }
    }

    /**
     * setting of the dialog box which is going to be displayed
     * @param str the message on the dialog
     */
    public void showDialog(String str) {
        /* create the dialog box */
        Dialog d = new Dialog(Dialog.BUTTON_OK, "result");
        /* put the character sequence */
        d.setText(str);
        /* display of the dialog box */
        d.show();
    }
}