/**
 * J013_4101_0101
 * 
 * MainPanel
 * 
 * PhoneSystem class behavior checking (repeatability)
 * 
 * $Id: J013_4101_0101.java,v 1.1 2002/01/07 08:27:39 misato Exp $
 */
 
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import java.util.*;

/**
 * PhoneSystem class behavior checking main class
 * @extends IApplication
 */
public class J013_4101_0101 extends IApplication{
    /**
     * starting method for I-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * PhoneSystem class action check main screen
 * @extends IApplication
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    String[] menuListItem = {
        "1.test 1",
//2002/07/25 DoJa1.5        "",
//2002/07/25 DoJa1.5        "",
        "4.test 4"
    };
    
    Frame subFrame;
    Label classLabel = new Label("PhoneSystem");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultBox = new TextBox("",20,3,TextBox.DISPLAY_ANY);
    Button execButton = new Button("execute");
    
    /**
     * constructer of the MainPanel
     */
    public MainPanel(){
        try{
            /* display the MainPanel */
            showMainPanel();
        }catch(Exception anException){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
            errDialog.setText("Error:"+anException.toString());
            errDialog.show();
        }
    }
    
    /**
     * display the main panel
     */
    void showMainPanel(){
        /* setting of the display item */
        menuList.setItems(menuListItem);
        setTitle("API class repeatability test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        
        /* add each component to the screen */
        add(classLabel);
        add(menuList);
        add(execButton);
        add(resultBox);
        
        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /**
     * do nothing when the softkey is pressed
     */
    public void softKeyPressed(int anIndex){}
    
    /**
     * terminate the application when the softkey is released
     */
    public void softKeyReleased(int anIndex){
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }
    
    /**
     * get the event on a component
     * @param aComponent the component on which an event occurred
     * @param aType event type
     * @param aParam event parameter
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        /* processing when the list choice is changed */
        if(aComponent == menuList && aType == ComponentListener.SELECTION_CHANGED){
            resultBox.setText("");
        }
        
        int index = menuList.getSelectedIndex();
        /* processing when the execution button is pushed */
        if(aComponent == execButton && aType == ComponentListener.BUTTON_PRESSED){
            test();
        }
    }
    
    /**
     * create the test method
     * each method when the excecution button is pushed
     */
    public void test(){
        int index = menuList.getSelectedIndex();
        switch(index){
            //J013_4101_0101
            case 0:
                try{
                    //int j;
                    int aRest = 0;
                    for(int i = 0;i<=100;i++){
                        aRest = i%2;
                        if (aRest == 0){
                            PhoneSystem.setAttribute(0,0);
                        }else{
                            PhoneSystem.setAttribute(0,1);
                        }
                        
                        if(i<100){
                            resultBox.setText(i+"th time");
                        }else if(i == 100){
                            resultBox.setText("OK : "+i+"th time");
                        }
                    }
                }catch(Exception anException){
                    resultBox.setText("NG : " +anException.toString());
                    break;
                }
                break;
                
            //J013_4101_0201
//2002/07/25 DoJa1.5            case 1:
//2002/07/25 DoJa1.5                try{
//2002/07/25 DoJa1.5                    int j=0;
//2002/07/25 DoJa1.5                    int k=0;
//2002/07/25 DoJa1.5                    
//2002/07/25 DoJa1.5                    j = PhoneSystem.getAttribute(PhoneSystem.DEV_BACKLIGHT);
//2002/07/25 DoJa1.5                    
//2002/07/25 DoJa1.5                    for(int i = 0;i<=100;i++){
//2002/07/25 DoJa1.5                        k = PhoneSystem.getAttribute(PhoneSystem.DEV_BACKLIGHT);
//2002/07/25 DoJa1.5                        
//2002/07/25 DoJa1.6                        /*  */
//2002/07/25 DoJa1.5                        if(j != k){
//2002/07/25 DoJa1.5                            resultBox.setText("NG");
//2002/07/25 DoJa1.5                            return;
//2002/07/25 DoJa1.5                        }
                        
//2002/07/25 DoJa1.5                        /*  */
//2002/07/25 DoJa1.5                        if(i == 100){
//2002/07/25 DoJa1.6                            resultBox.setText("OK : "+i+"");
//2002/07/25 DoJa1.5                        }
//2002/07/25 DoJa1.5                    }
//2002/07/25 DoJa1.5                }catch(Exception anException){
//2002/07/25 DoJa1.5                    resultBox.setText("NG : " +anException.toString());
//2002/07/25 DoJa1.5                    break;
//2002/07/25 DoJa1.5                }
//2002/07/25 DoJa1.5                break;
                
            //J013_4101_0301
//2002/07/25 DoJa1.5            case 2:
//2002/07/25 DoJa1.5                try{
//2002/07/25 DoJa1.5                    for(int i = 0;i<=100;i++){
//2002/07/25 DoJa1.5                        if(PhoneSystem.isAvailable(0) == true){
//2002/07/25 DoJa1.5                            if(i<100){
//2002/07/25 DoJa1.6                                resultBox.setText(i+" : TRUE");
//2002/07/25 DoJa1.5                            }else if(i == 100){
//2002/07/25 DoJa1.6                                resultBox.setText("OK : "+i+" : TRUE");
//2002/07/25 DoJa1.5                            }
//2002/07/25 DoJa1.5                        }else if(PhoneSystem.isAvailable(0) == false){
//2002/07/25 DoJa1.5                            if(i<100){
//2002/07/25 DoJa1.6                                resultBox.setText(i+" : FALSE");
//2002/07/25 DoJa1.5                            }else if(i == 100){
//2002/07/25 DoJa1.6                                resultBox.setText("OK : "+i+" : FALSE");
//2002/07/25 DoJa1.5                            }
//2002/07/25 DoJa1.5                        }
//2002/07/25 DoJa1.5                    }
//2002/07/25 DoJa1.5                }catch(Exception anException){
//2002/07/25 DoJa1.5                    resultBox.setText("NG : " +anException.toString());
//2002/07/25 DoJa1.5                    break;
//2002/07/25 DoJa1.5                }
//2002/07/25 DoJa1.5                break;
                
            //J013_4101_0401
//2002/07/25 DoJa1.5            case 3:
            case 1:		//2002/07/25 DoJa1.5
                try{
                    for(int i = 0;i<=100;i++){
                        PhoneSystem.playSound(0);
                        if(i<100){
                            resultBox.setText("");
                        }else if(i == 100){
                            resultBox.setText("OK : "+i+"th time");
                        }
                    }
                }catch(IllegalArgumentException e){
                    resultBox.setText("NG : "+e.toString());
                    break;
                }
                break;
                
            default:
                break;
        }
    }
}