/**
 * J013_4301_0101
 * MainPanel
 * 
 * SoftKeyListener class behavior checking (repeatability)
 * 
 * $Id: J013_4301_0101.java,v 1.1 2002/01/07 08:28:20 misato Exp $
 */
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * ComponentListener class action check main class
 * @extends IApplication
 */
public class J013_4301_0101 extends IApplication{
    /**
     * starting method for I-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * ComponentListener class action check main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    Frame subFrame;
    Label classLabel = new Label("ComponentListener");
    TextBox resultBox = new TextBox("",20,3,TextBox.DISPLAY_ANY);
    Button closeButton = new Button("terminate");
    int count1 = 0;
    int count2 = 0;
    
    
    /**
     * display the main panel
     */
    public MainPanel(){
        try{
            /* display the MainPanel */
            showMainPanel();
        }catch(Exception anException){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error");
            errDialog.setText("Error:" +anException.toString());
            errDialog.show();
        }
    }
    
    /**
     * display the main panel
     */
    void showMainPanel(){
        /* setting of the display item */
        setTitle("API repeatability test");
        setSoftLabel(Frame.SOFT_KEY_1,"1");
        setSoftLabel(Frame.SOFT_KEY_2,"2");
        
        /* add each component to the screen */
        add(classLabel);
        add(resultBox);
        add(closeButton);
        
        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /* processing when the softkey1 is pressed */
    public void softKeyPressed(int anIndex){
        //J013_4301_0101
        if(anIndex == Frame.SOFT_KEY_1){
            count1++;
            if(count1<100){
                resultBox.setText("SoftKey 1 was (for the"+count1+"th time) pressed");
            }else if(count1 == 100){
                resultBox.setText("OK : SoftKey 1 was (for the"+count1+"th time) pressed");
            }
        }else if(anIndex == Frame.SOFT_KEY_2){
            count1++;
            if(count1<100){
                resultBox.setText("SoftKey 2 was (for the"+count1+"th time) pressed");
            }else if(count1 == 100){
                resultBox.setText("OK : SoftKey 2 was (for the"+count1+"th time) pressed");
            }
        }
        
    }
    
    /* processing when the softkey1 is released */
    public void softKeyReleased(int anIndex){
        //J013_4301_0201
        if(anIndex == Frame.SOFT_KEY_1){
            count2++;
            if(count2<100){
                resultBox.setText("SoftKey 1 was (for the"+count2+"th time) released");
            }else if(count2 == 100){
                resultBox.setText("OK : SoftKey 1 was (for the"+count2+"th time) released");
            }
        }else if(anIndex == Frame.SOFT_KEY_2){
            count2++;
            if(count2<100){
                resultBox.setText("SoftKey 2 was (for the"+count2+"th time) released");
            }else if(count2 == 100){
                resultBox.setText("OK : SoftKey 2 was (for the"+count2+"th time) released");
            }
        }
        
    }
    
    /**
     * get the event on a component
     * @param aComponent the component on which an event occurred
     * @param aType event type
     * @param aParam event parameter
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        /* processing when the stop button is pressed */
        if(aComponent == closeButton && aType == ComponentListener.BUTTON_PRESSED){
            IApplication.getCurrentApp().terminate();
        }
    }
}