/**
 * J014_0301_0101
 *
 * The check of HttpConnection Logical Illegal data of operation.
 *
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * The operation check main class of HttpConnection Logical Illegal data.
 * @extends IApplication
 */
public class J014_0301_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * The operation check main screen of HttpConnection Logical Illegal data.
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
        String menulist[]={
            "0.getHeaderField",
            "1.setRequestProperty",
            "3.openInputStream"
        };
    
        Label title;
        ListBox menu;
        Button exe;

        /**
         * constructor of MainPanel class
         */
        MainPanel() {
            /* create a component */
            setTitle("API class abnormal route");
            title=new Label("HttpConnection Logical Illegal data behavior");
            title.setSize(getWidth(),title.getHeight());
            add(title);
            menu=new ListBox(ListBox.CHOICE);
            menu.setItems(menulist);
            add(menu);
            exe = new Button("execute");
            add(exe);

            /* setting of the listener */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setComponentListener(this);
        }

        /**
         * terminate the application when softkey is pushed
         * @param anIndex Index of the softkey
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * do nothing when a softkey1 is released
         * @param anIndex Index of the softkey
         */
        public void softKeyReleased(int anIndex) {
        }

        /**
         * get the event on a component
         * @param aComponent The component on which an event occurs
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when the menu is choiced */
            if( aComponent == menu && aType == ComponentListener.SELECTION_CHANGED ) {
				listBoxdisp(menu.getSelectedIndex());
            }

            /* when  the execution button is pushed */
            if (aComponent == exe && aType == ComponentListener.BUTTON_PRESSED) {
                /* test the menu which is choiced */
                test(menu.getSelectedIndex());
            }
        }

        /**
         * ListBox disp Judge
         * @param anIndex Index of the menu which is choiced
         */
        public void listBoxdisp(int anIndex) {

          
        }

        /**
         * Examine HttpConnection Logical Illegal data.
         * @param anIndex Index of the menu which is choiced
         */
        public void test(int anIndex) {
            HttpConnection  con=null;
            String          filename="J014_0301_0101.jam";

            switch( anIndex ) {
                // J014_0301_0101
                case 0:         /* getHeaderField */
                    try{
                        con=(HttpConnection) Connector.open(getSourceURL()+filename,
                                        	Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
						con.connect();
                        String msg = con.getHeaderField("Content-Type");
						showDialog("Content-Type:" + msg);
                    }
					catch (Exception e ){
						showDialog("Exception NG:" + e.toString());
                        break;
                    }
                    try{
                        if( con != null ){
                            con.close();
                        }
                    }
					catch (Exception e1 ){
						showDialog("Exception NG1:" + e1.toString());
                    }
                    break;
                // J014_0301_0201
                case 1:         /* setRequestProperty */
                    try{
                        con=(HttpConnection) Connector.open(getSourceURL()+ filename,
                                            Connector.READ, true);
                        con.setRequestMethod(HttpConnection.GET);
                        con.setRequestProperty("\uffff","\ueeee");
						showDialog("OK");
                    }
					catch (Exception e ){
						showDialog("Exception NG1:" + e.toString());
                    }
                    break;
              
                case 2:       
                // J014_0301_0401
               /* openInputStream */
		            try{
                        con=(HttpConnection) Connector.open(getSourceURL()+ filename,
                                            Connector.READ, true);
		                con.setRequestMethod(con.GET);
		                con.connect();
			            InputStream is = con.openInputStream();
		                is.close();
		                con.close();
						showDialog("OK");
		            }
					catch( Exception e ){
						showDialog("Exception NG1:" + e.toString());
						break;
		            }
                    break;
                default:
                    break;
            }
        }

        /**
         * Examine HttpConnection Logical Illegal data.
         * @param anIndex Index of the menu which is choiced
         */
        public void test2(int anIndex) {
			String url1 = "";
			String url2 = "";
			String url3 = "";
			String url4 = "";
			String url  = "";
            HttpConnection  con=null;
            String          filename="J014_0301_0101.jam";


           
		}

        /**
         * dialog display method
         * @param   aText chalacter sequence which is displaied
         */
        public void showDialog(String aText) {
            Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
            d.setText(aText);
            d.show();
        }
    }
}
