/**
 * J014_3601_0101.java
 * 
 * J013_3601_0101
 * MenuPanel
 * TestPanel
 * 
 * MediaManager class behavior checking (logical abnormal route)
 * 
 * $Id: J014_3601_0101.java,v 1.1 2002/01/07 02:54:38 waka Exp $
 */

import java.lang.*;
import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.lang.*;

/**
 * MediaManager class behavior checking main class
 * @extends IApplication
 */
public class J014_3601_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * MediaManager class repeat testing menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener,MediaListener {

  
    Button  execButton = null;    /* execution button */

	//	creating TextBox class
	 TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
	
   

    /**
     * MenuPanel class constructor
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        setTitle("API class abnormal route");
        Label subTitle = new Label("MediaManager");
        execButton     = new Button("execute");
        add(subTitle);
    	add(textBox1);
        add(execButton);
        subTitle.setSize(getWidth(), subTitle.getHeight());
    	
        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * action checking method
     */
    void test() {

		// 2003/03/13 ->
        //MediaData      testMediaData       = null;  /* define media data */
		MediaSound		testMediaSound		= null;	/* define media sound */
		// 2003/03/13 <-
        MediaResource  testMediaResource   = null;  /* media resource data definition */

       
// J014_3601_0103
     	    String	Str = new String("");
            Str = textBox1.getText();
            try {
				// 2003/03/13 ->
                //testMediaData = MediaManager.getData(Str);
                //testMediaResource = (MediaResource)testMediaData;
				testMediaSound = MediaManager.getSound(Str);
				testMediaResource = (MediaResource)testMediaSound;
				// 2003/03/13 <-
            } catch(IllegalArgumentException iae) {
                showMsg("IllegalArgumentException:" + iae.getMessage());
            } catch(Exception e) {
                showMsg(e.toString());
            } catch(Error e) {
                showMsg("Error:" + e.toString());
            }
           
        
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }

    /**
     * get the notice from media presenter
     * @param  aMedia media presenter which is the source of the notice
     * @param  aAction event type
     * @param  aParam event parameter
     */
    public void mediaAction(MediaPresenter aMedia, int aAction, int aParam){}
}
