/**
 * J014_3801_0101.java
 * 
 * J014_3801_0101
 * MenuPanel
 * TestPanel
 * 
 * MediaResource class behavior checking (logical abnormal route)
 * 
 * $Id: J014_3801_0101.java,v 1.1 2002/01/07 01:49:23 waka Exp $
 */

import java.lang.*;
import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.lang.*;

/**
 * MediaResource class behavior checking main class
 * @extends IApplication
 */
public class J014_3801_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * MediaManager class repeat testing menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener,MediaListener {

    ListBox menuList   = null;    /* selection processing  menu */
    Button  execButton = null;    /* execution button */

    String[] menuItem = {
        "0.test 1",
    };                            /* menu item */

    /**
     * MenuPanel class constructor
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        setTitle("API class abnormal route");
        Label subTitle = new Label("MediaManager");
        menuList       = new ListBox(ListBox.CHOICE, 14);
        execButton     = new Button("execute");
        add(subTitle);
        add(menuList);
        add(execButton);
        subTitle.setSize(getWidth(), subTitle.getHeight());
        menuList.setItems(menuItem);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * action checking method
     */
    void test() {

        MediaImage      testMediaImage      = null;  /* define media image */
        MediaResource   testMediaResource   = null;  /* media resource data definition */
        VisualPresenter testVisualPresenter = null;  /* define play object of media data */

        switch (menuList.getSelectedIndex()) {
// J014_3801_0101
        case 0:
            try {
                /* create instance */
                testVisualPresenter  = new VisualPresenter();

                testMediaImage = MediaManager.getImage(
                    ("resource:///J014_3801_0101.gif")); 
                testMediaResource = (MediaResource)testMediaImage;
//                testMediaResource.use();
                testVisualPresenter.setImage(testMediaImage);
            } catch(UIException e) {
                showMsg("UIException");
            } catch(Exception e) {
                showMsg(e.toString());
            } catch(Error e) {
                showMsg("Error:" + e.toString());
            }
            break;
        default:
            break;
        }
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }

    /**
     * get the notice from media presenter
     * @param  aMedia media presenter which is the source of the notice
     * @param  aAction event type
     * @param  aParam event parameter
     */
    public void mediaAction(MediaPresenter aMedia, int aAction, int aParam){}

}