/**
 * J014_4001_0101.java
 * 
 * J014_4001_0101
 * MenuPanel
 * TestPanel
 * 
 * MediaResource class behavior checking (logical abnormal route)
 * 
 * $Id: J014_4001_0101.java,v 1.1 2002/01/07 02:53:51 waka Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Panel class behavior checking main class
 * @extends IApplication
 */
public class J014_4001_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Panel class repeating test menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menuList   = null;    /* selection processing  menu */
    Button  execButton = null;    /* execution button */

    String[] menuItem = {
        "0.test 1",
    };                            /* menu item */

    /**
     * MenuPanel class constructor
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * display the main panel
     */
    public void showMainPanel() {

        setTitle("API class abnormal route");
        Label subTitle = new Label("Panel");
        menuList       = new ListBox(ListBox.CHOICE, 2);
        execButton     = new Button("execute");
        add(subTitle);
        add(menuList);
        add(execButton);
        subTitle.setSize(getWidth(), subTitle.getHeight());
        menuList.setItems(menuItem);

        /* setting the softkey label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* setting of the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * action checking method
     */
    void test() {

        Label testLabel = new Label("testLabel");

        switch (menuList.getSelectedIndex()) {
// J014_4001_0101
        case 0:
            try {

                add(testLabel);
                add(testLabel);

            } catch(UIException e) {
                showMsg("UIException" + e.getMessage());
            } catch(Exception e) {
                showMsg(e.toString());
            } catch(Error e) {
                showMsg("Error:" + e.toString());
            }
            break;
        default:
            break;
        }
    }

    /**
     * display message dialog
     * @param  aMsg dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * do nothing when the softkey is pressed
     * @param aSoftKey softkey type
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * terminate the application when the softkey1 is released
     * shift to the previous screen in case of softkey2
     * @param aSoftKey softkey type
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test();
        }
    }

}