/*
 * J021_0306_0101
 * 
 * ADF test
 * Confirmation of AppParam operations
 * $Id: J021_0306_0101.java,v 1.3 2002/02/14 08:16:24 lan Exp $
 */


import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * ADF contents 
 * @extends IApplication
 */

public class J021_0306_0101 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Main screen of confirmation of getArgs operations
     * @extends Panel
     * @implements SoftKeyListener
     */
    class MainPanel extends Panel implements SoftKeyListener
    {

        Label aLabel;
        Label bLabel;
        TextBox aTextBox;
        String str[];

        /**
         * Constructors of the MainPanel class
         */
        MainPanel()
        {

            /**
            * Acquire parameter of AppParam
            */
            str = getArgs();
            String para = new String("");
            for(int i=0; i<str.length; i++ ) {
                para += str[i] + " ";
            }

            /* Settings of display items */
            setTitle("Confirmation of AppParam");
            aLabel = new Label("Acquisition of a parameter");
            bLabel = new Label("");
            aTextBox = new TextBox("Acquire param = " + para,20,14,0);
            aTextBox.setEditable(false);

            /* Add each component to screen */
            add(aLabel);
            add(bLabel);
            add(aTextBox);

            /* Listener setting */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex   Index of soft key
         */
        public void softKeyPressed(int anIndex) {;
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * When soft key is released, operate nothing
         * @param anIndex   Index of soft key
         */
        public void softKeyReleased(int anIndex) {
        }
    }
}
