/*
 * J021_0308_0101
 * ADF contents 
 * Confirmation of version up
 * $Id: J021_0308_0101.java,v 1.1 2001/11/29 13:07:43 hoshi Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * ADF contents 
 * @extends IApplication
 */

public class J021_0308_0101 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Main screen of confirmation of version up
     * @extends Panel
     * @implements SoftKeyListener
     */
    class MainPanel extends Panel implements SoftKeyListener
    {

        Label aLabel;

        /**
         * Constructors of the MainPanel class
         */
        MainPanel()
        {
            /* Settings of display items */
            aLabel = new Label("Confirmation test for version up");

            /* Add each component to screen */
            add(aLabel);

            /* Listener setting */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex/ index of soft key
         */
        public void softKeyPressed(int anIndex) {;
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * When soft key is released, operate nothing
         * @param anIndex/ index of soft key
         */
        public void softKeyReleased(int anIndex) {
        }
    }
}
