/*
 * J021_0309_0101
 * 
 * ADF test 
 * Confirmation of auto-startup operations
 * $Id: J021_0309_0101.java,v 1.1 2001/11/29 13:07:43 hoshi Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Confirmation of auto-startup operations
 * @extends IApplication
 */
public class J021_0309_0101 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Main screen of confirmation of auto-startup operations
     * @extends Panel
     * @implements SoftKeyListener
     */
    class MainPanel extends Panel implements SoftKeyListener
    {

        Label aLabel;
        Label bLabel;
        Label cLabel;

        /**
         * Constructors of the MainPanel class
         */
        MainPanel(){

            /* Settings of display items */
            aLabel = new Label("Confirmation of auto-startup");
            bLabel = new Label("1 hour after the configuration is done");
            cLabel = new Label("To auto-startup");

            /* Add each component to screen */
            add(aLabel);
            add(bLabel);
            add(cLabel);

            /* Listener setting */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex/ index of soft key
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * When soft key is released, operate nothing
         * @param anIndex/ index of soft key
         */
        public void softKeyReleased(int anIndex) {}

    }
}
