/*
 * J022_0304_0101
 * 
 * ADF test 
 * Confirmation of Scratchpad operations(incapable)
 *
 * $Id: J022_0304_0101.java,v 1.1 2001/11/29 12:54:45 hoshi Exp $
 */

import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Confirmation of Scratchpad operations
 * @extends IApplication
 */
public class J022_0304_0101 extends IApplication {
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
		Display.setCurrent(new MainPanel());
    }
}

/**
* Main screen of confirmation of Scratchpad operations
* @extends Panel
* @implements SoftKeyListener
* @implements ComponentListener
*/
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

	Button aButton;
	Button bButton;
	TextBox aTextBox;
	boolean flg;
	int size = 1024;

	String string = new String();
	/**
	* Constructors of the MainPanel class
	*/
	public MainPanel() {

		/* Determination of write execution */
		flg = false;

		/* Settings of display items */
		setTitle("Confirmation of Spsize");
		aButton = new Button("Write");
		bButton = new Button("Read");
		aTextBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);
	   	setSoftLabel(Frame.SOFT_KEY_1, "exit");

		/* Add each component to screen */
		add(aButton);
		add(bButton);
		add(aTextBox);

		/* Listener setting */
		setComponentListener(this);
	   	setSoftKeyListener(this);

	}

	/*
	 * Dialog display method
	 * @param	aText		displayed character strings
	 */
	public void showDialog(String aText) {
		Dialog	d = new Dialog(Dialog.BUTTON_OK, "Result");
		d.setText(aText);
		d.show();
	}

	/**
	* When soft key is pressed, end the application
	* @param anIndex/ index of soft key
	*/
	public void softKeyPressed(int anIndex) {
		if (anIndex == Frame.SOFT_KEY_1) {
			IApplication.getCurrentApp().terminate();
		}
	}

	/**
	* When soft key is released, operate nothing
	* @param anIndex/ index of soft key
	*/
	public void softKeyReleased(int anIndex) {
	}

	/**
	* Receive events occurred in components
	* @param aComponent  Component where an event occurred
	* @param aType  Type of events
	* @param aParam  Parameter of events
	*/
	public void componentAction(Component aComponent, int aType, int aParam) {
		if (aComponent == aButton){
			save();
			flg = true;
		} if (aComponent == bButton) {
			if (flg) {
				load();
			} else {
				aTextBox.setText("Press \"write\" first.");
			}
		}
	}

	/**
	* Write into Scratchpad
	*/
	private void save() {
		DataOutputStream dos = null;
		try {
			dos = Connector.openDataOutputStream("scratchpad:///0");
			byte a = (byte) 'a';
			for (int i = 0; i < size; i++) {
				dos.write(a);
			}
			aTextBox.setText("Write:OK");
		} catch (IOException e) {
			showDialog("Write:NG(IOException)");
		} finally {
			try {
				if (dos != null) dos.close();
			} catch (IOException ie) {
				showDialog("close:NG");
			}
		}
	}

	/**
	* Read Scratchpad
	*/
	private void load() {
		DataInputStream dis = null;
		int i;

		try {
			dis = Connector.openDataInputStream("scratchpad:///0");
			for (i = 0; i < size; i++) {
				int a = dis.read();
				if (a == -1) {
					showDialog("Read:-1");
					break;
				}
			}
			if (i == size) {
				aTextBox.setText("Read:OK");
			} else {}
		} catch (IOException e) {
			showDialog("Read:NG(IOException)");
		} finally {
			try {
				if (dis != null) dis.close();
			} catch (IOException ie) {
				showDialog("close:NG");
			}
		}
	}
}
