/*
 * J022_0316_0101
 * 
 * ADF test 
 * Confirmation of depiction operations
 * $Id: J022_0316_0101.java,v 1.1 2001/11/29 12:54:48 hoshi Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * ADF test
 * 
 * @extends IApplication
 */
public class J022_0316_0101 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainCanvas());
    }

    /**
     * Main screen of confirmation of depiction area
     * @extends Canvas
     * 
     */
    class MainCanvas extends Canvas 
    {
        int backColor;
        int stringColor;

        /**
         * Constructor of MainCanvas class
         */
        public MainCanvas(){

            /* Color settings */
            backColor = Graphics.getColorOfName(Graphics.RED);
            stringColor = Graphics.getColorOfName(Graphics.BLACK);

            /* Settings of display items */
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

        }

        /**
         * Screen depiction
         */
        public void paint(Graphics g) {
            g.lock();
            g.setColor(backColor);
            g.fillRect(0,0,getWidth(),getHeight());
            g.setColor(stringColor);
            g.drawString("DrawArea96x72",0,10);
            g.drawString("Do not display outside the area",0,25);
            g.unlock(true);
        }

        /**
         * When soft key is pressed, end the application
         * @type
         * @param
         */
        public void processEvent(int type,int param) {
            if(type == Display.KEY_PRESSED_EVENT) {
                switch(param) {
                    case Display.KEY_SOFT1:
                        IApplication.getCurrentApp().terminate();
                        break;
                    default:
                }
            }
        }
    }
}
