/**
 * J111_0101_0101
 * 
 * MainPanel
 *
 * Confirmation of read operations of normal data with no copyright held(normal route)
 *
 * $Id: J111_0101_0101.java,v 1.1 2002/01/07 06:50:02 misato Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of confirmation of read operations of normal data
 * @extends Panel
 */
public class J111_0101_0101 extends IApplication{
    /**
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen of confirmation of read operations of normal data
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    /* Select Main menu from a list box */
    String[] menu1 = {
        "1.GIF87a",
        "2.GIF89a",
        "3.JFIF"
    };

    /* Select the Main menu from GIF87a */
    String[] menu2_01 = {
        "1.Normal",
        "2.Interlace"
    };

    /* Select the Main menu from GIF89a */
    String[] menu2_02 = {
        "1.Normal",
        "2.Interlace",
        "3.Transparent",
        "4.Animation",
        "5.Transparent animation"
    };

    /* Select the Main menu from JFIF */
    String[] menu2_03 = {
        "1.BaseLine",
    };

    Frame nextFrame;
    Label classLabel = new Label("Reading normal data-no copyright");
    ListBox menu_Li = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2 = new ListBox(ListBox.CHOICE);
    Button execButton = new Button("execute");
    TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);
    int firstType;
    int secondType;

    /**
     * Constructor of MainPanel class
     */
    public MainPanel(){
        /* Settings of display items */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("normal route media test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Add each component to screen */
        add(classLabel);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);
        add(resultBox);

        /* Registration of a soft key listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     */
    public void softKeyPressed(int anIndex){}

    /**
     * When soft key is released, end the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key1 is released, end the application */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Process as in the case when actions other than soft key occur
     */
    public void componentAction(Component source,int aType,int aParam){
        /* In the case one in the Menu1 is selected, */
        if(source == menu_Li && aType == ComponentListener.SELECTION_CHANGED){
            /* Acquire the selected item */
            firstType = menu_Li.getSelectedIndex();
            resultBox.setText("");

            /* Set the selection list of Menu1 */
            switch(firstType){
                /* In the case GIF87a is selected */
                case 0: 
                    menu_Li2.setItems(menu2_01);
                    break;

                /* In the case GIF89a is selected */
                case 1:
                    menu_Li2.setItems(menu2_02);
                    break;

                /* In the case JFIF is selected */
                case 2:
                    menu_Li2.setItems(menu2_03);
                    break;

                default:
                    break;
            }
        }

        /* In the case one in the Menu2 is selected */
        if(source == menu_Li2 && aType == ComponentListener.SELECTION_CHANGED){
            resultBox.setText("");
        }

        /* In the case execute button is pressed while it is focused */
        if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
            secondType = menu_Li2.getSelectedIndex();
            test();
        }
    }
    /**
     * Creation of test methods
     */
    public void test(){
        int first = menu_Li.getSelectedIndex();
        int second = menu_Li2.getSelectedIndex();
        MediaImage aMediaImage;

        switch(first){
            /* In the case GIF87a is selected in menu list1 */
            case 0:
                switch(second){

//J111_0101_0101
                    case 0:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///87a-1.gif");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;
                    
//J111_0101_0102
                    case 1:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///87a-7.gif");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;

                    default:
                        break;
                }
                break;

            /* In the case GIF89a is selected in menu list1 */
            case 1:
                switch(second){

//J111_0101_0103
                    case 0:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///89a1-1.gif");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;
                    
//J111_0101_0104
                    case 1:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///89a2-1.gif");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;

//J111_0101_0105
                    case 2:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///89a3-1.gif");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;

//J111_0101_0106
                    case 3:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///89a4-1.gif");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;

//J111_0101_0107
                    case 4:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///89a5-1.gif");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;

                    default:
                        break;
                }
                break;

            /* In the case JFIF is selected in menu list1 */
            case 2:
                switch(second){

//J111_0101_0113
                    case 0:
                        try{
                            aMediaImage = MediaManager.getImage
                                                    ("resource:///jfif1-1.jpg");
                            aMediaImage.use();
                            resultBox.setText("OK\n Reading successful");
                        }catch(Exception anException){
                            resultBox.setText("NG : "+anException.toString());
                        }
                        break;
        
                    default:
                        break;
                }
                break;

//J111_0101_0115
//Test cannot be conducted

            default:
                break;
        }

    }
}