/**
 * J111_0101_0117
 * 
 * MainPanel
 * 
 * iMelody for confirmation of normal data read operations
 * 
 * $Id: J111_0101_0117.java,v 1.2 2002/02/12 12:37:02 uruno Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of confirmation of read operations of normal data
 * @extends Panel
 */
public class J111_0101_0117 extends IApplication{
    /**
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen of confirmation of read operations of normal data
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    /* Selection of menu lists */
    String[] menu1 = {
        "1.Copyright-held",
        "2.Copyright-not held"
    };

    Frame nextFrame;
    Label classLabel = new Label("Reading media-music");
    ListBox menu_Li = new ListBox(ListBox.CHOICE);
    Button execButton = new Button("execute");
    TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);

    /**
     * Constructor of MainPanel class (initialization)
     */
    public MainPanel(){
        /* Settings of display items */
        menu_Li.setItems(menu1);
        setTitle("normal route media test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
    
        /* Add each component to screen */
        add(classLabel);
        add(menu_Li);
        add(execButton);
        add(resultBox);
        
        /* Registration of a listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /* When soft key is pressed, nothing should be done */
    public void softKeyPressed(int anIndex){}

    /* End the processed application of the case soft key is released */
    public void softKeyReleased(int anIndex){
        IApplication.getCurrentApp().terminate();
    }

    /* Process when execute button is pressed */
    public void componentAction(Component source,int aType,int aParam){
        if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
            resultBox.setText("");
            test();
        }
    }

    /**
     * Generation of a test method
     */
    void test(){
        /* Acquire the selected item */
        int first = menu_Li.getSelectedIndex();
        MediaSound aMediaSound;

        switch(first){
            //J111_0101_0117
            case 0:
                try{
                    aMediaSound = MediaManager.getSound
                                                    ("resource:///MFi1-1.mld");
                    aMediaSound.use();
                    resultBox.setText("OK\nReadingSuccessful");
                }catch(Exception anException){
                    resultBox.setText("NG : " +anException.toString());
                }
                break;

            //J111_0101_0118
            case 1:
                try{
                    aMediaSound = MediaManager.getSound
                                                    ("resource:///MFi2-1.mld");
                    aMediaSound.use();
                    resultBox.setText("OK\nReadingSuccessful");
                }catch(Exception anException){
                    resultBox.setText("NG : " +anException.toString());
                }
                break;

            default:
                break;
        }
    }
}