/**
 * J111_0201_0401
 * 
 * MainPanel
 * 
 * Confirmation of static image media playback operations VisualPresenter no copyright held(normal route)
 * 
 * $Id: J111_0201_0401.java,v 1.1 2002/01/07 06:59:31 misato Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of confirmation of static image media playback operations
 * @extends Panel
 */
public class J111_0201_0401 extends IApplication{
    /**
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * MainPanel Class
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    /* Creation of menu in the Menu list1 */
    String[] menu1 = {
        "1.GIF87a",
        "2.GIF89a",
        "3.JFIF"
    };

    /* Creation of menu in the Menu list2(GIF87a) */
    String[] menu2_01 = {
        "1.Normal",
        "2.Interlace"
    };

    /* Creation of menu in the Menu list2(GIF89a) */
    String[] menu2_02 = {
        "1.Normal",
        "2.Interlace",
        "3.Transparent"
    };

    /* Creation of menu in the Menu list2(JFIF) */
    String[] menu2_03 = {
        "1.BaseLine"
    };

    Frame nextFrame;
    Label classLabel = new Label("VisualPresenter-no copyright");
    ListBox menu_Li  = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2 = new ListBox(ListBox.CHOICE);
    Button execButton = new Button("execute");

    int firstType ;
    int secondType ;

    /**
     * Generation of constructor of MainPanel class
     */
    public MainPanel(){
        /* Settings of display items */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("Media test normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Add each component to screen */
        add(classLabel);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* Registration of a listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key listener is pressed, no operation to be made
     */
    public void softKeyPressed(int anIndex){}

    /**
     * When soft key 1 is released, end the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key 1 is pressed, end the application */
        if(anIndex == SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Processes when execute button is pressed
     * @param source    Pressed component
     * @param aType     Event type
     * @param aParam    Parameter
     */
    public void componentAction(Component source,int aType,int aParam){
        /* When Menu1 is selected, */
        if(source == menu_Li && aType == ComponentListener.SELECTION_CHANGED){
            /* Acquire the item selected in the Menu1 */
            firstType = menu_Li.getSelectedIndex();

            /* Set the selection list of Menu1 */
            switch(firstType){
                case 0:
                    menu_Li2.setItems(menu2_01);
                    break;
    
                case 1:
                    menu_Li2.setItems(menu2_02);
                    break;

                case 2:
                    menu_Li2.setItems(menu2_03);
                    break;

                default:
                    break;
            }
        }

        /* Process when execute button is pressed */
        if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
            /* Acquire the selected item */
            secondType = menu_Li2.getSelectedIndex();

            switch(firstType){
                case 0:
                    nextFrame = new NextPanel(this,firstType,secondType);
                    Display.setCurrent(nextFrame);
                    break;

                case 1:
                    nextFrame = new NextPanel(this,firstType,secondType);
                    Display.setCurrent(nextFrame);
                    break;

                case 2:
                    nextFrame = new NextPanel(this,firstType,secondType);
                    Display.setCurrent(nextFrame);
                    break;

                default:
                    break;
            }
        }
    }
}

/**
 * Creation of NextPanel class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel extends Panel implements SoftKeyListener{
    Frame frame;
    int firstType;
    int secondType;
    TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);
    
    /**
     * Constructor of MainPanel class (initialization)
     */
    public NextPanel(Frame f,int aType,int aType2){
        /* Configuration of an argument */
        frame = f;
        firstType = aType;
        secondType = aType2;

        /* Display the result */
        init();
        showResult();
    }

    /**
     * Configure various types of settings
     */
    public void init(){
        /* Configure the items to be displayed */
        setTitle("Result");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        add(resultBox);

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /*
     * When soft key listener is pressed, no operation to be made
     */
    public void softKeyPressed(int anIndex){}

    /*
     * When soft key 1 is released, end the application
     */
    public void softKeyReleased(int anIndex){
        if(anIndex == SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }else if(anIndex == SOFT_KEY_2){
            Display.setCurrent(frame);
        }
    }

    /* A method to display the result */
    public void showResult(){
        MediaImage aMediaImage;
        MediaData md;
        VisualPresenter vp = new VisualPresenter();

        /* GIF87a Test */
        if(firstType == 0){
            switch(secondType){
                //J111_0201_0401
                case 0:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///87a-1.gif");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J111_0201_0402
                case 1:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///87a-7.gif");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                default:
                    break;
            }
        }else if(firstType == 1){
            switch(secondType){
                //J111_0201_0403
                case 0:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a1-1.gif");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J111_0201_0404
                case 1:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a2-1.gif");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J111_0201_0105
                case 2:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a3-1.gif");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.setBackground(Graphics.getColorOfName(Graphics.YELLOW));
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                default:
                    break;
            }
        }else if(firstType == 2){
            switch(secondType){
                //J111_0201_0113
                case 0:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                ("resource:///jfif1-1.jpg");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                default:
                    break;
            }
        }
        //J111_0201_0115
        //Test cannot be conducted
    }
}