/**
 * J111_0202_0306
 * 
 * MainPanel
 * 
 * Operations of movie media playback(ImageLabel)
 * 
 * $Id: J111_0202_0306.java,v 1.1 2002/01/07 07:04:50 misato Exp $
 */
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of movie media playback operations
 * @extends IApplication
 */
public class J111_0202_0306 extends IApplication{
    /**
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen of movie media playback operations
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    /* Creation of Menu list */
    String[] menu1 = {
        "1.Animation",
        "2.Transparent animation"
    };

    /* Creation of Menu list2 */
    String[] menu2_01 = {
        "1.Copyright-not held",
        "2.Copyright-held"
    };

    String[] menu2_02 = {
        "1.Copyright-not held",
        "2.Copyright-held"
    };

    Frame nextFrame;
    Label classLabel = new Label("Movie media-ImageLabel");
    ListBox menu_Li = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2 = new ListBox(ListBox.CHOICE);
    Button execButton = new Button("execute");
    
    int firstType;
    int secondType;

    /**
     * Constructor of MainPanel
     */
    public MainPanel(){
        /* Settings of display items */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("normal route of media type testing");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Add a component to the screen */
        add(classLabel);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* Register listeners */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, nothing should be done
     */
    public void softKeyPressed(int anIndex){}

    /**
     * When soft key is released, end the application
     */
    public void softKeyReleased(int anIndex){
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Process when execute button is pressed
     */
    public void componentAction(Component source,int aType,int aParam){
        if(source == menu_Li && aType == ComponentListener.SELECTION_CHANGED){
            firstType = menu_Li.getSelectedIndex();

            /* Select the selected list of Menu1 */
            switch(firstType){
                case 0:
                    menu_Li2.setItems(menu2_01);
                    break;

                case 1:
                    menu_Li2.setItems(menu2_02);
                    break;

                default:
                    break;
            }
        }

        /* When execute button is pressed, */
        if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
            secondType = menu_Li2.getSelectedIndex();

            switch(secondType){
                case 0:
                    nextFrame = new NextPanel(this,firstType,secondType);
                    Display.setCurrent(nextFrame);
                    break;

                case 1:
                    nextFrame = new NextPanel(this,firstType,secondType);
                    Display.setCurrent(nextFrame);
                    break;

                default:
                    break;
            }
        }
    }
}

/**
 * Confirmation of the class method
 * 
 * @extends Panel
 * @implements softKeyListener
 */
class NextPanel extends Panel implements SoftKeyListener{
    Frame frame;
    int first;
    int second;
    TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);

    /**
     * Constructor of NextPanel
     */
    public NextPanel(Frame f,int aType,int aType2){
        /* Configuration of an argument */
        frame = f;
        first = aType;
        second = aType2;

        /* Display the result */
        init();
        showResult();
    }

    /**
     * Configure various types of settings
     */
    public void init(){
        /* Settings of display items */
        setTitle("Result");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Carry out allocation of screen */
        add(resultBox);

        /* Register listeners */
        setSoftKeyListener(this);
    }

    /**
     * When soft key is being pressed, do not carry out any operations
     */
    public void softKeyPressed(int anIndex){}

    /**
     * Processes when soft key is released
     */
    public void softKeyReleased(int anIndex){
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }else if(anIndex == Frame.SOFT_KEY_2){
            Display.setCurrent(frame);
        }
    }

    /**
     * Display the result screen
     */
    public void showResult(){
        MediaImage aMediaImage;

        if(first == 0){
            switch(second){
                //J111_0202_0306
                case 0:
                    try{
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a4-1.gif");
                        aMediaImage.use();
                        ImageLabel anImageLabel = new ImageLabel
                                                    (aMediaImage.getImage());
                        add(anImageLabel);
                        resultBox.setText("OK\n Reading successful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J111_0202_0311
                case 1:
                    try{
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a9-1.gif");
                        aMediaImage.use();
                        ImageLabel anImageLabel = new ImageLabel
                                                    (aMediaImage.getImage());
                        add(anImageLabel);
                        resultBox.setText("OK\n Reading successful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                default:
                    break;
            }
        }else if(first == 1){
            switch(second){
                //J111_0202_0307
                case 0:
                    try{
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a5-1.gif");
                        aMediaImage.use();
                        ImageLabel anImageLabel = new ImageLabel
                                                    (aMediaImage.getImage());
                        anImageLabel.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));                         add(anImageLabel);
                        resultBox.setText("OK\n Reading successful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J111_0202_0312
                case 1:
                    try{
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a10-1.gif");                        aMediaImage.use();
                        ImageLabel anImageLabel = new ImageLabel
                                                    (aMediaImage.getImage());
                        anImageLabel.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));                         add(anImageLabel);
                        resultBox.setText("OK\n Reading successful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                default:
                    break;
            }
        }
    }
}
