/**
 * J111_0305_0101
 * 
 * MainPanel
 *
 * Confirmation of file extension operations
 *
 * $Id: J111_0305_0101.java,v 1.1 2002/01/07 07:34:29 misato Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of confirmation of file extension operations
 * @extends Panel
 */
public class J111_0305_0101 extends IApplication{
    /**
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen of confirmation of read operations of normal data
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    /* Select Main menu from a list box */
    String[] menu1 = {
        "1.GIF87a",
        "2.GIF89a",
        "3.JFIF",
        "4.iMelody"
    };

    Frame nextFrame;
    Label classLabel = new Label("Confirmation of operations of files named in capital letters");
    ListBox menu_Li = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2 = new ListBox(ListBox.CHOICE);
    Button execButton = new Button("execute");
    TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);
    int firstType;
    int secondType;

    /**
     * Constructor of MainPanel class
     */
    public MainPanel(){
        /* Settings of display items */
        menu_Li.setItems(menu1);
        setTitle("normal route media test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Add each component to screen */
        add(classLabel);
        add(menu_Li);
        add(execButton);
        add(resultBox);

        /* Registration of a soft key listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     */
    public void softKeyPressed(int anIndex){}

    /**
     * When soft key is released, end the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key1 is released, end the application */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Process as in the case when actions other than soft key occur
     */
    public void componentAction(Component source,int aType,int aParam){
        /* In the case one in the Menu1 is selected, */
        if(source == menu_Li && aType == ComponentListener.SELECTION_CHANGED){
            /* Acquire the selected item */
            firstType = menu_Li.getSelectedIndex();
            resultBox.setText("");
        }


        /* In the case execute button is pressed while it is focused */
        if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
            secondType = menu_Li2.getSelectedIndex();
            test();
        }
    }
    /**
     * Creation of test methods
     */
    public void test(){
        int first = menu_Li.getSelectedIndex();
        MediaImage aMediaImage;

        switch(first){
            //J111_0305_0101
            case 0:
                try{
                    aMediaImage = MediaManager.getImage
                                                ("resource:///AAA.GIF");
                    aMediaImage.use();
                    resultBox.setText("OK\nReadingSuccessful");
                }catch(Exception anException){
                    resultBox.setText("NG : "+anException.toString());
                }
                break;

            //J111_0305_0108
            case 1:
                try{
                    aMediaImage = MediaManager.getImage
                                                ("resource:///BBB.GIF");
                    aMediaImage.use();
                    resultBox.setText("OK\nReadingSuccessful");
                }catch(Exception anException){
                    resultBox.setText("NG : "+anException.toString());
                }
                break;

            //J111_0305_0114
            case 2:
                try{
                    aMediaImage = MediaManager.getImage
                                                ("resource:///CCC.JPG");
                    aMediaImage.use();
                    resultBox.setText("OK\nReadingSuccessful");
                }catch(Exception anException){
                    resultBox.setText("NG : "+anException.toString());
                }
                break;

            //J111_0305_0115
            //Test cannot be conducted

            //J111_0305_0117
            case 3:
                try{
                    MediaSound aMediaSound = MediaManager.getSound
                                                ("resource:///DDD.MLD");
                    aMediaSound.use();
                    resultBox.setText("OK\nReadingSuccessful");
                }catch(Exception anException){
                    resultBox.setText("NG : "+anException.toString());
                }
                break;

            default:
                break;

        }
    }
}