/**
 * J111_0701_0119
 * Confirmation of read operations of optional media format
 * 
 * $Id: J111_0701_0119.java,v 1.1 2002/01/07 08:16:00 uruno Exp $
 */
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;

/**
 * Confirmation of read operations of optional media format
 * @extends IApplication
 */
public class J111_0701_0119 extends IApplication {
    /**
     * Overview of functions  :Startup method of i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Confirmation of read operations of optional media format
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem1 = {
        "1.No copyright held",
        "2.Copyright held"
    };

    String[] menuListItem2 = {
        "1.JFIF Progressive"
    };

    Label   classLabel = new Label("Reading option data");
    ListBox menuList1   = new ListBox(ListBox.CHOICE);
    ListBox menuList2   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    TextBox resultText = new TextBox("", 20, 2, TextBox.DISPLAY_ANY);

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    void showMainPanel() {

        /* Settings of display items */
        menuList1.setItems(menuListItem1);
        menuList2.setItems(menuListItem2);
        setTitle("normal route media");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Add each component to screen */
        add(classLabel);
        add(menuList1);
        add(menuList2);
        add(execButton);
        add(resultText);

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* In the case execute button is pressed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            int first = menuList1.getSelectedIndex();
            int second = menuList2.getSelectedIndex();
            resultText.setText("");

            switch (first) {
            
            /* no copyright held */ 
            case 0:
                switch (second) {
//J111_0101_0119 (JFIF no copyright held Sequential)
//Test cannot be conducted

//J111_0701_0120 (JFIF no copyright held Progressive)
                case 0:
                    GetImage("jfif3-1.jpg");
                    break;

//J111_0101_0123 (EXIF no copyright held Sequential)
//Test cannot be conducted

//J111_0101_0124 (EXIF no copyright held Progressive)
//Test cannot be conducted

                default:
                    break;
                }
                
            /* with copyright held*/
            case 1:
                switch (second) {
//J111_0101_0121 (JFIF with copyright held Sequential)
//Test cannot be conducted

//J111_0701_0122 (JFIF with copyright held Progressive)
                case 0:
                    GetImage("jfif4-1.jpg");
                    break;

//J111_0101_0125 (EXIF with copyright held Sequential)
//Test cannot be conducted

//J111_0101_0126 (EXIF with copyright held Progressive)
//Test cannot be conducted
                default:
                    break;
                }

            default:
                break;
            }
        }
    }
    
    /**
     * Reading media and its determination
     * @param aString Reading file name
     */
    void GetImage(String aString) {

        /* Setting a variable for read purpose */
        MediaImage mediaImage;

        /* Object name setting */
        String mediaPath = "resource:///" + aString;
        
        /* Acquisition of an object of media image */
        mediaImage = MediaManager.getImage(mediaPath);

        /* Reading media */
        try {
            mediaImage.use();
            resultText.setText("OK\nReadingSuccessful\n");
        } catch(Exception e) {
            resultText.setText("NG\nReadingUnsuccessful\n");
            resultText.setText(resultText.getText()+e.toString());
        }
    }
}
