/**
 * J111_0702_0119
 * 
 * MainPanel
 * 
 * Confirmation of optional media playback operations
 * 
 * $Id: J111_0702_0119.java,v 1.1 2002/01/07 07:38:16 misato Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of optional media playback operations
 * @extends Panel
 */
public class J111_0702_0119 extends IApplication{

    static MainPanel mainPanel;

    /**
     * Commencing method to i-appli
     */
    public void start(){
        mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * MainPanel Class
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    /* Creation of menu in the Menu list1 */
    String[] menu1 = {
//2002/0731 Doja1.5        "1.AnchorButton",
//2002/0731 Doja1.5        "2.ImageButtonl",
        "3.ImageLabel",
        "4.VisualPresenter",
        "5.Canvas"
    };

    String[] menu2_01 = {
        "1.Copyright-not held",
        "2.Copyright-held"
    };

    String[] menu2_02 = {
        "1.Copyright-not held",
        "2.Copyright-held"
    };

    String[] menu2_03 = {
        "1.Copyright-not held",
        "2.Copyright-held"
    };

    String[] menu2_04 = {
        "1.Copyright-not held",
        "2.Copyright-held"
    };

    String[] menu2_05 = {
        "1.Copyright-not held",
        "2.Copyright-held"
    };

    Frame nextFrame;
    Label classLabel = new Label("Operations of media playback");
    ListBox menu_Li  = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2 = new ListBox(ListBox.CHOICE);
    Button execButton = new Button("execute");

    int firstType ;
    int secondType ;

    /**
     * Generation of constructor of MainPanel class
     */
    public MainPanel(){
        /* Settings of display items */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("Media test normal route");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Add each component to screen */
        add(classLabel);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* Registration of a listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /* When soft key listener is pressed, no operation to be made */
    public void softKeyPressed(int anIndex){}

    /* When soft key 1 is released, end the application */
    public void softKeyReleased(int anIndex){
        /* When soft key 1 is pressed, end the application */
        if(anIndex == SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /* Processes when execute button is pressed */
    public void componentAction(Component source,int aType,int aParam){
        /* When Menu1 is selected, */
        if(source == menu_Li && aType == ComponentListener.SELECTION_CHANGED){
            /* Acquire the item selected in the Menu1 */
            firstType = menu_Li.getSelectedIndex();

            /* Set the selection list of Menu1 */
            switch(firstType){
//2002/0731 Doja1.5                case 0:
//2002/0731 Doja1.5                    menu_Li2.setItems(menu2_01);
//2002/0731 Doja1.5                    break;
    
//2002/0731 Doja1.5                case 1:
//2002/0731 Doja1.5                    menu_Li2.setItems(menu2_02);
//2002/0731 Doja1.5                    break;

                case 0:
//2002/0731 Doja1.5                case 2:
                    menu_Li2.setItems(menu2_03);
                    break;

                case 1:
//2002/0731 Doja1.5                case 3:
                    menu_Li2.setItems(menu2_04);
                    break;

                case 2:
//2002/0731 Doja1.5                case 4:
                    menu_Li2.setItems(menu2_05);
                    break;

                default:
                    break;
            }
        }

        /* Process when execute button is pressed */
        if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
            /* Acquire the selected item */
            secondType = menu_Li2.getSelectedIndex();

//2002/0731 Doja1.5            if(firstType == 0){
//2002/0731 Doja1.5                 nextFrame = new NextPanel(this,firstType,secondType);
//2002/0731 Doja1.5                 Display.setCurrent(nextFrame);
//2002/0731 Doja1.5            }else if(firstType == 1){
//2002/0731 Doja1.5                 nextFrame = new NextPanel(this,firstType,secondType);
//2002/0731 Doja1.5                 Display.setCurrent(nextFrame);
            if(firstType == 0){
//2002/0731 Doja1.5            }else if(firstType == 2){
                 nextFrame = new NextPanel(this,firstType,secondType);
                 Display.setCurrent(nextFrame);
            }else if(firstType == 1){
//2002/0731 Doja1.5            }else if(firstType == 3){
                 nextFrame = new NextPanel(this,firstType,secondType);
                 Display.setCurrent(nextFrame);
            }else if(firstType == 2){
//2002/0731 Doja1.5            }else if(firstType == 4){
                switch(secondType){
                    //J111_0702_0520
                    case 0: 
                        Display.setCurrent(new MainCanvas
                                            (firstType, this, "jfif3-1.jpg"));
                        break;


                    //J111_0702_0522
                    case 1:
                        Display.setCurrent(new MainCanvas
                                            (firstType, this, "jfif4-1.jpg"));
                        break;

                    //J111_0702_0519
                    //J111_0702_0521
                    //J111_0702_0523
                    //J111_0702_0524
                    //J111_0702_0525
                    //J111_0702_0526
                    //Test cannot be conducted

                    default:
                        break;
                }
            }
        }
    }
}

/**
 * Creation of NextPanel class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel extends Panel implements SoftKeyListener{
    Frame frame;
    int firstType;
    int secondType;
    TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);
    
    /**
     * Constructor of MainPanel class (initialization)
     */
    public NextPanel(Frame f,int aType,int aType2){
        /* Configuration of an argument */
        frame = f;
        firstType = aType;
        secondType = aType2;

        /* Display the result */
        init();
        showResult();
    }

    /**
     * Configure various types of settings
     */
    public void init(){
        /* Configure the items to be displayed */
        setTitle("Result");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        add(resultBox);

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /* When soft key is pressed, nothing should be done */
    public void softKeyPressed(int anIndex){}

    /* Processes when soft key is released */
    public void softKeyReleased(int anIndex){
        if(anIndex == SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }else if(anIndex == SOFT_KEY_2){
            Display.setCurrent(frame);
        }
    }

    /* A method to display the result */
    public void showResult(){
        MediaImage aMediaImage;
        VisualPresenter vp = new VisualPresenter();
        MediaData md;

        /* jpg87a Test */
//2002/0731 Doja1.5        if(firstType == 0){
//2002/0731 Doja1.5            switch(secondType){
                //J111_0702_0120
//2002/0731 Doja1.5                case 0:
//2002/0731 Doja1.5                    try{
//2002/0731 Doja1.5                        aMediaImage = MediaManager.getImage
//2002/0731 Doja1.5                                                   ("resource:///jfif3-1.jpg");
//2002/0731 Doja1.5                        aMediaImage.use();
//2002/0731 Doja1.5                        AnchorButton anAnchorButton = new AnchorButton
//2002/0731 Doja1.5                                                    (aMediaImage.getImage());
//2002/0731 Doja1.5                        add(anAnchorButton);
//2002/0731 Doja1.5                        resultBox.setText("OK\n Reading successful");
//2002/0731 Doja1.5                    }catch(Exception anException){
//2002/0731 Doja1.5                        resultBox.setText("NG : "+anException.toString());
//2002/0731 Doja1.5                    }
//2002/0731 Doja1.5                    break;

                //J111_0702_0122
//2002/0731 Doja1.5                case 1:
//2002/0731 Doja1.5                    try{
//2002/0731 Doja1.5                        aMediaImage = MediaManager.getImage
//2002/0731 Doja1.5                                                   ("resource:///jfif4-1.jpg");
//2002/0731 Doja1.5                        aMediaImage.use();
//2002/0731 Doja1.5                        AnchorButton anAnchorButton = new AnchorButton
//2002/0731 Doja1.5                                                    (aMediaImage.getImage());
//2002/0731 Doja1.5                        add(anAnchorButton);
//2002/0731 Doja1.5                        resultBox.setText("OK\n Reading successful");
//2002/0731 Doja1.5                    }catch(Exception anException){
//2002/0731 Doja1.5                        resultBox.setText("NG : "+anException.toString());
//2002/0731 Doja1.5                    }
//2002/0731 Doja1.5                    break;

                //J111_0702_0119
                //J111_0702_0121
                //J111_0702_0123
                //J111_0702_0124
                //J111_0702_0125
                //J111_0702_0126
                //Test cannot be conducted

//2002/0731 Doja1.5                default:
//2002/0731 Doja1.5                    break;
//2002/0731 Doja1.5            }
//2002/0731 Doja1.5        }else if(firstType == 1){
//2002/0731 Doja1.5            switch(secondType){
                //J111_0702_0220
//2002/0731 Doja1.5                case 0:
//2002/0731 Doja1.5                    try{
//2002/0731 Doja1.5                        aMediaImage = MediaManager.getImage
//2002/0731 Doja1.5                                                   ("resource:///jfif3-1.jpg");
//2002/0731 Doja1.5                        aMediaImage.use();
//2002/0731 Doja1.5                        ImageButton anImageButton = new ImageButton
//2002/0731 Doja1.5                                                    (aMediaImage.getImage());
//2002/0731 Doja1.5                        add(anImageButton);
//2002/0731 Doja1.5                        resultBox.setText("OK\n Reading successful");
//2002/0731 Doja1.5                    }catch(Exception anException){
//2002/0731 Doja1.5                        resultBox.setText("NG : "+anException.toString());
//2002/0731 Doja1.5                    }
//2002/0731 Doja1.5                    break;

                //J111_0702_0222
//2002/0731 Doja1.5                case 1:
//2002/0731 Doja1.5                    try{
//2002/0731 Doja1.5                        aMediaImage = MediaManager.getImage
//2002/0731 Doja1.5                                                   ("resource:///jfif4-1.jpg");
//2002/0731 Doja1.5                        aMediaImage.use();
//2002/0731 Doja1.5                        ImageButton anImageButton = new ImageButton
//2002/0731 Doja1.5                                                    (aMediaImage.getImage());
//2002/0731 Doja1.5                        add(anImageButton);
//2002/0731 Doja1.5                        resultBox.setText("OK\n Reading successful");
//2002/0731 Doja1.5                    }catch(Exception anException){
//2002/0731 Doja1.5                        resultBox.setText("NG : "+anException.toString());
//2002/0731 Doja1.5                    }
//2002/0731 Doja1.5                    break;

                //J111_0702_0219
                //J111_0702_0221
                //J111_0702_0223
                //J111_0702_0224
                //J111_0702_0225
                //J111_0702_0226
                //Test cannot be conducted

//2002/0731 Doja1.5                default:
//2002/0731 Doja1.5                    break;
//2002/0731 Doja1.5            }
        if(firstType == 0){
//2002/0731 Doja1.5        }else if(firstType == 2){
            switch(secondType){
                //J111_0702_0320
                case 0:
                    try{
                        aMediaImage = MediaManager.getImage
                                                   ("resource:///jfif3-1.jpg");
                        aMediaImage.use();
                        ImageLabel anImageLabel = new ImageLabel
                                                    (aMediaImage.getImage());
                        add(anImageLabel);
                        resultBox.setText("OK\n Reading successful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J111_0702_0322
                case 1:
                    try{
                        aMediaImage = MediaManager.getImage
                                                   ("resource:///jfif4-1.jpg");
                        aMediaImage.use();
                        ImageLabel anImageLabel = new ImageLabel
                                                    (aMediaImage.getImage());
                        add(anImageLabel);
                        resultBox.setText("OK\n Reading successful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;


                //J111_0702_0319
                //J111_0702_0321
                //J111_0702_0323
                //J111_0702_0324
                //J111_0702_0325
                //J111_0702_0326
                //Test cannot be conducted

                default:
                    break;
            }
        }else if(firstType == 1){
//2002/0731 Doja1.5        }else if(firstType == 3){
            switch(secondType){
                //J111_0702_0420
                case 0:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                               ("resource:///jfif3-1.jpg");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J111_0702_0422
                case 1:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                             ("resource:///jfif4-1.jpg");
                        aMediaImage.use();
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                     }
                    break;

                //J111_0702_0419
                //J111_0702_0421
                //J111_0702_0423
                //J111_0702_0424
                //J111_0702_0425
                //J111_0702_0426
                //Test cannot be conducted

                default:
                    break;
            }
        }
    }
}

/**
 * Confirmation of media format playback operations(with copyright held )
 * Canvas main screen of static image media playback operations
 * @extends Canvas
 */
class MainCanvas extends Canvas {

    int   testPattern;
    Image viewImage;
    Frame prevFrame;
    String sTitle = "Result of Canvas display";
    String sResult1 = "OK";
    String sResult2 = "Depiction successful";
    
    /**
     * Display a sub screen
     * @param aInt    Test Sub division
     * @param aFrame  Main screen object
     * @param aString Reading file name
     */
    public MainCanvas(int aInt, Frame aFrame, String aString) {

        /* Acquisition of test patterns */
        testPattern = aInt;

        /* Object name setting */
        prevFrame = aFrame;
        String mediaPath = "resource:///" + aString;

        /* Acquisition of image objects */
        MediaImage mi = MediaManager.getImage(mediaPath);
        
        /* Reading media */
        try {
            mi.use();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Reading unsuccessful" + e.toString());
            errDialog.show();
            IApplication.getCurrentApp().terminate();
        }

        /* Copy of an image */
        viewImage = mi.getImage();
        
        /* Settings of display items */
        setSoftLabel(Canvas.SOFT_KEY_1, "exit");
        setSoftLabel(Canvas.SOFT_KEY_2, "back");
    }

    /**
     * Drawing into Canvas
     * @param aGraphics Depiction object
     */
    public void paint(Graphics aGraphics) {


        /* Setting an image by test Sub division */
        switch (testPattern) {

        /* Canvas */
        case 2:
//2002/0731 Doja1.5        case 4:
            aGraphics.drawString(sTitle, 10, 20);
            aGraphics.drawImage(viewImage, 10, 30);
            aGraphics.drawString(sResult1, 10, viewImage.getHeight() + 50);
            aGraphics.drawString(sResult2, 10, viewImage.getHeight() + 62);
            break;

        default:
            break;

        }
    }

    /**
     * Types of events
     * @param type type of an event
     * @param param  parameter of an event
     */
    public void processEvent(int type, int param) {
    
        /* When soft key is released, the application ends */
        if(type == Display.KEY_RELEASED_EVENT) {
            switch(param){

                /* When soft key is released, the application ends */
                case Display.KEY_SOFT1:
                    IApplication.getCurrentApp().terminate();
                    break;

                /* When soft key2 is released, return to the main screen */
                case Display.KEY_SOFT2:
                    Display.setCurrent(J111_0702_0119.mainPanel);
                    break;
            }
        }
    }
}
