/**
 * J111_0801_0101
 * 
 * MainPanel
 * 
 * Confirmation of operations of when movie is replayed
 * 
 * $Id: J111_0801_0101.java,v 1.1 2002/01/07 07:04:13 misato Exp $
 */
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of confirmation of operations of when movie is replayed
 * @extends IApplication
 */
public class J111_0801_0101 extends IApplication{
	/**
	 * Commencing method to i-appli
	 */
	public void start(){
		Display.setCurrent(new MainPanel());
	}
}

/**
 * Main display when confirmation of operations of when movie is replayed
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
	/* Creation of Menu list */
	String[] menu1 = {
		"1.Animation",
	};

	Frame nextFrame;
	Label classLabel = new Label("Movie media");
	ListBox menu_Li = new ListBox(ListBox.CHOICE);
	Button execButton = new Button("execute");
	
	int firstType;

	/**
	 * Constructor of MainPanel
	 */
	public MainPanel(){
		/* Settings of display items */
		menu_Li.setItems(menu1);
		setTitle("normal route of media type testing");
		setSoftLabel(Frame.SOFT_KEY_1,"exit");

		/* Add a component to the screen */
		add(classLabel);
		add(menu_Li);
		add(execButton);

		/* Register listeners */
		setSoftKeyListener(this);
		setComponentListener(this);
	}

	/**
	 * When soft key is pressed, nothing should be done
	 */
	public void softKeyPressed(int anIndex){}

	/**
	 * When soft key is released, end the application
	 */
	public void softKeyReleased(int anIndex){
		if(anIndex == Frame.SOFT_KEY_1){
			IApplication.getCurrentApp().terminate();
		}
	}

	/**
	 * Processes when execute button is pressed
	 */
	public void componentAction(Component source,int aType,int aParam){
		/* When execute button is pressed, */
		if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
			firstType = menu_Li.getSelectedIndex();

			/* Select the selected list of Menu1 */
			switch(firstType){
				case 0:
					nextFrame = new NextPanel(this,firstType);
					Display.setCurrent(nextFrame);
					break;

				default:
					break;
			}
		}
	}
}

/**
 * Confirmation of the class method
 * 
 * @extends Panel
 * @implements softKeyListener
 */
class NextPanel extends Panel implements SoftKeyListener{
	Frame frame;
	int first;
	TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);

	/**
	 * Constructor of NextPanel
	 */
	public NextPanel(Frame f,int aType){
		/* Configuration of an argument */
		frame = f;
		first = aType;

		/* Display the result */
		init();
		showResult();
	}

	/**
	 * Configure various types of settings
	 */
	public void init(){
		/* Settings of display items */
		setTitle("Result");
		setSoftLabel(Frame.SOFT_KEY_1,"exit");
		setSoftLabel(Frame.SOFT_KEY_2,"back");

		/* Carry out allocation of screen */
		add(resultBox);

		/* Register listeners */
		setSoftKeyListener(this);
	}

	/**
	 * When soft key is being pressed, do not carry out any operations
	 */
	public void softKeyPressed(int anIndex){}

	/**
	 * Processes when soft key is released
	 */
	public void softKeyReleased(int anIndex){
		if(anIndex == Frame.SOFT_KEY_1){
			IApplication.getCurrentApp().terminate();
		}else if(anIndex == Frame.SOFT_KEY_2){
			Display.setCurrent(frame);
		}
	}

	/**
	 * Display the result screen
	 */
	public void showResult(){
		VisualPresenter vp = new VisualPresenter();
		MediaImage mi = null;

		if(first == 0){
			//J111_0801_0101
				try{
					mi = MediaManager.getImage("resource:///89a4-1.gif");
					mi.use();
					vp.setImage(mi);
					add(vp);
					vp.play();

					resultBox.setText("OK\nPlayback Successful");
				}catch(Exception anException){
					resultBox.setText("NG : "+anException.toString());
				}

		}
	}
}
