/**
 * J112_0303_0103
 * 
 * MainPanel
 * 
 * Confirmation of graphic image size operations(2561*256)
 * 
 * $Id: J112_0303_0103.java,v 1.1 2002/01/07 08:03:18 misato Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class of confirmation of graphic image size operations
 * @extends Panel
 */
public class J112_0303_0103 extends IApplication{
    /**
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/**
 * MainPanel Class
 * 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    /* Creation of menu in the Menu list1 */
    String[] menu1 = {
        "1.GIF89a"
    };

    /* Creation of menu in the Menu list2(GIF89a) */
    String[] menu2_01 = {
        "1.Normal",
        "2.Interlace",
        "3.Transparent",
        "4.Animation",
        "5.Transparent animation",
        "6.Normal-C",
        "7.Interlace-C",
        "8.Transparent-C",
        "9.Animation-C",
        "10.TransparentAnimation-C"
    };


    Frame nextFrame;
    Label classLabel = new Label("Graphic image of 256x256 dots");
    ListBox menu_Li  = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2 = new ListBox(ListBox.CHOICE);
    Button execButton = new Button("execute");

    int firstType ;
    int secondType ;

    /**
     * Generation of constructor of MainPanel class
     */
    public MainPanel(){
        /* Settings of display items */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_01);
        setTitle("Media test Boundary type");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Add each component to screen */
        add(classLabel);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* Registration of a listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key listener is pressed, no operation to be made
     */
    public void softKeyPressed(int anIndex){}

    /**
     * When soft key is released, end the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key 1 is pressed, end the application */
        if(anIndex == SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Processes when execute button is pressed
     * @param source Event component
     * @param aType  Event type
     * @parama aParam Event parameter
     */
    public void componentAction(Component source,int aType,int aParam){
        /* When Menu1 is selected, */
        if(source == menu_Li && aType == ComponentListener.SELECTION_CHANGED){
            /* Acquire the item selected in the Menu1 */
            firstType = menu_Li.getSelectedIndex();

            /* Set the selection list of Menu1 */
            switch(firstType){
                case 0:
                    menu_Li2.setItems(menu2_01);
                    break;
    
                default:
                    break;
            }
        }

        /* Process when execute button is pressed */
        if(source == execButton && aType == ComponentListener.BUTTON_PRESSED){
            /* Acquire the selected item */
            secondType = menu_Li2.getSelectedIndex();

            switch(firstType){
                case 0:
                    nextFrame = new NextPanel(this,firstType,secondType);
                    Display.setCurrent(nextFrame);
                    break;

                default:
                    break;
            }
        }
    }
}

/**
 * Creation of NextPanel class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel extends Panel implements SoftKeyListener{
    Frame frame;
    int firstType;
    int secondType;
    TextBox resultBox = new TextBox("",20,2,TextBox.DISPLAY_ANY);
    
    /**
     * Constructor of MainPanel class (initialization)
     */
    public NextPanel(Frame f,int aType,int aType2){
        /* Configuration of an argument */
        frame = f;
        firstType = aType;
        secondType = aType2;

        /* Display the result */
        init();
        showResult();
    }

    /**
     * Configure various types of settings
     */
    public void init(){
        /* Configure the items to be displayed */
        setTitle("Result");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        add(resultBox);

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /**
     * When soft key listener is pressed, no operation to be made
     */
    public void softKeyPressed(int anIndex){}

    /**
     * When soft key is released, end the application
     */
    public void softKeyReleased(int anIndex){
        if(anIndex == SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }else if(anIndex == SOFT_KEY_2){
            Display.setCurrent(frame);
        }
    }

    /* A method to display the result */
    public void showResult(){
        MediaImage aMediaImage;
        MediaData md;
        VisualPresenter vp = new VisualPresenter();

        if(firstType == 0){
            switch(secondType){
                //J112_0303_0103
                case 0:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a1-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0104
                case 1:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a2-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0105
                case 2:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a3-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0106
                case 3:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a4-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0107
                case 4:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a5-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0108
                case 5:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a6-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0109
                case 6:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a7-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0110
                case 7:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a8-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));

                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0111
                case 8:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a9-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                //J112_0303_0112
                case 9:
                    try{
                        add(vp);
                        aMediaImage = MediaManager.getImage
                                                    ("resource:///89a10-1.gif");
                        aMediaImage.use();
                        vp.setBackground
                                    (Graphics.getColorOfName(Graphics.YELLOW));
                        vp.setImage(aMediaImage);
                        vp.play();
                        resultBox.setText("OK\nDisplaySuccessful");
                    }catch(Exception anException){
                        resultBox.setText("NG : "+anException.toString());
                    }
                    break;

                default:
                    break;
            }
        }
    }
}