/**
 * J114_0105_0301
 * MainPanel
 *
 * Confirmation of operations of incorrect scheme of Media Abnormal route test
 *
 * $Id: J114_0105_0301.java,v 1.1 2002/01/07 07:23:20 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Main class of confirmation of operations of incorrect scheme of Media Abnormal route test
 * @extends IApplication
 */
public class J114_0105_0301 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }


    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * Main screen of confirmation of operations of incorrect scheme of Media Abnormal route test
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
        String[] menuItems = {
            "1 getData",
            "2 getImage",
            "3 getSound"
        };

        Button  execButton      = new Button("execute");
        Label   label           = new Label("Wrong scheme");
        ListBox menu            = new ListBox(ListBox.CHOICE);

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            setTitle("Media abnormal route");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(label);
            menu.setItems(menuItems);
            add(menu);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* Call a method for test implementation */
                test();
            }
        }


        /**
         * Method for test implementation
         */
        public void test() {
            /* Create URL of incorrect scheme */
            String orgURL = getSourceURL();
            String url;
            if( orgURL.startsWith("https") ) {
                url = "http" + orgURL.substring(5);
            } else {
                url = "https" + orgURL.substring(4);
            }

            /* Acquisition of media data */
            MediaImage mi = null;
            MediaSound ms = null;
            MediaData  md = null;
            try {
                switch( menu.getSelectedIndex() ) {
                case 0:
                	// J114_0105_0305
                    // J114_0105_0306
                    md = MediaManager.getData(url+"aaa.gif");
                	if(md == null){
                		showDialog("MediaData: Null");
                		return;
                	}
                    break;
                    
                case 1:
                	// J114_0105_0301
                    // J114_0105_0302
                    mi = MediaManager.getImage(url+"aaa.gif");
                    break;
                    
                case 2:
                    // J114_0105_0303
                    // J114_0105_0304
                    ms = MediaManager.getSound(url+"aaa.mld");
                    break;
                }
                showDialog("NG: no Exception");
            } catch( SecurityException se ) {
                showDialog("SecurityException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
        }
    }
}
