/**
 * J114_0106_0101
 * MainPanel
 *
 * Confirmation of operations of incorrect argument of Media Abnormal route test
 *
 * $Id: J114_0106_0101.java,v 1.1 2002/01/07 07:23:56 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Main class of confirmation of operations of incorrect argument of Media Abnormal route test
 * @extends IApplication
 */
public class J114_0106_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }


    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * Main screen of confirmation of operations of incorrect argument of Media Abnormal route test
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
        String[] menu1Items = {
            "1 IP",
           
        };
        String[] menu2Items = {
            "1 getData",
            "2 getImage",
            "3 getSound"
        };

        Button  execButton      = new Button("execute");
        Label   label           = new Label("Wrong argument");
        ListBox menu1           = new ListBox(ListBox.CHOICE);
        ListBox menu2           = new ListBox(ListBox.CHOICE);

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            setTitle("Media abnormal route");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(label);
            menu1.setItems(menu1Items);
            add(menu1);
            menu2.setItems(menu2Items);
            add(menu2);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* In the case menu1 is selected, */
            if (aComponent == menu1 &&
                aType == ComponentListener.SELECTION_CHANGED ) {
                /* Reset menu2 */
                menu2.setItems(menu2Items);
                return;
            }

            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* Call a method for test implementation */
                test();
            }
        }


        /**
         * Method for test implementation
         */
        public void test() {
            int idx1 = menu1.getSelectedIndex();
            int idx2 = menu2.getSelectedIndex();
            /* Creation of incorrect URL */
            String orgURL = getSourceURL();
            int i = orgURL.indexOf(".ne.jp");
            i += 7;
            String url = new String("");
            url = "http://10.7.214.95/";
//            url += orgURL.substring(i);
        	
            MediaImage mi = null;
            MediaSound ms = null;
            MediaData  md = null;
            try {
              switch( idx2 ) {
                case 0:
                    // J114_0106_0101
                    // J114_0106_0104
                    // J114_0106_0107
                    // J114_0106_0110
                    // J114_0106_0113
                    md = MediaManager.getData(url+"aaa.gif");
                	if(md == null){
                		showDialog("MediaData: Null");
                		return;
                	}
                    break;
                case 1:
                    // J114_0106_0102
                    // J114_0106_0105
                    // J114_0106_0108
                    // J114_0106_0111
                    // J114_0106_0114
                    mi = MediaManager.getImage(url+"aaa.gif");
                    break;
                case 2:
                    // J114_0106_0103
                    // J114_0106_0106
                    // J114_0106_0109
                    // J114_0106_0112
                    // J114_0106_0115
                    ms = MediaManager.getSound(url+"aaa.mld");
                    break;
                }
                showDialog("NG: no Exception");
            } catch( IllegalArgumentException iae ) {
                showDialog("IllegalArgumentException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
        }
    }
}
