/**
 * J114_0201_0101
 * MainPanel
 *
 * Confirmation of operations of illegal Content-Length of Media Abnormal route test
 *
 * $Id: J114_0201_0101.java,v 1.1 2002/01/07 07:25:03 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * Main class of confirmation of operations of illegal Content-Length of Media Abnormal route test
 * @extends IApplication
 */
public class J114_0201_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }


    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * Main screen of confirmation of operations of illegal Content-Length of Media Abnormal route test
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
        String[] menuItems = {
            "1 GIF87a",
            "2 GIF89a",
            "3 JFIF",
            "4 MFi"
        };
        String[] filenames = {
            "87a-1.gif",
            "89a6-1.gif",
            "jfif2-1.jpg",
            "MFi1-1.mld"
        };

        Button  execButton      = new Button("execute");
        Label   label           = new Label("Illegal Content-Length");
        ListBox menu            = new ListBox(ListBox.CHOICE);

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            setTitle("Media abnormal route");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(label);
            menu.setItems(menuItems);
            add(menu);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* Call a method for test implementation */
                test();
            }
        }


        /**
         * Method for test implementation
         */
        public void test() {
            MediaImage mi = null;
            MediaSound ms = null;
            int idx = menu.getSelectedIndex();
            String url = getSourceURL() + "../cgi-bin/getmedia.cgi?" + filenames[idx];
            // J114_0201_0101
            // J114_0201_0108
            // J114_0201_0114
            // J114_0201_0117
            try {
                if( idx == 3 ) {
                    ms = MediaManager.getSound(url);
                    ms.use();
                } else {
                    mi = MediaManager.getImage(url);
                    mi.use();
                }
                showDialog("NG: no Exception");
            } catch( ConnectionException ce ) {
                showDialog("ConnectionException");
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            }
        }
    }
}
