/** 
 * J211_0201_0101
 * MainPanel
 * 
 * Class operational test(AudioPresenter)
 * 
 * $id: $
 */

import com.nttdocomo.io.* ;
import com.nttdocomo.ui.* ;

/** 
 * Main class of class's operational test(AudioPresenter)
 * @extends IApplication
 */
public class J211_0201_0101 extends IApplication{
    
    /** 
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/** 
 * Main screen of class's operational test(AudioPresenter)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    String[] menuListItem = {
//2002/08/06 Doja1.5        "0. Test 1",
//2002/08/06 Doja1.5        "1.Test 2",
        "2.Test 3",
    };
    
    Frame subFrame ;
    Label classLabel = new Label("AudioPresenter1");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultBox =new TextBox("",20,2,TextBox.DISPLAY_ANY);
    Button execButton = new Button("execute");
    Button stopButton = new Button("Stop");
    AudioPresenter ap1 = null;
    AudioPresenter ap2 = null;
    AudioPresenter ap3 = null;
    
    /** 
     * Constructor of MainPanel
     */
    public MainPanel(){
        try{
            /* Display MainPanel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
            errDialog.setText("Error:" +e.toString());
            errDialog.show();
        }
    }
    
    /** 
     * Display a main panel
     */
    void showMainPanel(){
        /* Settings of display items */
        menuList.setItems(menuListItem);
        setTitle("Class's operational test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
    
        /* Add each component to screen */
        add(classLabel);
        add(menuList);
        add(execButton);
        add(stopButton);
        add(resultBox);
    
        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /** 
     *When soft key is pressed, do not carry out any operations.
     */
    public void softKeyPressed(int anIndex){}
    
    /** 
     * When soft key1 is released terminate the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key1 is released, end the application */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /** 
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType Type of events
     * @param aParam Parameter of events
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        int index = menuList.getSelectedIndex();
        /* Processes when execute button is pressed */
        if(aComponent == execButton && aType == 
            ComponentListener.BUTTON_PRESSED){
            test();
        }

        /* Process of when replay is suspended */
        if(aComponent == stopButton && aType == 
            ComponentListener.BUTTON_PRESSED){
                try {
                    ap1.stop();
                    resultBox.setText("Stop replaying");
                } catch(Exception e) {
                    resultBox.setText("NG");
                }
        }
    }

    /** 
     * Create a test method
     * Each event of the case when execute button is pressed
     */
    public void test(){
        try {
            ap1 = AudioPresenter.getAudioPresenter();
            ap2 = AudioPresenter.getAudioPresenter();
            MediaSound ms = MediaManager.getSound("resource:///MFi1-1.mld");
            ms.use();
            ap1.setSound(ms);
        } catch(Exception e) {
            resultBox.setText("NG:" + e.toString());
        }
        int index = menuList.getSelectedIndex();

        switch (index) {
//J211_0201_0201
//2002/08/06 Doja1.5            case 0:
//2002/08/06 Doja1.5                try{
//2002/08/06 Doja1.5                    ap1.setAttribute(AudioPresenter.SYNC_MODE,1);
//2002/08/06 Doja1.5                    resultBox.setText("OK: Test 1");
//2002/08/06 Doja1.5                }catch(UIException e){
//2002/08/06 Doja1.5                    resultBox.setText("NG");
//2002/08/06 Doja1.5                }
//2002/08/06 Doja1.5                break;
//J211_0201_0202
//2002/08/06 Doja1.5            case 1:
//2002/08/06 Doja1.5                try{
//2002/08/06 Doja1.5                    ap1.play();
//2002/08/06 Doja1.5                    ap1.setAttribute(AudioPresenter.SYNC_MODE,1);
//2002/08/06 Doja1.5                    resultBox.setText("OK:Test 2");
//2002/08/06 Doja1.5                }catch(Exception e){
//2002/08/06 Doja1.5                    resultBox.setText("NG");
//2002/08/06 Doja1.5                }
//2002/08/06 Doja1.5                break;
//J211_0201_0401
            case 0:
//2002/08/06 Doja1.5            case 2:
                if (ap1 == ap2) {
                    resultBox.setText("NG");
                } else {
                    resultBox.setText("OK:Test 3");
                }
                break;
            default:
                break;
        }
    }
}
