/** 
 * J211_0202_0101
 * MainPanel
 * 
 * Class operational test(AudioPresenter)
 * 
 * $id: $
 */

import com.nttdocomo.io.* ;
import com.nttdocomo.ui.* ;

/** 
 * Main class of class's operational test(AudioPresenter)
 * @extends IApplication
 */
public class J211_0202_0101 extends IApplication{
    
    /** 
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/** 
 * Main screen of class's operational test(AudioPresenter)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener,
    MediaListener {
    String[] menuListItem = {
        "0.Test 1",
        "1.Test 2",
        "2.Test 3",
//2002/08/06 Doja1.5        "3.Test 4",
        "4.Test 5",
    };
    
    Frame subFrame ;
    Label classLabel = new Label("AudioPresenter2");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultBox =new TextBox("",20,2,TextBox.DISPLAY_ANY);
    Button execButton = new Button("execute");
    Button stopButton = new Button("Stop");
    AudioPresenter ap1 = null;
    int testindex = 0;

    /** 
     * Constructor of MainPanel
     */
    public MainPanel(){
        try{
            /* Display MainPanel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
            errDialog.setText("Error:" +e.toString());
            errDialog.show();
        }
    }
    
    /** 
     * Display a main panel
     */
    void showMainPanel(){
        /* Settings of display items */
        menuList.setItems(menuListItem);
        setTitle("Class's operational test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
    
        /* Add each component to screen */
        add(classLabel);
        add(menuList);
        add(execButton);
        add(stopButton);
        add(resultBox);
    
        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /** 
     *When soft key is pressed, do not carry out any operations.
     */
    public void softKeyPressed(int anIndex){}
    
    /** 
     * When soft key1 is released terminate the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key1 is released, end the application */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /** 
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType Type of events
     * @param aParam Parameter of events
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        int index = menuList.getSelectedIndex();
        /* Processes when execute button is pressed */
        if(aComponent == execButton && aType == 
            ComponentListener.BUTTON_PRESSED){
            test();
        }

        /* Process of when replay is suspended */
        if(aComponent == stopButton && aType == 
            ComponentListener.BUTTON_PRESSED){
                try {
                    ap1.stop();
                    resultBox.setText("Stop replaying");
                } catch(Exception e) {
                    resultBox.setText("NG");
                }
        }
    }

    /** 
     * Create a test method
     * Each event of the case when execute button is pressed
     */
    public void test(){
        try {
            ap1 = AudioPresenter.getAudioPresenter();
            MediaSound ms = MediaManager.getSound("resource:///Java1.mld");
            ms.use();
            ap1.setSound(ms);
            ap1.setMediaListener(this);
        } catch(Exception e) {
            resultBox.setText("NG:" + e.toString());
        }
        resultBox.setText("");
        int index = menuList.getSelectedIndex();

        switch (index) {
//J211_0202_0101
            case 0:
                try{
                    testindex = 1;
                    ap1.play();
                }catch(UIException e){
                    resultBox.setText("NG");
                }
                break;
//J211_0202_0102
            case 1:
                try{
                    testindex = 2;
                    ap1.play();
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;
//J211_0202_0103
            case 2:
                try{
                    testindex = 3;
                    ap1.play();
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;
//J211_0202_0104
//2002/08/06 Doja1.5            case 3:
//2002/08/06 Doja1.5                try{
//2002/08/06 Doja1.5                    testindex = 4;
//2002/08/06 Doja1.5                    ap1.setAttribute(AudioPresenter.SYNC_MODE,1);
//2002/08/06 Doja1.5	                ap1.setSyncEvent(0, 30);
//2002/08/06 Doja1.5                    ap1.play();
//2002/08/06 Doja1.5                }catch(Exception e){
//2002/08/06 Doja1.5                    resultBox.setText("NG");
//2002/08/06 Doja1.5                }
//2002/08/06 Doja1.5                break;
//J211_0202_0105
//2002/09/17 Doja1.5            case 4:
            case 3:
                try{
                    testindex = 5;
                    ap1.play();
                    ap1.play();
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;
            default:
                break;
        }
    }

    /**
     *  Process that is responsible for event registration
     */
    public void mediaAction(MediaPresenter source,int aType,int aParam) {
        if (aType == AudioPresenter.AUDIO_COMPLETE) {
            if (testindex == 1) {
                resultBox.setText("OK:COMPLETE");
            }else{
            }
        }else if(aType == AudioPresenter.AUDIO_PLAYING) {
            if (testindex == 2) {
                resultBox.setText("OK:PLAYING");
            }else if (testindex == 6) {
                resultBox.setText(resultBox.getText() + "\nOK:PLAYING");
            }else{
            }
        }else if(aType == AudioPresenter.AUDIO_STOPPED) {
            if (testindex == 3) {
                resultBox.setText("OK:STOPPED");
            }else if (testindex == 5) {
                resultBox.setText("STOPPED");
                testindex = 6;
            }else{
            }
//2002/08/06 Doja1.5        }else if(aType == AudioPresenter.AUDIO_SYNC) {
//2002/08/06 Doja1.5            if (testindex == 4) {
//2002/08/06 Doja1.5                resultBox.setText("OK:SYNC");
//2002/08/06 Doja1.5            }else{
//2002/08/06 Doja1.5            }
        }else{
        }
    }
}
