/** 
 * J211_0202_0201
 * MainPanel
 * 
 * Class operational test(AudioPresenter)
 * 
 * $id: $
 */

import com.nttdocomo.io.* ;
import com.nttdocomo.ui.* ;
import java.lang.* ;

/** 
 * Main class of class's operational test(AudioPresenter)
 * @extends IApplication
 */
public class J211_0202_0201 extends IApplication{
	
	/** 
	 * Commencing method to i-appli
	 */
	public void start(){
		Display.setCurrent(new MainPanel());
	}
}

/** 
 * Main screen of class's operational test(AudioPresenter)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener,MediaListener {

	String[] menuListItem = {
		"0.Test 1",
		"1.Test 2",
	};
	
	Frame subFrame ;
	Label classLabel = new Label("AudioPresenter3");
	ListBox menuList = new ListBox(ListBox.CHOICE);
	TextBox resultBox =new TextBox("",20,3,TextBox.DISPLAY_ANY);
	Button execButton1 = new Button("execute 1");
	Button execButton2 = new Button("execute 2");
	Button stopButton = new Button("Stop");
	AudioPresenter ap1 = null;
	AudioPresenter ap2 = null;
	boolean buttonFlg = false;

	/** 
	 * Constructor of MainPanel
	 */
	public MainPanel(){
		try{
			/* Display MainPanel */
			showMainPanel();
		}catch(Exception e){
			Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
			errDialog.setText("Error:" +e.toString());
			errDialog.show();
		}
	}
	
	/** 
	 * Display a main panel
	 */
	void showMainPanel(){
		/* Settings of display items */
		menuList.setItems(menuListItem);
		setTitle("Class's operational test");
		setSoftLabel(Frame.SOFT_KEY_1,"exit");
	
		/* Add each component to screen */
		add(classLabel);
		add(menuList);
		add(execButton1);
		add(execButton2);
		add(stopButton);
		add(resultBox);
	
		/* Listener setting */
		setSoftKeyListener(this);
		setComponentListener(this);
	}
	
	/** 
	 *When soft key is pressed, do not carry out any operations.
	 */
	public void softKeyPressed(int anIndex){}
	
	/** 
	 * When soft key1 is released terminate the application
	 */
	public void softKeyReleased(int anIndex){
		/* When soft key1 is released, end the application */
		if(anIndex == Frame.SOFT_KEY_1){
			IApplication.getCurrentApp().terminate();
		}
	}

	/** 
	 * Receive events occurred in components
	 * @param aComponent  Component where an event occurred
	 * @param aType Type of events
	 * @param aParam Parameter of events
	 */
	public void componentAction(Component aComponent,int aType,int aParam){
		int index = menuList.getSelectedIndex();
		/* Process of when enter1 button is pressed */
		if(aComponent == execButton1 && aType == ComponentListener.BUTTON_PRESSED){
			ap1 = AudioPresenter.getAudioPresenter();
			try{
				ap2=AudioPresenter.getAudioPresenter();
			}
			catch (Exception e){
				resultBox.setText("Exception:" + e.toString());
			}
			try{
				MediaSound ms = MediaManager.getSound("resource:///MFi1-1.mld");
				MediaSound ms2 = MediaManager.getSound("resource:///MFi1-1.mld");
				ms.use();
				ms2.use();
				ap1.setSound(ms);
				ap1.setMediaListener(this);
				ap2.setSound(ms2);
				ap2.setMediaListener(this);
			}
			catch (Exception e){
				resultBox.setText("Exception2:" + e.toString());
			}
			test1();
		}

		/* Process of when enter2 button is pressed */
		if(aComponent == execButton2 && aType == 
			ComponentListener.BUTTON_PRESSED){
			test2();
		}

		/* Process of when replay is suspended */
		if(aComponent == stopButton && aType == 
			ComponentListener.BUTTON_PRESSED){
				try {
					ap1.stop();
					ap2.stop();
					resultBox.setText("Stop replaying");
				} catch(Exception e) {
					resultBox.setText("NG");
				}
		}
	}

	/** 
	 * Create test1 method
	 * Each event of when enter1 button is pressed
	 */
	public void test1(){

		int index = menuList.getSelectedIndex();
		buttonFlg = false;

		switch (index) {
//J211_0202_0201
			case 0:
				try{
					ap1.play();
//					StopClass sc = new StopClass();
//					Thread t1 = new Thread(sc);
//					t1.start();
				}catch(UIException e){
					resultBox.setText("NG");
				}
				break;
//J211_0202_0301
			case 1:
				 try{
					ap1.setMediaListener(new MediaListener() {
						public void mediaAction(MediaPresenter source,
							int aType,int aParam) {
							if(aType == AudioPresenter.AUDIO_PLAYING) {
								resultBox.setText(resultBox.getText()
									+ "ap1:PLAYING");
							}
						}
					});
					ap2.setMediaListener(new MediaListener() {
						public void mediaAction(MediaPresenter source,
							int aType,int aParam) {
							if(aType == AudioPresenter.AUDIO_PLAYING) {
								resultBox.setText(resultBox.getText()
									+ "\nap2:PLAYING");
							}
						}
					});
					ap1.play();
					ap2.play();
				}catch(Exception e){
					resultBox.setText("NG");
				}

				break;
			default:
				break;
		}
	}

	public void mediaAction(MediaPresenter source,int aType,int aParam) {
		if( aType == AudioPresenter.AUDIO_PLAYING) {
			if (buttonFlg == false) {
			  resultBox.setText(resultBox.getText()+ "execute 1:PLAYING");
//2003.05.13
                          test2();
			}else{
			  resultBox.setText(resultBox.getText()+ "\nExecute 2:PLAYING");
			}
			try {
				Thread.sleep(10000);
			} catch (Exception e) {
				resultBox.setText("NG");
			}

		}
	}


	/** 
	 * Create test2 method
	 * Each event of when enter2 button is pressed
	 */
	public void test2(){
		int index = menuList.getSelectedIndex();
		buttonFlg = true;

		switch (index) {
//J211_0202_0201
			case 0:
				try{
					ap1.play();
				}catch(UIException e){
					resultBox.setText("NG");
				}
				break;
			case 1:
				break;
			default:
				break;
		}
	}


	/**
	 * Class for execution of Threads
	 * @implements Runnable
	 */
	class StopClass implements Runnable {

		/**
		 * Constructor of StopClass
		 * @param aJudgment  Judgement of threads
		 */
		public StopClass(){
		}

		/**
		 * Thread execution method
		 */
		public void run() {
			buttonFlg = false;
		}
	}
}

