/** 
 * J211_0202_0401
 * MainPanel
 * 
 * Class operational test(AudioPresenter)
 * 
 * $id: $
 */

import com.nttdocomo.io.* ;
import com.nttdocomo.ui.* ;
import java.lang.* ;

/** 
 * Main class of class's operational test(AudioPresenter)
 * @extends IApplication
 */
public class J211_0202_0401 extends IApplication{

    MainPanel testPanel = new MainPanel();

    /** 
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(testPanel);
    }

    /**
     *  Resume process
     */
    public void resume() {
        try {
        	testPanel.resultBox.setText("OK:STOPPED");
            Thread.sleep(5000);
        }catch(Exception e) {
            testPanel.resultBox.setText("NG");
        }
        testPanel.ap1.play();
    }

}

/** 
 * Main screen of class's operational test(AudioPresenter)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener,
    MediaListener {

    String[] menuListItem = {
        "0. Test 1",
    };
    
    Frame subFrame ;
    Label classLabel = new Label("AudioPresenter4");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultBox =new TextBox("",20,2,TextBox.DISPLAY_ANY);
    Button execButton = new Button("execute");
    Button stopButton = new Button("Stop");
    AudioPresenter ap1 = null;

    /** 
     * Constructor of MainPanel
     */
    public MainPanel(){
        try{
            /* Display MainPanel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
            errDialog.setText("Error:" +e.toString());
            errDialog.show();
        }
    }
    
    /** 
     * Display a main panel
     */
    void showMainPanel(){
        /* Settings of display items */
        menuList.setItems(menuListItem);
        setTitle("Class's operational test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
    
        /* Add each component to screen */
        add(classLabel);
        add(menuList);
        add(execButton);
        add(stopButton);
        add(resultBox);
    
        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /** 
     *When soft key is pressed, do not carry out any operations.
     */
    public void softKeyPressed(int anIndex){}
    
    /** 
     * When soft key1 is released terminate the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key1 is released, end the application */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /** 
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType Type of events
     * @param aParam Parameter of events
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        int index = menuList.getSelectedIndex();
        /* Process of when enter1 button is pressed */
        if(aComponent == execButton && aType == 
            ComponentListener.BUTTON_PRESSED){
            test();
        }

        /* Process of when replay is suspended */
        if(aComponent == stopButton && aType == 
            ComponentListener.BUTTON_PRESSED){
                try {
                    ap1.stop();
                    resultBox.setText("Stop replaying");
                } catch(Exception e) {
                    resultBox.setText("NG");
                }
        }
    }

    /** 
     * Create a test method
     * Each event of the case when execute button is pressed
     */
    public void test(){
        try {
            ap1 = AudioPresenter.getAudioPresenter();
            MediaSound ms = MediaManager.getSound("resource:///MFi1-1.mld");
            ms.use();
            ap1.setSound(ms);
            ap1.setMediaListener(this);
        } catch(Exception e) {
            resultBox.setText("NG:" + e.toString());
        }
        int index = menuList.getSelectedIndex();

        switch (index) {
//J211_0202_0401
//J211_0202_0402
//J211_0202_0403
//J211_0202_0404
//J211_0202_0501
//J211_0202_0502
//J211_0202_0503
//J211_0202_0504
//J211_0202_0601
//J211_0202_0602
//J211_0202_0603
//J211_0202_0604
            case 0:
                try{
                    ap1.play();
                }catch(UIException e){
                    resultBox.setText("NG");
                }
                break;
            default:
                break;
        }
    }

    /** 
     * Process that is responsible for event registration
     */
    public void mediaAction(MediaPresenter source,int aType,int aParam){
        if( aType == AudioPresenter.AUDIO_PLAYING ) {
            resultBox.setText("PLAYING");
        }else if(aType == AudioPresenter.AUDIO_STOPPED){
            resultBox.setText("OK:STOPPED");
        }else{
            
        }
    }
}
