/** 
 * J211_0203_0101
 * MainPanel
 * 
 * Class operational test(AudioPresenter)
 * 
 * $id: $
 */

import com.nttdocomo.io.* ;
import com.nttdocomo.ui.* ;

/** 
 * Main class of class's operational test(AudioPresenter)
 * @extends IApplication
 */
public class J211_0203_0101 extends IApplication{
    
    /** 
     * Commencing method to i-appli
     */
    public void start(){
        Display.setCurrent(new MainPanel());
    }
}

/** 
 * Main screen of class's operational test(AudioPresenter)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    String[] menuListItem = {
        "0.Test 1",
        "1.Test 2",
        "2.Test 3",
        "3.Test 4",
        "4.Test 5",
        "5.Test 6",
        "6.Test 7",
    };
    
    Frame subFrame ;
    Label classLabel = new Label("AudioPresenter4");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultBox =new TextBox("",20,2,TextBox.DISPLAY_ANY);
    Button execButton1 = new Button("execute 1");
    Button execButton2 = new Button("execute 2");
    Button stopButton = new Button("Stop");
    AudioPresenter ap1 = null;
    int testindex = 0;

    /** 
     * Constructor of MainPanel
     */
    public MainPanel(){
        try{
            /* Display MainPanel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
            errDialog.setText("Error:" +e.toString());
            errDialog.show();
        }
    }
    
    /** 
     * Display a main panel
     */
    void showMainPanel(){
        /* Settings of display items */
        menuList.setItems(menuListItem);
        setTitle("Class's operational test");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
    
        /* Add each component to screen */
        add(classLabel);
        add(menuList);
        add(execButton1);
        add(execButton2);
        add(stopButton);
        add(resultBox);
    
        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /** 
     *When soft key is pressed, do not carry out any operations.
     */
    public void softKeyPressed(int anIndex){}
    
    /** 
     * When soft key1 is released terminate the application
     */
    public void softKeyReleased(int anIndex){
        /* When soft key1 is released, end the application */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /** 
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType Type of events
     * @param aParam Parameter of events
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        int index = menuList.getSelectedIndex();
        /* Processes when execute button is pressed */
        if(aComponent == execButton1 && aType == 
            ComponentListener.BUTTON_PRESSED){
            test1();
        }

        /* Process of when enter2 button is pressed */
        if(aComponent == execButton2 && aType == 
            ComponentListener.BUTTON_PRESSED){
            test2();
        }

        /* Process of when replay is suspended */
        if(aComponent == stopButton && aType == 
            ComponentListener.BUTTON_PRESSED){
                try {
                    ap1.stop();
                    resultBox.setText("Stop replaying");
                } catch(Exception e) {
                    resultBox.setText("NG");
                }
        }
    }

    /** 
     * Create test1 method
     * Each event of the case when execute button is pressed
     */
    public void test1(){
        try {
            ap1 = AudioPresenter.getAudioPresenter();
            MediaSound ms = MediaManager.getSound("resource:///MFi1-1.mld");
            ms.use();
            ap1.setSound(ms);
        } catch(Exception e) {
            resultBox.setText("NG:" + e.toString());
        }
        resultBox.setText("");
        int index = menuList.getSelectedIndex();

        switch (index) {
//J211_0203_0101
            case 0:
                try{
                    testindex = 1;
                    ap1.play();
                    resultBox.setText("OK:PLAYING");
                }catch(UIException e){
                    resultBox.setText("NG");
                }
                break;
//J211_0203_0102
//J211_0203_0201
            case 1:
                try{
                    ap1.setMediaListener(new MediaListener() {
                        public void mediaAction(MediaPresenter source,
                            int aType,int aParam) {
                            if(aType == AudioPresenter.AUDIO_PLAYING) {
                                resultBox.setText("OK:PLAYING");
                            }
                        }
                    });
                    ap1.play();
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;

//J211_0203_0202
            case 2:
                try{
                    ap1.setMediaListener(new MediaListener() {
                        public void mediaAction(MediaPresenter source,
                            int aType,int aParam) {
                            if(aType == AudioPresenter.AUDIO_PLAYING) {
                                resultBox.setText("NG:PLAYING");
                            }
                        }
                    });
                    ap1.setMediaListener(new MediaListener() {
                        public void mediaAction(MediaPresenter source,
                            int aType,int aParam) {
                            if(aType == AudioPresenter.AUDIO_PLAYING) {
                                resultBox.setText("OK:PLAYING");
                            }
                        }
                    });
                    ap1.play();
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;
//J211_0203_0203
            case 3:
                try{
                    ap1.setMediaListener(new MediaListener() {
                        public void mediaAction(MediaPresenter source,
                            int aType,int aParam) {
                            if(aType == AudioPresenter.AUDIO_PLAYING) {
                                resultBox.setText(resultBox.getText()
                                    + "\nNG ");
                            }
                        }
                    });
                    ap1.setMediaListener(null);
                    ap1.play();
                    resultBox.setText(resultBox.getText() + "PLAYING");
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;
//J211_0203_0301
            case 4:
                try{
                    ap1.play();
                    resultBox.setText("PLAYING");
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;

//J211_0203_0302
            case 5:
                try{
                    ap1.play();
                    resultBox.setText("PLAYING");
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;

//J211_0203_0303
            case 6:
                try{
                    ap1.setMediaListener(new MediaListener() {
                        public void mediaAction(MediaPresenter source,
                            int aType,int aParam) {
                            if(aType == AudioPresenter.AUDIO_PLAYING) {
                                resultBox.setText("PLAYING");
                            }else if(aType == AudioPresenter.AUDIO_STOPPED) {
                                resultBox.setText("NG:STOPPED");
                            }else{}
                        }
                    });
                    ap1.play();
                }catch(Exception e){
                    resultBox.setText("NG");
                }
                break;
            default:
                break;
        }
    }

    /** 
     * Create test2 method
     * Each event of when enter2 button is pressed
     */
    public void test2(){
        int index = menuList.getSelectedIndex();
        switch (index) {
//J211_0203_0301
            case 4:
                ap1.setMediaListener(new MediaListener() {
                    public void mediaAction(MediaPresenter source,
                        int aType,int aParam) {
                        if(aType == AudioPresenter.AUDIO_PLAYING) {
                            resultBox.setText("NG: Now replaying");
                        }else if(aType == AudioPresenter.AUDIO_STOPPED) {
                            resultBox.setText("OK:STOPPED");
                        }else{}
                    }
                });
                resultBox.setText("ListenerSet");
                break;

//J211_0203_0302
            case 5:
                ap1.setMediaListener(new MediaListener() {
                    public void mediaAction(MediaPresenter source,
                        int aType,int aParam) {
                        if(aType == AudioPresenter.AUDIO_STOPPED) {
                            resultBox.setText("NG:STOPPED");
                        }
                    }
                });
                ap1.setMediaListener(new MediaListener() {
                    public void mediaAction(MediaPresenter source,
                        int aType,int aParam) {
                        if(aType == AudioPresenter.AUDIO_STOPPED) {
                            resultBox.setText("OK:STOPPED");
                        }
                    }
                });
                resultBox.setText("ListenerSet");
                break;

//J211_0203_0303
            case 6:
                ap1.setMediaListener(null);
                resultBox.setText("ListenerNull");
                break;
        }
    }
}
