/**
 * J211_0301_0101.java
 * 
 * J211_0301_0101
 * MenuPanel
 * TestPanel
 * 
 * Class operational test(Button)
 * 
 * $Id: J211_0301_0101.java,v 1.1 2002/02/01 06:33:04 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class for class's operational test(Button)
 * @extends IApplication
 */
public class J211_0301_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational test(Button)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;
    ListBox menu2 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
        "0.Check behavior of display",
        "1.Check behavior of the size",
        "2.Check the behavior of the focus",
    };

    String[][] menu2Item = {
        /* Menu for checking display operations */
        {
            "0.In case of default size",
            "1.Specify the size 1",
            "2.Specify the size 2",
            "3.Invisible state",
            "4.Invalid state",
            "5.Linefeed",
            "6.Specify the foreground",
            "7.Specify both",
        },
        /* Menu for checking size operations */
        {
            "0.null",
            "1.No character",
            "2.one byte character",
//2002/08/06 Doja1.5            "3.two byte character",
            "4.String",
            "5.Horizontal > Character",
            "6.Horizontal = Character",
            "7.Horizontal < Character",
            "8.Vertical > Character",
            "9.Vertical=Character",
            "10.Vertical<Character",

        },
        /* Menu for checking behavior of the focus */
        {
            "0.With and without focus",
        },
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("Button1");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 3);
        menu2 = new ListBox(ListBox.CHOICE, 11);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        add(menu1);
        add(menu2);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* Set an item (menu2) when menu list (menu1) is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
            }
        }
        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();

                /* Transit to Panel for checking behavior */
                Display.setCurrent(new TestPanel(menu1Index, menu2Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Screen for checking class's operational(Button) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel extends Panel implements SoftKeyListener,ComponentListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int menu1Index = 0;
    int menu2Index = 0;                 /* Index of the menu of previous screen */
    Label subTitle = null;              /* Sub title */
    Label testLabel = null;             /* Test label */
    Button testButton;                  /* Button */
    Button testButton2;                  /* Button */
    TextBox textBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);
    int count = 0;
    int ButtonIndex = 0;

    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    TestPanel(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        menu1Index = menu1Index;
        menu2Index = menu2Index;

        try {
            showTestPanel();
            test(menu1Index, menu2Index);
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Panel for checking operations
     */
    void showTestPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        subTitle = new Label("");
        testLabel = new Label("");

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * The method of confirming operations
     * @param  menu1Index  Index of menu1 of menu screen
     * @param  menu2Index  Index of menu2 of menu screen
     */
    void test(int menu1Index, int menu2Index) {

        switch ( menu1Index ) {
            /* Check display operations */
            case 0:
                switch ( menu2Index ) {
//J221_0301_0201
                    case 0:
                        subTitle.setText("In case of default size");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        add(testButton);
                        break;
//J221_0301_0202
                    case 1:
                        subTitle.setText(" Specify the size 1");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(getWidth(),15);
                        add(testButton);
                        break;
//J221_0301_0203
                    case 2:
                        subTitle.setText(" Specify the size 2");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(50,Display.getHeight());
                        add(testButton);
                        break;
//J221_0301_0301
                    case 3:
                        subTitle.setText("Invisible state");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setVisible(false);
                        testLabel.setText("An empty line to exist above");
                        add(testButton);
                        add(testLabel);
                        break;
//J221_0301_0401
                    case 4:
                        subTitle.setText("Invalid state");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setEnabled(false);
                        add(testButton);
                        break;
//J221_0301_0505
                    case 5:
                        subTitle.setText("Linefeed");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("B\nu\nt\nt\no\nn\n");
                        add(testButton);
                        break;
//J221_0301_0602
                    case 6:
                        subTitle.setText("Specify the foreground");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("\uE653\uE749");
                        testButton.setForeground(ColorBox.colors[count]);
                        textBox.setText("Button's foreground is " + 
                            ColorBox.names[count] + 
                                " To be displayed by - and no influence on colors of pictograph and graphic image");
                        count++;
                        add(testButton);
                        add(textBox);
                        ButtonIndex = 1;
                        break;
//J221_0301_0604
                    case 7:
                        subTitle.setText("Specify both");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");

                        testButton.setBackground(ColorBox.colors[count]);
                        if(count == 15) {
                            count = 0;
                            testButton.setForeground(ColorBox.colors[count]);
                            textBox.setText(ColorBox.names[count] + 
                            " Characters to be displayed by");
                            count = 15;
                        } else {
                            testButton.setForeground(ColorBox.colors[count+1]);
                            textBox.setText(ColorBox.names[count+1] + 
                            " Characters to be displayed by");
                        }
                        count++;
                        add(testButton);
                        add(textBox);
                        ButtonIndex = 2;
                        break;
                }
                break;

            /* Check size operations */
            case 1:
                switch ( menu2Index ) {
//J221_0302_0101
                    case 0:
                        subTitle.setText("null");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button();
                        add(testButton);
                        break;
//J221_0302_0102
                    case 1:
                        subTitle.setText("No character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("");
                        add(testButton);
                        break;
//J221_0302_0103
                    case 2:
                        subTitle.setText("1 one byte character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("A");
                        add(testButton);
                        break;
//J221_0302_0104
//2002/08/06 Doja1.5                    case 3:
//2002/08/06 Doja1.5                        subTitle.setText("1 two byte character");
//2002/08/06 Doja1.5                        subTitle.setSize(getWidth(), subTitle.getHeight());
//2002/08/06 Doja1.5                        add(subTitle);
//2002/08/06 Doja1.5                        testButton = new Button("a");
//2002/08/06 Doja1.5                        add(testButton);
//2002/08/06 Doja1.5                        break;
//J221_0302_0105
                    case 3:
//2002/08/06 Doja1.5                    case 4:
                        subTitle.setText("Character strings");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Character strings");
                        add(testButton);
                        break;
//J221_0302_0201
                    case 4:
//2002/08/06 Doja1.5                    case 5:
                        subTitle.setText("Horizontal > Character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(getWidth(),15);
                        add(testButton);
                        break;
//J221_0302_0202
                    case 5:
//2002/08/06 Doja1.5                    case 6:
                        subTitle.setText("Horizontal = Character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(36,15);
                        add(testButton);
                        break;
//J221_0302_0203
                    case 6:
//2002/08/06 Doja1.5                    case 7:
                        subTitle.setText("Horizontal < Character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(30,15);
                        add(testButton);
                        break;
//J221_0302_0204
                    case 7:
//2002/08/06 Doja1.5                    case 8:
                        subTitle.setText("Vertical > Character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(36,50);
                        add(testButton);
                        break;
//J221_0302_0205
                    case 8:
//2002/08/06 Doja1.5                    case 9:
                        subTitle.setText("Vertical = Character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(36,12);
                        add(testButton);
                        break;
//J221_0302_0206
                    case 9:
//2002/08/06 Doja1.5                    case 10:
                        subTitle.setText("Vertical < Character");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button");
                        testButton.setSize(36,8);
                        add(testButton);
                        break;
                }
                break;

            /* Check focus operations */
            case 2:
                switch ( menu2Index ) {
//J211_0303_0101
//J211_0303_0201
                    case 0:
                        subTitle.setText("With or without focus");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton = new Button("Button 1");
                        testButton2 = new Button("Button 2");
                        add(testButton);
                        add(testButton2);
                        break;
                }
                break;
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == testButton ) {
            if (ButtonIndex == 1) {
                testButton.setForeground(ColorBox.colors[count]);
                textBox.setText("Button's foreground is " + ColorBox.names[count] +
                    " To be displayed by and no influence on color of the pictograph");
            } if (ButtonIndex == 2) {
                testButton.setBackground(ColorBox.colors[count]);
                if(count == 15) {
                    count = 0;
                    testButton.setForeground(ColorBox.colors[count]);
                    textBox.setText(ColorBox.names[count] + 
                    " Characters to be displayed by");
                    count = 15;
                } else {
                    testButton.setForeground(ColorBox.colors[count+1]);
                    textBox.setText(ColorBox.names[count+1] + 
                    " Characters to be displayed by");
                }
            }
            count++;
            if ( count > 15 ) {
                count = 0;
            }
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}


/**
 * Color setting of checking AnchorButton class operations
 */
class ColorBox {
    static int[] colors = {
        Graphics.getColorOfName(Graphics.BLACK),
        Graphics.getColorOfName(Graphics.BLUE),
        Graphics.getColorOfName(Graphics.LIME),
        Graphics.getColorOfName(Graphics.AQUA),
        Graphics.getColorOfName(Graphics.RED),
        Graphics.getColorOfName(Graphics.FUCHSIA),
        Graphics.getColorOfName(Graphics.YELLOW),
        Graphics.getColorOfName(Graphics.WHITE),
        Graphics.getColorOfName(Graphics.GRAY),
        Graphics.getColorOfName(Graphics.NAVY),
        Graphics.getColorOfName(Graphics.GREEN),
        Graphics.getColorOfName(Graphics.TEAL),
        Graphics.getColorOfName(Graphics.MAROON),
        Graphics.getColorOfName(Graphics.PURPLE),
        Graphics.getColorOfName(Graphics.OLIVE),
        Graphics.getColorOfName(Graphics.SILVER),
    };
    static String[] names = {
    "BLACK",
    "BLUE",
    "LIME",
    "AQUA",
    "RED",
    "FUCHSIA",
    "YELLOW",
    "WHITE",
    "GRAY",
    "NAVY",
    "GREEN",
    "TEAL",
    "MAROON",
    "PURPLE",
    "OLIVE",
    "SILVER",
    };
}

