/**
 * J211_0304_0101.java
 * 
 * J211_0304_0101
 * MenuPanel
 * TestPanel1
 * TestPanel2
 * TestPanel3
 * 
 * Class operational test(Button)
 * 
 * $Id: J211_0304_0101.java,v 1.1 2002/02/01 06:33:04 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class for class's operational test(Button)
 * @extends IApplication
 */
public class J211_0304_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational test(Button)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;
    ListBox menu2 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */
    int index = 0;

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
        "0.Default layout",
//2002/08/06 Doja1.5        "1.HTML layout",
        "2.NULL layout",
    };

    String[][] menu2Item = {
        /* Default layout menu */
        {
            "0.Test 1",
            "1.Test 2",
            "2.Test 3",
            "3.Test 4",
        },
        /* HTML layout menu */
        {
            "0.Test 1",
            "1.Test 2",
            "2.Test 3",
            "3.Test 4",
        },
        /* NULLlayout menu */
        {
            "0.Test 1",
            "1.Test 2",
            "2.Test 3",
            "3.Test 4",
        },
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("Button2");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 4);
        menu2 = new ListBox(ListBox.CHOICE, 4);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        add(menu1);
        add(menu2);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* Set an item (menu2) when menu list (menu1) is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
            }
        }
        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();

                switch ( menu1Index ) {
                    case 0:
                        switch ( menu2Index ) {
                            case 0:
                                index = 0;
                                break;
                            case 1:
                                index = 1;
                                break;
                            case 2:
                                index = 2;
                                break;
                            case 3:
                                index = 3;
                                break;
                        }
                        /* Transit to Panel1 for checking behavior */
                        Display.setCurrent(new TestPanel1(index, this));
                        break;
//2002/08/06 Doja1.5                    case 1:
//2002/08/06 Doja1.5                        switch ( menu2Index ) {
//2002/08/06 Doja1.5                            case 0:
//2002/08/06 Doja1.5                                index = 0;
//2002/08/06 Doja1.5                                break;
//2002/08/06 Doja1.5                            case 1:
//2002/08/06 Doja1.5                                index = 1;
//2002/08/06 Doja1.5                                break;
//2002/08/06 Doja1.5                            case 2:
//2002/08/06 Doja1.5                                index = 2;
//2002/08/06 Doja1.5                                break;
//2002/08/06 Doja1.5                            case 3:
//2002/08/06 Doja1.5                                index = 3;
//2002/08/06 Doja1.5                                break;
//2002/08/06 Doja1.5                        }
//2002/08/06 Doja1.5                        /* Transit to Panel2 for checking behavior */
//2002/08/06 Doja1.5                        Display.setCurrent(new TestPanel2(index, this));
//2002/08/06 Doja1.5                        break;
                    case 1:
//2002/08/06 Doja1.5                    case 2:
                        switch ( menu2Index ) {
                            case 0:
                                index = 0;
                                break;
                            case 1:
                                index = 1;
                                break;
                            case 2:
                                index = 2;
                                break;
                            case 3:
                                index = 3;
                                break;
                        }
                        /* Transit to Panel3 of operational confirmation */
                        Display.setCurrent(new TestPanel3(index, this));
                        break;
                }
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Screen for checking class's operational(Button) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel1 extends Panel implements SoftKeyListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int index = 0;                      /* Test index */
    Label subTitle = null;              /* Sub title */
    Button testButton1;
    Button testButton2;                 /* Button */
//2002/10/02 DoJa1.5    TextBox textBox = new TextBox("", 16, 10, TextBox.DISPLAY_ANY);
    TextBox textBox = new TextBox("", 16, 20, TextBox.DISPLAY_ANY);

    /**
     * Constructor of TestPanel1 class
     * @param  index  Test index
     */
    TestPanel1(int index, Frame aFrame) {
        previousFrame = aFrame;
        index = index;

        try {
            showTestPanel();
            test(index);
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Panel for checking operations
     */
    void showTestPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        subTitle = new Label("");

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /**
     * The method of confirming operations
     * @param  index  Test index
     */
    void test(int index) {
        switch ( index ) {
//J211_0304_0101
            case 0:
                subTitle.setText("Test 1");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                add(subTitle);
                testButton1 = new Button("Text");
                add(testButton1);
                textBox.setText("The screen to smoothly scroll by the constant width");
                add(textBox);
                break;
//J211_0304_0102
            case 1:
                subTitle.setText("Test 2");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                add(subTitle);
                testButton1 = new Button("Text");
                testButton1.setSize(90,300);
                add(testButton1);
                textBox.setText("The screen to smoothly scroll by the constant width");
                add(textBox);
                break;
//J211_0304_0103
            case 2:
                subTitle.setText("Test 3");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                add(subTitle);
                testButton1 = new Button("Text");
                testButton1.setSize(90,100);
                testButton1.setEnabled(false);
                add(testButton1);
                textBox.setText("The screen to smoothly scroll by the constant width");
                add(textBox);
                break;
//J211_0304_0104
            case 3:
                subTitle.setText("Test 4");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                add(subTitle);
                testButton1 = new Button("Text");
                testButton1.setSize(90,100);
                testButton1.setVisible(false);
                add(testButton1);
                textBox.setText("The screen to smoothly scroll by the constant width");
                add(textBox);
                break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}


/**
 * Screen for checking class's operational(Button) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
//2002/08/06 Doja1.5class TestPanel2 extends Panel implements SoftKeyListener {

//2002/08/06 Doja1.5    HTMLLayout lm = null;
//2002/08/06 Doja1.5    Frame previousFrame = null;         /* Store the previous screen */
//2002/08/06 Doja1.5    int index = 0;                      /* Test index */
//2002/08/06 Doja1.5    Label subTitle = null;              /* Sub title */
//2002/08/06 Doja1.5    Button testButton1;                 /* Button */
//2002/08/06 Doja1.5    TextBox textBox = new TextBox("", 16, 10, TextBox.DISPLAY_ANY);

    /**
     * Constructor of TestPanel2 class
     * @param  index  Test index
     */
//2002/08/06 Doja1.5    TestPanel2(int index, Frame aFrame) {
//2002/08/06 Doja1.5        previousFrame = aFrame;
//2002/08/06 Doja1.5        index = index;
//2002/08/06 Doja1.5        lm = new HTMLLayout();
//2002/08/06 Doja1.5        setLayoutManager(lm);
//2002/08/06 Doja1.5        lm.begin(HTMLLayout.CENTER);

//2002/08/06 Doja1.5        try {
//2002/08/06 Doja1.5            showTestPanel();
//2002/08/06 Doja1.5            test(index);
//2002/08/06 Doja1.5        } catch(Exception e) {
//2002/08/06 Doja1.5            showMsg(e.getMessage());
//2002/08/06 Doja1.5        } catch(Error e) {
//2002/08/06 Doja1.5            showMsg(e.getMessage());
//2002/08/06 Doja1.5        }
//2002/08/06 Doja1.5        lm.end();
//2002/08/06 Doja1.5    }

    /**
     * Panel for checking operations
     */
//2002/08/06 Doja1.5    void showTestPanel() {
//2002/08/06 Doja1.5        /* Display title/sub title */
//2002/08/06 Doja1.5        setTitle("Class behavior's test");
//2002/08/06 Doja1.5        subTitle = new Label("");
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5        /* Setting of the soft key label */
//2002/08/06 Doja1.5        setSoftLabel(Frame.SOFT_KEY_1,"exit");
//2002/08/06 Doja1.5        setSoftLabel(Frame.SOFT_KEY_2,"back");
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5        /* Listener setting */
//2002/08/06 Doja1.5        setSoftKeyListener(this);
//2002/08/06 Doja1.5    }
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5    /**
//2002/08/06 Doja1.5     * The method of confirming operations
//2002/08/06 Doja1.5     * @param  index  Test index
//2002/08/06 Doja1.5     */
//2002/08/06 Doja1.5    void test(int index) {
//2002/08/06 Doja1.5        switch ( index ) {
//J211_0304_0105
//2002/08/06 Doja1.5            case 0:
//2002/08/06 Doja1.5                subTitle.setText("Test 1");
//2002/08/06 Doja1.5                subTitle.setSize(getWidth(), subTitle.getHeight());
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                testButton1 = new Button("Text");
//2002/08/06 Doja1.5                add(testButton1);
//2002/08/06 Doja1.5                textBox.setText("The screen to smoothly scroll by the constant width");
//2002/08/06 Doja1.5                add(textBox);
//2002/08/06 Doja1.5                break;
//J211_0304_0106
//2002/08/06 Doja1.5            case 1:
//2002/08/06 Doja1.5                subTitle.setText("Test 2");
//2002/08/06 Doja1.5                subTitle.setSize(getWidth(), subTitle.getHeight());
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                testButton1 = new Button("Text");
//2002/08/06 Doja1.5                testButton1.setSize(90,300);
//2002/08/06 Doja1.5                add(testButton1);
//2002/08/06 Doja1.5                textBox.setText("The screen to smoothly scroll by the constant width");
//2002/08/06 Doja1.5                add(textBox);
//2002/08/06 Doja1.5                break;
//J211_0304_0107
//2002/08/06 Doja1.5            case 2:
//2002/08/06 Doja1.5                subTitle.setText("Test 3");
//2002/08/06 Doja1.5                subTitle.setSize(getWidth(), subTitle.getHeight());
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                testButton1 = new Button("Text");
//2002/08/06 Doja1.5                testButton1.setSize(90,100);
//2002/08/06 Doja1.5                testButton1.setEnabled(false);
//2002/08/06 Doja1.5                add(testButton1);
//2002/08/06 Doja1.5                textBox.setText("The screen to smoothly scroll by the constant width");
//2002/08/06 Doja1.5                add(textBox);
//2002/08/06 Doja1.5                break;
//J211_0304_0108
//2002/08/06 Doja1.5            case 3:
//2002/08/06 Doja1.5                subTitle.setText("Test 4");
//2002/08/06 Doja1.5                subTitle.setSize(getWidth(), subTitle.getHeight());
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                testButton1 = new Button("Text");
//2002/08/06 Doja1.5                testButton1.setSize(90,100);
//2002/08/06 Doja1.5                testButton1.setVisible(false);
//2002/08/06 Doja1.5                add(testButton1);
//2002/08/06 Doja1.5                textBox.setText("The screen to smoothly scroll by the constant width");
//2002/08/06 Doja1.5                add(textBox);
//2002/08/06 Doja1.5                break;
//2002/08/06 Doja1.5        }
//2002/08/06 Doja1.5    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
//2002/08/06 Doja1.5    void showMsg(String aMsg) {
//2002/08/06 Doja1.5        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
//2002/08/06 Doja1.5        msgDialog.setText(aMsg);
//2002/08/06 Doja1.5        msgDialog.show();
//2002/08/06 Doja1.5    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
//2002/08/06 Doja1.5    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
//2002/08/06 Doja1.5    public void softKeyReleased(int aSoftKey) {
//2002/08/06 Doja1.5        if (aSoftKey == Frame.SOFT_KEY_1) {
//2002/08/06 Doja1.5            IApplication.getCurrentApp().terminate();
//2002/08/06 Doja1.5        }
//2002/08/06 Doja1.5        if (aSoftKey == Frame.SOFT_KEY_2) {
//2002/08/06 Doja1.5            Display.setCurrent(previousFrame);
//2002/08/06 Doja1.5        }
//2002/08/06 Doja1.5    }
//2002/08/06 Doja1.5}


/**
 * Screen for checking class's operational(Button) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel3 extends Panel implements SoftKeyListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int index = 0;                      /* Test index */
    Label subTitle = null;              /* Sub title */
    Button testButton1;                 /* Button */
    TextBox textBox = new TextBox("", 16, 10, TextBox.DISPLAY_ANY);

    /**
     * Constructor of TestPanel3 class
     * @param  index  Test index
     */
    TestPanel3(int index, Frame aFrame) {
        setLayoutManager(null);
        previousFrame = aFrame;
        index = index;

        try {
            showTestPanel();
            test(index);
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Panel for checking operations
     */
    void showTestPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        subTitle = new Label("");

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /**
     * The method of confirming operations
     * @param  index  Test index
     */
    void test(int index) {
        switch ( index ) {
            /* NULL layout */
//J211_0304_0201
            case 0:
                subTitle.setText("Test 1");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                subTitle.setLocation(0,10);
                add(subTitle);
                testButton1 = new Button("Text");
                testButton1.setLocation(0,25);
                add(testButton1);
                textBox.setText("The screen to scroll");
                textBox.setLocation(0,50);
                add(textBox);
                break;
//J211_0304_0202
            case 1:
                subTitle.setText("Test 2");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                subTitle.setLocation(0,10);
                add(subTitle);
                testButton1 = new Button("Text");
                testButton1.setSize(90,300);
                testButton1.setLocation(0,25);
                add(testButton1);
                textBox.setText("The screen to scroll");
                textBox.setLocation(0,330);
                add(textBox);
                break;
//J211_0304_0203
            case 2:
                subTitle.setText("Test 3");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                subTitle.setLocation(0,10);
                add(subTitle);
                testButton1 = new Button("Text");
                testButton1.setSize(90,100);
                testButton1.setLocation(0,25);
                testButton1.setEnabled(false);
                add(testButton1);
                textBox.setText("The screen to scroll");
                textBox.setLocation(0,130);
                add(textBox);
                break;
//J211_0304_0204
            case 3:
                subTitle.setText("Test 4");
                subTitle.setSize(getWidth(), subTitle.getHeight());
                subTitle.setLocation(0,10);
                add(subTitle);
                testButton1 = new Button("Text");
                testButton1.setSize(90,100);
                testButton1.setLocation(0,25);
                testButton1.setVisible(false);
                add(testButton1);
                textBox.setText("The screen to scroll");
                textBox.setLocation(0,130);
                add(textBox);
                break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}
