/**
 * J211_0305_0101.java
 * 
 * J211_0305_0101
 * MenuPanel
 * TestPanel
 * 
 * Class operational test(Button)
 * 
 * $Id: J211_0305_0101.java,v 1.1 2002/02/01 06:33:04 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class for class's operational test(Button)
 * @extends IApplication
 */
public class J211_0305_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational test(Button)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;
    ListBox menu2 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */
    boolean panelFlg = true;                 /* Flag for changing panels */

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
        "0. Layout's behavior",
        "1. Behavior of event occurrence",
    };

    String[][] menu2Item = {
        /* Menu for layout operations */
        {
            "0. With or without focus",
        },
        /* Menu for operations of event occurrence */
        {
            "0. Checking the occurrence 1",
            "1. Checking the occurrence 2",
            "2. Creation not available",
        },
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("Button3");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 2);
        menu2 = new ListBox(ListBox.CHOICE, 3);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        add(menu1);
        add(menu2);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* Set an item (menu2) when menu list (menu1) is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
            }
        }
        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();

                if (menu1Index == 1) {
                    if (menu2Index == 0) {
                        panelFlg = true;
                    } if (menu2Index == 1) {
                        panelFlg = false;
                    } if (menu2Index == 2) {
                        panelFlg = false;
                    }
                } else {
                    panelFlg = true;
                }
                 
                if (panelFlg) {
                    /* Transit to Panel1 for checking behavior */
                    Display.setCurrent(
                        new TestPanel1(menu1Index, menu2Index, this));
                } else {
                    /* Transit to Panel2 for checking behavior */
                    Display.setCurrent(
                        new TestPanel2(menu1Index, menu2Index, this));
                }
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Screen for checking class's operational(Button) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel1 extends Panel implements SoftKeyListener,ComponentListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int menu1Index = 0;
    int menu2Index = 0;                 /* Index of the menu of previous screen */
    int ButtonIndex = 0;                /* Index of button */
    Label subTitle = null;              /* Sub title */
    Button testButton1;
    Button testButton2;                 /* Button */

    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    TestPanel1(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        menu1Index = menu1Index;
        menu2Index = menu2Index;

        try {
            showTestPanel();
            test(menu1Index, menu2Index);
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Panel for checking operations
     */
    void showTestPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        subTitle = new Label("");

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * The method of confirming operations
     * @param  menu1Index  Index of menu1 of menu screen
     * @param  menu2Index  Index of menu2 of menu screen
     */
    void test(int menu1Index, int menu2Index) {

        switch ( menu1Index ) {
            /* Layout operations */
            case 0:
                switch ( menu2Index ) {
//J221_0305_0101
//J221_0305_0102
                    case 0:
                        subTitle.setText("With or without focus");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton1 = new Button("Text1");
                        testButton2 = new Button("Text2");
                        add(testButton1);
                        add(testButton2);
                        break;
                }
                break;

            /* Behavior of event occurrence */
            case 1:
                switch ( menu2Index ) {
//J221_0306_0101
//J221_0306_0104
                    case 0:
                        subTitle.setText("Checking the occurrence 1");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton1 = new Button("Text");
                        add(testButton1);
                        ButtonIndex = 1;
                        break;
                }
                break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == testButton1 ) {
            if (ButtonIndex == 1) {
                if ( aType == BUTTON_PRESSED ) {
//J211_0306_0101
//J211_0306_0104
                    showMsg("BUTTON_PRESSED:OK");
                } else {
                    showMsg("BUTTON_PRESSED:NG");
                }
            }
        }


    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}


/**
 * Screen for checking class's operational(Button) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel2 extends Panel implements SoftKeyListener,ComponentListener,
    KeyListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int menu1Index = 0;
    int menu2Index = 0;                 /* Index of the menu of previous screen */
    Label subTitle = null;              /* Sub title */
    Button testButton1;
    Button testButton2;
    Button testButton3;
    Button testButton4;                 /* Test button */

    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    TestPanel2(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        menu1Index = menu1Index;
        menu2Index = menu2Index;

        try {
            showTestPanel();
            test(menu1Index, menu2Index);
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Panel for checking operations
     */
    void showTestPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        subTitle = new Label("");
        testButton3 = new Button("execute");
        testButton4 = new Button("execute");

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
        setKeyListener(this);
    }

    /**
     * The method of confirming operations
     * @param  menu1Index  Index of menu1 of menu screen
     * @param  menu2Index  Index of menu2 of menu screen
     */
    void test(int menu1Index, int menu2Index) {

        switch ( menu1Index ) {
            /* Behavior of event occurrence */
            case 1:
                switch ( menu2Index ) {
//J221_0106_0102
                    case 1:
                        subTitle.setText(" Checking the occurrence 2");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton1 = new Button("Text");
                        add(testButton1);
                        add(testButton3);
                        break;
//J221_0106_0103
                    case 2:
                        subTitle.setText("Creation not available");
                        subTitle.setSize(getWidth(), subTitle.getHeight());
                        add(subTitle);
                        testButton2 = new Button("Text");
                        add(testButton2);
                        add(testButton4);
                        break;
                }
                break;

        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == testButton3 ) {
                    StopClass sc1 = new StopClass(1);
                    Thread t1 = new Thread(sc1);
                    t1.start();
        }

        if ( aComponent == testButton4 ) {
                    StopClass sc2 = new StopClass(2);
                    Thread t2 = new Thread(sc2);
                    t2.start();
        }

        if ( aComponent == testButton1 ) {

            if ( aType == BUTTON_PRESSED ) {
//J211_0106_0102
                showMsg("BUTTON_PRESSED:OK");
            } else {
                showMsg("BUTTON_PRESSED:NG");
            }
        }

        if ( aComponent == testButton2 && aType == BUTTON_PRESSED ) {
                showMsg("BUTTON_PRESSED:NG");
        }
    }

    /**
     * When a key is pressed display that key
     * @param aPanel  Current panel in case of a key being pressed
     * @param aKey  The value of the pressed key
     */
    public void keyPressed(Panel aPanel, int aKey) {}

    /**
     * When a key is released display that key
     * @param p  Current panel of the case when a key is released
     * @param key  The value of the released key
     */
    public void keyReleased(Panel p, int key) {
//J211_0306_0103
        showMsg("keyReleased:OK");
    }

    /**
     * Class for execution of Threads
     * @implements Runnable
     */
    class StopClass implements Runnable {
        int judgment;

        /**
         * Constructor of StopClass
         * @param aJudgment  Judgement of threads
         */
        public StopClass(int aJudgment){
            judgment = aJudgment;
        }

        /**
         * Thread execution method
         */
        public void run() {
            try {
                Thread.sleep(5000);
                if ( judgment == 1 ) {
                    testButton1.setEnabled(false);
                } else if ( judgment == 2 ) {
                    testButton2.setVisible(false);
                }
            } catch (Exception e) {
                Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
                errDialog.setText("NG:" + e.toString());
                errDialog.show();
            }
        }
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

