/**
 * J211_0401_0101.java
 * 
 * J211_0401_0101
 * MenuPanel
 * TestPanel
 * 
 * Class operational test(Canvas)
 * 
 * $Id: J211_0401_0101.java,v 1.1 2002/02/01 06:33:04 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class for class's operational (Canvas) test
 * @extends IApplication
 */
public class J211_0401_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Screen for checking class's operational(Canvas) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;
    ListBox menu2 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
        "0.Checking basic operations",
        "1.Behavior of screen display",
        "2.Checking behavior of drawing",
    };

    String[][] menu2Item = {
        /* Menu for check basic operations */
        {
            "0.Get Graphics",
            "1.Behavior of key entry",
        },
        /* Menu for behavior of screen-display, */
        {
            "0.Behavior of drawing 1",
            "1.Behavior of drawing 2",
            "2.Change over",
            "3.Soft key display 1",
            "4.Soft key display 2",
            "5.ASCII",
//2002/08/06 Doja1.5            "6.Japanese one byte kana characters",
//2002/08/06 Doja1.5            "7.Japanese two byte characters",
            "8.Pictograph",
            "9.Linefeed",
            "10.Mixed",

        },
        /* Menu for checking drawing operations, */
        {
            "0.Re-drawing",
            "1.Select drawing",
        },
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("Canvas1");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 3);
        menu2 = new ListBox(ListBox.CHOICE, 11);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        add(menu1);
        add(menu2);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* Set an item (menu2) when menu list (menu1) is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
            }
        }
        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();

                /* Transit to Panel for checking behavior */
                Display.setCurrent(new TestPanel(menu1Index, menu2Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}


/**
 * Screen for checking class's operational (Canvas) test,
 * @extends Canvas
 */
class TestPanel extends Canvas {
    Frame previousFrame;         /* Store the previous screen */
    int Index1;
    int Index2;                 /* Index of the menu of previous screen */
    int flag = 0;
    int state;
    Graphics g1;
    Graphics g2;

    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    public TestPanel(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        Index1 = menu1Index;
        Index2 = menu2Index;

        if (Index1 == 1 && Index2 == 4) {
//J211_0402_0302
//J211_0402_0304
            setSoftLabel(Canvas.SOFT_KEY_1,null);
            setSoftLabel(Canvas.SOFT_KEY_2,null);
//J211_0402_0401
        }else if (Index1 == 1 && Index2 == 5) {
            setSoftLabel(Canvas.SOFT_KEY_1,"AbCd");
            setSoftLabel(Canvas.SOFT_KEY_2,null);
//J211_0402_0402
//2002/08/06 Doja1.5        }else if (Index1 == 1 && Index2 == 6) {
//2002/08/06 Doja1.5            setSoftLabel(Canvas.SOFT_KEY_1,"Return");
//2002/08/06 Doja1.5            setSoftLabel(Canvas.SOFT_KEY_2,null);
//J211_0402_0404
        }else if (Index1 == 1 && Index2 == 6) {
//2002/08/06 Doja1.5        }else if (Index1 == 1 && Index2 == 8) {
            setSoftLabel(Canvas.SOFT_KEY_1,"\uE681\uE6F1");
            setSoftLabel(Canvas.SOFT_KEY_2,null);
//J211_0402_0405
        }else if (Index1 == 1 && Index2 == 7) {
//2002/08/06 Doja1.5        }else if (Index1 == 1 && Index2 == 9) {
            setSoftLabel(Canvas.SOFT_KEY_1,"A\nA");
//2002/08/06 Doja1.5            setSoftLabel(Canvas.SOFT_KEY_1,"A\nA");
            setSoftLabel(Canvas.SOFT_KEY_2,null);
//J211_0402_0406
        }else if (Index1 == 1 && Index2 == 8) {
//2002/08/06 Doja1.5        }else if (Index1 == 1 && Index2 == 10) {
            setSoftLabel(Canvas.SOFT_KEY_1,"ABab");
//2002/08/06 Doja1.5            setSoftLabel(Canvas.SOFT_KEY_1,"AaA");
            setSoftLabel(Canvas.SOFT_KEY_2,"\uE681\nAb");
//2002/08/06 Doja1.5            setSoftLabel(Canvas.SOFT_KEY_2,"\uE681\nA");
        } else {
//J211_0402_0301
//J211_0402_0303
//J211_0402_0403
            setSoftLabel(Canvas.SOFT_KEY_1,"back");
            setSoftLabel(Canvas.SOFT_KEY_2,"execute");
        }
    }

    public void processEvent(int type,int param){
        /* Key event, */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* Process of when Return key is pressed, */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previousFrame);
                    break;
        
                /* Process of when enter key is pressed, */
                case Display.KEY_SOFT2:
                    test();
                    break;
            }
        } else if (type == Display.KEY_PRESSED_EVENT) {
//J211_0401_0201
//J211_0401_0202
            if (Display.KEY_0 <= param && param <= Display.KEY_9 && 
                Index1 ==0 ) {
                state = getKeypadState();
                flag = 3;
                repaint();
            }
        }
    }

    /**
     * Implement of test() method,
     */
    public void test(){
        TestPanel2 tp2 = new TestPanel2(Index1,Index2,this);
        switch ( Index1 ) {
            case 0:
                switch ( Index2 ) {
//J211_0401_0101
                    case 0:
                        g1 = getGraphics();
                        g2 = getGraphics();
                        if (g1 == g2) {
                             flag = 1;
                        } else {
                             flag = 2;
                        }
                        repaint();
                        break;
                }
                break;
            case 1:
                switch ( Index2 ) {
//J211_0402_0102
                    case 1:
                        tp2.test();
                        break;
//J211_0402_0201
                    case 2:
                        /* Transit to TestPanel2, */
                        Display.setCurrent(tp2);
                        break;
                }
                break;
            case 2:
                switch ( Index2 ) {
//J211_0403_0101
                    case 0:
                       flag = 1;
                       repaint();
                       break;
//J211_0403_0201
//J211_0403_0202
                    case 1:
                       g1 = getGraphics();
                       g1.drawString("OK",20,80);
                       tp2.g3.drawString("NG",20,100);
                       break;
                }
                break;
        }
    }

    /**
     * Implement of paint() method,
     */
    public void paint(Graphics g){

        switch ( Index1 ) {
            /* Check basic operations */
            case 0:
                switch ( Index2 ) {
                    case 0:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Get Graphics",10,20);
                        if (flag == 0) {
                            g.drawString("Press the execute button",20,40);
                            g.drawString("Please do",20,60);
                        } else if (flag == 1) {
                            g.drawString("NG",20,40);
                        } else if (flag == 2) {
                            g.drawString("OK",20,40);
                        }
                        break;

                    case 1:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Behavior of key entry",10,20);
                        if (flag == 0) {
                            g.drawString("Press numeric key",20,40);
                            g.drawString("Please do",20,60);
                        } else if (flag == 3) {
                            g.drawString(Integer.toString(state),20,40);
                        }
                        break;
                }
                break;

            /* Operations of screen display */
            case 1:
                switch ( Index2 ) {
//J211_0402_0101
                    case 0:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Behavior of drawing 1",10,20);
                        g.drawString("OK",20,40);
                        break;

                    case 1:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Behavior of drawing 2",10,20);
                        g.drawString("Press the execute button",20,40);
                        g.drawString("however the screen is",20,60);
                        g.drawString("No change.",20,80);
                        break;

                    case 2:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Change over",10,20);
                        g.drawString("Press the execute button",20,40);
                        g.drawString("Please do",20,60);
                        break;

                    case 3:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Soft key display 1",10,20);
                        g.drawString("Soft key displays",20,40);
                        g.drawString("To do.",20,60);
                        break;

                    case 4:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Soft key display 2",10,20);
                        g.drawString("Soft key displays",20,40);
                        g.drawString("Not to do.",20,60);
                        break;

                    case 5:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("ASCII",10,20);
                        g.drawString("AbCd by the soft key",20,40);
                        g.drawString("Display.",20,60);
                        break;

//2002/08/06 Doja1.5                    case 6:
//2002/08/06 Doja1.5                        g.clearRect(0, 0, getWidth(), getHeight());
//2002/08/06 Doja1.5                        g.drawString("Japanese one byte kana characters",10,20);
//2002/08/06 Doja1.5                        g.drawString("Return by the soft key",20,40);
//2002/08/06 Doja1.5                        g.drawString("Display.",20,60);
//2002/08/06 Doja1.5                        break;

//2002/08/06 Doja1.5                    case 7:
//2002/08/06 Doja1.5                        g.clearRect(0, 0, getWidth(), getHeight());
//2002/08/06 Doja1.5                        g.drawString("Double byte characters",10,20);
//2002/08/06 Doja1.5                        g.drawString("Return by the soft key",20,40);
//2002/08/06 Doja1.5                        g.drawString("Display.",20,60);
//2002/08/06 Doja1.5                        break;

                    case 6:
//2002/08/06 Doja1.5                    case 8:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Pictograph",10,20);
                        g.drawString("Soft key is pictograph",20,40);
                        g.drawString("Display.",20,60);
                        break;

                    case 7:
//2002/08/06 Doja1.5                    case 9:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Linefeed",10,20);
                        g.drawString("A A by the soft key",20,40);
//2002/08/06 Doja1.5                        g.drawString("Soft key is A ",20,40);
                        g.drawString("Display.",20,60);
                        break;

                    case 8:
//2002/08/06 Doja1.5                    case 10:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Mixed",10,20);
                        g.drawString("Soft key is in mixed characters",20,40);
                        g.drawString("Display.",20,60);
                        break;
                }
                break;

            /* Confirmation of depiction operations */
            case 2:
                switch ( Index2 ) {
                    case 0:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Re-drawing",10,20);
                        if (flag == 0) {
                            g.drawString("Press the execute button",20,40);
                            g.drawString("Please do",20,60);
                        } else if (flag == 1) {
                            g.drawString("Re-drawing OK",20,40);
                        }
                        break;
                    case 1:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Select drawing",10,20);
                        g.drawString("Press the execute button",20,40);
                        g.drawString("Please do",20,60);
                        break;
                }
                break;
            default:
                break;
        }
    }
}




/**
 * Screen for checking class's operational (Canvas) test,
 * @extends Canvas
 */
class TestPanel2 extends Canvas {
    Frame previousFrame;         /* Store the previous screen */
    int Index1;
    int Index2;                 /* Index of the menu of previous screen */
    Graphics g3;

    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    public TestPanel2(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        Index1 = menu1Index;
        Index2 = menu2Index;
        g3 = getGraphics();
        setSoftLabel(Canvas.SOFT_KEY_1,"back");
        setSoftLabel(Canvas.SOFT_KEY_2,"execute");
    }

    public void processEvent(int type,int param){
        /* Key event, */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* Process of when Return key is pressed, */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previousFrame);
                    break;
        
                /* Process of when enter key is pressed, */
                case Display.KEY_SOFT2:
                    break;
            }
        } else if (type == Display.KEY_PRESSED_EVENT) {}
    }

    /**
     * Implement of test() method,
     */
    public void test(){
        if (Index1 == 1 && Index2 == 1) {
//J211_0402_0102
            g3.clearRect(0, 0, getWidth(), getHeight());
            g3.drawString("Another Canvas",10,20);
            g3.drawString("NG",20,40);
        } else {}
    }

    /**
     * Implement of paint() method,
     */
    public void paint(Graphics g){
        if (Index1 == 1 && Index2 == 2) {
//J211_0402_0201
            g.clearRect(0, 0, getWidth(), getHeight());
            g.drawString("Another Canvas",10,20);
            g.drawString("OK",20,40);
        } else {}
    }
}