/**
 * J211_0404_0101.java
 * 
 * J211_0404_0101
 * MenuPanel
 * TestPanel
 * 
 * Class operational test(Canvas)
 * 
 * $Id: J211_0404_0101.java,v 1.1 2002/02/01 06:33:05 hoshi Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;
import com.nttdocomo.io.*;

/**
 * Main class for class's operational (Canvas) test
 * @extends IApplication
 */
public class J211_0404_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Screen for checking class's operational(Canvas) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;
    ListBox menu2 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
        "0. Notification of the event",
        "1. Behavior of key event",
        "2. Clipping behavior",
    };

    String[][] menu2Item = {
        /* Event notification menu */
        {
            "0.KEY_PRESSED",
            "1.KEY_RELEASED",
            "2.STOP_VM",
            "3.SUSPEND_VM",
            "4.RESUME_VM",
            "6.UPDATE_VM2",
            "7.UPDATE_VM3",
            "8.TIMER_EXPIRED1",
            "9.TIMER_EXPIRED2",
        },
        /* Key event operations menu */
        {
            "0.Test 1",
        },
        /* Clipping operations menu */
        {
            "0.Test 1",
        },
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("Canvas2");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 3);
        menu2 = new ListBox(ListBox.CHOICE, 14);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        menu2.setItems(menu2Item[0]);
        add(menu1);
        add(menu2);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* Set an item (menu2) when menu list (menu1) is selected */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menu1 ) {
                menu2.setItems(menu2Item[menu1.getSelectedIndex()]);
            }
        }
        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                int menu2Index = menu2.getSelectedIndex();

                /* Transit to Panel for checking behavior */
                Display.setCurrent(new TestPanel(menu1Index, menu2Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}


/**
 * Screen for checking class's operational (Canvas) test,
 * @extends Canvas
 */
class TestPanel extends Canvas {
    Frame previousFrame;         /* Store the previous screen */
    int Index1;
    int Index2;                 /* Index of the menu of previous screen */
    int flg = 0;
    int state;
    private Graphics gg = getGraphics();
    TestPanel2 tp2 = new TestPanel2(Index1,Index2,this);
    ShortTimer st1 = null;
    Timer timer;
    int[] a = new int[10];
    byte[] b = new byte[10];
    int k;
    int i;
    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }
    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    public TestPanel(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        Index1 = menu1Index;
        Index2 = menu2Index;
        setSoftLabel(Canvas.SOFT_KEY_1,"back");
        setSoftLabel(Canvas.SOFT_KEY_2,"execute");
    }

    public void processEvent(int type,int param){
        Graphics g2 = getGraphics();
        /* Key event, */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* Process of when Return key is pressed, */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previousFrame);
                    break;
        
                /* Process of when enter key is pressed, */
                case Display.KEY_SOFT2:
                    test();
                    break;
                case Display.KEY_SELECT:
//J211_0404_0104
//J211_0404_0105
//J211_0404_0106
                    if (Index1 == 0 && Index2 == 1) {
                        flg = 1;
                        repaint();
                    }
//J211_0404_0201
                    if (Index1 == 1 && Index2 == 0) {
                        if (flg == 1) {
                            repaint();
                        }
                    }
            }
        } else if (type == Display.KEY_PRESSED_EVENT) {
            if (param == Display.KEY_SELECT) {
//J211_0404_0101
//J211_0404_0102
//J211_0404_0103
                if (Index1 == 0 && Index2 == 0) {
                    flg = 1;
                    repaint();
                }
//J211_0404_0201
                if (Index1 == 1 && Index2 == 0) {
                    flg = 1;
                }
            }
//J211_0404_0107
        } else if (type == 2) {
            if (Index1 == 0 && Index2 == 2) {
                DataOutputStream dos = null;
                try {
                    dos = Connector.openDataOutputStream("scratchpad:///0");
                    byte a = (byte) '1';
                    for ( i = 0; i < 10; i++) {
                       dos.write(a);
                    }
                } catch (IOException e) {
                } finally {
                    try {
                        if (dos != null) dos.close();
                    } catch (IOException ie) {}
                }
            }
//J211_0404_0108
        } else if (type == 3) {
            if (Index1 == 0 && Index2 == 3) {
                flg = 1;
                repaint();
            }
        } else if (type == Display.RESUME_VM_EVENT) {
            g2.drawString("RESUME_EVENT!!", 20, 60);

//J211_0404_0109
//J211_0404_0110
            if (Index1 == 0 && Index2 == 4) {
                flg = 1;
//                repaint();
            }
//J211_0404_0114
            if (Index1 == 0 && Index2 == 6) {
                flg = 5;
            }
        } else if (type == Display.UPDATE_VM_EVENT) {
                g2.drawString("UPDATE EVENT", 20, 80);

//J211_0404_0112
//J211_0404_0113
            if (Index1 == 0 && Index2 == 5) {
                flg = 1;
            } 
            if (flg == 5) {
                flg = 3;
                repaint();
            }

        } else if (type == Display.TIMER_EXPIRED_EVENT) {
//J211_0404_0115
//J211_0404_0116
            if (param == 1) {
                flg = 1;
                repaint();
            }
//J211_0404_0117
            if (Index1 == 0 && Index2 == 8) {
                flg = 1;
                repaint();
            }
        } 


    }

    /**
     * Implement of test() method,
     */
    public void test(){
        switch ( Index1 ) {
            case 0:
                switch ( Index2 ) {
                    case 2:
                        InputStream is = null;
                        try {
                            is = Connector.openInputStream("scratchpad:///0");
                            for (i = 0; i < 10; i++) {
                                a[i] = is.read();
                                b[i] = (byte) a[i];

                                if (a[i] == -1) {
                                    break;
                                }
                            }

                            for ( k = 0; k < 10; k++) {
                                if (b[k] != 0) {
                                    break;
                                }
                            }
                            if (k != 10) {
                                flg = 2;
                            } else {
                                flg = 1;
                            }
                        } catch (IOException ioe) {
                            flg = 2;
                        } catch (Exception e) {
                            flg = 2;
                        } finally {
                            try {
                                if (is != null) is.close();
                            } catch (IOException ie) {
                                flg = 2;
                            }
                        }
                        repaint();
                        break;
//J211_0404_0115
//J211_0404_0116
                    case 7:
                        st1 = ShortTimer.getShortTimer(this,1,1000,false);
                        st1.start();
                        break;
//J211_0404_0117
                    case 8:
                        timer = new Timer();
                        timer.setTime(1000);
                        timer.setRepeat(false);
                        timer.start();
                        break;
                }
                break;
            case 1:
                break;
            case 2:
//J211_0404_0301
                switch ( Index2 ) {
                    case 0:
                       RepaintThread rt = new RepaintThread(this);
                       rt.start();
                       break;
                }
                break;
        }
    }

    /**
     * Implement of paint() method,
     */
    public void paint(Graphics g){

        switch ( Index1 ) {
            /* Event notification */
            case 0:
                switch ( Index2 ) {
                    case 0:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("KEY_PRESSED",10,20);
                        if (flg == 0) {
                            g.drawString("Press Enter key",20,40);
                            g.drawString("Please do",20,60);
                        } else if (flg == 1) {
                            g.drawString("OK",20,40);
                        }
                        break;

                    case 1:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("KEY_RELEASED",10,20);
                        if (flg == 0) {
                            g.drawString("Press Enter key",20,40);
                            g.drawString("Please do",20,60);
                        } else if(flg == 1 ) {
                            g.drawString("OK",20,40);
                        } else {
                            g.drawString("NG",20,40);
                        }
                        break;
                    case 2:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("STOP_VM",10,20);
                        if (flg == 0) {
                            g.drawString("After forcedly termination",20,40);
                            g.drawString("Reboot and execute button",20,60);
                            g.drawString("To be pressed.",20,80);
                        } else if(flg == 1 ) {
                            g.drawString("OK",20,40);
                        } else if(flg == 2 ) {
                            g.drawString("NG",20,40);
                        } else {
                            g.drawString("NG",20,40);
                        }
                        break;
                    case 3:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("SUSPEND_VM",10,20);
                        if (flg == 0) {
                            g.drawString("Interrupt the received call",20,40);
                            g.drawString("Please do",20,60);
                        } else if(flg == 1 ) {
                            g.drawString("NG:SUSPEND",20,40);
                        } else {
                            g.drawString("NG",20,40);
                        }
                        break;
                    case 4:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("RESUME_VM1",10,20);
                        if (flg == 0) {
                            g.drawString("Interrupt the received call",20,40);
                            g.drawString("Please do",20,60);
                        } else if(flg == 1 ) {
                            g.drawString("OK:RESUME",20,40);
                        } else {
                            g.drawString("NG",20,40);
                        }
                        break;
                    case 5:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("UPDATE_VM2",10,20);
                        if (flg == 1) {
                            g.drawString("OK:UPDATE",20,40);
                        } else {
                            g.drawString("NG",20,40);
			}
                        break;
                    case 6:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("UPDATE_VM3",10,20);
                        if (flg == 0) {
                            g.drawString("Interrupt the received call",20,40);
                            g.drawString("Please do",20,60);
                        } else if(flg == 5 ) {
                            g.drawString("OK",20,40);
                        } else {
                            g.drawString("NG",20,40);
                        }
                        break;
                    case 7:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("TIMER_EXPIRED1",10,20);
                        if (flg == 0) {
                            g.drawString("Press the execute button",20,40);
                            g.drawString("Please do",20,60);
                        } else if(flg == 1 ) {
                            g.drawString("OK:TIMER_EXPIRED",20,40);
                        } else {
                            g.drawString("NG",20,40);
                        }
                        break;
                    case 8:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("TIMER_EXPIRED2",10,20);
                        if (flg == 0) {
                            g.drawString("Press the execute button",20,40);
                            g.drawString("Please do",20,60);
                        } else if(flg == 1 ) {
                            g.drawString("NG",20,40);
                        } else {
                            g.drawString("NG",20,40);
                        }
                        break;
                }
                break;

            /* Key event operations */
            case 1:
                switch ( Index2 ) {
                    case 0:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Test 1",10,20);
                        if (flg == 0) {
                            g.drawString("Press Enter key",20,40);
                            g.drawString("Please do",20,60);
                        } else if (flg == 1) {
                            g.drawString("OK",20,40);
                        }
                        break;
                }
                break;

            /* Clipping operations */
            case 2:
                switch ( Index2 ) {
                    case 0:
                        g.clearRect(0, 0, getWidth(), getHeight());
                        g.drawString("Test 1",10,20);
                        g.drawString("Press the execute button",20,40);
                        g.drawString("Please do",20,60);
                        Graphics g2 = g.copy();
                        Graphics g3 = getGraphics();
                        Graphics g4 = g3.copy();
                        g.fillRect(10,80,10,30);
                        g2.fillRect(30,80,10,30);
                        g3.fillRect(50,80,10,30);
                        g4.fillRect(70,80,10,30);
                        break;
                }
                break;
            default:
                break;
        }
    }
}

/**
 * Screen for checking class's operational (Canvas) test,
 * @extends Canvas
 */
class TestPanel2 extends Canvas {
    Frame previousFrame;         /* Store the previous screen */
    int Index1;
    int Index2;                 /* Index of the menu of previous screen */

    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  menu2Index  Index of menu2
     */
    public TestPanel2(int menu1Index, int menu2Index, Frame aFrame) {
        previousFrame = aFrame;
        Index1 = menu1Index;
        Index2 = menu2Index;
        setSoftLabel(Canvas.SOFT_KEY_1,"back");
    }

    public void processEvent(int type,int param){

        /* Key event, */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* Process of when Return key is pressed, */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previousFrame);
                    break;

                case Display.KEY_SELECT:
                    if (Index1 == 0 && Index2 == 1) {
                        Display.setCurrent(new TestPanel3(1,this));
                    }
                    break;
            }
            
        } else if (type == Display.KEY_PRESSED_EVENT) {
            switch(param){
                case Display.KEY_SELECT:
                    if (Index1 == 0 && Index2 == 0) {
                        Display.setCurrent(new TestPanel3(1,this));
                    }
                    break;
            }
        } else if (type == 3) {
            if (Index1 == 0 && Index2 == 3) {
                Display.setCurrent(new TestPanel3(2,this));
            }
        } else if (type == Display.RESUME_VM_EVENT) {
            if (Index1 == 0 && Index2 == 4) {
                Display.setCurrent(new TestPanel3(2,this));
            }
        }
    }

    /**
     * Implement of paint() method,
     */
    public void paint(Graphics g){
            g.clearRect(0, 0, getWidth(), getHeight());
            g.drawString("Another Canvas",10,20);
            g.drawString("OK",10,40);
    }
}


/**
 * Screen for checking class's operational (Canvas) test,
 * @extends Canvas
 */
class TestPanel3 extends Canvas {
    Frame previousFrame;         /* Store the previous screen */
    int Index1;

    /**
     * Constructor of TestPanel class
     */
    public TestPanel3(int Index,Frame aFrame) {
        previousFrame = aFrame;
        Index1 = Index;
        setSoftLabel(Canvas.SOFT_KEY_1,"back");
    }

    public void processEvent(int type,int param){
        /* Key event, */
        if(type == Display.KEY_RELEASED_EVENT){
            switch(param){
                /* Process of when Return key is pressed, */
                case Display.KEY_SOFT1:
                    Display.setCurrent(previousFrame);
                    break;
            }
        }
    }

    /**
     * Implement of paint() method,
     */
    public void paint(Graphics g){
            if (Index1 == 1) {
                g.clearRect(0, 0, getWidth(), getHeight());
                g.drawString("Another Canvas",10,20);
                g.drawString("OK",10,40);
            } else if (Index1 == 2 ) {
                g.clearRect(0, 0, getWidth(), getHeight());
                g.drawString("Another Canvas",10,20);
                g.drawString("NG",10,40);
            }
    }
}

/**
 * Class for execution of Threads
 * @extends Thread
 */
class RepaintThread extends Thread {
    TestPanel tp;

    /**
     * Constructor of StopClass
     * @param testpanel 
     */
    public RepaintThread(TestPanel testpanel){
        tp = testpanel;
    }

    /**
     * Thread execution method
     */
    public void run() {
        try {
            Graphics g5 = tp.getGraphics();
            g5.clearRect(0,0,tp.getWidth(), tp.getHeight());
            tp.repaint(0,0,tp.getWidth(),95);
        }catch (Exception e) {

        }
    }
}