/**
 * J211_0701_0101.java
 * 
 * J211_0701_0101
 * MenuPanel
 * TestPanel1
 * TestPanel2
 * TestPanel3
 * 
 * Class's operational test (FocusManager)
 * 
 * $Id: J211_0701_0101.java,v 1.1 2002/02/01 06:33:07 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class of class's operational test (FocusManager)
 * @extends IApplication
 */
public class J211_0701_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational (FocusManager) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */
    int index = 0;

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
        "0. Check movement of the focus",
        "1. Default layout",
//2002/08/06 Doja1.5        "2. HTML layout",
        "3. NULL layout",
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("FocusManager1");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 4);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        add(menu1);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();

                switch ( menu1Index ) {
                    case 0:
                        index = 0;
                        /* Transit to Panel for checking behavior */
                        Display.setCurrent(new TestPanel1(index, this));
                        break;
                    case 1:
                        index = 1;
                        /* Transit to Panel for checking behavior */
                        Display.setCurrent(new TestPanel1(index, this));
                        break;
//2002/08/06 Doja1.5                    case 2:
//2002/08/06 Doja1.5                        index = 2;
//2002/08/06 Doja1.5                        /* Transit to Panel for checking behavior */
//2002/08/06 Doja1.5                        Display.setCurrent(new TestPanel2(index, this));
//2002/08/06 Doja1.5                        break;
                    case 2:
//2002/08/06 Doja1.5                    case 3:
                        index = 3;
                        /* Transit to Panel for checking behavior */
                        Display.setCurrent(new TestPanel3(index, this));
                        break;
                }
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Confirmation screen for class's operational (FocusManager)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel1 extends Panel implements SoftKeyListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int index = 0;                      /* Test index */
    Label subTitle = null;              /* Sub title */
    Button testButton1;
    Button testButton2;
    TextBox textBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);

    /**
     * Constructor of TestPanel1 class
     * @param  index  Test index
     */
    TestPanel1(int index, Frame aFrame) {
        previousFrame = aFrame;
        index = index;

        try {
            /* Display title/sub title */
            setTitle("Class behavior's test");
                subTitle = new Label("");
            if (index == 0) {
                subTitle.setText("Check movement of the focus");
            } if (index == 1) {
                subTitle.setText("Default layout");
            }
            subTitle.setSize(getWidth(), subTitle.getHeight());

            /* Setting of the soft key label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            /* Listener setting */
            setSoftKeyListener(this);

//J211_0701_0101
//J211_0701_0102
//J211_0701_0201
            testButton1 = new Button("Button 1");
            testButton2 = new Button("Button 2");
            textBox.setText("Text 3");
            add(subTitle);
            add(testButton1);
            add(testButton2);
            add(textBox);

        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Confirmation screen for class's operational (FocusManager)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
//2002/08/06 Doja1.5class TestPanel2 extends Panel implements SoftKeyListener {
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5    HTMLLayout lm = null;
//2002/08/06 Doja1.5    Frame previousFrame = null;         /* Store the previous screen */
//2002/08/06 Doja1.5    int index = 0;                      /* Test index */
//2002/08/06 Doja1.5    Label subTitle = null;              /* Sub title */
//2002/08/06 Doja1.5    Button testButton1;
//2002/08/06 Doja1.5    Button testButton2;
//2002/08/06 Doja1.5    TextBox textBox = new TextBox("", 16, 10, TextBox.DISPLAY_ANY);
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5    /**
//2002/08/06 Doja1.5     * Constructor of TestPanel2 class
//2002/08/06 Doja1.5     * @param  index  Test index
//2002/08/06 Doja1.5     */
//2002/08/06 Doja1.5    TestPanel2(int index, Frame aFrame) {
//2002/08/06 Doja1.5        previousFrame = aFrame;
//2002/08/06 Doja1.5        index = index;
//2002/08/06 Doja1.5        lm = new HTMLLayout();
//2002/08/06 Doja1.5        setLayoutManager(lm);
//2002/08/06 Doja1.5        lm.begin(HTMLLayout.CENTER);
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5        try {
//2002/08/06 Doja1.5            /* Display title/sub title */
//2002/08/06 Doja1.5            setTitle("Class behavior's test");
//2002/08/06 Doja1.5            subTitle = new Label("HTML layout");
//2002/08/06 Doja1.5            subTitle.setSize(getWidth(), subTitle.getHeight());
//2002/08/06 Doja1.5            /* Setting of the soft key label */
//2002/08/06 Doja1.5            setSoftLabel(Frame.SOFT_KEY_1,"exit");
//2002/08/06 Doja1.5            setSoftLabel(Frame.SOFT_KEY_2,"back");
//2002/08/06 Doja1.5            /* Listener setting */
//2002/08/06 Doja1.5            setSoftKeyListener(this);
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5//J211_0701_0202
//2002/08/06 Doja1.5            testButton1 = new Button("Button 1");
//2002/08/06 Doja1.5            testButton2 = new Button("Button 2");
//2002/08/06 Doja1.5            textBox.setText("Text 3");
//2002/08/06 Doja1.5            add(testButton1);
//2002/08/06 Doja1.5            add(testButton2);
//2002/08/06 Doja1.5            add(textBox);
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5        } catch(Exception e) {
//2002/08/06 Doja1.5            showMsg(e.getMessage());
//2002/08/06 Doja1.5        } catch(Error e) {
//2002/08/06 Doja1.5            showMsg(e.getMessage());
//2002/08/06 Doja1.5        }
//2002/08/06 Doja1.5        lm.end();
//2002/08/06 Doja1.5    }
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5    /**
//2002/08/06 Doja1.5     * Display a message dialog
//2002/08/06 Doja1.5     * @param  aMsg  Dialog message
//2002/08/06 Doja1.5     */
//2002/08/06 Doja1.5    void showMsg(String aMsg) {
//2002/08/06 Doja1.5        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
//2002/08/06 Doja1.5        msgDialog.setText(aMsg);
//2002/08/06 Doja1.5        msgDialog.show();
//2002/08/06 Doja1.5    }
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5    /**
//2002/08/06 Doja1.5     * No action to be made once soft key is pressed
//2002/08/06 Doja1.5     * @param aSoftKey  Type of soft key
//2002/08/06 Doja1.5     */
//2002/08/06 Doja1.5    public void softKeyPressed(int aSoftKey) {}
//2002/08/06 Doja1.5
//2002/08/06 Doja1.5    /**
//2002/08/06 Doja1.5     * Terminate the application if soft key1 is released
//2002/08/06 Doja1.5     * Transit to the whole screen in the event of soft key2
//2002/08/06 Doja1.5     * @param aSoftKey  Type of soft key
//2002/08/06 Doja1.5     */
//2002/08/06 Doja1.5    public void softKeyReleased(int aSoftKey) {
//2002/08/06 Doja1.5        if (aSoftKey == Frame.SOFT_KEY_1) {
//2002/08/06 Doja1.5            IApplication.getCurrentApp().terminate();
//2002/08/06 Doja1.5        }
//2002/08/06 Doja1.5        if (aSoftKey == Frame.SOFT_KEY_2) {
//2002/08/06 Doja1.5            Display.setCurrent(previousFrame);
//2002/08/06 Doja1.5        }
//2002/08/06 Doja1.5    }
//2002/08/06 Doja1.5}


/**
 * Confirmation screen for class's operational (FocusManager)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel3 extends Panel implements SoftKeyListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int index = 0;                      /* Test index */
    Label subTitle = null;              /* Sub title */
    Button testButton1;
    Button testButton2;
    TextBox textBox = new TextBox("", 16, 10, TextBox.DISPLAY_ANY);

    /**
     * Constructor of TestPanel3 class
     * @param  index  Test index
     */
    TestPanel3(int index, Frame aFrame) {
        setLayoutManager(null);
        previousFrame = aFrame;
        index = index;

        try {
            setTitle("Class behavior's test");
            subTitle = new Label("NULL layout");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");
            setSoftKeyListener(this);

//J211_0701_0203
            testButton1 = new Button("Button 1");
            testButton1.setLocation(0,0);
            testButton2 = new Button("Button 2");
            testButton2.setLocation(0,20);
            textBox.setText("Text 3");
            textBox.setLocation(0,40);
            add(testButton1);
            add(testButton2);
            add(textBox);

        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}
