
/**
 * J211_0702_0101.java
 * 
 * J211_0702_0101
 * MenuPanel
 * TestPanel
 * 
 * Class's operational test (FocusManager)
 * 
 * $Id: J211_0702_0101.java,v 1.1 2002/02/01 06:33:07 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class of class's operational test (FocusManager)
 * @extends IApplication
 */
public class J211_0702_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational (FocusManager) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */
    int index = 0;

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
//2002/08/06 Doja1.5        "0. Test 1",
        "1.Test 2",
//2002/08/06 Doja1.5        "2.Test 3",
        "3.Test 4",
        "4.Test 5",
//2002/08/06 Doja1.5        "5.Test 6",
        "6.Test 7",
//2002/08/06 Doja1.5        "7.Test 8",
        "8.Test 9",
        "9.Test 10",
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("FocusManager3");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 4);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        add(menu1);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                Display.setCurrent(new TestPanel(menu1Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Confirmation screen for class's operational (FocusManager)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel extends Panel implements SoftKeyListener, ComponentListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int buttonIndex;                          /* Test index */
    Label subTitle = null;              /* Sub title */
    MediaImage mi;                      /* Media image */
    Image img;                          /* Image */
    String fileName;                    /* File name */
    Button button;                      /* Button */
    TextBox textBox;                    /* Text box */
//2002/08/06 Doja1.5    AnchorButton anchorButton;          /* Anchor Button */
//2002/08/06 Doja1.5    ImageButton imageButton;            /* Image button */
    ListBox listBox;                    /* List box */

    String[] listBoxItem = {
        "aaa",
        "bbb",
        "ccc",
    };

    /**
     * Constructor of TestPanel class
     * @param  index  Test index
     */
    TestPanel(int index, Frame aFrame) {
        previousFrame = aFrame;
        buttonIndex = index;

        try {
            /* Display title/sub title */
            setTitle("Class behavior's test");
            subTitle = new Label("");
            subTitle.setText("Change in state of the focus");
            subTitle.setSize(getWidth(), subTitle.getHeight());

            /* Setting of the soft key label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);

            button = new Button("Button");
            fileName = new String("java1.gif");
//2002/08/06 Doja1.5            anchorButton = new AnchorButton(changeImage(fileName),"Text");
            textBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);
            listBox = new ListBox(ListBox.CHOICE,3);
            listBox.setItems(listBoxItem);
//2002/08/06 Doja1.5            imageButton = new ImageButton(changeImage(fileName));

//2002/08/06 Doja1.5            if (buttonIndex == 0) {
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                add(anchorButton);
//2002/08/06 Doja1.5                add(button);
//2002/08/06 Doja1.5                add(textBox);
            if (buttonIndex == 0) {
//2002/08/06 Doja1.5            } if (buttonIndex == 1) {
                add(subTitle);
                add(button);
                add(textBox);
//2002/08/06 Doja1.5            } if (buttonIndex == 2) {
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                add(imageButton);
//2002/08/06 Doja1.5                add(button);
//2002/08/06 Doja1.5                add(textBox);
            } if (buttonIndex == 1) {
//2002/08/06 Doja1.5            } if (buttonIndex == 3) {
                add(subTitle);
                add(textBox);
                add(button);
                add(listBox);
            } if (buttonIndex == 2) {
//2002/08/06 Doja1.5            } if (buttonIndex == 4) {
                add(subTitle);
                add(listBox);
                add(button);
                add(textBox);
//2002/08/06 Doja1.5            } if (buttonIndex == 5) {
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                add(anchorButton);
//2002/08/06 Doja1.5                add(button);
//2002/08/06 Doja1.5                add(textBox);
            } if (buttonIndex == 3) {
//2002/08/06 Doja1.5            } if (buttonIndex == 6) {
                add(subTitle);
                add(button);
                add(textBox);
//2002/08/06 Doja1.5            } if (buttonIndex == 7) {
//2002/08/06 Doja1.5                add(subTitle);
//2002/08/06 Doja1.5                add(imageButton);
//2002/08/06 Doja1.5                add(button);
//2002/08/06 Doja1.5                add(textBox);
            } if (buttonIndex == 4) {
//2002/08/06 Doja1.5            } if (buttonIndex == 8) {
                add(subTitle);
                add(textBox);
                add(button);
                add(listBox);
            } if (buttonIndex == 5) {
//2002/08/06 Doja1.5            } if (buttonIndex == 9) {
                add(subTitle);
                add(listBox);
                add(button);
                add(textBox);
            }
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
             StopClass sc1 = new StopClass(buttonIndex);
             Thread t1 = new Thread(sc1);
             t1.start();
        }
    }


    /**
     *Convert image into Image type 
     */
    public Image changeImage(String fileName){
        mi = MediaManager.getImage("resource:///" + fileName);

        try {
            mi.use();
        } catch (Exception e) {
            Dialog d = new Dialog(Dialog.DIALOG_INFO, "App");
            d.setText(e.toString());
            d.show();
        }
        img = mi.getImage();
        return img;
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * Class for execution of Threads
     * @implements Runnable
     */
    class StopClass implements Runnable {
        int judgment;

        /**
         * Constructor of StopClass
         * @param aJudgment  Judgement of threads
         */
        public StopClass(int buttonIndex){
            judgment = buttonIndex;
        }

        /**
         * Thread execution method
         */
        public void run() {
            try {
                Thread.sleep(5000);
//J211_0702_0101
//J211_0702_0301
//2002/08/06 Doja1.5                if ( judgment == 0 ) {
//2002/08/06 Doja1.5                    anchorButton.setVisible(false);
//J211_0702_0102
//J211_0702_0302
                if ( judgment == 0 ) {
//2002/08/06 Doja1.5                } if ( judgment == 1 ) {
                    button.setVisible(false);
//J211_0702_0103
//J211_0702_0303
//2002/08/06 Doja1.5                } if ( judgment == 2 ) {
//2002/08/06 Doja1.5                    imageButton.setVisible(false);
//J211_0702_0104
//J211_0702_0304
                } if ( judgment == 1 ) {
//2002/08/06 Doja1.5                } if ( judgment == 3 ) {
                    textBox.setVisible(false);
//J211_0702_0105
//J211_0702_0305
                } if ( judgment == 2 ) {
//2002/08/06 Doja1.5                } if ( judgment == 4 ) {
                    listBox.setVisible(false);
//J211_0702_0201
//2002/08/06 Doja1.5                } if ( judgment == 5 ) {
//2002/08/06 Doja1.5                    anchorButton.setEnabled(false);
//J211_0702_0202
                } if ( judgment == 3 ) {
//2002/08/06 Doja1.5                } if ( judgment == 6 ) {
                    button.setEnabled(false);
//J211_0702_0203
//2002/08/06 Doja1.5                } if ( judgment == 7 ) {
//2002/08/06 Doja1.5                    imageButton.setEnabled(false);
//J211_0702_0204
                } if ( judgment == 4 ) {
//2002/08/06 Doja1.5                } if ( judgment == 8 ) {
                    textBox.setEnabled(false);
//J211_0702_0205
                } if ( judgment == 5 ) {
//2002/08/06 Doja1.5                } if ( judgment == 9 ) {
                    listBox.setEnabled(false);
                }
            } catch (Exception e) {
                Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"Error");
                errDialog.setText("NG:" + e.toString());
                errDialog.show();
            }
        }
    }
}
