
/**
 * J211_0703_0101.java
 * 
 * J211_0703_0101
 * MenuPanel
 * TestPanel
 * 
 * Class's operational test (FocusManager)
 * 
 * $Id: J211_0703_0101.java,v 1.1 2002/02/01 06:33:08 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class of class's operational test (FocusManager)
 * @extends IApplication
 */
public class J211_0703_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational (FocusManager) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */
    int index = 0;

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
        "0. Test 1",
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("FocusManager4");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 4);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        add(menu1);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                Display.setCurrent(new TestPanel(menu1Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Confirmation screen for class's operational (FocusManager)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel extends Panel implements SoftKeyListener, ComponentListener {

    Frame previousFrame = null;         /* Store the previous screen */
    int buttonIndex;                    /* Test index */
    Label subTitle = null;              /* Sub title */
    Label label1;
    Label label2;
    Label label3;
    Label label4;
    Label label5;
    Label label6;
    Button button;                      /* Button */
    TextBox textBox;                    /* Text box */
    ListBox listBox1;
    ListBox listBox2;
    ListBox listBox3;
    ListBox listBox4;
    ListBox listBox5;
    ListBox listBox6;                    /* List box */

    String[] listBox1Item = {
        "aaa",
        "bbb",
        "ccc",
    };

    /**
     * Constructor of TestPanel class
     * @param  index  Test index
     */
    TestPanel(int index, Frame aFrame) {
        previousFrame = aFrame;
        buttonIndex = index;
//J211_0703_0102
//J211_0703_0103
//J211_0703_0104
//J211_0703_0105
//J211_0703_0106
//J211_0703_0107
//J211_0703_0108

        try {
            /* Display title/sub title */
            setTitle("Class behavior's test");
            subTitle = new Label("");
            subTitle.setText("Event block");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            label1 = new Label("CHOICE");
            label2 = new Label("SINGLE");
            label3 = new Label("MULTIPLE");
            label4 = new Label("RADIO");
            label5 = new Label("CHECK");
            label6 = new Label("NUMBERED");

            /* Setting of the soft key label */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");
            setSoftLabel(Frame.SOFT_KEY_2,"back");

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);

            button = new Button("Button");
            textBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);
            listBox1 = new ListBox(ListBox.CHOICE);
            listBox2 = new ListBox(ListBox.SINGLE_SELECT);
            listBox3 = new ListBox(ListBox.MULTIPLE_SELECT);
            listBox4 = new ListBox(ListBox.RADIO_BUTTON);
            listBox5 = new ListBox(ListBox.CHECK_BOX);
            listBox6 = new ListBox(ListBox.NUMBERED_LIST);
            listBox1.setItems(listBox1Item);
            listBox2.setItems(listBox1Item);
            listBox3.setItems(listBox1Item);
            listBox4.setItems(listBox1Item);
            listBox5.setItems(listBox1Item);
            listBox6.setItems(listBox1Item);

            add(subTitle);
            add(button);
            add(textBox);
            add(label1);
            add(listBox1);
            add(label2);
            add(listBox2);
            add(label3);
            add(listBox3);
            add(label4);
            add(listBox4);
            add(label5);
            add(listBox5);
            add(label6);
            add(listBox6);

        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
//J211_0703_0101
        if ( aComponent == button ) {
            showMsg("Focus not to be moved even when up/down keys are pressed");
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}
