/**
 * J211_1103_0103
 *
 * Class's operational tes(IApplication)
 *
 * $Id: J211_1103_0103.java,v 1.1 2002/02/01 06:33:11 hoshi Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class of class's operational test IApplication
 * @extends IApplication
 */

public class J211_1103_0103 extends IApplication {

    IApplication ia;

    /**
     * Commencing method to i-appli
     */
    public void start () {

//J211_1103_0103
        ia = getCurrentApp();
        Display.setCurrent(new MainPanel(ia));
    }
}

/**
 * Main screen of class's operational test IApplication
 * @extends Panel
 * @implements SoftKeyListener
 */
class MainPanel extends Panel implements SoftKeyListener {

    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
    private Label subTitle = null;
    IApplication ia1;
    IApplication ia2 = IApplication.getCurrentApp();

    /**
     * Constructor of MainPanel class
     */
    public MainPanel(IApplication ia) {
        try {
            ia1 = ia;

            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {
        setTitle("Check behavior of the class");
        subTitle = new Label("IApplication7");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);
        add(textBox);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);

        if (ia1 == ia2) {
            textBox.setText("OK");
        } else {
            textBox.setText("NG");
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}
