
/**
 * J211_1201_0101.java
 * 
 * J211_1201_0101
 * MenuPanel
 * TestPanel
 * 
 * Check behavior of the class(Image)
 * 
 * $Id: J211_1201_0101.java,v 1.1 2002/02/01 06:33:12 hoshi Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.lang.*;

/**
 * Main class for class's operational test (Image)
 * @extends IApplication
 */
public class J211_1201_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational (Image) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */
    int index = 0;

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
//2002/08/07 Doja1.5        "0. Test 1",
//2002/08/07 Doja1.5        "1.Test 2",
//2002/08/07 Doja1.5        "2.Test 3",
//2002/08/07 Doja1.5        "3.Test 4",
        "4.Test 5",
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("Image");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 4);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        add(menu1);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                Display.setCurrent(new testCanvas(menu1Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Confirmation screen class
 * @extends Canvas
 */
class testCanvas extends Canvas {

    /* Variable in order to return to the previous screen */
    Frame previousFrame = null;

    int index;
    Graphics g1;
    Graphics g2;
    Image img;
    Image img2;
    MediaImage mi;
    ImageLabel il;
    int flg;

    /* Creation of message dialog (error/Information) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * Constructor of testCanvas class
     * @param aType  Location of items of Menu
     * @param aFrame  Screen
     */
    public testCanvas(int aType, Frame aFrame) {

        /* Assign the previous screen */
        previousFrame = aFrame;
        index = aType;
        
        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

    }

    /**
     * test method
     */
     void test() {
        switch (index) {
//J211_1201_0101
//2002/08/07 Doja1.5            case 0:
//2002/08/07 Doja1.5                img = Image.createImage(getWidth(), getHeight());
//2002/08/07 Doja1.5                g1 = img.getGraphics();
//2002/08/07 Doja1.5                g1.setColor(Graphics.getColorOfName(Graphics.BLUE));
//2002/08/07 Doja1.5                g1.fillRect(0,0,getWidth(), getHeight());
//2002/08/07 Doja1.5                g1.setColor(Graphics.getColorOfName(Graphics.BLACK));
//2002/08/07 Doja1.5                g1.drawString("In the screen size",15,15);
//2002/08/07 Doja1.5                g1.drawString("To be BLUE",15,30);
//2002/08/07 Doja1.5                flg = 1;
//2002/08/07 Doja1.5                repaint();
//2002/08/07 Doja1.5                break;
//J211_1201_0102
//2002/08/07 Doja1.5            case 1:
//2002/08/07 Doja1.5                img = Image.createImage(50, 50);
//2002/08/07 Doja1.5                img2 = Image.createImage(50, 50);
//2002/08/07 Doja1.5                if (img == img2) {
//2002/08/07 Doja1.5                    flg = 2;
//2002/08/07 Doja1.5                } else {
//2002/08/07 Doja1.5                    flg = 3;
//2002/08/07 Doja1.5                }
//2002/08/07 Doja1.5                repaint();
//2002/08/07 Doja1.5                break;
//J211_1201_0103
//2002/08/07 Doja1.5            case 2:
//2002/08/07 Doja1.5                img = Image.createImage(80, 80);
//2002/08/07 Doja1.5                g1 = img.getGraphics();
//2002/08/07 Doja1.5                g1.drawString("Image",10,15);
//2002/08/07 Doja1.5                flg = 4;
//2002/08/07 Doja1.5                repaint();
//2002/08/07 Doja1.5                break;
//J211_1201_0104
//2002/08/07 Doja1.5            case 3:
//2002/08/07 Doja1.5                img = Image.createImage(getWidth(), getHeight());
//2002/08/07 Doja1.5                img2 = Image.createImage(getWidth(), getHeight());
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5                g1 = img.getGraphics();
//2002/08/07 Doja1.5                g2 = img2.getGraphics();
//2002/08/07 Doja1.5                g1.setColor(Graphics.getColorOfName(Graphics.RED));
//2002/08/07 Doja1.5                g2.setColor(Graphics.getColorOfName(Graphics.BLUE));
//2002/08/07 Doja1.5                g1.fillRect(0,0,getWidth(), getHeight());
//2002/08/07 Doja1.5                g2.fillRect(0,0,getWidth(), getHeight());
//2002/08/07 Doja1.5                g1.setColor(Graphics.getColorOfName(Graphics.BLACK));
//2002/08/07 Doja1.5                g2.setColor(Graphics.getColorOfName(Graphics.BLACK));
//2002/08/07 Doja1.5                g1.drawString("NG in case of RED",15,15);
//2002/08/07 Doja1.5                g2.drawString("OK in case of BLUE",15,15);
//2002/08/07 Doja1.5                flg = 5;
//2002/08/07 Doja1.5                repaint();
//2002/08/07 Doja1.5                break;
//J211_1201_0303
            case 0:
//2002/08/07 Doja1.5            case 4:
                mi = MediaManager.getImage("resource:///java1.gif");
                try {
                    mi.use();
                } catch (Exception e) {
                    Dialog d = new Dialog(Dialog.DIALOG_INFO, "App");
                    d.setText(e.toString());
                    d.show();
                }
                img = mi.getImage();
//2002/08/07 Doja1.5                img = Image.createImage(getWidth(), 50);
                try {
                    img.dispose();
                } catch (Exception e) {
                    err.setText("NG");
                    err.show();
                }
                try {
                    img.getHeight();
//2002/08/07 Doja1.5                    g1.dispose();
                    info.setText("NG");
                    info.show();
                } catch (Exception e) {
                    err.setText("1 : " + e.toString());
                    err.show();
                }
                try {
                    img.dispose();
                    info.setText("OK");
                    info.show();
                } catch (Exception e) {
                    err.setText("NG");
                    err.show();
                }
                break;
        }
    }

    /**
     * Screen depiction
     */
    public void paint(Graphics g) {

        g.lock();
        int y = 45;
        int x = 0;
        g.drawString("Check behavior of the class",0,10);
        g.drawLine(0,15,getWidth(),15);
        g.drawString("Press Enter key",0,30);

        switch (index) {
//2002/08/07 Doja1.5            case 0:
//2002/08/07 Doja1.5                if (flg == 1) {
//2002/08/07 Doja1.5                    g.drawImage(img,0,0);
//2002/08/07 Doja1.5                }
//2002/08/07 Doja1.5                break;
//2002/08/07 Doja1.5            case 1:
//2002/08/07 Doja1.5                if (flg == 2) {
//2002/08/07 Doja1.5                    g.drawString("NG",0,50);
//2002/08/07 Doja1.5                } if (flg == 3) {
//2002/08/07 Doja1.5                    g.drawString("OK",0,50);
//2002/08/07 Doja1.5                }
//2002/08/07 Doja1.5                break;
//2002/08/07 Doja1.5            case 2:
//2002/08/07 Doja1.5                if (flg == 4) {
//2002/08/07 Doja1.5                    g.drawImage(img,0,50);
//2002/08/07 Doja1.5                }
//2002/08/07 Doja1.5                break;
//2002/08/07 Doja1.5            case 3:
//2002/08/07 Doja1.5                if (flg == 5) {
//2002/08/07 Doja1.5                    g.drawImage(img,0,0);
//2002/08/07 Doja1.5                    g.drawImage(img2,0,0);
//2002/08/07 Doja1.5                }
//2002/08/07 Doja1.5                break;
            case 0:
//2002/08/07 Doja1.5            case 4:
                break;
        }
        g.unlock(true);
    }

    /**
     * Define the behavior in the case key being pressed
     * @param aSoftKey  Type of soft key
     */
    public void processEvent(int type,int param) {
        if(type == Display.KEY_RELEASED_EVENT) {
            switch(param) {
                case Display.KEY_SOFT1:
                    IApplication.getCurrentApp().terminate();
                    break;
                case Display.KEY_SOFT2:
                    if(previousFrame != null) {
                        Display.setCurrent(previousFrame);
                    }
                    break;
                case Display.KEY_SELECT:
                    test();
                    break;
                default:
            }
        }
    }
}
