/**
 * J211_1402_0101
 * Check behavior of the class
 * ImageLabel - Check behavior of the size
 *
 * $Id: J211_1402_0101.java,v 1.2 2002/05/23 10:18:10 torikatu Exp $
 */
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;

/**
 * Check behavior of the class
 * ImageLabel - Check behavior of the size
 * @extends IApplication
 */
public class J211_1402_0101 extends IApplication {

    static MainPanel mainPanel;

    /**
     * Overview of functions  :Startup method of i-appli
     */
    public void start() {
        mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * Check behavior of the class
 * ImageLabel - Check behavior of the size
 * Main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

	 

    Label classLabel   = new Label();
    TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
    Button  execButton = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    void showMainPanel() {

        /* Settings of display items */
        classLabel.setText("Operation check of ImageLabel");
        setTitle("Behavior of the class");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Add each component to screen */
        add(classLabel);
        add(textBox1);
        add(execButton);

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When menu list (menuList1) is selected set item(menuList2) */
       // if ( aType == textBox1 ) {
           // if ( aComponent == textBox1 ) {
            //    menuList2.setItems(menuListItem2[menuList1.getSelectedIndex()]);
           // }
      //  }

        /* In the case execute button is pressed */
        if ( aType == ComponentListener.BUTTON_PRESSED) {

            
            Display.setCurrent(new SubPanel(textBox1.getText()));
           
        }
    }
}

/**
 * Check behavior of the class
 * ImageLabel - Check behavior of the size
 * Sub screen
 * @extends Panel
 * @implements SoftKeyListener
 */
class SubPanel extends Panel implements SoftKeyListener {

    Image imageObj;
    Frame prevFrame;
    Label subTitle = null;
    Label sizeTitle = null;
    //int menu1Index;
   // int menu2Index;
 //   MakeImage getImageObj = new MakeImage();
    ImageLabel imageLabelObj = new ImageLabel();
     String text;

    /**
     * Display a sub screen
     * @param anInt1  Sub division of test
     * @param anInt2  Detail items of test
     * @param aFrame  Main screen object
     */
    public SubPanel( String str) {
	//this.str = str;
        /* Object name setting */
       // prevFrame = aFrame;
      //  menu1Index = anInt1;
      //  menu2Index = anInt2;
        try {
            /* Display sub panels */
            ShowSubPanel();
            testPanel(str);
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    void ShowSubPanel() {

        /* Settings of display items */
        subTitle = new Label("");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);
        sizeTitle = new Label("");
        add(sizeTitle);
        setTitle("Behavior of the class");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
    //	testPanel(this.str);
    }

public    void testPanel(String text) {

            subTitle.setText("Default");

         
//J211_1402_0101
           
                sizeTitle.setText("Specify null");
                sizeTitle.setSize(getWidth(), sizeTitle.getHeight());
               // ImageLabel b;
    	       // b = new ImageLabel();
              //  add(b);
              //  b.setImageLabel(str);
    	
    	
                /* Turn the background into GRAY to check the size */
                imageLabelObj.setBackground(
                Graphics.getColorOfName(Graphics.GRAY));
                add(imageLabelObj);
                sizeTitle.setText(text);
    }
              

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* When soft key2 is released, return to the main screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(J211_1402_0101.mainPanel);
        }
    }
}

