/**
 * J211_1602_0201
 * Check behavior of the class
 * Label - Checking behavior of the size
 *
 * $Id: J211_1602_0201.java,v 1.1 2002/02/01 06:56:08 uruno Exp $
 */
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;

/**
 * Check behavior of the class
 * Label - Checking behavior of the size
 * @extends IApplication
 */
public class J211_1602_0201 extends IApplication {

    static MainPanel mainPanel;

    /**
     * Overview of functions  :Startup method of i-appli
     */
    public void start() {
        mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * Check behavior of the class
 * Label - Checking behavior of the size
 * Main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    /* Menu, Selection of display type */
    String[] menuListItem = {
        "1.Specify the size Horizontal > Character",
        "2.Specify the size Horizontal = Character",
        "3.Specify the size Horizontal < Character",
        "4.Specify the size Vertical > Character",
        "5.Specify the size Vertical = Character",
        "6.Specify the size Vertical < Character",
        "7.Check the behavior of the margin"
    };

    Label classLabel   = new Label();
    ListBox menuList  = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    void showMainPanel() {

        /* Settings of display items */
        classLabel.setText("Operation check of Label");
        setTitle("Behavior of the class");
        menuList.setItems(menuListItem);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Add each component to screen */
        add(classLabel);
        add(menuList);
        add(execButton);

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* In the case execute button is pressed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            int menu1Index = menuList.getSelectedIndex();
            Display.setCurrent(new SubPanel(menu1Index, this));
        }
    }
}

/**
 * Check behavior of the class
 * ImageLabel - Check behavior of the size
 * Sub screen
 * @extends Panel
 * @implements SoftKeyListener
 */
class SubPanel extends Panel implements SoftKeyListener {

    Frame prevFrame;
    Label subTitle = null;
    Label sizeTitle = null;
    Label LabelObj = new Label();
    int menu1Index;
    String strMoji = "Character strings";
//2002/09/12 DoJa1.5    TextBox textBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);
    TextBox textBox = new TextBox("", 16, 6, TextBox.DISPLAY_ANY);

    /**
     * Display a sub screen
     * @param anInt    Sub division of test
     * @param aFrame  Main screen object
     */
    public SubPanel(int menu1Index, Frame aFrame) {

        /* Object name setting */
        prevFrame = aFrame;
        menu1Index = menu1Index;
        try {
            /* Display sub panels */
            ShowSubPanel();
            testPanel(menu1Index);
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    void ShowSubPanel() {

        /* Settings of display items */
        subTitle = new Label("");
        add(subTitle);
        sizeTitle = new Label("");
        add(sizeTitle);
        setTitle("Behavior of the class");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
    }

    void testPanel(int menu1Index) {

		Font font;

		font = Font.getDefaultFont();
		int label_width = font.stringWidth(strMoji);
		int label_height = 12;

        switch(menu1Index) {

//J211_1602_0201
        /* Size specification Horizontal > Character */
        case 0:
            subTitle.setText("Behavior in case of the size being specified");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            sizeTitle.setText("Horizontal > Character");
            sizeTitle.setSize(getWidth(), sizeTitle.getHeight());

            /* Set the label size */
            LabelObj.setText(strMoji);
//2002/09/12 DoJa1.5            LabelObj.setSize(48,12);
            LabelObj.setSize((label_width*2),label_height);

            break;

//J211_1602_0202
        /* Specify the size Horizontal = Character */
        case 1:
            subTitle.setText("Behavior in case of the size being specified");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            sizeTitle.setText("Horizontal = Character");
            sizeTitle.setSize(getWidth(), sizeTitle.getHeight());

            /* Set the label size */
            LabelObj.setText(strMoji);
//2002/09/12 DoJa1.5            LabelObj.setSize(36,12);
            LabelObj.setSize(label_width,label_height);

            break;

//J211_1602_0203
        /* Specify the size Horizontal < Character */
        case 2:
            subTitle.setText("Behavior in case of the size being specified");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            sizeTitle.setText("Horizontal<Character");
            sizeTitle.setSize(getWidth(), sizeTitle.getHeight());

            /* Set the label size */
            LabelObj.setText(strMoji);
//2002/09/12 DoJa1.5            LabelObj.setSize(24,12);
            LabelObj.setSize((label_width/2),label_height);

            break;

//J211_1602_0204
        /* Specify the size Vertical > Character */
        case 3:
            subTitle.setText("Behavior in case of the size being specified");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            sizeTitle.setText("Vertical > Character");
            sizeTitle.setSize(getWidth(), sizeTitle.getHeight());

            /* Set the label size */
            LabelObj.setText(strMoji);
//2002/09/12 DoJa1.5            LabelObj.setSize(36,24);
            LabelObj.setSize(label_width,label_height*2);

            break;

//J211_1602_0205
        /* Specify the size Vertical = Character */
        case 4:
            subTitle.setText("Behavior in case of the size being specified");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            sizeTitle.setText("Vertical = Character");
            sizeTitle.setSize(getWidth(), sizeTitle.getHeight());

            /* Set the label size */
            LabelObj.setText(strMoji);
//2002/09/12 DoJa1.5            LabelObj.setSize(36,12);
            LabelObj.setSize(label_width,label_height);

            break;

//J211_1602_0206
        /* Specify the size Vertical < Character */
        case 5:
            subTitle.setText("Behavior in case of the size being specified");
            subTitle.setSize(getWidth(), subTitle.getHeight());
            sizeTitle.setText("Vertical < Character");
            sizeTitle.setSize(getWidth(), sizeTitle.getHeight());

            /* Set the label size */
            LabelObj.setText(strMoji);
//2002/09/12 DoJa1.5            LabelObj.setSize(36,6);
            LabelObj.setSize(label_width,label_height/2);

            break;

//J211_1602_0301
        /* Check behavior of the margin */
        case 6:
            subTitle.setText("Behavior of the margin");
            subTitle.setSize(getWidth(), subTitle.getHeight());

            /* Setting of character of the Label */
            LabelObj.setText(strMoji);

            break;

        default:
            break;
        }

        /* Turn the background into AQUA to confirm the size */
        LabelObj.setBackground(Graphics.getColorOfName(Graphics.AQUA));

        textBox.setText("Character size\n Horizontal=36 Vertical=12\nLabel size\n Horizontal="
            + LabelObj.getWidth() + " Vertical=" +LabelObj.getHeight());
        add(LabelObj);
        add(textBox);
    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* When soft key2 is released, return to the main screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(J211_1602_0201.mainPanel);
        }
    }
}
