/**
 * J211_1902_0401
 * Check behavior of the class
 * ListBox - Check size operations(No size modification)
 *
 * $Id: J211_1902_0401.java,v 1.1 2002/02/01 06:56:10 uruno Exp $
 */
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;

/**
 * Check behavior of the class
 * ListBox - Check size operations(No size modification)
 * @extends IApplication
 */
public class J211_1902_0401 extends IApplication {

    static MainPanel mainPanel;

    /**
     * Overview of functions  :Startup method of i-appli
     */
    public void start() {
        mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * Check behavior of the class
 * ListBox - Check size operations(No size modification)
 * Main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    /* Select the display type */
    String[] menuListItem1 = {
        "1.String (short)",
        "2.String (long)",
        "3.Item quantity 1 line->3 lines",
        "4.Item quantity 3 line->1 lines",
    };

    String[][] menuListItem2 = {
        /* Menu for checking default size */
        {
            "1.CHOICE",
            "2.SINGLE_SELECT",
            "3.MULTIPLE_SELECT",
            "4.NUMBERED_LIST",
            "5.RADIO_BUTTON",
            "6.CHECK_BOX"
        },
    };

    Label classLabel   = new Label();
    ListBox menuList1  = new ListBox(ListBox.CHOICE);
    ListBox menuList2  = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    void showMainPanel() {

        /* Settings of display items */
        classLabel.setText("Operation check of ListBox");
        setTitle("Behavior of the class");
        menuList1.setItems(menuListItem1);
        menuList2.setItems(menuListItem2[0]);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Add each component to screen */
        add(classLabel);
        add(menuList1);
        add(menuList2);
        add(execButton);

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When menu list (menuList1) is selected set item(menuList2) */
        if ( aType == ComponentListener.SELECTION_CHANGED ) {
            if ( aComponent == menuList1 ) {
                menuList2.setItems(menuListItem2[0]);
            }
        }

        /* In the case execute button is pressed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

            int menu1Index = menuList1.getSelectedIndex();
            int menu2Index = menuList2.getSelectedIndex();
            Display.setCurrent(new SubPanel(menu1Index, menu2Index, this));
        }
    }
}

/**
 * Check behavior of the class
 * ListBox - Check size operations(No size modification)
 * Sub screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class SubPanel extends Panel implements SoftKeyListener, ComponentListener {

    Frame prevFrame;
    Label subTitle = null;
    Label sizeTitle = null;
    Button button = new Button("execute");
    ListBox ListBoxObj;

    int ButtonIndex1 = 0;
    int ButtonIndex2 = 0;
    int menu1Index;
    int menu2Index;

    int menuSizeY = 0;
    int frameSizeY = 0;

    /* ListBox type */
    int[] listType = {
        ListBox.CHOICE,
        ListBox.SINGLE_SELECT,
        ListBox.MULTIPLE_SELECT,
        ListBox.NUMBERED_LIST,
        ListBox.RADIO_BUTTON,
        ListBox.CHECK_BOX,
    };

    /* ListBox type name */
    String[] listTypeName = {
        "CHOICE",
        "SINGLE_SELECT",
        "MULTIPLE_SELECT",
        "NUMBERED_LIST",
        "RADIO_BUTTON",
        "CHECK_BOX"
    };

    /* Menu list */
    String[] menuListItem1 = {
        "1.String",
    };

    String[] menuListItem2 = {
        "1.String",
        "2.String",
        "3.String",
    };

    TextBox textBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);

    /**
     * Display a sub screen
     * @param anInt    Sub division of test
     * @param aFrame  Main screen object
     */
    public SubPanel(int menu1Index, int menu2Index, Frame aFrame) {

        /* Object name setting */
        prevFrame = aFrame;
        menu1Index = menu1Index;
        menu2Index = menu2Index;
        try {
            /* Display sub panels */
            ShowSubPanel();
            testPanel(menu1Index, menu2Index);
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    void ShowSubPanel() {

        /* Settings of display items */
        subTitle = new Label("");
        add(subTitle);
        sizeTitle = new Label("");
        add(sizeTitle);
        setTitle("Behavior of the class");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    void testPanel(int menu1Index, int menu2Index) {

        switch(menu1Index) {

        /* Change character length(Original->Short) */
        case 0:
            menuSizeY = 12;
            subTitle.setText("Change the length of the characters (short)");
            break;

        /* Change character length(Original->Long) */
        case 1:
            menuSizeY = 12;
            subTitle.setText("Change the length of the characters (long)");
            break;

        /* Change the item quantity(1 line->3 lines) */
        case 2:
            menuSizeY = 12;
            subTitle.setText("Change the length of the item (Default)");
            break;

        /* Change the item quantity(3 line->1 lines) */
        case 3:
            menuSizeY = 36;
            subTitle.setText("Change the length of the item (Default)");

            break;
        default:
            break;
        }

        /* Only CHOICE has a different vertical width */
        if(menu2Index == 0) {
            frameSizeY = 15;
        } else {
            frameSizeY = 24;
        }

        /* ButtonIndex setting */
        ButtonIndex1 = menu1Index;
        ButtonIndex2 = menu2Index;

        /* Create ListBox */
        ListBoxObj = new ListBox(listType[menu2Index]);
        if(menu1Index==3) {
            ListBoxObj.setItems(menuListItem2);
        } else {
            ListBoxObj.setItems(menuListItem1);
        }

        textBox.setText("Size of the character (48" + menuSizeY + ")\n" +
            "ListBox size\n(" + ListBoxObj.getWidth() +
            "," + ListBoxObj.getHeight() +")");

        subTitle.setSize(getWidth(), subTitle.getHeight());
        sizeTitle.setText(listTypeName[menu2Index]);
        sizeTitle.setSize(getWidth(), sizeTitle.getHeight());

        /* Add components */
        add(ListBoxObj);
        add(button);
        button.requestFocus();
        add(textBox);

    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* When soft key2 is released, return to the main screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(J211_1902_0401.mainPanel);
        }
    }


//J211_1905_0301
//J211_1905_0302
//J211_1905_0303
//J211_1905_0304
//J211_1905_0305
//J211_1905_0306
    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if ( aComponent == button ) {
            /* Menu list */
            String[] changeMenuListItem1 = {
                "1.Character",
            };

            String[] changeMenuListItem2 = {
                "1.Change the length of string",
            };

            String[] changeMenuListItem3 = {
                "1.String",
                "2.String",
                "3.String",
            };

            String[] changeMenuListItem4 = {
                "1.String",
            };

            switch(ButtonIndex1) {
//J211_1902_0401
//J211_1902_0402
//J211_1902_0403
//J211_1902_0404
//J211_1902_0405
//J211_1902_0406
            case 0:
                ListBoxObj.setItems(changeMenuListItem1);
                textBox.setText("Character size(32,12)\n" +
                    "ListBox size\n(" + ListBoxObj.getWidth() +
                    "," + ListBoxObj.getHeight() +")");
                break;
//J211_1902_0407
//J211_1902_0408
//J211_1902_0409
//J211_1902_0410
//J211_1902_0411
//J211_1902_0412
            case 1:
                ListBoxObj.setItems(changeMenuListItem2);
                textBox.setText("Character size(84,12)\n" +
                    "ListBox size\n(" + ListBoxObj.getWidth() +
                    "," + ListBoxObj.getHeight() +")");
                break;
//J211_1902_0413
//J211_1902_0414
//J211_1902_0415
//J211_1902_0416
//J211_1902_0417
//J211_1902_0418
            case 2:
                ListBoxObj.setItems(changeMenuListItem3);
                textBox.setText("Character size(48,36)\n" +
                    "ListBox size\n(" + ListBoxObj.getWidth() +
                    "," + ListBoxObj.getHeight() +")");
                break;
//J211_1902_0419
//J211_1902_0420
//J211_1902_0421
//J211_1902_0422
//J211_1902_0423
//J211_1902_0424
            case 3:
                ListBoxObj.setItems(changeMenuListItem4);
                textBox.setText("Character size(48,12)\n" +
                    "ListBox size\n(" + ListBoxObj.getWidth() +
                    "," + ListBoxObj.getHeight() +")");
                break;
            default:
                break;
            }
        }
    }
}
