/**
 * J211_2701_0102
 * MainPanel
 * NextPanel1
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J211_2701_0102.java,v 1.1 2002/02/04 07:28:35 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import java.lang.*;

/**
 * Main class for checking behavior of the PhoneSystem class and the class
 * @extends IApplication
 */

public class J211_2701_0102 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the PhoneSystem class and the class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Back light ON",
            "2 Back light OFF",
            "3 BL continuous",
            "4  Vibrator ON",
            "5  Vibrator OFF",
            "6 VR continuous",
//2002/08/07 Doja1.5            "7 Folding",
//2002/08/07 Doja1.5            "8  Mail state",
//2002/08/07 Doja1.5            "9 Message state",
//2002/08/07 Doja1.5            "10 Check the state",
//2002/09/24 Doja1.5            "11 Available",
            "12 information",
            "13 Warning",
            "14 Error",
            "15 Alarm",
            "16 Confirmation"
    };
    private Button button1,button2;
    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
    private int backlight = 0;
    private int vibrator = 0;

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        /* Settings of display items */
        setTitle("Check behavior of the class");
        menuList.setItems(menuListItem);
        add(menuList);
        button1 = new Button("execute");
        add(button1);
        button2 = new Button("execute OFF");
        add(button2);

        add(textBox);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        
        if ( aComponent == menuList ) {
            textBox.setText("");
        }

        if ( aComponent == button1 && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    PhoneSystem.setAttribute(PhoneSystem.DEV_BACKLIGHT,
                            PhoneSystem.ATTR_BACKLIGHT_ON);
                    backlight = 1;
                    break;
                case 1:
//J211_2701_0102
                    PhoneSystem.setAttribute(PhoneSystem.DEV_BACKLIGHT,
                            PhoneSystem.ATTR_BACKLIGHT_OFF);
                    backlight = 0;
                    break;
                case 2:
//J211_2701_0103
                    PhoneSystem.setAttribute(PhoneSystem.DEV_BACKLIGHT,
                            PhoneSystem.ATTR_BACKLIGHT_ON);
                    backlight = 1;
                    break;
                case 3:
//J211_2701_0106
                    PhoneSystem.setAttribute(PhoneSystem.DEV_VIBRATOR,
                            PhoneSystem.ATTR_VIBRATOR_ON);
                    vibrator = 1;
                    break;
                case 4:
//J211_2701_0107
                    PhoneSystem.setAttribute(PhoneSystem.DEV_VIBRATOR,
                            PhoneSystem.ATTR_VIBRATOR_OFF);
                    vibrator = 0;
                    break;
                case 5:
                    PhoneSystem.setAttribute(PhoneSystem.DEV_VIBRATOR,
                            PhoneSystem.ATTR_VIBRATOR_ON);
                    vibrator = 1;
                    break;
//2002/08/07 Doja1.5                case 6:
//J211_2701_0111
//2002/08/07 Doja1.5                    PhoneSystem.setAttribute(PhoneSystem.DEV_FOLDING,
//2002/08/07 Doja1.5                            PhoneSystem.ATTR_FOLDING_CLOSE);
//2002/08/07 Doja1.5                    if ( PhoneSystem.getAttribute(PhoneSystem.DEV_FOLDING) 
//2002/08/07 Doja1.5                                    == PhoneSystem.ATTR_FOLDING_CLOSE ){
//2002/08/07 Doja1.5                        textBox.setText("DEV_FOLDING:NG");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("DEV_FOLDING:OK");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 7:
//J211_2701_0112
//2002/08/07 Doja1.5                    PhoneSystem.setAttribute(PhoneSystem.DEV_MAILBOX,
//2002/08/07 Doja1.5                            PhoneSystem.ATTR_MAIL_NONE);
//2002/08/07 Doja1.5                    if ( PhoneSystem.getAttribute(PhoneSystem.DEV_MAILBOX) 
//2002/08/07 Doja1.5                                    == PhoneSystem.ATTR_MAIL_RECEIVED ){
//2002/08/07 Doja1.5                        textBox.setText("DEV_MAILBOX:OK");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("DEV_MAILBOX:NG");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 8:
//J211_2701_0113
//2002/08/07 Doja1.5                    PhoneSystem.setAttribute(PhoneSystem.DEV_MESSAGEBOX,
//2002/08/07 Doja1.5                            PhoneSystem.ATTR_MESSAGE_NONE);
//2002/08/07 Doja1.5                    if ( PhoneSystem.getAttribute(PhoneSystem.DEV_MESSAGEBOX) 
//2002/08/07 Doja1.5                                    == PhoneSystem.ATTR_MESSAGE_NONE ){
//2002/08/07 Doja1.5                        textBox.setText("DEV_MESSAGEBOX:OK");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("DEV_MESSAGEBOX:NG");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 9:
                    /* Creation 1 of NextPanel1 */
//2002/08/07 Doja1.5                    Display.setCurrent(new NextPanel1((Frame) this));
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 10:
//J211_2701_0301
//2002/08/07 Doja1.5                    boolean flag = PhoneSystem.isAvailable(PhoneSystem.DEV_BACKLIGHT);
//2002/08/07 Doja1.5                    if ( flag == true ) {
//2002/08/07 Doja1.5                        textBox.setText("yes");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("no");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
                case 6:
//2002/08/07 Doja1.5                case 11:
//J211_2701_0401
                    PhoneSystem.playSound(PhoneSystem.SOUND_INFO);
                    break;
                case 7:
//2002/08/07 Doja1.5                case 12:
//J211_2701_0402
                    PhoneSystem.playSound(PhoneSystem.SOUND_WARNING);
                    break;
                case 8:
//2002/08/07 Doja1.5                case 13:
//J211_2701_0403
                    PhoneSystem.playSound(PhoneSystem.SOUND_ERROR);
                    break;
                case 9:
//2002/08/07 Doja1.5                case 14:
//J211_2701_0404
                    PhoneSystem.playSound(PhoneSystem.SOUND_ALARM);
                    break;
                case 10:
//2002/08/07 Doja1.5                case 15:
//J211_2701_0405
                    PhoneSystem.playSound(PhoneSystem.SOUND_CONFIRM);
                    break;
            }
        }

        if ( aComponent == button2 && aType == BUTTON_PRESSED  ) {
            if ( backlight == 1 ) {
//J211_2701_0103
                PhoneSystem.setAttribute(PhoneSystem.DEV_BACKLIGHT,PhoneSystem.ATTR_BACKLIGHT_OFF);
            } 
            if ( vibrator == 1 ) {
//J211_2701_0108
                PhoneSystem.setAttribute(PhoneSystem.DEV_VIBRATOR,PhoneSystem.ATTR_VIBRATOR_OFF);
            }
        }

    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Sub screen for checking behavior of the PhoneSystem
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
//2002/08/07 Doja1.5class NextPanel1 extends Panel implements SoftKeyListener, ComponentListener {
//2002/08/07 Doja1.5    private Frame previousFrame = null;
//2002/08/07 Doja1.5    private ListBox menuList = new ListBox(ListBox.CHOICE);
//2002/08/07 Doja1.5    private  String[] menuListItem = {
//2002/08/07 Doja1.5            "1 Back light saving",
//2002/08/07 Doja1.5            "2 Vibrator",
//2002/08/07 Doja1.5            "3 Vibrator saving",
//2002/08/07 Doja1.5            "4 Folding",
//2002/08/07 Doja1.5            "5 Mail state",
//2002/08/07 Doja1.5            "6 Message state",
//2002/08/07 Doja1.5    };
//2002/08/07 Doja1.5    private Button button1,button2,button3;
//2002/08/07 Doja1.5    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5    /**
//2002/08/07 Doja1.5     * Constructor of NextPanel1
//2002/08/07 Doja1.5     * @param aPrev Object of MainPanel
//2002/08/07 Doja1.5     */
//2002/08/07 Doja1.5    public NextPanel1(Frame aPrev) {
//2002/08/07 Doja1.5        previousFrame = aPrev;
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        /* Settings of display items */
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        menuList.setItems(menuListItem);
//2002/08/07 Doja1.5        add(menuList);
//2002/08/07 Doja1.5        button1 = new Button("execute");
//2002/08/07 Doja1.5        button2 = new Button("Back light");
//2002/08/07 Doja1.5        button3 = new Button("Vibrator");
//2002/08/07 Doja1.5        add(button1);
//2002/08/07 Doja1.5        add(button2);
//2002/08/07 Doja1.5        add(button3);
//2002/08/07 Doja1.5        add(textBox);
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        setSoftLabel(Frame.SOFT_KEY_1, "exit");
//2002/08/07 Doja1.5        setSoftLabel(Frame.SOFT_KEY_2, "back");
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        /* Listener setting */
//2002/08/07 Doja1.5        setSoftKeyListener(this);
//2002/08/07 Doja1.5        setComponentListener(this);
//2002/08/07 Doja1.5    }
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5    /**
//2002/08/07 Doja1.5     * Receive events occurred in components
//2002/08/07 Doja1.5     * @param aComponent  Component where an event occurred
//2002/08/07 Doja1.5     * @param aType  Type of events
//2002/08/07 Doja1.5     * @param aParam  Parameter of events
//2002/08/07 Doja1.5     */
//2002/08/07 Doja1.5    public void componentAction(Component aComponent, int aType, int aParam) {
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        /* Clear text box */
//2002/08/07 Doja1.5        if ( aComponent == menuList ) {
//2002/08/07 Doja1.5            textBox.setText("");
//2002/08/07 Doja1.5        }
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        if ( aComponent == button2 && aType == BUTTON_PRESSED ) {
//2002/08/07 Doja1.5            PhoneSystem.setAttribute(PhoneSystem.DEV_BACKLIGHT,
//2002/08/07 Doja1.5                                    PhoneSystem.ATTR_BACKLIGHT_ON);
//2002/08/07 Doja1.5        }
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        if ( aComponent == button3 && aType == BUTTON_PRESSED ) {
//2002/08/07 Doja1.5            PhoneSystem.setAttribute(PhoneSystem.DEV_VIBRATOR,
//2002/08/07 Doja1.5                                    PhoneSystem.ATTR_VIBRATOR_ON);
//2002/08/07 Doja1.5        }
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5        if ( aComponent == button1 && aType == BUTTON_PRESSED ) {
//2002/08/07 Doja1.5            switch(menuList.getSelectedIndex()){
//2002/08/07 Doja1.5                case 0:
//2002/08/07 Doja1.5//J211_2701_0202
//2002/08/07 Doja1.5                    try {
//2002/08/07 Doja1.5                        Thread.sleep(30000);
//2002/08/07 Doja1.5                    } catch ( Exception e ) {}
//2002/08/07 Doja1.5                    int bl = PhoneSystem.getAttribute(PhoneSystem.DEV_BACKLIGHT);
//2002/08/07 Doja1.5                    if ( bl == PhoneSystem.ATTR_BACKLIGHT_OFF) {
//2002/08/07 Doja1.5                        textBox.setText("BACKLIGHT:OK");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("BACKLIGHT:NG");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 1:
//2002/08/07 Doja1.5//J211_2701_0203
//2002/08/07 Doja1.5                    int vr = PhoneSystem.getAttribute(PhoneSystem.DEV_VIBRATOR);
//2002/08/07 Doja1.5                    if ( vr == PhoneSystem.ATTR_VIBRATOR_ON ) {
//2002/08/07 Doja1.5                        textBox.setText("VIBRATOR_ON:OK");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("VIBRATOR_OFF:NG");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 2:
//2002/08/07 Doja1.5//J211_2701_0204
//2002/08/07 Doja1.5//J211_2701_0110
//2002/08/07 Doja1.5                    int vr2 = PhoneSystem.getAttribute(PhoneSystem.DEV_VIBRATOR);
//2002/08/07 Doja1.5                    if ( vr2 == PhoneSystem.ATTR_VIBRATOR_OFF ) {
//2002/08/07 Doja1.5                        textBox.setText("VIBRATOR_OFF:OK");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("VIBRATOR_ON:NG");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 3:
//2002/08/07 Doja1.5//J211_2701_0205
//2002/08/07 Doja1.5                    int fd = PhoneSystem.getAttribute(PhoneSystem.DEV_FOLDING);
//2002/08/07 Doja1.5                    if ( fd == PhoneSystem.ATTR_FOLDING_OPEN ) {
//2002/08/07 Doja1.5                        textBox.setText("FOLDING_OPEN:OK");
//2002/08/07 Doja1.5                    } else {
//2002/08/07 Doja1.5                        textBox.setText("FOLDING_CLOSE:NG");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 4:
//2002/08/07 Doja1.5//J211_2701_0206
//2002/08/07 Doja1.5                    int mb = PhoneSystem.getAttribute(PhoneSystem.DEV_MAILBOX);
//2002/08/07 Doja1.5                    if ( mb == PhoneSystem.ATTR_MAIL_AT_CENTER 
//2002/08/07 Doja1.5                                || mb == PhoneSystem.ATTR_MAIL_NONE 
//2002/08/07 Doja1.5                                    || mb == PhoneSystem.ATTR_MAIL_RECEIVED ) {
//2002/08/07 Doja1.5                        textBox.setText("MAIL:OK");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5                case 5:
//2002/08/07 Doja1.5//J211_2701_0207
//2002/08/07 Doja1.5                    int meb = PhoneSystem.getAttribute(PhoneSystem.DEV_MESSAGEBOX);
//2002/08/07 Doja1.5                    if ( meb == PhoneSystem.ATTR_MESSAGE_AT_CENTER 
//2002/08/07 Doja1.5                                || meb == PhoneSystem.ATTR_MESSAGE_NONE 
//2002/08/07 Doja1.5                                    || meb == PhoneSystem.ATTR_MESSAGE_RECEIVED ) {
//2002/08/07 Doja1.5                        textBox.setText("MESSAGE:OK");
//2002/08/07 Doja1.5                    }
//2002/08/07 Doja1.5                    break;
//2002/08/07 Doja1.5            }
//2002/08/07 Doja1.5        }
//2002/08/07 Doja1.5    }
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5    /**
//2002/08/07 Doja1.5     * When soft key is pressed, do not carry out any operations.
//2002/08/07 Doja1.5     * @param anIndex Key index
//2002/08/07 Doja1.5     */
//2002/08/07 Doja1.5    public void softKeyPressed(int anIndex) {}
//2002/08/07 Doja1.5
//2002/08/07 Doja1.5    /**
//2002/08/07 Doja1.5     * Terminate appli when soft key1 is released
//2002/08/07 Doja1.5     * Return to the previous screen when soft key2 is released.
//2002/08/07 Doja1.5     * @param anIndex Key index
//2002/08/07 Doja1.5     */
//2002/08/07 Doja1.5    public void softKeyReleased(int anIndex) {
//2002/08/07 Doja1.5        if (anIndex == Frame.SOFT_KEY_1) {
//2002/08/07 Doja1.5            IApplication.getCurrentApp().terminate();
//2002/08/07 Doja1.5        }
//2002/08/07 Doja1.5        if (anIndex == Frame.SOFT_KEY_2) {
//2002/08/07 Doja1.5            Display.setCurrent(previousFrame);
//2002/08/07 Doja1.5        }
//2002/08/07 Doja1.5    }
//2002/08/07 Doja1.5}
