/**
 * J211_2901_0101
 * MainPanel
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J211_2901_0101.java,v 1.1 2002/02/04 07:28:36 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import java.lang.*;

/**
 * Main class for checking behavior of the SoftKeyListener class and the class
 * @extends IApplication
 */

public class J211_2901_0101 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the PhoneSystem class and the class
 * @extends Panel
 * @implements SoftKeyListener
 */
class MainPanel extends Panel implements SoftKeyListener {
//2002/08/07 DoJa1.5    private AnchorButton anchorButton = new AnchorButton("Check behavior of the SoftKeyListener class");
    private Button button = new Button("Check behavior of the SoftKeyListener class");
    private Label label = new Label("  test  ");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        /* Settings of display items */
        setTitle("Check behavior of the class");
//2002/08/07 DoJa1.5        anchorButton.setEnabled(false);
//2002/08/07 DoJa1.5        add(anchorButton);
        button.setEnabled(false);
        add(button);
        add(label);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "test");

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /**
     * No action to be taken when soft key 2 is pressed
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_2) {
//J211_2901_0101
            label.setText("test:OK");
        }
    }

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Dialog dialog= new Dialog(Dialog.DIALOG_INFO, "test");
            dialog.setText("Press softkey1 while dialog is being displayed.");
            dialog.show();
        }
    }
}