/**
 * J211_3001_0101
 * MainPanel
 * NextPanel1
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J211_3001_0101.java,v 1.1 2002/02/04 07:28:37 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import java.lang.*;

/**
 * Main class for checking behavior of the TextBox class and the class
 * @extends IApplication
 */

public class J211_3001_0101 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the TextBox class and the class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Display the dialog",
            "2 Change over the frame",
            "3 Check the invalid state",
            "4 Check both specifications",
            "5 Horizontal > Character",
            "6 Horizontal = Character",
            "7 Horizontal < Character",
            "8 Vertical > Character",
            "9 Vertical = Character",
            "10 Vertical < Character",
            "11 Default layout",
//2002/08/07 DoJa1.5            "12 HTML layout",
            "13 NULL layout",
            "14 Visible setText",
            "15 Invisible setText",
            "16 Invalid setText",
            "17 Not displayed while being edited",
    };
    private Button button = new Button(" execute ");
    private TextBox textBox1 = new TextBox("", 20, 2, TextBox.DISPLAY_ANY);
//J211_3001_0203
    private TextBox textBox2 = new TextBox("", 20, 1, TextBox.DISPLAY_PASSWORD);
    private TextBox textBox3 = new TextBox("abcdeefghi", 10, 1, TextBox.DISPLAY_ANY);
//J211_3003_0101
    private TextBox textBox4 = new TextBox("", 10, 1, TextBox.DISPLAY_ANY);
    private String str;
    private int columns,rows;

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        /* Settings of display items */
        setTitle("Check behavior of the class");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);

        add(textBox1);
        add(textBox2);
        add(textBox3);
        add(textBox4);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        
char[]    emoji             = {0xE63E, 0xE63F, 0xE640, 0xE641};
String emojistr = new String(emoji);

        if ( aComponent == menuList ) {
            textBox1.setEditable(true);
            textBox1.setVisible(true);
            textBox1.setEnabled(true);
        }

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                case 1:
                    /* Create NextPanel2 */
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
                case 2:
//J211_3002_0301
                    textBox1.setEnabled(false);
                    break;
                case 3:
//J211_3002_0503
                    textBox2.setBackground(Graphics.getColorOfName(Graphics.LIME));
                    textBox2.setForeground(Graphics.getColorOfName(Graphics.PURPLE));
                    break;
                case 4:
                    str = "ai";
                    columns = 20;
                    rows = 2;
                    /* Create NextPanel3 */
//J211_3003_0201
                    Display.setCurrent(new NextPanel3((Frame) this, str, columns, rows));
                    break;
                case 5:
                    columns = 4;
                    rows = 2;
                    /* Create NextPanel3 */
//J211_3003_0202
                    Display.setCurrent(new NextPanel3((Frame) this, emojistr, columns, rows));
                    break;
                case 6:
                    str = "abcdefghijklmnopqr";
                    columns = 5;
                    rows = 2;
                    /* Create NextPanel3 */
//J211_3003_0203
                    Display.setCurrent(new NextPanel3((Frame) this, str, columns, rows));
                    break;
                case 7:
                    str = "abcde";
                    columns = 5;
                    rows = 2;
                    /* Create NextPanel3 */
//J211_3003_0204
                    Display.setCurrent(new NextPanel3((Frame) this, str, columns, rows));
                    break;
                case 8:
//                    str = "Agyq";
                    columns = 1;
//                    rows = 2;
                    rows = 4;
                    /* Create NextPanel3 */
//J211_3003_0205
                    Display.setCurrent(new NextPanel3((Frame) this, emojistr, columns, rows));
                    break;
                case 9:
                    str = "abcdefghijklmnopq";
                    columns = 2;
                    rows = 2;
                    /* Create NextPanel3 */
//J211_3003_0206
                    Display.setCurrent(new NextPanel3((Frame) this, str, columns, rows));
                    break;
                case 10:
                    /* Create NextPanel4 */
                    Display.setCurrent(new NextPanel4((Frame) this));
                    break;
//2002/08/07 DoJa1.5                case 11:
                    /* Create NextPanel5 */
//2002/08/07 DoJa1.5                    Display.setCurrent(new NextPanel5((Frame) this));
//2002/08/07 DoJa1.5                    break;
//2002/08/07 DoJa1.5                case 12:
                case 11:
                    /* Create NextPanel6 */
                    Display.setCurrent(new NextPanel6((Frame) this));
                    break;
//2002/08/07 DoJa1.5                case 13:
                case 12:
//J211_3007_0103
                    textBox1.setText("abcdef");
                    break;
//2002/08/07 DoJa1.5                case 14:
                case 13:
//J211_3007_0104
                    textBox1.setVisible(false);
                    textBox1.setText("ghijkl");
                    break;
//2002/08/07 DoJa1.5                case 15:
                case 14:
//J211_3007_0105
                    textBox1.setEnabled(false);
                    textBox1.setText("mnopqr");
                    break;
//2002/08/07 DoJa1.5                case 16:
                case 15:
                    /* Create NextPanel7 */
                    Display.setCurrent(new NextPanel7((Frame) this));
                    break;
            }
        }

        if ( aComponent == textBox4 && aType == TEXT_CHANGED ) {
            showDialog();
        } else if ( aComponent == textBox1 && aType == TEXT_CHANGED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    showDialog();
                    break;
//2002/08/07 DoJa1.5                case 13:
                case 12:
                    showDialog();
                    break;
//2002/08/07 DoJa1.5                case 14:
                case 13:
                    showDialog();
                    break;
//2002/08/07 DoJa1.5                case 15:
                case 14:
                    showDialog();
                    break;
            }
        }
    }

    /**
     * Dialog display method
     */
    public void showDialog() {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText("Dialog to be displayed");
        d.show();
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Sub screen 1 for checking behavior of the TextBox class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 * @implements Runnable
 */
class NextPanel1 extends Panel implements SoftKeyListener, ComponentListener,Runnable {
    private Frame previousFrame = null;
    private TextBox textBox = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);
    private Button button = new Button(" execute ");
    private Label label = new Label("Display dialog while input");

    /**
     * Constructor of NextPanel1
     * @param aPrev Object of MainPanel
     */
    public NextPanel1(Frame aPrev) {
        previousFrame = aPrev;

        /* Settings of display items */
        setTitle("Check behavior of the class");
        add(label);
        add(button);
        add(textBox);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            Thread t1 = new Thread(this);
            t1.start();
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * Thread execution method
     */
    public void run() {
        try {
            Thread.sleep(5000);
        } catch ( Exception e ) {}
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "message");
//J211_3001_0301
        d.setText("Dialog to be displayed after the text box is edited");
        d.show();
    }
}

/**
 * Sub screen 2 for checking behavior of the TextBox class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 * @implements Runnable
 */
class NextPanel2 extends Panel implements SoftKeyListener, ComponentListener,Runnable {
    private Frame previousFrame = null;
    private TextBox textBox = new TextBox("", 20, 1, TextBox.DISPLAY_ANY);
    private Button button = new Button(" execute ");
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Frame change-over",
            "2 Multiple change-over of the frame",
            "3 Dialog of frame change-over"
    };
    private int selection;

    /**
     * Constructor of NextPanel2
     * @param aPrev Object of MainPanel
     */
    public NextPanel2(Frame aPrev) {
        previousFrame = aPrev;

        /* Settings of display items */
        setTitle("Check behavior of the class");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);
        add(textBox);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            selection = menuList.getSelectedIndex();
            if (menuList.getSelectedIndex() == 0){
                Thread t1 = new Thread(this);
                t1.start();
            } else if ( menuList.getSelectedIndex() == 1 || menuList.getSelectedIndex() == 2 ) {
                Thread t2 = new Thread(this);
                t2.start();
            }
        }

        if ( aType == TEXT_CHANGED ) {
//J211_3001_0304
            if ( menuList.getSelectedIndex() == 2 ) {
                Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
                d.setText("Dialog to be displayed after the text box is edited");
                d.show();
            }
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * Thread execution method
     */
    public void run() {
        try {
            Thread.sleep(5000);
        } catch ( Exception e ) {}
//2002/09/18 Doja1.5        if( selection == 0 || selection == 2 ) {
            if( selection == 0 ) {
//J211_3001_0302
            Display.setCurrent(previousFrame);
//2002/09/18 Doja1.5        } else if ( selection == 1 ) {
            } else if ( selection == 1 || selection == 2 ) {
//J211_3001_0303
//J211_3001_0304
            Display.setCurrent(new NextPanel1((Frame) this));
            Display.setCurrent(new NextPanel4((Frame) this));
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Sub screen 3 for checking behavior of the TextBox class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel3 extends Panel implements SoftKeyListener {
    private Frame previousFrame = null;
    private TextBox textBox;
    private Label label = new Label("Check when size is specified");
    private String str;
    private int columns, rows;

    /**
     * Constructor of NextPanel3
     * @param aPrev Object of MainPanel
     */
    public NextPanel3(Frame aPrev, String aStr, int aColumns, int aRows) {
        previousFrame = aPrev;
        str = aStr;
        columns = aColumns;
        rows = aRows;
        textBox = new TextBox(str, columns, rows, TextBox.DISPLAY_ANY);

        /* Settings of display items */
        setTitle("Check behavior of the class");
        add(label);
        add(textBox);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Sub screen 4 for checking behavior of the TextBox class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel4 extends Panel implements SoftKeyListener, ComponentListener{

    private Frame previousFrame = null;
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Invalid state",
            "2 Invisible state",
    };
    private Button button = new Button("execute");
    private TextBox textBox1 = new TextBox("Check scrolling", 10, 1, TextBox.DISPLAY_ANY);
    private TextBox textBox2 = new TextBox("Check scrolling", 20, 1, TextBox.DISPLAY_ANY);
    private TextBox textBox3 = new TextBox("Check scrolling", 20, 5, TextBox.DISPLAY_ANY);

    /**
     * Constructor of NextPanel4
     * @param aPrev Object of MainPanel
     */
    public NextPanel4(Frame aPrev) {
        previousFrame = aPrev;

        /* Settings of display items */

        menuList.setItems(menuListItem);
        add(menuList);
        add(button);

        add(textBox1);
        add(textBox2);
        textBox3.setSize(Display.getWidth(),Display.getHeight());
//J211_3005_0102
        add(textBox3);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == menuList ) {
            textBox2.setEnabled(true);
            textBox2.setVisible(true);
        }

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
//J211_3005_0103
                    textBox2.setEnabled(false);
                    break;
                case 1:
//J211_3005_0104
                    textBox2.setVisible(false);
                    break;
            }
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Sub screen 5 for checking behavior of the TextBox class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
//2002/08/07 DoJa1.5class NextPanel5 extends Panel implements SoftKeyListener, ComponentListener{

//2002/08/07 DoJa1.5    private Frame previousFrame = null;
//2002/08/07 DoJa1.5    private HTMLLayout hm = new HTMLLayout();
//2002/08/07 DoJa1.5    private ListBox menuList = new ListBox(ListBox.CHOICE);
//2002/08/07 DoJa1.5    private  String[] menuListItem = {
//2002/08/07 DoJa1.5            "1 Invalid state",
//2002/08/07 DoJa1.5            "2 Invisible state",
//2002/08/07 DoJa1.5    };
//2002/08/07 DoJa1.5    private Button button = new Button("execute");
//2002/08/07 DoJa1.5    private TextBox textBox1 = new TextBox("Check scrolling", 10, 1, TextBox.DISPLAY_ANY);
//2002/08/07 DoJa1.5    private TextBox textBox2 = new TextBox("Check scrolling", 20, 1, TextBox.DISPLAY_ANY);
//2002/08/07 DoJa1.5    private TextBox textBox3 = new TextBox("Check scrolling", 20, 5, TextBox.DISPLAY_ANY);

    /**
     * Constructor of NextPanel 5
     * @param aPrev Object of MainPanel
     */
//2002/08/07 DoJa1.5    public NextPanel5(Frame aPrev) {
//2002/08/07 DoJa1.5        previousFrame = aPrev;
//2002/08/07 DoJa1.5        setLayoutManager(hm);

        /* Settings of display items */
//2002/08/07 DoJa1.5        hm.begin(HTMLLayout.CENTER);
//2002/08/07 DoJa1.5        menuList.setItems(menuListItem);
//2002/08/07 DoJa1.5        add(menuList);
//2002/08/07 DoJa1.5        hm.br();
//2002/08/07 DoJa1.5        add(button);
//2002/08/07 DoJa1.5        hm.br();

//2002/08/07 DoJa1.5        add(textBox1);
//2002/08/07 DoJa1.5        hm.br();
//2002/08/07 DoJa1.5        add(textBox2);
//2002/08/07 DoJa1.5        hm.br();
//2002/08/07 DoJa1.5        textBox3.setSize(Display.getWidth(),Display.getHeight());
//J211_3005_0106
//2002/08/07 DoJa1.5        add(textBox3);

//2002/08/07 DoJa1.5        setSoftLabel(Frame.SOFT_KEY_1, "exit");
//2002/08/07 DoJa1.5        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
//2002/08/07 DoJa1.5        setSoftKeyListener(this);
//2002/08/07 DoJa1.5        setComponentListener(this);
//2002/08/07 DoJa1.5    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
//2002/08/07 DoJa1.5    public void componentAction(Component aComponent, int aType, int aParam) {

//2002/08/07 DoJa1.5        if ( aComponent == menuList ) {
//2002/08/07 DoJa1.5            textBox2.setEnabled(true);
//2002/08/07 DoJa1.5            textBox2.setVisible(true);
//2002/08/07 DoJa1.5        }

//2002/08/07 DoJa1.5        if ( aComponent == button && aType == BUTTON_PRESSED ) {
//2002/08/07 DoJa1.5            switch(menuList.getSelectedIndex()){
//2002/08/07 DoJa1.5                case 0:
//2002/08/07 DoJa1.5                    textBox2.setEnabled(false);
//J211_3005_0107
//2002/08/07 DoJa1.5                    break;
//2002/08/07 DoJa1.5                case 1:
//J211_3005_0108
//2002/08/07 DoJa1.5                    textBox2.setVisible(false);
//2002/08/07 DoJa1.5                    break;
//2002/08/07 DoJa1.5            }
//2002/08/07 DoJa1.5        }
//2002/08/07 DoJa1.5    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
//2002/08/07 DoJa1.5    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
//2002/08/07 DoJa1.5    public void softKeyReleased(int anIndex) {
//2002/08/07 DoJa1.5        if (anIndex == Frame.SOFT_KEY_1) {
//2002/08/07 DoJa1.5            IApplication.getCurrentApp().terminate();
//2002/08/07 DoJa1.5        }
//2002/08/07 DoJa1.5        if (anIndex == Frame.SOFT_KEY_2) {
//2002/08/07 DoJa1.5            Display.setCurrent(previousFrame);
//2002/08/07 DoJa1.5        }
//2002/08/07 DoJa1.5    }
//2002/08/07 DoJa1.5}

/**
 * Sub screen 6 for checking behavior of the TextBox class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel6 extends Panel implements SoftKeyListener, ComponentListener{

    private Frame previousFrame = null;
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Invalid state",
            "2 Invisible state",
    };
    private Button button = new Button("execute");
    private TextBox textBox1 = new TextBox("Check scrolling", 10, 1, TextBox.DISPLAY_ANY);
    private TextBox textBox2 = new TextBox("Check scrolling", 20, 1, TextBox.DISPLAY_ANY);
    private TextBox textBox3 = new TextBox("Check scrolling", 20, 5, TextBox.DISPLAY_ANY);

    /**
     * Constructor of NextPanel 6
     * @param aPrev Object of MainPanel
     */
    public NextPanel6(Frame aPrev) {
        previousFrame = aPrev;
        setLayoutManager(null);

        /* Settings of display items */
        menuList.setItems(menuListItem);
        menuList.setLocation(1,0);
        add(menuList);
        button.setLocation(1,20);
        add(button);

        textBox1.setLocation(1,40);
        add(textBox1);
        textBox2.setLocation(1,60);
        add(textBox2);
        textBox3.setSize(Display.getWidth(),Display.getHeight());
        textBox3.setLocation(1,80);
//J211_3005_0202
        add(textBox3);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == menuList ) {
            textBox2.setEnabled(true);
            textBox2.setVisible(true);
        }

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
//J211_3005_0203
                    textBox2.setEnabled(false);
                    break;
                case 1:
//J211_3005_0204
                    textBox2.setVisible(false);
                    break;
            }
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Sub screen 7 for checking behavior of the TextBox class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 * @implements Runnable
 */
class NextPanel7 extends Panel implements SoftKeyListener, ComponentListener, Runnable{

    private Frame previousFrame = null;
    private Label label = new Label("Check non-display");
    private TextBox textBox = new TextBox("Check non-display", 20, 2, TextBox.DISPLAY_ANY);
    private Button button = new Button(" execute ");

    /**
     * Constructor of NextPanel 7
     * @param aPrev Object of MainPanel
     */
    public NextPanel7(Frame aPrev) {
        previousFrame = aPrev;

        /* Settings of display items */
        setTitle("Check behavior of the class");
        add(label);
        add(button);
        add(textBox);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            Thread t1 = new Thread(this);
            t1.start();
        }

        if ( aType == TEXT_CHANGED ) {
//J211_3007_0201
            Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
            d.setText("Dialog to be displayed");
            d.show();
        }
    }

    public void run() {
        try {
            Thread.sleep(5000);
        } catch ( Exception e ) {}
        textBox.setVisible(false);
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}
