/**
 * J211_3101_0101
 * MainPanel
 * NextPanel1
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J211_3101_0101.java,v 1.1 2002/02/04 07:28:37 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import java.lang.*;

/**
 * Main class for checking behavior of the Ticker class and the class
 * @extends IApplication
 */

public class J211_3101_0101 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the Ticker class and the class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Linefeed code",
            "2 Pictograph in the foreground color ",
            "3 Check both specifications",
            "4 Horizontal > Character",
            "5 Horizontal = Character",
            "6 Horizontal < Character",
            "7 Vertical > Character",
            "8 Vertical = Character",
            "9 Vertical < Character",
            "10 Original character > New character",
            "11 Original character < New character",
            "12 Default layout",
//2002/08/07 DoJa1.5            "13 HTML layout",
            "14 NULL layout",
    };
//J211_3101_0101
    private Ticker ticker1 = new Ticker();
//J211_3101_0102
    private Ticker ticker2 = new Ticker("a");
//J211_3101_0103
//2002/08/07 DoJa1.5    private Ticker ticker3 = new Ticker("a");
//J211_3101_0104
    private Ticker ticker4 = new Ticker("Tickerabcdefgh");
    private Button button = new Button(" execute ");
    private TextBox textBox1 = new TextBox("", 20, 2, TextBox.DISPLAY_ANY);
    private int width, height;

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        /* Settings of display items */
        setTitle("Check behavior of the class");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);

        add(ticker1);
        width = ticker1.getWidth();
        height = ticker1.getHeight();
        add(ticker2);
//2002/08/07 DoJa1.5        add(ticker3);
        add(ticker4);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == menuList ) {
            ticker1.setText("");
        }

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
//J211_3101_0405
                    ticker1.setText("abc\ndef");
                    break;
                case 1:
//J211_3101_0502
                    ticker1.setForeground(Graphics.getColorOfName(Graphics.PURPLE));
                    ticker1.setText("\uE63E\uE653\uE65E\uE678");
                    break;
                case 2:
//J211_3101_0504
                    ticker1.setBackground(Graphics.getColorOfName(Graphics.LIME));
                    ticker1.setForeground(Graphics.getColorOfName(Graphics.PURPLE));
                    ticker1.setText("abcdef");
                    break;
                case 3:
//J211_3102_0201
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this, height, width, height, width, 
                                    menuList.getSelectedIndex()));
                    break;
                case 4:
//J211_3102_0202
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this, height, 60, height, 80, 
                                    menuList.getSelectedIndex()));
                    break;
                case 5:
//J211_3102_0203
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this, height, width, height, width, 
                                    menuList.getSelectedIndex()));
                    break;
                case 6:
//J211_3102_0204
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this, (height*2), width, (height*2),
                                    width, menuList.getSelectedIndex()));
                    break;
                case 7:
//J211_3102_0205
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this, 12, width, 16, width, 
                                    menuList.getSelectedIndex()));
                    break;
                case 8:
//J211_3102_0206
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this, (12-6), width, (16-8), width, 
                                    menuList.getSelectedIndex()));
                    break;
                case 9:
//J211_3102_0301
                    ticker4.setText("ghijk");
                    break;
                case 10:
//J211_3102_0302
                    ticker2.setText("ghijklmn");
                    break;
                case 11:
                    /* Create NextPanel2 */
                    Display.setCurrent(new NextPanel2((Frame) this));
                    break;
//2002/08/07 DoJa1.5                case 12:
                    /* Create NextPanel3 */
//2002/08/07 DoJa1.5                    Display.setCurrent(new NextPanel3((Frame) this));
//2002/08/07 DoJa1.5                    break;
//2002/08/07 DoJa1.5                case 13:
                case 12:
                    /* Create NextPanel4 */
                    Display.setCurrent(new NextPanel4((Frame) this));
                    break;
            }
        }
    }
    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

/**
 * Sub screen 1 for checking behavior of the Ticker class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener  {

    private Frame previousFrame = null;
    private Ticker ticker1 = new Ticker();
    private Ticker ticker2 = new Ticker();
    private Label label = new Label("Check the behavior of the size specification");
    private int width1, height1, width2, height2, selection;

    /**
     * Constructor of NextPanel1
     * @param aPrev Object of MainPanel
     */
    public NextPanel1(Frame aPrev, int aHeight1, int aWidth1, int aHeight2,
                        int aWidth2,  int aSelection) {
        previousFrame = aPrev;
        width1 = aWidth1;
        height1 = aHeight1;
        width2 = aWidth2;
        height2 = aHeight2;
        selection = aSelection;

        /* Settings of display items */
        setTitle("Check behavior of the class");
        add(label);

        test();
        ticker1.setSize(width1,height1);
        ticker2.setSize(width2,height2);
        add(ticker1);
        add(ticker2);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
    }


    public void test(){
        switch( selection ){
            case 3:
                ticker1.setText("a");
                break;
            case 4:
				String strMoji = "aiueo";
				Font font;
				font = Font.getDefaultFont();
				width1 = font.stringWidth(strMoji);
				width2 = font.stringWidth(strMoji);
//2002/09/24 DoJa1.5                ticker1.setText("aiueo");
//2002/09/24 DoJa1.5                ticker2.setText("aiueo");
                ticker1.setText(strMoji);
                ticker2.setText(strMoji);
                break;
            case 5:
                ticker1.setText("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ");
                break;
            case 6:
                ticker1.setText("abcde");
                break;
            case 7:
                ticker1.setText("aiueo");
                ticker2.setText("aiueo");
                break;
            case 8:
                ticker1.setText("aiueo");
                ticker2.setText("aiueo");
                break;
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

/**
 * Sub screen 2 for checking behavior of the Ticker class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel2 extends Panel implements SoftKeyListener, ComponentListener{

    private Frame previousFrame = null;
    private Label label = new Label("Check scrolling of default layout");
    private Button button = new Button("execute");
    private Ticker ticker1 = new Ticker("Check scrolling");
    private Ticker ticker2 = new Ticker("Check scrolling");
    private Ticker ticker3 = new Ticker("Check scrolling");

    /**
     * Constructor of NextPanel2
     * @param aPrev Object of MainPanel
     */
    public NextPanel2(Frame aPrev) {
        previousFrame = aPrev;

        /* Settings of display items */
        add(label);
        add(button);

        add(ticker1);
        add(ticker2);
//J211_3103_0102
        ticker3.setSize(Display.getWidth(),Display.getHeight());
        add(ticker3);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
//J211_3103_0104
            ticker2.setVisible(false);
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}
/*
 * Sub screen 3 for checking behavior of the Ticker class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
//2002/08/07 DoJa1.5class NextPanel3 extends Panel implements SoftKeyListener, ComponentListener{

//2002/08/07 DoJa1.5    private Frame previousFrame = null;
//2002/08/07 DoJa1.5    private Label label = new Label("Check scrolling of HTML layout");
//2002/08/07 DoJa1.5    private HTMLLayout hm = new HTMLLayout();
//2002/08/07 DoJa1.5    private Button button = new Button("execute");
//2002/08/07 DoJa1.5    private Ticker ticker1 = new Ticker("Check scrolling");
//2002/08/07 DoJa1.5    private Ticker ticker2 = new Ticker("Check scrolling");
//2002/08/07 DoJa1.5    private Ticker ticker3 = new Ticker("Check scrolling");

    /**
     * Constructor of NextPanel3
     * @param aPrev Object of MainPanel
     */
//2002/08/07 DoJa1.5    public NextPanel3(Frame aPrev) {
//2002/08/07 DoJa1.5        previousFrame = aPrev;
//2002/08/07 DoJa1.5        setLayoutManager(hm);

        /* Settings of display items */
//2002/08/07 DoJa1.5        hm.begin(HTMLLayout.CENTER);
//2002/08/07 DoJa1.5        add(label);
//2002/08/07 DoJa1.5        hm.br();
//2002/08/07 DoJa1.5        add(button);
//2002/08/07 DoJa1.5        hm.br();

//2002/08/07 DoJa1.5        add(ticker1);
//2002/08/07 DoJa1.5        hm.br();
//2002/08/07 DoJa1.5        add(ticker2);
//2002/08/07 DoJa1.5        hm.br();
//J211_3103_0106
//2002/08/07 DoJa1.5        ticker3.setSize(Display.getWidth(),Display.getHeight());
//2002/08/07 DoJa1.5        add(ticker3);

//2002/08/07 DoJa1.5        setSoftLabel(Frame.SOFT_KEY_1, "exit");
//2002/08/07 DoJa1.5        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
//2002/08/07 DoJa1.5        setSoftKeyListener(this);
//2002/08/07 DoJa1.5        setComponentListener(this);
//2002/08/07 DoJa1.5    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
//2002/08/07 DoJa1.5    public void componentAction(Component aComponent, int aType, int aParam) {

//2002/08/07 DoJa1.5        if ( aComponent == button && aType == BUTTON_PRESSED ) {
//J211_3103_0108
//2002/08/07 DoJa1.5            ticker2.setVisible(false);
//2002/08/07 DoJa1.5        }
//2002/08/07 DoJa1.5    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
//2002/08/07 DoJa1.5    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
//2002/08/07 DoJa1.5    public void softKeyReleased(int anIndex) {
//2002/08/07 DoJa1.5        if (anIndex == Frame.SOFT_KEY_1) {
//2002/08/07 DoJa1.5            IApplication.getCurrentApp().terminate();
//2002/08/07 DoJa1.5        }
//2002/08/07 DoJa1.5        if (anIndex == Frame.SOFT_KEY_2) {
//2002/08/07 DoJa1.5            Display.setCurrent(previousFrame);
//2002/08/07 DoJa1.5        }
//2002/08/07 DoJa1.5    }
//2002/08/07 DoJa1.5}

/*
 * Sub screen 4 for checking behavior of the Ticker class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class NextPanel4 extends Panel implements SoftKeyListener, ComponentListener{

    private Frame previousFrame = null;
    private Label label = new Label("Check scrolling of null layout");
    private Button button = new Button("execute");
    private Ticker ticker1 = new Ticker("Check scrolling");
    private Ticker ticker2 = new Ticker("Check scrolling");
    private Ticker ticker3 = new Ticker("Check scrolling");

    /**
     * Constructor of NextPanel4
     * @param aPrev Object of MainPanel
     */
    public NextPanel4(Frame aPrev) {
        previousFrame = aPrev;
        setLayoutManager(null);

        /* Settings of display items */
        label.setLocation(1,0);
        add(label);
        button.setLocation(1,20);
        add(button);

        ticker1.setLocation(1,40);
        add(ticker1);
        ticker2.setLocation(1,60);
        add(ticker2);
//J211_3103_0202
        ticker3.setSize(Display.getWidth(),Display.getHeight());
        ticker3.setLocation(1,80);
        add(ticker3);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
//J211_3103_0204
            ticker2.setVisible(false);
        }
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

