/**
 * J212_0202_0101.java
 * 
 * J212_0202_0101
 * MenuPanel
 * 
 * Class's operational test
 * 
 * $Id: J212_0202_0101.java,v 1.1 2002/02/05 12:02:39 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Main class for Button of the UI boundary
 * @extends IApplication
 */
public class J212_0202_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for checking Button of the UI boundary
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    Label            subTitle      = null;  /* Sub title */
    Button           execButton    = null;  /* execute button */
    TextBox          resultText    = null;  /* Text box for displaying the result */
    boolean          okFlag        = false; /* Flag for determination of test result */
    int              menu1Index    = 0;
	
    TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
    String text;
    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("UI boundary operations");

        /* Create and add components */
        subTitle       = new Label("Button");
       
        execButton     = new Button("execute");
        add(subTitle);
        add(textBox1);
        add(execButton);

     
        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        if (aAction == ComponentListener.BUTTON_PRESSED) {
          
    	/* Transit to Panel for checking behavior */
        
    	 Display.setCurrent(new TestPanel(textBox1.getText(), this));
                /* test the menu which is choiced */
               
            }
        }
    }


/**
 * Confirmation screen for behavior of Button of the UI boundary
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class TestPanel extends Panel implements SoftKeyListener, ComponentListener {
    Frame        previousFrame    = null;  /* Store the previous screen */
    int          menu1Index       = 0;     /* Index of the menu of previous screen */
    Label        subTitle         = null;  /* Sub title */
    Button       testButton1      = null;
    Button       testButton2      = null;
    Button       testButton3      = null;
   String text;
    /**
     * Constructor of TestPanel class
     * @param  menu1Index  Index of menu1
     * @param  aFrame      Previous screen
     */
    TestPanel(String str, Frame aFrame) {
        previousFrame = aFrame;

        try {
            showTestPanel();
            test(str);
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Panel for checking operations
     */
 void showTestPanel() {

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
 	 	

    
    }

    /**
     * The method of confirming operations
     * @param  menu1Index  Index of menu1 of menu screen
     * @param  menu2Index  Index of menu2 of menu screen
     * @param  menu3Index  Index of Menu 3 of menu screen
     */
 public   void test(String text) {
       

// J212_0201_0201

        /* Display operations */
       
            /* Display title/sub title */
            setTitle("UI boundary operations");
            subTitle = new Label("");
            add(subTitle);
            subTitle.setText("Display operations");
            subTitle.setSize(getWidth(), subTitle.getHeight());

            testButton1 = new Button(text);

            add(testButton1);
         
           
// J212_0201_0301
        
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application if soft key1 is released
     * Transit to the whole screen in the event of soft key2
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(
        Component aComponent, int aAction, int aParam) {}
}