
/**
 * J212_0501_0101.java
 * 
 * J212_0501_0101
 * MenuPanel
 * TestPanel
 * 
 * Class's operational test(Graphics)
 * 
 * $Id: J212_0501_0101.java,v 1.1 2002/02/01 06:35:14 hoshi Exp $
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.lang.*;

/**
 * Main class for class's operational test (Graphics)
 * @extends IApplication
 */
public class J212_0501_0101 extends IApplication {

    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * Menu screen for class's operational (Graphics) test
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {

    ListBox menu1 = null;                    /* Process selection menu */
    Button execButton = null;                /* execute button */
    int index = 0;

    /* Items in process selection menu(menu1menu2) */
    String[] menu1Item = {
//2002/08/06 Do_Ja1.5        "0. Test 1",
        "1.Test 2",
        "2.Test 3",
        "3.Test 4",
    };

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.getMessage());
        } catch(Error e) {
            showMsg(e.getMessage());
        }
    }

    /**
     * Display menu screen
     */
    public void showMainPanel() {
        /* Display title/sub title */
        setTitle("Class behavior's test");
        Label subTitle = new Label("Graphics");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Add creation of components */
        menu1 = new ListBox(ListBox.CHOICE, 4);
        execButton = new Button("execute");
        menu1.setItems(menu1Item);
        add(menu1);
        add(execButton);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "msg");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }


    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* When execute button is pressed store menu index into a variable and evoke a method for checking behavior*/
        if ( aType == ComponentListener.BUTTON_PRESSED ) {
            try {
                int menu1Index = menu1.getSelectedIndex();
                Display.setCurrent(new testCanvas(menu1Index, this));
            } catch(Exception e) {
                showMsg(e.toString());
            } catch (Error e) {
                showMsg(e.toString());
            }
        }
    }
}

/**
 * Confirmation screen class
 * @extends Canvas
 */
class testCanvas extends Canvas {

    /* Variable in order to return to the previous screen */
    Frame previousFrame = null;

    int index;
    Graphics g1;
    Graphics g2;
    Graphics g3;
    Graphics g4;
    Graphics g5;
    Graphics g6;
    Graphics g7;
    Graphics g8;
    Graphics g9;
    Image img;
    Image img2;
    MediaImage mi;
    ImageLabel il;
    int flg;

    /* Creation of message dialog (error/Information) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * Constructor of testCanvas class
     * @param aType  Location of items of Menu
     * @param aFrame  Screen
     */
    public testCanvas(int aType, Frame aFrame) {

        /* Assign the previous screen */
        previousFrame = aFrame;
        index = aType;
        
        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

    }

    /**
     * test method
     */
     void test() {
        switch (index) {
//J212_0501_0101
//2002/08/06 Do_Ja1.5            case 0:
//2002/08/06 Do_Ja1.5                img = Image.createImage(getWidth(), getHeight());
//2002/08/06 Do_Ja1.5                try {
//2002/08/06 Do_Ja1.5                    g1 = img.getGraphics();
//2002/08/06 Do_Ja1.5                    g2 = img.getGraphics();
//2002/08/06 Do_Ja1.5                    g3 = img.getGraphics();
//2002/08/06 Do_Ja1.5                    g4 = img.getGraphics();
//2002/08/06 Do_Ja1.5                    g5 = img.getGraphics();
//2002/08/06 Do_Ja1.5                    g6 = img.getGraphics();
//2002/08/06 Do_Ja1.5                    g7 = img.getGraphics();
//2002/08/06 Do_Ja1.5                    g8 = img.getGraphics();

//2002/08/06 Do_Ja1.5                    info.setText("OK");
//2002/08/06 Do_Ja1.5                    info.show();
//2002/08/06 Do_Ja1.5                } catch (Exception e) {
//2002/08/06 Do_Ja1.5                    err.setText("NG : " + e.toString());
//2002/08/06 Do_Ja1.5                    err.show();
//2002/08/06 Do_Ja1.5                }
//2002/08/06 Do_Ja1.5                break;
//J212_0501_0102
//2002/08/06 Do_Ja1.5            case 1:
            case 0:
                try {
                    g1 = getGraphics();
                    g2 = getGraphics();
                    g3 = getGraphics();
                    g4 = getGraphics();
                    g5 = getGraphics();
                    g6 = getGraphics();
                    g7 = getGraphics();
                    g8 = getGraphics();

                    info.setText("OK");
                    info.show();
                } catch (Exception e) {
                    err.setText("NG : " + e.toString());
                    err.show();
                }
                break;
//J212_0501_0103
//2002/08/06 Do_Ja1.5            case 2:
            case 1:
                CanvasClass1 cc1  = new CanvasClass1();
                CanvasClass2 cc2  = new CanvasClass2();
                CanvasClass3 cc3  = new CanvasClass3();
                CanvasClass4 cc4  = new CanvasClass4();
                CanvasClass5 cc5  = new CanvasClass5();
                CanvasClass6 cc6  = new CanvasClass6();
                CanvasClass7 cc7  = new CanvasClass7();
                CanvasClass8 cc8  = new CanvasClass8();

                try {
                    g1 = cc1.getGraphics();
                    g2 = cc2.getGraphics();
                    g3 = cc3.getGraphics();
                    g4 = cc4.getGraphics();
                    g5 = cc5.getGraphics();
                    g6 = cc6.getGraphics();
                    g7 = cc7.getGraphics();
                    g8 = cc8.getGraphics();

                    info.setText("OK");
                    info.show();
                } catch (Exception e) {
                    err.setText("NG : " + e.toString());
                    err.show();
                }
                flg = 1;
                repaint();
                break;
//J212_0501_0104
//2002/08/06 Do_Ja1.5            case 3:
            case 2:
                try {
                    g1 = getGraphics();
                    g2 = getGraphics();
                    g3 = getGraphics();
                    g4 = getGraphics();
                    g5 = getGraphics();
                    g6 = getGraphics();
                    g7 = getGraphics();
                    g8 = getGraphics();
                    g9 = getGraphics();

                    info.setText("OK");
                    info.show();
                } catch (Exception e) {
                    err.setText("NG : " + e.toString());
                    err.show();
                }
                break;
        }
    }

    /**
     * Screen depiction
     */
    public void paint(Graphics g) {

        g.lock();
        int y = 45;
        int x = 0;
        g.drawString("Check behavior of the class",0,10);
        g.drawLine(0,15,getWidth(),15);
        g.drawString("Press Enter key",0,30);

        switch (index) {
            case 0:
                break;
            case 1:

                break;
            case 2:
                break;
            case 3:
                break;
        }
        g.unlock(true);
    }

    /**
     * Define the behavior in the case key being pressed
     * @param aSoftKey  Type of soft key
     */
    public void processEvent(int type,int param) {
        if(type == Display.KEY_RELEASED_EVENT) {
            switch(param) {
                case Display.KEY_SOFT1:
                    IApplication.getCurrentApp().terminate();
                    break;
                case Display.KEY_SOFT2:
                    if(previousFrame != null) {
                        Display.setCurrent(previousFrame);
                    }
                    break;
                case Display.KEY_SELECT:
                    test();
                    break;
                default:
            }
        }
    }
}

/**
 * Canvas class1
 * @extends Canvas
 */
class CanvasClass1 extends Canvas {

    /**
     * Constructor of CanvasClass1 class
     */
    public CanvasClass1() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}

/**
 * Canvas class2
 * @extends Canvas
 */
class CanvasClass2 extends Canvas {

    /**
     * Constructor of CanvasClass2 class
     */
    public CanvasClass2() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}

/**
 * Canvas class3
 * @extends Canvas
 */
class CanvasClass3 extends Canvas {

    /**
     * Constructor of CanvasClass3 class
     */
    public CanvasClass3() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}

/**
 * Canvas class4
 * @extends Canvas
 */
class CanvasClass4 extends Canvas {

    /**
     * Constructor of CanvasClass4 class
     */
    public CanvasClass4() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}

/**
 * Canvas class5
 * @extends Canvas
 */
class CanvasClass5 extends Canvas {

    /**
     * Constructor of CanvasClass5 class
     */
    public CanvasClass5() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}

/**
 * Canvas class6
 * @extends Canvas
 */
class CanvasClass6 extends Canvas {

    /**
     * Constructor of CanvasClass6 class
     */
    public CanvasClass6() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}

/**
 * Canvas class7
 * @extends Canvas
 */
class CanvasClass7 extends Canvas {

    /**
     * Constructor of CanvasClass7 class
     */
    public CanvasClass7() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}

/**
 * Canvas class8
 * @extends Canvas
 */
class CanvasClass8 extends Canvas {

    /**
     * Constructor of CanvasClass8 class
     */
    public CanvasClass8() {}

    /**
     * Drawing method
     */
    public void paint(Graphics g) {}
}