/**
 * J212_0802_0201
 * UI boundary operations
 * Check behavior of the Label display - Check behavior for maximum-exceeding setting
 *
 * $Id: J212_0802_0201.java,v 1.1 2002/02/01 07:15:42 uruno Exp $
 */
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;

/**
 * UI boundary operations
 * Check behavior of the Label display - Check behavior for maximum-exceeding setting
 * @extends IApplication
 */
public class J212_0802_0201 extends IApplication {

    static MainPanel mainPanel;

    /**
     * Overview of functions  :Startup method of i-appli
     */
    public void start() {
        mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * UI boundary operations
 * Check behavior of the Label display - Check behavior for maximum-exceeding setting
 * Main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    /* Menu, Selection of display type */
   TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
   // String text;
    Label classLabel = new Label();
    Button  execButton = new Button("execute");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    void showMainPanel() {

        /* Settings of display items */
        classLabel.setText("Behavior of the label exceeding the maximum");
        setTitle("UI boundary operations");
      
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Add each component to screen */
        add(classLabel);
        add(textBox1);
        add(execButton);

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* In the case execute button is pressed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {

           // int testType = menuList.getSelectedIndex();
            Display.setCurrent(new SubPanel(textBox1.getText()));
        }
    }
}

/**
 * UI boundary operations
 * Check behavior of the Label display - Check behavior for maximum-exceeding setting
 * Sub screen
 * @extends Panel
 * @implements SoftKeyListener
 */
class SubPanel extends Panel implements SoftKeyListener {

    Frame prevFrame;
   // int testType;
    Label classLabel = new Label("");
    String text;

    /**
     * Display a sub screen
     * @param anInt    Sub division of test
     * @param aFrame  Main screen object
     */
    public SubPanel(String text) {

        /* Object name setting */
      //  prevFrame = aFrame;
        //testType = text;
        
        try {
            /* Display sub panels */
            ShowSubPanel(text);
        
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

 public void ShowSubPanel(String text) {

        /* Create a label for each item */
      
                /* Set 30 of one byte characters to the Label */
                classLabel.setText(text);
        	
             

//J212_0802_0202
//2002/08/07 Do_Ja1.5            case 1:
                /* Set the 16th character and after of Label to Japanese two byte characters */
//2002/08/07 Do_Ja1.5                classLabel.setText("123456789012345678901234567890");
//2002/08/07 Do_Ja1.5                break;

           

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Add each component to screen */
        setTitle("UI boundary operations");
        add(classLabel);
        //add(resultText);

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /**
     * When soft key is pressed, it does not operate
     * @param anIndex  The value of the soft key pressed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * When soft key1 is released, the application ends
     * @param anIndex  The value of released soft key
     */
    public void softKeyReleased(int anIndex) {

        /* When soft key is released, the application ends */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }

        /* When soft key2 is released, return to the main screen */
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(J212_0802_0201.mainPanel);
        }
    }
}
