/**
 * J212_1101_0102
 * MainPanel
 *
 * Class operations(ShortTimer)
 *
 *
 * $Id:
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;
import java.lang.*;

/**
 * Class for checking behavior of the boundary UI (ShortTimer)
 * @extends IApplication
 */

public class J212_1101_0102 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainCanvas());
    }
}

/**
 * Main class for checking behavior of the class (ShortTimer)
 * @extends Canvas
 */
class MainCanvas extends Canvas {

    TestCanvas tc = new TestCanvas();

    /**
     * Constructor of MainCanvas
     */
    MainCanvas() {

        setSoftLabel(Frame.SOFT_KEY_1, "Start");
        setSoftLabel(Frame.SOFT_KEY_2, "exit");
    }

    /**
     * implement the paint() method
     * @param g  Graphics object of Canvas
     */
    public void paint(Graphics g){
        g.clearRect(0,0,getWidth(), getHeight());
        g.drawString("Press Start soft key", 5, 20);
    }


    /**
     * Event acceptance method
     * @param type  Event type
     * @param param  parameter of an event
     */
    public void processEvent(int aType, int aParam) {
        if ( aType == Display.KEY_RELEASED_EVENT ) {
            switch ( aParam ) {
                case Display.KEY_SOFT1:
                    Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
                    boolean flag = tc.test();
                    if ( flag == true ) {
                        d.setText("Another Canvas OK");
                    } else {
                        d.setText("Another Canvas NG");
                    }
                    d.show();
                    break;
                /* When End is pressed */
                case Display.KEY_SOFT2:
                    /* Return to Main menu screen */
                    IApplication.getCurrentApp().terminate();
                    break;
            }
        }
    }
}

/**
 * Class for checking the change over of the Canvas (ShortTimer)
 * @extends Canvas
 */
class TestCanvas extends Canvas {
    private ShortTimer[] st = new ShortTimer[5];

    /**
     * Test method
     */
    public boolean test() {
        for ( int i = 0; i < 5; i++ ) {
//J212_1101_0102
            st[i] = st[i].getShortTimer(this,i,1000,true);
            st[i].start();
        }
        return(true);
    }

    /**
     * implement the paint() method
     * @param g  Graphics object of Canvas
     */
    public void paint(Graphics g){
        g.clearRect(0,0,getWidth(), getHeight());
        g.drawString("Return to the previous screen", 5, 20);
    }
}
