/**
 * J212_1101_0103
 * MainPanel
 *
 * Class operations(ShortTimer)
 *
 *
 * $Id:
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;
import java.lang.*;

/**
 * Class for checking behavior of the boundary UI (ShortTimer)
 * @extends IApplication
 */

public class J212_1101_0103 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainCanvas());
    }
}

/**
 * Main class for checking behavior of the class (ShortTimer)
 * @extends Canvas
 */
class MainCanvas extends Canvas {

    private ShortTimer st;
    private int count = 0;

    /**
     * Constructor of MainCanvas
     */
    MainCanvas() {


        setSoftLabel(Frame.SOFT_KEY_1, "Start");
        setSoftLabel(Frame.SOFT_KEY_2, "exit");
    }

    /**
     * implement the paint() method
     * @param g  Graphics object of Canvas
     */
    public void paint(Graphics g){
        g.clearRect(0,0,getWidth(), getHeight());
        g.drawString("Press Start soft key", 5, 20);
        g.drawString("Count: "+(count), 10, 40);
    }

    /**
     * Event acceptance method
     * @param type  Event type
     * @param param  parameter of an event
     */
    public void processEvent(int aType, int aParam) {

        if ( aType == Display.TIMER_EXPIRED_EVENT ) {
            count++;
            repaint();
        }

        if ( aType == Display.KEY_RELEASED_EVENT ) {
            switch ( aParam ) {
                case Display.KEY_SOFT1:
                    st = st.getShortTimer(this,0,1000,true);
                    st.start();
                    break;

                /* When End is pressed */
                case Display.KEY_SOFT2:
                    /* Return to Main menu screen */
                    IApplication.getCurrentApp().terminate();
                    break;
                
                case Display.KEY_0:
                    st.dispose();
                    try {
//J212_1101_0103
                        st = st.getShortTimer(this,0,1000,true);
                        count = 0;
                        st.start();
                    } catch ( Exception e ) {
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
                        errDialog.setText("Error:" + e.toString());
                        errDialog.show();
                    }
            }
        }
    }
}