/**
 * J212_1101_0104
 * MainPanel
 *
 * Class operations(ShortTimer)
 *
 *
 * $Id:
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;
import java.lang.*;

/**
 * Class for checking behavior of the boundary UI (ShortTimer)
 * @extends IApplication
 */

public class J212_1101_0104 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainCanvas());
    }
}

/**
 * Main class for checking behavior of the class (ShortTimer)
 * @extends Canvas
 */
class MainCanvas extends Canvas {

    private ShortTimer[] st = new ShortTimer[6];
    private int count = 0;
    private int count2 = 0;
    private boolean flag = false;

    /**
     * Constructor of MainCanvas
     */
    MainCanvas() {


        setSoftLabel(Frame.SOFT_KEY_1, "Start");
        setSoftLabel(Frame.SOFT_KEY_2, "exit");
    }

    /**
     * implement the paint() method
     * @param g  Graphics object of Canvas
     */
    public void paint(Graphics g){
        g.clearRect(0,0,getWidth(), getHeight());
        g.drawString("Press Start soft key", 5, 20);
        g.drawString("Count: "+(count), 5, 40);
        g.drawString("Count: "+(count2), 5, 60);
    }

    /**
     * Event acceptance method
     * @param type  Event type
     * @param param  parameter of an event
     */
    public void processEvent(int aType, int aParam) {

        if ( aType == Display.TIMER_EXPIRED_EVENT ) {
            if ( flag == true ) {
                count2++;
            } else {
                count++;
            }
            repaint();
        }

        if ( aType == Display.KEY_RELEASED_EVENT ) {
            switch ( aParam ) {
                case Display.KEY_SOFT1:
                for ( int i = 0; i < 5; i++ ) {
                    st[i] = st[i].getShortTimer(this,i,1000,true);
                    st[i].start();
                }
                break;

                /* When End is pressed */
                case Display.KEY_SOFT2:
                    /* Return to Main menu screen */
                    IApplication.getCurrentApp().terminate();
                    break;
                
                case Display.KEY_0:
                    try {
                        st[5] = st[5].getShortTimer(this,6,1000,true);
                        st[5].start();
                        flag = true;
//J212_1101_0104
                    } catch ( UIException uie ) {
                        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
                        d.setText("UIException:OK");
                        d.show();
                    } catch ( Exception e ) {
                        Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
                        errDialog.setText("Error:" + e.toString());
                        errDialog.show();
                    }
                    break;
            }
        }
    }
}

   