/**
 * J212_1202_0102
 * MainPanel
 *
 * Check behavior of TextBox class (behavior of UI boundary)
 *
 * $Id: J212_1202_0102.java,v 1.3 2002/04/11 04:21:37 takanao Exp $
 */

import com.nttdocomo.ui.*;
import java.lang.*;

/**
 * Main class for checking behavior of the TextBox class and the class
 * @extends IApplication
 */

public class J212_1202_0102 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the TextBox class and the class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
   	TextBox textBox2 = new TextBox("TextBox", 20, 1, TextBox.DISPLAY_ANY);
	String text = new String("");
	String Str = new String("");

    private Button button = new Button(" execute ");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        
        /* Settings of display items */
        setTitle("Class operation UI boundary");
      
        add(textBox1);
        add(button);
        add(textBox2);

    	
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
           
				   text = textBox1.getText();
                   textBox2.setSize(255,255);
			       for ( int i = 0; i < 48; i++ ) {
						Str += text;
			       }
			       	textBox2.setText(Str);
            }
        }
 

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Call the addResult method when soft key2 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Add output to the textBox[0]
     * @param aMessage Output character strings
     */
    public void addResult(String aMessage) {
//J212_1202_0105
       // textBox[0].setText(textBox[0].getText()+aMessage);
    }
}

