/**
 * J212_1301_0101
 * MainPanel
 * NextPanel1
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J212_1301_0101.java,v 1.1 2002/02/04 07:28:45 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import java.lang.*;

/**
 * Main class for checking behavior of the Ticker class and the class
 * @extends IApplication
 */

public class J212_1301_0101 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the Ticker class and the class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 11pieces",
           
//2002/08/07 Do_Ja1.5            "3 Displayed two byte characters"
    };
    private Ticker[] ticker = new Ticker[10];
    private Button button = new Button(" execute ");

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        
        /* Settings of display items */
        setTitle("Class operation UI boundary");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);

        for ( int i = 0; i < 10; i++ ) {
//J212_1301_0101
            ticker[i] = new Ticker("ticker"+(i+1));
            add(ticker[i]);
        }

        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    /* Create NextPanel1 */
                    Display.setCurrent(new NextPanel1((Frame) this));
                    break;
                
            }
        }
    }


    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

   
/**
 * Sub screen 1 for checking behavior of the Ticker class
 * @extends Panel
 * @implements SoftKeyListener
 */
class NextPanel1 extends Panel implements SoftKeyListener{

    private Frame previousFrame = null;
    private Ticker[] ticker = new Ticker[11];

    /**
     * Constructor of NextPanel1
     * @param aPrev Object of MainPanel
     */
    public NextPanel1(Frame aPrev) {
        previousFrame = aPrev;

        /* Settings of display items */
        setTitle("Class operation UI boundary");

//J212_1301_0102
        for ( int i = 0; i < 11; i++ ) {
            ticker[i] = new Ticker("ticker"+(i+1));
            add(ticker[i]);
        }

        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setSoftLabel(Frame.SOFT_KEY_2, "back");

        /* Listener setting */
        setSoftKeyListener(this);
    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * Return to the previous screen when soft key2 is released.
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (anIndex == Frame.SOFT_KEY_2) {
            Display.setCurrent(previousFrame);
        }
    }
}

