/**
 * J212_1302_0103
 * MainPanel
 * NextPanel1
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J212_1302_0103.java,v 1.1 2002/02/04 07:28:45 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import java.lang.*;

/**
 * Main class for checking behavior of the Ticker class and the class
 * @extends IApplication
 */

public class J212_1302_0103 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the Ticker class and the class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
   
	TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);

	private Ticker[] ticker = new Ticker[1];
	String text = new String("");
	String Str = new String("");
	 private Button button = new Button(" execute ");

	/**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        
        /* Settings of display items */
        setTitle("Class operation UI boundary");
        add(textBox1);
        add(button);
    	add(ticker1);
    	setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

        Ticker ticker1 = new Ticker("");
           
    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
           	
        	    text = textBox1.getText();
        	 for ( int i = 0; i < 32; i++ ) {
					Str += text;
        			ticker1.setText(text);
                   
            }
        		ticker1.setText(Str);       	
        }
    }



    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}

