/**
 * J212_1501_0101
 * MainPanel
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J212_1501_0101.java,v 1.1 2002/02/04 07:28:46 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.util.*;
import java.lang.*;

/**
 * Main class for checking behavior of the Timer class and the class
 * @extends IApplication
 */

public class J212_1501_0101 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the Timer class and class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener{

    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Create 5",
            "2 Create 6"
    };
    private Timer[] timer = new Timer[6];
    static final int TIMER_INTERVAL = 5000;
    private Label[] label = new Label[6];
    private int[] timerCounter = {0,0,0,0,0,0};
    private Button button = new Button("execute");
    private Button button1 = new Button("Suspend the Timer");

    /*
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        /* Setting of the displayed items */
        setTitle("Behavior of the class");
        menuList.setItems(menuListItem);
        add(menuList);

        add(button);
        add(button1);
        
        for ( int i = 0; i < 6; i++ ){
            label[i] = new Label(" TimerCounter:0");
            add(label[i]);
        }
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);

    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button1 && aType == BUTTON_PRESSED ) {
            for ( int i = 0; i < 6; i++ ){
                try {
                    timer[i].stop();
                }catch( Exception e ){}
            }
        }

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    for(int j=0; j<5; j++) {
//J212_1501_0101
                        timer[j] = new Timer();
                        timer[j].setTime(TIMER_INTERVAL);
                        timer[j].setRepeat(true);
                        timer[j].setListener(new TimerListener() {
                            public void timerExpired(Timer t) {
                                if ( t == timer[0] ) {
                                    timerCounter[0]++;
                                    label[0].setText(" TimerCounter:"+timerCounter[0]);
                                } else if ( t == timer[1] ) {
                                    timerCounter[1]++;
                                    label[1].setText(" TimerCounter:"+timerCounter[1]);
                                } else if ( t == timer[2] ) {
                                    timerCounter[2]++;
                                    label[2].setText(" TimerCounter:"+timerCounter[2]);
                                } else if ( t == timer[3] ) {
                                    timerCounter[3]++;
                                    label[3].setText(" TimerCounter:"+timerCounter[3]);
                                } else if ( t == timer[4] ) {
                                    timerCounter[4]++;
                                    label[4].setText(" TimerCounter:"+timerCounter[4]);
                                } else if ( t == timer[5] ) {
                                    timerCounter[5]++;
                                    label[5].setText(" TimerCounter:"+timerCounter[5]);
                                } 
                            }
                        });
                        timer[j].start();
                    }
                    break;
                case 1:
                    timer[0].stop();
//J212_1501_0102
                    timer[5] = new Timer();
                    timer[5].setTime(TIMER_INTERVAL);
                    timer[5].setRepeat(true);
                    timer[5].setListener(new TimerListener() {
                        public void timerExpired(Timer t) {
                            if ( t == timer[5] ) {
                                timerCounter[5]++;
                                label[5].setText(" TimerCounter:"+timerCounter[5]);
                            } 
                        }
                    });
                    timer[5].start();
                    break;
            }
        }
    }


    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}