/**
 * J212_1502_0101
 * MainPanel
 *
 * Check behavior of the class(Class operations)
 *
 * $Id: J212_1502_0101.java,v 1.1 2002/02/04 07:28:46 t_yaeda Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.util.*;
import java.lang.*;
import java.util.*;

/**
 * Main class for checking behavior of the Timer class and the class
 * @extends IApplication
 */

public class J212_1502_0101 extends IApplication {
    
    /**
     * Appli startup method
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Main screen for checking behavior of the Timer class and class
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener{

    private ListBox menuList = new ListBox(ListBox.CHOICE);
    private  String[] menuListItem = {
            "1 Create the boundary",
            "2 Not-started start"
    };
    private Button button = new Button(" execute ");
    private Vector v = new Vector();
    private Timer timer;
    private Label label = new Label("");

    /*
     * Constructor of MainPanel class
     */
    public MainPanel() {
        try {
            /* Main panel display */
            showMainPanel();
        } catch (Exception e) {
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR, "Error");
            errDialog.setText("Error:" + e.toString());
            errDialog.show();
        }
    }

    /**
     * Display a main panel
     */
    public void showMainPanel() {

        /* Setting of the displayed items */
        setTitle("Behavior of the class");
        menuList.setItems(menuListItem);
        add(menuList);
        add(button);
        add(label);

        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);

    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if ( aComponent == button && aType == BUTTON_PRESSED ) {
            switch(menuList.getSelectedIndex()){
                case 0:
                    try {
                        label.setText("Timer being created...");
                        while(true){
                            timer = new Timer();
                            timer.start();
                            v.addElement(timer);
                        }
                    } catch ( OutOfMemoryError oome ) {
                        showDialog("Test not available");
                    } catch ( UIException uie ) {
                        if ( uie.getStatus() == UIException.NO_RESOURCES ) {
                            try {
                                label.setText("Implement test");
//J212_1502_0101
                                timer = new Timer();
                                showDialog("OK");
                            } catch ( Exception e ) {
                                showDialog(e.toString());
                            }
                        } else {
                            showDialog("UIException:"+uie.getStatus());
                        }
                    } catch ( Exception e ) {
                        showDialog(e.toString());
                    }
                    break;
                case 1:
                    try {
                        label.setText("Timer being created...");
                        while(true){
                            timer = new Timer();
                            timer.start();
                            v.addElement(timer);
//2002/08/07 Do_Ja1.5                            timer.start();
                        }
                    } catch ( OutOfMemoryError oome ) {
                        showDialog("Test not available");
                    } catch ( UIException uie ) {
                        if ( uie.getStatus() == UIException.NO_RESOURCES ) {
                            try {
                                label.setText("Implement test");
                                timer = (Timer)v.lastElement();
                                timer.stop();
                                timer = new Timer();
//J212_1502_0102
                                timer.start();
                                showDialog("OK");
                            } catch ( Exception e ) {
                                showDialog(e.toString());
                            }
                        } else {
                            showDialog("UIException:"+uie.getStatus());
                        }
                    } catch ( Exception e ) {
                        showDialog(e.toString());
                    }
                    break;
            }
        }
    }

    /**
     * Dialog display method
     * @param str  String to display
     */
    public void showDialog(String str) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(str);
        d.show();
    }


    /**
     * When soft key is pressed, do not carry out any operations.
     * @param anIndex Key index
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * Terminate appli when soft key1 is released
     * @param anIndex Key index
     */
    public void softKeyReleased(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
}


