/**
 * J221_0101_0701
 *
 * Behavior of deletion of application
 *
 * $Id: J221_0101_0701.java,v 1.1 2001/12/29 01:45:19 takanao Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class for checking deletion of applications
 * @extends IApplication
 */

public class J221_0101_0701 extends IApplication {

    MainPanel testPanel = new MainPanel();

    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(testPanel);
    }
}

/**
 * Menu screen for checking deletion of application
 * @extends Panel
 * @implements SoftKeyListener
 */
class MainPanel extends Panel implements SoftKeyListener {

    /* Definition of GUI components */
    TextBox resultBox = new TextBox(null, 16, 16, TextBox.DISPLAY_ANY);

    /**
     * Create panel (Constructor of Panel)
     */
    public MainPanel() {

        /* GUI settings */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setTitle("Operation of deleting application");
        resultBox.setText("Behavior of this application itself has no direct association with the test");

        /* GUI location */
        add(resultBox);

        /* Listener setting */
        this.setSoftKeyListener(this);
    }

    /** 
     * Soft key handler
     * @param aKey Pressed key
     */
    public void softKeyPressed(int aKey) {}

    /** 
     * Soft key handler
     * @param aKey Released key
     */
    public void softKeyReleased(int aKey) {
        /* When soft key1 is released, end the application */
        if (aKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

}
