/**
 * J221_0103_0101
 *
 * For display of AppTrace contents
 *
 * $Id: J221_0103_0101.java,v 1.1 2001/12/29 01:45:20 takanao Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Appli to display AppTrace
 * @extends MApplication
 */

public class J221_0103_0101 extends IApplication {

    MainPanel testPanel = new MainPanel();

    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(testPanel);
    }

}

/**
 * Menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuItem = {
        "00 Exception thrown",
        "01 Check the output",
        "02 Output 512 bytes",
    };


    /* Definition of GUI components */
    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button  processButton = new Button("execute");
    TextBox resultBox = new TextBox(null, 16, 16, TextBox.DISPLAY_ANY);

    /**
     * Create panel (Constructor of Panel)
     */
    public MainPanel() {

        /* GUI settings */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setTitle("Check the contents of the AppTrace");
        menuList.setItems(menuItem);

        /* GUI location */
        add(menuList);
        add(processButton);
        add(resultBox);

        /* Listener setting */
        this.setSoftKeyListener(this);
        this.setComponentListener(this);
    }

    /**
     * Soft key handler
     * @param aKey Pressed soft key
     **/
    public void softKeyPressed(int aKey) {}

    /**
     * Soft key handler
     * @param aKey Released soft key
     **/
    public void softKeyReleased(int aKey) {
        /* When soft key1 is released, end the application */
        if (aKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
    
    /** 
     * Component event handler
     * @param aComponent Component of event occurrence
     * @param aType Event type
     * @param aParam Event parameter
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aType == ComponentListener.BUTTON_PRESSED && aComponent == processButton) {
            int selectedIndex = menuList.getSelectedIndex();
            if (selectedIndex >= 0) {
                doTest(selectedIndex);
            }
        }
    }

    /**
     * Test method
     * @param aTest Test number
     */
    public void doTest(int aTest) {
        switch (aTest) {
        // J221_0103_0101
        case 0:
            int[] illegalArray = new int[10];
            illegalArray[-1] = 0;
            break;
        // J221_0103_0201
        case 1:
            System.out.println("Standard output: OK");
            System.err.println("Error output: OK");
            IApplication.getCurrentApp().terminate();
            break;
        // J221_0103_0204
        case 2:
            System.out.print("S");
            for (int i=1; i<511; i++) {
                System.out.print(i%10);
            }
            System.out.print("E");
            IApplication.getCurrentApp().terminate();
            break;
        }
    }
}
