/**
 * J221_0203_0403
 *
 * For checking cgi parameters
 *
 * $Id: J221_0203_0403.java,v 1.1 2001/12/29 01:45:25 takanao Exp $
 */

import com.nttdocomo.ui.*;

/**
 * Main class for checking cgi parameters
 * @extends IApplication
 */

public class J221_0203_0403 extends IApplication {

    MainPanel testPanel = new MainPanel();

    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(testPanel);
    }
}

/**
 * Appli menu screen
 * @extends Panel
 * @implements SoftKeyListener
 */
class MainPanel extends Panel implements SoftKeyListener {

    /* Definition of GUI components */
    TextBox resultBox = new TextBox(null, 16, 16, TextBox.DISPLAY_ANY);

    /**
     * Create panel (Constructor of Panel)
     */
    public MainPanel() {

        /* GUI settings */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setTitle("Behavior to check the cgi parameter");

        /* GUI location */
        add(resultBox);

        /* Listener setting */
        this.setSoftKeyListener(this);

        // J221_0203_0404
        String[] AppliArgs = IApplication.getCurrentApp().getArgs();
        String cgiParam = "";
        for (int i=0; i<AppliArgs.length; i++) {
            cgiParam = cgiParam + AppliArgs[i];
        }
        resultBox.setText(cgiParam);
    }

    /** 
     * Soft key handler
     * @param aKey Pressed key
     */
    public void softKeyPressed(int aKey) {}

    /** 
     * Soft key handler
     * @param aKey Released key
     */
    public void softKeyReleased(int aKey) {
        /* When soft key1 is released, end the application */
        if (aKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

}
