/**
 * J221_0205_0102
 *
 * 30K Jar
 *
 * $Id: J221_0205_0102.java,v 1.1 2001/12/29 01:45:28 takanao Exp $
 */

import java.util.Hashtable;
import com.nttdocomo.ui.*;

/**
 * 30K Jar
 * @extends IApplication
 */

public class J221_0205_0102 extends IApplication {

    MainPanel testPanel = new MainPanel();

    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(testPanel);
    }

}

/**
 * Appli menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 * @implemenrs KeyListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener, KeyListener {

    String[] menuItem = {
        "anim7",
        "anime_over1",
        "anime_over2",
        "anime_over3",
        "anime_over4",
        "anime_max1",
        "anime_max2",
        "anime_max3",
        "anime_max4",
        "anime5k",
        "hugeanim",
        "animmax",
    };

	String dummy1 = "abcdefghijklmnopqrstuvxyz";
	String dummy2 = "abcdefghijklmnopqrstuvxyz";
	String dummy3 = "abcdefghijklmnopqrstuvxyz";
	String dummy4 = "ab";


    /* Definition of GUI components */
    TextBox resultBox = new TextBox(null, 16, 16, TextBox.DISPLAY_ANY);
    ListBox menuList  = new ListBox(ListBox.CHOICE);
    Button playButton = new Button("Replay");
    Button stopButton = new Button("Stop");
    VisualPresenter animeVP = new VisualPresenter();

    /* Record the location of image display */
    int xpos = 0;
    int ypos = 0;

    /**
     * Create panel (Constructor of Panel)
     */
    public MainPanel() {

        /* GUI settings */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setTitle("Check 30K jar");

        animeVP.setSize(Display.getWidth(), Display.getHeight());
        animeVP.setBackground(Graphics.getColorOfName(Graphics.BLUE));

        /* GUI location */
        menuList.setItems(menuItem);
        add(menuList);
        add(playButton);
        add(stopButton);
        add(animeVP);
        add(resultBox);

        /* Listener setting */
        this.setSoftKeyListener(this);
        this.setComponentListener(this);
        this.setKeyListener(this);

        resultBox.setText("The result of behavior of this application has no association with the test result");
    }

    /** 
     * Soft key handler
     * @param aKey Pressed key
     */
    public void softKeyPressed(int aKey) {}

    /** 
     * Soft key handler
     * @param aKey Released key
     */
    public void softKeyReleased(int aKey) {
        /* When soft key1 is released, end the application */
        if (aKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Component event
     * @param aComponent Event occurrence component
     * @param aType Event type
     * @param aParam Event parameter
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aType == ComponentListener.SELECTION_CHANGED && aComponent == menuList) {
            int index = menuList.getSelectedIndex();
            if (index >= 0) {
                MediaImage mi = MImageCache.get("resource:///"+menuItem[index]+".gif");
                try {
                    animeVP.setImage(mi);
                } catch (UIException uie) {
                    animeVP.stop();
                    animeVP.setImage(mi);
                }
            }
        }
        if (aType == ComponentListener.BUTTON_PRESSED) {
            if (aComponent == playButton) {
                animeVP.play();
            } else if (aComponent == stopButton) {
                animeVP.stop();
            }
        }
    }

    /**
     * Key pressing event handler
     * @param aPanel Panel for notification of key entry
     * @param aKey Key code
     */
    public void keyPressed(Panel aPanel, int aKey) {}

    /**
     * Key releasing event handler
     * @param aPanel Panel for notification of key entry
     * @param aKey Key code
     */
    public void keyReleased(Panel aPanel, int aKey) {
        if (aPanel == this) {
            switch (aKey) {
            case Display.KEY_2:
                ypos -= 4;
                break;
            case Display.KEY_4:
                xpos -= 4;
                break;
            case Display.KEY_6:
                xpos += 4;
                break;
            case Display.KEY_8:
                ypos += 4;
                break;
            default:
                break;
            }
            animeVP.setAttribute(VisualPresenter.IMAGE_XPOS, xpos);
            animeVP.setAttribute(VisualPresenter.IMAGE_YPOS, ypos);
        }
    }
}

/**
 * Image cache class
 */
class MImageCache {

    private static Hashtable cache;

    static {
        cache = new Hashtable();
    }

    /**
     * Get media image of specified URL.
     * @param fileName URL of media
     * @return MediaImage dataReturn null when data acquisition error occurs
     */
    public static MediaImage get(String fileName) {
        try {
            MediaImage mImage = (MediaImage)cache.get(fileName);
            if (mImage != null) {
                return mImage;
            }
            mImage = MediaManager.getImage(fileName);
            mImage.use();
            cache.put(fileName, mImage);
            return mImage;
        } catch (Exception e) {
            return null;
        }
    }
}

/**
 * Gap-filling class
 */
class dummy {
    int a;
    int b;
    int c;
    int d;
    int e;
}
