/**
 * J221_0205_0204
 *
 * Scratchpad 50K
 *
 * $Id: J221_0205_0204.java,v 1.1 2001/12/29 01:45:34 takanao Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;

/**
 * Main class for checking Scratchpad of 50K
 * @extends IApplication
 */

public class J221_0205_0204 extends IApplication {

    MainPanel testPanel = new MainPanel();

    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(testPanel);
    }
}

/**
 * Check download when Scratchpad is set to 50k
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    /* Definition of GUI components */
    TextBox resultBox = new TextBox(null, 16, 16, TextBox.DISPLAY_ANY);
    Button  processButton = new Button("execute");

    /**
     * Create panel (Constructor of Panel)
     */
    public MainPanel() {

        /* GUI settings */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setTitle("Download of scratchpad of 50K");

        /* GUI location */
        add(processButton);
        add(resultBox);

        /* Listener setting */
        this.setSoftKeyListener(this);
        this.setComponentListener(this);
    }

    /** 
     * Soft key handler
     * @param aKey Pressed key
     */
    public void softKeyPressed(int aKey) {}

    /** 
     * Soft key handler
     * @param aKey Released key
     */
    public void softKeyReleased(int aKey) {
        /* When soft key1 is released, end the application */
        if (aKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Component event
     * @param aComponent Event occurrence component
     * @param aType Event type
     * @param aParam Event parameter
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aComponent == processButton && aType == ComponentListener.BUTTON_PRESSED) {
            doTest();
        }
    }

    /**
     * Method for test
     */
    public void doTest() {
        try {
            InputStream in = Connector.openInputStream("scratchpad:///0;pos=51199");
            int data = in.read();
            in.close();
            if (data == 0) {
                resultBox.setText("OK: Secure 50K");
            } else {
                resultBox.setText("NG: Illegal data");
            }
        } catch (Exception e) {
            resultBox.setText("NG: "+e.getClass().getName());
        }
    }
}
