/*
 * J221_0305_1101.java
 * Check behavior of update of Use Network normal value
 *
 * $Id: J221_0305_1101.java,v 1.1 2002/01/07 02:35:34 hoshi Exp $
 */

import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Check behavior of update of Use Network normal value
 * @extends IApplication
 */
public class J221_0305_1101 extends IApplication {
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Main screen for checking behavior of update of UseNetwork's normal value
     * @extends Panel
     * @implements SoftKeyListener
     */
    class MainPanel extends Panel implements SoftKeyListener {

        TextBox aTextBox;
        Label aLabel;
        Label bLabel;

        /**
         * Constructors of the MainPanel class
         */
        public MainPanel() {

            /* Settings of display items */
            setTitle("Check the UseNetwork update");
            aLabel = new Label("Result of the connection");
            bLabel = new Label("Ver.1");
            aTextBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);

            /* Add each component to screen */
            add(aLabel);
            add(bLabel);
            add(aTextBox);

            /* Listener setting */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
            setSoftLabel(Frame.SOFT_KEY_2, "Connection");
        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex/ index of soft key
         */
        public void softKeyPressed(int anIndex) {
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }if (anIndex == Frame.SOFT_KEY_2) {
                connect();
            }
        }

        /**
         * When soft key is released, operate nothing
         * @param anIndex/ index of soft key
         */
        public void softKeyReleased(int anIndex) {}

        /**
         * Establish communication
         */
        private void connect() {

            /* Specify URL of acquired data */
            String url = IApplication.getCurrentApp().getSourceURL()
                + "J221_0305_1101.jam";

            HttpConnection con = null;

            String mes = "Start connection:";
            try {
                con = (HttpConnection)Connector.open(url, Connector.READ, true);
                con.setRequestMethod(HttpConnection.GET);
                con.connect();

            /**
             *    Exceptions of ConnectionException
             */
            }catch (ConnectionException ce) {
                int aStatus = ce.getStatus();
                switch (aStatus) {
                    case ConnectionException.ILLEGAL_STATE:
                        mes = mes + "\nCE:ILLEGAL_STATE";
                        break;
                    case ConnectionException.NO_RESOURCE:
                        mes = mes + "\nCE:NO_RESOURCE";
                        break;
                    case ConnectionException.RESOURCE_BUSY:
                        mes = mes + "\nCE:RESOURCE_BUSY";
                        break;
                    case ConnectionException.NO_USE:
                        mes = mes + "\nCE:NO_USE";
                        break;
                    case ConnectionException.OUT_OF_SERVICE:
                        mes = mes + "\nCE:OUT_OF_SERVICE";
                        break;
                    case ConnectionException.IMODE_LOCKED:
                        mes = mes + "\nCE:IMODE_LOCKED";
                        break;
                    case ConnectionException.TIMEOUT:
                        mes = mes + "\nCE:TIMEOUT";
                        break;
                    case ConnectionException.USER_ABORT:
                        mes = mes + "\nCE:USER_ABORT";
                        break;
                    case ConnectionException.SYSTEM_ABORT:
                        mes = mes + "\nCE:SYSTEM_ABORT";
                        break;
                    case ConnectionException.HTTP_ERROR:
                        mes = mes + "\nCE:HTTP_ERROR";
                        break;
                    case ConnectionException.SCRATCHPAD_OVERSIZE:
                        mes = mes + "\nCE:SCRATCHPAD_OVERSIZE";
                        break;
                    case ConnectionException.UNDEFINED:
                        mes = mes + "\nCE:UNDEFINED";
                        break;
                    default:
                        mes = mes + "\nCE:Undefined";
                        break;
                }

            /**
             *	Exceptions of IOException
             */
            } catch (IOException ioe) {
			    mes = mes + "\nIOException";
            } catch (SecurityException se) {
                mes = mes + "\nSecurityException";
            } catch (IllegalArgumentException iae) {
                mes = mes + "\nIllegalArgumentException";
            } catch (Exception e) {
                mes = mes + "\n" + getExceptionName(e);
            } finally {
                try {
                    con.close();
                } catch (Exception e) {
                    mes = mes + "\nAbort.";
                }
            }

            mes = mes + "\n exit";
            aTextBox.setText(mes);
        }

        private String getExceptionName(Throwable e) {
            String str = e.toString();
            return str.substring(str.lastIndexOf('.')) + e.getMessage();
        }
    }
}
