/*
 * J221_0305_1901.java
 * Check behavior of update of AppTrace normal value
 * J221_0305_1901
 * $Id: J221_0305_1901.java,v 1.1 2002/01/07 02:23:30 hoshi Exp $
 */

import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Check behavior of update of AppTrace normal value
 * @extends IApplication
 */

public class J221_0305_1901 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Check behavior of update of AppTrace normal value
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,
        ComponentListener {

        Label aLabel;
        Button aButton;

        /**
         * Constructors of the MainPanel class
         */
        MainPanel() {

            /* Settings of display items */
            setTitle("Confirmation of AppTrace");
            aLabel = new Label("Ver.1");
            aButton = new Button("Occurrence of exceptions");

            /* Add each component to screen */
            add(aLabel);
            add(aButton);

            /* Listener setting */
            setComponentListener(this);
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

        }

        /*
         * Dialog display method
         * @param	aText		displayed character strings
         */
        public void showDialog(String aText) {
            Dialog	d = new Dialog(Dialog.BUTTON_OK, "Result");
            d.setText(aText);
            d.show();
        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex/ index of soft key
         */
        public void softKeyPressed(int anIndex) {;
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * When soft key is released, operate nothing
         * @param anIndex/ index of soft key
         */
        public void softKeyReleased(int anIndex) {}

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent,
            int aType, int aParam) {

            String url[];
            url = new String[1];

            if (aComponent == aButton) {

                /* Set the URL of where downloaded from */
                url[0] = IApplication.getCurrentApp().getSourceURL();
				
                /* Display a browser */
//2002/10/02 Doja1.5                launch(LAUNCH_BROWSER, url);
            }
        }
    }
}
