/*
 * J221_0305_2001.java
 * Check behavior of update of DrawArea normal value
 * J221_0305_2001
 * $Id: J221_0305_2001org2.java,v 1.1 2002/01/07 02:20:52 hoshi Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Check behavior of update of DrawArea normal value
 * @extends IApplication
 */
public class J221_0305_2001 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start() {
        Display.setCurrent(new MainCanvas());
    }

    /**
     * Main screen for checking behavior of update of DrawArea normal value
     * @extends Canvas
     */
    class MainCanvas extends Canvas {

        int backColor;
        int stringColor;

        /**
         * Constructor of MainCanvas class
         */
        public MainCanvas(){

            /* Color settings */
            backColor = Graphics.getColorOfName(Graphics.RED);
            stringColor = Graphics.getColorOfName(Graphics.BLACK);

            /* Settings of display items */
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
        }

        /**
         * Draw screen
         */
        public void paint(Graphics g) {
            g.lock();
            g.setColor(backColor);
            g.fillRect(0,0,getWidth(),getHeight());
            g.setColor(stringColor);
            g.drawString("Check DrawArea",0,10);
            g.drawString("Ver.2",0,25);
            g.unlock(true);
        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex/ index of soft key
         */
        public void processEvent(int type,int param) {
            if(type == Display.KEY_PRESSED_EVENT) {
                switch(param) {
                    case Display.KEY_SOFT1:
                        IApplication.getCurrentApp().terminate();
                        break;
                    default:
                }
            }
        }
    }
}
