/*
 * J221_0307_0301.java
 * Confirmation of version-up operations
 * J221_0307_0301
 * $Id: J221_0307_0301.java,v 1.2 2002/02/20 06:39:33 takanao Exp $
 */

import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Confirmation of version-up operations
 * @extends IApplication
 */
public class J221_0307_0301 extends IApplication {
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * Confirmation of version-up operations
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    /* Menu */
    String[] menuItem = {
    "00 10",
    "01 20",
    "02 Decreasing",
    };

    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button aButton;
    Button bButton;
    TextBox aTextBox;
    int size = 20;
    int i;
    int k;
    int[] a = new int[20];
    byte[] b = new byte[20];
    String SPread;
    int index = 0;

    /**
     * Constructors of the MainPanel class
     */
    public MainPanel() {

        /* Settings of display items */
        setTitle("Check SP Ver.1");
        menuList.setItems(menuItem);
        aButton = new Button("Write");
        bButton = new Button("Read");
        aTextBox = new TextBox("", 16, 4, TextBox.DISPLAY_ANY);
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* Add each component to screen */
        add(menuList);
        add(aButton);
        add(bButton);
        add(aTextBox);

        /* Listener setting */
        setComponentListener(this);
        setSoftKeyListener(this);
    }

    /*
     * Dialog display method
     * @param	aText		displayed character strings
     */
    public void showDialog(String aText) {
        Dialog	d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }

    /**
     * When soft key is pressed, end the application
     * @param anIndex/ index of soft key
     */
    public void softKeyPressed(int anIndex) {
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * When soft key is released, operate nothing
     * @param anIndex/ index of soft key
     */
    public void softKeyReleased(int anIndex) {}

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
	index = menuList.getSelectedIndex();
        if (aComponent == aButton){

            switch (index) {
            case 0:
                size = 10;
                break;
            case 1:
                size = 20;
                break;
            }
            save();
        } if (aComponent == bButton) {
            switch (index) {
            case 0:
                size = 10;
                break;
            case 1:
                size = 20;
                break;
	    case 2:
		size = 10;
		break;
            }
            load();
        }
    }

    /**
     * Write into Scratchpad
     */
    private void save() {
        DataOutputStream dos = null;
        try {
            dos = Connector.openDataOutputStream("scratchpad:///0");
            byte a = (byte) '1';
            for ( i = 0; i < size; i++) {
                dos.write(a);
            }
            aTextBox.setText("Write:OK");
        } catch (IOException e) {
            showDialog("Write:NG");
        } finally {
            try {
                if (dos != null) dos.close();
            } catch (IOException ie) {
                showDialog("close:NG");
            }
        }
    }

    /**
     * Read Scratchpad
     */
    private void load() {
        InputStream is = null;
        SPread = new String("");
        
        try {
            is = Connector.openInputStream("scratchpad:///0");
            for (i = 0; i < size; i++) {
                a[i] = is.read();
                b[i] = (byte) a[i];
                if (a[i] == -1) {
                    break;
                }
            }

            if (size == 20) {
                for (k = 10; k < 20; k++) {
                    if (b[k] != 0) {
                        break;
                    }
                }

                if (k != 20) {
                    showDialog("NG");
                } else {
                    showDialog("OK");
                }

            }

            if (index == 2) {
                for (k = 0; k < 10; k++) {
                    if (b[k] != 0) {
                        break;
                    }
                }

                if (k != 10) {
                    showDialog("NG");
                } else {
                    showDialog("OK");
                }

            }

            SPread = new String(b);
            if (i == size) {
                aTextBox.setText(SPread);
            } else {
                  showDialog("Read:NG");
            }

        } catch (IOException ioe) {
            showDialog("Read:NG(IOException)");
        } catch (Exception e) {
            showDialog("Reading NG : " + e.toString());  
        } finally {
            try {
                if (is != null) is.close();
            } catch (IOException ie) {
                showDialog("close:NG");
            }
        }
    }
}
