/*
 * J221_0401_0101.java
 * Check JVM operations
 * J221_0401_0101
 *
 * $Id: J221_0401_0101.java,v 1.1 2002/01/07 02:03:34 hoshi Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Check JVM operations
 * @extends IApplication
 */

public class J221_0401_0101 extends IApplication
{
    /**
     * Overview of functions  :Startup method of i appli
     */
    public void start()
    {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Check JVM operations
     * @extends Panel
     * @implements SoftKeyListener
     */
    class MainPanel extends Panel implements SoftKeyListener
    {

        Label aLabel;
        Label bLabel;

        /**
         * Constructors of the MainPanel class
         */
        MainPanel() {

            /* Settings of display items */
            setTitle("JAM-JVM");
            aLabel = new Label("Test to check behavior of JVM");
            bLabel = new Label("  Ver.1  ");

            /* Add each component to screen */
            add(aLabel);
            add(bLabel);

            /* Listener setting */
            setSoftKeyListener(this);
            setSoftLabel(Frame.SOFT_KEY_1, "exit");
        }

        /**
         * When soft key is pressed, end the application
         * @param anIndex/ index of soft key
         */
        public void softKeyPressed(int anIndex) {;
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * When soft key is released, operate nothing
         * @param anIndex/ index of soft key
         */
        public void softKeyReleased(int anIndex) {}
    }
}
