/**
 * J221_0402_0102.java
 * 
 * J221_0402_0102
 * MainPanel
 * 
 * Check screen area
 * 
 * $Id: J221_0402_0102.java,v 1.1 2002/01/07 02:01:22 hoshi Exp $
*/

import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Main class for checking screen area
 * @extends IApplication
 */
public class J221_0402_0102 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * Main screen for checking screen area
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

    /* Creation of message dialog (error/Information) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* execute button */
    Button execButton = null;
    /* Create menu for selecting process */   
    
   TextBox textBox1 = new TextBox("",20,1,TextBox.DISPLAY_ANY);
	String text = new String("");
	String Str = new String ("");
    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {

        try {
            showMainPanel();
        } catch(Exception e) {
            err.setText("Exception:" + e.toString());
        } catch(Error e) {
            err.setText("Error" + e.toString());
        }

    }

    /**
     * Display main screen for checking screen area
     */
    public void showMainPanel() {

        /* Display title */
        setTitle("JAM-JVM");

        /* Display sub title */
        Label subTitle = new Label("Check screen area");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

       
        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);



        /* Setting of the execute button */
        execButton = new Button("execute");

        /* Add component to the screen */
        add(textBox1);
        add(execButton);
       
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * softKeyReleased
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        /* Completed when soft key 1 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* Transit to the screen that is compliant with menu by pressing execute button */
        if ( aComponent == execButton && aType == BUTTON_PRESSED ) {
          	text = textBox1.getText();
        	for ( int i = 0; i < 8; i++ ) {
						Str += text;
        	}
                Display.setCurrent(new testPanel(Str,this));
        
    }
}


/**
 * Screen area confirmation screen class
 * @extends Canvas
 */
class testCanvas extends Canvas {

   // static int size = 12;
  //  static int count = 0;
  //  static int setsize = 0;

    /* Variable in order to return to the previous screen */
    Frame previousFrame = null;
    int index;
    Font font;

    /* Creation of message dialog (error/Information) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /**
     * Constructor of testCanvas class
     * @param aType  Location of items of Menu
     * @param aFrame  Screen
     */
    public testCanvas(int aType, Frame aFrame) {

        /* Assign the previous screen */
        previousFrame = aFrame;
        index = aType;
        
        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

      //  setsize = 0;
        repaint();
    }

	public void paint(Graphics g) {

	//	g.clearRect(0,-(setsize*count),getWidth(),getHeight()+(setsize*count));
      //  g.setOrigin(0,setsize);

		g.lock();
        int y = 45;
        int x = 0;
		g.drawString("JAM-JVM",0,10);
        g.drawLine(0,15,getWidth(),15);

        switch (index) {
            /* Size of the screen */
            //J221_0402_0102
            case 0:
                g.drawString("Size of the screen",5,30);
//2002/09/17 Doja1.5                g.drawString("Height:" + getHeight() + "  "
                g.drawString("Height:" + getHeight() + " "
                    + "Width:" + getWidth(),10,45);
                break;

            /* Number of characters */
            // J221_0402_0102
          
        }
		g.unlock(true);
    }

    /**
     * Process in case of events occurrence by key operation
     * @param type  Event type
     * @param param  Event parameter
     */


    /**
     * Define the behavior for the case soft key being released
     * @param aSoftKey  Type of soft key
     */
    public void processEvent(int type,int param) {
        if(type == Display.KEY_PRESSED_EVENT) {
            switch(param) {
                case Display.KEY_SOFT1:
                    IApplication.getCurrentApp().terminate();
                    break;
                case Display.KEY_SOFT2:
                    if(previousFrame != null) {
                        Display.setCurrent(previousFrame);
                    }
                    break;
               
                default:
			}
		}
    }
}

/**
 * Screen area confirmation screen class
 * @extends Panel
 * @implements SoftKeyListener
 */
class testPanel extends Panel implements SoftKeyListener {

    /* Creation of message dialog (error/Information) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* Variable in order to return to the previous screen */
    Frame previousFrame = null;

	Label label[] = new Label[6];

    /**
     * Constructor of testPanel class
     * @param aFrame  Screen
     */
    public testPanel(String Str,Frame aFrame) {

        /* Assign the previous screen */
        previousFrame = aFrame;

        /* Add component to the screen */
        for(int i = 0;i < 6; i++) {
            label[i] = new Label(Str);
        	
            add(label[i]);
        }

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
        setSoftLabel(Frame.SOFT_KEY_2,"back");

        /* Listener setting */
        setSoftKeyListener(this);

    }

    /**
     * When soft key is pressed, do not carry out any operations.
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Define the behavior for the case soft key being released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
        if (aSoftKey == Frame.SOFT_KEY_2) {
            if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
            }
        }
    }
}
}
