/**
 * J221_0405_0101.java
 * Check behavior of CLDC restriction
 * J221_0405_0101
 * 
 * $Id: J221_0405_0101.java,v 1.1 2002/01/07 01:56:45 hoshi Exp $
*/

import com.nttdocomo.lang.*;
import java.util.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * Main class for checking behavior of CLDC restriction
 * @extends IApplication
 */
public class J221_0405_0101 extends IApplication {
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }
}

/**
 * Main class for checking behavior of CLDC restriction
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {

Runtime runtime;


    /* Creation of message dialog (error/Information) */
    Dialog err = new Dialog(Dialog.DIALOG_ERROR,"error");
    Dialog info = new Dialog(Dialog.DIALOG_INFO, "info");

    /* execute button */
    Button execButton = null;

    /* Text box for displaying test result */
    TextBox resultTextBox = new TextBox("", getWidth(), 3, 
                                                TextBox.DISPLAY_ANY);
    /* Create menu for selecting process */
    ListBox mainMenu = new ListBox(ListBox.CHOICE,4);

    /* Menu item for selecting process */
    String[] mainItem = {
        "0.System#exit",
        "1.Runtime#exit",
    };

    /**
     * Constructor of MainPanel class
     */
    public MainPanel() {

        try {
            showMainPanel();
        } catch(Exception e) {
            err.setText("Exception:" + e.toString());
        } catch(Error e) {
            err.setText("Error" + e.toString());
        }

    }

    /**
     * Display main screen for checking behavior of CLDC restriction
     */
    public void showMainPanel() {

        /* Display title */
        setTitle("JAM-JVM");

        /* Display sub title */
        Label subTitle = new Label("Check behavior of CLDC restriction");
        subTitle.setSize(getWidth(), subTitle.getHeight());
        add(subTitle);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);

        /* Setting of the main menu */
        mainMenu.setItems(mainItem);

        /* Setting of the execute button */
        execButton = new Button("execute");

        /* Add component to the screen */
        add(mainMenu);
        add(execButton);
        add(resultTextBox);

    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * softKeyReleased
     * When soft key 1 is released, end the application
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        /* Completed when soft key 1 is released */
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType  Type of events
     * @param aParam  Parameter of events
     */
    public void componentAction(Component aComponent, int aType, int aPram) {

        /* Transit to the screen that is compliant with menu by pressing execute button */
        if ( aComponent == execButton
             && aType == BUTTON_PRESSED ) {

            switch (mainMenu.getSelectedIndex()) {
            /* System#exit */
            // J221_0405_0101
            case 0:
                try {
                    System.exit(1);
                    resultTextBox.setText("NG : NO_Exception");
                } catch (SecurityException se) {
                    resultTextBox.setText("OK : " + se.toString());
                } catch (Exception e) {
                    resultTextBox.setText("NG : " + e.toString());
                }
                break;
            /* Runtime#exit */
            // J221_0405_0102
            case 1:
                try {
                    runtime = Runtime.getRuntime();
                    runtime.exit(1);
                    resultTextBox.setText("NG : NO_Exception");
                } catch (SecurityException se) {
                    resultTextBox.setText("OK : " + se.toString());
                } catch (Exception e) {
                    resultTextBox.setText("NG : " + e.toString());
                }
                break;
            }
        }
    }
}
