/**
 * J223_0102_0108
 *
 * For display of AppTrace contents
 *
 */

import com.nttdocomo.ui.*;

/**
 * Appli to display AppTrace
 * @extends MApplication
 */

public class J223_0102_0108 extends IApplication {

    MainPanel testPanel = new MainPanel();

    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(testPanel);
    }

}

/**
 * Menu screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuItem = {
        "AppTrace",
    };


    /* Definition of GUI components */
    ListBox menuList = new ListBox(ListBox.CHOICE);
    Button  processButton = new Button("execute");
    TextBox resultBox = new TextBox(null, 16, 16, TextBox.DISPLAY_ANY);

    /**
     * Create panel (Constructor of Panel)
     */
    public MainPanel() {

        /* GUI settings */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
        setTitle("JAM-JVM");
        menuList.setItems(menuItem);

        /* GUI location */
        add(menuList);
        add(processButton);
        add(resultBox);

        /* Listener setting */
        this.setSoftKeyListener(this);
        this.setComponentListener(this);
    }

    /**
     * Soft key handler
     * @param aKey Pressed soft key
     **/
    public void softKeyPressed(int aKey) {}

    /**
     * Soft key handler
     * @param aKey Released soft key
     **/
    public void softKeyReleased(int aKey) {
        /* When soft key1 is released, end the application */
        if (aKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }
    
    /** 
     * Component event handler
     * @param aComponent Component of event occurrence
     * @param aType Event type
     * @param aParam Event parameter
     */
    public void componentAction(Component aComponent, int aType, int aParam) {
        if (aType == ComponentListener.BUTTON_PRESSED && aComponent == processButton) {
            int selectedIndex = menuList.getSelectedIndex();
            if (selectedIndex >= 0) {
                doTest(selectedIndex);
            }
        }
    }

    /**
     * Test method
     * @param aTest Test number
     */
    public void doTest(int aTest) {
        switch (aTest) {
        // J223_0102_0108
        case 0:
            int[] illegalArray = new int[10];
            illegalArray[-1] = 0;
            break;
        }
    }
}
