/**
 * J223_0102_0205
 *
 *
 */

import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;

/**
 * Frame class action check main class
 * @extends IApplication
 */
public class J223_0102_0205 extends IApplication {

    /**
     * starting i-Appli start()
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * Phone class behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menu1 = {
        "01 GetUtn",
    };

    String[] menu2_02 = {
        "01 terminal-id",
        "02 user-id"
    };


    Label   title      = new Label("ICCID");
    ListBox menu_Li    = new ListBox(ListBox.CHOICE);
    ListBox menu_Li2   = new ListBox(ListBox.CHOICE);
    Button  execButton = new Button("execute");
    int     firstType;
    int     secondType;

    /**
     * MainPanel constructor(initializing)
     */
    public MainPanel() {

        /* setting of the display item */
        menu_Li.setItems(menu1);
        menu_Li2.setItems(menu2_02);
        setTitle("JAM-JVM");
        setSoftLabel(Frame.SOFT_KEY_1, "exit");

        /* adding each component on the display */
        add(title);
        add(menu_Li);
        add(menu_Li2);
        add(execButton);

        /* register the softkey listener */
        setSoftKeyListener(this);
        /* register the component listener */
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     * @param anIndex the value of the pushed softkey 
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when SOFT_KEY_1 is released
     * @param anIndex the value of the released softkey 
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when SOFT_KEY_1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * process when the action other than softkey happens
     * @param source the component on which the event occurs
     * @param type event type
     * @param param event parameter
     */
    public void componentAction(Component source, int type, int param) {
        /* when item in the menu1 is selected */
        if (source == menu_Li && type == ComponentListener.SELECTION_CHANGED) {

            /* get the chosen item */
            firstType = menu_Li.getSelectedIndex();

            /* set the selection list in menu 1 */
            switch (firstType) {
                case 0:
                    menu_Li2.setItems(menu2_02);
                    break;
                default:
                    break;
            }
        }

        /* when the fix-key is pushed on the condition the execution button is focused */
        if (source == execButton 
            && type == ComponentListener.BUTTON_PRESSED) {

            /* get the chosen item */
            secondType = menu_Li2.getSelectedIndex();

            switch (firstType) {
                case 0:
                    /* to the prescribed value method behavior checking */
                    test5();
                    break;
                default:
                    break;
            }
        }
    }


    /**
     * checking prescribed value method action
     */
    public void test5() {

        Phone phone = new Phone();
		String terminalID = "";
		String userID = "";

		switch(secondType){
			case 0:
            //	in case of getProperty(terminal-id)
				try{
					terminalID = phone.getProperty("terminal-id");
					showDialog("terminal-id:"+terminalID);
				}
				catch (SecurityException e) {
					showDialog("SecurityException:"+e.getMessage());
				}
				catch (IllegalArgumentException e) {
					showDialog("IllegalArgumentException:"+e.getMessage());
				}
				catch (NullPointerException e) {
					showDialog("NullPointerException:"+e.getMessage());
				}
				break;
			case 1:
            //	in case of getProperty(user-id)
				try{
					userID = phone.getProperty("user-id");
					showDialog("user-id:"+userID);
				}
				catch (SecurityException e) {
					showDialog("SecurityException:"+e.getMessage());
				}
				catch (IllegalArgumentException e) {
					showDialog("IllegalArgumentException:"+e.getMessage());
				}
				catch (NullPointerException e) {
					showDialog("NullPointerException:"+e.getMessage());
				}
				break;
        }
    }

    /**
     * setting of the dialog box which is going to be displayed
     * @param str the message which is displayed in the dialog
     */
    public void showDialog(String str) {
        /* create the dialog box */
        Dialog    d = new Dialog(Dialog.BUTTON_OK, "result");
        /* put the character sequence */
        d.setText(str);
        /* display of the dialog box */
        d.show();
    }
}
//2002/07/25 DoJa1.5
