/**
 * J311_0101_0205
 * MainPanel
 *
 * HTTP basic behavior/check the variation of file name recognition 1
 *
 * $Id: J311_0101_0205.java,v 1.1 2002/02/04 04:31:40 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * HTTP basic behavior/main class of checking the variation of file name recognition 
 * @extends IApplication
 */
public class J311_0101_0205 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * HTTP basic behavior/main screen of checking the variation of file name recognition
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
        String[] menuItems = {
           
            "5. numeric",
            "6. resource",
            "7. scratchpad",
            "8. http",
            "9. https",
//2002/08/28             "10. obex",
            "11. no extension",
            "12. html",
            "13. cgi",
            "14. gif",
            "15. jpg",
            "16. mld",
            "17. jsp",
            "18. period plural",
            "19. period continuous",
            "20. hyphen"
        };
        String[] files = {
           
            "123",
            "resource",
            "scratchpad",
            "http",
            "https",
//2002/08/28 DoJa1.5            "obex",
            "aaa",
            "html",
            "cgi",
            "gif",
            "jpg",
            "mld",
            "jsp",
            "a.b.c.d",
            "a...b",
            "a-b-c"
        };

        Label   lab              = new Label("file name recognition");
        ListBox menu             = new ListBox(ListBox.CHOICE);
        Button  execButton       = new Button("execute");

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            menu.setItems(menuItems);
            setTitle("HTTP basic behavior");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(lab);
            add(menu);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent,int aType,int aParam){
            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* execute the test method */
                test();
            }
        }

        /**
         * method to execute the test
         */
        public void test() {
            HttpConnection con = null;

            // J311_0101_0205
            // J311_0101_0202
            // J311_0101_0205
            // J311_0101_0204
            // J311_0101_0205
            // J311_0101_0206
            // J311_0101_0207
            // J311_0101_0208
            // J311_0101_0209
//2002/08/28 DoJa1.5            // J311_0101_0210
            // J311_0101_0211
            // J311_0101_0212
            // J311_0101_0213
            // J311_0101_0214
            // J311_0101_0215
            // J311_0101_0216
            // J311_0101_0217
            // J311_0101_0218
            // J311_0101_0219
            // J311_0101_0220
            /* Acquisition of selected menu index */
            int idx = menu.getSelectedIndex();
            /* URL creation */
            String url = getSourceURL() + files[idx];
            /* execute HTTP connection */
            try {
                con = (HttpConnection) Connector.open(url,Connector.READ,true);
                con.setRequestMethod(con.GET);
                con.connect();
                con.close();
                showDialog("OK");
            } catch( Exception e ) {
                if( con != null ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                }
                showDialog("NG:" + e.toString());
            }
        }
    }
}
