/**
 * J311_0102_0401
 * MainPanel
 *
 * HTTP basic behavior/ check the header preconditions
 *
 * $Id: J311_0102_0401.java,v 1.1 2002/02/04 04:31:43 lan Exp $
 */

import java.io.*;
import java.lang.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * HTTP basic behavior/ main class of checking the header preconditions
 * @extends IApplication
 */
public class J311_0102_0401 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * HTTP basic behavior/ main screen of checking the header preconditions
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
        String[] menuItems = {
            "1. Content-Length exists",
            "2. Content-Length not exist",
            "3. Time Out no Content-Length"
        };

        Label   lab              = new Label("preconditions of header");
        ListBox menu             = new ListBox(ListBox.CHOICE);
        Button  execButton       = new Button("execute");

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            menu.setItems(menuItems);
            setTitle("HTTP basic behavior");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(lab);
            add(menu);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent,int aType,int aParam){
            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* execute the test method */
                test();
            }
        }

        /**
         * method to execute the test
         */
        public void test() {
            HttpConnection con = null;
            InputStream  ins = null;
            OutputStream ous = null;

            /* Acquisition of selected menu index */
            int idx = menu.getSelectedIndex();
            /* URL creation */
            String url = getSourceURL();

            /* execute HTTP connection */
            if( idx == 0 ) {
                // J311_0102_0401
                // J311_0102_0403
                url += "../cgi-bin/get1.cgi?value=abc";
            } else if (idx == 1 ) {
                // J311_0102_0402
                url += "../cgi-bin/get2.cgi?value=abc";
            } else {
                // J311_0102_0404
                url += "../cgi-bin/get3.cgi?value=abc";
            }
            try {
                con = (HttpConnection) Connector.open(url,Connector.READ,
                                                        true);
                con.setRequestMethod(con.GET);
		  System.out.println("J311_0102_040X start before connection.");
                con.connect();
		  System.out.println("before openInputStream");
                ins = con.openInputStream();
		  System.out.println("available=" + Integer.toString(ins.available()));
                byte[] b = new byte[1024];
		  int length=ins.read(b);
                String s = new String(b);
		  System.out.println("string=" + s);
		  while( true ){
			int l = ins.read(b);
			if( l < 0 ) { break; }
		  }
//                String s = new String(b);
                if( s.startsWith("abc") ) {
                    showDialog("OK");
                } else {
                    showDialog("NG: " + s);
                }
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            } finally {
		  try {
                    ins.close();
                    con.close();
		  } catch ( Exception e ) {}
//                if( con != null ) {
//                    try {
//                        con.close();
//                    } catch( Exception e1 ) {}
//                }
            }
        }
    }
}
