/**
 * J311_0106_0101
 * MainPanel
 *
 * HTTP basic behavior/check the result code behavior
 *
 * $Id: J311_0106_0101.java,v 1.1 2002/02/04 04:31:45 lan Exp $
 */

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * HTTP basic behavior/main class of checking the result code behavior 
 * @extends IApplication
 */
public class J311_0106_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * HTTP basic behavior/main screen of checking the result code behavior
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
        String[] menuItems = {
            "1. 200",
            "2. 201",
            "3. 202",
            "4. 203",
            "5. 204",
            "6. 205",
            "7. 206",
            "8. 300",
            "9. 301",
            "10. 302",
            "11. 303",
            "12. 304",
            "13. 305",
            "14. 307",
            "15. 400",
            "16. 401",
            "17. 402",
            "18. 403",
            "19. 404",
            "20. 405",
            "21. 406",
            "22. 407",
            "23. 408",
            "24. 409",
            "25. 410",
            "26. 411",
            "27. 412",
            "28. 413",
            "29. 414",
            "30. 415",
            "31. 416",
            "32. 417",
            "33. 500",
            "34. 501",
            "35. 502",
            "36. 503",
            "37. 504",
            "38. 505"
        };
        String[] subItems = {
            "1. GET"
        };
        String[] code = {
            "200",
            "201",
            "202",
            "203",
            "204",
            "205",
            "206",
            "300",
            "301",
            "302",
            "303",
            "304",
            "305",
            "307",
            "400",
            "401",
            "402",
            "403",
            "404",
            "405",
            "406",
            "407",
            "408",
            "409",
            "410",
            "411",
            "412",
            "413",
            "414",
            "415",
            "416",
            "417",
            "500",
            "501",
            "502",
            "503",
            "504",
            "505"
        };

        Label   lab              = new Label("result code");
        ListBox menu             = new ListBox(ListBox.CHOICE);
        ListBox menu2            = new ListBox(ListBox.CHOICE);
        Button  execButton       = new Button("execute");

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            menu.setItems(menuItems);
            menu2.setItems(subItems);
            setTitle("HTTP basic behavior");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(lab);
            add(menu);
            add(menu2);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent,int aType,int aParam){
            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* execute the test method */
                test();
            }
        }

        /**
         * method to execute the test
         */
        public void test() {
            HttpConnection con = null;
            InputStream  ins = null;

            /* Acquisition of selected menu index */
            int idx1 = menu.getSelectedIndex();
            int idx2 = menu2.getSelectedIndex();
            /* URL creation */
            String url = getSourceURL();
            if( idx1 == 15 ) {
                url += "../sec/aaa";
            } else {
                url += "../status/" + code[idx1] + ".asis";
            }

            /* execute HTTP connection */
            // J311_0106_0101
            // J311_0106_0103
            // J311_0106_0201
            // J311_0106_0203
            // J311_0106_0301
            // J311_0106_0303
            // J311_0106_0401
            // J311_0106_0403
            // J311_0106_0501
            // J311_0106_0503
            // J311_0106_0601
            // J311_0106_0603
            // J311_0106_0701
            // J311_0106_0703
            // J311_0106_0801
            // J311_0106_0803
            // J311_0106_0901
            // J311_0106_0903
            // J311_0106_1001
            // J311_0106_1003
            // J311_0106_1101
            // J311_0106_1103
            // J311_0106_1201
            // J311_0106_1203
            // J311_0106_1301
            // J311_0106_1303
            // J311_0106_1401
            // J311_0106_1403
            // J311_0106_1501
            // J311_0106_1503
            // J311_0106_1601
            // J311_0106_1603
            // J311_0106_1604
            // J311_0106_1606
            // J311_0106_1607
            // J311_0106_1609
            // J311_0106_1701
            // J311_0106_1703
            // J311_0106_1801
            // J311_0106_1803
            // J311_0106_1901
            // J311_0106_1903
            // J311_0106_2001
            // J311_0106_2003
            // J311_0106_2101
            // J311_0106_2103
            // J311_0106_2201
            // J311_0106_2203
            // J311_0106_2301
            // J311_0106_2303
            // J311_0106_2401
            // J311_0106_2403
            // J311_0106_2501
            // J311_0106_2503
            // J311_0106_2601
            // J311_0106_2603
            // J311_0106_2701
            // J311_0106_2703
            // J311_0106_2801
            // J311_0106_2803
            // J311_0106_2901
            // J311_0106_2903
            // J311_0106_3001
            // J311_0106_3003
            // J311_0106_3101
            // J311_0106_3103
            // J311_0106_3201
            // J311_0106_3203
            // J311_0106_3301
            // J311_0106_3303
            // J311_0106_3401
            // J311_0106_3403
            // J311_0106_3501
            // J311_0106_3503
            // J311_0106_3601
            // J311_0106_3603
            // J311_0106_3701
            // J311_0106_3703
            // J311_0106_3801
            // J311_0106_3803
            int res = 0;
            int len = 0;
            byte[] data = new byte[5];
            try {
                con = (HttpConnection) Connector.open(url,Connector.READ_WRITE,
                                                    true);
                if( idx2 == 0 ) {
                    con.setRequestMethod(con.GET);
                } else {}
                con.connect();
                res = con.getResponseCode();
                if( idx1 == 15 ) {
                    ins = con.openInputStream();
                    len = ins.read(data);
                    ins.close();
                }
                con.close();
                if( idx1 == 15 ) {
                    showDialog("code=" + res + " content:" + new String(data));
                } else {
                    showDialog("code=" + res );
                }
            } catch( ConnectionException ce ) {
                try {
                    res = con.getResponseCode();
                } catch( Exception e1 ) {}
                if( idx1 == 15 ) {
                    try {
                        ins = con.openInputStream();
                        len = ins.read(data);
                        ins.close();
                        if( len > 0 ) {
                            showDialog("ConnectionException: code=" + res);
                        } else {
                            showDialog("ConnectionException: code=" + res +
                                        ":no content");
                        }
                    } catch( Exception e ) {
                        showDialog("ConnectionException: code=" + res + 
                                    "InputStream Exception");
                    }
                } else {
                    if( ce.getStatus() == ce.HTTP_ERROR ) {
                        showDialog("ConnectionException(HTTP_ERROR): code=" +
                                    res);
                    } else {
                        showDialog("ConnectionException: code=" + res);
                    }
                }
            } catch( Exception e ) {
                showDialog("NG:" + e.toString());
            } finally {
                if( con != null ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                }
            }
        }
    }
}
