/**
 * J311_0403_0101
 * MainPanel
 *
 * HTTP basic behavior/check the possible to write status
 *
 * $Id: J311_0403_0101.java,v 1.1 2002/02/04 04:31:51 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * HTTP basic behavior/main class of checking the possible to write status 
 * @extends IApplication
 */
public class J311_0403_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * HTTP basic behavior/main screen of checking the possible to write status
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
        String[] menuItems = {
            "1. OS.close-POST",
            "2. OS.close-GET",
            "4. HC.close-POST",
            "5. connect-POST",
            "6. connect-GET",
            "8. getDate",
            "9. getEncoding",
            "10. getExpiration",
            "11. getHeaderField",
            "12. getLastModified",
            "13. getLength",
            "14. getResponseCode",
            "15. getResponseMessage",
            "16. getType",
            "17. getURL",
            "18. openInputStream",
            "19. openOutputStream",
            "20. setIfModifiedSince",
            "21. setRequestMethod",
            "22. setRequestProperty"
        };

        Label   lab              = new Label("possible to write status");
        ListBox menu             = new ListBox(ListBox.CHOICE);
        Button  execButton       = new Button("execute");

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            menu.setItems(menuItems);
            setTitle("HTTP basic behavior");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(lab);
            add(menu);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent,int aType,int aParam){
            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* execute the test method */
                test();
            }
        }

        /**
         * method to execute the test
         */
        public void test() {
            HttpConnection con = null;
            InputStream  ins = null;
            OutputStream ous = null;

            /* Acquisition of selected menu index */
            int idx = menu.getSelectedIndex();
            /* URL creation */
            String url = getSourceURL() + "../cgi-bin/post.cgi";

            /* execute HTTP connection */
            switch( idx ) {
            case 0:
                // J311_0403_0101
                /* no break sentence */
            case 1:
                // J311_0403_0102
                /* put it to the possible to write status */
                try {
                    switch( idx ) {
                    case 0:
                        con = (HttpConnection) Connector.open(url,
                                Connector.READ_WRITE, true);
                        con.setRequestMethod(con.POST);
                        break;
                    case 1:
                        con = (HttpConnection) Connector.open(url,
                                Connector.READ_WRITE, true);
                        con.setRequestMethod(con.GET);
                        break;
                    }
                    ous = con.openOutputStream();
                } catch( Exception e ) {
                    if( con != null ) {
                        try {
                            con.close();
                        } catch( Exception e1 ) {}
                    }
                    showDialog("NG1: " + e.toString());
                    return;
                }
                /* test */
                try {
                    ous.close();
                } catch( Exception e ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                    showDialog("NG2:" + e.toString());
                    return;
                }
                /* close the connection */
                try {
                    con.close();
                } catch( Exception e1 ) {}
                showDialog("OK");
                break;
            case 2:
                // J311_0403_0201
                /* put it to the possible to write status */
                try {
                    con = (HttpConnection) Connector.open(url,
                            Connector.READ_WRITE, true);
                    con.setRequestMethod(con.POST);
                    ous = con.openOutputStream();
                } catch( Exception e ) {
                    if( con != null ) {
                        try {
                            con.close();
                        } catch( Exception e1 ) {}
                    }
                    showDialog("NG1: " + e.toString());
                    return;
                }
                /* test */
                try {
                    con.close();
                } catch( Exception e ) {
                    showDialog("NG2:" + e.toString());
                    return;
                }
                /* OK if the connection re-opens */
                try {
                    con = (HttpConnection) Connector.open(url,
                            Connector.READ_WRITE, true);
                    con.setRequestMethod(con.POST);
                    con.connect();
                    con.close();
                } catch( Exception e ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                    showDialog("NG3:" + e.toString());
                    return;
                }
                showDialog("OK");
                break;
            case 3:
                // J311_0403_0301
                /* no break sentence */
            case 4:
                // J311_0403_0302
                /* put it to the possible to write status */
                try {
                    switch( idx ) {
                    case 3:
                        con = (HttpConnection) Connector.open(url,
                                Connector.READ_WRITE, true);
                        con.setRequestMethod(con.POST);
                        break;
                    case 4:
                        con = (HttpConnection) Connector.open(url,
                                Connector.READ_WRITE, true);
                        con.setRequestMethod(con.GET);
                        break;
                    }
                    ous = con.openOutputStream();
                } catch( Exception e ) {
                    if( con != null ) {
                        try {
                            con.close();
                        } catch( Exception e1 ) {}
                    }
                    showDialog("NG1: " + e.toString());
                    return;
                }
                /* test */
                try {
                    con.connect();
                } catch( RuntimeException re ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                    showDialog("RuntimeException: " + re.getMessage());
                    return;
                } catch( Exception e ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                    showDialog("NG2:" + e.toString());
                    return;
                }
                /* close the connection */
                try {
                    con.close();
                } catch( Exception e1 ) {}
                showDialog("NG: no Exception");
                break;
            case 5:
                // J311_0403_0401
                /* no break sentence */
            case 6:
                // J311_0403_0501
                /* no break sentence */
            case 7:
                // J311_0403_0601
                /* no break sentence */
            case 8:
                // J311_0403_0701
                /* no break sentence */
            case 9:
                // J311_0403_0801
                /* no break sentence */
            case 10:
                // J311_0403_0901
                /* no break sentence */
            case 11:
                // J311_0403_1001
                /* no break sentence */
            case 12:
                // J311_0403_1101
                /* no break sentence */
            case 13:
                // J311_0403_1201
                /* no break sentence */
            case 15:
                // J311_0403_1401
                /* put it to the possible to write status */
                try {
                    con = (HttpConnection) Connector.open(url,
                            Connector.READ_WRITE, true);
                    con.setRequestMethod(con.POST);
                    ous = con.openOutputStream();
                } catch( Exception e ) {
                    if( con != null ) {
                        try {
                            con.close();
                        } catch( Exception e1 ) {}
                    }
                    showDialog("NG1: " + e.toString());
                    return;
                }
                /* test */
                try {
                    switch( idx ) {
                    case 5:
                        // J311_0403_0401
                        long date = con.getDate();
                        break;
                    case 6:
                        // J311_0403_0501
                        String str = con.getEncoding();
                        break;
                    case 7:
                        // J311_0403_0601
                        long expire = con.getExpiration();
                        break;
                    case 8:
                        // J311_0403_0701
                        String header = con.getHeaderField("Content-Type");
                        break;
                    case 9:
                        // J311_0403_0801
                        long last = con.getLastModified();
                        break;
                    case 10:
                        // J311_0403_0901
                        long len = con.getLength();
                        break;
                    case 11:
                        // J311_0403_1001
                        int code = con.getResponseCode();
                        break;
                    case 12:
                        // J311_0403_1101
                        String msg = con.getResponseMessage();
                        break;
                    case 13:
                        // J311_0403_1201
                        String type = con.getType();
                        break;
                    case 15:
                        // J311_0403_1401
                        ins = con.openInputStream();
                        break;
                    }
                } catch( RuntimeException re ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                    showDialog("RuntimeException: " + re.getMessage());
                    return;
                } catch( Exception e ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                    showDialog("NG2:" + e.toString());
                    return;
                }
                /* close the connection */
                try {
                    con.close();
                } catch( Exception e1 ) {}
                showDialog("NG: no Exception");
                break;
            case 14:
                // J311_0403_1301
                /* no break sentence */
            case 17:
                // J311_0403_1601
                /* no break sentence */
            case 18:
                // J311_0403_1701
                /* no break sentence */
            case 19:
                // J311_0403_1801
                /* put it to the possible to write status */
                try {
                    con = (HttpConnection) Connector.open(url,
                            Connector.READ_WRITE, true);
                    con.setRequestMethod(con.POST);
                    ous = con.openOutputStream();
                } catch( Exception e ) {
                    if( con != null ) {
                        try {
                            con.close();
                        } catch( Exception e1 ) {}
                    }
                    showDialog("NG1: " + e.toString());
                    return;
                }
                /* test */
                try {
                    switch( idx ) {
                    case 14:
                        // J311_0403_1301
                        String url1 = con.getURL();
                        if( url1.compareTo(url) != 0 ) {
                            try {
                                con.close();
                            } catch( Exception e1 ) {}
                            showDialog("NG: getURL()=" + url1);
                            return;
                        }
                        break;
                    case 17:
                        // J311_0403_1601
                        con.setIfModifiedSince(10000);
                        break;
                    case 18:
                        // J311_0403_1701
                        con.setRequestMethod(con.GET);
                        break;
                    case 19:
                        // J311_0403_1801
                        con.setRequestProperty("Content-Type","text/plain");
                        break;
                    }
                } catch( Exception e ) {
                    try {
                        con.close();
                    } catch( Exception e1 ) {}
                    showDialog("NG2:" + e.toString());
                    return;
                }
                /* close the connection */
                try {
                    con.close();
                } catch( Exception e1 ) {}
                showDialog("OK");
                break;
            case 16:
                // J311_0403_1501
                /* put it to the possible to write status */
                try {
                    con = (HttpConnection) Connector.open(url,
                            Connector.READ_WRITE, true);
                    con.setRequestMethod(con.POST);
                    ous = con.openOutputStream();
                } catch( Exception e ) {
                    if( con != null ) {
                        try {
                            con.close();
                        } catch( Exception e1 ) {}
                    }
                    showDialog("NG1: " + e.toString());
                    return;
                }
                /* test */
                try {
                    OutputStream os = con.openOutputStream();
                    os.close();
                } catch( Exception e ) {
                    showDialog("Exception: " + e.getMessage());
                }
                try {
                    ous.close();
                    con.connect();
                    con.close();
                } catch( Exception e ) {
                    showDialog("Exception2: " + e.getMessage());
                }
                showDialog("no Exception");
                break;
            }
        }
    }
}
