/**
 * J312_0301_0201
 * MainPanel
 *
 * HTTP boundary behavior/submission behavior 2
 *
 * $Id: J312_0301_0201.java,v 1.3 2002/03/29 03:07:48 takanao Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * HTTP boundary behavior/main class of the submission behavior 
 * @extends IApplication
 */
public class J312_0301_0201 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * Dialog display method
     * @param   aText       Displayed character string
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result");
        d.setText(aText);
        d.show();
    }


    /**
     * HTTP boundary behavior/main class of the submission behavior
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
        String[] menuItems = {
            "1. POST5k"
        };

        Label   lab              = new Label("submission behavior");
        ListBox menu             = new ListBox(ListBox.CHOICE);
        Button  execButton       = new Button("execute");

        /**
         * Constructor of MainPanel class
         */
        public MainPanel() {
            /* Settings of display items */
            menu.setItems(menuItems);
            setTitle("HTTP boundary behavior");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* Add each component to screen */
            add(lab);
            add(menu);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);

            /* Listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * When soft key is pressed, do not carry out any operations.
         * @param   anIndex     Index of soft keys
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * When soft key is released, end the application
         * @param   anIndex     Index of soft keys
         */
        public void softKeyReleased(int anIndex) {
            /* When soft key1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * Receive events occurred in components
         * @param aComponent  Component where an event occurred
         * @param aType  Type of events
         * @param aParam  Parameter of events
         */
        public void componentAction(Component aComponent,int aType,int aParam){
            /* In the case execute button is pressed */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* execute the test method */
                test();
            }
        }

        /**
         * method to execute the test
         */
        public void test() {
            /* Acquisition of selected menu index */
            int idx1 = menu.getSelectedIndex();
            /* URL creation */
            String url = getSourceURL() + "../cgi-bin/post.cgi";

            /* execute HTTP connection */
            HttpConnection con = null;
            OutputStream os = null;
            int len = 5120;
            byte[] data = new byte[len];

            String overmes = null;

            for( int i=0; i<len; i++ ) {
                data[i] = (byte) 'a';
            }
            int length = 0;
            try {
                con = (HttpConnection) Connector.open(url,
                                        Connector.READ_WRITE,true);
                con.setRequestMethod(con.POST);
                os = con.openOutputStream();
                /* 5k output */
                // J312_0301_0201
                os.write(data,0,len);
                os.close();
                con.connect();
                /* get the submitted data and check */
                length = (int) con.getLength();
                con.close();
            } catch( Exception e ) {
                closeConnection(con);
                showDialog("NG: " + e.toString());
                return;
            }

            /* result judgment */
            if( length != len ) {
                showDialog("NG: getLength=" + length);
            } else {
                    showDialog("OK");
            }
        }

        /**
         * close the connection
         * @param con   HttpConnection
         */
        public void closeConnection(HttpConnection con) {
            if( con != null ) {
                try {
                    con.close();
                } catch( Exception e ) {}
            }
        }
    }
}
