/**
 * J331_0101_0201.java
 * 
 * J331_0101_0201
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0101_0201.java,v 1.1 2002/02/01 09:19:21 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class of checking the basic behavior of  Scratchpad 
 * @extends IApplication
 */
public class J331_0101_0201 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the basic behavior of  Scratchpad 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle1      = null;  /* subtitle 1 */
    private  Label     subTitle2      = null;  /* subtitle 2 */
    private  ListBox   menuList       = null;  /* Menu list */
    private  Button    execButton     = null;  /* execute button */
    private  TextBox   resultTextBox  = null;  /* Text box for displaying the result */
    private  String[]  menuListItem   = {
        "0.:0",
        "1.:/0",
        "2.://0",
        "3.:///00",
        "4.:///1",
        "5.:///",
        "6.SCRATCHPAD:///0",
        "7.:/// 0",
        "8.:/// 0 ; pos = 0",
        "9.:///0;pos=abcd",
        "10.:///0;;pos=0",
        "11.:///http",
        "12.:///https",
        "13.:///scratchpad",
        "14.:///resource",
//2002/08/19 DoJa1.5        "15.:///obex",
    };                                         /* Menu list */

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        /* Create and add components */
        setTitle("basic behavior of Scratchpad");

        subTitle1      = new Label("open name behavior");
        subTitle2      = new Label("variation of abnormal recognition");
        menuList      = new ListBox(ListBox.CHOICE,5);
        execButton    = new Button("execute");

        add(subTitle1);
        add(subTitle2);
        add(menuList);
        add(execButton);

        menuList.setItems(menuListItem);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * execute the test
     * @param  menuIndex  index for selection menu
     */
    public void test(int menuIndex) {
        DataOutputStream dos = null;  /*  */

        try {
            switch(menuIndex) {
            /* scratchpad:///0 */
// J331_0101_0201
            case 0:
                dos = Connector.openDataOutputStream(
                    "scratchpad:0");
                break;
// J331_0101_0202
            case 1:
                dos = Connector.openDataOutputStream(
                    "scratchpad:/0");
                break;
// J331_0101_0203
            case 2:
                dos = Connector.openDataOutputStream(
                    "scratchpad://0");
                break;
// J331_0101_0204
            case 3:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///00");
                break;
// J331_0101_0205
            case 4:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///1");
                break;
// J331_0101_0206
            case 5:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///");
                break;
// J331_0101_0207
            case 6:
                dos = Connector.openDataOutputStream(
                    "SCRATCHPAD:///0");
                break;
// J331_0101_0208
            case 7:
                dos = Connector.openDataOutputStream(
                    "scratchpad:/// 0");
                break;
// J331_0101_0209
            case 8:
                dos = Connector.openDataOutputStream(
                    "scratchpad:/// 0 ; pos = 0");
                break;
// J331_0101_0210
            case 9:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///0;pos=abcd");
                break;
// J331_0101_0211
            case 10:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///0;;pos=0");
                break;
// J331_0101_0212
            case 11:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///http");
                break;
// J331_0101_0213
            case 12:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///https");
                break;
// J331_0101_0214
            case 13:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///scratchpad");
                break;
// J331_0101_0215
            case 14:
                dos = Connector.openDataOutputStream(
                    "scratchpad:///resource");
                break;
//2002/08/19 DoJa1.5// J331_0101_0216
//2002/08/19 DoJa1.5            case 15:
//2002/08/19 DoJa1.5                dos = Connector.openDataOutputStream(
//2002/08/19 DoJa1.5                    "scratchpad:///obex");
//2002/08/19 DoJa1.5                break;
            default:
                break;
            }
//            resultTextBox.setText("\"OK\": Open succeeded");
		showMsg("\"OK\": Open succeeded");
        } catch (IOException ioe) {
            showMsg(ioe.toString());
        } catch (Exception e) {
            showMsg(e.toString());
        } finally {
            try {
                if (dos != null) {
                    dos.close();
                }
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test(menuList.getSelectedIndex());
        }
    }
}