/**
 * J331_0102_0201.java
 * 
 * J331_0102_0201
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0102_0201.java,v 1.1 2002/02/01 09:19:22 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class of checking the basic behavior of  Scratchpad 
 * @extends IApplication
 */
public class J331_0102_0201 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the basic behavior of  Scratchpad 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle1       = null;  /* subtitle 1 */
    private  Label     subTitle2       = null;  /* subtitle 2 */
    private  ListBox   menuList        = null;  /* Menu list */
    private  Button    execButton      = null;  /* execute button */
    private  TextBox   resultTextBox   = null;  /* Text box for displaying the result */
    private  String[]  menuListItem    = {
        "0.Test 1",
        "1.Test 2",
        "2.Test 3",
        "3.Test 4",
        "4.Test 5",
        "5.Test 6",
        "6.Test 7",
        "7.Test 8",
        "8.Test 9",
        "9.Test 10",
        "10.Test 11",
        "11.Test 12",
        "12.Test 13",
        "13.Test 14",
        "14.Test 15",
        "15.Test 16"
    };                                         /* Menu list */

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("basic behavior of Scratchpad");

        /* Create and add components */
        subTitle1      = new Label("behavior at the time of opening");
        subTitle2      = new Label("open mode restriction");
        menuList       = new ListBox(ListBox.CHOICE,8);
        execButton     = new Button("execute");
        resultTextBox  = new TextBox("",getWidth(), 3, TextBox.DISPLAY_ANY);
        add(subTitle1);
        add(subTitle2);
        add(menuList);
        add(execButton);
        add(resultTextBox);

        /* Setting of the Menu items */
        menuList.setItems(menuListItem);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * execute the test
     * @param  menuIndex  index for selection menu
     */
    public void test(int menuIndex) {
        InputConnection   inc       = null;
        InputStream       ins       = null;
        DataInputStream   dins      = null;
        OutputConnection  ouc       = null;
        OutputStream      ous       = null;
        DataOutputStream  dous      = null;
        Connection        con       = null;

        switch(menuIndex) {
// J331_0102_0201
        /* InputStream from connection */
        case 0:
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();

                if (ins == null) {
                    resultTextBox.setText("\"NG\":InputStream");
                } else {
                    resultTextBox.setText("\"OK\":InputStream");
                }

                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
// J331_0102_0202
        /* DataInputStream from connection */
        case 1:
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                dins = inc.openDataInputStream();

                if (dins == null) {
                    resultTextBox.setText("\"NG\":DataInputStream");
                } else {
                    resultTextBox.setText("\"OK\":DataInputStream");
                }

                dins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }

            break;
// J331_0102_0203
        /* IOException from connection in OutputStream */
        case 2:
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ous = ouc.openOutputStream();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                if (ous == null) {
                    resultTextBox.setText(
                        "\"OK\": no stream was obtained due to the IOException being generated");
                } else {
                    resultTextBox.setText("\"NG\"");
                }
            }

            try {
//                ous.close();
                ouc.close();
            } catch(IOException ioe) {}
            break;
// J331_0102_0204
        /* IOException in DataOutputStream from connection */
        case 3:
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                dous = ouc.openDataOutputStream();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                if (dous == null) {
                    resultTextBox.setText(
                        "\"OK\": no stream was obtained due to the IOException being generated");
                } else {
                    resultTextBox.setText("\"NG\"");
                }
            }

            try {
//                dous.close();
                ouc.close();
            } catch(IOException ioe) {}
            break;
// J331_0102_0205
        /* InputStream directly by Connector */
        case 4:
            try {
                ins = Connector.openInputStream("scratchpad:///0");

                if (ins == null) {
                    resultTextBox.setText("\"NG\":InputStream");
                } else {
                    resultTextBox.setText("\"OK\":InputStream");
                }

                ins.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }

            break;
// J331_0102_0206
        /* DataInputStream directly by Connector */
        case 5:
            try {
                dins = Connector.openDataInputStream("scratchpad:///0");

                if (dins == null) {
                    resultTextBox.setText("\"NG\":DataInputStream");
                } else {
                    resultTextBox.setText("\"OK\":DataInputStream");
                }

                dins.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }

            break;
// J331_0102_0209
        /* OutputStream from connection */
        case 6:
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();

                if (ous == null) {
                    resultTextBox.setText("\"NG\":OutputStream");
                } else {
                    resultTextBox.setText("\"OK\":OutputStream");
                }

                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
// J331_0102_0210
        /* DataOutputStream from connection */
        case 7:
            try {
                ouc = (OutputConnection)Connector.open(
                "scratchpad:///0",Connector.WRITE,true);
                dous = ouc.openDataOutputStream();

                if (dous == null) {
                    resultTextBox.setText("\"NG\":DataOutputStream");
                } else {
                    resultTextBox.setText("\"OK\":DataOutputStream");
                }

                dous.close();
                ouc.close();
            } catch(IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
        /* IOException from connection in InputStream */
// J331_0102_0211
        case 8:
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ins = inc.openInputStream();

            } catch(IOException ioe) {
                showMsg(ioe.toString());
                if (ins == null) {
                    resultTextBox.setText(
                        "\"OK\": no stream was obtained due to the IOException being generated");

                } else {
                    resultTextBox.setText("\"NG\"");
                }
            }

            try {
//                ins.close();
                inc.close();
            } catch(IOException ioe) {}

            break;
// J331_0102_0212
        /* IOException from connection in DataInputStream */
        case 9:
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                dins = inc.openDataInputStream();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                if (dins == null) {
                    resultTextBox.setText(
                        "\"OK\": no stream was obtained due to the IOException being generated");
                } else {
                    resultTextBox.setText("\"NG\"");
                }
            }

            try {
//                dins.close();
                inc.close();
            } catch(IOException ioe) {}

            break;
// J331_0102_0213
        /* OutputStream by Connector */
        case 10:
            try {
                ous = Connector.openOutputStream("scratchpad:///0");

                if (ous == null) {
                    resultTextBox.setText("\"NG\":OutputStream");
                } else {
                    resultTextBox.setText("\"OK\":OutputStream");
                }

                ous.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
// J331_0102_0214
        /* DataOutputStream by Connector */
        case 11:
            try {
                dous = Connector.openDataOutputStream("scratchpad:///0");

                if (dous == null) {
                    resultTextBox.setText("\"NG\":DataOutputStream");
                } else {
                    resultTextBox.setText("\"OK\":DataOutputStream");
                }

                dous.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
// J331_0102_0217
        /* InputStream from connection */
        case 12:
            try {
                con = Connector.open(
                    "scratchpad:///0", Connector.READ_WRITE,true);
                inc = (InputConnection)con;
                ins = inc.openInputStream();

                if (ins == null) {
                    resultTextBox.setText("\"NG\":InputStream");
                } else {
                    resultTextBox.setText("\"OK\":InputStream");
                }

                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
// J331_0102_0218
        /* DataInputStream from connection */
        case 13:
            try {
                con = Connector.open(
                    "scratchpad:///0", Connector.READ_WRITE,true);
                inc = (InputConnection)con;
                dins = inc.openDataInputStream();

                if (dins == null) {
                    resultTextBox.setText("\"NG\":DataInputStream");
                } else {
                    resultTextBox.setText("\"OK\":DataInputStream");
                }

                dins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
// J331_0102_0219
        /* OutputStream from connection */
        case 14:
            try {
                con = Connector.open(
                    "scratchpad:///0", Connector.READ_WRITE,true);
                ouc = (OutputConnection)con;
                ous = ouc.openOutputStream();

                if (ous == null) {
                    resultTextBox.setText("\"NG\":OutputStream");
                } else {
                    resultTextBox.setText("\"OK\":OutputStream");
                }

                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
// J331_0102_0220
        /* DataOutputStream from connection */
        case 15:
            try {
                con = Connector.open(
                    "scratchpad:///0", Connector.READ_WRITE,true);
                ouc = (OutputConnection)con;
                dous = ouc.openDataOutputStream();

                if (dous == null) {
                    resultTextBox.setText("\"NG\":DataOutputStream");
                } else {
                    resultTextBox.setText("\"OK\":DataOutputStream");
                }

                dous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }
            break;
        default:
            break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {
        /* Implement test */
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test(menuList.getSelectedIndex());
        }
        /* initialize the textbox of result display */
        if (aAction == ComponentListener.SELECTION_CHANGED) {
            resultTextBox.setText("");
        }
    }
}