/**
 * J331_0103_0101.java
 * 
 * J331_0103_0101
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0103_0101.java,v 1.1 2002/02/01 09:19:22 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class of checking the basic behavior of  Scratchpad 
 * @extends IApplication
 */
public class J331_0103_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the basic behavior of  Scratchpad 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle1       = null;  /* subtitle 1 */
    private  Label     subTitle2       = null;  /* subtitle 2 */
    private  ListBox   menuList        = null;  /* Menu list */
    private  Button    execButton      = null;  /* execute button */
    private  TextBox   resultTextBox   = null;  /* Text box for displaying the result */
    private  String[]  menuListItem    = {
        "0.Test 1",
        "1.Test 2",
        "2.Test 3",
        "3.Test 4",
        "4.Test 5",
        "5.Test 6",
        "6.Test 7",
        "7.Test 8",
        "8.Test 9",
        "9.Test 10",
        "10.Test 11",
        "11.Test 12"
    };                                          /* Menu list */

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("basic behavior of Scratchpad");

        /* Create and add components */
        subTitle1      = new Label("closing behavior");
        subTitle2      = new Label("behavior at the time of Connection close");
        menuList       = new ListBox(ListBox.CHOICE,11);
        execButton     = new Button("execute");
        resultTextBox  = new TextBox("",getWidth(), 3, TextBox.DISPLAY_ANY);
        add(subTitle1);
        add(subTitle2);
        add(menuList);
        add(execButton);
        add(resultTextBox);

        /* Setting of the Menu items */
        menuList.setItems(menuListItem);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * execute the test
     * @param  menuIndex  index for selection menu
     */
    public void test(int menuIndex) {
        InputConnection   inc       = null;
        InputStream       ins       = null;
        DataInputStream   dins      = null;
        OutputConnection  ouc       = null;
        OutputStream      ous       = null;
        DataOutputStream  dous      = null;
        Connection        con;

        switch(menuIndex) {
//J331_0103_0101
        /* get InputStream -> InputStream Close -> connection Close */
        case 0:
            try {
             inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0102
        /* get DataInputStream -> DataInputStream Close -> connection Close */
        case 1:
            try {
             inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                dins = inc.openDataInputStream();
                dins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0103
        /* get OutputStream -> OutputStream Close -> connection Close */
        case 2:
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0104
        /* get DataOutputStream->DataOutputStream Close->connection Close */
        case 3:
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                dous = ouc.openDataOutputStream();
                dous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0105
        /* get InputStream->connection Close->InputStream Close */
        case 4:
            try {
             inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                inc.close();
                ins.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0106
        /* get DataInputStream->connection Close->DataInputStream Close */
        case 5:
            try {
             inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                dins = inc.openDataInputStream();
                inc.close();
                dins.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0107
        /* get OutputStream->connection Close->OutputStream Close */
        case 6:
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                ouc.close();
                ous.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0108
        /* get DataOutputStream->connection Close->DataOutputStream Close */
        case 7:
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                dous = ouc.openDataOutputStream();
                ouc.close();
                dous.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0201
        /* openInputStream */
        case 8:
            try {
                ins = Connector.openInputStream("scratchpad:///0");
                ins.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0202
        /* openDataInputStream */
        case 9:
            try {
                dins = Connector.openDataInputStream("scratchpad:///0");
                dins.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                ouc = (OutputConnection)Connector.open(
                    "scratchpad:///0",Connector.WRITE,true);
                ous = ouc.openOutputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ous.close();
                ouc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0203
        /* openOutputStream */
        case 10:
            try {
                ous = Connector.openOutputStream("scratchpad:///0");
                ous.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
//J331_0103_0204
        /* openDataoutputStream */
        case 11:
            try {
                dous = Connector.openDataOutputStream("scratchpad:///0");
                dous.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            }

            /* 
             * check to see if connection is opened
             * change the mode and open 
             */
            try {
                inc = (InputConnection)Connector.open(
                    "scratchpad:///0",Connector.READ,true);
                ins = inc.openInputStream();
                resultTextBox.setText("\"OK\": connection was released");
                ins.close();
                inc.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
                resultTextBox.setText("\"NG\": connection is not released");
            } catch(Exception e) {
                showMsg(e.toString());
                resultTextBox.setText("\"NG\": error occurred");
            }
            break;
        default:
            break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        /* Implement test */
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test(menuList.getSelectedIndex());
        }
        /* initialize the textbox of result display */
        if (aAction == ComponentListener.SELECTION_CHANGED) {
            resultTextBox.setText("");
        }
    }
}