/**
 * J331_0104_0101.java
 * 
 * J331_0104_0101
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0104_0101.java,v 1.1 2002/02/01 09:19:22 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class of checking the basic behavior of  Scratchpad 
 * @extends IApplication
 */
public class J331_0104_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the basic behavior of  Scratchpad 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle1       = null;  /* subtitle 1 */
    private  Label     subTitle2       = null;  /* subtitle 2 */
    private  Button    execButton      = null;  /* execute button */
    private  TextBox   resultTextBox   = null;  /* Text box for displaying the result */
    private  int       size            = 20;
    private  int       i;
    private  int       k;
    private  int[]     a               = new int[20];
    private  byte[]    b               = new byte[20];
    private  String    SPread;

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("basic behavior of Scratchpad");

        /* Create and add components */
        subTitle1      = new Label("scratchpad independent behavior");
        subTitle2      = new Label("Initial status");
        execButton     = new Button("execute");
        resultTextBox  = new TextBox("",getWidth(), 3, TextBox.DISPLAY_ANY);
        add(subTitle1);
        add(subTitle2);
        add(execButton);
        add(resultTextBox);

        execButton.setSize(getWidth(),execButton.getHeight());

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

//J331_0104_0101
    /*
     * Read Scratchpad
     */
    private void load() {
        InputStream is = null;
        SPread = new String("");

        try {
            is = Connector.openInputStream("scratchpad:///0");
            for (i = 0; i < size; i++) {
                a[i] = is.read();
                b[i] = (byte) a[i];
                if (a[i] == -1) {
                    break;
                }
            }
            for (k = 0; k < 20; k++) {
                if (b[k] != 0) {
                    break;
                }
            }

            if (k != 20) {
                resultTextBox.setText("NG");
            } else {
                resultTextBox.setText("OK");
            }
        } catch (IOException ioe) {
            showMsg("NG(IOException)");
        } catch (Exception e) {
            showMsg("NG : " + e.toString());  
        } finally {
            try {
                if (is != null) is.close();
            } catch (IOException ie) {
                showMsg("close:NG");
            }
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        /* Implement test */
//J331_0104_0101
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            load();
        }
    }
}