/**
 * J331_0104_0301.java
 * 
 * J331_0104_0301
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0104_0301.java,v 1.1 2002/02/01 09:19:23 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class of checking the basic behavior of  Scratchpad 
 * @extends IApplication
 */
public class J331_0104_0301 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the basic behavior of  Scratchpad 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle1       = null;  /* subtitle 1 */
    private  Label     subTitle2       = null;  /* subtitle 2 */
    private  ListBox   menuList        = null;  /* Menu list */
    private  Button    execButton1     = null;  /* write 1 button */
    private  Button    execButton2     = null;  /* write 2 button */
    private  Button    execButton3     = null;  /* read button */
    private  TextBox   textBox1        = null;  /* for data input */
    private  TextBox   textBox2        = null;  /* for displaying the result of the read operations  */

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
             textBox2.setText("save data " + load());
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("basic behavior of Scratchpad");

        /* Create and add components */
        subTitle1       = new Label("scratchpad independent behavior");
        subTitle2       = new Label("transaction behavior");
        menuList        = new ListBox(ListBox.CHOICE,7);
        execButton1     = new Button("save 1");
        execButton2     = new Button("save 2");
        execButton3     = new Button("abnormal termination");
        textBox1        = new TextBox("",getWidth(), 1, TextBox.DISPLAY_ANY);
        textBox2        = new TextBox("",getWidth(), 2, TextBox.DISPLAY_ANY);
        add(subTitle1);
        add(subTitle2);
        add(textBox1);
        add(execButton1);
        add(execButton2);
        add(execButton3);
        add(textBox2);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

//J331_0104_0301
//J331_0104_0302
//J331_0104_0303
    /**
     * write inputted data onto the scratchpad
     * @param  str  input data
     */
    public void save1(String str){
        try{
            DataOutputStream out =
                Connector.openDataOutputStream("scratchpad:///0");
            out.writeUTF(str);
            out.close();
        }catch(IOException ioe){
            showMsg(ioe.toString());
        } catch(Exception e) {
            showMsg(e.toString());
        }
    }

//J331_0104_0304
//J331_0104_0305
//J331_0104_0306
//J331_0104_0307
    /**
     * write inputted data onto the scratchpad
     * not close the scratchpad
     * @param  str  input data
     */
    public void save2(String str){
      try{
          DataOutputStream out =
              Connector.openDataOutputStream("scratchpad:///0");
          out.writeUTF(str);
//        out.close();
        }catch(IOException ioe){
            showMsg(ioe.toString());
        } catch(Exception e) {
            showMsg(e.toString());
        }
    }

//J331_0104_0301
//J331_0104_0302
//J331_0104_0303
//J331_0104_0304
//J331_0104_0305
//J331_0104_0307
//J331_0104_0307
    /**
     * read data from the scratchpad
     * @param  str  input data
     */
    public String load(){
      String str = new String();

      try{
        DataInputStream in =
            Connector.openDataInputStream("scratchpad:///0");
        str = in.readUTF();
        in.close();
      }catch(IOException e){
        }
      return str;
    }

//J331_0104_0307
    /**
     * method of abnormal termination
     */
    void abnormalEnd() {
        Button abnormalButton = null;
        add(abnormalButton);
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        /* Implement test */
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            if (aComponent == execButton1) {
                 save1(textBox1.getText());
                 textBox1.setText("");
            }
            if (aComponent == execButton2) {
                 save2(textBox1.getText());
                 textBox1.setText("");
            }
            if (aComponent == execButton3) {
//                  textBox2.setText("save data:"+load());
                abnormalEnd();
            }
        }
        /* initialize the textbox of result display */
        if (aAction == ComponentListener.SELECTION_CHANGED) {
            textBox1.setText("");
            textBox2.setText("");
        }
    }
}
