/**
 * J331_0105_0201.java
 * 
 * J331_0105_0201
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0105_0201.java,v 1.1 2002/02/01 09:19:24 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class of checking the basic behavior of  Scratchpad 
 * @extends IApplication
 */
public class J331_0105_0201 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen of basic behavior menu for Scratchpad
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle1       = null;  /* subtitle 1 */
    private  Label     subTitle2       = null;  /* subtitle 2 */
    private  ListBox   menuList        = null;  /* Menu list */
    private  Button    execButton1     = null;  /* execute button 1 */
    private  Button    execButton2     = null;  /* execute button 2 */
    private  TextBox   resultText      = null;  /* Text box for displaying the result */
    private  String[]  menuListItem    = {
        "0.Test 1",
        "1.Test 2",
        "2.Test 3",
        "3.Test 4",
        "4.Test 5",
        "5.Test 6",
        "6.Test 7",
        "7.Test 8",
        "8.Test 9",
        "9.Test 10",
        "10.Test 11",
        "11.Test 12",
        "12.Test 13",
        "13.Test 14",
        "14.Test 15",
        "15.Test 16",
        "16.Test 17",
        "17.Test 18",
        "18.Test 19",
    };                                          /* Menu list */
    InputConnection   ic               = null;
    InputStream       is               = null;
    DataInputStream   dis              = null;
    OutputConnection  oc               = null;
    OutputStream      os               = null;
    DataOutputStream  dos              = null;
    Connection        con              = null;
    byte              byt[]            = null;
    boolean           bl               = false;

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("basic behavior of Scratchpad");

        /* Create and add components */
        subTitle1      = new Label("input/output behavior");
        subTitle2      = new Label("InputStream behavior");
        menuList       = new ListBox(ListBox.CHOICE,5);
        execButton1    = new Button("Write");
        execButton2    = new Button("Read");
        resultText     = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);
        add(subTitle1);
        add(subTitle2);
        add(menuList);
        add(execButton1);
        add(execButton2);
        add(resultText);

        menuList.setItems(menuListItem);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * method to read into the scratchpad
     * @param  index  menu index
     */
    void load(int index) {

        byt    = new byte[10];
        boolean okFlag = false;

        switch (index) {
//J331_0105_0201
        case 0:
            try {
                is=Connector.openInputStream("scratchpad:///0");
                if (is.read() == 99) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                is.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (is != null) is.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0202
        case 1:
            try {
                is=Connector.openInputStream("scratchpad:///0");
                if (is.read(byt) == 10) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                is.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (is != null) is.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0203
        case 2:
            try {
                is=Connector.openInputStream("scratchpad:///0");
                if (is.read(byt,0,5) == 5) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                is.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (is != null) is.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0205
        case 3:
            try {
                is=Connector.openInputStream("scratchpad:///0");
                is.skip(5);
                if (is.read() == 4) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                is.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) is.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0301
        case 4:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.read() == 9) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0302
        case 5:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.read(byt) == 10) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0303
        case 6:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.read(byt,0,5) == 5) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0304
        case 7:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readBoolean() == false) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0305
        case 8:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readByte() == 99) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0306
        case 9:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readChar() == 99) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0307
        case 10:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                okFlag = true;
                dis.readFully(byt);
                dis.close();
            } catch (Exception e) {
                okFlag = false;
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    okFlag = false;
                    showMsg("close:NG");
                }
            }

            if (okFlag = true) {
                resultText.setText("read OK");
            } else {
                resultText.setText("read NG");
            }
            break;
//J331_0105_0308
        case 11:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                okFlag = true;
                dis.readFully(byt, 1, 1);
                dis.close();
            } catch (Exception e) {
                okFlag = false;
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    okFlag = false;
                    showMsg("close:NG");
                }
            }

            if (okFlag = true) {
                resultText.setText("read OK");
            } else {
                resultText.setText("read NG");
            }
            break;
//J331_0105_0309
        case 12:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readInt() == 99) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0310
        case 13:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readLong() == 9999) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0311
        case 14:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readShort() == 1) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0312
        case 15:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readUnsignedByte() == 99) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0313
        case 16:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                if (dis.readUnsignedShort() == 99) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0314
        case 17:
            try {
                dis=Connector.openDataInputStream("scratchpad:///0");
                String testStr = dis.readUTF();
                if (testStr.equals("test")) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                dis.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (dis != null) dis.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0316
        case 18:
            try {
                is=Connector.openInputStream("scratchpad:///0");
                is.skip(5);
                if (is.read() == 4) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                is.close();
            } catch (Exception e) {
                showMsg(e.toString());  
            } finally {
                try {
                    if (is != null) is.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
        default:
            break;
        }
    }

    /**
     * method to write into the scratchpad
     * @param  index  menu index
     */
    void save(int index) {
        byt = new byte[10];
        byt[0] = 9;
        byt[1] = 8;
        byt[2] = 7;
        byt[3] = 6;
        byt[4] = 5;
        byt[5] = 4;
        byt[6] = 3;
        byt[7] = 2;
        byt[8] = 1;
        byt[9] = 0;

        try {
        switch (index) {
//J331_0105_0401
        case 0:
            int intWrite = 99;
            try {

                DataOutputStream out =
                Connector.openDataOutputStream("scratchpad:///0");
                out.write(99);
                out.close();

                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (os != null) os.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0402
        case 1:
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                os.write(byt);
                os.close();
                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (os != null) os.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0403
        case 2:
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                os.write(byt,0,5);
                os.close();
                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (os != null) os.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
        case 3:
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                os.write(byt);
                os.close();
                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (os != null) os.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0501
        case 4:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.write(byt);
                dos.close();
                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0502
        case 5:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.write(byt);
                dos.close();
                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0503
        case 6:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.write(byt,0,5);
                dos.close();
                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0504
        case 7:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeBoolean(bl);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0505
        case 8:
            int writeByteInt = 99;
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeByte(writeByteInt);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0506
        case 9:
            int writeChar = 99;
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeChar(writeChar);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0507
        case 10:
            String writeChars = "XYZ";
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeChars(writeChars);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
        case 11:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.write(byt);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0508
        case 12:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeInt(99);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0509
        case 13:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeLong(9999);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_0510
        case 14:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeShort(1);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
        case 15:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeByte(99);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
        case 16:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeShort(99);
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
//J331_0105_05011
        case 17:
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                dos.writeUTF("test");
                resultText.setText("write OK");
                dos.close();
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (dos != null) dos.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
        case 18:
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                os.write(byt);
                os.close();
                resultText.setText("write OK");
            } catch (IOException e) {
                showMsg("Write:NG" + e.toString());
            } finally {
                try {
                    if (os != null) os.close();
                } catch (IOException ie) {
                    showMsg("close:NG");
                }
            }
            break;
        default:
            break;
        }
        } catch(Exception e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        /* Implement test */
        if (aAction == ComponentListener.BUTTON_PRESSED) {
            if (aComponent == execButton1) {
                if (menuList.getSelectedIndex() == 0) {
                    save(0);
                }
                if (menuList.getSelectedIndex() == 1) {
                    save(1);
                }
                if (menuList.getSelectedIndex() == 2) {
                    save(2);
                }
                if (menuList.getSelectedIndex() == 3) {
                    save(3);
                }
                if (menuList.getSelectedIndex() == 4) {
                    save(4);
                }
                if (menuList.getSelectedIndex() == 5) {
                    save(5);
                }
                if (menuList.getSelectedIndex() == 6) {
                    save(6);
                }
                if (menuList.getSelectedIndex() == 7) {
                    save(7);
                }
                if (menuList.getSelectedIndex() == 8) {
                    save(8);
                }
                if (menuList.getSelectedIndex() == 9) {
                    save(9);
                }
                if (menuList.getSelectedIndex() == 10) {
                    save(10);
                }
                if (menuList.getSelectedIndex() == 11) {
                    save(11);
                }
                if (menuList.getSelectedIndex() == 12) {
                    save(12);
                }
                if (menuList.getSelectedIndex() == 13) {
                    save(13);
                }
                if (menuList.getSelectedIndex() == 14) {
                    save(14);
                }
                if (menuList.getSelectedIndex() == 15) {
                    save(15);
                }
                if (menuList.getSelectedIndex() == 16) {
                    save(16);
                }
                if (menuList.getSelectedIndex() == 17) {
                    save(17);
                }
                if (menuList.getSelectedIndex() == 18) {
                    save(18);
                }
            }
            if (aComponent == execButton2) {
                if (menuList.getSelectedIndex() == 0) {
                    load(0);
                }
                if (menuList.getSelectedIndex() == 1) {
                    load(1);
                }
                if (menuList.getSelectedIndex() == 2) {
                    load(2);
                }
                if (menuList.getSelectedIndex() == 3) {
                    load(3);
                }
                if (menuList.getSelectedIndex() == 4) {
                    load(4);
                }
                if (menuList.getSelectedIndex() == 5) {
                    load(5);
                }
                if (menuList.getSelectedIndex() == 6) {
                    load(6);
                }
                if (menuList.getSelectedIndex() == 7) {
                    load(7);
                }
                if (menuList.getSelectedIndex() == 8) {
                    load(8);
                }
                if (menuList.getSelectedIndex() == 9) {
                    load(9);
                }
                if (menuList.getSelectedIndex() == 10) {
                    load(10);
                }
                if (menuList.getSelectedIndex() == 11) {
                    load(11);
                }
                if (menuList.getSelectedIndex() == 12) {
                    load(12);
                }
                if (menuList.getSelectedIndex() == 13) {
                    load(13);
                }
                if (menuList.getSelectedIndex() == 14) {
                    load(14);
                }
                if (menuList.getSelectedIndex() == 15) {
                    load(15);
                }
                if (menuList.getSelectedIndex() == 16) {
                    load(16);
                }
                if (menuList.getSelectedIndex() == 17) {
                    load(17);
                }
                if (menuList.getSelectedIndex() == 18) {
                    load(18);
                }
            }
        }
        if (aAction == ComponentListener.SELECTION_CHANGED) {
            resultText.setText("");
        }
    }
}
