/**
 * J331_0106_0101.java
 * 
 * J331_0106_0101
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0106_0101.java,v 1.2 2002/03/12 02:48:40 takanao Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class of checking the basic behavior of  Scratchpad 
 * @extends IApplication
 */
public class J331_0106_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the basic behavior of  Scratchpad 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle       = null;  /* subtitle 1 */
    private  ListBox   menuList        = null;  /* Menu list */
    private  Button    execButton1     = null;  /* write button */
    private  Button    execButton2     = null;  /* read button */
    private  TextBox   resultText      = null;  /* Text box for displaying the result */
    private  String[]  menuListItem    = {
        "0.Test 1",
        "1.Test 2",
        "2.Test 3",
        "3.Test 4",
        "4.Test 5",
        "5.Test 6",
        "6.Test 7",
        "7.Test 8",
        "8.Test 9",
        "9.Test 10",
        "10.Test 11",
        "11.Test 12",
        "12.Test 13",
        "13.Test 14",
        "14.Test 15",
        "15.Test 16",
        "16.Test 17",
        "17.Test 18",
        "18.Test 19",
        "19.Test 20"
    };                                         /* Menu list */

    private  InputConnection   ic      = null;
    private  InputConnection   ic2     = null;
    private  InputStream       is      = null;
    private  DataInputStream   dis     = null;
    private  OutputConnection  oc      = null;
    private  OutputConnection  oc2     = null;
    private  OutputStream      os      = null;
    private  DataOutputStream  dos     = null;
    private  Connection        con     = null;
    private  Connection        con2    = null;

    private  boolean           okFlag  = false;

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("basic behavior of Scratchpad");

        /* Create and add components */
        subTitle       = new Label("multiple open behavior");
        menuList       = new ListBox(ListBox.CHOICE,20);
        execButton1    = new Button("execute");
        execButton2    = new Button("preparation");
        resultText     = new TextBox("",getWidth(), 2, TextBox.DISPLAY_ANY);
        add(subTitle);
        add(menuList);
        add(execButton1);
        add(execButton2);
        add(resultText);

        /* Setting of the Menu items */
        menuList.setItems(menuListItem);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * Test method
     */
    void test1() {
        switch (menuList.getSelectedIndex()) {
// J331_0106_0101
            case 0:
                try {
                    ic = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    ic2 = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    ic.close();
                    ic2.close();
                    okFlag = true;
                    ic.close();
                } catch (IOException ioe) {
                    okFlag = false;
                    showMsg(ioe.toString());
                    resultText.setText("NG");
                } catch (Exception e) {
                    okFlag = false;
                    showMsg(e.toString());
                }

                if (okFlag == true) {
                    resultText.setText("read OK");
                } else {
                    resultText.setText("read NG");
                }
                break;
// J331_0106_0102
            case 1:
                readTestThread testThread = new readTestThread();
                testThread.start();
                break;
// J331_0106_0103
            case 2:
                try {
                    ic = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    os = Connector.openOutputStream("scratchpad:///0");
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                } catch (Exception e) {
                    showMsg(e.toString());
                }
                break;
// J331_0106_0104
            case 3:
                try {
                    ic = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    ic2 = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    ic.close();
                    ic2.close();
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    okFlag = true;
                    resultText.setText("multiple Open:OK");
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                    resultText.setText("multiple Open:NG");
                } catch (Exception e) {
                    resultText.setText("multiple Open:NG");
                    showMsg(e.toString());
                }
                break;
// J331_0106_0105
            case 4:
                try {
                    ic = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                } catch (Exception e) {
                    showMsg(e.toString());
                }
                break;
// J331_0106_0106
            case 5:
                try {
                    ic = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    ic2 = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    ic.close();
                    ic2.close();
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    okFlag = true;
                    resultText.setText("multiple Open:OK");
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                    resultText.setText("multiple Open:NG");
                } catch (Exception e) {
                    resultText.setText("multiple Open:NG");
                    showMsg(e.toString());
                }
                break;
// J331_0106_0201
            case 6:
                try {
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    is = Connector.openInputStream("scratchpad:///0");
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_00202
            case 7:
                try {
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    oc.close();
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ,true);
                    okFlag = true;
                    resultText.setText("READ_Open:OK");
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                    resultText.setText("READ_Open:NG");
                } catch (Exception e) {
                    resultText.setText("READ_Open:NG");
                    showMsg(e.toString());
                }
                break;
// J331_0106_0203
            case 8:
                try {
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    os = Connector.openOutputStream("scratchpad:///0");
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0204
            case 9:
                try {
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    oc.close();
                    con = Connector.open(
                        "scratchpad:///0", Connector.WRITE,true);
                    okFlag = true;
                    resultText.setText("WRITE_Open:OK");
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                    resultText.setText("WRITE_Open:NG");
                } catch (Exception e) {
                    resultText.setText("WRITE_Open:NG");
                    showMsg(e.toString());
                }
                break;
// J331_0106_0205
            case 10:
                try {
//2002/09/25 Doja1.5                    os = Connector.openOutputStream("scratchpad:///0");
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0206
            case 11:
                try {
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    oc.close();
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    okFlag = true;
                    resultText.setText("WRITE_Open:OK");
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                    resultText.setText("WRITE_Open:NG");
                } catch (Exception e) {
                    resultText.setText("WRITE_Open:NG");
                    showMsg(e.toString());
                }
                break;
// J331_0106_0301
            case 12:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    ic = (InputConnection)con;
                    is = ic.openInputStream();
                    oc = (OutputConnection)con;
                    os = oc.openOutputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0302
            case 13:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    ic = (InputConnection)con;
                    is = ic.openInputStream();
                    oc = (OutputConnection)con;
                    dos = oc.openDataOutputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0303
            case 14:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    ic = (InputConnection)con;
                    dis = ic.openDataInputStream();
                    oc = (OutputConnection)con;
                    os = oc.openOutputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0304
            case 15:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    ic = (InputConnection)con;
                    dis = ic.openDataInputStream();
                    oc = (OutputConnection)con;
                    dos = oc.openDataOutputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0305
            case 16:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    oc = (OutputConnection)con;
                    os = oc.openOutputStream();
                    ic = (InputConnection)con;
                    is = ic.openInputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0306
            case 17:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    oc = (OutputConnection)con;
                    os = oc.openOutputStream();
                    ic = (InputConnection)con;
                    dis = ic.openDataInputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0307
            case 18:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    oc = (OutputConnection)con;
                    dos = oc.openDataOutputStream();
                    ic = (InputConnection)con;
                    is = ic.openInputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
// J331_0106_0308
            case 19:
                try {
                    con = Connector.open(
                        "scratchpad:///0", Connector.READ_WRITE,true);
                    oc = (OutputConnection)con;
                    dos = oc.openDataOutputStream();
                    ic = (InputConnection)con;
                    dis = ic.openDataInputStream();
                } catch (ConnectionException ce) {
//2002/09/25 Doja1.5                    showMsg("CE:"+ce.getMessage());
                    showMsg(ce.toString());
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                }
                break;
            default:
                break;
        }
    }

    /**
     * method of preparing the test
     */
    void test2() {
        switch (menuList.getSelectedIndex()) {
            case 0:
                    showMsg("0.\"ready\" button is not used in the test 1");
                break;
// J331_0106_0102
            case 1:
                try {
                    oc = (OutputConnection)Connector.open(
                        "scratchpad:///0",Connector.WRITE,true);
                    os = oc.openOutputStream();
                    os.write(99);
                    os.close();
                    oc.close();

                    ic = (InputConnection)Connector.open(
                        "scratchpad:///0",Connector.READ,true);
                    is = ic.openInputStream();
                    resultText.setText("preparation OK");
                } catch (IOException ioe) {
                    showMsg(ioe.toString());
                    resultText.setText("preparation NG");
                } catch (Exception e) {
                    showMsg(e.toString());
                    resultText.setText("preparation NG");
                }
                break;
            case 2:
                    showMsg("2.\"ready\" button is not used in the test 3");
                break;
            case 3:
                    showMsg("3.\"ready\" button is not used in the test 4");
                break;
            case 4:
                    showMsg("4.\"ready\" button is not used in the test 5");
                break;
            case 5:
                    showMsg("5.\"ready\" button is not used in the test 6");
                break;
            case 6:
                    showMsg("6.\"ready\" button is not used in the test 7");
                break;
            case 7:
                    showMsg("7.\"ready\" button is not used in the test 8");
                break;
            case 8:
                    showMsg("8.\"ready\" button is not used in the test 9");
                break;
            case 9:
                    showMsg("9.\"ready\" button is not used in the test 10");
                break;
            case 10:
                    showMsg("10.\"ready\" button is not used in the test 11");
                break;
            case 11:
                    showMsg("11.\"ready\" button is not used in the test 12");
                break;
            case 12:
                    showMsg("12.\"ready\" button is not used in the test 13");
                break;
            case 13:
                    showMsg("12.\"ready\" button is not used in the test 14");
                break;
            case 14:
                    showMsg("14.\"ready\" button is not used in the test 15");
                break;
            case 15:
                    showMsg("15.\"ready\" button is not used in the test 16");
                break;
            case 16:
                    showMsg("16.\"ready\" button is not used in the test 17");
                break;
            case 17:
                    showMsg("17.\"ready\" button is not used in the test 18");
                break;
            case 18:
                    showMsg("18.\"ready\" button is not used in the test 19");
                break;
            case 19:
                    showMsg("19.\"ready\" button is not used in the test 20");
                break;
            default:
                break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        if (aAction == ComponentListener.BUTTON_PRESSED) {
            if (aComponent == execButton1) {
                test1();
            }
            if (aComponent == execButton2) {
                test2();
            }
        }
        if (aAction == ComponentListener.SELECTION_CHANGED) {
            resultText.setText("");
        }
    }

    /**
     * thread class for the test
     * @extends Thread
     */
    class readTestThread extends Thread {
        /**
         * ReadThread constructor
         */
        public readTestThread() {}

// J331_0106_0102
        /**
         *  run method
         */
         public void run() {
            try {
                if (is.read() == 99) {
                    resultText.setText("read OK");
                    is.close();
                    ic.close();
                } else {
                    resultText.setText("read NG");
                }
            } catch (IOException ioe) {
                showMsg(ioe.toString());
                resultText.setText("read NG");
            } catch (Exception e) {
                showMsg(e.toString());
                resultText.setText("read NG");
            }
        }
    }

}
