/**
 * J331_0201_0101.java
 * 
 * J331_0201_0101
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J331_0201_0101.java,v 1.1 2002/02/01 09:19:25 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.net.*;

/**
 * main class for checking the behavior of Scratchpad interworking 
 * @extends IApplication
 */
public class J331_0201_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the behavior of Scratchpad inteworking  
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    private  Label     subTitle1       = null;  /* subtitle 1 */
    private  Label     subTitle2       = null;  /* subtitle 2 */
    private  ListBox   menuList        = null;  /* Menu list */
    private  Button    execButton      = null;  /* execute button */
    private  TextBox   resultText      = null;  /* Text box for displaying the result */
    private  String[]  menuListItem    = {
//2002/08/08 DoJa1.5        "0.Test 1",
        "1.Test 2",
        "2.Test 3"
    };
    private  byte      byt[]           = null;

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("basic behavior of Scratchpad");

        /* Create and add components */
        subTitle1      = new Label("behavior of saving characters");
        subTitle2      = new Label("character code variation");
        menuList       = new ListBox(ListBox.CHOICE,20);
        execButton     = new Button("execute");
        resultText     = new TextBox("",getWidth(), 2, TextBox.DISPLAY_ANY);
        add(subTitle1);
        add(subTitle2);
        add(menuList);
        add(execButton);
        add(resultText);

        /* Setting of the Menu items */
        menuList.setItems(menuListItem);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * execute the test
     */
    void test() {
        switch (menuList.getSelectedIndex()) {
// J331_0201_0101
//2002/08/08 DoJa1.5        case 0:
//2002/08/08 DoJa1.5            try {
//2002/08/08 DoJa1.5                String str1 = "1";
//2002/08/08 DoJa1.5                OutputStream os =
//2002/08/08 DoJa1.5                    Connector.openOutputStream("scratchpad:///0;pos=0");
//2002/08/08 DoJa1.5                OutputStreamWriter osw = new OutputStreamWriter(
//2002/08/08 DoJa1.5                    os,"SJIS");
//2002/08/08 DoJa1.5                osw.write(str1,0,str1.length());
//2002/08/08 DoJa1.5                osw.close();
//2002/08/08 DoJa1.5                os.close();
//2002/08/08 DoJa1.5
//2002/08/08 DoJa1.5                InputStream is =
//2002/08/08 DoJa1.5                    Connector.openInputStream("scratchpad:///0;pos=0");
//2002/08/08 DoJa1.5                InputStreamReader isr = new InputStreamReader(
//2002/08/08 DoJa1.5                    is,"SJIS");
//2002/08/08 DoJa1.5
//2002/08/08 DoJa1.5                if (isr.read() == 49) {
//2002/08/08 DoJa1.5                    resultText.setText("OK to read and write");
//2002/08/08 DoJa1.5                    isr.close();
//2002/08/08 DoJa1.5                    is.close();
//2002/08/08 DoJa1.5                } else {
//2002/08/08 DoJa1.5                    resultText.setText("NG to read and write");
//2002/08/08 DoJa1.5                }
//2002/08/08 DoJa1.5            }
//2002/08/08 DoJa1.5            catch (Exception e) {
//2002/08/08 DoJa1.5            }
//2002/08/08 DoJa1.5            break;
// J331_0201_0102
//2002/08/08 DoJa1.5        case 1:
            case 0:
//2002/09/27 Doja1.5                String testStr   = "a"; /* %82%A0 */
                String testStr   = "\uE63E"; /* %EE%98%BE */
                String encodeStr = "";
            try {
                DataOutputStream dos =
                    Connector.openDataOutputStream("scratchpad:///0;pos=0");
                encodeStr = URLEncoder.encode(testStr);
                dos.writeUTF(encodeStr);
                dos.close();

                DataInputStream dis =
                    Connector.openDataInputStream("scratchpad:///0;pos=0");

//2002/09/27 Doja1.5                if (dis.readUTF().equals("%82%A0")) {
                    if (dis.readUTF().equals("%EE%98%BE")) {
                    resultText.setText("OK to read and write");
                    dis.close();
                } else {
                    resultText.setText("NG to read and write");
                }
            } catch (IOException ioe) {
                showMsg(ioe.toString());
            } catch (Exception e) {
                showMsg(e.toString());
            }
            break;
// J331_0201_0103
//2002/08/08 DoJa1.5        case 2:
            case 1:
            try {
                OutputStream out =
                    Connector.openOutputStream("scratchpad:///0;pos=0");
                out.write(99);
                out.close();
                InputStream in = 
                    Connector.openInputStream("scratchpad:///0;pos=0");

                if (in.read() == 99) {
                    resultText.setText("OK to read and write");
                    in.close();
                } else {
                    resultText.setText("NG to read and write");
                }
            } catch (IOException ioe) {
                showMsg(ioe.toString());
            } catch (Exception e) {
                showMsg(e.toString());
            }
            break;
        default:
            break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test();
        }
        if (aAction == ComponentListener.SELECTION_CHANGED) {
            resultText.setText("");
        }
    }
}