/**
 * J333_0101_0101.java
 * 
 * J333_0101_0101
 * MenuPanel
 * 
 * communication interlocking test (Scratchpad)
 * 
 * $Id: J333_0101_0101.java,v 1.1 2002/02/01 09:20:30 waka Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

/**
 * main class for checking the repeat behavior of single operation of Scratchpad
 * @extends IApplication
 */
public class J333_0101_0101 extends IApplication {
    /**
     * Commencing method to i-appli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }
}

/**
 * screen to check the repeat behavior of single operation of Scratchpad
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
    Label            subTitle      = null;  /* subtitle 1 */
    ListBox          menuList      = null;  /* Menu list */
    Button           execButton    = null;  /* execute button */
    TextBox          resultText    = null;  /* Text box for displaying the result */
    boolean          okFlag        = false; /* Flag for determination of test result */
    String[]         menuListItem  = {
        "0.Test 1",
        "1.Test 2",
        "2.Test 3",
        "3.Test 4",
        "4.Test 5",
        "5.Test 6",
        "6.Test 7",
        "7.Test 8"
    };
    InputStream      is            = null;
    DataInputStream  dis           = null;
    InputConnection  ic            = null;
    OutputStream     os            = null;
    DataOutputStream dos           = null;
    OutputConnection oc            = null;
    Connection       con           = null;
    int              i             = 0;
    int              counter       = 0;
    int              writeCounter  = 0;    /* the number of the write operations */
    int              readCounter   = 0;    /* the number of the read operations */

    /**
     * Constructor of MenuPanel class
     */
    MenuPanel() {
        try {
            showMainPanel();
        } catch(Exception e) {
            showMsg(e.toString());
        } catch(Error e) {
            showMsg(e.toString());
        }
    }

    /**
     * Display the main panel
     */
    public void showMainPanel() {
        setTitle("boundary behavior at the time of reading SP");

        /* Create and add components */
        subTitle      = new Label("mode-wise repeat ");
        menuList       = new ListBox(ListBox.CHOICE,8);
        execButton     = new Button("execute");
        resultText     = new TextBox("",getWidth(), 3, TextBox.DISPLAY_ANY);
        add(subTitle);
        add(menuList);
        add(execButton);
        add(resultText);

        /* Setting of the Menu items */
        menuList.setItems(menuListItem);

        /* Setting of the soft key label */
        setSoftLabel(Frame.SOFT_KEY_1,"exit");

        /* Listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * The method of confirming operations
     */
    void test() {
        int readValue1 = 0;
        int readValue2 = 0;
        int writeTest1 = 0;
        int writeTest2 = 0;
        /* behavior check */
        switch (menuList.getSelectedIndex()) {
// J333_0101_0101
        case 0:
            counter = 100;
            /* write data for checking */
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++){
                    os.write(i);
                }
                os.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }

                if (writeTest2 != 5050) {
                    resultText.setText("preparation (write) NG");
                    return;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* check the read operations */
            try {
                is = Connector.openInputStream("scratchpad:///0");

                for (i = 1; i <= counter/2; i++) {
                    readValue1 = is.read();
                    readValue2 = is.read();
                    if (readValue1 == readValue2) {
                        if (readValue1 != -1||readValue2 != -1) {
                            resultText.setText("\"NG\"");
                            return;
                        }
                    }
                    /* OK will be shown if it reaches 50 */
                    if (i == (counter / 2)) {
                        okFlag = true;
                    }
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("read OK");
            } else {
                resultText.setText("NG");
            }
            break;
// J333_0101_0102
        case 1:
            counter = 100;
            /* write data for checking */
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++){
                    os.write(i);
                }
                os.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }

                if (writeTest2 != 5050) {
                    resultText.setText("preparation (write) NG");
                    return;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* check the read operations */
            try {
                dis = Connector.openDataInputStream("scratchpad:///0");

                for (i = 1; i <= counter/2; i++) {
                    readValue1 = dis.read();
                    readValue2 = dis.read();
                    if (readValue1 == readValue2) {
                        if (readValue1 != -1||readValue2 != -1) {
                            resultText.setText("\"NG\"");
                            return;
                        }
                    }
                    /* OK will be shown if it reaches 50 */
                    if (i == (counter / 2)) {
                        okFlag = true;
                    }
                }
                dis.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("read OK");
            } else {
                resultText.setText("NG");
            }
            break;
// J333_0101_0201
        case 2:
            counter = 100;
            /* check the write operations */
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++){
                    os.write(i);
                }
                os.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }

                if (writeTest2 == 5050) {
                    okFlag = true;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("write OK");
            } else {
                resultText.setText("NG");
            }
            break;
// J333_0101_0202
        case 3:
            counter = 100;
            /* check the write operations */
            try {
                dos = Connector.openDataOutputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++){
                    dos.write(i + 10);
                }
                dos.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }
                if (writeTest2 == 6050) {
                    okFlag = true;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("write OK");
            } else {
                resultText.setText("NG");
            }
            break;
// J333_0101_0301
        case 4:
            counter = 100;
            /* write data for checking */
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++){
                    os.write(i);
                }
                os.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }

                if (writeTest2 != 5050) {
                    resultText.setText("preparation (write) NG");
                    return;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* check the read operations */
            try {
                con = Connector.open(
                    "scratchpad:///0", Connector.READ_WRITE,true);
                ic = (InputConnection)con;
                is = ic.openInputStream();

                for (i = 1; i <= counter/2; i++) {
                    readValue1 = is.read();
                    readValue2 = is.read();
                    if (readValue1 == readValue2) {
                        if (readValue1 != -1||readValue2 != -1) {
                            resultText.setText("\"NG\"");
                            return;
                        }
                    }
                    /* OK will be shown if it reaches 50 */
                    if (i == (counter / 2)) {
                        okFlag = true;
                    }
                }
                is.close();
                ic.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("read OK");
            } else {
                resultText.setText("NG");
            }
            break;
// J333_0101_0302
        case 5:
            counter = 100;
            /* write data for checking */
            try {
                os = Connector.openOutputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++){
                    os.write(i);
                }
                os.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }

                if (writeTest2 != 5050) {
                    resultText.setText("preparation (write) NG");
                    return;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            /* check the read operations */
            try {
                con = Connector.open(
                    "scratchpad:///0", Connector.READ_WRITE,true);
                ic = (InputConnection)con;
                dis = ic.openDataInputStream();

                for (i = 1; i <= counter/2; i++) {
                    readValue1 = dis.read();
                    readValue2 = dis.read();
                    if (readValue1 == readValue2) {
                        if (readValue1 != -1||readValue2 != -1) {
                            resultText.setText("\"NG\"");
                            return;
                        }
                    }
                    /* OK will be shown if it reaches 50 */
                    if (i == (counter / 2)) {
                        okFlag = true;
                    }
                }
                dis.close();
                ic.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("read OK");
            } else {
                resultText.setText("NG");
            }
            break;
// J333_0101_0303
        case 6:
            counter = 100;
            /* write data for checking */
            try {
                oc = (OutputConnection)Connector.open(
                "scratchpad:///0",Connector.WRITE,true);
                os = oc.openOutputStream();

                for (i = 1; i <= counter; i++){
                    os.write(i);
                }
                os.close();
                oc.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }

                if (writeTest2 == 5050) {
                    okFlag = true;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("write OK");
            } else {
                resultText.setText("NG");
            }
            break;
// J333_0101_0304
        case 7:
            counter = 100;
            /* write data for checking */
            try {
                oc = (OutputConnection)Connector.open(
                "scratchpad:///0",Connector.WRITE,true);
                dos = oc.openDataOutputStream();

                for (i = 1; i <= counter; i++){
                    dos.write(i + 10);
                }
                dos.close();
                oc.close();

                is = Connector.openInputStream("scratchpad:///0");
                for (i = 1; i <= counter; i++) {
                    writeTest1 = is.read();
                    writeTest2 = writeTest2 + writeTest1;
                }

                if (writeTest2 == 6050) {
                    okFlag = true;
                }
                is.close();
            } catch(IOException ioe) {
                showMsg(ioe.toString());
            } catch(Exception e) {
                showMsg(e.toString());
            }

            if (okFlag) {
                resultText.setText("write OK");
            } else {
                resultText.setText("NG");
            }
            break;
        default:
            break;
        }
    }

    /**
     * Display a message dialog
     * @param  aMsg  Dialog message
     */
    void showMsg(String aMsg) {
        Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
        msgDialog.setText(aMsg);
        msgDialog.show();
    }

    /**
     * No action to be made once soft key is pressed
     * @param aSoftKey  Type of soft key
     */
    public void softKeyPressed(int aSoftKey) {}

    /**
     * Terminate the application when soft key1 is released
     * @param aSoftKey  Type of soft key
     */
    public void softKeyReleased(int aSoftKey) {
        if (aSoftKey == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * Receive events occurred in components
     * @param aComponent  Component where an event occurred
     * @param aType       Event type
     * @param aParam     Event parameter
     */
    public void componentAction(Component aComponent, int aAction, int aParam) {        if (aAction == ComponentListener.BUTTON_PRESSED) {
            test();
        }
        if (aAction == ComponentListener.SELECTION_CHANGED) {
            resultText.setText("");
        }
    }
}