/**
 * J341_0101_0201
 * MainPanel
 *
 * communication (resource):check the behavior when it is opened (resource name operation) 
 *
 * $Id: J341_0101_0201.java,v 1.2 2002/04/03 02:37:25 takanao Exp $
 */

import com.nttdocomo.ui.*;
import javax.microedition.io.*;
import java.io.*;


/**
 * main class
 * @extends IApplication
 */
public class J341_0101_0201 extends IApplication {

    /**
     * startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * communication (resource)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    Button executeButton = new Button("execute");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    String[] menuListItem = {
        "test 1",
        "test 2",
        "test 3",
        "test 4",
        "test 5"
    };

    /**
     * constructor of MainPanel class
     */
    public MainPanel() {
        /* configuration of display items */
        menuList.setItems(menuListItem);
        setTitle("communication (resource)");
        setSoftLabel(SOFT_KEY_1, "exit");

        /* add each component to the screen */
        add(menuList);
        add(executeButton);

        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * operate nothing when soft key is pushed down
     * @param index of anIndex key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * end the application when soft key 1 is released
     * @param index of anIndex key
     */
    public void softKeyReleased(int anIndex) {

        /* end the application when soft key 1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * receive events occurred in components
     * @param aComponent the component that has been generated an event
     * @param aType event type
     * @param aParam event parameter
     * 
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if (aComponent == executeButton) {
            test();
        }
    }

    /*
     * dialog display method
     * @param   aText displayed character strings 
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * method to execute the test
     */
    public void test() {
        int idx = menuList.getSelectedIndex();
        String[] url = new String[1];

        /* execute each of the tests */
        switch( idx ) {

//J341_0101_0201
            case 0:
                try {
                    Connection con = Connector.open("resource:filename", Connector.READ);
                    if(con != null){
                        showDialog("NG:open");
                        con.close();
                    }
                }
                catch (IllegalArgumentException iae) {
                    String message = iae.getMessage();
//2002/09/27 Doja1.5                    if(message.compareTo("Illegal url") == 0){
//2002/09/27 Doja1.5                        showDialog("OK:IllegalArgumentException("+ message +")");
//2002/09/27 Doja1.5                    } else {
//2002/09/27 Doja1.5                        showDialog("NG:message(" + message + ")");
//2002/09/27 Doja1.5                    }
                    if(message.indexOf("Illegal url") != -1){
                        showDialog("OK:IllegalArgumentException("+ message +")");
                    } else {
                        showDialog("NG:message(" + message + ")");
                    }
                }
                catch (Exception e) {
                    showDialog("NG:Exception");
                }
                break;

//J341_0101_0202
            case 1:
                try {
                    Connection con = Connector.open("resource:/filename", Connector.READ);
                    if(con != null){
                        showDialog("NG:open");
                        con.close();
                    }
                }
                catch (IllegalArgumentException iae) {
                    String message = iae.getMessage();
//2002/09/27 Doja1.5                    if(message.compareTo("Illegal url") == 0){
//2002/09/27 Doja1.5                        showDialog("OK:IllegalArgumentException("+ message +")");
//2002/09/27 Doja1.5                    } else {
//2002/09/27 Doja1.5                        showDialog("NG:message(" + message + ")");
//2002/09/27 Doja1.5                    }
                    if(message.indexOf("Illegal url") != -1){
                        showDialog("OK:IllegalArgumentException("+ message +")");
                    } else {
                        showDialog("NG:message(" + message + ")");
                    }
                }
                catch (Exception e) {
                    showDialog("NG:Exception");
                }
                break;

//J341_0101_0203
            case 2:
                try {
                    Connection con = Connector.open("resource://filename", Connector.READ);
                    if(con != null){
                        showDialog("NG:open");
                        con.close();
                    }
                }
                catch (IllegalArgumentException iae) {
                    String message = iae.getMessage();
//2002/09/27 Doja1.5                    if(message.compareTo("Illegal url") == 0){
//2002/09/27 Doja1.5                        showDialog("OK:IllegalArgumentException("+ message +")");
//2002/09/27 Doja1.5                    } else {
//2002/09/27 Doja1.5                        showDialog("NG:message(" + message + ")");
//2002/09/27 Doja1.5                    }
                    if(message.indexOf("Illegal url") != -1){
                        showDialog("OK:IllegalArgumentException("+ message +")");
                    } else {
                        showDialog("NG:message(" + message + ")");
                    }
                }
                catch (Exception e) {
                    showDialog("NG:Exception");
                }
                break;

//J341_0101_0204
            case 3:
                try {
                    Connection con = Connector.open("resource:///", Connector.READ);
                    if(con != null){
                        showDialog("NG:open");
                        con.close();
//2002/10/07 Doja1.5
                    } else {
                        showDialog("OK:null");
                        con.close();
                    }
                }
                catch (IllegalArgumentException iae) {
                    String message = iae.getMessage();
//2002/09/27 Doja1.5                    if(message.compareTo("Illegal url") == 0){
//2002/09/27 Doja1.5                        showDialog("OK:IllegalArgumentException("+ message +")");
//2002/09/27 Doja1.5                    } else {
//2002/09/27 Doja1.5                        showDialog("NG:message(" + message + ")");
//2002/09/27 Doja1.5                    }
                    if(message.indexOf("Illegal url") != -1){
//2002/10/07 Doja1.5                        showDialog("OK:IllegalArgumentException("+ message +")");
                        showDialog("NG:IllegalArgumentException("+ message +")");
                    } else {
                        showDialog("NG:message(" + message + ")");
                    }
                }
                catch (Exception e) {
                    showDialog("NG:Exception");
                }
                break;

//J341_0101_0301
            case 4:
                try {
                    Connection con = Connector.open("resource:///nofile", Connector.READ);
                    if(con != null){
                        showDialog("NG:open");
                        con.close();
//2002/10/07 Doja1.5
                    } else {
                        showDialog("OK:null");
                        con.close();
                    }
                }
                catch (ConnectionNotFoundException cnfe) {
                    showDialog("OK:ConnectionNotFoundException");
                }
                catch (IllegalArgumentException iae) {
                    String message = iae.getMessage();
//2002/09/27 Doja1.5                    if(message.compareTo("Illegal url") == 0){
//2002/09/27 Doja1.5                        showDialog("OK:IllegalArgumentException("+ message +")");
//2002/09/27 Doja1.5                    } else {
//2002/09/27 Doja1.5                        showDialog("NG:message(" + message + ")");
//2002/09/27 Doja1.5                    }
                    if(message.indexOf("Illegal url") != -1){
//2002/10/07 Doja1.5                        showDialog("OK:IllegalArgumentException("+ message +")");
                        showDialog("NG:IllegalArgumentException("+ message +")");
                    } else {
                        showDialog("NG:message(" + message + ")");
                    }
                }
                catch (IOException ioe) {
                    showDialog("catch by IOException");
                }
                catch (Exception e) {
                    showDialog("NG:Exception");
                }
                break;
        }
    }
}

