/**
 * J341_0102_0101
 * MainPanel
 *
 * communication (resource):check the behavior when it is opened (resource name operation) 
 *
 * $Id: J341_0102_0101.java,v 1.2 2002/04/03 02:37:40 takanao Exp $
 */

import com.nttdocomo.ui.*;
import javax.microedition.io.*;
import java.io.*;


/**
 * main class
 * @extends IApplication
 */
public class J341_0102_0101 extends IApplication {

    /**
     * startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * communication (resource)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    Button executeButton = new Button("execute");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    String[] menuListItem = {
        "1.absolute path",
        "2.parent directory",
        "3.\"./\"",
        "4.\"\\\"",
        "5.\":\""
    };

    /**
     * constructor of MainPanel class
     */
    public MainPanel() {
        /* configuration of display items */
        menuList.setItems(menuListItem);
        setTitle("communication (resource)");
        setSoftLabel(SOFT_KEY_1, "exit");

        /* add each component to the screen */
        add(menuList);
        add(executeButton);

        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * operate nothing when soft key is pushed down
     * @param index of anIndex key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * end the application when soft key 1 is released
     * @param index of anIndex key
     */
    public void softKeyReleased(int anIndex) {

        /* end the application when soft key 1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * receive events occurred in components
     * @param aComponent the component that has been generated an event
     * @param aType event type
     * @param aParam event parameter
     * 
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if (aComponent == executeButton) {
            test();
        }
    }

    /*
     * dialog display method
     * @param   aText displayed character strings 
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * method to execute the test
     */
    public void test() {
        int idx = menuList.getSelectedIndex();

        /* execute each of the tests */
        switch( idx ) {

//J341_0102_0101
            case 0:
                try {
                    Connection con = Connector.open("resource:///c:/test/a", Connector.READ);
                    if(con != null){
                        showDialog("NG");
                        con.close();
                    }
                }
                catch (SecurityException se) {
                    showDialog("OK:SecurityException("+ se.getMessage()+")");
                }
                catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

//J341_0102_0102
            case 1:
                try {
                    Connection con = Connector.open("resource:///../b", Connector.READ);
                    if(con != null){
                        showDialog("NG");
                        con.close();
                    }
                }
                catch (SecurityException se) {
                    showDialog("OK:SecurityException("+ se.getMessage()+")");
                }
                catch (Exception e) {
                    showDialog(e.toString());
                }
                break;


//J341_0102_0103
            case 2:
                try {
                    Connection con = Connector.open("resource:///test2/./c", Connector.READ);
                    if(con != null){
                        showDialog("NG");
                        con.close();
                    }
                }
                catch (SecurityException se) {
                    showDialog("OK:SecurityException("+ se.getMessage()+")");
                }
                catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

//J341_0102_0105
            case 3:
                try {
                    Connection con = Connector.open("resource:///\\e", Connector.READ);
                    if(con != null){
                        showDialog("NG");
                        con.close();
                    }
                }
                catch (SecurityException se) {
                    showDialog("OK:SecurityException("+ se.getMessage()+")");
                }
                catch (Exception e) {
                    showDialog(e.toString());
                }
                break;
//J341_0102_0106
            case 4:
                try {
                    Connection con = Connector.open("resource:///:f", Connector.READ);
                    if(con != null){
                        showDialog("NG");
                        con.close();
                    }
                }
                catch (SecurityException se) {
                    showDialog("OK:SecurityException("+ se.getMessage()+")");
                }
                catch (Exception e) {
                    showDialog(e.toString());
                }
                break;
        }
    }
}

