/**
 * J341_0201_0101
 * MainPanel
 *
 * communication (resource):check the behavior when it is opened (resource name operation) 
 *
 * $Id: J341_0201_0101.java,v 1.1 2002/02/01 09:30:27 yuki_o Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;
import javax.microedition.io.*;
import java.io.*;
import javax.microedition.*;
import java.util.*;


/**
 * main class
 * @extends IApplication
 */
public class J341_0201_0101 extends IApplication {

    /**
     * startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * communication (resource)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    Button executeButton = new Button("execute");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    InputStream lastIS;
    InputStream lastDIS;

    String[] menuListItem = {
//2002/08/08 DoJa1.5         "test 1",
        "test 2"
    };

    /**
     * constructor of MainPanel class
     */
    public MainPanel() {
        /* configuration of display items */
        menuList.setItems(menuListItem);
        setTitle("communication (resource)");
        setSoftLabel(SOFT_KEY_1, "exit");

        /* add each component to the screen */
        add(menuList);
        add(executeButton);

        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * operate nothing when soft key is pushed down
     * @param index of anIndex key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * end the application when soft key 1 is released
     * @param index of anIndex key
     */
    public void softKeyReleased(int anIndex) {

        /* end the application when soft key 1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * receive events occurred in components
     * @param aComponent the component that has been generated an event
     * @param aType event type
     * @param aParam event parameter
     * 
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if (aComponent == executeButton) {
            test();
        }

    }

    /*
     * dialog display method
     * @param   aText displayed character strings 
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }


    /**
     * method to execute the test
     */
    public void test() {
        int idx = menuList.getSelectedIndex();
        InputConnection   ic1 = null;
        InputStream       is1 = null;
        InputStreamReader isr = null;
        char[]            cbuf= new char[3];
//2002/09/25 Doja1.5        byte[]            bbuf1= new byte[18];
        byte[]            bbuf1= new byte[27];
        int               len = 0;

        /* execute each of the tests */
        switch( idx ) {

//2002/08/08 DoJa1.5 //J341_0201_0101
//2002/08/08 DoJa1.5             case 0:
//2002/08/08 DoJa1.5                 try{
//2002/08/08 DoJa1.5                    is1 = Connector.openInputStream("resource:///Shift-JIS");
//2002/08/08 DoJa1.5                    isr = new InputStreamReader(is1,"SJIS");
//2002/08/08 DoJa1.5                    isr.read(cbuf,0,3);
//2002/08/08 DoJa1.5                 }
//2002/08/08 DoJa1.5                 catch(Exception e){
//2002/08/08 DoJa1.5                     showDialog("NG:"+ e.toString());
//2002/08/08 DoJa1.5                 }
//2002/08/08 DoJa1.5                 finally{
//2002/08/08 DoJa1.5                     try{
//2002/08/08 DoJa1.5                         is1.close();
//2002/08/08 DoJa1.5                         isr.close();
//2002/08/08 DoJa1.5                     }
//2002/08/08 DoJa1.5                     catch(Exception e){
//2002/08/08 DoJa1.5                         showDialog("NG:" + e.toString());
//2002/08/08 DoJa1.5                     }
//2002/08/08 DoJa1.5                 }
//2002/08/08 DoJa1.5                 if(cbuf[0] == '{' && cbuf[1] == '' && cbuf[2] == 'r'){
//2002/08/08 DoJa1.5                     showDialog("OK");
//2002/08/08 DoJa1.5                 }else{
//2002/08/08 DoJa1.5                     showDialog("NG:" + cbuf[0] + cbuf[1] + cbuf[2] );
//2002/08/08 DoJa1.5                 }
//2002/08/08 DoJa1.5                 break;


//J341_0201_0102
//2002/08/08 DoJa1.5             case 1:
				case 0:
                /* get  multiple streams from one connection */
                try{
                   is1 = Connector.openInputStream("resource:///URLEncode");
                   len = is1.read(bbuf1);
                }
                catch(Exception e){
                    showDialog("NG:"+ e.toString());
                }
                finally{
                    try{
                        is1.close();
                    }
                    catch(Exception e){
                        showDialog("NG:" + e.toString());
                    }
                }

                byte[] bbuf2 = new byte[len];
                bbuf2 = bbuf1;
                String a = new String(bbuf2);
                String data = URLDecoder.decode(a);
//2002/09/25 Doja1.5                if(data.compareTo("Docomo") == 0){
                if(data.compareTo("\uE63E\uE63F\uE640") == 0){
                    showDialog("OK");
                }else{
                    showDialog("NG:" + data );
                }
                break;
        }
    }
}

