/**
 * J342_0101_0101
 * MainPanel
 *
 * communication (resource):check the behavior when it is opened (resource name operation) 
 *
 * $Id: J342_0101_0101.java,v 1.1 2002/03/11 03:01:25 yuki_o Exp $
 */

import com.nttdocomo.ui.*;
import javax.microedition.io.*;
import java.io.*;
import java.lang.*;



/**
 * main class
 * @extends IApplication
 */
public class J342_0101_0101 extends IApplication {

    /**
     * startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * communication (resource)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener {
    Button executeButton = new Button("execute");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    String[] menuListItem = {
        "1.255characters",
        "2.256characters",
        "3.0byte"
    };

    /**
     * constructor of MainPanel class
     */
    public MainPanel() {
        /* configuration of display items */
        menuList.setItems(menuListItem);
        setTitle("communication (resource)");
        setSoftLabel(SOFT_KEY_1, "exit");

        /* add each component to the screen */
        add(menuList);
        add(executeButton);

        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * operate nothing when soft key is pushed down
     * @param index of anIndex key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * end the application when soft key 1 is released
     * @param index of anIndex key
     */
    public void softKeyReleased(int anIndex) {

        /* end the application when soft key 1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * receive events occurred in components
     * @param aComponent the component that has been generated an event
     * @param aType event type
     * @param aParam event parameter
     * 
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if (aComponent == executeButton) {
            test();
        }
    }

    /*
     * dialog display method
     * @param   aText displayed character strings 
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * method to execute the test
     */
    public void test() {
        int idx = menuList.getSelectedIndex();

        /* execute each of the tests */
        switch( idx ) {

//J342_0101_0101
            case 0:
                try {
                    InputStream is = Connector.openInputStream("resource:///filename                                                                                                                                                                                                                                           ");
                    if(is != null){
                        showDialog("OPEN:OK");
                    }
                    is.close();
                }
                catch (Exception e) {
                    showDialog("NG:" + e.toString());
                    System.out.println(e.toString());
                }
                break;

//J342_0101_0102
            case 1:
                try {
                    InputStream is = Connector.openInputStream("resource:///filename                                                                                                                                                                                                                                            ");
                    if(is != null){
                        showDialog("OPEN:NG");
                    }
                    is.close();
                }
                catch (IllegalArgumentException iae){
                    showDialog("OK:IllegalArgumentException(" + iae.getMessage() + ")");
                }
                catch (Exception e) {
                    showDialog(e.toString());
                }
                break;

//J342_0101_0103
            case 2:
                try {
                    InputStream is = Connector.openInputStream("resource:///0byte");
                    if(is != null){
                        showDialog("OPEN:OK");
                    }
                    is.close();
                }
                catch (Exception e) {
                    showDialog("OPEN:NG");
                }
                break;
        }
    }
}

