/**
 * J342_0201_0103
 * MainPanel
 *
 * communication (resource):check the behavior when it is opened (resource name operation) 
 *
 * $Id: J342_0201_0103.java,v 1.1 2002/02/01 09:30:30 yuki_o Exp $
 */

import com.nttdocomo.ui.*;
import javax.microedition.io.*;
import java.io.*;
import javax.microedition.*;
import java.lang.*;



/**
 * main class
 * @extends IApplication
 */
public class J342_0201_0103 extends IApplication {

    /**
     * startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * communication (resource)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    Button executeButton = new Button("execute");
    ListBox menuList = new ListBox(ListBox.CHOICE);

    String[] menuListItem = {
        "1.30kJust",
        "2.30kOver"
    };

    /**
     * constructor of MainPanel class
     */
    public MainPanel() {
        /* configuration of display items */
        menuList.setItems(menuListItem);
        setTitle("communication (resource)");
        setSoftLabel(SOFT_KEY_1, "exit");

        /* add each component to the screen */
        add(menuList);
        add(executeButton);

        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * operate nothing when soft key is pushed down
     * @param index of anIndex key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * end the application when soft key 1 is released
     * @param index of anIndex key
     */
    public void softKeyReleased(int anIndex) {

        /* end the application when soft key 1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * receive events occurred in components
     * @param aComponent the component that has been generated an event
     * @param aType event type
     * @param aParam event parameter
     * 
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if (aComponent == executeButton) {
            test();
        }
    }

    /*
     * dialog display method
     * @param   aText displayed character strings 
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }

    /**
     * method to execute the test
     */
    public void test() {
        int idx = menuList.getSelectedIndex();
        int data = 0;
        boolean flag = true;

        /* execute each of the tests */
        switch( idx ) {
//J342_0201_0102
            case 0:
                data = 0;
                try {
                    InputConnection ic = (InputConnection) Connector.open("resource:///30kJust",Connector.READ);
                    InputStream     is = ic.openInputStream();
                    while(data != -1){
                        data = is.read();
                    }
                    is.close();
                    ic.close();

                    if(data == -1){
                        showDialog("read OK");
                    }
                }
                catch (Exception e) {
                    showDialog("NG:" + e.toString());
                }
                break;

//J342_0201_0103
            case 1:
                data = 0;
                try {
                    InputConnection ic = (InputConnection) Connector.open("resource:///30kOver",Connector.READ);
                    InputStream     is = ic.openInputStream();
                    while(data != -1){
                        data = is.read();
                    }
                    is.close();
                    ic.close();

                    if(data == -1){
                        showDialog("read OK");
                    }
                }
                catch (Exception e) {
                    showDialog("NG:" + e.toString());
                }
                break;
        }
    }
}

