/**
 * J343_0101_0101
 * MainPanel
 *
 * communication (resource):check the behavior when it is opened (resource name operation) 
 *
 * $Id: J343_0101_0101.java,v 1.1 2002/02/01 09:30:33 yuki_o Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import javax.microedition.io.*;
import java.io.*;
import javax.microedition.*;
import java.util.*;


/**
 * main class
 * @extends IApplication
 */
public class J343_0101_0101 extends IApplication {

    /**
     * startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}

/**
 * communication (resource)
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener{
    Button executeButton = new Button("execute");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    InputConnection  ic = null;
    InputStream      is = null;
    DataInputStream dis = null;
    int count = 0;
    String data = "1234567890";
    String stringData;

    String[] menuListItem = {
        "test 1",
        "test 2"
    };

    /**
     * constructor of MainPanel class
     */
    public MainPanel() {
        /* configuration of display items */
        menuList.setItems(menuListItem);
        setTitle("communication (resource)");
        setSoftLabel(SOFT_KEY_1, "exit");

        /* add each component to the screen */
        add(menuList);
        add(executeButton);

        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * operate nothing when soft key is pushed down
     * @param index of anIndex key
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * end the application when soft key 1 is released
     * @param index of anIndex key
     */
    public void softKeyReleased(int anIndex) {

        /* end the application when soft key 1 is released */
        if (anIndex == SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * receive events occurred in components
     * @param aComponent the component that has been generated an event
     * @param aType event type
     * @param aParam event parameter
     * 
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        if (aComponent == executeButton) {
            test();
        }

    }

    /*
     * dialog display method
     * @param   aText displayed character strings 
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }


    /**
     * method to execute the test
     */
    public void test() {
        int idx = menuList.getSelectedIndex();

        /* execute each of the tests */
        switch( idx ) {
//J343_0101_0101
            case 0:
                byte[] b1 = new byte[10]; 
                count = 0;
                try{
                    ic = (InputConnection) Connector.open("resource:///datafile",Connector.READ);
                    is = ic.openInputStream();
                }
               catch(Exception e){
                    showDialog( e.toString());
                }

                while(count < 100 ){
                    try{
                        is.read(b1);
                        stringData = new String(b1);
                        if(stringData.compareTo(data) != 0){
                            showDialog("NG");
                            break;
                        }
                        count++;
                    }
                    catch(Exception e){
                        showDialog("NG:" + e.toString());
                    }
                }
                
                if(count == 100){
                    showDialog("OK");
                }

                try{
                    is.close();
                    ic.close();
                }
                catch(Exception e){
                    showDialog("NG:" + e.toString());
                }
                
                break;

//J343_0101_0102
            case 1:
                byte[] b2 = new byte[10]; 
                count = 0;
                try{
                    ic = (InputConnection) Connector.open("resource:///datafile",Connector.READ);
                    dis = ic.openDataInputStream();
                }
               catch(Exception e){
                    showDialog( e.toString());
                }

                while(count < 100 ){
                    try{
                        dis.read(b2);
                        stringData = new String(b2);
                        if(stringData.compareTo(data) != 0){
                            showDialog("NG");
                            break;
                        }
                        count++;
                    }
                    catch(Exception e){
                        showDialog("NG:" + e.toString());
                    }
                }
                
                if(count == 100){
                    showDialog("OK");
                }

                try{
                    dis.close();
                    ic.close();
                }
                catch(Exception e){
                    showDialog("NG:" + e.toString());
                }
                
                break;
        }
    }
}

