/**
 * J423_0202_0101
 * MainPanel
 *
 *  checking the return of interruption during apli resource accessing
 *
 * $Id: J423_0202_0101.java,v 1.2 2002/02/27 08:04:42 lan Exp $
 */

import java.io.*;
import javax.microedition.io.*;
import com.nttdocomo.lang.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * main class of checking the return of interruption during apli resource accessing
 * @extends IApplication
 */
public class J423_0202_0101 extends IApplication {
    /**
     * startup method of iaapli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }

    /**
     * event acceptance
     * @param   type event type
     * @param   param event parameter
     */
    public void processSystemEvent(int type, int param) {}


    /**
     * dialog display method
     * @param   aText displayed character strings
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "result");
        d.setText(aText);
        d.show();
    }


    /**
     * main screen of checking the interruption behavior during appli resource accessing
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MainPanel extends Panel implements SoftKeyListener, ComponentListener {
        Label   lab              = new Label("resource access");
        Button  execButton       = new Button("execution");
        TextBox statText         = new TextBox("", 20, 3, TextBox.DISPLAY_ANY);

        /**
         * constructor of MainPanel class
         */
        public MainPanel() {
            /* configure the displayed items */
            setTitle("check the return from interruption");
            setSoftLabel(Frame.SOFT_KEY_1, "exit");

            /* add each component to the screen */
            add(lab);
            execButton.setSize(getWidth(),execButton.getHeight());
            add(execButton);
            add(statText);

            /* listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }


        /**
         * operate nothing when the soft key is pressed down
         * @param   anIndex soft key index
         */
        public void softKeyPressed(int anIndex) {}

        /**
         * process when the soft key is released
         * @param   anIndex soft key index
         */
        public void softKeyReleased(int anIndex) {
            /* when the soft key 1 is released, end the application */
            if (anIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * receive events generated in the components
         * @param aComponent component that has generated events
         * @param aType event type
         * @param aParam event parameter
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            /* when the execute button is pressed down */
            if (aComponent == execButton
                && aType == ComponentListener.BUTTON_PRESSED) {
                /* execute the test */
                test();
            }
        }

        /**
         * resource access operating method
         */
        public void test() {
            /* modified  2002.02.27  -- without using sleep(), modify it to be able to
                read large data.txt */
            statText.setText("accessing (approximately 20 sec)");
            InputStream is = null;
            byte[] data = new byte[20];
            /* access the resource once */
           int cnt = 1;
           long beforemem = 0;
           long aftermem = 0;
           Runtime rt =  Runtime.getRuntime();
           while (cnt != 5){
            try {
                is = Connector.openInputStream("resource:///data.txt");
                int j = 0;
                while( true ) {
                    int c = is.read();
                    if( c == -1 ) {
                        break;
                    }
                    if( j < 20 ) {
                        data[j] = (byte) c;
                        j++;
                    }
                }
                is.close();
                rt.gc();

            } catch( Exception e ) {
                statText.setText("exception thrown:" + e.toString());
                /* clean up */
                if( is != null ) {
                    try {
                        is.close();
                    } catch( Exception e1 ) {}
                }
            }
                cnt++;
           }

                /* judge the result of reading */
                String out = new String(data);
                if( out.compareTo("abcdefghijklmnopqrst") == 0 ) {
                    statText.setText("read completed normally");
                } else {
                    statText.setText("read completed abnormally:" + out);
                }
        }
    }
}
