/**
 * J423_0204_0101.java
 * 
 * J423_0204_0101
 * MenuPanel
 * 
 * check the return from the application interruption 
 * 
 * 
 * $Id: J423_0204_0101.java,v 1.1 2002/02/07 08:07:33 waka Exp $
 */

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.net.*;

/**
 * main class of checking the interruption behavior during the operation of AP route connection 
 * @extends IApplication
 */
public class J423_0204_0101 extends IApplication {
    /**
     * startup method of iaapli
     */
    public void start() {
        MenuPanel menuPanel = new MenuPanel();
        Display.setCurrent(menuPanel);
    }

    /**
     * checking the interruption behavior during the operation of AP route connection 
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class MenuPanel extends Panel implements SoftKeyListener,ComponentListener {
        Label            subTitle1     = null;  /* subtitle */
        Label            subTitle2     = null;  /* subtitle */
        Button           execButton    = null;  /* execut button */
        TextBox          resultText    = null;  /* text box for status indication */

        /**
         * constructor of MenuPanel class
         */
        MenuPanel() {
            try {
                showMainPanel();
            } catch(Exception e) {
                showMsg(e.toString());
            } catch(Error e) {
                showMsg(e.toString());
            }
        }

        /**
         * display the soft key panel
         */
        public void showMainPanel() {
            setTitle("check the return from AP interruption");

            /* component generation/addition */
            subTitle1      = new Label("mobile interruption");
            subTitle2      = new Label("under the packet transfer connecting");
            execButton     = new Button("start connection");
            resultText     = new TextBox("",getWidth(),3,TextBox.DISPLAY_ANY);

            subTitle1.setSize(getWidth(),subTitle1.getHeight());
            subTitle2.setSize(getWidth(),subTitle2.getHeight());

            add(subTitle1);
            add(subTitle2);
            add(execButton);
            add(resultText);

            /* soft key label setting */
            setSoftLabel(Frame.SOFT_KEY_1,"exit");

            /* listener setting */
            setSoftKeyListener(this);
            setComponentListener(this);
        }

//J423_0204_0101
//J423_0204_0102
//J423_0204_0103
//J423_0204_0104
//J423_0204_0105
//J423_0204_0106
//J423_0204_0107

//J423_0204_0301
//J423_0204_0302
//J423_0204_0303

//J423_0204_0401
//J423_0204_0402
//J423_0204_0403
        /**
         * execute the HTTP connection
         */
        void testConnect1() {
            HttpConnection con = null;
            InputStream    is  = null;

            resultText.setText("connecting");

            int c = 1;
            long beforemem = 0;
            long aftermem = 0;
            Runtime rt =  Runtime.getRuntime();
            while (c != 20){

            try {
                beforemem = rt.freeMemory();
                con = (HttpConnection) Connector.open(
                    getSourceURL() + "../res/anima8.gif",Connector.READ,true);
                con.setRequestMethod(HttpConnection.GET);
            	resultText.setText("connect start" + c);
                con.connect();
            	resultText.setText("connect end" + c);
                con.close();
                rt.gc();

            } catch( InterruptedIOException ie ) {
//J423_0204_0201
//J423_0204_0202
//J423_0204_0203
//J423_0204_0204
//J423_0204_0205
//J423_0204_0206
//J423_0204_0207

                showMsg("InterruptedIOException");
                aftermem = rt.freeMemory();
//                showMsg("Before Interruption->" + beforemem + "\nAfter Interruption->" + aftermem);
                /* after the interruption, re-connect to check it */
                resultText.setText("now connecting after the interruption");

                try {
                    con = (HttpConnection) Connector.open(
                        getSourceURL() + "../res/anima8.gif",Connector.READ,true);
                    con.setRequestMethod(HttpConnection.GET);
                    con.connect();
                    is = con.openInputStream();
                } catch( InterruptedIOException ie2 ) {
                    showMsg("InterruptedIOException");
                    resultText.setText("connecting suspended after the interruption");
                    return;
                } catch( Exception e ) {
                    resultText.setText("connection error after the interruption");
                    showMsg("NG:" + e.toString());
                    return;
                }
                resultText.setText("connection completed after the interruption");
                return;
            } catch( Exception e ) {
                resultText.setText("connection error");
                showMsg("NG:" + e.toString());
                return;
            }
                 c++;
            }
            resultText.setText("connection completed");
        }

        /**
         * display the message dialog
         * @param  aMsg dialog message
         */
        void showMsg(String aMsg) {
            Dialog msgDialog = new Dialog(Dialog.BUTTON_OK, "Message");
            msgDialog.setText(aMsg);
            msgDialog.show();
        }

        /**
         * operate nothing when the soft key is pressed 
         * @param aSoftKey soft key type
         */
        public void softKeyPressed(int aSoftKey) {}

        /**
         * when the soft key 1 is released, end the application
         * @param aSoftKey soft key type
         */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * receive events generated in the components
         * @param aComponent component that has generated events
         * @param aType event type
         * @param aParam event parameter
         */
        public void componentAction(Component aComponent, int aAction, int aParam) {
            if (aAction == ComponentListener.BUTTON_PRESSED) {
                testConnect1();
            }
        }
    }
}