/** 
 * J423_0305_0301
 * MainPanel
 * 
 * check the return from the application interruption 
 * 
 * $id: $
 */

import com.nttdocomo.io.* ;
import com.nttdocomo.ui.* ;
import java.lang.* ;

/** 
 * main class of checking the return from the application interruption 
 * @extends IApplication
 */
public class J423_0305_0301 extends IApplication{

    MainPanel testPanel = new MainPanel();

    /** 
     * startup method of iaapli
     */
    public void start(){
        Display.setCurrent(testPanel);
    }

    /**
     *  resume process
     */
    public void resume() {
        testPanel.ap1.play();
    }

}

/** 
 * main screen of checking the return from the application interruption 
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener,ComponentListener,
    MediaListener {

    String[] menuListItem = {
        "0.test 1",
    };
    
    Frame subFrame ;
    Label classLabel = new Label("AudioPresenter");
    ListBox menuList = new ListBox(ListBox.CHOICE);
    TextBox resultBox =new TextBox("",20,2,TextBox.DISPLAY_ANY);
    Button execButton = new Button("execute");
    Button stopButton = new Button("stop");
    AudioPresenter ap1 = null;

    /** 
     * constructor of ManPanel
     */
    public MainPanel(){
        try{
            /* display MainPanel */
            showMainPanel();
        }catch(Exception e){
            Dialog errDialog = new Dialog(Dialog.DIALOG_ERROR,"error ");
            errDialog.setText("Error:" +e.toString());
            errDialog.show();
        }
    }
    
    /** 
     * display the main panel
     */
    void showMainPanel(){
        /* configure the displayed items */
        menuList.setItems(menuListItem);
        setTitle("check the return from the interruption");
        setSoftLabel(Frame.SOFT_KEY_1,"exit");
    
        /* add each component to the screen */
        add(classLabel);
        add(menuList);
        add(execButton);
        add(stopButton);
        add(resultBox);
    
        /* listener setting */
        setSoftKeyListener(this);
        setComponentListener(this);
    }
    
    /** 
     *operate nothing when the soft key is pressed down
     */
    public void softKeyPressed(int anIndex){}
    
    /** 
     * when the soft key 1 is released, end the application
     */
    public void softKeyReleased(int anIndex){
        /* when the soft key 1 is released, end the application */
        if(anIndex == Frame.SOFT_KEY_1){
            IApplication.getCurrentApp().terminate();
        }
    }

    /** 
     * receive events generated in the components
     * @param aComponent component that has generated events
     * @param aType event type
     * @param aParam event parameter
     */
    public void componentAction(Component aComponent,int aType,int aParam){
        int index = menuList.getSelectedIndex();
        /* process when the execute 1 button is pressed down */
        if(aComponent == execButton && aType == 
            ComponentListener.BUTTON_PRESSED){
            test();
        }

        /* process to stop playing */
        if(aComponent == stopButton && aType == 
            ComponentListener.BUTTON_PRESSED){
            try {
                ap1.stop();
                resultBox.setText("stop");
            } catch(Exception e) {
                resultBox.setText("NG");
            }
        }
    }

    /** 
     * create the test method
     * each event when execute button is pressed down
     */
    public void test(){
        try {
            ap1 = AudioPresenter.getAudioPresenter();
            MediaSound ms = MediaManager.getSound("resource:///Java1.mld");
            ms.use();
            ap1.setSound(ms);
            ap1.setMediaListener(this);
        } catch(Exception e) {
            resultBox.setText("NG:" + e.toString());
        }
        int index = menuList.getSelectedIndex();

        switch (index) {
            case 0:
                try{
                    ap1.play();
                }catch(UIException e){
                    resultBox.setText("NG");
                }
                break;
            default:
                break;
        }
    }

    /** 
     * process to register events
     */
    public void mediaAction(MediaPresenter source,int aType,int aParam){}
}
