/*
 * J423_0307_0101
 * check the return from the application interruption 
 * 
 * $Id: J423_0307_0101.java,v 1.1 2002/02/07 08:23:23 hoshi Exp $
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.util.*;

/**
 * check the return from the application interruption 
 * 
 * @extends IApplication
 */
public class J423_0307_0101 extends IApplication {

    /**
     * function overview: startup method of iappli
     */
    public void start() {
        Display.setCurrent(new MainCanvas());
    }
}

/**
 * main screen of checking the return from the application interruption 
 * @extends Canvas
 * 
 */
class MainCanvas extends Canvas {

    int backColor;
    int stringColor;

    /**
     * constructor of MainCanvas class
     */
    public MainCanvas(){

        backColor = Graphics.getColorOfName(Graphics.WHITE);
        stringColor = Graphics.getColorOfName(Graphics.BLACK);

        /* configure the displayed items */
        setSoftLabel(Frame.SOFT_KEY_1, "exit");
//2002/09/26 Doja1.5        setSoftLabel(Frame.SOFT_KEY_2, "calls");
    }

    /**
     * screen drawing
     */
    public void paint(Graphics g) {
        g.lock();
        g.setColor(backColor);
        g.fillRect(0,0,getWidth(),getHeight());
        g.setColor(stringColor);
        g.drawString("interruption test",0,15);
        g.drawString("after the return from the interruption, ",5,35);
        g.drawString("display this screen",5,55);
        g.unlock(true);
    }

    /**
     * when the soft key 1 is pressed down, end the application
     * @type
     * @param
     */
    public void processEvent(int type,int param) {
        if(type == Display.KEY_PRESSED_EVENT) {
            switch(param) {
                case Display.KEY_SOFT1:
                    IApplication.getCurrentApp().terminate();
                    break;
//2002/09/26 Doja1.5                case Display.KEY_SOFT2:
//2002/09/26 Doja1.5                    Phone aPhone = new Phone();
//2002/09/26 Doja1.5                    aPhone.call("117");
//2002/09/26 Doja1.5                    break;
                default:
                    break;
            }
        }
    }
}

