/**
 * L011_2901_0101.java
 * 
 * MainPanel
 * 
 * Label class action check (normal route)
 * 
 */

import com.nttdocomo.ui.*;

/**
 * Label class action check main class
 * @extends IApplication
 */
public class L011_2901_0101 extends IApplication {
    /**
     * starting method for I-appli
     */
    public void start() {
        MainPanel mainPanel = new MainPanel();
        Display.setCurrent(mainPanel);
    }

   
   

    /**
     * Label class action check main screen
     * main menu
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    public class MainPanel  extends Panel implements SoftKeyListener,ComponentListener{

        Button execButton = null;
        Dialog err = new Dialog(Dialog.DIALOG_ERROR,"Fout");
        Dialog info = new Dialog(Dialog.DIALOG_INFO, "Info");

        /**
         * Constructor of MainPanel class
         */
        MainPanel() {

            try {
                showMainPanel();
            } catch(Exception e) {
                err.setText(e.toString());
            } catch(Error e) {
                err.setText(e.toString());
            }

        }

        int i;
        String[] mainItem = {
            "Test1",
            "Test2",
        };

        ListBox mainMenu = new ListBox(ListBox.CHOICE,2);

        /**
         * display the main panel
         */
        public void showMainPanel() {

            /* title displaying */
            setTitle("L011");

            /* setting the softkey label */
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");

            /* setting of the listener */
            setSoftKeyListener(this);
            setComponentListener(this);

            /* main menu setting */
            mainMenu.setItems(mainItem);

            /* execution button setting */
            execButton = new Button("Uitvoere");

            /* add the component to the screen */
            add(mainMenu);
            add(execButton);

        }

        /**
         * do nothing when a softkey is pushed
         * @param  aIndex iindex of softkey
         */
        public void softKeyPressed(int aIndex) {
        }

        /**
         * terminate the application when softkey1 is released
         * @param  aIndex iindex of softkey
         */
        public void softKeyReleased(int aIndex) {
            /* terminate when the softkey is released */
            if (aIndex == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {

            /* going to the screen or displaying when the execution button is pushed */
            if ( aComponent == execButton
                && aType == BUTTON_PRESSED) {
                switch (mainMenu.getSelectedIndex()) {
                    /* access level action check */
                   
                    /* constructor */
                    case 0:
                        Display.setCurrent(new L011_2903((Frame) this));
                        break;
                    /* method  */
                    case 1:
                        Display.setCurrent(new L011_2905((Frame) this));
                        break;
                    /* exception action */
                   
                }
            }
        }
    }


    /**
     * constructor action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class L011_2903 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonL011_2903 = null;
        String[] itemL011_2903 = {
            "Item1",
            "Item2",
        };

        /**
         * L011_2903 class constructor
         * @param  aFrame the screen before shifting
         */
        L011_2903(Frame aFrame) {
            previousFrame = aFrame;
            showPanelL011_2903();
        }

        ListBox menuL011_2903 = new ListBox(ListBox.CHOICE,2);

        /**
         * displaying constructor action check menu screen
         */
        void showPanelL011_2903() {
            setTitle("L011");
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");
            setSoftLabel(Frame.SOFT_KEY_2,"Terg");

            menuL011_2903.setItems(itemL011_2903);
            add(menuL011_2903);

            execButtonL011_2903 = new Button("Uitvoere");
            add(execButtonL011_2903);

            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aIndex iindex of softkey
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            if ( aComponent == execButtonL011_2903
                && aType == BUTTON_PRESSED) {
                switch (menuL011_2903.getSelectedIndex()) {
                    /* the prescribed value constructor menu display */
                    case 0:
                       
                        Display.setCurrent(new L011_2903_03((Frame) this));
                        break;
                    /* constructor variation Align display */
                    case 1:
                        Display.setCurrent(new L011_2903_03_01((Frame) this));
                        break;
                }
            }
        }
    }

  

    /**
     * the prescribed value constructor variation checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class L011_2903_03 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonL011_2903_03 = null;

        /**
         * L011_2903_03 class constructor
         * @param  aFrame the screen before shifting
         */
        L011_2903_03(Frame aFrame) {
            previousFrame = aFrame;
            showPanelL011_2903_03();
        }

        ListBox menuL011_2903_03 = new ListBox(ListBox.CHOICE,2);

        /**
         * display the prescribed value constructor variation checking screen
         */
        void showPanelL011_2903_03() {
            setTitle("L011");
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");
            setSoftLabel(Frame.SOFT_KEY_2,"Terg");

            Label testLabel1;

        // L011_2903_0302
           testLabel1 = new Label("");
           testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
           testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
            testLabel1.setSize(getWidth(),testLabel1.getHeight());
           add(testLabel1);

        

            setSoftKeyListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey index of softkey
         */
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }

    /**
     * display the prescribed value constructor variation Align checking screen
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class L011_2903_03_01 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonL011_2903_03_01 = null;

        /**
         * L011_2903_03_01 class constructor
         * @param  aFrame the screen before shifting
         */
        L011_2903_03_01(Frame aFrame) {
            previousFrame = aFrame;
            showPanelL011_2903_03_01();
        }

        ListBox menuL011_2903_03_01 = new ListBox(ListBox.CHOICE,2);

        /**
         * display the prescribed value constructor variation Align checking screen
         */
        void showPanelL011_2903_03_01() {
            setTitle("L011");
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");
            setSoftLabel(Frame.SOFT_KEY_2,"Terg");

            Label testLabel1;
            Label testLabel2;
            Label testLabel3;

        // L011_2903_0307
           testLabel1 = new Label("",0);
           testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
           testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
           testLabel1.setSize(getWidth(),testLabel1.getHeight());
           add(testLabel1);

           testLabel2 = new Label("",1);
           testLabel2.setBackground(Graphics.getColorOfName(Graphics.BLACK));
           testLabel2.setForeground(Graphics.getColorOfName(Graphics.WHITE));
           testLabel2.setSize(getWidth(),testLabel2.getHeight());
           add(testLabel2);

           testLabel3 = new Label("",2);
           testLabel3.setBackground(Graphics.getColorOfName(Graphics.BLACK));
           testLabel3.setForeground(Graphics.getColorOfName(Graphics.WHITE));
           testLabel3.setSize(getWidth(),testLabel3.getHeight());
           add(testLabel3);

            setSoftKeyListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey index of softkey
         */
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        public void softKeyReleased(int aSoftKey) {
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
        }
    }

    /**
     * method action check menu screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class L011_2905 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonL011_2905 = null;
        String[] itemL011_2905 = {
            "Item1",
        };

        /**
         * L011_2905 class constructor
         * @param  aFrame the screen before shifting
         */
        L011_2905(Frame aFrame) {
            previousFrame = aFrame;
            showPanelL011_2905();
        }

        ListBox menuL011_2905 = new ListBox(ListBox.CHOICE,2);

        /**
         * method action check menu screen displaying
         */
        void showPanelL011_2905() {
            setTitle("L011");
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");
            setSoftLabel(Frame.SOFT_KEY_2,"Terg");

            menuL011_2905.setItems(itemL011_2905);
            add(menuL011_2905);

            execButtonL011_2905 = new Button("Uitvoere");
            add(execButtonL011_2905);

            setSoftKeyListener(this);
            setComponentListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey index of softkey
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }

        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {
            if ( aComponent == execButtonL011_2905
                && aType == BUTTON_PRESSED) {
                switch (menuL011_2905.getSelectedIndex()) {
                   /* variation */
                    case 0:
                   
                        Display.setCurrent(new L011_2905_03((Frame) this));
                        break;
                }
            }
        }
    }



    /**
     * variation checking screen class
     * @extends Panel
     * @implements SoftKeyListener
     * @implements ComponentListener
     */
    class L011_2905_03 extends Panel implements SoftKeyListener,ComponentListener {
        Frame previousFrame = null;
        Button execButtonL011_2905_03 = null;
        Dialog info = new Dialog(Dialog.DIALOG_INFO, "Info");

        /**
         * L011_2905_03 class constructor
         * @param  aFrame the screen before shifting
         */
        L011_2905_03(Frame aFrame) {
            previousFrame = aFrame;
            showPanelL011_2905_03();
        }

        ListBox menuL011_2905_03 = new ListBox(ListBox.CHOICE,2);

        /**
         * variation checking screen displaying
         */
        void showPanelL011_2905_03() {
            setTitle("L011");
            setSoftLabel(Frame.SOFT_KEY_1,"Exit");
            setSoftLabel(Frame.SOFT_KEY_2,"Terg");


            Label testLabel1;

            testLabel1 = new Label();
        // L011_2905_0302
            testLabel1.setText("");
            testLabel1.setBackground(Graphics.getColorOfName(Graphics.BLACK));
            testLabel1.setForeground(Graphics.getColorOfName(Graphics.WHITE));
            testLabel1.setSize(getWidth(),testLabel1.getHeight());
            add(testLabel1);

          
            setSoftKeyListener(this);
        }

        /**
         * do nothing when a softkey is pushed
         * @param  aSoftKey type of soft menu
         */
        public void softKeyPressed(int aSoftKey) {
        }

        /**
         * define the action when softkey is released
         * @param  aSoftKey type of soft menu
         */
        /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
        public void softKeyReleased(int aSoftKey) {
            /* terminate when the softkey1 is released, go to the previous screen when the softkey2 is released */
            if (aSoftKey == Frame.SOFT_KEY_1) {
                IApplication.getCurrentApp().terminate();
            }
            if (aSoftKey == Frame.SOFT_KEY_2) {
                if ( previousFrame != null ) {
                Display.setCurrent(previousFrame);
                }
            }
        }

        /**
         * get the event on a component
         * @param aComponent The component on which a event occurred
         * @param aType Type of an event.
         * @param aParam Parameter of an event
         */
        public void componentAction(Component aComponent, int aType, int aParam) {}
    }
}

 
               
