/**
 * L011_4405_0201
 * MainPanel
 *
 * TextBox class prescribed value method behavior checking (normal route)
 *
 */

import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


/**
 * TextBox class prescribed value method behavior checking main class
 * @extends IApplication
 */
public class L011_4405_0201 extends IApplication {

    /**
     * starting method for I-appli
     */
    public void start() {
        Display.setCurrent(new MainPanel());
    }
}


/**
 * TextBox class prescribed value method behavior checking main screen
 * @extends Panel
 * @implements SoftKeyListener
 * @implements ComponentListener
 */
class MainPanel extends Panel implements SoftKeyListener, ComponentListener {

    String[] menuListItem = {
        "Test1",
    };
    String[][] subItems = {
        {
            "Item1",
            "Item2"
        },
       
    };

    ListBox menuList         = new ListBox(ListBox.CHOICE);
    ListBox menuList2        = new ListBox(ListBox.CHOICE);
    Button  execButton       = new Button("Uitvoere");
    TextBox testBox          = new TextBox("TextBox",12,1,TextBox.DISPLAY_ANY);

   /**
     * Constructor of MainPanel class
     */
    public MainPanel() {
        /* setting of the display item */
        menuList.setItems(menuListItem);
        menuList2.setItems(subItems[0]);
        setTitle("L011");
        setSoftLabel(Frame.SOFT_KEY_1, "Exit");

        /* adding each component on the display */
        add(menuList);
        add(menuList2);
        execButton.setSize(getWidth(),execButton.getHeight());
        add(execButton);
        add(testBox);

        /* setting the listener */
        setSoftKeyListener(this);
        setComponentListener(this);
    }

    /**
     * do nothing when a softkey is pushed
     */
    public void softKeyPressed(int anIndex) {}

    /**
     * terminate the application when softkey1 is released
     */
    public void softKeyReleased(int anIndex) {

        /* terminate the application when softkey1 is released */
        if (anIndex == Frame.SOFT_KEY_1) {
            IApplication.getCurrentApp().terminate();
        }
    }

    /**
     * get the event on a component
     * @param aComponent The component on which a event occurred
     * @param aType Type of an event.
     * @param aParam Parameter of an event
     */
    public void componentAction(Component aComponent, int aType, int aParam) {

        /* when the menu is choiced */
        if (aComponent == menuList
            && aType == ComponentListener.SELECTION_CHANGED) {
            /* sub menu setting */
            menuList2.setItems(subItems[menuList.getSelectedIndex()]);
        }

        /* when  the execution button is pushed */
        if (aComponent == execButton
            && aType == ComponentListener.BUTTON_PRESSED) {
            test();
        }

    }


    /**
     * dialog display method
     * @param   aText chalacter sequence which is displaied
     */
    public void showDialog(String aText) {
        Dialog  d = new Dialog(Dialog.BUTTON_OK, "Result.");
        d.setText(aText);
        d.show();
    }

    /**
     * testing the selected menu
     */
    public void test() {
        /* execute each testing */
        switch( menuList.getSelectedIndex() ) {
            case 0:
                switch( menuList2.getSelectedIndex() ) {
                    case 0:
                        // L011_4405_0211
						try{
            	            testBox.setInputMode(TextBox.ALPHA);
                	     	testBox.setText("TextBox.ALPHA");
						} catch (Exception e) {
							testBox.setText(e.toString());
						}
						break;
                	 case 1:
                        // L011_4405_0212
						try{
                        	testBox.setInputMode(TextBox.KANA);
                     		testBox.setText("TextBox.KANA");
						} catch (Exception e) {
							testBox.setText(e.toString());
						}
                        break;
                }
        }
    }
}
